General
-------
AVL and its plot library should compile on any Unix system 
with normal Fortran-77, C, and X-Windows support. 


Build sequence
--------------

1) Build Xplot11 library in  ./plotlib  ...

 % cd plotlib
 % make (displays current make options for system (gfortran,ifort,mingw)
 % make (system)          (creates libPlt.a)

 Or if that does not work...
 % edit Makefile and config.make for your system (set compiler flags for your system)
 % make                   (creates libPlt.a)


2) Build Eispack library in ./eispack  ...

 % cd eispack
 % make -f Makefile.xxx   (where xxx is gfortran, ifort or mingw)

 Or if that does not work...
 % edit Makefile.xxx  (set compiler flags for your system)
 % make           (creates eispack.a)

3) Build AVL in ./bin  ...
 % cd bin
 % make -f Makefile.xxx avl   (where xxx is gfortran, ifort or mingw)

 Or if that does not work...
 % edit Makefile.xxx and save as Makefile  (set compiler flags for your system)
 % make avl


The executable will appear in the bin/ directory.


Documentation
-------------
User Guide is in the  avl_doc.txt  file.  If impatient, you can just
run AVL in the runs/ directory, which contains a few input files:

 % cd runs
 % ../bin/avl vanilla

The files  session1.txt, session2.txt  contain keyboard input examples.


Graphic Notes for X-windows 
---------------------------
The plot library for X-windows does not refresh the plot windows on expose 
events (i.e. when the window is covered and then uncovered).  Proper operation
assumes that the optional X backing store is enabled.  It is not always turned
on in current (Linux, typically) X installations.  The backing store can be 
enabled by adding a line to your X configuration file (typically found in 
/etc/X11/xorg.conf).  The line should be added to the Device Section and looks
like this:
   Option "BackingStore" "True"

This shows the Device section from my xorg.conf file with the backing store 
enabled.  Note that you will have your own Identifier and Driver lines, 
just add the Option line.

Section "Device"
    Identifier  "Miserable Old SVGA"
    Driver      "miserable"
    Option	"BackingStore"	"True"
EndSection

You probably need to restart the X server before this works (try just logging 
out or rebooting).

Example session to make animated GIF from AVL eigenmode plots, for B737 case, 
using ImageMagick "convert" command

1) Create plot.ps with AVL:

% avl b737
MODE
N
X
  click on topmost Dutch-Roll root, roughly at (-0.3,1.9)
  use LRUD keys to rotate airplane for best view of Dutch Roll, e.g. Azim,Elev = -160,15
  play mode by holding down > key, adjust scale with +/- keys as needed, reset time with 0 key
  <space>
G
X
  click on same Dutch Roll root again
  play mode by holding down > key, for whatever length needed
  <space>
<Enter>
Q

2) Edit plot.ps
Globally replace 
 "612    0 translate   90 rotate"
with
 "0 0 translate 0 rotate"
Write new file, e.g. plot2.ps or whatever

3) Create animated GIF:

convert -delay 4 -page 720x500 -border 4x4 plot2.ps plot2.gif

/*********************************************************************** 
    Module:  Readme
 
    Copyright (C) 1996 Harold Youngren, Mark Drela 
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Report problems to:    guppy@maine.com 
                        or drela@mit.edu  
***********************************************************************/ 

C     Version 4.51 Updated 2/7/17


To make the plotlib under Unix/Linux with X-Windows graphics:

  If you have a Linux/OSX or Windows with MinGW there are make options to
  build for those environments

Simply typing make gives the options:

Usage:
  type: make <MACHINE>
   where <MACHINE> is one of the following:
   gfortran - Linux/OSX/Cygwin using gcc toolset
   ifort    - Linux/OSX with ifort/gcc
   mingw    - Windows using MinGW
   gfortranDP - Linux/OSX/Cygwin using gcc toolset, dbleprecision
   ifortDP    - Linux/OSX with ifort/gcc, dblprecision
   mingwDP    - Windows using MinGW, dblprecision
   clean    - cleanup directory

  The config.make.xxx files control the options.  These are supplied for
  xxx = gfortran/ifort on Linux or OSX or xxx=mingw for Windows with the
  MinGW tools installed. If the baseline options do not work you may need
  change the config.make files to reflect your compiler and library options.

  Several versions of config.make are supplied for the GNU gfortran/gcc and 
  the Intel ifort and gcc compilers. 

  A config.make for MinGW is provided to make a Windows Win32 executable (see
  below).  Separate Makefile.NT makefiles for Windows with Visual C are also 
  included though these are not updated very often (see below).

  The config.make files are supplied for single and double precision 
  versions of the plotlib.  Note that there are also optional declarations 
  for GNU 32 bit or 64 bit architectures in the config.make's, these may be 
  needed if your system has 64 bit libraries and your gcc or gfortran defaults
  to 32 bit executables.  This shows up as an incompatible link message as a 
  rule, check the make output.   Comment or uncomment options for your machine.

  The Makefile simply links one of the config.make.xxx files to config.make and
  then calls Makefile.all to do the work.
  

To make the plotlib under Windows there are three choices:

1) The best (free) option is the MinGW GNU development environment that
provides the compiler and libraries to develop programs to run under Windows.
MinGW is free, from (http://www.mingw.org/). MinGW comes with a Bash shell 
environment and a range of Unix-like tools for development and running 
programs (a useful addition if you learn to use them).  

Compiling the library and programs under MingGW is done from a MinGW shell 
using what is basically the same Unix style build process.  The only difference
is that the programs are linked against the MSYS libraries as well as the 
native Win32 libraries. 

Note that the MinGW Windows executables will need to be linked using
static linking (using a -static flag to the GNU compilers) if you want to make
an executable that is portable without having to similarly install the MingGW 
environment and libraries.  Static linking adds these MSYS libraries into the 
binary file so they should run on any Windows computer (XP...Win7/8)

To compile and link under MinGW:
  Enter make mingw or make mingwDP (for double precision library). The options
  are set in config.make.mingw which is linked to config.make.
  This should compile the fortran and a C interface library (W32win2.c in
  /win32 directory to make a workable plot library for Windows.

2) These programs can be built using the Cygwin toolset which provides a 
Unix-like environment (including X-Windows) on Windows.  This requires getting
and installing Cygwin (free from Cygwin (http://www.cygwin.com/) and then 
compiling using the Unix options and running under X-Windows.

This works but has several disadvantages. The X Windows server must be started 
before a plotlib program is called in order to get a plot window.  Also, the 
executable is not stand alone, requiring the cygwin.dll to be present to 
function. The need to install Cygwin/X and the cygwin.dll makes it hard to 
distribute these executables with other users.



3) use Intel Fortran and C or Intel Fortran and Visual C compiler.  
You should check the options in Makefile.NT to ensure that
these options match your system.  The supplied files match the Intel 
Fortran and Visual C compiler and use the Microsoft "nmake" utility.

Compile and link with command in DOS window: 
C:\Xfoil\plotlib: cd win32
C:\Xfoil\plotlib\win32: nmake /f Makefile.NT

This places all the .obj files in the win32 directory and copies libPltxx.lib
to the parent plotlib directory.

Alternatively you could load all the files into a Visual Studio project and
create the library that way.

#========================================================================#
Odd bits:

RE multiple precision libraries (if you wanted to support a code
compiled with higher precision for "reals" in fortran).

To create plot library libPlt.a you can normally just type:
  % make
  provided the file config.make matches your machine. The supplied config.make
  matches the config.make.SP single precision options file.

If you want to create a double precision version of the library:
  Link or copy one of the files config.make.xxxDP to config.make and check that 
  the options match your machine.  Set any names and compile options for double
  precision.  Then type:
  % make

If you don't have a file config.make.DP your alternative is to to this:
  go into the config.make and uncomment or add the line 
#PLTLIB = libPltDP.a
  set the DP flag for your compiler (uncomment appropriate line) and then:
  % make

For Unix, if you have set the INSTALLDIR variable you can install the plot 
  library libPlt.a to that location using the install option.  Before running
  this check the config.make and Makefile for proper install options and 
  destination for your system
  % make install


#========================================================================#
Graphics and windows:

The X-Windows environment may support automatic window refresh (when uncovered)
through the use of a "backing store".  If you do not have automatic window 
refresh (they stay blanked after uncovering) then a backing store can be set 
up using an option in the X config file (now Xorg.conf, usually in /etc/X11 
on Unix/Linux).  Check your X Windows documentation "man X" or "man Xorg.conf"
pages for further information. 

To set black-on-white video, define Unix variable as follows:
  % setenv XPLOT11_BACKGROUND white

To restore white-on-black video:
  % unsetenv XPLOT11_BACKGROUND

Windows versions of this require an environment variable to be defined to 
change the background (defaults to black)
  XPLOT11_BACKGROUND white


#========================================================================#
Plotlib test and examples:

There is a test directory to check the operation of the plotlib in ./examples
To create the test example and color selection programs (all optional):
  % make test

OR, go into the examples directory and do a:
  % make

To create the test and examples under Windoze:
  .\plotlib: cd examples
For MinGW this uses the plotlib ..\config.make setup:
  .\plotlib\examples: make
For Intel/Visual C use the nmake command on the special Makefile:   
  .\plotlib\examples: nmake /f Makefile.NT




See the following files for more info:

 Doc           Discussion, sample application calls, some routine descriptions
 pltlib.inc    Description of all global plot data (for tinkering with source)

 plt_base.f    Routine headers describe call lists
 plt_font.f     "
 plt_util.f     "
 plt_color.f    "
 plt_3D.f       "

 sym/Readme    Description of vector font generation and/or modification

 Readme-examples    Description of test and example programs		
 Readme.absoft      Info on Absoft Linux f77 for Xplot11 compile

examples/Readme-examples

C***********************************************************************
C    Module:  asetup.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE SETUP
C
C...PURPOSE  To set up the vortex lattice calculation.
C
C            Additional geometry data is calculated.
C            An AIC matrix is assembled and solutions
C            obtained for 0 deg and 90 deg angle of attack 
C            (for later superposition in AERO). The matrix
C            defining normalwash at the bound vortex midpoints
C            is calculated. This is used to define the bound vortex
C            normalwash for 0 and 90 deg angles of attack (used 
C            for superposition in AERO).
C            
C...INPUT    Global Data in labelled commons, defining configuration
C          
C...OUTPUT   GAM(i,1..3)  Vortex strengths for unit VINF1,2,3
C            GAM(i,4..6)  Vortex strengths for unit WROT1,2,3
C            W            Normalwash at vortex midpoints for GAM
C
C...COMMENTS   
C
      INCLUDE 'AVL.INC'
      REAL WORK(NVMAX)
C
      AMACH = MACH
      BETM = SQRT(1.0 - AMACH**2)
C
C
      IF(.NOT.LAIC) THEN
       WRITE(*,*) ' Building normalwash AIC matrix...'
       CALL VVOR(BETM,IYSYM,YSYM,IZSYM,ZSYM,VRCORE,
     &           NVOR,RV1,RV2,NSURFV,CHORDV,
     &           NVOR,RC ,    NSURFV,.FALSE.,
     &           WC_GAM,NVMAX)
       DO I = 1, NVOR
         DO J = 1, NVOR
           AICN(I,J) = WC_GAM(1,I,J)*ENC(1,I)
     &               + WC_GAM(2,I,J)*ENC(2,I)
     &               + WC_GAM(3,I,J)*ENC(3,I)
           LVNC(I) = .TRUE.
ccc           write(*,*) i, j, aicn(i,j)  !@@@
         ENDDO
       ENDDO

C----- process each surface which does not shed a wake
       DO 10 N = 1, NSURF
         IF(LFWAKE(N)) GO TO 10

C------- go over TE control points on this surface
         J1 = JFRST(N)
         JN = JFRST(N) + NJ(N)-1
C
         DO J = J1, JN
           I1 = IJFRST(J)
           IV = IJFRST(J) + NVSTRP(J) - 1

C--------- clear system row for TE control point
           DO JV = 1, NVOR
             AICN(IV,JV) = 0.
           ENDDO
           LVNC(IV) = .FALSE.

C--------- set  sum_strip(Gamma) = 0  for this strip
           DO JV = I1, IV
             AICN(IV,JV) = 1.0
           ENDDO
         ENDDO
 10    CONTINUE

C
CC...Holdover from HPV hydro project for forces near free surface
CC...Eliminates excluded vortices from eqns which are below z=Zsym 
C      CALL MUNGEA
C
       WRITE(*,*) ' Factoring normalwash AIC matrix...'
       CALL LUDCMP(NVMAX,NVOR,AICN,IAPIV,WORK)
C
       LAIC = .TRUE.
      ENDIF
C
C
      IF(.NOT.LSRD) THEN
        WRITE(*,*) ' Building source+doublet strength AIC matrix...'
        CALL SRDSET(BETM,XYZREF,
     &              NBODY,LFRST,NLMAX,
     &              NL,RL,RADL,
     &              SRC_U,DBL_U)
        WRITE(*,*) ' Building source+doublet velocity AIC matrix...'
        NU = 6
        CALL VSRD(BETM,IYSYM,YSYM,IZSYM,ZSYM,SRCORE,
     &            NBODY,LFRST,NLMAX,
     &            NL,RL,RADL,
     &            NU,SRC_U,DBL_U,
     &            NVOR,RC,
     &            WCSRD_U,NVMAX)
        LSRD = .TRUE.
      ENDIF

C
      IF(.NOT.LVEL) THEN
       WRITE(*,*) ' Building bound-vortex velocity matrix...'
       CALL VVOR(BETM,IYSYM,YSYM,IZSYM,ZSYM,VRCORE,
     &           NVOR,RV1,RV2,NSURFV,CHORDV,
     &           NVOR,RV ,    NSURFV,.TRUE.,
     &           WV_GAM,NVMAX)
C
       NU = 6
       CALL VSRD(BETM,IYSYM,YSYM,IZSYM,ZSYM,SRCORE,
     &           NBODY,LFRST,NLMAX,
     &           NL,RL,RADL,
     &           NU,SRC_U,DBL_U,
     &           NVOR,RV ,
     &           WVSRD_U,NVMAX)
C
       LVEL = .TRUE.
      ENDIF
C
      RETURN
      END ! SETUP


 
      SUBROUTINE GUCALC
      INCLUDE 'AVL.INC'
      REAL RROT(3), VUNIT(3), WUNIT(3)
C
C---- setup BC's at control points for unit freestream,rotation vectors,
C      and back-substitute to obtain corresponding vortex circulations
C
C---- go over freestream velocity components u,v,w = f(V,beta,alpha)
      DO 10 IU = 1, 3
C------ go over all control points
        DO I = 1, NVOR
          IF(LVNC(I)) THEN
C--------- this c.p. has V.n equation...
           VUNIT(1) = 0.
           VUNIT(2) = 0.
           VUNIT(3) = 0.
           IF(LVALBE(I)) THEN
C---------- direct freestream influence is enabled for this c.p.
            VUNIT(IU) = VUNIT(IU) + 1.0
           ENDIF

C--------- always add on indirect freestream influence via BODY sources and doublets
           VUNIT(1) = VUNIT(1) + WCSRD_U(1,I,IU)
           VUNIT(2) = VUNIT(2) + WCSRD_U(2,I,IU)
           VUNIT(3) = VUNIT(3) + WCSRD_U(3,I,IU)

C--------- set r.h.s. for V.n equation
           GAM_U_0(I,IU) = -DOT(ENC(1,I),VUNIT)
           DO N = 1, NCONTROL
             GAM_U_D(I,IU,N) = -DOT(ENC_D(1,I,N),VUNIT)
           ENDDO
           DO N = 1, NDESIGN
             GAM_U_G(I,IU,N) = -DOT(ENC_G(1,I,N),VUNIT)
           ENDDO

          ELSE
C--------- just clear r.h.s.
           GAM_U_0(I,IU) = 0.
           DO N = 1, NCONTROL
             GAM_U_D(I,IU,N) = 0.
           ENDDO
           DO N = 1, NDESIGN
             GAM_U_G(I,IU,N) = 0.
           ENDDO
          ENDIF
        ENDDO

        CALL BAKSUB(NVMAX,NVOR,AICN,IAPIV,GAM_U_0(1,IU))
        DO N = 1, NCONTROL
          CALL BAKSUB(NVMAX,NVOR,AICN,IAPIV,GAM_U_D(1,IU,N))
        ENDDO
        DO N = 1, NDESIGN
          CALL BAKSUB(NVMAX,NVOR,AICN,IAPIV,GAM_U_G(1,IU,N))
        ENDDO
 10   CONTINUE
C
C---- go over freestream rotation components p,q,r
      DO 20 IU = 4, 6
C------ go over all control points
        DO I = 1, NVOR
          IF(LVNC(I)) THEN
C--------- this c.p. has V.n equation
           WUNIT(1) = 0.
           WUNIT(2) = 0.
           WUNIT(3) = 0.
           IF(LVALBE(I)) THEN
C---------- direct freestream influence is enabled for this c.p.
            WUNIT(IU-3) = WUNIT(IU-3) + 1.0
           ENDIF
           RROT(1) = RC(1,I) - XYZREF(1)
           RROT(2) = RC(2,I) - XYZREF(2)
           RROT(3) = RC(3,I) - XYZREF(3)
           CALL CROSS(RROT,WUNIT,VUNIT)

C--------- always add on indirect freestream influence via BODY sources and doublets
           VUNIT(1) = VUNIT(1) + WCSRD_U(1,I,IU)
           VUNIT(2) = VUNIT(2) + WCSRD_U(2,I,IU)
           VUNIT(3) = VUNIT(3) + WCSRD_U(3,I,IU)

C--------- set r.h.s. for V.n equation
           GAM_U_0(I,IU) = -DOT(ENC(1,I),VUNIT)
           DO N = 1, NCONTROL
             GAM_U_D(I,IU,N) = -DOT(ENC_D(1,I,N),VUNIT)
           ENDDO
           DO N = 1, NDESIGN
             GAM_U_G(I,IU,N) = -DOT(ENC_G(1,I,N),VUNIT)
           ENDDO
          ELSE
C--------- just clear r.h.s.
           GAM_U_0(I,IU) = 0.
           DO N = 1, NCONTROL
             GAM_U_D(I,IU,N) = 0.
           ENDDO
           DO N = 1, NDESIGN
             GAM_U_G(I,IU,N) = 0.
           ENDDO
          ENDIF
        ENDDO
        CALL BAKSUB(NVMAX,NVOR,AICN,IAPIV,GAM_U_0(1,IU))
        DO N = 1, NCONTROL
          CALL BAKSUB(NVMAX,NVOR,AICN,IAPIV,GAM_U_D(1,IU,N))
        ENDDO
        DO N = 1, NDESIGN
          CALL BAKSUB(NVMAX,NVOR,AICN,IAPIV,GAM_U_G(1,IU,N))
        ENDDO
   20 CONTINUE
C
      RETURN
      END ! GUCALC


 
      SUBROUTINE GDCALC(NQDEF,LQDEF,ENC_Q,GAM_Q)
      INCLUDE 'AVL.INC'
      LOGICAL LQDEF(*)
      REAL ENC_Q(3,NVMAX,*), GAM_Q(NVMAX,*)
C
C
      REAL RROT(3), VROT(3), VC(3)
C
      IF(NQDEF.EQ.0) RETURN
C
C---- Setup variational BC's at the control points
      DO 100 IQ = 1, NQDEF
C------ don't bother if this control variable is undefined
        IF(.NOT.LQDEF(IQ)) GO TO 100
C
        DO I = 1, NVOR
          IF(LVNC(I)) THEN
           IF(LVALBE(I)) THEN
            RROT(1) = RC(1,I) - XYZREF(1)
            RROT(2) = RC(2,I) - XYZREF(2)
            RROT(3) = RC(3,I) - XYZREF(3)
            CALL CROSS(RROT,WROT,VROT)
            DO K = 1, 3
              VC(K) = VINF(K)
     &              + VROT(K)
            ENDDO
           ELSE
            VC(1) = 0.
            VC(2) = 0.
            VC(3) = 0.
           ENDIF

           DO K = 1, 3
             VC(K) = VC(K)
     &             + WCSRD_U(K,I,1)*VINF(1)
     &             + WCSRD_U(K,I,2)*VINF(2)
     &             + WCSRD_U(K,I,3)*VINF(3)
     &             + WCSRD_U(K,I,4)*WROT(1)
     &             + WCSRD_U(K,I,5)*WROT(2)
     &             + WCSRD_U(K,I,6)*WROT(3)
           ENDDO
C
           GAM_Q(I,IQ) = -DOT(ENC_Q(1,I,IQ),VC)
          ELSE
           GAM_Q(I,IQ) = 0.
          ENDIF
        ENDDO

C********************************************************************
C...Holdover from HPV hydro project for forces near free surface
C...Eliminates excluded vortex equations for strips with z<Zsym 
ccc      CALL MUNGEB(GAM_Q(1,IQ))
C********************************************************************
C
        CALL BAKSUB(NVMAX,NVOR,AICN,IAPIV,GAM_Q(1,IQ))
 100  CONTINUE
C
      RETURN
      END ! GDCALC



      SUBROUTINE MUNGEA
C
C...PURPOSE  To remove hidden vortex equations in AIC matrix
C          
C...OUTPUT   A(.,.)  AIC matrix with affected rows replaced with 1 on diagonal
C                
C
      INCLUDE 'AVL.INC'
C
      DO 30 J = 1, NSTRIP
        IF (.NOT. LSTRIPOFF(J)) GO TO 30
        I1 = IJFRST(J)
        DO 20 K = 1, NVSTRP(J)
          II = I1+K-1
          DO 10 I = 1, NVOR
            AICN(II,I) = 0.0
   10     CONTINUE
          AICN(II,II) = 1.0
   20   CONTINUE
   30 CONTINUE
C
      RETURN
      END


      SUBROUTINE MUNGEB(B)
C
C...PURPOSE  To remove hidden vortex equations in RHS's
C          
C...OUTPUT   B(.)  RHS vector with affected rows replaced with 0
C
      INCLUDE 'AVL.INC'
      REAL B(NVMAX)
C
      DO 30 J = 1, NSTRIP
        IF (.NOT. LSTRIPOFF(J)) GO TO 30
        I1 = IJFRST(J)
        DO 20 K = 1, NVSTRP(J)
          II = I1+K-1
          B(II) = 0.
   20   CONTINUE
   30 CONTINUE
C
      RETURN
      END


      SUBROUTINE GAMSUM
      INCLUDE 'AVL.INC'
C--------------------------------------------------
C     Sums AIC components to get GAM, SRC, DBL
C--------------------------------------------------
C
C---- Set vortex strengths
      DO I = 1, NVOR
        DO IU = 1, 6
          GAM_U(I,IU) = GAM_U_0(I,IU)

          DO N = 1, NCONTROL
            GAM_U(I,IU) = GAM_U(I,IU) + GAM_U_D(I,IU,N)*DELCON(N)
          ENDDO
          DO N = 1, NDESIGN
            GAM_U(I,IU) = GAM_U(I,IU) + GAM_U_G(I,IU,N)*DELDES(N)
          ENDDO
        ENDDO

        DO N = 1, NCONTROL
          GAM_D(I,N) = GAM_U_D(I,1,N)*VINF(1)
     &               + GAM_U_D(I,2,N)*VINF(2)
     &               + GAM_U_D(I,3,N)*VINF(3)
     &               + GAM_U_D(I,4,N)*WROT(1)
     &               + GAM_U_D(I,5,N)*WROT(2)
     &               + GAM_U_D(I,6,N)*WROT(3)
        ENDDO

        DO N = 1, NDESIGN
          GAM_G(I,N) = GAM_U_G(I,1,N)*VINF(1)
     &               + GAM_U_G(I,2,N)*VINF(2)
     &               + GAM_U_G(I,3,N)*VINF(3)
     &               + GAM_U_G(I,4,N)*WROT(1)
     &               + GAM_U_G(I,5,N)*WROT(2)
     &               + GAM_U_G(I,6,N)*WROT(3)
        ENDDO

        GAM(I) = GAM_U(I,1)*VINF(1)
     &         + GAM_U(I,2)*VINF(2)
     &         + GAM_U(I,3)*VINF(3)
     &         + GAM_U(I,4)*WROT(1)
     &         + GAM_U(I,5)*WROT(2)
     &         + GAM_U(I,6)*WROT(3)

c        DO N = 1, NCONTROL
c          GAM(I) = GAM(I) + GAM_D(I,N)*DELCON(N)
c        ENDDO
c        DO N = 1, NDESIGN
c          GAM(I) = GAM(I) + GAM_G(I,N)*DELDES(N)
c        ENDDO
      END DO
C
C---- Set source and doublet strengths
      DO L = 1, NLNODE
        SRC(L) = SRC_U(L,1)*VINF(1)
     &         + SRC_U(L,2)*VINF(2)
     &         + SRC_U(L,3)*VINF(3)
     &         + SRC_U(L,4)*WROT(1)
     &         + SRC_U(L,5)*WROT(2)
     &         + SRC_U(L,6)*WROT(3)
        DO K = 1, 3
          DBL(K,L) = DBL_U(K,L,1)*VINF(1)
     &             + DBL_U(K,L,2)*VINF(2)
     &             + DBL_U(K,L,3)*VINF(3)
     &             + DBL_U(K,L,4)*WROT(1)
     &             + DBL_U(K,L,5)*WROT(2)
     &             + DBL_U(K,L,6)*WROT(3)
        ENDDO
      ENDDO
C
      RETURN
      END ! GAMSUM


      SUBROUTINE VELSUM
      INCLUDE 'AVL.INC'
C--------------------------------------------------
C     Sums AIC components to get WC, WV
C--------------------------------------------------
C
      DO I = 1, NVOR
        DO K = 1, 3
          WC(K,I) = WCSRD_U(K,I,1)*VINF(1)
     &            + WCSRD_U(K,I,2)*VINF(2)
     &            + WCSRD_U(K,I,3)*VINF(3)
     &            + WCSRD_U(K,I,4)*WROT(1)
     &            + WCSRD_U(K,I,5)*WROT(2)
     &            + WCSRD_U(K,I,6)*WROT(3)
          WV(K,I) = WVSRD_U(K,I,1)*VINF(1)
     &            + WVSRD_U(K,I,2)*VINF(2)
     &            + WVSRD_U(K,I,3)*VINF(3)
     &            + WVSRD_U(K,I,4)*WROT(1)
     &            + WVSRD_U(K,I,5)*WROT(2)
     &            + WVSRD_U(K,I,6)*WROT(3)
          DO J = 1, NVOR
            WC(K,I) = WC(K,I) + WC_GAM(K,I,J)*GAM(J)
            WV(K,I) = WV(K,I) + WV_GAM(K,I,J)*GAM(J)
          ENDDO
C
          DO N = 1, NUMAX
            WC_U(K,I,N) = WCSRD_U(K,I,N)
            WV_U(K,I,N) = WVSRD_U(K,I,N)
            DO J = 1, NVOR
              WC_U(K,I,N) = WC_U(K,I,N) + WC_GAM(K,I,J)*GAM_U(J,N)
              WV_U(K,I,N) = WV_U(K,I,N) + WV_GAM(K,I,J)*GAM_U(J,N)
            ENDDO
          ENDDO
C
        ENDDO
      ENDDO
C
      RETURN
      END ! VELSUM



      SUBROUTINE WSENS
      INCLUDE 'AVL.INC'
C---------------------------------------------------
C     Computes induced-velocity sensitivities
C     to control and design changes
C---------------------------------------------------
C
      DO I = 1, NVOR
        DO K = 1, 3
          DO N = 1, NCONTROL
            WC_D(K,I,N) = 0.
            WV_D(K,I,N) = 0.
            DO J = 1, NVOR
              WC_D(K,I,N) = WC_D(K,I,N) + WC_GAM(K,I,J)*GAM_D(J,N)
              WV_D(K,I,N) = WV_D(K,I,N) + WV_GAM(K,I,J)*GAM_D(J,N)
            ENDDO
          ENDDO  
C
          DO N = 1, NDESIGN
            WC_G(K,I,N) = 0.
            WV_G(K,I,N) = 0.
            DO J = 1, NVOR
              WC_G(K,I,N) = WC_G(K,I,N) + WC_GAM(K,I,J)*GAM_G(J,N)
              WV_G(K,I,N) = WV_G(K,I,N) + WV_GAM(K,I,J)*GAM_G(J,N)
            ENDDO
          ENDDO  
        ENDDO
      ENDDO
C
      RETURN
      END ! WSENS

C***********************************************************************
C    Module:  amake.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE MAKESURF(ISURF, IBX,NSEC, 
     &       NVC1, CSPACE, NVS1, SSPACE,
     &       XYZSCAL,XYZTRAN,ADDINC,
     &       XYZLES,CHORDS,AINCS,SSPACES,NSPANS,
     &       XASEC,SASEC,TASEC,NASEC,
     &       CLCDSEC,CLAF,
     &       ICONX, 
     &       ICONTD,NSCON,GAIND,XHINGED,VHINGED,REFLD,
     &       IDESTD,NSDES,GAING )
C--------------------------------------------------------------
C     Sets up all stuff for surface ISURF, 
C     using info from configuration input file.
C--------------------------------------------------------------
      INCLUDE 'AVL.INC'
C
      REAL XYZSCAL(3), XYZTRAN(3), ADDINC
      REAL XYZLES(3,*),CHORDS(*),AINCS(*),SSPACES(*)
      INTEGER NSPANS(*), NASEC(*)
      REAL XASEC(IBX,*), SASEC(IBX,*), TASEC(IBX,*)
      REAL CLCDSEC(6,*), CLAF(*)
      INTEGER ICONTD(ICONX,*),NSCON(*),
     &        IDESTD(ICONX,*),NSDES(*)
      REAL GAIND(ICONX,*),
     &     XHINGED(ICONX,*),VHINGED(3,ICONX,*),REFLD(ICONX,*),
     &     GAING(ICONX,*)
C
      REAL XYZLEL(3), XYZLER(3)
C
      PARAMETER (KCMAX=50,
     &           KSMAX=500)
      REAL XPT0(KCMAX), XCP0(KCMAX), XVR0(KCMAX), XSR0(KCMAX),
     &     XPT1(KCMAX), XCP1(KCMAX), XVR1(KCMAX), XSR1(KCMAX),
     &     XPT2(KCMAX), XCP2(KCMAX), XVR2(KCMAX), XSR2(KCMAX)
      REAL XPT(KCMAX), XCP(KCMAX), XVR(KCMAX), XSR(KCMAX),
     &     YPT(KSMAX), YCP(KSMAX)
      REAL YZLEN(KSMAX)
      INTEGER IPTLOC(KSMAX)
C
      PARAMETER (KPMAX=2*KCMAX+2*KSMAX)
      REAL FSPACE(KPMAX)
C
      REAL CHSINL_G(NGMAX),CHCOSL_G(NGMAX),
     &     CHSINR_G(NGMAX),CHCOSR_G(NGMAX)
      INTEGER ISCONL(NDMAX), ISCONR(NDMAX)
      REAL XLED(NDMAX), XTED(NDMAX), GAINDA(NDMAX)
C
C
      IF(NSEC.LT.2) THEN
       WRITE(*,*) '*** Need at least 2 sections per surface.'
       STOP
      ENDIF
C
      NVC = NVC1
      NVS = NVS1
C
      IF(NVC.GT.KCMAX) THEN
       WRITE(*,*) '* MAKESURF: Array overflow.  Increase KCMAX to', NVC
       NVC = KCMAX
      ENDIF
C
      IF(NVS.GT.KSMAX) THEN
       WRITE(*,*) '* MAKESURF: Array overflow.  Increase KSMAX to', NVS
       NVS = KSMAX
      ENDIF
C
C--- Image flag set to indicate section definition direction
C    IMAGS= 1  defines edge 1 located at surface root edge 
C    IMAGS=-1  defines edge 2 located at surface root edge (reflected surfaces)
      IMAGS(ISURF) = 1
      IFRST(ISURF) = NVOR   + 1 
      JFRST(ISURF) = NSTRIP + 1
      NK(ISURF) = NVC
C
C-----------------------------------------------------------------
C---- section arc lengths of wing trace in y-z plane
      YZLEN(1) = 0.
      DO ISEC = 2, NSEC
        DY = XYZLES(2,ISEC) - XYZLES(2,ISEC-1)
        DZ = XYZLES(3,ISEC) - XYZLES(3,ISEC-1)
        YZLEN(ISEC) = YZLEN(ISEC-1) + SQRT(DY*DY + DZ*DZ)
      ENDDO
C
C
      IF(NVS1.EQ.0) THEN
C----- set spanwise spacing using spacing parameters for each section interval
       NVS = 0
       DO ISEC = 1, NSEC-1
         NVS = NVS + NSPANS(ISEC)
       ENDDO
       IF(NVS.GT.KSMAX) THEN
        WRITE(*,*) '*** MAKESURF: Array overflow. Increase KSMAX to',NVS
        STOP
       ENDIF
C
       NVS = 0
       YPT(1) = YZLEN(1)
       IPTLOC(1) = 1
C
       DO ISEC = 1, NSEC-1
         DYZLEN = YZLEN(ISEC+1) - YZLEN(ISEC)
C
         NVINT = NSPANS(ISEC)
C
C------- set spanwise spacing array
         NSPACE = 2*NVINT + 1
         IF(NSPACE.GT.KPMAX) THEN
          WRITE(*,*) '*** MAKESURF: Array overflow. Increase KPMAX to', 
     &                 NSPACE
          STOP
         ENDIF
         CALL SPACER(NSPACE,SSPACES(ISEC),FSPACE)
C
         DO N = 1, NVINT
           IVS = NVS + N
           YCP(IVS)   = YPT(NVS+1) + DYZLEN*FSPACE(2*N)
           YPT(IVS+1) = YPT(NVS+1) + DYZLEN*FSPACE(2*N+1)
         ENDDO
         IPTLOC(ISEC+1) = NVS + NVINT + 1
C
         NVS = NVS + NVINT
       ENDDO
C
      ELSE
C----- set spanwise spacing using overall parameters NVS, SSPACE
C
       NSPACE = 2*NVS + 1
       IF(NSPACE.GT.KPMAX) THEN
        WRITE(*,*) '*** MAKESURF: Array overflow. Increase KPMAX to', 
     &              NSPACE
        STOP
       ENDIF
       CALL SPACER(NSPACE,SSPACE,FSPACE)
C
       YPT(1) = YZLEN(1)
       DO IVS = 1, NVS
         YCP(IVS)   = YZLEN(1) + (YZLEN(NSEC)-YZLEN(1))*FSPACE(2*IVS)
         YPT(IVS+1) = YZLEN(1) + (YZLEN(NSEC)-YZLEN(1))*FSPACE(2*IVS+1)
       ENDDO
C
       NPT = NVS + 1
C
C----- find node nearest each section
       DO ISEC = 2, NSEC-1
         YPTLOC = 1.0E9
         IPTLOC(ISEC) = 1
         DO IPT = 1, NPT
           YPTDEL = ABS(YZLEN(ISEC) - YPT(IPT))
           IF(YPTDEL .LT. YPTLOC) THEN
            YPTLOC = YPTDEL
            IPTLOC(ISEC) = IPT
           ENDIF
         ENDDO
       ENDDO
       IPTLOC(1)    = 1
       IPTLOC(NSEC) = NPT
C
C----- fudge Glauert angles to make nodes match up exactly with interior sections
       DO ISEC = 2, NSEC-1
         IPT1 = IPTLOC(ISEC-1)
         IPT2 = IPTLOC(ISEC  )
         IF(IPT1.EQ.IPT2) THEN
          CALL STRIP(STITLE(ISURF),NST)
          WRITE(*,7000) ISEC, STITLE(ISURF)(1:NST)
          STOP
         ENDIF
C
         YPT1 = YPT(IPT1)
         YSCALE = (YZLEN(ISEC)-YZLEN(ISEC-1)) / (YPT(IPT2)-YPT(IPT1))
         DO IPT = IPT1, IPT2-1
           YPT(IPT) = YZLEN(ISEC-1) + YSCALE*(YPT(IPT)-YPT1)
         ENDDO
         DO IVS = IPT1, IPT2-1
           YCP(IVS) = YZLEN(ISEC-1) + YSCALE*(YCP(IVS)-YPT1)
         ENDDO
C
         IPT1 = IPTLOC(ISEC  )
         IPT2 = IPTLOC(ISEC+1)
         IF(IPT1.EQ.IPT2) THEN
          CALL STRIP(STITLE(ISURF),NST)
          WRITE(*,7000) ISEC, STITLE(ISURF)(1:NST)
          STOP
         ENDIF
C
         YPT1 = YPT(IPT1)
         YSCALE = (YPT(IPT2)-YZLEN(ISEC)) / (YPT(IPT2)-YPT(IPT1))
         DO IPT = IPT1, IPT2-1
           YPT(IPT) = YZLEN(ISEC) + YSCALE*(YPT(IPT)-YPT1)
         ENDDO
         DO IVS = IPT1, IPT2-1
           YCP(IVS) = YZLEN(ISEC) + YSCALE*(YCP(IVS)-YPT1)
         ENDDO
C
 7000    FORMAT(
     &   /' *** Cannot adjust spanwise spacing at section', I3, 
     &    ', on surface ', A
     &   /' *** Insufficient number of spanwise vortices to work with')
       ENDDO
C
      ENDIF
C
C
C====================================================
C---- define strips between input sections
C
      NJ(ISURF) = 0
C
      IF(NCONTROL.GT.NDMAX) THEN
       WRITE(*,*) '*** Too many control variables.  Increase NDMAX to',
     &            NCONTROL
       STOP
      ENDIF
C
      IF(NDESIGN.GT.NGMAX) THEN
       WRITE(*,*) '*** Too many design variables.  Increase NGMAX to',
     &            NDESIGN
       STOP
      ENDIF
C
C---- go over section intervals
      DO 200 ISEC = 1, NSEC-1
        XYZLEL(1) = XYZSCAL(1)*XYZLES(1,ISEC)    + XYZTRAN(1)
        XYZLEL(2) = XYZSCAL(2)*XYZLES(2,ISEC)    + XYZTRAN(2)
        XYZLEL(3) = XYZSCAL(3)*XYZLES(3,ISEC)    + XYZTRAN(3)
        XYZLER(1) = XYZSCAL(1)*XYZLES(1,ISEC+1)  + XYZTRAN(1)
        XYZLER(2) = XYZSCAL(2)*XYZLES(2,ISEC+1)  + XYZTRAN(2)
        XYZLER(3) = XYZSCAL(3)*XYZLES(3,ISEC+1)  + XYZTRAN(3)
C
        WIDTH = SQRT(  (XYZLER(2)-XYZLEL(2))**2
     &               + (XYZLER(3)-XYZLEL(3))**2 )
C
        CHORDL = XYZSCAL(1)*CHORDS(ISEC)
        CHORDR = XYZSCAL(1)*CHORDS(ISEC+1)
C
        CLAFL = CLAF(ISEC)
        CLAFR = CLAF(ISEC+1)
C
C------ removed CLAF influence on zero-lift angle  (MD  21 Mar 08)
        AINCL = AINCS(ISEC)   + ADDINC
        AINCR = AINCS(ISEC+1) + ADDINC
cc      AINCL = AINCS(ISEC)   + ADDINC - 4.0*DTR*(CLAFL-1.0)
cc      AINCR = AINCS(ISEC+1) + ADDINC - 4.0*DTR*(CLAFR-1.0)
C
        CHSINL = CHORDL*SIN(AINCL)
        CHSINR = CHORDR*SIN(AINCR)
        CHCOSL = CHORDL*COS(AINCL)
        CHCOSR = CHORDR*COS(AINCR)
C
C------ set control-declaration lines for each control variable
        DO N = 1, NCONTROL
          ISCONL(N) = 0
          ISCONR(N) = 0
          DO ISCON = 1, NSCON(ISEC)
            IF(ICONTD(ISCON,ISEC)  .EQ.N) ISCONL(N) = ISCON
          ENDDO
          DO ISCON = 1, NSCON(ISEC+1)
            IF(ICONTD(ISCON,ISEC+1).EQ.N) ISCONR(N) = ISCON
          ENDDO
        ENDDO
C
C------ set design-variable sensitivities of CHSIN and CHCOS
        DO N = 1, NDESIGN
          CHSINL_G(N) = 0.
          CHSINR_G(N) = 0.
          CHCOSL_G(N) = 0.
          CHCOSR_G(N) = 0.
C
          DO ISDES = 1, NSDES(ISEC)
            IF(IDESTD(ISDES,ISEC).EQ.N) THEN
             CHSINL_G(N) =  CHCOSL * GAING(ISDES,ISEC)*DTR
             CHCOSL_G(N) = -CHSINL * GAING(ISDES,ISEC)*DTR
            ENDIF
          ENDDO
C
          DO ISDES = 1, NSDES(ISEC+1)
            IF(IDESTD(ISDES,ISEC+1).EQ.N) THEN
             CHSINR_G(N) =  CHCOSR * GAING(ISDES,ISEC+1)*DTR
             CHCOSR_G(N) = -CHSINR * GAING(ISDES,ISEC+1)*DTR
            ENDIF
          ENDDO
        ENDDO
C
C
C------ go over chord strips
        IPTL = IPTLOC(ISEC)
        IPTR = IPTLOC(ISEC+1)
        NSPAN = IPTR - IPTL
        DO 150 ISPAN = 1, NSPAN
C-------- define left and right edges of vortex strip
C-          note that incidence angle is set by ATAN of chord projections,
C-          not by linear interpolation of AINC
          IPT1 = IPTL + ISPAN - 1
          IPT2 = IPTL + ISPAN
          IVS  = IPTL + ISPAN - 1
          F1 = (YPT(IPT1)-YPT(IPTL))/(YPT(IPTR)-YPT(IPTL))
          F2 = (YPT(IPT2)-YPT(IPTL))/(YPT(IPTR)-YPT(IPTL))
          FC = (YCP(IVS) -YPT(IPTL))/(YPT(IPTR)-YPT(IPTL))
C
C-------- store strip in global data arrays
          NSTRIP = NSTRIP + 1
          NJ(ISURF) = NJ(ISURF) + 1
C
          RLE1(1,NSTRIP) = (1.0-F1)*XYZLEL(1) + F1*XYZLER(1)
          RLE1(2,NSTRIP) = (1.0-F1)*XYZLEL(2) + F1*XYZLER(2)
          RLE1(3,NSTRIP) = (1.0-F1)*XYZLEL(3) + F1*XYZLER(3)
          CHORD1(NSTRIP) = (1.0-F1)*CHORDL    + F1*CHORDR
C
          RLE2(1,NSTRIP) = (1.0-F2)*XYZLEL(1) + F2*XYZLER(1)
          RLE2(2,NSTRIP) = (1.0-F2)*XYZLEL(2) + F2*XYZLER(2)
          RLE2(3,NSTRIP) = (1.0-F2)*XYZLEL(3) + F2*XYZLER(3)
          CHORD2(NSTRIP) = (1.0-F2)*CHORDL    + F2*CHORDR
C
          RLE(1,NSTRIP)  = (1.0-FC)*XYZLEL(1) + FC*XYZLER(1)
          RLE(2,NSTRIP)  = (1.0-FC)*XYZLEL(2) + FC*XYZLER(2)
          RLE(3,NSTRIP)  = (1.0-FC)*XYZLEL(3) + FC*XYZLER(3)
          CHORD(NSTRIP)  = (1.0-FC)*CHORDL    + FC*CHORDR
C
          WSTRIP(NSTRIP) = ABS(F2-F1)*WIDTH
          TANLE(NSTRIP)  = (XYZLER(1)-XYZLEL(1))/WIDTH
          TANTE(NSTRIP)  = (XYZLER(1)+CHORDR - XYZLEL(1)-CHORDL)/WIDTH
C
          CHSIN = CHSINL + FC*(CHSINR-CHSINL)
          CHCOS = CHCOSL + FC*(CHCOSR-CHCOSL)
          AINC(NSTRIP) = ATAN2(CHSIN,CHCOS)
C
          DO N = 1, NDESIGN
            CHSIN_G = (1.0-FC)*CHSINL_G(N) + FC*CHSINR_G(N)
            CHCOS_G = (1.0-FC)*CHCOSL_G(N) + FC*CHCOSR_G(N)
            AINC_G(NSTRIP,N) = (CHCOS*CHSIN_G - CHSIN*CHCOS_G)
     &                       / (CHSIN**2 + CHCOS**2)
          ENDDO
C
          DO N = 1, NCONTROL
            ICL = ISCONL(N)
            ICR = ISCONR(N)
C
            IF(ICL.EQ.0 .OR. ICR.EQ.0) THEN
C----------- no control effect here
             GAINDA(N) = 0.
             XLED(N) = 0.
             XTED(N) = 0.
C
             VHINGE(1,NSTRIP,N) = 0.
             VHINGE(2,NSTRIP,N) = 0.
             VHINGE(3,NSTRIP,N) = 0.
C
             VREFL(NSTRIP,N) = 0.
C
             PHINGE(1,NSTRIP,N) = 0.
             PHINGE(2,NSTRIP,N) = 0.
             PHINGE(3,NSTRIP,N) = 0.
C
            ELSE
C----------- control variable # N is active here
             GAINDA(N) = GAIND(ICL,ISEC  )*(1.0-FC)
     &                 + GAIND(ICR,ISEC+1)*     FC
C
             XHD = CHORDL*XHINGED(ICL,ISEC  )*(1.0-FC)
     &           + CHORDR*XHINGED(ICR,ISEC+1)*     FC
             IF(XHD.GE.0.0) THEN
C------------ TE control surface, with hinge at XHD
              XLED(N) = XHD
              XTED(N) = CHORD(NSTRIP)
             ELSE
C------------ LE control surface, with hinge at -XHD
              XLED(N) =  0.0
              XTED(N) = -XHD
             ENDIF
C
             VHX = VHINGED(1,ICL,ISEC)*XYZSCAL(1)
             VHY = VHINGED(2,ICL,ISEC)*XYZSCAL(2)
             VHZ = VHINGED(3,ICL,ISEC)*XYZSCAL(3)
             VSQ = VHX**2 + VHY**2 + VHZ**2
             IF(VSQ.EQ.0.0) THEN
C------------ default: set hinge vector along hingeline
              VHX = XYZLES(1,ISEC+1) + ABS(CHORDR*XHINGED(ICR,ISEC+1))
     &            - XYZLES(1,ISEC  ) - ABS(CHORDL*XHINGED(ICL,ISEC  ))
              VHY = XYZLES(2,ISEC+1)
     &            - XYZLES(2,ISEC  )
              VHZ = XYZLES(3,ISEC+1)
     &            - XYZLES(3,ISEC  )
              VHX = VHX*XYZSCAL(1)
              VHY = VHY*XYZSCAL(2)
              VHZ = VHZ*XYZSCAL(3)
              VSQ = VHX**2 + VHY**2 + VHZ**2
             ENDIF
C
             VMOD = SQRT(VSQ)
             VHINGE(1,NSTRIP,N) = VHX/VMOD
             VHINGE(2,NSTRIP,N) = VHY/VMOD
             VHINGE(3,NSTRIP,N) = VHZ/VMOD
C
             VREFL(NSTRIP,N) = REFLD(ICL,ISEC)
C
             IF(XHD .GE. 0.0) THEN
              PHINGE(1,NSTRIP,N) = RLE(1,NSTRIP) + XHD
              PHINGE(2,NSTRIP,N) = RLE(2,NSTRIP)
              PHINGE(3,NSTRIP,N) = RLE(3,NSTRIP)
             ELSE
              PHINGE(1,NSTRIP,N) = RLE(1,NSTRIP) - XHD
              PHINGE(2,NSTRIP,N) = RLE(2,NSTRIP)
              PHINGE(3,NSTRIP,N) = RLE(3,NSTRIP)
             ENDIF
C
            ENDIF
          ENDDO
C
C--- Interpolate CD-CL polar defining data from input sections to strips
          DO L = 1, 6
            CLCD(L,NSTRIP) = (1.0-FC)*CLCDSEC(L,ISEC) 
     &                      +     FC *CLCDSEC(L,ISEC+1)
          END DO
C--- If the min drag is zero flag the strip as no-viscous data
          LVISCSTRP(NSTRIP) = (CLCD(4,NSTRIP).NE.0.0)
C
C
          IJFRST(NSTRIP) = NVOR + 1
          NVSTRP(NSTRIP) = NVC
C
          NSURFS(NSTRIP) = ISURF
C
          NSL = NASEC(ISEC  )
          NSR = NASEC(ISEC+1)
C
          CHORDC = CHORD(NSTRIP)
C
          CLAFC =  (1.-FC)*(CHORDL/CHORDC)*CLAFL
     &           +     FC *(CHORDR/CHORDC)*CLAFR
C
C-------- set chordwise spacing fraction arrays
          CALL CSPACER(NVC,CSPACE,CLAFC, XPT,XVR,XSR,XCP)
c
C-------- go over vortices in this strip
          DO 1505 IVC = 1, NVC
            NVOR = NVOR + 1
C
            RV1(1,NVOR) = RLE1(1,NSTRIP) + XVR(IVC)*CHORD1(NSTRIP)
            RV1(2,NVOR) = RLE1(2,NSTRIP)
            RV1(3,NVOR) = RLE1(3,NSTRIP)
C
            RV2(1,NVOR) = RLE2(1,NSTRIP) + XVR(IVC)*CHORD2(NSTRIP)
            RV2(2,NVOR) = RLE2(2,NSTRIP)
            RV2(3,NVOR) = RLE2(3,NSTRIP)
C
            RV(1,NVOR) = RLE(1,NSTRIP) + XVR(IVC)*CHORDC
            RV(2,NVOR) = RLE(2,NSTRIP)
            RV(3,NVOR) = RLE(3,NSTRIP)
C
            RC(1,NVOR) = RLE(1,NSTRIP) + XCP(IVC)*CHORDC
            RC(2,NVOR) = RLE(2,NSTRIP)
            RC(3,NVOR) = RLE(3,NSTRIP)
C
            RS(1,NVOR) = RLE(1,NSTRIP) + XSR(IVC)*CHORDC
            RS(2,NVOR) = RLE(2,NSTRIP)
            RS(3,NVOR) = RLE(3,NSTRIP)
C
            CALL AKIMA(XASEC(1,ISEC  ),SASEC(1,ISEC  ),NSL,
     &                 XCP(IVC),SLOPEL, DSDX)
            CALL AKIMA(XASEC(1,ISEC+1),SASEC(1,ISEC+1),NSR,
     &                 XCP(IVC),SLOPER, DSDX)
            SLOPEC(NVOR) =  (1.-FC)*(CHORDL/CHORDC)*SLOPEL 
     &                    +     FC *(CHORDR/CHORDC)*SLOPER
C
            CALL AKIMA(XASEC(1,ISEC  ),SASEC(1,ISEC  ),NSL,
     &                 XVR(IVC),SLOPEL, DSDX)
            CALL AKIMA(XASEC(1,ISEC+1),SASEC(1,ISEC+1),NSR,
     &                 XVR(IVC),SLOPER, DSDX)
            SLOPEV(NVOR) =  (1.-FC)*(CHORDL/CHORDC)*SLOPEL 
     &                    +     FC *(CHORDR/CHORDC)*SLOPER
C
            DXOC = XPT(IVC+1) - XPT(IVC)
            DXV(NVOR) = DXOC*CHORDC
            CHORDV(NVOR) = CHORDC
            NSURFV(NVOR) = LSCOMP(ISURF)

            LVNC(NVOR) = .TRUE.
C
C---------- element inherits alpha,beta flag from surface
            LVALBE(NVOR) = LFALBE(ISURF)
C
            DO N = 1, NCONTROL
C------------ scale control gain by factor 0..1, (fraction of element on control surface)
              FRACLE = (XLED(N)/CHORDC-XPT(IVC)) / DXOC
              FRACTE = (XTED(N)/CHORDC-XPT(IVC)) / DXOC
C
              FRACLE = MIN( 1.0 , MAX( 0.0 , FRACLE ) )
              FRACTE = MIN( 1.0 , MAX( 0.0 , FRACTE ) )
C
              DCONTROL(NVOR,N) = GAINDA(N)*(FRACTE-FRACLE)
            ENDDO
C
C---------- TE control point used only if surface sheds a wake
            LVNC(NVOR) = LFWAKE(ISURF)

 1505     CONTINUE
C
 150    CONTINUE
C
 200  CONTINUE
C
C---- Find wetted surface area (one side)
      SUM  = 0.0
      WTOT = 0.0
      DO JJ = 1, NJ(ISURF)
        J = JFRST(ISURF) + JJ-1 
        ASTRP = WSTRIP(J)*CHORD(J)
        SUM  = SUM + ASTRP
        WTOT = WTOT + WSTRIP(J)
      ENDDO
      SSURF(ISURF) = SUM
C
      IF(WTOT .EQ. 0.0) THEN
       CAVESURF(ISURF) = 0.0
      ELSE
       CAVESURF(ISURF) = SUM/WTOT
      ENDIF
C
      RETURN
      END ! MAKESURF



      SUBROUTINE MAKEBODY(IBODY, IBX,
     &       NVB1, BSPACE,
     &       XYZSCAL,XYZTRAN,
     &       XBOD,YBOD,TBOD,NBOD)
C--------------------------------------------------------------
C     Sets up all stuff for body IBODY,
C     using info from configuration input file.
C--------------------------------------------------------------
      INCLUDE 'AVL.INC'
C
      REAL XYZSCAL(3), XYZTRAN(3)
      REAL XBOD(IBX), YBOD(IBX), TBOD(IBX)
C
      PARAMETER (KLMAX=101)
      REAL XPT(KLMAX), FSPACE(KLMAX)
C
C
c      IF(NSEC.LT.2) THEN
c       WRITE(*,*) '*** Need at least 2 sections per body.'
c       STOP
c      ENDIF
C
      NVB = NVB1
C
      IF(NVB.GT.KLMAX) THEN
       WRITE(*,*) '* MAKEBODY: Array overflow.  Increase KLMAX to', NVB
       NVB = KLMAX
      ENDIF
C
C
      LFRST(IBODY) = NLNODE + 1 
      NL(IBODY) = NVB
C
      IF(NLNODE+NVB.GT.NLMAX) THEN
       WRITE(*,*) '*** MAKEBODY: Array overflow. Increase NLMAX to',
     &             NLNODE+NVB
       STOP
      ENDIF
C
C-----------------------------------------------------------------
C---- set lengthwise spacing fraction arrays
      NSPACE = NVB + 1
      IF(NSPACE.GT.KLMAX) THEN
       WRITE(*,*) '*** MAKEBODY: Array overflow. Increase KLMAX to', 
     &             NSPACE
       STOP
      ENDIF
      CALL SPACER(NSPACE,BSPACE,FSPACE)
C
      DO IVB = 1, NVB
        XPT(IVB) = FSPACE(IVB)
      ENDDO
      XPT(1) = 0.0
      XPT(NVB+1) = 1.0
C
C---- set body nodes and radii
      VOLB = 0.0
      SRFB = 0.0
      DO IVB = 1, NVB+1
        NLNODE = NLNODE + 1
C
        XVB = XBOD(1) + (XBOD(NBOD)-XBOD(1))*XPT(IVB)
        CALL AKIMA(XBOD,YBOD,NBOD,XVB,YVB,DYDX)
        RL(1,NLNODE) = XYZTRAN(1) + XYZSCAL(1)*XVB
        RL(2,NLNODE) = XYZTRAN(2)
        RL(3,NLNODE) = XYZTRAN(3) + XYZSCAL(3)*YVB
C
        CALL AKIMA(XBOD,TBOD,NBOD,XVB,TVB,DRDX)
        RADL(NLNODE) = SQRT(XYZSCAL(2)*XYZSCAL(3)) * 0.5*TVB
      ENDDO
C---- get surface length, area and volume
      VOLB = 0.0
      SRFB = 0.0
      XBMN = RL(1,LFRST(IBODY))
      XBMX = XBMN
      DO IVB = 1, NVB
        NL0 = LFRST(IBODY) + IVB-1
        NL1 = NL0 + 1
        X0 = RL(1,NL0)
        X1 = RL(1,NL1)
        DX = ABS(X1 - X0)
        R0 = RADL(NL0)
        R1 = RADL(NL1)
        DVOL = PI*DX * (R0**2 + R0*R1 + R1**2) / 3.0
        DS = SQRT((R0-R1)**2 + DX**2)
        DSRF = PI*DS * (R0+R1)
C
        SRFB = SRFB + DSRF
        VOLB = VOLB + DVOL
        XBMN = MIN(XBMN,X0,X1)
        XBMX = MAX(XBMX,X0,X1)
      ENDDO
      VOLBDY(IBODY) = VOLB
      SRFBDY(IBODY) = SRFB
      ELBDY(IBODY) = XBMX - XBMN
C
      RETURN
      END ! MAKEBODY




      SUBROUTINE SDUPL(NN,YDUPL,MSG)
C-----------------------------------
C     Adds image of surface NN,
C     reflected about y=YDUPL.
C-----------------------------------
      INCLUDE 'AVL.INC'
      CHARACTER*(*) MSG
C
      NNI = NSURF + 1
      IF(NNI.GT.NFMAX) THEN
        WRITE(*,*) 'SDUPL: Surface array overflow. Increase NFMAX',
     &             ' currently ',NFMAX
        STOP
      ENDIF
C
      KLEN = LEN(STITLE(NN))
      DO K = KLEN, 1, -1
        IF(STITLE(NN)(K:K) .NE. ' ') GO TO 6
      ENDDO
 6    STITLE(NNI) = STITLE(NN)(1:K) // ' (' // MSG // ')'
      WRITE(*,*) ' '
      WRITE(*,*) '  Building duplicate image-surface: ',STITLE(NNI)
C
C---- duplicate surface is assumed to be the same logical component surface
      LSCOMP(NNI) = LSCOMP(NN)
C
C---- same various logical flags
      LFWAKE(NNI) = LFWAKE(NN)
      LFALBE(NNI) = LFALBE(NN)
      LFLOAD(NNI) = LFLOAD(NN)

C---- accumulate stuff for new image surface 
      IFRST(NNI) = NVOR   + 1
      JFRST(NNI) = NSTRIP + 1
      NJ(NNI) = NJ(NN)
      NK(NNI) = NK(NN)
C
      NVC = NK(NNI)
      NVS = NJ(NNI)
C
      SSURF(NNI)    = SSURF(NN)
      CAVESURF(NNI) = CAVESURF(NN)
C--- Note hinge axis is flipped to reverse the Y component of the hinge
C    vector.   This means that deflections need to be reversed for image
C    surfaces.
C
C--- Image flag reversed (set to -IMAGS) for imaged surfaces
      IMAGS(NNI) = -IMAGS(NN)
C
      YOFF = 2.0*YDUPL
C
C--- Create image strips, to maintain the same sense of positive GAMMA
C    these have the 1 and 2 strip edges reversed (i.e. root is edge 2, 
C    not edge 1 as for a strip with IMAGS=1
      DO 100 IVS = 1, NVS
        NSTRIP = NSTRIP + 1
        IF(NSTRIP.GT.NSMAX) THEN
          WRITE(*,*) 'SDUPL: Strip array overflow. Increase NSMAX',
     &               ' currently ',NSMAX
          STOP
        ENDIF
C
        JJI = JFRST(NNI) + IVS-1
        JJ  = JFRST(NN)  + IVS-1
        RLE1(1,JJI)   =  RLE2(1,JJ)
        RLE1(2,JJI)   = -RLE2(2,JJ) + YOFF
        RLE1(3,JJI)   =  RLE2(3,JJ)
        CHORD1(JJI) =  CHORD2(JJ)
        RLE2(1,JJI)   =  RLE1(1,JJ)
        RLE2(2,JJI)   = -RLE1(2,JJ) + YOFF
        RLE2(3,JJI)   =  RLE1(3,JJ)
        CHORD2(JJI) =  CHORD1(JJ)
        RLE(1,JJI)    =  RLE(1,JJ)
        RLE(2,JJI)    = -RLE(2,JJ) + YOFF
        RLE(3,JJI)    =  RLE(3,JJ)
        CHORD(JJI)  =  CHORD(JJ)
        WSTRIP(JJI) =  WSTRIP(JJ)
        TANLE(JJI)  = -TANLE(JJ)
        AINC (JJI)  =  AINC(JJ)
C
        NSURFS(NSTRIP) = NNI
C
        DO N = 1, NDESIGN
          AINC_G(JJI,N) = AINC_G(JJ,N)
        ENDDO
C
        DO N = 1, NCONTROL
          VREFL(JJI,N) = VREFL(JJ,N)
C
          VHINGE(1,JJI,N) =  VHINGE(1,JJ,N)
          VHINGE(2,JJI,N) = -VHINGE(2,JJ,N)
          VHINGE(3,JJI,N) =  VHINGE(3,JJ,N)
C
          PHINGE(1,JJI,N) =  PHINGE(1,JJ,N)
          PHINGE(2,JJI,N) = -PHINGE(2,JJ,N) + YOFF
          PHINGE(3,JJI,N) =  PHINGE(3,JJ,N)
        ENDDO
C
C--- The defined section for image strip is flagged with (-)
        IJFRST(JJI)  = NVOR + 1
        NVSTRP(JJI)  = NVC
        DO L = 1, 6
          CLCD(L,JJI) = CLCD(L,JJ) 
        END DO
        LVISCSTRP(JJI) = LVISCSTRP(JJ)
C
        DO 80 IVC = 1, NVC
          NVOR = NVOR + 1
          IF(NVOR.GT.NVMAX) THEN
            WRITE(*,*) 'SDUPL: Vortex array overflow. Increase NVMAX',
     &                 ' currently ',NVMAX
            STOP
          ENDIF
C
          III = IJFRST(JJI) + IVC-1
          II  = IJFRST(JJ)  + IVC-1
          RV1(1,III)     =  RV2(1,II)
          RV1(2,III)     = -RV2(2,II) + YOFF
          RV1(3,III)     =  RV2(3,II)
          RV2(1,III)     =  RV1(1,II)
          RV2(2,III)     = -RV1(2,II) + YOFF
          RV2(3,III)     =  RV1(3,II)
          RV(1,III)     =  RV(1,II)
          RV(2,III)     = -RV(2,II) + YOFF
          RV(3,III)     =  RV(3,II)
          RC(1,III)     =  RC(1,II)
          RC(2,III)     = -RC(2,II) + YOFF
          RC(3,III)     =  RC(3,II)
          SLOPEC(III) = SLOPEC(II)
          SLOPEV(III) = SLOPEV(II)
          DXV(III)     = DXV(II)
          CHORDV(III) = CHORDV(II)
          NSURFV(III) = LSCOMP(NNI)
          LVALBE(III) = LVALBE(II)
          LVNC(III) = LVNC(II)
C
          DO N = 1, NCONTROL
ccc         RSGN = SIGN( 1.0 , VREFL(JJ,N) )
            RSGN = VREFL(JJ,N)
            DCONTROL(III,N) = -DCONTROL(II,N)*RSGN
          ENDDO
C
   80   CONTINUE
C
  100 CONTINUE
C
      NSURF = NSURF + 1
C
      RETURN
      END ! SDUPL




      SUBROUTINE BDUPL(NN,YDUPL,MSG)
C-----------------------------------
C     Adds image of surface NN,
C     reflected about y=YDUPL.
C-----------------------------------
      INCLUDE 'AVL.INC'
      CHARACTER*(*) MSG
C
      NNI = NBODY + 1
      IF(NNI.GT.NBMAX) THEN
        WRITE(*,*) 'BDUPL: Body array overflow. Increase NBMAX',
     &             ' currently ',NBMAX
        STOP
      ENDIF
C
      KLEN = LEN(BTITLE(NN))
      DO K = KLEN, 1, -1
        IF(BTITLE(NN)(K:K) .NE. ' ') GO TO 6
      ENDDO
 6    BTITLE(NNI) = BTITLE(NN)(1:K) // ' (' // MSG // ')'
      WRITE(*,*) ' '
      WRITE(*,*) '  Building duplicate image-body: ',BTITLE(NNI)
C
      LFRST(NNI) = NLNODE + 1
      NL(NNI) = NL(NN)
C
      NVB = NL(NNI)
C
      IF(NLNODE+NVB.GT.NLMAX) THEN
       WRITE(*,*) '*** MAKEBODY: Array overflow. Increase NLMAX to',
     &             NLNODE+NVB
       STOP
      ENDIF
C
C
      ELBDY(NNI)  = ELBDY(NN)
      SRFBDY(NNI) = SRFBDY(NN)
      VOLBDY(NNI) = VOLBDY(NN)
C
      YOFF = 2.0*YDUPL
C
C---- set body nodes and radii
      DO IVB = 1, NVB+1
        NLNODE = NLNODE + 1
C
        LLI = LFRST(NNI) + IVB-1
        LL  = LFRST(NN)  + IVB-1
C
        RL(1,LLI) =  RL(1,LL)
        RL(2,LLI) = -RL(2,LL) + YOFF
        RL(3,LLI) =  RL(3,LL)
C
        RADL(LLI) =  RADL(LL)
      ENDDO
C
      NBODY = NBODY + 1
C
      RETURN
      END ! BDUPL




      SUBROUTINE ENCALC
C
C...PURPOSE  To calculate the normal vectors for the strips, 
C            the horseshoe vortices, and the control points.
C            Incorporates surface deflections.
C
C...INPUT    NVOR      Number of vortices
C            X1        Coordinates of endpoint #1 of the vortices
C            X2        Coordinates of endpoint #2 of the vortices
C            SLOPEV    Slope at bound vortices
C            SLOPEC    Slope at control points
C            NSTRIP    Number of strips
C            IJFRST    Index of first element in strip
C            NVSTRP    No. of vortices in strip
C            AINC      Angle of incidence of strip
C            LDES      include design-variable deflections if TRUE
C
C...OUTPUT   ENC(3)        Normal vector at control point
C            ENV(3)        Normal vector at bound vortices
C            ENSY, ENSZ    Strip normal vector (ENSX=0)
C            LSTRIPOFF     Non-used strip (T) (below z=ZSYM)
C
C...COMMENTS   
C
      INCLUDE 'AVL.INC'
C
      REAL EP(3), EQ(3), ES(3), EB(3), EC(3), ECXB(3)
      REAL EC_G(3,NDMAX), ECXB_G(3)
C
C...Calculate the normal vector at control points and bound vortex midpoints
C
      DO 10 J = 1, NSTRIP
C
C...Calculate normal vector for the strip (normal to X axis)
        I = IJFRST(J)
        DXLE =  RV2(1,I)-RV1(1,I)
        DYLE =  RV2(2,I)-RV1(2,I)
        DZLE =  RV2(3,I)-RV1(3,I)
c       AXLE = (RV2(1,I)+RV1(1,I))*0.5
c       AYLE = (RV2(2,I)+RV1(2,I))*0.5
c       AZLE = (RV2(3,I)+RV1(3,I))*0.5
        AXLE = RV(1,I)
        AYLE = RV(2,I)
        AZLE = RV(3,I)
C
        I = IJFRST(J) + (NVSTRP(J)-1)
        DXTE =  RV2(1,I)-RV1(1,I)
        DYTE =  RV2(2,I)-RV1(2,I)
        DZTE =  RV2(3,I)-RV1(3,I)
c       AXTE = (RV2(1,I)+RV1(1,I))*0.5
c       AYTE = (RV2(2,I)+RV1(2,I))*0.5
c       AZTE = (RV2(3,I)+RV1(3,I))*0.5
        AXTE = RV(1,I)
        AYTE = RV(2,I)
        AZTE = RV(3,I)
C
        DXT = (1.0-SAXFR)*DXLE + SAXFR*DXTE
        DYT = (1.0-SAXFR)*DYLE + SAXFR*DYTE
        DZT = (1.0-SAXFR)*DZLE + SAXFR*DZTE
C
        ESS(1,J) =  DXT/SQRT(DXT*DXT + DYT*DYT + DZT*DZT)
        ESS(2,J) =  DYT/SQRT(DXT*DXT + DYT*DYT + DZT*DZT)
        ESS(3,J) =  DZT/SQRT(DXT*DXT + DYT*DYT + DZT*DZT)
C
        ENSY(J) = -DZT/SQRT(DYT*DYT + DZT*DZT)
        ENSZ(J) =  DYT/SQRT(DYT*DYT + DZT*DZT)
C
        XSREF(J) = (1.0-SAXFR)*AXLE + SAXFR*AXTE
        YSREF(J) = (1.0-SAXFR)*AYLE + SAXFR*AYTE
        ZSREF(J) = (1.0-SAXFR)*AZLE + SAXFR*AZTE
C
C
        ES(1) = 0.
        ES(2) = ENSY(J)
        ES(3) = ENSZ(J)
C
        LSTRIPOFF(J) = .FALSE.
C
        NV = NVSTRP(J)
        DO 105 II = 1, NV
C
          I = IJFRST(J) + (II-1)
C
          DO N = 1, NCONTROL
            ENV_D(1,I,N) = 0.
            ENV_D(2,I,N) = 0.
            ENV_D(3,I,N) = 0.
            ENC_D(1,I,N) = 0.
            ENC_D(2,I,N) = 0.
            ENC_D(3,I,N) = 0.
          ENDDO
C
          DO N = 1, NDESIGN
            ENV_G(1,I,N) = 0.
            ENV_G(2,I,N) = 0.
            ENV_G(3,I,N) = 0.
            ENC_G(1,I,N) = 0.
            ENC_G(2,I,N) = 0.
            ENC_G(3,I,N) = 0.
          ENDDO
C
C...Define unit vector along bound leg
          DXB = RV2(1,I)-RV1(1,I)
          DYB = RV2(2,I)-RV1(2,I)
          DZB = RV2(3,I)-RV1(3,I)
          EMAG = SQRT(DXB**2 + DYB**2 + DZB**2)
          EB(1) = DXB/EMAG
          EB(2) = DYB/EMAG
          EB(3) = DZB/EMAG
C
C...Define direction of normal vector at control point 
C   The YZ projection of the normal vector matches the camber slope
C   + section local incidence in the YZ defining plane for the section
          ANG = AINC(J) - ATAN(SLOPEC(I))
cc          IF(LDES) THEN
C--------- add design-variable contribution to angle
           DO N = 1, NDESIGN
             ANG = ANG + AINC_G(J,N)*DELDES(N)
           ENDDO
cc          ENDIF
C
          SINC = SIN(ANG)
          COSC = COS(ANG)
          EC(1) =  COSC
          EC(2) = -SINC*ES(2)
          EC(3) = -SINC*ES(3)
          DO N = 1, NDESIGN
            EC_G(1,N) = -SINC      *AINC_G(J,N)
            EC_G(2,N) = -COSC*ES(2)*AINC_G(J,N)
            EC_G(3,N) = -COSC*ES(3)*AINC_G(J,N)
          ENDDO
C
C...Normal vector is perpendicular to camberline vector and to the bound leg
          CALL CROSS(EC,EB,ECXB)
          EMAG = SQRT(ECXB(1)**2 + ECXB(2)**2 + ECXB(3)**2)
          IF(EMAG.NE.0.0) THEN
            ENC(1,I) = ECXB(1)/EMAG
            ENC(2,I) = ECXB(2)/EMAG
            ENC(3,I) = ECXB(3)/EMAG
            DO N = 1, NDESIGN
              CALL CROSS(EC_G(1,N),EB,ECXB_G)
              EMAG_G = ENC(1,I)*ECXB_G(1)
     &               + ENC(2,I)*ECXB_G(2)
     &               + ENC(3,I)*ECXB_G(3)
              ENC_G(1,I,N) = (ECXB_G(1) - ENC(1,I)*EMAG_G)/EMAG
              ENC_G(2,I,N) = (ECXB_G(2) - ENC(2,I)*EMAG_G)/EMAG
              ENC_G(3,I,N) = (ECXB_G(3) - ENC(3,I)*EMAG_G)/EMAG
            ENDDO
          ELSE
            ENC(1,I) = ES(1)
            ENC(2,I) = ES(2)
            ENC(3,I) = ES(3)
          ENDIF
C
C
C...Define direction of normal vector at vortex mid-point. 
C   The YZ projection of the normal vector matches the camber slope
C   + section local incidence in the YZ defining plane for the section
          ANG = AINC(J) - ATAN(SLOPEV(I)) 
cc          IF(LDES) THEN
C--------- add design-variable contribution to angle
           DO N = 1, NDESIGN
             ANG = ANG + AINC_G(J,N)*DELDES(N)
           ENDDO
cc          ENDIF
C
          SINC = SIN(ANG)
          COSC = COS(ANG)
          EC(1) =  COSC
          EC(2) = -SINC*ES(2)
          EC(3) = -SINC*ES(3)
          DO N = 1, NDESIGN
            EC_G(1,N) = -SINC      *AINC_G(J,N)
            EC_G(2,N) = -COSC*ES(2)*AINC_G(J,N)
            EC_G(3,N) = -COSC*ES(3)*AINC_G(J,N)
          ENDDO
C
C...Normal vector is perpendicular to camberline vector and to the bound leg
          CALL CROSS(EC,EB,ECXB)
          EMAG = SQRT(ECXB(1)**2 + ECXB(2)**2 + ECXB(3)**2)
          IF(EMAG.NE.0.0) THEN
            ENV(1,I) = ECXB(1)/EMAG
            ENV(2,I) = ECXB(2)/EMAG
            ENV(3,I) = ECXB(3)/EMAG
            DO N = 1, NDESIGN
              CALL CROSS(EC_G(1,N),EB,ECXB_G)
              EMAG_G = ENC(1,I)*ECXB_G(1)
     &               + ENC(2,I)*ECXB_G(2)
     &               + ENC(3,I)*ECXB_G(3)
              ENV_G(1,I,N) = (ECXB_G(1) - ENV(1,I)*EMAG_G)/EMAG
              ENV_G(2,I,N) = (ECXB_G(2) - ENV(2,I)*EMAG_G)/EMAG
              ENV_G(3,I,N) = (ECXB_G(3) - ENV(3,I)*EMAG_G)/EMAG
            ENDDO
          ELSE
            ENV(1,I) = ES(1)
            ENV(2,I) = ES(2)
            ENV(3,I) = ES(3)
          ENDIF
C
C
ccc       write(*,*) i, dcontrol(i,1), dcontrol(i,2)
C
C=======================================================
C-------- rotate normal vectors for control surface
          DO 100 N = 1, NCONTROL
C
C---------- skip everything if this element is unaffected by control variable N
            IF(DCONTROL(I,N).EQ.0.0) GO TO 100
C
            ANG     = DTR*DCONTROL(I,N)*DELCON(N)
            ANG_DDC = DTR*DCONTROL(I,N)
C
            COSD = COS(ANG)
            SIND = SIN(ANG)
C
C---------- EP = normal-vector component perpendicular to hinge line
            ENDOT = DOT(ENC(1,I),VHINGE(1,J,N))
            EP(1) = ENC(1,I) - ENDOT*VHINGE(1,J,N)
            EP(2) = ENC(2,I) - ENDOT*VHINGE(2,J,N)
            EP(3) = ENC(3,I) - ENDOT*VHINGE(3,J,N)
C---------- EQ = unit vector perpendicular to both EP and hinge line
            CALL CROSS(VHINGE(1,J,N),EP,EQ)
C
C---------- rotated vector would consist of sin,cos parts from EP and EQ,
C-          with hinge-parallel component ENDOT restored 
cc          ENC(1,I) = EP(1)*COSD + EQ(1)*SIND + ENDOT*VHINGE(1,J,N)
cc          ENC(2,I) = EP(2)*COSD + EQ(2)*SIND + ENDOT*VHINGE(2,J,N)
cc          ENC(3,I) = EP(3)*COSD + EQ(3)*SIND + ENDOT*VHINGE(3,J,N)
C
C---------- linearize about zero deflection (COSD=1, SIND=0)
            ENC_D(1,I,N) = ENC_D(1,I,N) + EQ(1)*ANG_DDC
            ENC_D(2,I,N) = ENC_D(2,I,N) + EQ(2)*ANG_DDC
            ENC_D(3,I,N) = ENC_D(3,I,N) + EQ(3)*ANG_DDC
C
C
C---------- repeat for ENV vector
C
C---------- EP = normal-vector component perpendicular to hinge line
            ENDOT = DOT(ENV(1,I),VHINGE(1,J,N))
            EP(1) = ENV(1,I) - ENDOT*VHINGE(1,J,N)
            EP(2) = ENV(2,I) - ENDOT*VHINGE(2,J,N)
            EP(3) = ENV(3,I) - ENDOT*VHINGE(3,J,N)
C---------- EQ = unit vector perpendicular to both EP and hinge line
            CALL CROSS(VHINGE(1,J,N),EP,EQ)
C
C---------- rotated vector would consist of sin,cos parts from EP and EQ,
C-          with hinge-parallel component ENDOT restored 
cc          ENV(1,I) = EP(1)*COSD + EQ(1)*SIND + ENDOT*VHINGE(1,J,N)
cc          ENV(2,I) = EP(2)*COSD + EQ(2)*SIND + ENDOT*VHINGE(2,J,N)
cc          ENV(3,I) = EP(3)*COSD + EQ(3)*SIND + ENDOT*VHINGE(3,J,N)
C
C---------- linearize about zero deflection (COSD=1, SIND=0)
            ENV_D(1,I,N) = ENV_D(1,I,N) + EQ(1)*ANG_DDC
            ENV_D(2,I,N) = ENV_D(2,I,N) + EQ(2)*ANG_DDC
            ENV_D(3,I,N) = ENV_D(3,I,N) + EQ(3)*ANG_DDC
 100      CONTINUE
 101      CONTINUE
C
 105    CONTINUE
  10  CONTINUE
C
      LENC = .TRUE.
C
      RETURN
      END ! ENCALC

C***********************************************************************
C    Module:  plutil.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************
 
      SUBROUTINE XYPLOT(N,X,Y,XOFF,XSF,YOFF,YSF,ILIN,SH,ISYM)
      DIMENSION X(N), Y(N)
C
      IF(ISYM.LE.0) CALL XYLINE(N,X,Y,XOFF,XSF,YOFF,YSF,ILIN)
      IF(ISYM.NE.0) CALL XYSYMB(N,X,Y,XOFF,XSF,YOFF,YSF,SH,IABS(ISYM))
C
      RETURN
      END



      SUBROUTINE XAXIS2(X1,Y1,XAXT,DXANN,FANN,DANN,IFLAG,CHT,NDIG)
C
C---XAXIS2 differs from libPlt XAXIS by having a flag to suppress both
C   end annotations rather than the zero annotation.
C.......................................................
C     X1,Y1  starting point of x axis
C     XAXT   length of x axis 
C     DXANN  distance between annotations
C     FANN   first annotation value
C     DANN   delta annotation value
C     IFLAG  flag to suppress end annotations 
C            = 0    all annotations
C            = 1    suppress first annotation
C            = 2    suppress last  annotation
C            = 3    suppress first and last annotations
C     CHT    character height   ( - = annotation above axis)
C     NDIG   number of digits to right of decimal point
C            = -1   no decimal point
C            = -2   number of digits determined internally
C.......................................................
C
      XAX = ABS(XAXT)
      IF(XAX.LE.0) RETURN
      CH = ABS(CHT)
C
C--- determine # of digits to use for annotations
      IF(NDIG.LE.-2) THEN
        ND = 1 - MAX( 0 , INT(LOG10(DANN)) )
        IF(DANN*10**ND - AINT(DANN*10**ND+0.01) .GT. 0.01) ND = ND + 1
        IF(DANN*10**ND - AINT(DANN*10**ND+0.01) .GT. 0.01) ND = ND + 1
      ELSE
        ND = NDIG
      ENDIF
C
C---- x-axis
      CALL PLOT(X1,Y1,3)
      CALL PLOT(X1+XAX,Y1,2)
      NANN = 1 + IFIX(XAX/DXANN + 0.1)
C
C---- annotate x-axis
      DO 10 NT=1, NANN
        XT = X1 + DXANN*FLOAT(NT-1)
C---- skip annotation for first or last annotation position as given by IFLG
        IF(MOD(IFLAG,2).EQ.1 .AND. NT.EQ.1)    GO TO 10
        IF(IFLAG.GT.1        .AND. NT.EQ.NANN) GO TO 10
C
        CALL PLOT(XT,Y1-0.2*CH,3)
        CALL PLOT(XT,Y1+0.2*CH,2)
        RN = FANN + DANN*FLOAT(NT-1)
        GRN = 0.
        IF(RN.NE.0.0) GRN = ALOG10(ABS(RN)+0.5/10.0**ND)
        GRN = MAX(GRN,0.0)
        NABC = INT(GRN) + 2 + ND
        WIDTH = 0.95*CH*FLOAT(NABC)
        IF(RN.LT.0.0) WIDTH = WIDTH + CH
        XNUM = XT - 0.5*WIDTH
        YNUM = Y1 - 2.1*CH
        IF(CHT.LT.0.0) YNUM = Y1 + 0.9*CH
C
        CALL PLNUMB(XNUM,YNUM,CH,RN,0.0,ND)
   10 CONTINUE
C
      RETURN
      END ! XAXIS
 



      SUBROUTINE VIEWINIT(AZIM, ELEV, TILT, ROBINV)
C----------------------------------------------------------------------------
C     Sets up projection for points in 3-D Cartesian space
C     onto a 2-D plane from the viewpoint of an observer
C     at a specified location.  This can be used to "view" 
C     a 3-D object described by a set of points on a planar
C     2-D graphics screen. 
C        The viewing  plane, which has its own x,y coordinate
C     system, always faces the observer but can be turned
C     around the viewing axis, thus simulating the observer
C     tilting his head while looking at the object.  This tilt
C     is specified by giving a vector which "points up" relative
C     to the observer.
C        The distance of the observer from the object is specified
C     explicitly.  This does not affect much the size of the viewed
C     object, since the viewing plane contains the 3-D space origin
C     and hence is at or near the object.  It does however affect the
C     apparent distortion of the object due to perspective.  This
C     is very useful to convey the 3-dimensionality of the object.
C     If the observer is very very far away, there is no distortion
C     (as in a mechanical drawing).
C
C     AZIM      azimuth   angle of observer in degrees   (input)
C     ELEV      elevation angle of observer in degrees   (input)
C     TILT      tilt      angle of observer in degress   (input)
C     ROBINV    1/(distance to observer)                 (input)
C
C     XYZOB(.)  Cartesian vector pointing towards observer  (internal output)
C               (magnitude irrelevant)
C     XYZUP(.)  Cartesian vector which points "up" from the 
C               observer's viewpoint (magnitude irrelevant) (internal output)
C----------------------------------------------------------------------------
C
      COMMON /VIEWDATA/ RINV,
     &       XIHAT, YIHAT, ZIHAT,
     &       XJHAT, YJHAT, ZJHAT,
     &       XKHAT, YKHAT, ZKHAT

      REAL XYZOB(3), XYZUP(3)
C
      DATA DTR / 0.01745329 /
C
      XYZOB(1) = -COS(DTR*AZIM) * COS(DTR*ELEV)
      XYZOB(2) =  SIN(DTR*AZIM) * COS(DTR*ELEV)
      XYZOB(3) =                  SIN(DTR*ELEV)
C
      XYZUP(1) =  0.
      XYZUP(2) = -SIN(DTR*TILT)
      XYZUP(3) =  COS(DTR*TILT)
C
C---- unit view vector out of viewing plane (towards observer)
      XKHAT = XYZOB(1)/SQRT(XYZOB(1)**2 + XYZOB(2)**2 + XYZOB(3)**2)
      YKHAT = XYZOB(2)/SQRT(XYZOB(1)**2 + XYZOB(2)**2 + XYZOB(3)**2)
      ZKHAT = XYZOB(3)/SQRT(XYZOB(1)**2 + XYZOB(2)**2 + XYZOB(3)**2)
C
C---- vector along plane's local x coordinate: (up vector)X(view vector)
      XIP = XYZUP(2)*ZKHAT - XYZUP(3)*YKHAT
      YIP = XYZUP(3)*XKHAT - XYZUP(1)*ZKHAT
      ZIP = XYZUP(1)*YKHAT - XYZUP(2)*XKHAT
C
C---- normalize plane's x coordinate vector
      XIHAT = XIP/SQRT(XIP**2 + YIP**2 + ZIP**2)
      YIHAT = YIP/SQRT(XIP**2 + YIP**2 + ZIP**2)
      ZIHAT = ZIP/SQRT(XIP**2 + YIP**2 + ZIP**2)
C
C---- unit vector along plane's y coord.: (view vector)X(x unit vector)
      XJHAT = YKHAT*ZIHAT - ZKHAT*YIHAT
      YJHAT = ZKHAT*XIHAT - XKHAT*ZIHAT
      ZJHAT = XKHAT*YIHAT - YKHAT*XIHAT
C
      RINV = ROBINV
C
      RETURN
      END ! VIEWINIT



      SUBROUTINE VIEWPROJ(XYZ,N,XYZPROJ)
      REAL XYZ(3,N), XYZPROJ(3,N)
C.......................................................................
C
C     Projects one or more points in 3-D Cartesian space
C     onto a 2-D plane from the viewpoint of an observer
C     at a specified location using the projection transformation
C     setup in VIEWINIT.
C
C     This can be used to "view" a 3-D object described by a set 
C     of points on a planar 2-D graphics screen.  This routine also 
C     returns the out-of-plane vector for depth comparison.
C        The viewing  plane, which has its own x,y coordinate
C     system, always faces the observer but can be turned
C     around the viewing axis, thus simulating the observer
C     tilting his head while looking at the object.  This tilt
C     is specified by giving a vector which "points up" relative
C     to the observer.
C        The distance of the observer from the object is specified
C     explicitly.  This does not affect much the size of the viewed
C     object, since the viewing plane contains the 3-D space origin
C     and hence is at or near the object.  It does however affect the
C     apparent distortion of the object due to perspective.  This
C     is very useful to convey the 3-dimensionality of the object.
C     If the observer is very very far away, there is no distortion
C     (as in a mechanical drawing).
C
C     XYZ(.)       Cartesian point coordinates                  (input)
C     N            number of points                             (input)
C     XYZPROJ(.)   projected point coordinates on viewing plane (output)
C.......................................................................
C
      COMMON /VIEWDATA/ RINV,
     &       XIHAT, YIHAT, ZIHAT,
     &       XJHAT, YJHAT, ZJHAT,
     &       XKHAT, YKHAT, ZKHAT
C
C
C---- go over all points
      DO I=1, N
        RDOTI = XYZ(1,I)*XIHAT + XYZ(2,I)*YIHAT + XYZ(3,I)*ZIHAT
        RDOTJ = XYZ(1,I)*XJHAT + XYZ(2,I)*YJHAT + XYZ(3,I)*ZJHAT
        RDOTK = XYZ(1,I)*XKHAT + XYZ(2,I)*YKHAT + XYZ(3,I)*ZKHAT
C
C------ viewing-axis component of vector
        RKX = RDOTK*XKHAT
        RKY = RDOTK*YKHAT
        RKZ = RDOTK*ZKHAT
C
C------ projected vector scaling factor due to perspective
        VSCAL = 1.0 / SQRT( (XKHAT-RINV*RKX)**2
     &                    + (YKHAT-RINV*RKY)**2
     &                    + (ZKHAT-RINV*RKZ)**2 )
C
C------ dot vector into plane coordinate system unit vectors, and scale
        XYZPROJ(1,I) = VSCAL * RDOTI
        XYZPROJ(2,I) = VSCAL * RDOTJ
        XYZPROJ(3,I) = VSCAL * RDOTK
      END DO
C
      RETURN
      END



      SUBROUTINE OPLSET(IDEV,IDEVH,IPSLU,LSVMOV,
     &                  SIZE,PAR,
     &                  XMARG,YMARG,XPAGE,YPAGE,
     &                  CSIZE,SCRNFR,LCURS,LCREV)
      LOGICAL LSVMOV,LCURS,LCREV
C-----------------------------------------------------------
C     Allows user modification of various plot parameters.
C-----------------------------------------------------------
      CHARACTER*1 VAR
      CHARACTER*4 COMAND
      CHARACTER*128 COMARG
      CHARACTER*10 CHCURS, CHLAND
      DIMENSION IINPUT(20)
      DIMENSION RINPUT(20)
      LOGICAL ERROR, LGRAPH, LCOLOR, LFILES
C
 1000 FORMAT(A)
C
 1    CONTINUE
      IF(LCURS) THEN
       CHCURS = 'Cursor    '
      ELSE
       CHCURS = 'Keyboard  '
      ENDIF
C
      IF(SCRNFR.GT.0.0) THEN
       CHLAND = 'Landscape '
      ELSE
       CHLAND = 'Portrait  '
      ENDIF
C
      ASF = ABS(SCRNFR)
C
      LGRAPH = IDEV  .GE. 1
      LCOLOR = IDEVH .EQ. 4
      LFILES = IPSLU .LT. 0
C
      WRITE(*,2000) LGRAPH, LCOLOR, LFILES, LSVMOV,
     &              PAR, ASF, SIZE,
     &              XPAGE,YPAGE, XMARG,YMARG, 
     &              CSIZE,
     &              CHLAND, CHCURS
 2000 FORMAT(' ...............................................'
     &     //'  G raphics-enable flag        ', L2,
     &      /'  C olor PostScript output?    ', L2,
     &      /'  I ndividual PS file output?  ', L2,
     &      /'  H ardcopy movie PS output?   ', L2,
     &     //'  A spect ratio of plot object ', F8.4
     &      /'  W indow/screen size fraction ', F8.4
     &     //'  S ize of plot object         ', F6.2,'"'
     &      /'  P age dimensions             ', F6.2,' x',F6.2,'"'
     &      /'  M argins from page edges     ', F6.2,'",',F6.2,'"'
     &      /'  F ont size (relative)        ', F8.4
     &     //'  O rientation of plot:        ', A 
     &      /'  B lowup input method:        ', A )
ccc     &      /'  R everse-video output?       ', L2 )
C
C   A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
C   x x x     x x           x   x x     x       x     
C
 5    CALL ASKC('      Option, Value   (or <Return>) ^',COMAND,COMARG)
C
      DO I=1, 20
        IINPUT(I) = 0.0
        RINPUT(I) = 0.0
      ENDDO
      NINPUT = 0
      CALL GETINT(COMARG,IINPUT,NINPUT,ERROR)
      NINPUT = 0
      CALL GETFLT(COMARG,RINPUT,NINPUT,ERROR)
C
      VAR = COMAND(1:1)
      IF (VAR.EQ.'0' .OR. VAR.EQ.' ') THEN
       RETURN
C
      ELSEIF (INDEX('Gg',VAR).NE.0) THEN
        IF(IDEV.EQ.0) THEN
         IDEV = 1
        ELSE
         IDEV = 0
        ENDIF
C
      ELSEIF (INDEX('Cc',VAR).NE.0) THEN
        IF(IDEVH.EQ.2) THEN
         IDEVH = 4
        ELSE
         IDEVH = 2
        ENDIF
C
      ELSEIF (INDEX('Ii',VAR).NE.0) THEN
        IF(IPSLU.EQ.0) THEN
         IPSLU = -1
        ELSE
         IPSLU = 0
        ENDIF
C
      ELSEIF (INDEX('Ss',VAR).NE.0) THEN
        IF(NINPUT.GE.1) THEN
          SIZE = RINPUT(1)
        ELSE
          CALL ASKR('Enter size (in)^',SIZE)
        ENDIF
C
      ELSEIF (INDEX('Aa',VAR).NE.0) THEN
        IF(NINPUT.GE.1) THEN
          PAR = RINPUT(1)
        ELSE
          CALL ASKR('Enter aspect ratio^',PAR)
        ENDIF
C
      ELSEIF (INDEX('Pp',VAR).NE.0) THEN
        IF(NINPUT.GE.2) THEN
          XPAGE = RINPUT(1)
          YPAGE = RINPUT(2)
        ELSEIF(NINPUT.GE.1) THEN
          XPAGE = RINPUT(1)
          CALL ASKR('Enter page Y dimension (in)^',YPAGE)
        ELSE
          CALL ASKR('Enter page X dimension (in)^',XPAGE)
          CALL ASKR('Enter page Y dimension (in)^',YPAGE)
        ENDIF
C
      ELSEIF (INDEX('Mm',VAR).NE.0) THEN
        IF(NINPUT.GE.2) THEN
          XMARG = RINPUT(1)
          YMARG = RINPUT(2)
        ELSEIF(NINPUT.GE.1) THEN
          XMARG = RINPUT(1)
          CALL ASKR('Enter page Y margin (in)^',YMARG)
        ELSE
          CALL ASKR('Enter page X margin (in)^',XMARG)
          CALL ASKR('Enter page Y margin (in)^',YMARG)
        ENDIF
C
      ELSEIF (INDEX('Ff',VAR).NE.0) THEN
        IF(NINPUT.GE.1) THEN
          CSIZE = RINPUT(1)
        ELSE
          CALL ASKR('Enter character font size^',CSIZE)
        ENDIF
C
      ELSEIF (INDEX('Ww',VAR).NE.0) THEN
        IF(NINPUT.GE.1) THEN
          ASF = RINPUT(1)
        ELSE
          CALL ASKR('Enter window/screen size fraction^',ASF)
        ENDIF
        SCRNFR = SIGN( ASF , SCRNFR )
C
      ELSEIF (INDEX('Bb',VAR).NE.0) THEN
        LCURS = .NOT. LCURS
C
      ELSEIF (INDEX('Oo',VAR).NE.0) THEN
        SCRNFR = -SCRNFR
        WRITE(*,*)
        WRITE(*,*) 'Swapping X,Y page dimensions'
        XTMP = XPAGE
        YTMP = YPAGE
        XPAGE = YTMP
        YPAGE = XTMP
C
      ELSEIF (INDEX('Rr',VAR).NE.0) THEN
        LCREV = .NOT. LCREV
C
      ELSE
        WRITE(*,*) '*** Item not recognized ***'
      ENDIF
      GO TO 1
C
      END ! OPLSET





      subroutine AXISADJ2(xmin,xmax,xspan,deltax,ntics)
C...Make scaled axes with engineering increments between tics
C
C   Input:    xmin, xmax - input range for which scaled axis is desired
C
C   Output:   xmin, xmax - adjusted range for scaled axis
C             xspan      - adjusted span of scaled axis
C             deltax     - increment to be used for scaled axis
C             ntics      - number of axis tics (each deltax long)
C
      real    xmin,xmax,xspan,deltax,xinc,xinctbl(4)
      integer ntics,i
      data    xinctbl / 0.1, 0.2, 0.5, 1.0 /
c
      xspan1 = xmax-xmin
      if (xspan1.eq.0.) xspan1 = 1.
c
      xpon = ifix(log10(xspan1))
      xspan = xspan1 / 10.**xpon
c
      do i = 1, 4
        xinc = xinctbl(i)
        ntics = 1 + ifix(xspan/xinc)
        if (ntics.LE.12) go to 1
      end do
c
   1  deltax = xinc*10.**xpon
      xmin = deltax*  ifloor(xmin/deltax)
      xmax = deltax*iceiling(xmax/deltax)
      xspan = xmax - xmin
      return
      end

C***********************************************************************
C    Module:  atrim.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************


      SUBROUTINE TRMSET(COMAND,COMARG,LMATCH,IR)
      INCLUDE 'AVL.INC'
      CHARACTER*(*) COMAND, COMARG
      LOGICAL LMATCH
C
      CHARACTER*2 CNUM
C
      CHARACTER*4 COM
      CHARACTER*80 CARG, PROMPT, RTNEW
      LOGICAL ERROR, REPKEY
C
      INTEGER IINP(10)
      REAL RINP(10)
C
C---- for trim command, first number in arg string should be part of command
      IF(COMAND(1:1) .NE. 'C') THEN
       LMATCH = .FALSE.
       RETURN
      ENDIF
C
      CNUM = COMARG(1:2)
C
C
      IF    (CNUM.EQ.'1 ') THEN
       KTRIM = 1
cc       CALL TRIM1(IR)
       LMATCH = .TRUE.
C
      ELSEIF(CNUM.EQ.'2 ') THEN
       KTRIM = 2
cc       CALL TRIM2(IR)
       LMATCH = .TRUE.
C
      ELSE
       LMATCH = .FALSE.
       RETURN
C
      ENDIF
C
C
C---- start here with new run case
 100  CONTINUE
C
      IF(KTRIM.EQ.1 .OR.
     &   KTRIM.EQ.2      ) THEN
       IF(PARVAL(IPCL,IR) .EQ. 0.0) THEN
C------ current case has CL=0 ... set it using CL constraint, if it's present
        DO IV = 1, NVTOT
          IF(ICON(IV,IR) .EQ. ICCL) THEN
           WRITE(*,*)
           WRITE(*,*)'       Setting trim CL from current CL constraint'
           PARVAL(IPCL,IR) = CONVAL(ICCL,IR)
           GO TO 101
          ENDIF
        ENDDO
       ENDIF
 101   CONTINUE
      ENDIF
C
      WRITE(*,*)
C
C---- tag this run case with trim type (not converged yet)
      ITRIM(IR) = -KTRIM
C
      IF(PARVAL(IPRHO,IR) .LE. 0.0) PARVAL(IPRHO,IR)  = RHO0
      IF(PARVAL(IPGEE,IR) .LE. 0.0) PARVAL(IPGEE,IR)  = GEE0
      IF(PARVAL(IPMASS,IR).LE. 0.0) PARVAL(IPMASS,IR) = RMASS0
C
      IR1 = IR
      IR2 = IR
C
C----------------------------------------------------------------
C---- jump back here to calculate stuff depending on case
 5    CONTINUE
C
      CREFD = CREF*UNITL
      BREFD = BREF*UNITL
      SREFD = SREF*UNITL**2
C
C- - - - - - - - - - - - - - - - - - - - - - - - 
 7500 FORMAT('     .. setting new ', A,' for run case', I3)
C
      IF    (KTRIM.EQ.1) THEN
C------ Level or banked horizontal flight:    recalculate V or CL, Radius
C
        DO 7 JR = IR1, IR2
          PHI = PARVAL(IPPHI,JR)
          THE = PARVAL(IPTHE,JR)
          CL  = PARVAL(IPCL ,JR)
          CD0 = PARVAL(IPCD0,JR)
          VEE = PARVAL(IPVEE,JR)
          RAD = PARVAL(IPRAD,JR)
          RHO = PARVAL(IPRHO,JR)
          GEE = PARVAL(IPGEE,JR)
          FAC = PARVAL(IPFAC,JR)
          RMASS = PARVAL(IPMASS,JR)
C
          SINP = SIN(PHI*DTR)
          COSP = COS(PHI*DTR)
C
C-------- set velocity ?
          IF(VEE .LE. 0.0 .AND.
     &       CL  .GT. 0.0       ) THEN
           VEE = SQRT( 2.0*RMASS*GEE / (RHO*SREFD*CL*COSP) )
           PARVAL(IPVEE,JR) = VEE
           WRITE(*,7500) 'velocity', JR
          ENDIF
C
C-------- set CL ?
          IF(CL  .LE. 0.0 .AND.
     &       VEE .GT. 0.0       ) THEN
           CL  = 2.0*RMASS*GEE / (RHO*SREFD*VEE**2*COSP)
           PARVAL(IPCL,JR) = CL
           WRITE(*,7500) 'CL', JR
          ENDIF
C
          IF(SINP .EQ. 0.0) THEN
           RAD = 0.
          ELSE
           RAD = VEE**2 * COSP / (GEE * SINP)
          ENDIF
          PARVAL(IPRAD,JR) = RAD
          WRITE(*,7500) 'turn radius', JR
C
          FAC = 1.0/COSP
          PARVAL(IPFAC,JR) = FAC
          WRITE(*,7500) 'load factor', JR
C
          THE = 0.
          PARVAL(IPTHE,JR) = THE
cc        WRITE(*,7500) 'elevation', JR
C
C-------- set up CL and rotation rate constraints
          IF(RAD .GT. 0.0) THEN
           WHX = 0.
           WHY = SINP * CREFD/(2.0*RAD)
           WHZ = COSP * BREFD/(2.0*RAD)
          ELSE
           WHX = 0.
           WHY = 0.
           WHZ = 0.
          ENDIF
C
          CONVAL(ICCL  ,JR) = CL 
          CONVAL(ICROTX,JR) = WHX
          CONVAL(ICROTY,JR) = WHY
          CONVAL(ICROTZ,JR) = WHZ
C 
          ICON(IVALFA,JR) = ICCL
          ICON(IVROTX,JR) = ICROTX
          ICON(IVROTY,JR) = ICROTY
          ICON(IVROTZ,JR) = ICROTZ
 7      CONTINUE
C
C- - - - - - - - - - - - - - - - - - - - - - - - 
      ELSEIF(KTRIM.EQ.2) THEN
C------ Steady pitch rate (looping flight
C
        DO 8 JR = IR1, IR2
          PHI = PARVAL(IPPHI,JR)
          THE = PARVAL(IPTHE,JR)
          CL  = PARVAL(IPCL ,JR)
          CD0 = PARVAL(IPCD0,JR)
          VEE = PARVAL(IPVEE,JR)
          RAD = PARVAL(IPRAD,JR)
          RHO = PARVAL(IPRHO,JR)
          GEE = PARVAL(IPGEE,JR)
          FAC = PARVAL(IPFAC,JR)
          RMASS = PARVAL(IPMASS,JR)
C
          SINP = SIN(PHI*DTR)
          COSP = COS(PHI*DTR)
C
C-------- set radius ?
          IF(RAD .EQ. 0.0 .AND.
     &       CL  .GT. 0.0      ) THEN
           RAD = RMASS / (0.5*RHO * SREFD * CL)
           PARVAL(IPRAD,JR) = RAD
           WRITE(*,7500) 'turn radius', JR
          ENDIF
C
C-------- set CL ?
          IF(RAD .GT. 0.0 .AND.
     &       CL  .EQ. 0.0      ) THEN
           CL = RMASS / (0.5*RHO * SREFD * RAD)
           PARVAL(IPCL,JR) = CL
           WRITE(*,7500) 'CL', JR
          ENDIF
C
C-------- set load factor ?
          IF(FAC .EQ. 0.0 .AND.
     &       CL  .GT. 0.0 .AND. 
     &       VEE .GT. 0.0 .AND. 
     &       GEE .GT. 0.0      ) THEN
           FAC = 0.5*RHO*VEE**2 * SREFD * CL / (RMASS*GEE)
           PARVAL(IPFAC,JR) = FAC
           WRITE(*,7500) 'load factor', JR
          ENDIF
C
C-------- set velocity ?
          IF(FAC .GT. 0.0 .AND.
     &       CL  .GT. 0.0 .AND. 
     &       VEE .EQ. 0.0 .AND. 
     &       GEE .GT. 0.0      ) THEN
           VEE = SQRT( FAC * RMASS*GEE / (0.5*RHO*SREFD*CL) )
           PARVAL(IPVEE,JR) = VEE
           WRITE(*,7500) 'velocity', JR
          ENDIF
C
          THE = 0.
          PARVAL(IPTHE,JR) = THE
cc        WRITE(*,7500) 'elevation', JR
C
C-------- set up CL and rotation rate constraints
          IF(RAD .GT. 0.0) THEN
           WHX = 0.
           WHY = CREFD/(2.0*RAD)
           WHZ = 0.
          ELSE
           WHX = 0.
           WHY = 0.
           WHZ = 0.
          ENDIF
C
          CONVAL(ICCL  ,JR) = CL 
          CONVAL(ICROTX,JR) = WHX
          CONVAL(ICROTY,JR) = WHY
          CONVAL(ICROTZ,JR) = WHZ
C 
          ICON(IVALFA,JR) = ICCL
          ICON(IVROTX,JR) = ICROTX
          ICON(IVROTY,JR) = ICROTY
          ICON(IVROTZ,JR) = ICROTZ
 8      CONTINUE
C
      ENDIF
C
      PHI = PARVAL(IPPHI,IR)
      THE = PARVAL(IPTHE,IR)
      CL  = PARVAL(IPCL ,IR)
      CD0 = PARVAL(IPCD0,IR)
      VEE = PARVAL(IPVEE,IR)
      RAD = PARVAL(IPRAD,IR)
      RHO = PARVAL(IPRHO,IR)
      GEE = PARVAL(IPGEE,IR)
      FAC = PARVAL(IPFAC,IR)
      XCG = PARVAL(IPXCG,IR)
      YCG = PARVAL(IPYCG,IR)
      ZCG = PARVAL(IPZCG,IR)
      RMASS = PARVAL(IPMASS,IR)
C
      SINP = SIN(PHI*DTR)
      COSP = COS(PHI*DTR)
C
 1000 FORMAT(A)
 2000 FORMAT(/'     Setup of trimmed run case ',A,':  ', A)
 2005 FORMAT( '     ', A
     &       /'     =================================================')
 2105 FORMAT(6X, A, G10.4, 2X, A)
 2110 FORMAT(6X, A, A )
C
C--------------------------------------------------------------------------
C----- jump back here just for menu
 10    CONTINUE
       CALL CFRAC(IR,NRUN,PROMPT,NPR)
       WRITE(*,2000) PROMPT(1:NPR),RTITLE(IR)
C
       IF    (KTRIM.EQ.1) THEN
        WRITE(*,2005) '(level or banked horizontal flight)'
        WRITE(*,2105) 'B  bank angle = ', PHI  , 'deg'
        WRITE(*,2105) 'C  CL         = ', CL   , ' '
        WRITE(*,2105) 'V  velocity   = ', VEE  , UNCHV(1:NUV)
        WRITE(*,2105) 'M  mass       = ', RMASS, UNCHM(1:NUM)
        WRITE(*,2105) 'D  air dens.  = ', RHO  , UNCHD(1:NUD)
        WRITE(*,2105) 'G  grav.acc.  = ', GEE  , UNCHA(1:NUA)
        WRITE(*,2105) '   turn rad.  = ', RAD  , UNCHL(1:NUL)
        WRITE(*,2105) '   load fac.  = ', FAC  , ' '
        WRITE(*,2105) 'X  X_cg       = ', XCG  , 'Lunit'
        WRITE(*,2105) 'Y  Y_cg       = ', YCG  , 'Lunit'
        WRITE(*,2105) 'Z  Z_cg       = ', ZCG  , 'Lunit'
C
       ELSEIF(KTRIM.EQ.2) THEN
        WRITE(*,2005) '(steady pitch rate - looping flight)'
        WRITE(*,2105) 'C  CL        = ', CL   , ' '
        WRITE(*,2105) 'V  velocity  = ', VEE  , UNCHV(1:NUV) 
        WRITE(*,2105) 'M  mass      = ', RMASS, UNCHM(1:NUM)
        WRITE(*,2105) 'D  air dens. = ', RHO  , UNCHD(1:NUD) 
        WRITE(*,2105) 'G  grav.acc. = ', GEE  , UNCHA(1:NUA) 
        WRITE(*,2105) 'R  turn rad. = ', RAD  , UNCHL(1:NUL) 
        WRITE(*,2105) 'L  load fac. = ', FAC  , ' '
        WRITE(*,2105) 'X  X_cg      = ', XCG  , 'Lunit'
        WRITE(*,2105) 'Y  Y_cg      = ', YCG  , 'Lunit'
        WRITE(*,2105) 'Z  Z_cg      = ', ZCG  , 'Lunit'
C
       ENDIF
C
       CALL ASKC('     Enter parameter, value  (or  # - + N )',COM,CARG)
C
       IF(COM.EQ.'    ') THEN
C------ just a Return entered... go back
        RETURN
       ENDIF
C
C
C------------------------------------------------------
C---- check for run case commands
      IF(COM.EQ.'+   ') THEN
C----- add new case after current one
C
       IF(NRUN.EQ.NRMAX) THEN
        WRITE(*,*)
        WRITE(*,*) '* Run case array limit NRMAX reached'
       ELSE
        NRUN = NRUN + 1
C
        DO JR = NRUN, IR+1, -1
          CALL RCOPY(JR,JR-1)
        ENDDO
        WRITE(*,*) 'Initializing new run case from current one'
C        
        IR = IR + 1
       ENDIF
C
       GO TO 100
C
      ELSEIF(COM.EQ.'-   ') THEN
C----- delete current case
C
       IF(NRUN.LE.1) THEN
        WRITE(*,*)
        WRITE(*,*) '* Cannot delete one remaining run case'
       ELSE
        DO JR = IR, NRUN-1
          CALL RCOPY(JR,JR+1)
        ENDDO
        NRUN = NRUN - 1
        IRUN = MAX( 1 , MIN( IRUN , NRUN ) )
       ENDIF
C
       GO TO 100
C
      ENDIF
C
C------------------------------------------------------
C---- see if command is an integer (new run case selection)
      NINP = 1
      CALL GETINT(COM,IINP,NINP,ERROR)
      IF(.NOT.ERROR .AND. NINP.GE.1 
     &  .AND. COM(1:1).NE.'T'
     &  .AND. COM(1:1).NE.'F' ) THEN
C----- command is an integer... new case index?
       IF(IINP(1).LT.1 .OR. IINP(1).GT.NRUN) THEN
        WRITE(*,*)
        WRITE(*,*) '* Selected new run case is not defined'
        GO TO 10
       ELSE
C------ valid new run case selected... go back to top of menu
        IR = IINP(1)
        GO TO 100
       ENDIF
      ENDIF
C
C
C------------------------------------------------------
C---- extract argument, if any
      NINP = 1
      CALL GETFLT(CARG,RINP,NINP,ERROR)
C
C
      IF    (COM(1:1) .EQ. COM(2:2)) THEN
       REPKEY = .TRUE.
       IR1 = 1
       IR2 = NRUN
       COM(2:2) = ' '
      ELSEIF(COM(1:2) .EQ. COM(3:4)) THEN
       REPKEY = .TRUE.
       IR1 = 1
       IR2 = NRUN
       COM(3:4) = '  '
      ELSE
       REPKEY = .FALSE.
       IR1 = IR
       IR2 = IR
      ENDIF
C
C
C==============================================================================
C---- now decode regular parameter value commands
C
C------------------------------------
      IF(COM(1:1).EQ.'B') THEN
        IF    (KTRIM.EQ.1) THEN
 11      CONTINUE
         IF(NINP.GE.1) THEN
          PHI = RINP(1)
         ELSE
          CALL ASKR('      Enter bank angle^',PHI)
         ENDIF
C
         IF(PHI.LE.-90.0 .OR. PHI.GE.90.0) THEN
          WRITE(*,*) '    * Must have  -90 < bank < +90'
          NINP = 0
          GO TO 11
         ENDIF
C
         DO JR = IR1, IR2
           PARVAL(IPPHI,JR) = PHI
C
C--------- recalculate V, R, and N
           PARVAL(IPVEE,JR) = 0.
         ENDDO
C
        ELSEIF(KTRIM.EQ.2) THEN
         WRITE(*,*) 'Bank angle not used for this trim case'
         GO TO 10
C
        ENDIF
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'C' .OR.
     &       COM(1:2).EQ.'CL'      ) THEN
 21     CONTINUE
        IF(NINP.GE.1) THEN
         CL = RINP(1)
        ELSE
         CALL ASKR('      Enter CL^',CL)
        ENDIF
C
        IF(CL .LE. 0.0) THEN
         WRITE(*,*) '    * Must have  CL > 0'
         NINP = 0
         GO TO 21
        ENDIF

        DO JR = IR1, IR2
          PARVAL(IPCL,JR) = CL
C
          IF    (KTRIM.EQ.1) THEN
C--------- go recalculate V and R
           PARVAL(IPVEE,JR) = 0.
           PARVAL(IPRAD,JR) = 0.
C
          ELSEIF(KTRIM.EQ.2) THEN
C--------- go recalculate R and N
           PARVAL(IPRAD,JR) = 0.
           PARVAL(IPFAC,JR) = 0.
C
          ENDIF
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'V') THEN
 31     CONTINUE
        IF(NINP.GE.1) THEN
         VEE = RINP(1)
        ELSE
         CALL ASKR('      Enter velocity^',VEE)
        ENDIF
C
        IF(VEE.LE.0.0) THEN
         WRITE(*,*) '    * Must have  V > 0'
         NINP = 0
         GO TO 31
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPVEE,JR) = VEE
C
          IF    (KTRIM.EQ.1) THEN
C--------- go recalculate CL
           PARVAL(IPCL,JR) = 0.
C
          ELSEIF(KTRIM.EQ.2) THEN
C--------- go recalculate N
           PARVAL(IPFAC,JR) = 0.
C
          ENDIF
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'M') THEN
 41     CONTINUE
        IF(NINP.GE.1) THEN
         RMASS = RINP(1)
        ELSE
         CALL ASKR('      Enter mass^',RMASS)
        ENDIF
C
        IF(RMASS.LE.0.0) THEN
         WRITE(*,*) '    * Must have  m > 0'
         NINP = 0
         GO TO 41
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPMASS,JR) = RMASS
C
          IF    (KTRIM.EQ.1) THEN
C--------- go recalculate V
           PARVAL(IPVEE,JR) = 0.
C
          ELSEIF(KTRIM.EQ.2) THEN
C--------- go recalculate R and N
           PARVAL(IPRAD,JR) = 0.
           PARVAL(IPFAC,JR) = 0.
C
          ENDIF
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'D') THEN
 51     CONTINUE
        IF(NINP.GE.1) THEN
         RHO = RINP(1)
        ELSE
         CALL ASKR('      Enter air density^',RHO)
        ENDIF
C
        IF(RHO.LE.0.0) THEN
         WRITE(*,*) '    * Must have  rho > 0'
         NINP = 0
         GO TO 51
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPRHO,JR) = RHO
C
          IF    (KTRIM.EQ.1) THEN
C--------- go recalculate V
           PARVAL(IPVEE,JR) = 0.
C
          ELSEIF(KTRIM.EQ.2) THEN
C--------- go recalculate R and N
           PARVAL(IPRAD,JR) = 0.
           PARVAL(IPFAC,JR) = 0.
C
          ENDIF
        ENDDO

C-------------------------------------
      ELSEIF(COM(1:1).EQ.'G') THEN
 61     CONTINUE
        IF(NINP.GE.1) THEN
         GEE = RINP(1)
        ELSE
         CALL ASKR('      Enter gravity^',GEE)
        ENDIF
C
        IF(GEE.LE.0.0) THEN
         WRITE(*,*) '    * Must have  g > 0'
         NINP = 0
         GO TO 61
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPGEE,JR) = GEE
C
          IF    (KTRIM.EQ.1) THEN
C--------- go recalculate V
           PARVAL(IPVEE,JR) = 0.
C
          ELSEIF(KTRIM.EQ.2) THEN
C--------- go recalculate N
           PARVAL(IPFAC,JR) = 0.
C
          ENDIF
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'R') THEN
        IF    (KTRIM.EQ.1) THEN
         WRITE(*,*) 'Turn radius not specifiable for this trim case'
         GO TO 10
C
        ELSEIF(KTRIM.EQ.2) THEN
 71      CONTINUE
         IF(NINP.GE.1) THEN
          RAD = RINP(1)
         ELSE
          CALL ASKR('      Enter turn radius^',RAD)
         ENDIF
C
         IF(RAD.LE.0.0) THEN
          WRITE(*,*) '    * Must have  R > 0'
          NINP = 0
          GO TO 71
         ENDIF
C
         DO JR = IR1, IR2
           PARVAL(IPRAD,JR) = RAD
C
C--------- go recalculate CL, N
           PARVAL(IPCL ,JR) = 0.
           PARVAL(IPFAC,JR) = 0.
         ENDDO
C
        ENDIF
C
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'L') THEN
        IF    (KTRIM.EQ.1) THEN
         WRITE(*,*) 'Load factor not specifiable for this trim case'
         GO TO 10
C
        ELSEIF(KTRIM.EQ.2) THEN
 81      CONTINUE
         IF(NINP.GE.1) THEN
          FAC = RINP(1)
         ELSE
          CALL ASKR('      Enter load factor^',FAC)
         ENDIF
C
         IF(FAC.LE.0.0) THEN
          WRITE(*,*) '    * Must have  N > 0'
          NINP = 0
          GO TO 81
         ENDIF
C
         DO JR = IR1, IR2
           PARVAL(IPFAC,JR) = FAC
C
C--------- go recalculate V
           PARVAL(IPVEE,JR) = 0.
         ENDDO
C
        ENDIF
C
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'X') THEN
        IF(NINP.GE.1) THEN
         XCG = RINP(1)
        ELSE
         CALL ASKR('      Enter X_cg location^',XCG)
        ENDIF
        DO JR = IR1, IR2
          PARVAL(IPXCG,JR) = XCG
          WRITE(*,7500) 'x_cg', JR
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'Y') THEN
        IF(NINP.GE.1) THEN
         YCG = RINP(1)
        ELSE
         CALL ASKR('      Enter Y_cg location^',YCG)
        ENDIF
        DO JR = IR1, IR2
          PARVAL(IPYCG,JR) = YCG
          WRITE(*,7500) 'y_cg', JR
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'Z') THEN
        IF(NINP.GE.1) THEN
         ZCG = RINP(1)
        ELSE
         CALL ASKR('      Enter Z_cg location^',ZCG)
        ENDIF
        DO JR = IR1, IR2
          PARVAL(IPZCG,JR) = ZCG
          WRITE(*,7500) 'z_cg', JR
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:1).EQ.'P') THEN
        IF(NINP.GE.1) THEN
         CD0 = RINP(1)
        ELSE
         CALL ASKR('      Enter profile CDo^',CD0)
        ENDIF
        DO JR = IR1, IR2
          PARVAL(IPCD0,JR) = CD0
          WRITE(*,7500) 'CDo', JR
        ENDDO
C
C------------------------------------------------------
      ELSEIF(COM .EQ. 'N') THEN
C------ change name of run case
        IF(CARG.NE.' ') THEN
         RTITLE(IR) = CARG
        ELSE
         WRITE(*,830) RTITLE(IR)
 830     FORMAT(/' Enter run case name:  ', A)
         READ(*,1000) RTNEW
         IF(RTNEW.NE.' ') RTITLE(IR) = RTNEW
        ENDIF
C
C-------------------------------------
      ELSE
        WRITE(*,*) '     * Unrecognized parameter'
        GO TO 10
C
      ENDIF
C
      GO TO 5
C
      END ! TRMSET

C***********************************************************************
C    Module:  avl.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      PROGRAM AVL
C=======================================================================
C     3-D Vortex Lattice code.
C     See file avl_doc.txt for user guide.
C     See file version_notes.txt for most recent changes.
C=======================================================================
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      LOGICAL ERROR, LINPFILE
C
      CHARACTER*4 COMAND
      CHARACTER*128 COMARG
      CHARACTER*256 FNNEW
C
      REAL    RINPUT(20)
      INTEGER IINPUT(20)
C
C      
      VERSION = 3.36
C
 1000 FORMAT(A)
C
      WRITE (*,1005) VERSION
 1005 FORMAT (
     &  /' ==================================================='
     &  /'  Athena Vortex Lattice  Program      Version ',F5.2
     &  /'  Copyright (C) 2002   Mark Drela, Harold Youngren'
     & //'  This software comes with ABSOLUTELY NO WARRANTY,' 
     &  /'    subject to the GNU General Public License.'
     & //'  Caveat computor'
     &  /' ===================================================')
C
C
      PI = 4.0*ATAN(1.0)
      DTR = PI/180.0
C
C---- Flag for having valid input data from file
      LINPFILE = .FALSE.
C
C---- logical units
      LUINP = 4   ! configuration file
      LURUN = 7   ! run case file
      LUMAS = 8   ! mass file
      LUPRM = 9   ! parameter file
      LUOUT = 19  ! output dump file
      LUSTD = 20  ! stability derivative dump file
      LUSYS = 22  ! dynamic system matrix dump file
C
C---- set basic defaults
      CALL DEFINI
      CALL MASINI
C
C---- initialize Xplot, and AVL plot stuff
      CALL PLINIT
C
C
C---- Read a new input geometry from input file
      CALL GETARG0(1,FILDEF)
C
      IF(FILDEF.NE.' ') THEN
       CALL INPUT(LUINP,FILDEF,ERROR)
C
C----- no valid geometry... skip reading run and mass files
       IF(ERROR) GO TO 100
C
C----- we have an input dataset to process
       LINPFILE = .TRUE.
C
C----- set up all parameters
       CALL PARSET
C
C----- process geometry to define strip and vortex data
       LPLTNEW = .TRUE.
       CALL ENCALC
C
C----- initialize state
       CALL VARINI
C
      ELSE
C----- no geometry... skip reading run and mass files
       GO TO 100
C
      ENDIF
C
C-------------------------------------------------------------------
C---- try to read mass file
      CALL GETARG0(3,FMSDEF)
      IF(FMSDEF.EQ.' ') THEN
       KDOT = INDEX(FILDEF,'.')
       IF(KDOT.EQ.0) THEN
        CALL STRIP(FILDEF,LENF)
        FMSDEF = FILDEF(1:LENF) // '.mass'
       ELSE
        FMSDEF = FILDEF(1:KDOT) // 'mass'
       ENDIF
      ENDIF
C
      CALL STRIP(FMSDEF,NMS)
      WRITE(*,*) 
      WRITE(*,*)
     & '---------------------------------------------------------------'
      WRITE(*,*) 'Trying to read file: ', FMSDEF(1:NMS), '  ...'
      CALL MASGET(LUMAS,FMSDEF,ERROR)
C
      IF(ERROR) THEN
       WRITE(*,*) 'Internal mass defaults used'
       CALL MASINI
C
      ELSE
       WRITE(*,*)
       WRITE(*,*) 'Mass distribution read ...'
       CALL MASSHO(6)
C
       CALL APPGET
       WRITE(*,*) 
     & '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
       CALL APPSHO(6,RHO0)
C
      ENDIF
C
C-------------------------------------------------------------------
C---- try to read run case file
      CALL GETARG0(2,FRNDEF)
      IF(FRNDEF.EQ.' ') THEN
       KDOT = INDEX(FILDEF,'.')
       IF(KDOT.EQ.0) THEN
        CALL STRIP(FILDEF,LENF)
        FRNDEF = FILDEF(1:LENF) // '.run'
       ELSE
        FRNDEF = FILDEF(1:KDOT) // 'run'
       ENDIF
      ENDIF
C
      CALL STRIP(FRNDEF,NFR)
      WRITE(*,*)
      WRITE(*,*)
     & '---------------------------------------------------------------'
      WRITE(*,*) 'Trying to read file: ', FRNDEF(1:NFR), '  ...'
      CALL RUNGET(LURUN,FRNDEF,ERROR)
C
      IF(ERROR) THEN
       WRITE(*,*) 'Internal run case defaults used'
       CALL RUNINI
C
      ELSE
       WRITE(*,1025) (IR, RTITLE(IR), IR=1, NRUN)
 1025  FORMAT(//' Run cases read  ...',
     &        100(/1X,I4,': ',A))
C
      ENDIF
C
C-------------------------------------------------------------------
 100  CONTINUE
C
C---- set up plotting parameters for geometry (if any)
      IF(LINPFILE) CALL PLPARS
C
      WRITE(*,2000) 
 2000 FORMAT(
     &  /' =========================================================='
     &  /'   Quit    Exit program'
     & //'  .OPER    Compute operating-point run cases'
     &  /'  .MODE    Eigenvalue analysis of run cases'
     &  /'  .TIME    Time-domain calculations'
     & //'   LOAD f  Read configuration input file'
     &  /'   MASS f  Read mass distribution file'
     &  /'   CASE f  Read run case file'
     & //'   CINI    Clear and initialize run cases'
     &  /'   MSET i  Apply mass file data to stored run case(s)'
     & //'  .PLOP    Plotting options'
     &  /'   NAME s  Specify new configuration name')
C
C======================================================================
C---- start of menu loop
  500 CONTINUE
      CALL ASKC(' AVL^',COMAND,COMARG)
C
C---- extract command line numeric arguments
      DO I=1, 20
        IINPUT(I) = 0
        RINPUT(I) = 0.0
      ENDDO
      NINPUT = 20
      CALL GETINT(COMARG,IINPUT,NINPUT,ERROR)
      NINPUT = 20
      CALL GETFLT(COMARG,RINPUT,NINPUT,ERROR)
C
C===============================================
      IF(COMAND.EQ.'    ') THEN
       GO TO 500
C
C===============================================
      ELSEIF(COMAND.EQ.'?   ') THEN
       WRITE(*,2000)
C
C===============================================
      ELSEIF(COMAND.EQ.'QUIT' .OR.
     &       COMAND.EQ.'Q   '      ) THEN
       CALL PLCLOSE
       STOP
C
C===============================================
      ELSEIF(COMAND.EQ.'OPER') THEN
       CALL OPER
C
C===============================================
      ELSEIF(COMAND.EQ.'MODE') THEN
       CALL MODE
C
C===============================================
      ELSEIF(COMAND.EQ.'TIME') THEN
ccc       CALL TIME
C
C===============================================
      ELSE IF(COMAND.EQ.'LOAD') THEN
C----- Read a new input geometry from input file
       IF(COMARG.NE.' ') THEN
        FILDEF = COMARG
C
       ELSE
        CALL STRIP(FILDEF,LENF)
        LENF1 = MAX(LENF,1)
C
        WRITE(*,2010) FILDEF(1:LENF1)
 2010   FORMAT(' Enter input filename: ', A)
        READ (*,1000)  FNNEW
C
        IF(FNNEW.EQ.' ') THEN
         IF(LENF.EQ.0) GO TO 500
        ELSE
         FILDEF = FNNEW
        ENDIF
C
       ENDIF
C
       LINPFILE = .FALSE.
       CALL INPUT(LUINP,FILDEF,ERROR)
       IF(ERROR) THEN
        WRITE(*,*) 
     &    '** File not processed. Current geometry may be corrupted.'
       GO TO 500
       ENDIF
C----- we have an input dataset to process
       LINPFILE = .TRUE.
       CALL PARSET
C
       IF(NRUN.EQ.0) THEN
        CALL RUNINI
       ELSE
        WRITE(*,*)
        WRITE(*,*) 'Existing run cases will be used.'
        WRITE(*,*) 'Issue CASE or CINI command if necessary.'
       ENDIF
C
C----- process geometry to define strip and vortex data
       LPLTNEW = .TRUE.
       CALL ENCALC
C
C----- initialize state
       CALL VARINI
C
       LAIC = .FALSE.
       LSRD = .FALSE.
       LVEL = .FALSE.
       LSOL = .FALSE.
       LSEN = .FALSE.
C
C----- set up plotting parameters for new geometry 
       CALL PLPARS
C
C===============================================
      ELSE IF(COMAND.EQ.'MASS') THEN
C----- Read a new mass distribution file
       IF(COMARG.NE.' ') THEN
        FMSDEF = COMARG
C
       ELSE
        CALL STRIP(FMSDEF,LENF)
        LENF1 = MAX(LENF,1)
C
        WRITE(*,3010) FMSDEF(1:LENF1)
 3010   FORMAT(' Enter mass filename: ', A)
        READ (*,1000)  FNNEW
C
        IF(FNNEW.EQ.' ') THEN
         IF(LENF.EQ.0) GO TO 500
        ELSE
         FMSDEF = FNNEW
        ENDIF
       ENDIF
C
       CALL STRIP(FMSDEF,NMS)
       CALL MASGET(LUMAS,FMSDEF,ERROR)
       IF(ERROR) THEN
       ELSE
        WRITE(*,*)
        WRITE(*,*) 'Mass distribution read ...'
        CALL MASSHO(6)
C
        CALL APPGET
        WRITE(*,*) 
     & '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
        CALL APPSHO(6,RHO0)
C
        WRITE(*,*)
        WRITE(*,*) 
     &    'Use MSET to apply these mass,inertias to run cases'
ccc        CALL MASPUT(1,NRMAX)
       ENDIF
C
C===============================================
      ELSE IF(COMAND.EQ.'CASE') THEN
C----- Read a new run case file
       IF(COMARG.NE.' ') THEN
        FRNDEF = COMARG
C
       ELSE
        CALL STRIP(FRNDEF,LENF)
        LENF1 = MAX(LENF,1)
C
        WRITE(*,3020) FRNDEF(1:LENF1)
 3020   FORMAT(' Enter run case filename: ', A)
        READ (*,1000)  FNNEW
C
        IF(FNNEW.EQ.' ') THEN
         IF(LENF.EQ.0) GO TO 500
        ELSE
         FRNDEF = FNNEW
        ENDIF
       ENDIF
C
       CALL STRIP(FRNDEF,NFR)
       CALL RUNGET(LURUN,FRNDEF,ERROR)
       IF(ERROR) THEN
       ELSE
        WRITE(*,1025) (IR, RTITLE(IR), IR=1, NRUN)
       ENDIF
C
C----- initialize state
       CALL VARINI
C
       LSOL = .FALSE.
       LSEN = .FALSE.
C
C===============================================
      ELSE IF(COMAND.EQ.'CINI') THEN
       IF(LGEO) THEN
        CALL RUNINI
       ELSE
        WRITE(*,*) 'No configuration available.'
        NRUN = 0
       ENDIF
C
C===============================================
      ELSE IF(COMAND.EQ.'MSET') THEN
C----- set input mass,inertias
       IF(NINPUT.GE.1) THEN
        IR1 = IINPUT(1)
       ELSE
 60     WRITE(*,3060) 
 3060   FORMAT(/
     &     ' Enter index of target run case (0=all, -1=abort):  0')
        IR1 = 0
        CALL READI(1,IR1,ERROR)
        IF(ERROR) GO TO 60
       ENDIF
C
       IF(IR1.EQ.0) THEN
        IR1 = 1
        IR2 = NRUN
       ELSE
        IR2 = IR1
       ENDIF
C
       IF(IR1.LT.1 .OR. IR1.GT.NRUN) GO TO 500
C
       CALL MASPUT(IR1,IR2)
C
       LSOL = .FALSE.
       LSEN = .FALSE.
C
C===============================================
      ELSEIF(COMAND.EQ.'PLOP') THEN
       CALL OPLSET(IDEV,IDEVH,IPSLU,LSVMOV,
     &             SIZE,PLOTAR,
     &             XMARG,YMARG,XPAGE,YPAGE,
     &             CH,SCRNFRAC,LCURS,LCREV)
C
C===============================================
      ELSEIF(COMAND.EQ.'NAME') THEN
       IF(COMARG.EQ.' ') THEN
        CALL ASKS('Enter new name^',TITLE)
       ELSE
        TITLE = COMARG
       ENDIF
C
C===============================================
      ELSE
       WRITE(*,1050) COMAND
 1050  FORMAT(1X,A4,' command not recognized.  Type a "?" for list')
C
      ENDIF
C
      GO TO 500
      END ! AVL


 
      SUBROUTINE PLINIT
C---- Initialize plotting variables
C
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      REAL ORG(3)
C
C---- Plotting flag
      IDEV = 1   ! X11 window only
c     IDEV = 2   ! B&W PostScript output file only (no color)
c     IDEV = 3   ! both X11 and B&W PostScript file
c     IDEV = 4   ! Color PostScript output file only 
c     IDEV = 5   ! both X11 and Color PostScript file 
C
C---- Re-plotting flag (for hardcopy)
c     IDEVH = 2    ! B&W PostScript
      IDEVH = 4    ! Color PostScript
C
C---- Movie-plotting flag
cc    IDEVH = 3    ! B&W PostScript
      IDEVM = 5   ! both X11 and Color PostScript file 
C
      LSVMOV = .FALSE.   ! no movie PS output yet
C
C---- PostScript output logical unit and file specification
ccc   IPSLU = -1  ! output to files plotNNN.ps on LU 80, with NNN = 001, 002, ...
      IPSLU = 0   ! output to file  plot.ps    on LU 80   (default case)
ccc   IPSLU = nnn ! output to file  plotNNN.ps on LU NNN
C
C---- screen fraction taken up by plot window upon opening
      SCRNFRAC = 0.70    ! Landscape
C     SCRNFRAC = -0.85   ! Portrait  specified if < 0
C
C---- Default plot size in inches
C-    (Default plot window is 11.0 x 8.5)
      SIZE = 9.0
C
C---- plot aspect ratio
      PLOTAR = 0.75
C
C---- character width/SIZE
      CH = 0.017
C
      CALL PLINITIALIZE
C
      NCOLORS = 0
C---- set up color spectrum
ccc      NCOLORS = 32
ccc      CALL COLORSPECTRUMHUES(NCOLORS,'RYGCBM')
C
C---- plot-window dimensions in inches for plot blowup calculations
C-    currently,  11.0 x 8.5  default window is hard-wired in libPlt
      XPAGE = 11.0
      YPAGE = 8.5
C
      XWIND = 11.0
      YWIND = 8.5
C
C---- page margins in inches
      XMARG = 0.0
      YMARG = 0.0
C
C---- bottom,left plot margin from edge
      PMARG = 0.15
C
      IF(IDEV.EQ.0) THEN 
        LPLOT = .FALSE.
      ENDIF
C

C---- set colors for run cases
      DO IR = 1, NRMAX
        IRCOLOR(IR) = MOD(IR-1,8) + 3
      ENDDO
C
C---- set vectors for little axes
      SLEN = 0.5
      HLEN = 0.5
C
      RHEAD = HLEN * 0.25
      NHEAD = NHAXIS
C
      ORG(1) = 0.
      ORG(2) = 0.
      ORG(3) = 0.
      DO IAX = 1, 3
        UAXDIR(1,IAX) = 0.
        UAXDIR(2,IAX) = 0.
        UAXDIR(3,IAX) = 0.
        UAXDIR(IAX,IAX) = 1.0
        CALL ARWSET(ORG,UAXDIR(1,IAX),SLEN,HLEN,RHEAD,NHEAD,
     &                  UAXARW(1,1,1,IAX),NLINAX)
      ENDDO
C
C---- initial phase, eigenvector scale, slo-mo scale (for mode plots)
      EPHASE = 0.0
      EIGENF = 1.0
      SLOMOF = 1.0
      TMOFAC = 1.0

      RETURN
      END ! PLINIT



      SUBROUTINE PLPARS
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      IMARKSURF = 0
      DO N = 1, NSURF
        LPLTSURF(N) = .TRUE. 
      END DO
      DO N = 1, NBODY
        LPLTBODY(N) = .TRUE. 
      END DO
C
C---- Scaling factors for velocity and pressure
      CPFAC = MIN(0.4*CREF,0.1*BREF)  / CREF
      ENFAC = MIN(0.3*CREF,0.06*BREF) / CREF
      HNFAC = MIN(CREF,0.5*BREF)      / CREF
C
C---- initialize observer position angles and perspective 1/distance
      AZIMOB = -45.0
      ELEVOB =  20.0
      TILTOB =   0.
      ROBINV = 0.
C
C---- slo-mo factor
      SLOMOF = 1.0
C
C---- eigenmode animation integration time step
      DTIMED = 0.025
C
C---- movie-dump frame time step
      DTMOVIE = 0.05
C
C---- max length of movie
      TMOVIE = 10.0
C
C...Flags 
      LABEL_BODY = .FALSE.
      LABEL_SURF = .FALSE.
      LABEL_STRP = .FALSE.
      LABEL_VRTX = .FALSE.
      LWAKEPLT   = .FALSE.
      LHINGEPLT  = .FALSE.
      LLOADPLT   = .FALSE.
      LCNTLPTS   = .FALSE.
      LNRMLPLT   = .FALSE.
      LAXESPLT   = .TRUE.
      LRREFPLT   = .TRUE.
      LCLPERPLT  = .TRUE.
      LDWASHPLT  = .TRUE.
      LLABSURF   = .FALSE.
      LCAMBER    = .FALSE.
      LCHORDLINE = .TRUE.
      LBOUNDLEG  = .TRUE.
C
C---- Initially assume nothing hidden
      LHID = .TRUE.
C
C---- Initially assume no reverse color output
      LCREV = .FALSE.
C
C---- flags to plot parameter values above eigenmode map
      DO IP = 1, IPTOT
        LPPAR(IP) = .FALSE.
      ENDDO

      LPPAR(IPALFA) = .TRUE.
      LPPAR(IPBETA) = .TRUE.
c      LPPAR(IPROTX) = .TRUE.
c      LPPAR(IPROTY) = .TRUE.
c      LPPAR(IPROTZ) = .TRUE.
      LPPAR(IPCL  ) = .TRUE.
      LPPAR(IPCD0 ) = .TRUE.

      LPPAR(IPPHI ) = .TRUE.
c      LPPAR(IPTHE ) = .TRUE.
c      LPPAR(IPPSI ) = .TRUE.

c      LPPAR(IPMACH) = .TRUE.
      LPPAR(IPVEE ) = .TRUE.
      LPPAR(IPRHO ) = .TRUE.
c      LPPAR(IPGEE ) = .TRUE.

      LPPAR(IPRAD ) = .TRUE.
c      LPPAR(IPFAC ) = .TRUE.

      LPPAR(IPXCG ) = .TRUE.
c      LPPAR(IPYCG ) = .TRUE.
      LPPAR(IPZCG ) = .TRUE.

      LPPAR(IPMASS) = .TRUE.
c      LPPAR(IPIXX ) = .TRUE.
c      LPPAR(IPIYY ) = .TRUE.
c      LPPAR(IPIZZ ) = .TRUE.
c      LPPAR(IPIXY ) = .TRUE.
c      LPPAR(IPIYZ ) = .TRUE.
c      LPPAR(IPIZX ) = .TRUE.

c      LPPAR(IPCLA ) = .TRUE.
c      LPPAR(IPCLU ) = .TRUE.
c      LPPAR(IPCMA ) = .TRUE.
c      LPPAR(IPCMU ) = .TRUE.

      RETURN
      END ! PLPARS



      SUBROUTINE DEFINI
      INCLUDE 'AVL.INC'
C
C---- flag for forces in standard NASA stability axes (as in Etkin)
      LNASA_SA  = .TRUE.
C
C---- flag for rotations defined in stability axes or body axes
      LSA_RATES = .TRUE.
C
      LPTOT   = .TRUE.
      LPSURF  = .FALSE.
      LPSTRP  = .FALSE.
      LPELE   = .FALSE.
      LPHINGE = .FALSE.
      LPDERIV = .FALSE.
C
      LGEO  = .FALSE.
      LENC  = .FALSE.
C
      LAIC  = .FALSE.
      LSRD  = .FALSE.
      LVEL  = .FALSE.
      LSOL  = .FALSE.
      LSEN  = .FALSE.
C
      LVISC    = .TRUE.
      LBFORCE  = .TRUE.
      LTRFORCE = .TRUE.
C
      LMWAIT = .FALSE.
C
      MATSYM = 0
      NITMAX = 20
C
      SAXFR = 0.25  ! x/c location of spanwise axis for Vperp definition
C
      VRCORE = 0.25   ! vortex core radius / vortex span
      SRCORE = 0.75   ! source core radius / body radius
C
C---- dafault basic units
      UNITL = 1.
      UNITM = 1.
      UNITT = 1.
      UNCHL = 'Lunit'
      UNCHM = 'Munit'
      UNCHT = 'Tunit'
      NUL = 5
      NUM = 5
      NUT = 5
C
C---- set corresponding derived units
      CALL UNITSET
C
C---- default air density and grav. accel.
      RHO0 = 1.0
      GEE0 = 1.0
C
C---- no eigenvalue reference data yet
      FEVDEF = ' '
      DO IR = 1, NRMAX
        NEIGENDAT(IR) = 0
      ENDDO
C
C---- no run cases defined yet
      NRUN = 0
      IRUN = 1
C
C---- number of valid time levels stored
      NTLEV = 0
C
C---- default time step, and number of time steps to take
      DELTAT = 0.0
      NTSTEPS = 0
C
      RETURN
      END ! DEFINI



      SUBROUTINE PARSET
      INCLUDE 'AVL.INC'
C
C---- variable names
      VARNAM(IVALFA) = 'alpha '
      VARNAM(IVBETA) = 'beta  '
      VARNAM(IVROTX) = 'pb/2V '
      VARNAM(IVROTY) = 'qc/2V '
      VARNAM(IVROTZ) = 'rb/2V '
C
C---- variable selection keys
      VARKEY(IVALFA) = 'A lpha'
      VARKEY(IVBETA) = 'B eta'
      VARKEY(IVROTX) = 'R oll  rate'
      VARKEY(IVROTY) = 'P itch rate'
      VARKEY(IVROTZ) = 'Y aw   rate'
C
C---- constraint names
CCC                     123456789012
      CONNAM(ICALFA) = 'alpha '
      CONNAM(ICBETA) = 'beta  '
      CONNAM(ICROTX) = 'pb/2V '
      CONNAM(ICROTY) = 'qc/2V '
      CONNAM(ICROTZ) = 'rb/2V '
      CONNAM(ICCL  ) = 'CL    '
      CONNAM(ICCY  ) = 'CY    '
      CONNAM(ICMOMX) = 'Cl roll mom'
      CONNAM(ICMOMY) = 'Cm pitchmom'
      CONNAM(ICMOMZ) = 'Cn yaw  mom'
C
C---- constraint selection keys
      CONKEY(ICALFA) = 'A '
      CONKEY(ICBETA) = 'B '
      CONKEY(ICROTX) = 'R '
      CONKEY(ICROTY) = 'P '
      CONKEY(ICROTZ) = 'Y '
      CONKEY(ICCL  ) = 'C '
      CONKEY(ICCY  ) = 'S '
      CONKEY(ICMOMX) = 'RM'
      CONKEY(ICMOMY) = 'PM'
      CONKEY(ICMOMZ) = 'YM'
C
C------------------------------------------------------------------------
      IZERO = ICHAR('0')
C
C---- add control variables, direct constraints
      DO N = 1, NCONTROL
        ITEN = N/10
        IONE = N - 10*ITEN
C
C------ assign slots in variable ond constraint lists
        IV = IVTOT + N
        IC = ICTOT + N
        VARNAM(IV) = DNAME(N)
        CONNAM(IC) = DNAME(N)
        IF(ITEN.EQ.0) THEN
         VARKEY(IV) = 'D' // CHAR(IZERO+IONE) // ' '
     &             // ' ' // DNAME(N)(1:8)
         CONKEY(IC) = 'D' // CHAR(IZERO+IONE)
        ELSE
         VARKEY(IV) = 'D' // CHAR(IZERO+ITEN) // CHAR(IZERO+IONE)
     &             // ' ' // DNAME(N)(1:8)
         CONKEY(IC) = 'D' // CHAR(IZERO+ITEN) // CHAR(IZERO+IONE)
        ENDIF
C
        LCONDEF(N) = .TRUE.
      ENDDO
C
C---- default design-variable flags, names
      DO N = 1, NDESIGN
        LDESDEF(N) = .TRUE.
      ENDDO
C
C---- total number of variables, constraints
      NVTOT = IVTOT + NCONTROL
      NCTOT = ICTOT + NCONTROL
C
C---- run-case parameter names
      PARNAM(IPALFA) = 'alpha    '
      PARNAM(IPBETA) = 'beta     '
      PARNAM(IPROTX) = 'pb/2V    '
      PARNAM(IPROTY) = 'qc/2V    '
      PARNAM(IPROTZ) = 'rb/2V    '
      PARNAM(IPCL )  = 'CL       '
      PARNAM(IPCD0)  = 'CDo      '
      PARNAM(IPPHI)  = 'bank     '
      PARNAM(IPTHE)  = 'elevation'
      PARNAM(IPPSI)  = 'heading  '
      PARNAM(IPMACH) = 'Mach     '
      PARNAM(IPVEE)  = 'velocity '
      PARNAM(IPRHO)  = 'density  '
      PARNAM(IPGEE)  = 'grav.acc.'
      PARNAM(IPRAD)  = 'turn_rad.'
      PARNAM(IPFAC)  = 'load_fac.'
      PARNAM(IPXCG)  = 'X_cg     '
      PARNAM(IPYCG)  = 'Y_cg     '
      PARNAM(IPZCG)  = 'Z_cg     '
      PARNAM(IPMASS) = 'mass     '
      PARNAM(IPIXX)  = 'Ixx      '
      PARNAM(IPIYY)  = 'Iyy      '
      PARNAM(IPIZZ)  = 'Izz      '
      PARNAM(IPIXY)  = 'Ixy      '
      PARNAM(IPIYZ)  = 'Iyz      '
      PARNAM(IPIZX)  = 'Izx      '
      PARNAM(IPCLA)  = 'visc CL_a'
      PARNAM(IPCLU)  = 'visc CL_u'
      PARNAM(IPCMA)  = 'visc CM_a'
      PARNAM(IPCMU)  = 'visc CM_u'
C
C---- total number of parameters
      NPTOT = IPTOT
C
C---- set default parameter unit names
      CALL PARNSET
C
      RETURN
      END ! PARSET



      SUBROUTINE PARNSET
      INCLUDE 'AVL.INC'
C
C---- set parameter unit name
      DO IP = 1, IPTOT
        PARUNCH(IP) = ' '
      ENDDO
C
      PARUNCH(IPALFA) = 'deg'
      PARUNCH(IPBETA) = 'deg'
      PARUNCH(IPPHI)  = 'deg'
      PARUNCH(IPTHE)  = 'deg'
      PARUNCH(IPPSI)  = 'deg'
      PARUNCH(IPVEE)  = UNCHV
      PARUNCH(IPRHO)  = UNCHD
      PARUNCH(IPGEE)  = UNCHA
      PARUNCH(IPRAD)  = UNCHL

C---- bug  21 Feb 13   MD
c      PARUNCH(IPXCG)  = UNCHL
c      PARUNCH(IPYCG)  = UNCHL
c      PARUNCH(IPZCG)  = UNCHL
      PARUNCH(IPXCG)  = 'Lunit'
      PARUNCH(IPYCG)  = 'Lunit'
      PARUNCH(IPZCG)  = 'Lunit'

      PARUNCH(IPMASS) = UNCHM
      PARUNCH(IPIXX)  = UNCHI
      PARUNCH(IPIYY)  = UNCHI
      PARUNCH(IPIZZ)  = UNCHI
      PARUNCH(IPIXY)  = UNCHI
      PARUNCH(IPIYZ)  = UNCHI
      PARUNCH(IPIZX)  = UNCHI
C
      RETURN
      END ! PARNSET



      SUBROUTINE VARINI
      INCLUDE 'AVL.INC'
C
C---- initialize state
      ALFA = 0.
      BETA = 0.
      WROT(1) = 0.
      WROT(2) = 0.
      WROT(3) = 0.
C
      DO N = 1, NCONTROL
        DELCON(N) = 0.0
      ENDDO
C
      DO N = 1, NDESIGN
        DELDES(N) = 0.0
      ENDDO
      LSOL = .FALSE.
C
      RETURN
      END ! VARINI



      SUBROUTINE RUNINI
      INCLUDE 'AVL.INC'
C
      WRITE(*,*)
      WRITE(*,*) 'Initializing run cases...'
C
C---- go over all run cases
      DO IR = 1, NRMAX
C------ index of default constraint for each variable
        ICON(IVALFA,IR) = ICALFA
        ICON(IVBETA,IR) = ICBETA
        ICON(IVROTX,IR) = ICROTX
        ICON(IVROTY,IR) = ICROTY
        ICON(IVROTZ,IR) = ICROTZ
C
C------ default constraint values
        DO IC = 1, ICTOT
          CONVAL(IC,IR) = 0.
        ENDDO
C
C------ default run case titles
        RTITLE(IR) = ' -unnamed- '
C
C------ default dimensional run case parameters
        DO IP = 1, NPTOT
          PARVAL(IP,IR) = 0.
        ENDDO
        PARVAL(IPGEE,IR) = GEE0
        PARVAL(IPRHO,IR) = RHO0
C
C------ default CG location is the input reference location
        PARVAL(IPXCG,IR) = XYZREF0(1)
        PARVAL(IPYCG,IR) = XYZREF0(2)
        PARVAL(IPZCG,IR) = XYZREF0(3)
C
        PARVAL(IPMASS,IR) = RMASS0
        PARVAL(IPIXX,IR) = RINER0(1,1)
        PARVAL(IPIYY,IR) = RINER0(2,2)
        PARVAL(IPIZZ,IR) = RINER0(3,3)
        PARVAL(IPIXY,IR) = RINER0(1,2)
        PARVAL(IPIYZ,IR) = RINER0(2,3)
        PARVAL(IPIZX,IR) = RINER0(3,1)
C
        PARVAL(IPCD0,IR) = CDREF0
C
        PARVAL(IPCLA,IR) = DCL_A0
        PARVAL(IPCLU,IR) = DCL_U0
        PARVAL(IPCMA,IR) = DCM_A0
        PARVAL(IPCMU,IR) = DCM_U0
C
        ITRIM(IR) = 0
        NEIGEN(IR) = 0
      ENDDO
C
C---- add control variables, direct constraints
      DO N = 1, NDMAX
        IV = IVTOT + N
        IC = ICTOT + N
        DO IR = 1, NRMAX
          ICON(IV,IR) = IC
          CONVAL(IC,IR) = 0.
        ENDDO
      ENDDO
C
C---- default number of run cases
      IRUN = 1
      NRUN = 1
C
C---- all run cases are targets for eigenmode calculation
      IRUNE = 0
C
C---- first run case is default for time march initial state
      IRUNT = 1
C
      RETURN
      END ! RUNINI



      SUBROUTINE RUNGET(LU,FNAME,ERROR)
C-------------------------------------------------
C     Reads run case file into run case arrays
C-------------------------------------------------
      INCLUDE 'AVL.INC'
      CHARACTER*(*) FNAME
      LOGICAL ERROR
C
      CHARACTER*80 LINE, REST
      CHARACTER*12 VARN, CONN
      CHARACTER*8  PARN
C
      OPEN(LU,FILE=FNAME,STATUS='OLD',ERR=90)
      ILINE = 0
C
      IR = 0
C
C==============================================================
C---- start line-reading loop
 10   CONTINUE
C
      READ(LU,1000,END=50) LINE
 1000 FORMAT(A)
      ILINE = ILINE + 1
C
      KCOL = INDEX(LINE,':' )
      KARR = INDEX(LINE,'->')
      KEQU = INDEX(LINE,'=' )
      IF(KCOL.NE.0) THEN
C----- start of new run case
       READ(LINE(KCOL-3:KCOL-1),*,ERR=80) IR
C
       IF(IR.LT.1 .OR. IR.GT.NRMAX) THEN
        WRITE(*,*) 'RUNGET:  Run case array limit NRMAX exceeded:', IR
        IR = 0
        GO TO 10
       ENDIF
C
       NRUN = MAX(NRUN,IR)
C
       RTITLE(IR) = LINE(KCOL+1:80)
       CALL STRIP(RTITLE(IR),NRT)
C
      ELSEIF(IR.EQ.0) THEN
C----- keep ignoring lines if valid run case index is not set
       GO TO 10
C
      ELSEIF(KARR.NE.0 .AND. KEQU.NE.0) THEN
C----- variable/constraint declaration line
       VARN = LINE(1:KARR-1)
       CONN = LINE(KARR+2:KEQU-1)
       CALL STRIP(VARN,NVARN)
       CALL STRIP(CONN,NCONN)
C
       DO IV = 1, NVTOT
         IF(INDEX(VARNAM(IV),VARN(1:NVARN)).NE.0) GO TO 20
       ENDDO
       WRITE(*,*) 'Ignoring unrecognized variable: ', VARN(1:NVARN)
       GO TO 10
C
 20    CONTINUE
       DO IC = 1, NCTOT
         IF(INDEX(CONNAM(IC),CONN(1:NCONN)).NE.0) GO TO 25
       ENDDO
       WRITE(*,*) 'Ignoring unrecognized constraint: ', CONN(1:NCONN)
       GO TO 10
C
 25    CONTINUE
       READ(LINE(KEQU+1:80),*,ERR=80) CONV
C
       ICON(IV,IR) = IC
       CONVAL(IC,IR) = CONV
C
      ELSEIF(KARR.EQ.0 .AND. KEQU.NE.0) THEN
C----- run case parameter data line
       PARN = LINE(1:KEQU-1)
       CALL STRIP(PARN,NPARN)
       DO IP = 1, NPTOT
         IF(INDEX(PARNAM(IP),PARN(1:NPARN)).NE.0) GO TO 30
       ENDDO
       WRITE(*,*) 'Ignoring unrecognized parameter: ', PARN(1:NPARN)
       GO TO 10
C
 30    CONTINUE
       REST = LINE(KEQU+1:80)
       READ(REST,*,ERR=80) PARV
       PARVAL(IP,IR) = PARV


       if(.false.) then
       CALL STRIP(REST,NREST)
       KBLK = INDEX(REST,' ')
       IF(KBLK .NE. 0) THEN
        REST = REST(KBLK+1:80)
        CALL STRIP(REST,NREST)
        IF(NREST.GT.0) THEN
         PARUNCH(IP) = REST
        ENDIF
       ENDIF
       endif

      ENDIF
C
C---- keep reading lines
      GO TO 10
C
C==============================================================
C
 50   CONTINUE
      CLOSE(LU)
      ERROR = .FALSE.
      RETURN
C
 80   CONTINUE
      CALL STRIP(FNAME,NFN)
      CALL STRIP(LINE ,NLI)
      WRITE(*,8000) FNAME(1:NFN), ILINE, LINE(1:NLI)
 8000 FORMAT(/' Run case file  ',A,'  read error on line', I4,':',A)
      CLOSE(LU)
      ERROR = .TRUE.
      NRUN = 0
      RETURN
C
 90   CONTINUE
      CALL STRIP(FNAME,NFN)
      WRITE(*,9000) FNAME(1:NFN)
 9000 FORMAT(/' Run case file  ',A,'  open error')
      ERROR = .TRUE.
      RETURN
      END ! RUNGET



      SUBROUTINE RUNSAV(LU)
      INCLUDE 'AVL.INC'
C
      DO IR = 1, NRUN
        WRITE(LU,1010) IR, RTITLE(IR)
        DO IV = 1, NVTOT
          IC = ICON(IV,IR)
          WRITE(LU,1050) VARNAM(IV), CONNAM(IC), CONVAL(IC,IR)
        ENDDO
C
        WRITE(LU,*)
C
        DO IP = 1, NPTOT
          WRITE(LU,1080) PARNAM(IP), PARVAL(IP,IR), PARUNCH(IP)
        ENDDO
      ENDDO
C
 1010 FORMAT(/' ---------------------------------------------'
     &       /' Run case', I3,':  ', A /)
 1050 FORMAT(1X,A,' ->  ', A, '=', G14.6, 1X, A)
 1080 FORMAT(1X,A,'=', G14.6, 1X, A)
C
      RETURN
      END ! RUNSAV



      LOGICAL FUNCTION LOWRIT(FNAME)
      CHARACTER*(*) FNAME
C
      CHARACTER*1 ANS
 1000 FORMAT(A)
C
      K = INDEX(FNAME,' ')
C
      WRITE(*,*) 'File  ', FNAME(1:K), ' exists.  Overwrite?  Y'
      READ (*,1000) ANS
      LOWRIT = INDEX('Nn',ANS) .EQ. 0
C
      RETURN
      END


      SUBROUTINE AOCFIL(FNAME,IFILE)
      CHARACTER*(*) FNAME
C
      CHARACTER*1 ANS
 1000 FORMAT(A)
C
      K = INDEX(FNAME,' ')
C
      WRITE(*,*) 'File  ', FNAME(1:K), 
     &     ' exists.  Append, Overwrite, or Cancel?  A'
      READ (*,1000) ANS
      IFILE = INDEX('AOC',ANS) + INDEX('aoc',ANS)
C
      IF(IFILE.EQ.0) IFILE = 1
C
      RETURN
      END

C***********************************************************************
C    Module:  atime.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE TIME
C---------------------------------------------
C     Time-domain integration driver
C---------------------------------------------
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      LOGICAL ERROR, LOK, LWRIT, SAVED, OVERLAY
C
      CHARACTER*1 ITEM, ANS, CHKEY
      CHARACTER*2 OPT, CHPLOT
      CHARACTER*4 COMAND, ITEMC
      CHARACTER*256 FNOUT, FNNEW, FNSYS, FNVB
      CHARACTER*80 LINE, COMARG, PROMPT, RTNEW
      CHARACTER SATYPE*50, ROTTYPE*50
C
      REAL*8 ASYS(JETOT,JETOT),BSYS(JETOT,NDMAX),RSYS(JETOT)
C
      PARAMETER (JTMAX=JETOT+NDMAX)
      REAL AMAT(JTMAX,JTMAX),RMAT(JTMAX),WORK(JTMAX)
      REAL DTPAR(JEMAX), DTCON(NDMAX)
      INTEGER IMAT(JTMAX)
C
      REAL RINPUT(20), RINP(20)
      INTEGER IINPUT(20), IINP(20)
C
      IRUN0 = IRUN
C
      FNVB = ' '
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
      IF(LSA_RATES) THEN
        ROTTYPE = 'Rates,moments about Stability axes'
       ELSE
        ROTTYPE = 'Rates,moments about Body axes'
      ENDIF
C
 1000 FORMAT (A)
C
C---- force computation of plot limits
      TMIN = 0.
      TMAX = 0.
      FMIN = 0.
      FMAX = 0.
C
C
      LPLOT = .FALSE.
      LWRIT = .FALSE.
C
      FNOUT = ' '
C
      CHPLOT = '  '
C
c      EYEPTZ = 180.
c      EYEPTY = 90.
c      EYEPTX = 0.
c      ROBINV = 0.
C
      OVERLAY = .FALSE.
C
C=================================================================
C---- start of user interaction loop
 800  CONTINUE
C
      WRITE(*,1050) 
 1050 FORMAT(
     &  /'  Run-case parameters for candidate initial states... ')
C
      LU = 6
      CALL RUNLST(LU,IRUN)
C
C
C
      WRITE(*,1052)
 1052 FORMAT(
     &   ' =========================================================='
     & //' "#" select run case for initial state'
     &  /'  M odify parameters'
     & //' eX ecute time march calculation'
     & //'  V iew time march calculation'
     &  /'  P lot time traces'
     &  /'  W rite time traces to screen or file'
     &  /'  D ata file overlay toggle'
     & //'  Z oom'
     &  /'  U nzoom')
C
C   A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
C         x                 x     x         x x x x   x

 810  CONTINUE
      CALL ASKC(' .TIME^',COMAND,COMARG)
C
 815  CONTINUE
C------------------------------------------------------
      IF    (COMAND.EQ.'    ') THEN
       IF(LPLOT) CALL PLEND
       LPLOT = .FALSE.
       CALL CLRZOOM
       IRUN = IRUN0
       RETURN
C
      ELSEIF(COMAND.EQ.'?   ') THEN
       GO TO 800
C
      ENDIF
C
C-------------------------------------------------------------------
C---- see if command is an integer
      NINPUT = 1
      CALL GETINT(COMAND,IINPUT,NINPUT,ERROR)
      IF(.NOT.ERROR .AND. NINPUT.GE.1 
     &  .AND. COMAND(1:1).NE.'T'
     &  .AND. COMAND(1:1).NE.'F' ) THEN
C----- command is an integer... new case index?
       IF(IINPUT(1).LT.0 .OR. IINPUT(1).GT.NRUN) THEN
        WRITE(*,*)
        WRITE(*,*) '* Selected new run case is not defined'
        GO TO 800
       ELSE
C------ valid new run case selected... go back to menu
        IRUN = IINPUT(1)
        GO TO 800
       ENDIF
      ENDIF
C
C-------------------------------------------------------------------
C---- extract command line numeric arguments
      DO I=1, 20
        IINPUT(I) = 0
        RINPUT(I) = 0.0
      ENDDO
      NINPUT = 20
      CALL GETINT(COMARG,IINPUT,NINPUT,ERROR)
      NINPUT = 20
      CALL GETFLT(COMARG,RINPUT,NINPUT,ERROR)
C
C-----------------------------------------------------------------------
      IF    (COMAND.EQ.'M   ') THEN
       CALL PARMOD(IRUN)
C
C-------------------------------------------------------------------
      ELSEIF(COMAND .EQ. 'X   ') THEN
C------ execute time march calculation
C
 22     RINPUT(1) = DELTAT
        RINPUT(2) = FLOAT(NTSTEPS)
        WRITE(*,2022) DELTAT, NTSTEPS
 2022   FORMAT(
     &   /' Enter delta(t), Nstep  (-Nstep to append steps)', F9.5, I8)
        CALL READR(2,RINPUT,ERROR)
        IF(ERROR) GO TO 22
C
C------ abort?
        IF(RINPUT(1).LE.0.0 .OR. RINPUT(2).EQ.0.0) GO TO 510
C
        DELTAT = RINPUT(1)
        NTSTEPS = INT( RINPUT(2) + SIGN(0.01,RINPUT(2)) )
        NTSTEP  = IABS(NTSTEPS)
C
C------ append to current time trace?
        LTAPP = NTSTEPS .LT. 0
C
C------ set up marching indices and initial state
        IF(LTAPP) THEN
C------- make sure we have a valid time trace up to now
         IF(NTLEV.LT.2) THEN
C--------- bug out
           WRITE(*,*) 'No time march available to append to.'
           GO TO 510
         ENDIF
C
C------- will just add NTSTEP points starting at current time level ITLEV
C-       (any levels after ITLEV will be overwritten)
         ITLEV1 = ITLEV
         ITLEV2 = ITLEV + NTSTEP
C
        ELSE
C------- will start new sequence from current run case IRUN
         ITLEV1 = 1
         ITLEV2 = 1 + NTSTEP
C
         IR = IRUN
C
         CALL RUNCHK(IR,LOK)
         IF(.NOT.LOK) THEN
          WRITE(*,*) '** No initial state.  Ill-posed run case', IR
          GO TO 100
         ENDIF
C
C------- converge initial state
         NITER = 10
         INFO = 0
         CALL EXEC(NITER,INFO,IR)
C
         VEE = PARVAL(IPVEE,IR)
         ROT = VEE/UNITL
C
         RHO = PARVAL(IPRHO,IR)
         QS = 0.5*RHO*VEE**2 * SREF*UNITL**2
C
         WEIGHT = PARVAL(IPMASS,IR)*PARVAL(IPGEE,IR)
C
C------- set initial state
         IT = ITLEV1
         TLEV(IT) = 0.
         TPARS(KPBANK,IT) = PARVAL(IPPHI,IR)*DTR
         TPARS(KPELEV,IT) = PARVAL(IPTHE,IR)*DTR
         TPARS(KPHEAD,IT) = PARVAL(IPPSI,IR)*DTR
         TPARS(KPVINF,IT) = PARVAL(IPVEE ,IR)
         TPARS(KPALFA,IT) = PARVAL(IPALFA,IR)*DTR
         TPARS(KPBETA,IT) = PARVAL(IPBETA,IR)*DTR
         TPARS(KPCLIF,IT) = CLTOT
         TPARS(KPCDRG,IT) = CDTOT
         TPARS(KPCDIN,IT) = CDITOT
         TPARS(KPCMOM,IT) = CMTOT
         TPARS(KPLIFT,IT) = CLTOT*QS
         TPARS(KPDRAG,IT) = CDTOT*QS
         TPARS(KPMACH,IT) = 0.0
         TPARS(KPALTK,IT) = 0.0
         TPARS(KPDENS,IT) = RHO
         TPARS(KPVSOU,IT) = 1.0
         TPARS(KPLOAD,IT) = CLTOT*QS / WEIGHT
C
         TPARV(1,KPVEL,IT) =  VINF(1)*VEE
         TPARV(2,KPVEL,IT) = -VINF(2)*VEE
         TPARV(3,KPVEL,IT) =  VINF(3)*VEE
         TPARV(1,KPROT,IT) = -WROT(1)*ROT
         TPARV(2,KPROT,IT) =  WROT(2)*ROT
         TPARV(3,KPROT,IT) = -WROT(3)*ROT
         TPARV(1,KPPOS,IT) = 0.0
         TPARV(2,KPPOS,IT) = 0.0
         TPARV(3,KPPOS,IT) = 0.0
         TPARV(1,KPFOR,IT) = CXTOT
         TPARV(2,KPFOR,IT) = CYTOT
         TPARV(3,KPFOR,IT) = CZTOT
         TPARV(1,KPMOM,IT) = CRTOT
         TPARV(2,KPMOM,IT) = CMTOT
         TPARV(3,KPMOM,IT) = CNTOT
C 
         DO N = 1, NCONTROL
           TPARD(N,IT) = DELCON(N)
         ENDDO
        ENDIF
C
C
        DO 50 ITLEV = ITLEV1+1, ITLEV2
          IT  = ITLEV
          ITM = ITLEV - 1
          ITL = MAX( 1 , ITLEV - 2 )
C
C-------- initial guess for current time from previous time
          CALL TCOPY(ITLEV-1,ITLEV)
C
          TLEV(ITLEV) = TLEV(ITLEV-1) + DELTAT
C
cC-------- better initial guess by extrapolating in time
c          IF(IPTIME.GT.2) CALL QPRED(IPTIME)
c          PSTEADY(IPTIME) = .FALSE.
C
C-------- set time-differencing weights
          CALL TDSET(ITLEV,TLEV,TDER)
C
          WRITE(*,*)
          WRITE(*,*)
     &       'Converging time level',ITLEV,' ... t = ',TLEV(ITLEV)
C


          INFO = 1
          ETOL = 1.0E-5
          IF(COMAND .EQ. 'X   ') THEN
           CALL SYSMAT(IR,ASYS,BSYS,RSYS,NSYS)
          ELSE
           CALL APPMAT(IR,ASYS,BSYS,RSYS,NSYS)
          ENDIF
C
cc          LU = 6
cc          CALL SYSSHO(LU,ASYS,BSYS,RSYS,NSYS)
C
          NMAT = JETOT + NCONTROL
          DO K = 1, NMAT
            RMAT(K) = 0.
            DO J = 1, NMAT
              AMAT(K,J) = 0.
            ENDDO
          ENDDO
C
C-------- set total residuals and Jacobian
          DO K = 1, JETOT
            RMAT(K) = RSYS(K)
     &              - TDER(1)*TPAR(K,IT )
     &              - TDER(2)*TPAR(K,ITM)
     &              - TDER(3)*TPAR(K,ITL)
            DO J = 1, JETOT
              AMAT(K,J) = ASYS(K,J) - TDER(1)
            ENDDO
            DO L = 1, NCONTROL
              J = JETOT + L
              AMAT(K,J) = BSYS(K,L)
            ENDDO
          ENDDO
C
C-------- set control-variable residuals and Jacobian
          DO N = 1, NCONTROL
            K = JETOT + N
            RMAT(K) = TCON(N,IT) - TCONSP(N,IT)
            AMAT(K,K) = 1.0
          ENDDO
C
          CALL LUDCMP(JTMAX,NMAT,AMAT,IMAT,WORK)
          CALL BAKSUB(JTMAX,NMAT,AMAT,IMAT,RMAT)
C
          DRMS = 0.
          DMAX = 0.
          JMAX = 0
          DO J = 1, JETOT
            DTPAR(J) = -RMAT(J)
C
            IF(ABS(DTPAR(J))/TREF(J) .GT. ABS(DMAX)) THEN
             DMAX = DTPAR(J)
             JMAX = J
            ENDIF
            DRMS = DRMS + (DTPAR(J)/TREF(J))**2
          ENDDO
          DO N = 1, NCONTROL
            J = JETOT + N
            DTCON(N) = -RMAT(J)
C
            IF(ABS(DTCON(N))/TREF(J) .GT. ABS(DMAX)) THEN
             DMAX = DTCON(N)
             JMAX = J
            ENDIF
            DRMS = DRMS + (DTCON(N)/TREF(J))**2
          ENDDO
C
          DRMS = SQRT( DRMS/FLOAT(JETOT+NCONTROL) )
C
C
          RLX = 1.0
          DO J = 1, JETOT
            TPAR(J,IT) = TPAR(J,IT) + RLX*DTPAR(J)
          ENDDO
          DO N = 1, NCONTROL
            TCON(N,IT) = TCON(N,IT) + RLX*DTCON(N)
          ENDDO
C
          VSQ = TPAR(JUE,IT)**2 + TPAR(JVE,IT)**2 + TPAR(JWE,IT)**2
          VEE = SQRT(VSQ)
          ROT = VEE/UNITL
C
          IF(VEE .EQ. 0.0) THEN
           VINV = 1.0
           RINV = 1.0
          ELSE
           VINV = 1.0/VEE
           RINV = 1.0/ROT
          ENDIF
C
          VINF(1) =  TPAR(JEU ,IT)*VINV
          VINF(2) = -TPAR(JEV ,IT)*VINV
          VINF(3) =  TPAR(JEW ,IT)*VINV
          WROT(1) = -TPAR(JEP ,IT)*RINV
          WROT(2) =  TPAR(JEQ ,IT)*RINV
          WROT(3) = -TPAR(JER ,IT)*RINV
C
          V13 = SQRT( VINF(1)**2 + VINF(3)**2 )
C
          ALFA = ATAN2(  VINF(3) , VINF(1) )
          BETA = ATAN2( -VINF(2) , V13     )
C
          PARVAL(IPALFA,IR) = ALFA/DTR
          PARVAL(IPBETA,IR) = BETA/DTR
          PARVAL(IPROTX,IR) = WROT(1)*0.5*BREF
          PARVAL(IPROTY,IR) = WROT(2)*0.5*CREF
          PARVAL(IPROTZ,IR) = WROT(3)*0.5*BREF
          PARVAL(IPCL  ,IR) = CLTOT
C
          PARVAL(IPALFA,IR) = ALFA
          PARVAL(IPBETA,IR) = BETA
          PARVAL(IPROTX,IR) = WROT(1)
          PARVAL(IPROTY,IR) = WROT(2)
          PARVAL(IPROTZ,IR) = WROT(3)
          PARVAL(IPPHI,IR) = TPAR(JEPH,IT)
          PARVAL(IPTHE,IR) = TPAR(JETH,IT)
          PARVAL(IPPSI,IR) = TPAR(JEPS,IT)
C
C-------- sum AIC matrices to get GAM,SRC,DBL
          CALL GAMSUM
C
C-------- sum AIC matrices to get WC,WV
          CALL VELSUM
C
C-------- compute forces
          CALL AERO
C
C
          IF(DRMS .LT. EPS .AND. ABS(DMAX) .LT. 10.0*EPS) THEN
           GO TO 100
          ENDIF


C
 100    CONTINUE
C
        CHPLOT = 'P '
C
C-------------------------------------------------------------------
C---- Blowup window
      ELSEIF(COMAND.EQ.'B   ') THEN
       IF(INDEX('P',CHPLOT(1:1)) .EQ. 0) THEN
        WRITE(*,*) 'No plot to blow up'
        GO TO 810
       ENDIF
C
       DCROSS = 2.0
       WRITE(*,*) 'Mark off corners of blowup area'
       CALL GETCURSORXY(XC1,YC1,CHKEY)
       CALL PLSYMB(XC1,YC1,DCROSS,3,0.0,0)
       CALL PLFLUSH
       CALL GETCURSORXY(XC2,YC2,CHKEY)
       CALL PLSYMB(XC2,YC2,DCROSS,3,0.0,0)
       CALL PLFLUSH
C
       XE1 = TMIN+(XC1-XORG0)/TFAC
       YE1 = FMIN+(YC1-YORG0)/FFAC
       XE2 = TMIN+(XC2-XORG0)/TFAC
       YE2 = FMIN+(YC2-YORG0)/FFAC
C
       TMIN = MIN( XE1 , XE2 )
       TMAX = MAX( XE1 , XE2 )
       FMIN = MIN( YE1 , YE2 )
       FMAX = MAX( YE1 , YE2 )
C
       CALL AXISADJ(TMIN,TMAX, TTOT, TDEL, NANN)
       CALL AXISADJ(FMIN,FMAX, FTOT, FDEL, NANN)
C
       COMAND = 'P   '
       GO TO 815
C
C-------------------------------------------------------------------
C---- Normal size
      ELSEIF(COMAND.EQ.'R   ') THEN
       TMIN = 0.
       TMAX = 0.
       FMIN = 0.
       FMAX = 0.
C
       COMAND = 'P   '
       GO TO 815
C
C-------------------------------------------------------------------
C---- Annotate
      ELSEIF(COMAND.EQ.'A   ') THEN
       IF(LPLOT) THEN
        CALL ANNOT(CH)
       ELSE
        WRITE(*,*) 'No active plot'
       ENDIF
C
C-------------------------------------------------------------------
C---- Hardcopy
      ELSEIF(COMAND.EQ.'H   ') THEN
       IF(LPLOT) CALL PLEND
       LPLOT = .FALSE.
       CALL REPLOT(IDEVH)
C
C-------------------------------------------------------------------
C---- write eigenvalues
      ELSEIF(COMAND.EQ.'W   ') THEN
       IF(FEVDEF(1:1).EQ.' ') THEN
C------ set default filename
        KDOT = INDEX(FILDEF,'.')
        IF(KDOT.EQ.0) THEN
         CALL SLEN(FILDEF,NFIL)
         FEVDEF = FILDEF(1:NFIL) // '.eig'
        ELSE
         FEVDEF = FILDEF(1:KDOT) // 'eig'
        ENDIF
       ENDIF
C
       CALL SLEN(FEVDEF,NFE)
       NFE = MAX( NFE , 1 )
       WRITE(*,2040) FEVDEF(1:NFE)
 2040  FORMAT(' Enter eigenvalue save filename: ', A)
       READ (*,1000) FNNEW
       IF(FNNEW.NE.' ') FEVDEF = FNNEW
       CALL EIGOUT(FEVDEF, IRUN1,IRUN2, SAVED)
C
C-------------------------------------------------------------------
C---- toggle overlay flag
      ELSEIF(COMAND.EQ.'D   ') THEN
       OVERLAY = .NOT.OVERLAY
C
       IF(OVERLAY) THEN
        IF(FEVDEF(1:1).EQ.' ') THEN
C------- set default filename
         KDOT = INDEX(FILDEF,'.')
         IF(KDOT.EQ.0) THEN
          CALL SLEN(FILDEF,NFIL)
          FEVDEF = FILDEF(1:NFIL) // '.eig'
         ELSE
          FEVDEF = FILDEF(1:KDOT) // 'eig'
         ENDIF
        ENDIF
C
        CALL SLEN(FEVDEF,NFE)
        NFE = MAX( NFE , 1 )
        WRITE(*,2050) FEVDEF(1:NFE)
 2050   FORMAT(' Enter eigenvalue data filename: ', A)
        READ (*,1000) FNNEW
        IF(FNNEW.NE.' ') FEVDEF = FNNEW
C
C------ read the data file
        CALL EIGINP(FEVDEF, ERROR)
        IF(ERROR) THEN
         OVERLAY = .FALSE.
         GO TO 800
        ENDIF
C
        OVERLAY = .TRUE.
        WRITE(*,*) 'Overlay plotting enabled'
C
        IF(INDEX('P',CHPLOT(1:1)).NE.0) THEN
         COMAND = CHPLOT
         GO TO 815
        ENDIF
C
       ELSE
        WRITE(*,*) 'Overlay plotting disabled'
C
       ENDIF
C
C-------------------------------------------------------------------
C---- Zoom in on plot
      ELSEIF(COMAND.EQ.'Z   ') THEN
       IF(INDEX('P',CHPLOT(1:1)) .EQ. 0) THEN
        WRITE(*,*) 'No plot to zoom'
        GO TO 810
       ENDIF
C
       CALL USETZOOM(.TRUE.,.TRUE.)
       CALL REPLOT(IDEV)
C
C-------------------------------------------------------------------
C---- Reset zoom on plot
      ELSEIF(COMAND.EQ.'U   ') THEN
       CALL CLRZOOM
       CALL REPLOT(IDEV)
C
C-------------------------------------------------------------------
      ELSE
        WRITE(*,*)
        WRITE(*,*) '* Option not recognized'
C
      ENDIF
      GO TO 800
C
      END ! TIME



      SUBROUTINE TCOPY(IT1,IT2)
      INCLUDE 'AVL.INC'
C
      TLEV(IT2) = TLEV(IT1)
      DO J = 1, JETOT
        TPAR(J,IT2) = TPAR(J,IT1)
      ENDDO
      DO N = 1, NCONTROL
        TCON(N,IT2) = TCON(N,IT1)
      ENDDO
C
      RETURN
      END ! TCOPY



      SUBROUTINE TDSET(ITIME,TIME,QTWT)
      REAL TIME(*), QTWT(3)
C
      REAL QTWT1(3), QTWT2(3)
C
C---- set differencing blending fraction
C
C-      F = 0   1st-order backward difference
C-      F = 1   2nd-order backward difference
C 
      DATA F / 1.0 /
ccc      DATA F / 0.0 /
C
      IF    (ITIME.LT.2) THEN
        QTWT1(1) = 0.
        QTWT1(2) = 0.
        QTWT1(3) = 0.
        QTWT2(1) = 0.
        QTWT2(2) = 0.
        QTWT2(3) = 0.
C
      ELSEIF(ITIME.EQ.2) THEN
        T0 = TIME(ITIME  )
        T1 = TIME(ITIME-1)
C
        QTWT1(1) =  1.0/(T0-T1)
        QTWT1(2) = -1.0/(T0-T1)
        QTWT1(3) = 0.
C
        QTWT2(1) =  1.0/(T0-T1)
        QTWT2(2) = -1.0/(T0-T1)
        QTWT2(3) = 0.
C
      ELSE
        T0 = TIME(ITIME  )
        T1 = TIME(ITIME-1)
        T2 = TIME(ITIME-2)
C
        QTWT1(1) =  1.0/(T0-T1)
        QTWT1(2) = -1.0/(T0-T1)
        QTWT1(3) = 0.
C
        QTWT2(1) =  1.0/(T0-T1) + 1.0/(T0-T2)
        QTWT2(2) = -1.0/(T0-T1) - 1.0/(T0-T2)
     &             -    (T0-T1)/((T0-T2)*(T1-T2))
        QTWT2(3) =      (T0-T1)/((T0-T2)*(T1-T2))
C
      ENDIF
C
C---- blend 1st and 2nd order differences
      QTWT(1) = (1.0-F)*QTWT1(1) + F*QTWT2(1)
      QTWT(2) = (1.0-F)*QTWT1(2) + F*QTWT2(2)
      QTWT(3) = (1.0-F)*QTWT1(3) + F*QTWT2(3)
C
      RETURN
      END ! TDSET

C***********************************************************************
C    Module:  sgutil.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************



      SUBROUTINE AKIMA ( X, Y, N, XX, YY, SLP )
C
C...PURPOSE    General-purpose monovariate interpolation routine
C              using a locally-fitted cubic spline. One point is
C              interpolated from the input data arrays.
C
C...INPUT:     X  An input array of abscissas in ascending or 
C                 descending value order.
C              Y  An input array of corresponding ordinates. The 
C                 function Y(X) must be single-valued.
C              N  Size for the 'X' and 'Y' arrays. 'N' is an integer.
C                 (the input arrays may be any size)
C
C             XX  Input 'X' point at which an interpolated 'Y' value is
C                 desired.
C
C...OUTPUT:   YY  Interpolated 'Y' ordinate.
C            SLP  Interpolated slope (DY/DX).
C
C...DISCUSSION This spline method produces an interpolated curve that
C              is relatively free of the oscillatory behavior normally
C              associated with cubic splines. The curve produced will
C              be continuous in 'Y' and 'DY/DX' but further derivatives
C              may be discontinuous. The interpolated slope should be
C              treated with some caution, however, due to the tendency
C              of this spline curve to concentrate changes of curvature
C              at the input points (interval ends). If only 2 points are
C              input the curve will be linear, if 3 points are given
C              the curve will be parabolic, more than 3 points will
C              produce a cubic. Extrapolation beyond the bounds of the
C              input data is done with a quadratic through the last 3
C              points at that data boundary.
C
C              This routine is intended as a replacement for B.Wainfan's
C              AKIMAD. It is shorter, twice as fast and it works on
C              input data in ascending or descending order. The calling
C              sequence is more natural and is easier to use for the
C              bulk of applications.
C
C              The coding is compatible with IBM or VAX Fortran 77 
C              and IBM Fortran IV G or H with optimization.
C
C...ORIGIN     Harold Youngren  CALAC Dept. 72-71   3/81
C
C...REFERENCE  Akima, Hiroshi, "A New Method of Interpolation and
C              Smooth Curve Fitting Based on Local Procedures",
C              Journal of the Association for Computing Machines,
C              Vol. 17, No. 4, Oct 1970, pages 589-602
C
C              Wainfan, B. S., "The Akima Subroutines:  Nonlinear
C              Interpolation by Local Polynomial Fit", LR 29244,
C              Oct 30, 1979.
C
C
      DIMENSION  X(N), Y(N), D(5), T(2)
C 
C
C...Check for a degenerate case ( X(1)=X(N) ).    
C 
      IF (X(1) .NE. X(N))  GO TO 10
         YY  = Y(1) 
         SLP = 0. 
         GO TO 70
C
C
C...Find which interval contains the point by binary search.
C...The binary search loop is terminated when the search residual
C...(NSTEP) is zero. The index 'I' will point to the input point
C...lower than or equal to the desired point for the 'X' values
C...in ascending order or to the input point greater than or equal
C...to the desired point for descending order 'X' values.       
C
   10 XORDR = 1.0
      IF (X(1) .GT. X(N))  XORDR = -1.0
C
      IBOT = 1
      ITOP = N
      XXO  = XX * XORDR
C
   20 NSTEP = ( ITOP - IBOT ) / 2
      I     = IBOT + NSTEP
      XO    = X(I) * XORDR
      IF ( XXO .GE. XO )  IBOT = I
      IF ( XXO .LT. XO )  ITOP = I
      IF ( NSTEP .NE. 0 )  GO TO 20
C
C
C...Calculate the straight line slopes between adjacent input points.
C...D(3) is the slope on the interval of interpolation. If the other
C...slopes D(1), D(2), D(4) OR D(5) are not defined they will be
C...created by quadratic extrapolation (only at start and end of data).
C
      DO 30  J = 1, 5
         K  = I + (J-2)
         IF ( ((K-1) .GE. 1) .AND. (K .LE. N) )
     *      D(J) = ( Y(K) - Y(K-1) ) / ( X(K) - X(K-1) )
   30 CONTINUE
C
C...Synthesize upper and lower slopes if required. Check for
C...single line segment input (N=2).
C
      IF (N .EQ. 2)  D(2) = D(3)
C
      IF ((I+2) .GT. N)  D(4) = 2. * D(3) - D(2)
      IF ((I+3) .GT. N)  D(5) = 2. * D(4) - D(3)
      IF ((I-1) .LT. 1)  D(2) = 2. * D(3) - D(4)
      IF ((I-2) .LT. 1)  D(1) = 2. * D(2) - D(3)
C
C
C...Calculate the slopes (T(1),T(2)) at the lower and upper
C...points bounding the interval of interpolation. If the point is
C...at an intersection of straight line segments the slope is
C...defined by the average of the adjacent segment slopes.
C
      DO 50 J = 1, 2
         A = ABS( D(J+3)  -  D(J+2) )
         B = ABS( D(J+1)  -  D(J)   )
         IF ((A + B) .NE. 0.)  GO TO 40
            A = 1.
            B = 1.
   40    T(J) = ( A*D(J+1) + B*D(J+2) ) / ( A + B )
   50 CONTINUE
C
C
C...Check if desired point is on upper point of interval. This
C...reduces error at the transition points between intervals.
C
      IF (XX .NE. X(I+1))  GO TO 60
         YY  = Y(I+1)
         SLP = T(2)
         GO TO 70
C
C...Calculate the cubic coefficients.
C
   60 XINT  =  X(I+1) - X(I)
      XDIF  =  XX     - X(I)
      P0    =  Y(I)
      P1    =  T(1)
      P2    =  ( 3.*D(3) - 2.*T(1) - T(2) ) / XINT
      P3    =  ( T(1)  + T(2)  -  2.*D(3) ) / (XINT*XINT)
C
C...Calculate the Y-value and the slope.
C
      YY  =  P0 + XDIF*( P1 + XDIF*( P2 + XDIF*P3 ) )
      SLP =  P1 + XDIF*( 2.*P2 + XDIF*( 3.*P3 ) )
C
   70 RETURN
      END ! AKIMA



      FUNCTION TRP1 (N,X,Y,XTRP)
C
C...PURPOSE  TO LINEARLY INTERPOLATE A VALUE FROM AN 
C            ARRAY OF DATA
C
C...INPUT    N         NUMBER OF POINTS IN ARRAY 
C            X,Y       ARRAYS OF ABSCISSAE AND ORDINATES
C            XTRP      COORDINATE AT WHICH YTRP IS DESIRED 
C
C...OUTPUT   TRP1      INTERPOLATED VALUE
C
C...COMMENTS   
C
      DIMENSION  X(N), Y(N)
C
      IF (N.LT.1)  THEN
        TRP1 = 0.
        RETURN
      ENDIF
      IF (N.LT.2)  THEN
        TRP1 = Y(1)
        RETURN
      ENDIF
C
C...FIND THE INTERVAL CONTAINING THE POINT
      I = 1
   10 IF (X(I+1).GT.XTRP .OR. I+1.EQ.N)  GO TO 20 
        I = I + 1
        GO TO 10
C
   20 TRP1 = Y(I) + (Y(I+1)-Y(I))*(XTRP-X(I))/(X(I+1)-X(I))
      RETURN
      END ! TRP1


      SUBROUTINE NRMLIZ (N,X)
C
C...PURPOSE  TO NORMALIZE AN ARRAY OF DATA
C
C...INPUT    N         NUMBER OF POINTS IN ARRAY 
C            X         ARRAY OF DATA IN ASCENDING OR DESCENDING ORDER
C
C...OUTPUT   X         NORMALIZED ARRAY (0<=X<=1.)
C
C...COMMENTS   
C
      DIMENSION  X(N)
C
      IF (N.LE.1)  RETURN
C
      DX = X(N) - X(1)
      IF (DX .EQ. 0.0) DX = 1.0
C
      X1 = X(1)
      DO 10 I = 1, N
        X(I) = (X(I)-X1) / DX
   10 CONTINUE
      RETURN
      END ! NRMLIZ


      SUBROUTINE SPACER (N,PSPACE,X)
C...PURPOSE     TO CALCULATE A NORMALIZED (0<=X<=1) SPACING ARRAY.
C
C...INPUT       N      =  NUMBER OF DESIRED POINTS IN ARRAY.
C               PSPACE =  SPACING PARAMETER (-3<=PSPACE<=3).
C                         DEFINES POINT DISTRIBUTION
C                         TO BE USED AS FOLLOWS:
C                 PSPACE = 0  : EQUAL SPACING
C                 PSPACE = 1  : COSINE SPACING.
C                 PSPACE = 2  : SINE SPACING
C                               (CONCENTRATING POINTS NEAR 0).
C                 PSPACE = 3  : EQUAL SPACING.
C
C                 NEGATIVE VALUES OF PSPACE PRODUCE SPACING
C                 WHICH IS REVERSED (AFFECTS ONLY SINE SPACING).
C                 INTERMEDIATE VALUES OF PSPACE WILL PRODUCE
C                 A SPACING WHICH IS A LINEAR COMBINATION
C                 OF THE CORRESPONDING INTEGER VALUES.
C     
C...OUTPUT      X      =  NORMALIZED SPACING ARRAY (0 <= X <= 1)
C                         THE FIRST ELEMENT WILL ALWAYS BE  X(1) = 0.
C                         THE LAST ELEMENT WILL ALWAYS BE   X(N) = 1.
C
      DIMENSION  X(N)
      DATA  PI / 3.1415926535 /
C
      PABS = ABS (PSPACE)
      NABS = IFIX (PABS) + 1
C
      GO TO (10,20,30,30), NABS
C
   10                 PEQU   = 1.-PABS
                      PCOS   = PABS
                      PSIN   = 0.
           GO TO 50
C
   20                 PEQU   = 0.
                      PCOS   = 2.-PABS
                      PSIN   = PABS-1.
           GO TO 50
C
   30                 PEQU   = PABS-2.
                      PCOS   = 0.
                      PSIN   = 3.-PABS
C
   50 DO 100  K = 1, N
         FRAC = FLOAT(K-1)/FLOAT(N-1)
         THETA =  FRAC * PI
         IF (PSPACE .GE. 0. )   X(K) =
     &                 PEQU * FRAC
     &       +         PCOS * ( 1. - COS ( THETA )      ) / 2.
     &       +         PSIN * ( 1. - COS ( THETA / 2. ) )
         IF (PSPACE .LE. 0. )   X(K) =
     &                 PEQU * FRAC
     &       +         PCOS * ( 1. - COS ( THETA )      ) / 2.
     &       +         PSIN * SIN ( THETA / 2. )
  100 CONTINUE
C
      RETURN
      END ! SPACER



      SUBROUTINE CSPACER(NVC,CSPACE,CLAF, XPT,XVR,XSR,XCP)
      REAL XPT(*), XVR(*), XSR(*), XCP(*)
C
      PI = 4.0*ATAN(1.0)
C
C---- set blending weights
      ACSP = ABS(CSPACE)
      NCSP = IFIX(ACSP)
      IF    (NCSP.EQ.0) THEN
       F0 = 1.0 - ACSP
       F1 = ACSP
       F2 = 0.
      ELSEIF(NCSP.EQ.1) THEN
       F0 = 0.
       F1 = 2.0 - ACSP
       F2 = ACSP - 1.0
      ELSE
       F0 = ACSP - 2.0
       F1 = 0.
       F2 = 3.0 - ACSP
      ENDIF
C
C---- cosine chordwise spacing
      DTH1 =     PI/FLOAT(4*NVC + 2)
      DTH2 = 0.5*PI/FLOAT(4*NVC + 1)
      DXC0 =    1.0/FLOAT(4*NVC)
C
      DO IVC = 1, NVC
C------ uniform
        XC0 = INT(4*IVC - 4) * DXC0
        XPT0 = XC0        
        XVR0 = XC0 +     DXC0
        XSR0 = XC0 + 2.0*DXC0
        XCP0 = XC0 +     DXC0 + 2.0*DXC0*CLAF
C
C------ cosine
        TH1 = INT(4*IVC - 3) * DTH1
        XPT1 = 0.5*(1.0 - COS(TH1         ))
        XVR1 = 0.5*(1.0 - COS(TH1+    DTH1))
        XSR1 = 0.5*(1.0 - COS(TH1+2.0*DTH1))
        XCP1 = 0.5*(1.0 - COS(TH1+    DTH1+2.0*DTH1*CLAF))
C
        IF(CSPACE .GT. 0.0) THEN
C------- sine
         TH2 = INT(4*IVC - 3) * DTH2
         XPT2 = 1.0 - COS(TH2         )
         XVR2 = 1.0 - COS(TH2+    DTH2)
         XSR2 = 1.0 - COS(TH2+2.0*DTH2)
         XCP2 = 1.0 - COS(TH2+    DTH2+2.0*DTH2*CLAF)
        ELSE
C------- -sine
         TH2 = INT(4*IVC - 4) * DTH2
         XPT2 = SIN(TH2         )
         XVR2 = SIN(TH2+    DTH2)
         XSR2 = SIN(TH2+2.0*DTH2)
         XCP2 = SIN(TH2+    DTH2+2.0*DTH2*CLAF)
        ENDIF
C
C------ blend 'em
        XPT(IVC) = F0*XPT0 + F1*XPT1 + F2*XPT2
        XVR(IVC) = F0*XVR0 + F1*XVR1 + F2*XVR2
        XSR(IVC) = F0*XSR0 + F1*XSR1 + F2*XSR2
        XCP(IVC) = F0*XCP0 + F1*XCP1 + F2*XCP2
C
      ENDDO
      XPT(1) = 0.0
      XPT(NVC+1) = 1.0
C
      RETURN
      END ! CSPACER

      SUBROUTINE LUDCMP(NSIZ,N,A,INDX,WORK)
C     *******************************************************
C     *   Factors a full NxN matrix into an LU form.        *
C     *   Uses LINPACK routines for linear algebra          *
C     *******************************************************
C
      REAL A(NSIZ,NSIZ), WORK(NSIZ)
      INTEGER INDX(NSIZ)
C
      CALL SGETRF(N,NSIZ,A,NSIZ,INDX,INFO)
C
      RETURN
      END ! LUDCMP


      SUBROUTINE BAKSUB(NSIZ,N,A,INDX,B)
      DIMENSION A(NSIZ,NSIZ), B(NSIZ), INDX(NSIZ)
C     *******************************************************
C     *   BAKSUB does back-substitution with RHS using      *
C     *   stored LU decomposition.                          *
C     *   Uses LINPACK routines for linear algebra          *
C     *******************************************************
C
      MRHS = 1
      CALL SGETRS('N',N,MRHS,A,NSIZ,INDX,B,NSIZ,INFO)
C
      RETURN
      END ! BAKSUB

C***********************************************************************
C    Module:  aplotmd.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE PLOTMD(AZIM, ELEV, TILT, RINV, KEIG, IR)
C
C----Plotting module for AVL vortex lattice program
C
C    Plots geometry and loading results for vortex lattice
C     Geometry plots:
C       Surfaces     (straight tapered panels of chordwise strips of vortices)
C       Strips       (chordwise strips of vortices)
C       Vortex legs  (bound vortex legs)
C       Control pts  (vortex element control points)
C       Camber slope (camber of each strip - used for establishing BC's)
C       Hinge lines  (surface deflection axis and deflected surface outline)
C       Strip loading (chordwise plot of vortex loading on each strip)
C
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      LOGICAL LMOVE, LEVIEW, LCPAN
      LOGICAL LINITVIEW, LFIRST
      SAVE    LINITVIEW, LCPAN
      LOGICAL ERROR
      CHARACTER*4 OPT
      CHARACTER*1 CHKEY
C
      REAL*8 TCPU0, TCPU1, TCPU
C
      REAL ANG0(3), POS0(3)
      REAL ANGE(3), POSE(3), VELE(3), ROTE(3)
      REAL ANG(3), POS(3), ANGP(3),DANG(3)
      REAL TT(3,3), TT_ANG(3,3,3),
     &     RT(3,3), RT_ANG(3,3,3)
C
      REAL EVR(JEMAX)
C
      REAL RINP(10)
C
C---- viewpoint changes (deg), zoom/unzoom, perspective scale factors
      DATA DAZIM, DELEV, ZUFAC, DPAN , PRAT 
     &     / 5.0 , 5.0 , 1.25 , 0.075, 1.1 /
C
C---- phase step and scale factor step for interactive phase plots
      DATA DPHASE, SCALEF / 5.0 , 1.25 /
C
      CALL GETWINSIZE(XWIND,YWIND)
      CCH = 0.75*CH
      XPLT0 = XABS2USR(PMARG)
      YPLT0 = YABS2USR(YWIND-YMARG-PMARG) - 1.2*CCH
C
      YSP = 2.0
C
C---- Initialization for plot program variables
      IF(LPLTNEW .OR. (.NOT.LPLOT)) THEN 
        LPLTNEW = .FALSE.
        LINITVIEW = .FALSE.
      ENDIF
C
      LFIRST = .TRUE.
C
C---- default is plot at zero baseline Euler angles
      LEVIEW = .TRUE.
C
C---- default is camera pans with aircraft
      LCPAN = .TRUE.
C
C---- no movie mode
      LMOVE = .FALSE.
C
C---- find geometry limits
      CALL GLIMS(GMIN,GMAX,.FALSE.)
C
C---- set stuff for this mode
      VEE = PARVAL(IPVEE,IR)
      REFL = BREF*UNITL
      REFV = VEE
C
      EVMIN = (REFV/REFL) * 1.0E-5
      CALL EVNORM(EVEC(1,KEIG,IR),ESF,REFL,REFV)
C
      SIGMA = REAL(EVAL(KEIG,IR))
      OMEGA = IMAG(EVAL(KEIG,IR))
      EVMAG = SQRT(SIGMA**2 + OMEGA**2)
C
      FRQ = OMEGA / (2.0*PI)
      IF(SIGMA .EQ. 0.0) THEN
       DAMPR = 0.
      ELSE
       DAMPR = -SIGMA / EVMAG
      ENDIF
C
C---- initial position
      POS0(1) = 0.
      POS0(2) = 0.
      POS0(3) = 0.
C
      ANG0(1) = PARVAL(IPPHI,IR)*DTR
      ANG0(2) = PARVAL(IPTHE,IR)*DTR
      ANG0(3) = PARVAL(IPPSI,IR)*DTR
C
      XYZREF(1) = PARVAL(IPXCG,IR)
      XYZREF(2) = PARVAL(IPYCG,IR)
      XYZREF(3) = PARVAL(IPZCG,IR)
C
C---- sat baseline velocities and rotation rates
      ALFA = PARVAL(IPALFA,IR)*DTR
      BETA = PARVAL(IPBETA,IR)*DTR
      CALL VINFAB
      WROT(1) = PARVAL(IPROTX,IR)*2.0/BREF
      WROT(2) = PARVAL(IPROTY,IR)*2.0/CREF
      WROT(3) = PARVAL(IPROTZ,IR)*2.0/BREF
C
C
C---- time step sign
      TSIGN = 1.0
C
C---- initial time
      TIMED = 0.
C
      POS(1) = POS0(1)
      POS(2) = POS0(2)
      POS(3) = POS0(3)
      ANG(1) = ANG0(1)
      ANG(2) = ANG0(2)
      ANG(3) = ANG0(3)
C
C---- set time step based on max Euler angle change
      WRMAX = MAX( ABS(WROT(1)) , ABS(WROT(2)) , ABS(WROT(3)) )
C
C***************************************************
    1 CONTINUE
      WRITE(*,2041) LCPAN, LMWAIT
 2041 FORMAT(/'  ------------------------------'
     &       /'   L eft           R ight       '
     &       /'   U p             D own        '
     &       /'   C lear                       '
     &      //'   Z oom           N ormal size '
     &       /'   I ngress        O utgress    '
     &       /'   H ardcopy       A nnotate    '
     &      //'   P anning camera toggle: ', L1
     &       /'   W ait-for-clock toggle: ', L1
     &      //'  < > 0  mode play              '
     &       /'  - + 1  mode scale             '
     &       /'  S      mode sign change       '
     &       /'  { }    slower-mo / faster-mo  '
     &      //' Type in plot window:  Command,  or  <space> to exit')
C
C   A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
c   x   x x       x x     x   x x x   x x   x   x     x
C
C***************************************************
C---- Setup view transformation 
    4 CALL VIEWINIT(AZIM, ELEV, TILT, RINV)
C
C---- scale and project x,y,z orientation arrows UAXARW(....)
C-    also project x,y,z unit vectors UAXDIR(..)
      ARWLEN = 0.2*BREF
C
      RHEADP = RHEAD*ARWLEN
      DO IXYZ = 1, 3
        DO K = 1, 3
          DO IL = 1, NLINAX
            UAXARWP(K,1,IL,IXYZ) = UAXARW(K,1,IL,IXYZ)*ARWLEN
            UAXARWP(K,2,IL,IXYZ) = UAXARW(K,2,IL,IXYZ)*ARWLEN
          ENDDO
        ENDDO
      ENDDO
      NLIN = 3 * 2*NLINAX
      NAXD = 3   
      CALL VIEWPROJ(UAXARWP,NLIN,UAXARWP)
      CALL VIEWPROJ(UAXDIR ,NAXD,UAXDIRP)
C
      DO IAXD = 1, NAXD
        DIRMAG = SQRT( UAXDIRP(1,IAXD)**2
     &               + UAXDIRP(2,IAXD)**2
     &               + UAXDIRP(3,IAXD)**2 )
        IF(DIRMAG .GT. 0.0) THEN
         UAXDIRP(1,IAXD) = UAXDIRP(1,IAXD)/DIRMAG
         UAXDIRP(2,IAXD) = UAXDIRP(2,IAXD)/DIRMAG
         UAXDIRP(3,IAXD) = UAXDIRP(3,IAXD)/DIRMAG
        ENDIF
      ENDDO
C
C***************************************************
C---- compute perturbed position at current or new time
    6 CONTINUE
C
      IF(LMOVE) THEN
C----- advance or retreat in time
       TIMED = TIMED + TSIGN*DTIMED*TMOFAC
C
       IF(LCPAN) THEN
C------ leave aircraft position unchanged (since camera is following it)

       ELSE
C------ integrate velocities and angular rates to next movie frame time
C
C------ time interval in AVL units
        DTIME = DTIMED*VEE/UNITL * TMOFAC
C
C------ set number of time steps for suitable accuracy (limit max angle change)
        DAMAX = WRMAX*DTIME
        NTIME = MAX( 1 , INT(DAMAX/0.02) )
C
C------ integrate over time interval  t = TIME..TIME+DTIME
        DO ITIME = 1, NTIME
          DT = TSIGN * DTIME/FLOAT(NTIME)
C
C-------- predictor step, slopes evaluated at  t
          CALL RATEKI3(ANG,RT,RT_ANG)
          DO K = 1, 3
            DANG(K) = DT*( RT(K,1)*WROT(1)
     &                   + RT(K,2)*WROT(2)
     &                   + RT(K,3)*WROT(3) )
            ANGP(K) = ANG(K) + DANG(K)
          ENDDO
C
C-------- corrector step, slopes evaluated at  t + dt
          CALL RATEKI3(ANGP,RT,RT_ANG)
          DO K = 1, 3
            DANGP = DT*( RT(K,1)*WROT(1)
     &                 + RT(K,2)*WROT(2)
     &                 + RT(K,3)*WROT(3) )
C---------- midpoint angles at  t + dt/2
            ANGP(K) = ANG(K) + 0.25*(DANG(K) + DANGP)
          ENDDO
C
C-------- use midpoint-angle matrices
          CALL RATEKI3(ANGP,RT,RT_ANG)
          CALL ROTENS3(ANGP,TT,TT_ANG)
C
C-------- final integration step, using midpoint slopes
          DO K = 1, 3
            POS(K) = POS(K) - DT*( TT(K,1)*VINF(1)
     &                           + TT(K,2)*VINF(2)
     &                           + TT(K,3)*VINF(3) )
            ANG(K) = ANG(K) + DT*( RT(K,1)*WROT(1)
     &                           + RT(K,2)*WROT(2)
     &                           + RT(K,3)*WROT(3) )
          ENDDO
        ENDDO
       ENDIF
      ENDIF
C
      EPHASE = OMEGA*TIMED / DTR
      EFAC = ESF*EIGENF
      CALL EVREAL(EVEC(1,KEIG,IR),EVAL(KEIG,IR), EFAC,TIMED, EVR)
C
C
C---- scale from standard (SI or English) to AVL units
C
      EVR(JEX) = EVR(JEX)/UNITL
      EVR(JEY) = EVR(JEY)/UNITL
      EVR(JEZ) = EVR(JEZ)/UNITL
C
      EVR(JEU) = EVR(JEU)/VEE
      EVR(JEV) = EVR(JEV)/VEE
      EVR(JEW) = EVR(JEW)/VEE
C
      EVR(JEP) = EVR(JEP)*UNITL/VEE
      EVR(JEQ) = EVR(JEQ)*UNITL/VEE
      EVR(JER) = EVR(JER)*UNITL/VEE
C
CCC   EVR(JEPH) = EVR(JEPH)
CCC   EVR(JETH) = EVR(JETH)
CCC   EVR(JEPS) = EVR(JEPS)
C
c      write(*,*)
c      write(*,*) 'xyz', evr(jex),evr(jey),evr(jez)
c      write(*,*) 'uvw', evr(jeu),evr(jev),evr(jew)
c      write(*,*) 'pqr', evr(jep),evr(jeq),evr(jer)
c      write(*,*) 'reh', evr(jeph),evr(jeth),evr(jeps)
C
C
C---- set final position, including eigenvector perturbation
      POSE(1) = POS(1) + EVR(JEX)
      POSE(2) = POS(2) + EVR(JEY)
      POSE(3) = POS(3) + EVR(JEZ)
C
C---- set final angles, including eigenvector perturbation
      ANGE(1) = ANG(1) + EVR(JEPH)
      ANGE(2) = ANG(2) + EVR(JETH)
      ANGE(3) = ANG(3) + EVR(JEPS)
C
      VELE(1) = VINF(1) - EVR(JEU)
      VELE(2) = VINF(2) - EVR(JEV)
      VELE(3) = VINF(3) - EVR(JEW)
C
      ROTE(1) = WROT(1) + EVR(JEP)
      ROTE(2) = WROT(2) + EVR(JEQ)
      ROTE(3) = WROT(3) + EVR(JER)
C
      VMAGE = SQRT(VELE(1)**2 + VELE(2)**2 + VELE(3)**2)
      V13   = SQRT(VELE(1)**2              + VELE(3)**2)
      ALFAE = ATAN2(  VELE(3) , VELE(1) )
      BETAE = ATAN2( -VELE(2) , V13     )
C
c      CALL RATEKI3(ANG,RT,RT_ANG)
c      DO K = 1, 3
c        DANG(K) =    RT(K,1)*WROT(1)
c     &             + RT(K,2)*WROT(2)
c     &             + RT(K,3)*WROT(3)
c      ENDDO
c      write(1,1234) ( pos(k)/12.0, k=1, 3),
c     &              ( ang(k)/dtr , k=1, 3),
c     &              ( dang(k)*bref/dtr    , k=1, 3)
c      write(2,1234) (pose(k)/12.0, k=1, 3), (ange(k)/dtr, k=1, 3)
c 1234 format(1x,9f10.3)
C
C
C---- set limits for baseline position
      CALL ROTENS3(ANG,TT,TT_ANG)
      CALL GRLIMS(VMINP,VMAXP,.TRUE. ,TT ,XYZREF,POS )
      IF(LFIRST) THEN
C----- first frame... set plot limits directly
       XMIN = VMINP(1)
       YMIN = VMINP(2)
       XMAX = VMAXP(1)
       YMAX = VMAXP(2)
      ELSE
C----- clip to new limits
       XMIN = MIN(XMIN,VMINP(1))
       YMIN = MIN(YMIN,VMINP(2))
       XMAX = MAX(XMAX,VMAXP(1))
       YMAX = MAX(YMAX,VMAXP(2))
      ENDIF
      LFIRST = .FALSE.
C
C
C---- also enforce limits for perturbed position
      CALL ROTENS3(ANGE,TT,TT_ANG)
      CALL GRLIMS(VMINP,VMAXP,.TRUE. ,TT ,XYZREF,POSE)
      XMIN = MIN(XMIN,VMINP(1))
      YMIN = MIN(YMIN,VMINP(2))
      XMAX = MAX(XMAX,VMAXP(1))
      YMAX = MAX(YMAX,VMAXP(2))
C
      CALL OFFINI
C
C***************************************************
C---- plot the baseline and displaced geometry
    8 CONTINUE
      CALL PVLINI(TITLE,AZIM,ELEV,TILT,VERSION,LSVMOV)
C
      XPLT = XPLT0
      YPLT = YPLT0
      CALL PLCHAR(XPLT,YPLT,CCH,'Run  ',0.0,5)
      CALL PLNUMB(999.,YPLT,CCH,FLOAT(IR),0.0,-1)
C
      YPLT = YPLT - YSP*CCH
      CALL PLCHAR(XPLT,YPLT,CCH,'Mode ',0.0,5)
      CALL PLNUMB(999.,YPLT,CCH,FLOAT(KEIG),0.0,-1)
C
      YPLT = YPLT - YSP*CCH
      CALL PLCHAR(XPLT,YPLT,CCH,'f = ',0.0,4)
      CALL PLNUMB(999.,YPLT,CCH,FRQ,0.0,4)
      CALL PLCHAR(999.,YPLT,CCH,' cycles/' ,0.0,8)
      CALL PLCHAR(999.,YPLT,CCH,UNCHT(1:NUT),0.0,NUT)
C
      YPLT = YPLT - YSP*CCH
      CALL PLMATH(XPLT,YPLT,CCH,'z = ',0.0,4)
      CALL PLNUMB(999.,YPLT,CCH,DAMPR,0.0,6)
C
      YPLT = YPLT - YSP*CCH
      CALL PLCHAR(XPLT,YPLT,CCH,'t = ',0.0,4)
      CALL PLNUMB(999.,YPLT,CCH,TIMED ,0.0,2)
      CALL PLCHAR(999.,YPLT,CCH,UNCHT(1:NUT),0.0,NUT)
C
      YPLT = YPLT - YSP*CCH
      CALL PLMATH(XPLT,YPLT,CCH,'w = ',0.0, 4)
      CALL PLCHAR(XPLT,YPLT,CCH,' t  ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,EPHASE,0.0,-1)
      CALL PLMATH(999.,YPLT,CCH,   '"',0.0, 1)
C
      YPLT = YPLT - 1.0*CCH
C
      YPLT = YPLT - YSP*CCH
      CALL PLCHAR(XPLT,YPLT,CCH,'x = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,POSE(1)*UNITL,0.0,-1)
      CALL PLCHAR(999.,YPLT,CCH,UNCHL,0.0,NUL)
C
      YPLT = YPLT - YSP*CCH
      CALL PLCHAR(XPLT,YPLT,CCH,'y = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,POSE(2)*UNITL,0.0,-1)
      CALL PLCHAR(999.,YPLT,CCH,UNCHL,0.0,NUL)
C
      YPLT = YPLT - YSP*CCH
      CALL PLCHAR(XPLT,YPLT,CCH,'z = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,POSE(3)*UNITL,0.0,-1)
      CALL PLCHAR(999.,YPLT,CCH,UNCHL,0.0,NUL)
C
      YPLT = YPLT - 1.0*CCH
C
      YPLT = YPLT - YSP*CCH
      CALL PLMATH(XPLT,YPLT,CCH,'f = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,ANGE(1)/DTR,0.0,1)
      CALL PLMATH(999.,YPLT,CCH,'"',0.0,1)
C
      YPLT = YPLT - YSP*CCH
      CALL PLMATH(XPLT,YPLT,CCH,'q = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,ANGE(2)/DTR,0.0,1)
      CALL PLMATH(999.,YPLT,CCH,'"',0.0,1)
C
      YPLT = YPLT - YSP*CCH
      CALL PLMATH(XPLT,YPLT,CCH,'y = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,ANGE(3)/DTR,0.0,1)
      CALL PLMATH(999.,YPLT,CCH,'"',0.0,1)
C
      YPLT = YPLT - 1.0*CCH
C
      YPLT = YPLT - YSP*CCH
      CALL PLCHAR(XPLT,YPLT,CCH,'V = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,VMAGE*VEE  ,0.0,-1)
      CALL PLCHAR(999.,YPLT,CCH,UNCHV,0.0,NUV)
C
      YPLT = YPLT - YSP*CCH
      CALL PLMATH(XPLT,YPLT,CCH,'a = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,ALFAE/DTR,0.0,2)
      CALL PLMATH(999.,YPLT,CCH,'"',0.0,1)
C
      YPLT = YPLT - YSP*CCH
      CALL PLMATH(XPLT,YPLT,CCH,'b = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,BETAE/DTR,0.0,2)
      CALL PLMATH(999.,YPLT,CCH,'"',0.0,1)
C
C
C---- Setup hidden line data
      CALL HIDINITE(.TRUE., ANGE,POSE,XYZREF)
C
C---- plot baseline position
      CALL GETCOLOR(ICOL0)
      CALL PLOTMODE(ANG ,POS ,XYZREF,0)

C---- plot mode-displaced position
      CALL NEWCOLORNAME('RED')
      CALL PLOTMODE(ANGE,POSE,XYZREF,1)

      CALL NEWCOLOR(ICOL0)
      CALL PLFLUSH
C
      IF(LMOVE .AND. LMWAIT) THEN
C----- waste time if in movie mode and waiting is enabled
       CALL SECONDS(TCPU1)
 9     CONTINUE
       CALL SECONDS(TCPU)
       DTCPU = TCPU - TCPU0
ccc       write(*,*) tcpu0, tcpu, dtcpu, dtimed
       IF(DTCPU .LT. DTIMED) GO TO 9
C
c       dtcpu1 = tcpu1 - tcpu0
c       WRITE(*,*) 'plot time frac:', DTCPU1/DTIMED
      ENDIF
C
ccc      CALL DRAWTOSCREEN
C---------------------------------------------
C---- set user command key
 10   CONTINUE
C
      CHKEY = ' '
      CALL GETCURSORXY(XX,YY,CHKEY)
C
      LMOVE = .FALSE.
      IF(CHKEY .EQ. ' ') THEN
        RETURN
C
C---- change observer's azimuth and elevation angles
      ELSEIF(INDEX('Ll',CHKEY).NE.0) THEN
        AZIM = AZIM + DAZIM
        IF(AZIM .GT.  180.01) AZIM = AZIM - 360.0
        GO TO 4
C
      ELSEIF(INDEX('Rr',CHKEY).NE.0) THEN
        AZIM = AZIM - DAZIM
        IF(AZIM .LT. -180.01) AZIM = AZIM + 360.0
        GO TO 4
C
      ELSEIF(INDEX('Uu',CHKEY).NE.0) THEN
        ELEV = ELEV + DELEV
        IF(ELEV .GT.  180.01) ELEV = ELEV - 360.0
        GO TO 4
C
      ELSEIF(INDEX('Dd',CHKEY).NE.0) THEN
        ELEV = ELEV - DELEV
        IF(ELEV .LT. -180.01) ELEV = ELEV + 360.0
        GO TO 4
C
      ELSEIF(INDEX('Cc',CHKEY).NE.0) THEN
        ELEV = 0.
        AZIM = 0.
        LFIRST = .TRUE.
        GO TO 4
C
      ELSEIF(INDEX('Zz',CHKEY).NE.0) THEN
C------ put center at current cursor location, increase magnification
        XOFF = XX/SF + XOFF
        YOFF = YY/SF + YOFF
        SF = SF*ZUFAC
        XDIF =    1.0/SF
        YDIF = PLOTAR/SF
        XOFF = XOFF - 0.5*XDIF
        YOFF = YOFF - 0.5*YDIF
        GO TO 8
C
      ELSEIF(INDEX('Nn',CHKEY).NE.0) THEN
C------ force resetting of scale,offset factors
        LFIRST = .TRUE.
        GO TO 6
C
      ELSEIF(INDEX('Ii',CHKEY).NE.0) THEN
C------ increase perspective distortion
        IF(RINV.EQ.0.0) THEN
         RINV = 0.02/BREF
        ELSE
         RINV = RINV*PRAT
        ENDIF
        WRITE(*,8010) 1.0/RINV
        GO TO 4
C
      ELSEIF(INDEX('Oo',CHKEY).NE.0) THEN
C------ decrease perspective distortion
        IF(RINV .LT. 0.02/BREF) THEN
         RINV = 0.0
         WRITE(*,*) '  Observer distance = infinity  (no perspective)'
        ELSE
         RINV = RINV/PRAT
         WRITE(*,8010) 1.0/RINV
        ENDIF
        GO TO 4
C
      ELSEIF(INDEX('Aa',CHKEY).NE.0) THEN
C------ annotate plot
        CALL NEWPEN(2)
        CALL ANNOT(CH)
        GO TO 1
C
      ELSEIF(INDEX('Hh',CHKEY).NE.0) THEN
C------ write PostScript version of current screen
        CALL REPLOT(IDEVH)
        GO TO 1
C
c      ELSEIF(INDEX('Ee',CHKEY).NE.0) THEN
cC------ toggle viewing at true/zero Euler angles
c        LEVIEW = .NOT.LEVIEW
c        IF(LEVIEW) THEN
c         WRITE(*,*) 'View at actual Euler angles'
c        ELSE
c         WRITE(*,*) 'View at zero Euler angles'
c        ENDIF
c        GO TO 6
C
      ELSEIF(INDEX('Pp',CHKEY).NE.0) THEN
C------ toggle camera panning
        LCPAN = .NOT.LCPAN
        IF(LCPAN) THEN
         WRITE(*,*) 'Camera will pan with aircraft'
        ELSE
         WRITE(*,*) 'Camera will not pan with aircraft'
        ENDIF
        EPHASE = 0.
        TIMED = 0.
        POS(1) = POS0(1)
        POS(2) = POS0(2)
        POS(3) = POS0(3)
        ANG(1) = ANG0(1)
        ANG(2) = ANG0(2)
        ANG(3) = ANG0(3)
        EIGENF = 1.
        LFIRST = .TRUE.
        GO TO 6
C
      ELSEIF(INDEX('Ww',CHKEY).NE.0) THEN
C------ toggle clock waiting
        LMWAIT = .NOT.LMWAIT
        IF(LMWAIT) THEN
         WRITE(*,*) 'Frame plotting will wait for clock'
        ELSE
         WRITE(*,*) 'Frame plotting will not wait for clock'
        ENDIF
        GO TO 6
C
      ELSEIF(INDEX('0' ,CHKEY).NE.0) THEN
C------ set zero phase
ccc        EPHASE = 0.0
        TIMED = 0.
        POS(1) = POS0(1)
        POS(2) = POS0(2)
        POS(3) = POS0(3)
        ANG(1) = ANG0(1)
        ANG(2) = ANG0(2)
        ANG(3) = ANG0(3)
        GO TO 6
C
      ELSEIF(INDEX('1' ,CHKEY).NE.0) THEN
C------ set unity scale factor
        EIGENF = 1.0
        GO TO 6
C
      ELSEIF(INDEX('<,',CHKEY).NE.0) THEN
C------ decrease phase by DPHASE amount
ccc        EPHASE = EPHASE - DPHASE
        LMOVE = .TRUE.
        TSIGN = -1.0
        CALL SECONDS(TCPU0)
        GO TO 6
C
      ELSEIF(INDEX('>.',CHKEY).NE.0) THEN
C------ increase phase by DPHASE amount
ccc        EPHASE = EPHASE + DPHASE
        LMOVE = .TRUE.
        TSIGN = +1.0
        CALL SECONDS(TCPU0)
        GO TO 6
C
      ELSEIF(INDEX('-_',CHKEY).NE.0) THEN
C------ decrease response vector coefficient
        EIGENF = EIGENF / SCALEF
        GO TO 6
C
      ELSEIF(INDEX('+=',CHKEY).NE.0) THEN
C------ increase response vector coefficient
        EIGENF = EIGENF * SCALEF
        GO TO 6
C
      ELSEIF(INDEX('{[',CHKEY).NE.0) THEN
C------ slow down time advance
        TMOFAC = TMOFAC / SCALEF
        IF(ABS(TMOFAC-1.0) .LT. 0.01) THEN
         TMOFAC = 1.0
         WRITE(*,8020) TMOFAC, ' (real time)'
        ELSE
         WRITE(*,8020) TMOFAC
        ENDIF
        GO TO 6
C
      ELSEIF(INDEX('}]',CHKEY).NE.0) THEN
C------ speed up time advance
        TMOFAC = TMOFAC * SCALEF
        IF(ABS(TMOFAC-1.0) .LT. 0.01) THEN
         TMOFAC = 1.0
         WRITE(*,8020) TMOFAC, ' (real time)'
        ELSE
         WRITE(*,8020) TMOFAC
        ENDIF
        GO TO 6
C
      ELSEIF(INDEX('Ss',CHKEY).NE.0) THEN
C------ change mode sign
        EIGENF = -EIGENF
        GO TO 6
C
      ELSE
        WRITE(*,*) '* Key command not recognized'
        GO TO 1
C
      ENDIF
 8010 FORMAT('  Observer distance =', F11.3,1X,A)
 8020 FORMAT('  Time advance factor =', F11.3,1X,A)
C
      END ! PLOTMD




      SUBROUTINE EVREAL(EVEC,EVAL,EFAC,TIMED,EVR)
      COMPLEX EVEC(*), EVAL
      REAL EVR(*)
      INCLUDE 'AINDEX.INC'
C
      COMPLEX EVFAC
C
C
C---- set complex mode scale factor
      EVFAC = CEXP( EVAL*TIMED ) * EFAC
C
C---- real part of phsyically-scaled scaled eigenmode
      NJ = JETOT
      DO J = 1, NJ
        EVR(J) = REAL( EVFAC * EVEC(J) )
      ENDDO
C
      END ! EVREAL



      SUBROUTINE EVNORM(EV,ESF,REFL,REFV)
      COMPLEX EV(*)
C
      INCLUDE 'AINDEX.INC'
C
      DATA EFRAC / 0.5 /
C
      REFW = REFV/REFL
      REFA = 0.5
C
      RMAX = 0.
C
C---- test x,y,z changes
      RMAX = MAX( RMAX , CABS( EV(JEX)/REFL ) )
      RMAX = MAX( RMAX , CABS( EV(JEY)/REFL ) )
      RMAX = MAX( RMAX , CABS( EV(JEZ)/REFL ) )
C
C---- test u,v,w changes
      RMAX = MAX( RMAX , CABS( EV(JEU)/REFV ) )
      RMAX = MAX( RMAX , CABS( EV(JEV)/REFV ) )
      RMAX = MAX( RMAX , CABS( EV(JEW)/REFV ) )
C
C---- test p,q,r changes
      RMAX = MAX( RMAX , CABS( EV(JEP)/REFW ) )
      RMAX = MAX( RMAX , CABS( EV(JEQ)/REFW ) )
      RMAX = MAX( RMAX , CABS( EV(JER)/REFW ) )
C
C---- test Euler angle changes
      RMAX = MAX( RMAX , CABS( EV(JEPH)/REFA ) )
      RMAX = MAX( RMAX , CABS( EV(JETH)/REFA ) )
      RMAX = MAX( RMAX , CABS( EV(JEPS)/REFA ) )
C
      IF(RMAX .EQ. 0.0) THEN
        ESF = 1.0
      ELSE
        ESF = EFRAC/RMAX
      ENDIF
C
      RETURN
      END ! EVNORM



      SUBROUTINE PLOTMODE(ANG,POS,XYZR,IPAT)
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      REAL ANG(3), POS(3), XYZR(3)
C
      REAL TT(3,3), TT_ANG(3,3,3)
C
      REAL PTS_LINES(3,2,NVMAX), ID_LINES(NVMAX),
     &     PTS_LPROJ(3,2,NVMAX)
C
      DATA ID_LINES / NVMAX * 0.0 /

      INCLUDE 'MASKS.INC'
C
      IF(IPAT.EQ.0) THEN
       LMOUT = LMASK2
       LMCHD = LMASk3
       IPOUT = 2
       IPCHD = 1
      ELSE
       LMOUT = LMASK0
       LMCHD = LMASK1
       IPOUT = 4
       IPCHD = 1
      ENDIF
C
C---- number of line segments for drawing a body section "hoop"
      KK = 18
C
      CALL ROTENS3(ANG,TT,TT_ANG)
C
C---- go over surfaces
      DO 100 N = 1, NSURF
C
C------ do only surfaces which are to be plotted
        IF(.NOT.LPLTSURF(N)) GO TO 100
C
        J1 = JFRST(N)
        JN = JFRST(N) + NJ(N)-1
        JINC = 1
        IF(IMAGS(N).LT.0) THEN
         J1 = JFRST(N) + NJ(N)-1
         JN = JFRST(N)
         JINC = -1
        ENDIF
C
C------ Chordlines plotted
        IF(LCHORDLINE) THEN
         IP = 0
         DO J = J1, JN, JINC
           IP = IP+1
           PTS_LINES(1,1,IP) = RLE1(1,J)
           PTS_LINES(2,1,IP) = RLE1(2,J)
           PTS_LINES(3,1,IP) = RLE1(3,J)
           PTS_LINES(1,2,IP) = RLE1(1,J) + CHORD1(J)
           PTS_LINES(2,2,IP) = RLE1(2,J)
           PTS_LINES(3,2,IP) = RLE1(3,J)
           ID_LINES(IP) = J
           CALL TETRAN(PTS_LINES(1,1,IP),TT,XYZR,POS)
           CALL TETRAN(PTS_LINES(1,2,IP),TT,XYZR,POS)
         END DO
         IP = IP+1
         PTS_LINES(1,1,IP) = RLE2(1,JN)
         PTS_LINES(2,1,IP) = RLE2(2,JN)
         PTS_LINES(3,1,IP) = RLE2(3,JN)
         PTS_LINES(1,2,IP) = RLE2(1,JN) + CHORD2(JN)
         PTS_LINES(2,2,IP) = RLE2(2,JN)
         PTS_LINES(3,2,IP) = RLE2(3,JN)
         ID_LINES(IP) = JN
         CALL TETRAN(PTS_LINES(1,1,IP),TT,XYZR,POS)
         CALL TETRAN(PTS_LINES(1,2,IP),TT,XYZR,POS)
C
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C
         CALL NEWPAT(LMCHD)
         CALL NEWPEN(IPCHD)
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
c         DO IP = 1, NLINES
c           CALL PLOT(PTS_LINES(1,1,IP),PTS_LINES(2,1,IP),3)
c           CALL PLOT(PTS_LINES(1,2,IP),PTS_LINES(2,2,IP),2)
c         ENDDO
        ENDIF
C
C
C--- Surface boundary lines plotted
        IP = 0
        IP = IP+1
        PTS_LINES(1,1,IP) = RLE1(1,J1)
        PTS_LINES(2,1,IP) = RLE1(2,J1)
        PTS_LINES(3,1,IP) = RLE1(3,J1)
        PTS_LINES(1,2,IP) = RLE1(1,J1) + CHORD1(J1)
        PTS_LINES(2,2,IP) = RLE1(2,J1)
        PTS_LINES(3,2,IP) = RLE1(3,J1)
        ID_LINES(IP) = J1
        CALL TETRAN(PTS_LINES(1,1,IP),TT,XYZR,POS)
        CALL TETRAN(PTS_LINES(1,2,IP),TT,XYZR,POS)
C
        IP = IP+1
        PTS_LINES(1,1,IP) = RLE2(1,JN)
        PTS_LINES(2,1,IP) = RLE2(2,JN)
        PTS_LINES(3,1,IP) = RLE2(3,JN)
        PTS_LINES(1,2,IP) = RLE2(1,JN) + CHORD2(JN)
        PTS_LINES(2,2,IP) = RLE2(2,JN)
        PTS_LINES(3,2,IP) = RLE2(3,JN)
        ID_LINES(IP) = JN
        CALL TETRAN(PTS_LINES(1,1,IP),TT,XYZR,POS)
        CALL TETRAN(PTS_LINES(1,2,IP),TT,XYZR,POS)
C
        DO J = J1, JN, JINC
          IP = IP+1
          PTS_LINES(1,1,IP) = RLE1(1,J)
          PTS_LINES(2,1,IP) = RLE1(2,J)
          PTS_LINES(3,1,IP) = RLE1(3,J)
          PTS_LINES(1,2,IP) = RLE2(1,J)
          PTS_LINES(2,2,IP) = RLE2(2,J)
          PTS_LINES(3,2,IP) = RLE2(3,J)
          ID_LINES(IP) = J
          CALL TETRAN(PTS_LINES(1,1,IP),TT,XYZR,POS)
          CALL TETRAN(PTS_LINES(1,2,IP),TT,XYZR,POS)
C
          IP = IP+1
          PTS_LINES(1,1,IP) = RLE1(1,J) + CHORD1(J)
          PTS_LINES(2,1,IP) = RLE1(2,J)
          PTS_LINES(3,1,IP) = RLE1(3,J)
          PTS_LINES(1,2,IP) = RLE2(1,J) + CHORD2(J)
          PTS_LINES(2,2,IP) = RLE2(2,J)
          PTS_LINES(3,2,IP) = RLE2(3,J)
          ID_LINES(IP) = J
          CALL TETRAN(PTS_LINES(1,1,IP),TT,XYZR,POS)
          CALL TETRAN(PTS_LINES(1,2,IP),TT,XYZR,POS)
        END DO
C
        NLINES = IP
        NPROJ = 2*NLINES
        CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C
        CALL NEWPAT(LMOUT)
        CALL NEWPEN(IPOUT)
        CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
c        DO IP = 1, NLINES
c          CALL PLOT(PTS_LINES(1,1,IP),PTS_LINES(2,1,IP),3)
c          CALL PLOT(PTS_LINES(1,2,IP),PTS_LINES(2,2,IP),2)
c        ENDDO
C
 100  CONTINUE
C
C
C---- go over bodies
      DO 300 N = 1, NBODY
C
C------ do only bodies which are to be plotted
        IF(.NOT.LPLTBODY(N)) GO TO 300
C
        L1 = LFRST(N)
        LN = LFRST(N) + NL(N)-1
        LINC = 1
C
C------ source lines plotted
        IP = 0
        DO L = L1, LN-LINC, LINC
          IP = IP+1
          PTS_LINES(1,1,IP) = RL(1,L)
          PTS_LINES(2,1,IP) = RL(2,L)
          PTS_LINES(3,1,IP) = RL(3,L)
          PTS_LINES(1,2,IP) = RL(1,L+LINC)
          PTS_LINES(2,2,IP) = RL(2,L+LINC)
          PTS_LINES(3,2,IP) = RL(3,L+LINC)
          CALL TETRAN(PTS_LINES(1,1,IP),TT,XYZR,POS)
          CALL TETRAN(PTS_LINES(1,2,IP),TT,XYZR,POS)
        END DO
C
        NLINES = IP
        NPROJ = 2*NLINES
        CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C
        CALL NEWPAT(LMCHD)
        CALL NEWPEN(IPCHD)
        CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
c        DO IP = 1, NLINES
c          CALL PLOT(PTS_LINES(1,1,IP),PTS_LINES(2,1,IP),3)
c          CALL PLOT(PTS_LINES(1,2,IP),PTS_LINES(2,2,IP),2)
c        ENDDO
C
C
C------ Body hoops plotted
ccc        IF(LCHORDLINE) THEN
         IP = 0
         DO L = L1, LN, LINC
C--------- set "horizontal" and "vertical" body section unit vectors
           IF(LINC.GT.0) THEN
            LM = MAX(L-1,L1)
            LP = MIN(L+1,LN)
           ELSE
            LM = MAX(L-1,LN)
            LP = MIN(L+1,L1)
           ENDIF
           DXL = RL(1,LP) - RL(1,LM)
           DYL = RL(2,LP) - RL(2,LM)
           DZL = RL(3,LP) - RL(3,LM)
           DSL = SQRT(DXL**2 + DYL**2 + DZL**2)
           IF(DSL.NE.0.0) THEN
            DXL = DXL/DSL
            DYL = DYL/DSL
            DZL = DZL/DSL
           ENDIF
C     
           UHX = -DYL
           UHY =  DXL
           UHZ = 0.
C
           UVX = DYL*UHZ - DZL*UHY
           UVY = DZL*UHX - DXL*UHZ
           UVZ = DXL*UHY - DYL*UHX
C
           DO K = 1, KK
             THK1 = 2.0*PI*FLOAT(K-1)/FLOAT(KK)
             THK2 = 2.0*PI*FLOAT(K  )/FLOAT(KK)
C
             HX1 = UHX*COS(THK1)
             HY1 = UHY*COS(THK1)
             HZ1 = UHZ*COS(THK1)
C
             VX1 = UVX*SIN(THK1)
             VY1 = UVY*SIN(THK1)
             VZ1 = UVZ*SIN(THK1)
C
             HX2 = UHX*COS(THK2)
             HY2 = UHY*COS(THK2)
             HZ2 = UHZ*COS(THK2)
C
             VX2 = UVX*SIN(THK2)
             VY2 = UVY*SIN(THK2)
             VZ2 = UVZ*SIN(THK2)
C
             IP = IP+1
             PTS_LINES(1,1,IP) = RL(1,L) + HX1*RADL(L) + VX1*RADL(L)
             PTS_LINES(2,1,IP) = RL(2,L) + HY1*RADL(L) + VY1*RADL(L)
             PTS_LINES(3,1,IP) = RL(3,L) + HZ1*RADL(L) + VZ1*RADL(L)
             PTS_LINES(1,2,IP) = RL(1,L) + HX2*RADL(L) + VX2*RADL(L)
             PTS_LINES(2,2,IP) = RL(2,L) + HY2*RADL(L) + VY2*RADL(L)
             PTS_LINES(3,2,IP) = RL(3,L) + HZ2*RADL(L) + VZ2*RADL(L)
             CALL TETRAN(PTS_LINES(1,1,IP),TT,XYZR,POS)
             CALL TETRAN(PTS_LINES(1,2,IP),TT,XYZR,POS)
           ENDDO
         END DO
C
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C
         CALL NEWPAT(LMOUT)
         CALL NEWPEN(IPOUT)
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
c         DO IP = 1, NLINES
c           CALL PLOT(PTS_LINES(1,1,IP),PTS_LINES(2,1,IP),3)
c           CALL PLOT(PTS_LINES(1,2,IP),PTS_LINES(2,2,IP),2)
c         ENDDO
ccc        ENDIF
C
 300  CONTINUE
C
      CALL NEWPAT(LMASK0)
      RETURN
      END ! PLOTMODE





      SUBROUTINE PLEMAP(XORG0,YORG0, 
     &                  IRUN1,IRUN2,
     &                  KEVIEW,IRVIEW,
     &                  LPROOT,LPRNUM,OVERLAY,
     &                  TMIN,TMAX,TDEL,TFAC,
     &                  FMIN,FMAX,FDEL,FFAC )
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      LOGICAL LPROOT(JEMAX,*), LPRNUM(JEMAX,*), OVERLAY
C
      LOGICAL LCONVT(NRMAX), LLINE, LBASE
      LOGICAL LPGRID
C
      REAL PARV(IPMAX,NRMAX)
C
      CS  = 0.55*CH
      CSL = 0.70*CH
      CSN = 0.75*CH
      CSP = 0.55*CH

      DXLAB = 2.0*CSP
      DYLAB = 2.3*CSP
C
C---- data root overlay symbol size and type
      CSS = 0.55*CS
      ISYMB = 3
C
      LPGRID = .TRUE.
C
C---- initialize plot window and move origin away from lower left corner
      CALL PLTINI(IDEV)
C
      CALL PLOT(1.0,0.75,-3)
      CALL NEWFACTOR(SIZE)
C
      CALL GETCOLOR(ICOL0)
C
C---- aspect ratio, lower-left plot location
      XORG = XORG0
      YORG = YORG0
C
C---- draw plot
      PARXY = PLOTAR - DYLAB*(1.3 + FLOAT(IRUN2-IRUN1+1))
      CALL PLROOT(XORG,YORG, 
     &            IRUN1, IRUN2, IRCOLOR, 
     &            JEMAX,NEIGEN,EVAL,LPROOT,LPRNUM,
     &            UNCHT(1:NUT), PARXY,CS, LPGRID, 
     &            TMIN,TMAX,TDEL,TFAC,FMIN,FMAX,FDEL,FFAC)
C
cC---- plot "o" over shift location
c      CALL NEWPEN(1)
c      XC1 = XORG + (REAL(ZSHIFT)-TMIN)*TFAC
c      YC1 = YORG + (IMAG(ZSHIFT)-FMIN)*FFAC
c      CALL PLSYMB(XC1,YC1,CS,1,0.0,0)
C
      IF(IRVIEW.GE.1 .AND. IRVIEW.LE.NRUN) THEN
       IR = IRVIEW
       IF(KEVIEW.GT.0 .AND. KEVIEW.LE.NEIGEN(IR)) THEN
C------ plot "+" over currently-examined root, if any
        CALL NEWPEN(1)
        XC1 = XORG + (REAL(EVAL(KEVIEW,IR))-TMIN)*TFAC
        YC1 = YORG + (IMAG(EVAL(KEVIEW,IR))-FMIN)*FFAC
        CALL PLSYMB(XC1,YC1,2.0*CS,3,0.0,0)
       ENDIF
      ENDIF
C
      IF(OVERLAY) THEN
C----- data exists... overlay it
       CALL GETCOLOR(ICOL0)
C
       CALL NEWPEN(2)
       XORG = XORG0
       YORG = YORG0
C
       DO IR = 1, NRMAX
         DO KEIG = 1, NEIGENDAT(IR)
           XEV = REAL(EVALDAT(KEIG,IR))
           YEV = IMAG(EVALDAT(KEIG,IR))
           IF(YEV .GE. -1.0E-4) THEN
            CALL NEWCOLOR(IRCOLOR(IR))
            XPLT = XORG + (XEV-TMIN)*TFAC
            YPLT = YORG + (YEV-FMIN)*FFAC
            CALL PLSYMB(XPLT,YPLT,CSS,ISYMB,0.0,0)
           ENDIF
         ENDDO
       ENDDO
       CALL NEWPEN(1)
       CALL NEWCOLOR(ICOL0)
      ENDIF
C
      CALL PLFLUSH
C
C---- put up parameter list
      DO IR = IRUN1, IRUN2
        DO IP = 1, IPMAX
          PARV(IP,IR) = PARVAL(IP,IR)
          IF(ABS(PARV(IP,IR)) .LT. 1.0E-8) PARV(IP,IR) = 0.
        ENDDO
      ENDDO
C
      XPLT = XORG
      YPLT = YORG + (FMAX-FMIN)*FFAC
C
      CALL PLTPAR(XPLT,YPLT, IRUN1, IRUN2,
     &            PARV, LPPAR,
     &            IRCOLOR, CSP, DXLAB, DYLAB )
C
      YPLT = YPLT + 3.0*CSP
      CALL STRIP(TITLE,NTI)
      CALL NEWPEN(3)
      CALL PLCHAR(XORG,YPLT,CSN,TITLE,0.0,NTI)
C
      CALL PLFLUSH
      RETURN
      END ! PLEMAP



      SUBROUTINE TETRAN(R,TT,RREF,DR)
      REAL R(3), TT(3,3), RREF(3), DR(3)
C
      REAL RB(3)
C
      RB(1) = R(1) - RREF(1)
      RB(2) = R(2) - RREF(2)
      RB(3) = R(3) - RREF(3)
C
      DO K = 1, 3
        R(K) = TT(K,1)*RB(1)
     &       + TT(K,2)*RB(2)
     &       + TT(K,3)*RB(3) + RREF(K) + DR(K)
      ENDDO
C
      RETURN
      END ! TETRAN

C***********************************************************************
C    Module:  plsubs.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE PLROOT(XORG,YORG, 
     &                  IRUN1, IRUN2, IRCOLOR,
     &                  JEMAX,NEIGEN, EVAL, LPROOT, LPRNUM,
     &                  UNCHT, PAR,CS, LPGRID,
     &                  XMIN,XMAX,XDEL,XFAC,YMIN,YMAX,YDEL,YFAC)
      INTEGER IRCOLOR(*)
      INTEGER NEIGEN(*)
      COMPLEX EVAL(JEMAX,*)
      CHARACTER*(*) UNCHT
      LOGICAL LPROOT(JEMAX,*), LPRNUM(JEMAX,*), LPGRID
C-----------------------------------------------------------------
C     Makes root-locus plot
C     If XMIN=XMAX, then XMIN,XMAX,XDEL are set here.
C     If YMIN=YMAX, then YMIN,YMAX,YDEL are set here.
C-----------------------------------------------------------------
      DATA TPI / 6.2831853071795864769 /
      INCLUDE 'MASKS.INC'
C
C---- label character size
      CSL = 1.5*CS
      CSU = 1.2*CS
      CSA = 1.0*CS
      CSS = 0.5*CS
      CSN = 0.8*CS
C
      NRUN = IRUN2 - IRUN1 + 1

C---- root symbol index
      ISYMB = 1
C
      CALL GETCOLOR(ICOL0)
C
      IF(XMIN.EQ.XMAX) THEN
       XMIN =  1.0E23
       XMAX = -1.0E23
       DO IR = IRUN1, IRUN2
         DO KEIG = 1, NEIGEN(IR)
           IF(LPROOT(KEIG,IR)) THEN
            XMIN = MIN(XMIN,REAL(EVAL(KEIG,IR)))
            XMAX = MAX(XMAX,REAL(EVAL(KEIG,IR)))
           ENDIF
         ENDDO
       ENDDO
       CALL AXISADJ(XMIN,XMAX, XTOT, XDEL, NANN)
      ENDIF
C
      IF(YMIN.EQ.YMAX) THEN
       YMIN =  1.0E23
       YMAX = -1.0E23
       DO IR = IRUN1, IRUN2
         DO KEIG = 1, NEIGEN(IR)
           IF(LPROOT(KEIG,IR)) THEN
            YMIN = MIN(YMIN,IMAG(EVAL(KEIG,IR)))
            YMAX = MAX(YMAX,IMAG(EVAL(KEIG,IR)))
           ENDIF
         ENDDO
       ENDDO
       YMIN = 0.0     !##
       CALL AXISADJ(YMIN,YMAX, YTOT, YDEL, NANN)
      ENDIF
C
C---- make sure aspect ratio of plot isn't absurd
      IF(XMAX-XMIN .LT. 2.0*YDEL) THEN
       XMIN = XMAX - 2.0*YDEL
       CALL AXISADJ(XMIN,XMAX, XTOT, XDEL, NANN)
      ENDIF
      IF(YMAX-YMIN .LT. 2.0*XDEL) THEN
cc       YMIN = 0.5*(YMIN+YMAX) - XDEL  !##
       YMAX = YMIN + 2.0*XDEL
       CALL AXISADJ(YMIN,YMAX, YTOT, YDEL, NANN)
      ENDIF
C
C---- annotations for Hz axis
      YTMIN = YMIN/TPI
      YTMAX = YMAX/TPI
      CALL AXISADJ2(YTMIN,YTMAX, YTTOT, YTDEL, NANN)
      IF(YTDEL.GT.0.49*(YTMAX-YTMIN)) THEN
       YTDEL = 0.5*YTDEL
       NANN = 2*NANN
      ENDIF
      IF(YTMIN.LT.YMIN/TPI) YTMIN = YTMIN + YTDEL
      IF(YTMAX.GT.YMAX/TPI) YTMAX = YTMAX - YTDEL
C
      XFAC = 1.0/(XMAX-XMIN)
      YFAC = PAR/(YMAX-YMIN)
C
      SFAC = MIN( XFAC , YFAC )
      XFAC = SFAC
      YFAC = SFAC
C
      XLEN = (XMAX-XMIN)*XFAC
      YLEN = (YMAX-YMIN)*YFAC
C
      YTFAC = YFAC*TPI
C
      CALL NEWPEN(1)
      IF(LPGRID) THEN
       DXG = 0.5*XDEL*XFAC
       DYG = 0.5*YDEL*YFAC
C
       NXG = INT( 2.0*(XMAX-XMIN)/XDEL + 0.5 )
       NYG = INT( 2.0*(YMAX-YMIN)/YDEL + 0.5 )
       CALL PLGRID(XORG,YORG, NXG,DXG, NYG,DYG, LMASK2 )
C
      ELSE
       CALL PLOT(XORG     ,YORG+YLEN,3)
       CALL PLOT(XORG+XLEN,YORG+YLEN,2)
       CALL PLOT(XORG+XLEN,YORG     ,3)
       CALL PLOT(XORG+XLEN,YORG+YLEN,2)
C
      ENDIF
C
      CALL NEWPEN(2)
      CALL XAXIS(XORG     ,YORG,XLEN, XDEL*XFAC,  XMIN, XDEL, CSA,-2)
      CALL YAXIS(XORG     ,YORG,YLEN, YDEL*YFAC,  YMIN, YDEL, CSA,-2)
      CALL YAXIS(XORG+XLEN,YORG-YMIN*YFAC+YTMIN*YTFAC,
     &          (YTMAX-YTMIN)*YTFAC,YTDEL*YTFAC, YTMIN,YTDEL,-CSA,-2)
C
C---- plot x,y axes as heavy dotted lines
      CALL NEWPEN(2)
      CALL NEWPAT(LMASK1)
      CALL PLOT(XORG     ,YORG-YMIN*YFAC,3)
      CALL PLOT(XORG+XLEN,YORG-YMIN*YFAC,2)
      CALL PLOT(XORG-XMIN*XFAC,YORG     ,3)
      CALL PLOT(XORG-XMIN*XFAC,YORG+YLEN,2)
      CALL NEWPAT(LMASK0)
C
C---- plot axis parameter name annotations
      CALL NEWPEN(3)
      XL = XORG + XLEN - 0.5*CSL - 1.5*XDEL*XFAC
      YL = YORG        - 2.3*CSL
      CALL PLMATH(XL  ,YL, CSL,'s'    ,0.0, 1)
      XL = XORG + XLEN - 1.5*CSU - 0.5*XDEL*XFAC
      CALL PLCHAR(XL  ,YL, CSU,'1/'   ,0.0, 2)
      CALL PLCHAR(999.,YL, CSU, UNCHT ,0.0,-1)
C
      XL = XORG        - 3.0*CSL
      YL = YORG + YLEN - 0.5*CSL - 0.5*YDEL*YFAC
      CALL PLMATH(XL  ,YL, CSL,'w',0.0, 1)
      XL = XORG        - 4.2*CSU
      YL = YORG + YLEN - 0.5*CSL - 1.5*YDEL*YFAC
      CALL PLCHAR(XL  ,YL, CSU,'1/',0.0,2)
      CALL PLCHAR(999.,YL, CSU, UNCHT,0.0,-1)
C
      XL = XORG + XLEN      + 2.0*CSL
      YL = YORG - YMIN*YFAC - 0.5*CSL + (YTMAX - 0.5*YTDEL)*YTFAC
      CALL PLMATH(XL  ,YL, CSL,'w  p',0.0, 4)
      CALL PLCHAR(XL  ,YL, CSL,' /2 ',0.0, 4)
      XL = XORG + XLEN      + 1.2*CSU
      YL = YORG - YMIN*YFAC - 0.5*CSL + (YTMAX - 1.5*YTDEL)*YTFAC
      CALL PLCHAR(XL  ,YL, CSU,'cycles/',0.0,7)
      CALL PLCHAR(999.,YL, CSU, UNCHT,0.0,-1)
C
C---- plot root symbols
      XOFF = XMIN - XORG/XFAC
      YOFF = YMIN - YORG/YFAC
      DO IR = IRUN1, IRUN2
        DO KEIG = 1, NEIGEN(IR)
          IF(LPROOT(KEIG,IR)) THEN
           XEV = REAL(EVAL(KEIG,IR))
           YEV = IMAG(EVAL(KEIG,IR))
           IF(YEV .GE. -1.0E-4) THEN
            CALL NEWPEN(5)
            CALL NEWCOLOR(IRCOLOR(IR))
            XPLT = (XEV - XOFF)*XFAC
            YPLT = (YEV - YOFF)*YFAC
            CALL XYSYMB(1,XPLT,YPLT,0.0,1.0,0.0,1.0,CSS,ISYMB)
            IF(LPRNUM(KEIG,IR)) THEN
             CALL NEWPEN(2)
             XNUM = XPLT + 0.85*CSS
             YNUM = YPLT + 0.85*CSS
             CALL PLNUMB(XNUM,YNUM,CSN,FLOAT(IR),0.0,-1)
            ENDIF
           ENDIF
          ENDIF
        ENDDO
      ENDDO
      CALL NEWCOLOR(ICOL0)
C
      CALL PLFLUSH
C
      RETURN
      END ! PLROOT



      SUBROUTINE PLTPAR(XPLT,YPLT, IRUN1, IRUN2,
     &                  PARVAL,LPPAR,
     &                  IRCOLOR, CSIZ, DELX, DELY)
C-----------------------------------------------
C     Plots operating conditions in table form
C-----------------------------------------------
      INCLUDE 'AINDEX.INC'
C
      REAL PARVAL(IPTOT,*)
      LOGICAL LPPAR(IPTOT)
      INTEGER IRCOLOR(*)
C
C
      INTEGER NPDIG(IPTOT), NPWID(IPTOT)
      REAL XPAR(IPTOT), FACPAR(IPTOT)
C
      DATA DTR / 0.0174532925 /
C
C
      CS  =     CSIZ
      CSL = 1.3*CSIZ
C
C---- set number of significant digits for each variable
      DO IP = 1, IPTOT
        NPDIG(IP) = 4
      ENDDO
C
C---- set total number of digits for each variable (including decimal point)
      DO IP = 1, IPTOT
        NPWID(IP) = 3 + NPDIG(IP)
      ENDDO
C
C---- set scale factors of displayed value
      DO IP = 1, IPTOT
        FACPAR(IP) = 1.0
      ENDDO
cc      FACPAR(IPALFA) = 1.0/DTR
cc      FACPAR(IPBETA) = 1.0/DTR
cc      FACPAR(IPTHE ) = 1.0/DTR
cc      FACPAR(IPPHI ) = 1.0/DTR
C
C---- starting x-position
      XPOS = XPLT + 2.5*CS + DELX
C
C---- set starting x position for each variable
      DO IP = 1, IPTOT
        IF(LPPAR(IP)) THEN
         XPAR(IP) = XPOS
         XPOS = XPOS + CS*NPWID(IP) + DELX
        ELSE
         XPAR(IP) = 0.
        ENDIF
      ENDDO
C
C
      CALL GETCOLOR(ICOL0)
C
      Y = YPLT
      DO IR = IRUN2, IRUN1, -1
        Y = Y + DELY
C
        CALL NEWCOLOR(IRCOLOR(IR))
C
        CALL NEWPEN(2)
        X = XPLT
        CALL PLNUMB(X,Y,CS,FLOAT(IR),0.0,-1)
        CALL PLCHAR(999.,Y,CS,':',0.0,1)
C
C------ plot numerical parameter values
        CALL NEWPEN(2)
        DO IP = 1, IPTOT
          IF(LPPAR(IP)) THEN
           X = XPAR(IP)
           RNUM = PARVAL(IP,IR)*FACPAR(IP)
           CALL PLNUMS(X,Y,CS,RNUM,0.0,NPDIG(IP))
          ENDIF
        ENDDO
      ENDDO
C
      CALL NEWCOLOR(ICOL0)
      CALL NEWPEN(3)
C
      Y = Y + DELY + 0.3*CS
C
      DO IP = 1, IPTOT
        IF(LPPAR(IP)) THEN
         X = XPAR(IP) + 0.5*CS*FLOAT(NPWID(IP)-3) - 0.5*CSL
         CALL PPNAME(X,Y,CSL, IP)
        ENDIF
      ENDDO
C
C---- save upper Y limit for passing back
      YPLT = Y + CSL
C
      RETURN
      END ! PLTPAR



      SUBROUTINE PPNAME(X,Y,CSIZ,IP)
      INCLUDE 'AINDEX.INC'
C------------------------------------------------------------------
C     Plots symbol name of parameter specified by IP index
C
C      X,Y   position of lower-left corner of symbol
C      CSIZ  size of symbol
C      IP    index of parameter
C------------------------------------------------------------------
      CSP =      CSIZ
      CSC = 0.70*CSIZ
C
      CALL GETLASTXY(XPLT,YPLT)
      IF(X .NE. 999.0) XPLT = X
      IF(Y .NE. 999.0) YPLT = Y
C
C------ plot scalar parameter name
C
      IF    (IP.EQ.IPALFA) THEN
       CALL PLMATH(XPLT,YPLT,CSP,'a"' ,0.0,2)
C
      ELSEIF(IP.EQ.IPBETA) THEN
       CALL PLMATH(XPLT,YPLT,CSP,'b"' ,0.0,2)
C
      ELSEIF(IP.EQ.IPROTX) THEN
       CALL PLCHAR(XPLT,YPLT,CSP,'p'  ,0.0,1)
C
      ELSEIF(IP.EQ.IPROTY) THEN
       CALL PLCHAR(XPLT,YPLT,CSP,'q'  ,0.0,1)
C
      ELSEIF(IP.EQ.IPROTZ) THEN
       CALL PLCHAR(XPLT,YPLT,CSP,'r'  ,0.0,1)
C
      ELSEIF(IP.EQ.IPCL  ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'C' ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'L',0.0,1)
C
      ELSEIF(IP.EQ.IPCD0 ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'C'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'Do',0.0,2)
C
      ELSEIF(IP.EQ.IPTHE ) THEN
ccc       CALL PLMATH(XPLT,YPLT,CSP,'Q"' ,0.0,2)
       CALL PLCHAR(XPLT,YPLT,CSP,'elev' ,0.0,4)
C
      ELSEIF(IP.EQ.IPPHI ) THEN
ccc       CALL PLMATH(XPLT,YPLT,CSP,'F"' ,0.0,2)
       CALL PLCHAR(XPLT,YPLT,CSP,'bank' ,0.0,4)
C
      ELSEIF(IP.EQ.IPVEE ) THEN
       CALL PLCHAR(XPLT,YPLT,CSP,'V'  ,0.0,1)
C
      ELSEIF(IP.EQ.IPRHO ) THEN
       CALL PLMATH(XPLT,YPLT,CSP,'r'  ,0.0,1)
C
      ELSEIF(IP.EQ.IPGEE ) THEN
       CALL PLCHAR(XPLT,YPLT,CSP,'g'  ,0.0,1)
C
      ELSEIF(IP.EQ.IPRAD ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'R'   ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC,'turn',0.0,4)

C
      ELSEIF(IP.EQ.IPFAC ) THEN
       CALL PLCHAR(XPLT,YPLT,CSP,'N'  ,0.0,1)
C
      ELSEIF(IP.EQ.IPXCG ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'X'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'cg',0.0,2)
C
      ELSEIF(IP.EQ.IPYCG ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'Y'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'cg',0.0,2)
C
      ELSEIF(IP.EQ.IPZCG ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'Z'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'cg',0.0,2)
C
      ELSEIF(IP.EQ.IPMASS) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'mass',0.0,4)
C
      ELSEIF(IP.EQ.IPIXX ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'I'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'xx',0.0,2)
C
      ELSEIF(IP.EQ.IPIYY ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'I'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'yy',0.0,2)
C
      ELSEIF(IP.EQ.IPIZZ ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'I'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'zz',0.0,2)
C
      ELSEIF(IP.EQ.IPIXY ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'I'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'xy',0.0,2)
C
      ELSEIF(IP.EQ.IPIYZ ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'I'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'yz',0.0,2)
C
      ELSEIF(IP.EQ.IPIZX ) THEN
       CALL PLCHAR(XPLT        ,YPLT        ,CSP,'I'  ,0.0,1)
       CALL PLCHAR(XPLT+0.9*CSP,YPLT-0.4*CSP,CSC, 'zx',0.0,2)
C
      ELSEIF(IP.EQ.IPCLA ) THEN
       CALL PLMATH(XPLT        ,YPLT        ,CSP,'D'  ,0.0,1)
       CALL PLCHAR(XPLT+1.0*CSP,YPLT        ,CSP,'C'  ,0.0,1)
       CALL PLCHAR(XPLT+1.9*CSP,YPLT-0.4*CSP,CSC, 'L' ,0.0,1)
       CALL PLMATH(XPLT+2.7*CSP,YPLT-0.6*CSP,CSC,  'a',0.0,1)
C
      ELSEIF(IP.EQ.IPCLU ) THEN
       CALL PLMATH(XPLT        ,YPLT        ,CSP,'D'  ,0.0,1)
       CALL PLCHAR(XPLT+1.0*CSP,YPLT        ,CSP,'C'  ,0.0,1)
       CALL PLCHAR(XPLT+1.9*CSP,YPLT-0.4*CSP,CSC, 'L' ,0.0,1)
       CALL PLCHAR(XPLT+2.7*CSP,YPLT-0.6*CSP,CSC,  'u',0.0,1)
C
      ELSEIF(IP.EQ.IPCMA ) THEN
       CALL PLMATH(XPLT        ,YPLT        ,CSP,'D'  ,0.0,1)
       CALL PLCHAR(XPLT+1.0*CSP,YPLT        ,CSP,'C'  ,0.0,1)
       CALL PLCHAR(XPLT+1.9*CSP,YPLT-0.4*CSP,CSC, 'M' ,0.0,1)
       CALL PLMATH(XPLT+2.7*CSP,YPLT-0.6*CSP,CSC,  'a',0.0,1)
C
      ELSEIF(IP.EQ.IPCMU ) THEN
       CALL PLMATH(XPLT        ,YPLT        ,CSP,'D'  ,0.0,1)
       CALL PLCHAR(XPLT+1.0*CSP,YPLT        ,CSP,'C'  ,0.0,1)
       CALL PLCHAR(XPLT+1.9*CSP,YPLT-0.4*CSP,CSC, 'M' ,0.0,1)
       CALL PLCHAR(XPLT+2.7*CSP,YPLT-0.6*CSP,CSC,  'u',0.0,1)
C
      ENDIF
C
C---- make sure subscript didn't screw up vertical pen location
      CALL PLCHAR(999.0,YPLT,0.001*CSP,' ',0.0,1)
C
      RETURN
      END ! PPNAME


      SUBROUTINE PLNUMS(X,Y,CS,RNUM,ANG,NDIG)
C----------------------------------------------------------
C     Plots real number with NDIG significant digits
C----------------------------------------------------------
C
      IF(RNUM.EQ.0.0) THEN
       XPLT = X + CS*FLOAT(NDIG/2-1)
       CALL PLNUMB(XPLT,Y,CS,RNUM,ANG,1)
       RETURN
      ENDIF
C
      ARNUM = ABS(RNUM)
      RLOG = LOG10(ARNUM)
C
C---- set number of digits to left and right of decimal point
      NL = INT( RLOG + 101.0 ) - 100
      NR = NDIG - NL
C
      IF(NL.GT.NDIG .OR. NR.GT.NDIG) THEN
C----- plot with scientific notation
       NEXP = 1 - NL
       FEXP = 10.0**NEXP
       ND = MAX( NDIG - 1 , 1 )
       CALL PLNUMB(X   ,Y,CS,RNUM*FEXP,ANG,ND)
       CALL PLCHAR(999.,Y,CS,'e',ANG,1)
       CALL PLNUMB(999.,Y,CS,FLOAT(-NEXP),ANG,-1)
      ELSE
       ND = MAX( NR , 0 )
       CALL PLNUMB(X,Y,CS,RNUM,ANG,ND)
      ENDIF
C
      RETURN
      END

C***********************************************************************
C    Module:  amode.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE MODE
C---------------------------------------------
C     Flight dynamics analysis driver
C---------------------------------------------
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      LOGICAL ERROR, LOK, LWRIT, SAVED, OVERLAY, LOWRIT
C
      CHARACTER*1 ITEM, ANS, CHKEY
      CHARACTER*2 OPT, CHPLOT
      CHARACTER*4 COMAND, ITEMC
      CHARACTER*256 FNOUT, FNNEW, FNSYS, FNVB 
      CHARACTER*80 LINE, COMARG, PROMPT, RTNEW
      CHARACTER SATYPE*50, ROTTYPE*50
C
      LOGICAL LPROOT(JEMAX,NRMAX),
     &        LPRNUM(JEMAX,NRMAX)
      SAVE LPROOT,LPRNUM
C
      REAL*8 ASYS(JEMAX,JEMAX),BSYS(JEMAX,NDMAX),RSYS(JEMAX)
      COMPLEX ZCROOT
C
      REAL RINPUT(20), RINP(20)
      INTEGER IINPUT(20), IINP(20)
C
      IRUN0 = IRUN
C
      FNVB = ' '
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
      IF(LSA_RATES) THEN
        ROTTYPE = 'Rates,moments about Stability axes'
       ELSE
        ROTTYPE = 'Rates,moments about Body axes'
      ENDIF
C
 1000 FORMAT (A)
C
C---- no viewed eigenmode yet
      KEVIEW = 0
      IRVIEW = 0
C
C---- force computation of plot limits
      TMIN = 0.
      TMAX = 0.
      FMIN = 0.
      FMAX = 0.
C
C
      LPLOT = .FALSE.
      LWRIT = .FALSE.
C
      FNOUT = ' '
C
      CHPLOT = '  '
C
c      EYEPTZ = 180.
c      EYEPTY = 90.
c      EYEPTX = 0.
c      ROBINV = 0.
C
      OVERLAY = .FALSE.


      write(*,*) 3, parnam(ipixx), '  ', parunch(ipixx)

C
C=================================================================
C---- start of user interaction loop
 800  CONTINUE
C
      WRITE(*,1050) 
 1050 FORMAT(
     &  /'  Run-case parameters for eigenmode analyses ... ')
C
      LU = 6
      CALL RUNLST(LU,IRUNE)
C
C
C
      WRITE(*,1052) LSVMOV
 1052 FORMAT(
     &   ' =========================================================='
     & //' "#" select run case for eigenmode analysis (0 = all)'
     & //'  M odify parameters'
     & //'  N ew eigenmode calculation'
     & //'  P lot root locus'
     &  /'  B lowup window'
     &  /'  R eset to normal size'
     &  /' eX amine selected eigenmode'
     & //'  A nnotate current plot'
     &  /'  H ardcopy current plot'
     &  /'  T ime-integration parameters'
     &  /'  G enerate hardcopy movie toggle', L3
     & //'  S ystem matrix output'
     &  /'  W rite eigenvalues to file'
     &  /'  D ata file overlay toggle'
     & //'  Z oom'
     &  /'  U nzoom')
C
C   A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
C   x x x x     x x         x x   x   x x x x   x x   x

 810  CONTINUE
      CALL ASKC(' .MODE^',COMAND,COMARG)
C
 815  CONTINUE
C------------------------------------------------------
      IF    (COMAND.EQ.'    ') THEN
       IF(LPLOT) CALL PLEND
       LPLOT = .FALSE.
       CALL CLRZOOM
       IRUN = IRUN0
       RETURN
C
      ELSEIF(COMAND.EQ.'?   ') THEN
       GO TO 800
C
      ENDIF
C
C-------------------------------------------------------------------
C---- see if command is an integer
      NINPUT = 1
      CALL GETINT(COMAND,IINPUT,NINPUT,ERROR)
      IF(.NOT.ERROR .AND. NINPUT.GE.1 
     &  .AND. COMAND(1:1).NE.'T'
     &  .AND. COMAND(1:1).NE.'F' ) THEN
C----- command is an integer... new case index?
       IF(IINPUT(1).LT.0 .OR. IINPUT(1).GT.NRUN) THEN
        WRITE(*,*)
        WRITE(*,*) '* Selected new run case is not defined'
        GO TO 800
       ELSE
C------ valid new run case selected... go back to menu
        IRUNE = IINPUT(1)
        GO TO 800
       ENDIF
      ENDIF
C
C-------------------------------------------------------------------
C---- extract command line numeric arguments
      DO I=1, 20
        IINPUT(I) = 0
        RINPUT(I) = 0.0
      ENDDO
      NINPUT = 20
      CALL GETINT(COMARG,IINPUT,NINPUT,ERROR)
      NINPUT = 20
      CALL GETFLT(COMARG,RINPUT,NINPUT,ERROR)
C
C---- set up for multiple or single run cases
      IF(IRUNE.EQ.0) THEN
       IRUN1 = 1
       IRUN2 = NRUN
      ELSE
       IRUN1 = IRUNE
       IRUN2 = IRUNE
      ENDIF
C
C-----------------------------------------------------------------------
c      IF    (COMAND.EQ.'R   ') THEN
cC----- set moment reference point to CG location
c       DXCREF = (XYZMASS(1)/UNITL - XYZREF(1)) / CREF
c       WRITE(*,*)
c       WRITE(*,1210) '  Previous XYZref  = ', (XYZREF(K), K=1,3),'Lunit'
c       XYZREF(1) = XYZMASS(1)/UNITL
c       XYZREF(2) = XYZMASS(2)/UNITL
c       XYZREF(3) = XYZMASS(3)/UNITL
c       WRITE(*,1210) '  New (CG) XYZref  = ', (XYZREF(K), K=1,3),'Lunit'
cC
c       WRITE(*,*)
c       WRITE(*,1210) '  delta(Xref)/Cref = ', DXCREF
c 1210  FORMAT(1X, A, 3G10.4,3X,A)
cC
C-----------------------------------------------------------------------
      IF    (COMAND.EQ.'M   ') THEN
       CALL PARMOD(IRUNE)
C
C-------------------------------------------------------------------
      ELSEIF(COMAND .EQ. 'N   ' .OR.
     &       COMAND .EQ. 'C   '      ) THEN
C------ execute eigenmode calculation
        DO 100 IR = IRUN1, IRUN2
          CALL RUNCHK(IR,LOK)
          IF(.NOT.LOK) THEN
           WRITE(*,*) '** Skipping ill-posed run case', IR
           GO TO 100
          ENDIF
C
          NITER = 10
          INFO = 1
          CALL EXEC(NITER,INFO,IR)
C
          IF(COMAND .EQ. 'N   ') THEN
           CALL SYSMAT(IR,ASYS,BSYS,RSYS,NSYS)
          ELSE
           CALL APPMAT(IR,ASYS,BSYS,RSYS,NSYS)
          ENDIF
C
cc          LU = 6
cc          CALL SYSSHO(LU,ASYS,BSYS,RSYS,NSYS)
C
          INFO = 1
          ETOL = 1.0E-5
          CALL EIGSOL(INFO,IR,ETOL,ASYS,NSYS)
C
C
          DO KEIG = 1, NEIGEN(IR)
            LPROOT(KEIG,IR) = .TRUE.
            LPRNUM(KEIG,IR) = IRUN1 .NE. IRUN2
          ENDDO
C
          XORG0 = 0.0
          YORG0 = 0.0
          TMIN = 0.
          TMAX = 0.
          FMIN = 0.
          FMAX = 0.
          CALL PLEMAP(XORG0,YORG0, 
     &                IRUN1,IR,
     &                KEVIEW,IRVIEW,
     &                LPROOT,LPRNUM,OVERLAY,
     &                TMIN,TMAX,TDEL,TFAC,
     &                FMIN,FMAX,FDEL,FFAC )
C
          WRITE(*,*)
          CALL EIGLST(6,IR)
C
 100    CONTINUE
C
        CHPLOT = 'P '
C
C-------------------------------------------------------------------
      ELSEIF(COMAND .EQ. 'P   ') THEN
        DO IR = IRUN1, IRUN2
          IF(NEIGEN(IR) .GT. 0) GO TO 51
        ENDDO
        WRITE(*,*) 'First compute eigenmodes with N command'
        GO TO 810
C
 51     XORG0 = 0.0
        YORG0 = 0.0
        CALL PLEMAP(XORG0,YORG0, 
     &              IRUN1,IRUN2,
     &              KEVIEW,IRVIEW,
     &              LPROOT,LPRNUM,OVERLAY,
     &              TMIN,TMAX,TDEL,TFAC,
     &              FMIN,FMAX,FDEL,FFAC )
        CHPLOT = COMAND(1:2)
C
C-------------------------------------------------------------------
      ELSEIF(COMAND .EQ. 'X   ') THEN
       DO IR = IRUN1, IRUN2
         IF(NEIGEN(IR) .GT. 0) GO TO 61
       ENDDO
       WRITE(*,*) 'First compute eigenmodes with N command'
       GO TO 810
C
 61    CONTINUE
       IF(INDEX('P',CHPLOT(1:1)) .EQ. 0) THEN
C------ make root map plot first
        XORG0 = 0.0
        YORG0 = 0.0
        TMIN = 0.
        TMAX = 0.
        FMIN = 0.
        FMAX = 0.
        CALL PLEMAP(XORG0,YORG0, 
     &              IRUN1,IRUN2,
     &              KEVIEW,IRVIEW,
     &              LPROOT,LPRNUM,OVERLAY,
     &              TMIN,TMAX,TDEL,TFAC,
     &              FMIN,FMAX,FDEL,FFAC )
       ENDIF
C
       WRITE(*,*)
       WRITE(*,*) 'Click on root of eigenmode to be viewed...'
C
       CALL GETCURSORXY(XC1,YC1,CHKEY)
       XE1 = (XC1-XORG0)/TFAC + TMIN
       YE1 = (YC1-YORG0)/FFAC + FMIN
C
 64    CONTINUE
       IF(XE1 .LT. TMIN .OR. XE1 .GT. TMAX  .OR.
     &    YE1 .LT. FMIN .OR. YE1 .GT. FMAX       ) THEN
C------ click was outside of grid... manual input
 65     RINPUT(1) = 0.
        RINPUT(2) = 0.
        WRITE(*,1165) RINPUT(1), RINPUT(2)
 1165   FORMAT(/' Enter  sigma,omega  of root to be viewed:', 2F12.6)
        CALL READR(2,RINPUT,ERROR)
        IF(ERROR) GO TO 65
C
        ZCROOT = CMPLX( RINPUT(1) , RINPUT(2) )
C
       ELSE
C------ set root from its symbol-plot coordinates
        ZCROOT = CMPLX( XE1 , YE1 )
C
       ENDIF
C
C----- search current roots for one nearest to specified location
       IR = 0
       KEIG = 0
       DIST = 1.0E32
       DO JR = IRUN1, IRUN2
         DO K = 1, NEIGEN(JR)
           DIST1 = ABS( ZCROOT - EVAL(K,JR) )
           IF(DIST1.LE.DIST) THEN
            IR = JR
            KEIG = K
            DIST = DIST1
           ENDIF
         ENDDO
       ENDDO
C
       IF(IR.EQ.0 .OR. KEIG.EQ.0) THEN
        WRITE(*,*) 'Nearest root not identified'
        GO TO 810
       ENDIF
C
       CALL PLOTMD(AZIMOB, ELEVOB, TILTOB, ROBINV, KEIG, IR)
C
       KEVIEW = KEIG
       IRVIEW = IR
C
       CHPLOT = COMAND(1:2)
C
C-------------------------------------------------------------------
C---- Blowup window
      ELSEIF(COMAND.EQ.'B   ') THEN
       IF(INDEX('P',CHPLOT(1:1)) .EQ. 0) THEN
        WRITE(*,*) 'No plot to blow up'
        GO TO 810
       ENDIF
C
       DCROSS = 2.0
       WRITE(*,*) 'Mark off corners of blowup area'
       CALL GETCURSORXY(XC1,YC1,CHKEY)
       CALL PLSYMB(XC1,YC1,DCROSS,3,0.0,0)
       CALL PLFLUSH
       CALL GETCURSORXY(XC2,YC2,CHKEY)
       CALL PLSYMB(XC2,YC2,DCROSS,3,0.0,0)
       CALL PLFLUSH
C
       XE1 = TMIN+(XC1-XORG0)/TFAC
       YE1 = FMIN+(YC1-YORG0)/FFAC
       XE2 = TMIN+(XC2-XORG0)/TFAC
       YE2 = FMIN+(YC2-YORG0)/FFAC
C
       TMIN = MIN( XE1 , XE2 )
       TMAX = MAX( XE1 , XE2 )
       FMIN = MIN( YE1 , YE2 )
       FMAX = MAX( YE1 , YE2 )
C
       CALL AXISADJ(TMIN,TMAX, TTOT, TDEL, NANN)
       CALL AXISADJ(FMIN,FMAX, FTOT, FDEL, NANN)
C
       COMAND = 'P   '
       GO TO 815
C
C-------------------------------------------------------------------
C---- Normal size
      ELSEIF(COMAND.EQ.'R   ') THEN
       TMIN = 0.
       TMAX = 0.
       FMIN = 0.
       FMAX = 0.
C
       COMAND = 'P   '
       GO TO 815
C
C-------------------------------------------------------------------
C---- Annotate
      ELSEIF(COMAND.EQ.'A   ') THEN
       IF(LPLOT) THEN
        CALL ANNOT(CH)
       ELSE
        WRITE(*,*) 'No active plot'
       ENDIF
C
C-------------------------------------------------------------------
C---- Hardcopy
      ELSEIF(COMAND.EQ.'H   ') THEN
       IF(LPLOT) CALL PLEND
       LPLOT = .FALSE.
       CALL REPLOT(IDEVH)
C
C-------------------------------------------------------------------
C---- Change time integration parameters
      ELSEIF(COMAND.EQ.'T   ') THEN
 70     WRITE(*,2070) DTIMED, DTMOVIE, TMOVIE
 2070   FORMAT(/' ==========================='
     &         /'  I ntegration  delta(t): ', G11.5,
     &         /'  O utput-frame delta(t): ', G11.5,
     &         /'  M aximum movie time   : ', G11.5 )
C
 72     CALL ASKC(' Select item,value^',ITEMC,COMARG)
 2072   FORMAT(' Enter new ',A,': ', $)
C
        IF(ITEMC.EQ.'    ') THEN
          GO TO 810
        ENDIF
C
        NINP = 1
        CALL GETFLT(COMARG,RINP,NINP,ERROR)
C
        IF    (INDEX('Ii',ITEMC(1:1)).NE.0) THEN
          IF(NINP.EQ.0) THEN
 74        WRITE(*,2072) 'integration delta(t)'
           READ (*,*,ERR=74) DTIMED
          ELSE
           DTIMED = RINP(1)
          ENDIF
C
        ELSEIF(INDEX('Oo',ITEMC(1:1)).NE.0) THEN
          IF(NINP.EQ.0) THEN
 75        WRITE(*,2072) 'output-frame delta(t)'
           READ (*,*,ERR=75) DTMOVIE
          ELSE
           DTMOVIE = RINP(1)
          ENDIF
C
        ELSEIF(INDEX('Mm',ITEMC(1:1)).NE.0) THEN
          IF(NINP.EQ.0) THEN
 76        WRITE(*,2072) 'maximum movie time'
           READ (*,*,ERR=76) TMOVIE
          ELSE
           TMOVIE = RINP(1)
          ENDIF
C
        ELSE
          WRITE(*,*) 'Item not recognized'
          GO TO 70
C
        ENDIF
        GO TO 70
C
C-----------------------------------------------------------------------
      ELSEIF(COMAND.EQ.'G   ') THEN
       LSVMOV = .NOT. LSVMOV
C
C-------------------------------------------------------------------
C---- write system matrices
      ELSEIF(COMAND.EQ.'S   ' .OR.
     &       COMAND.EQ.'SC  '      ) THEN
        DO 80 IR = IRUN1, IRUN2
          WRITE(*,2080) IR
 2080     FORMAT(/' Run case', I3,'...')
C
          CALL RUNCHK(IR,LOK)
          IF(.NOT.LOK) THEN
           WRITE(*,*) '** Skipping ill-posed run case', IR
           GO TO 80
          ENDIF
C
          ALFA    = PARVAL(IPALFA,IR)*DTR
          BETA    = PARVAL(IPBETA,IR)*DTR
          WROT(1) = PARVAL(IPROTX,IR)*2.0/BREF
          WROT(2) = PARVAL(IPROTY,IR)*2.0/CREF
          WROT(3) = PARVAL(IPROTZ,IR)*2.0/BREF
C
          XYZREF(1) = PARVAL(IPXCG,IR)
          XYZREF(2) = PARVAL(IPYCG,IR)
          XYZREF(3) = PARVAL(IPZCG,IR)
          CDREF     = PARVAL(IPCD0,IR)
C
          NITER = 10
          INFO = 1
          CALL EXEC(NITER,INFO,IR)
C
          IF(COMAND.EQ.'S   ') THEN
           CALL SYSMAT(IR,ASYS,BSYS,RSYS,NSYS)
          ELSE
           CALL APPMAT(IR,ASYS,BSYS,RSYS,NSYS)
          ENDIF
C
          LU = 6
          CALL SYSSHO(LU,ASYS,BSYS,RSYS,NSYS)
C
          WRITE(*,2082)
 2082     FORMAT(/' Enter output filename (or <Return>): ', $)
          READ(*,1000) FNSYS
          CALL STRIP(FNSYS,NFS)
          IF(NFS.EQ.0) GO TO 80
C
          OPEN(LUSYS,FILE=FNSYS,STATUS='OLD',ERR=81)
          IF(LOWRIT(FNSYS)) THEN
           REWIND(LUSYS)
           GO TO 82
          ELSE
           CLOSE(LUSYS)
           GO TO 80
          ENDIF
C
 81       OPEN(LUSYS,FILE=FNSYS,STATUS='NEW',ERR=85)
 82       CALL SYSSHO(LUSYS,ASYS,BSYS,RSYS,NSYS)
          CLOSE(LUSYS)
          GO TO 800
C
 85       CONTINUE
          WRITE(*,*) '* File OPEN error'
C
 80     CONTINUE
C
C-------------------------------------------------------------------
C---- write eigenvalues
      ELSEIF(COMAND.EQ.'W   ') THEN
       IF(FEVDEF(1:1).EQ.' ') THEN
C------ set default filename
        KDOT = INDEX(FILDEF,'.')
        IF(KDOT.EQ.0) THEN
         CALL SLEN(FILDEF,NFIL)
         FEVDEF = FILDEF(1:NFIL) // '.eig'
        ELSE
         FEVDEF = FILDEF(1:KDOT) // 'eig'
        ENDIF
       ENDIF
C
       CALL SLEN(FEVDEF,NFE)
       NFE = MAX( NFE , 1 )
       WRITE(*,2040) FEVDEF(1:NFE)
 2040  FORMAT(' Enter eigenvalue save filename: ', A)
       READ (*,1000) FNNEW
       IF(FNNEW.NE.' ') FEVDEF = FNNEW
       CALL EIGOUT(FEVDEF, IRUN1,IRUN2, SAVED)
C
C-------------------------------------------------------------------
C---- toggle overlay flag
      ELSEIF(COMAND.EQ.'D   ') THEN
       OVERLAY = .NOT.OVERLAY
C
       IF(OVERLAY) THEN
        IF(FEVDEF(1:1).EQ.' ') THEN
C------- set default filename
         KDOT = INDEX(FILDEF,'.')
         IF(KDOT.EQ.0) THEN
          CALL SLEN(FILDEF,NFIL)
          FEVDEF = FILDEF(1:NFIL) // '.eig'
         ELSE
          FEVDEF = FILDEF(1:KDOT) // 'eig'
         ENDIF
        ENDIF
C
        CALL SLEN(FEVDEF,NFE)
        NFE = MAX( NFE , 1 )
        WRITE(*,2050) FEVDEF(1:NFE)
 2050   FORMAT(' Enter eigenvalue data filename: ', A)
        READ (*,1000) FNNEW
        IF(FNNEW.NE.' ') FEVDEF = FNNEW
C
C------ read the data file
        CALL EIGINP(FEVDEF, ERROR)
        IF(ERROR) THEN
         OVERLAY = .FALSE.
         GO TO 800
        ENDIF
C
        OVERLAY = .TRUE.
        WRITE(*,*) 'Overlay plotting enabled'
C
        IF(INDEX('P',CHPLOT(1:1)).NE.0) THEN
         COMAND = CHPLOT
         GO TO 815
        ENDIF
C
       ELSE
        WRITE(*,*) 'Overlay plotting disabled'
C
       ENDIF
C
C-------------------------------------------------------------------
C---- Zoom in on plot
      ELSEIF(COMAND.EQ.'Z   ') THEN
       IF(INDEX('P',CHPLOT(1:1)) .EQ. 0) THEN
        WRITE(*,*) 'No plot to zoom'
        GO TO 810
       ENDIF
C
       CALL USETZOOM(.TRUE.,.TRUE.)
       CALL REPLOT(IDEV)
C
C-------------------------------------------------------------------
C---- Reset zoom on plot
      ELSEIF(COMAND.EQ.'U   ') THEN
       CALL CLRZOOM
       CALL REPLOT(IDEV)
C
C-------------------------------------------------------------------
      ELSE
        WRITE(*,*)
        WRITE(*,*) '* Option not recognized'
C
      ENDIF
      GO TO 800
C
      END ! MODE


      SUBROUTINE EIGLST(LU,IR)
      INCLUDE 'AVL.INC'
C
      WRITE(LU,3100) IR, RTITLE(IR)
C
      DO J = 1, NEIGEN(IR)
      WRITE(LU,3200) J, REAL(EVAL(J,IR)), IMAG(EVAL(J,IR))
      WRITE(LU,3300)
     & 'u  ', REAL(EVEC(JEU,J,IR)), IMAG(EVEC(JEU,J,IR)),
     & 'v  ', REAL(EVEC(JEV,J,IR)), IMAG(EVEC(JEV,J,IR)),
     & 'x  ', REAL(EVEC(JEX,J,IR)), IMAG(EVEC(JEX,J,IR))
      WRITE(LU,3300)
     & 'w  ', REAL(EVEC(JEW,J,IR)), IMAG(EVEC(JEW,J,IR)),
     & 'p  ', REAL(EVEC(JEP,J,IR)), IMAG(EVEC(JEP,J,IR)),
     & 'y  ', REAL(EVEC(JEY,J,IR)), IMAG(EVEC(JEY,J,IR))
      WRITE(LU,3300)
     & 'q  ', REAL(EVEC(JEQ,J,IR)), IMAG(EVEC(JEQ,J,IR)),
     & 'r  ', REAL(EVEC(JER,J,IR)), IMAG(EVEC(JER,J,IR)),
     & 'z  ', REAL(EVEC(JEZ,J,IR)), IMAG(EVEC(JEZ,J,IR))
      WRITE(LU,3300)
     & 'the', REAL(EVEC(JETH,J,IR)), IMAG(EVEC(JETH,J,IR)),
     & 'phi', REAL(EVEC(JEPH,J,IR)), IMAG(EVEC(JEPH,J,IR)),
     & 'psi', REAL(EVEC(JEPS,J,IR)), IMAG(EVEC(JEPS,J,IR))
      ENDDO

 3100 FORMAT(/1X,'Run case',I3,':  ',A)
 3200 FORMAT(/1X,' mode',I2,':', 2G14.6)
 3300 FORMAT( 1X, A,':', 2F11.4, 6X, A,':', 2F11.4, 6X, A,':', 2G12.4)
C
      RETURN
      END ! EIGLST



      SUBROUTINE EIGOUT(FILNAM, IRUN1,IRUN2, SAVED)
      INCLUDE 'AVL.INC'
C
      CHARACTER*(*) FILNAM
      LOGICAL SAVED
C
      LOGICAL LOWRIT
C
      LU = 2
      OPEN(LU,FILE=FILNAM,STATUS='OLD',ERR=17)
      IF(LOWRIT(FILNAM)) THEN
       GO TO 18
      ELSE
       CLOSE(LU)
       WRITE(*,*) 'Eigenvalues not saved.'
       SAVED = .FALSE.
       RETURN
      ENDIF
C
 17   OPEN(LU,FILE=FILNAM,STATUS='UNKNOWN',ERR=80)
 18   CONTINUE
      REWIND(LU)
C
C---- write header
      WRITE(LU,1100) TITLE
 1100 FORMAT('# ', A
     &      /'# '
     &      /'#   Run case     Eigenvalue')
C
 2300 FORMAT(1X, I7, 2G18.8, f12.4 )
C
      DO IR = IRUN1, IRUN2
        DO KEIG = 1, NEIGEN(IR)
          WRITE(LU,2300) IR,
     &                 REAL(EVAL(KEIG,IR)),
     &                 IMAG(EVAL(KEIG,IR))
        ENDDO
      ENDDO
C
      CLOSE(LU)
      SAVED = .TRUE.
      RETURN
C
 80   CONTINUE
      SAVED = .FALSE.
      RETURN
      END ! EIGOUT




      SUBROUTINE EIGINP(FILNAM, ERROR)
      INCLUDE 'AVL.INC'
C
      CHARACTER*(*) FILNAM
      LOGICAL ERROR
C
      CHARACTER*1 DUMMY
C
C---- assume that read will fail
      ERROR = .TRUE.
C
 1000 FORMAT(A)
C
      DO IR = 1, NRMAX
        NEIGENDAT(IR) = 0
      ENDDO
C
      LU = 2
      OPEN(LU,FILE=FILNAM,STATUS='OLD',ERR=85)
      REWIND(LU)
C
C---- read header
      READ(LU,1000,ERR=90) DUMMY
      READ(LU,1000,ERR=90) DUMMY
      READ(LU,1000,ERR=90) DUMMY
C
C---- find index of forcing parameter of this file
      DO ILINE = 1, 123456
 15     READ(LU,*,END=20,ERR=90) IR, SIGMA, OMEGA
        IF(IR.LT.1 .OR. IR.GT.NRMAX) GO TO 15
C
        KEIG = NEIGENDAT(IR) + 1
        IF(KEIG .LE. JEMAX) THEN
         EVALDAT(KEIG,IR) = CMPLX(SIGMA,OMEGA)
         NEIGENDAT(IR) = KEIG
        ENDIF
      ENDDO
C
 20   CONTINUE
      CLOSE(LU)
      ERROR = .FALSE.
      RETURN
C
 85   CONTINUE
      WRITE(*,*) 'File OPEN error'
      RETURN
C
 90   CONTINUE
      WRITE(*,*) 'File READ error'
      CLOSE(LU)
      RETURN
      END ! EIGINP





      SUBROUTINE RUNCHK(JRUN,OK)
C------------------------------------------------------------------
C     Returns OK=t if run case JRUN has no redundant constraints.
C------------------------------------------------------------------
      INCLUDE 'AVL.INC'
      LOGICAL OK
C
      OK = .TRUE.
      DO IV = 1, NVTOT
        DO JV = 1, NVTOT
          IF(IV.NE.JV .AND. ICON(IV,JRUN).EQ.ICON(JV,JRUN)) THEN
           OK = .FALSE.
          ENDIF
        ENDDO
      ENDDO
C
      RETURN
      END ! RUNCHK



      SUBROUTINE SYSMAT(IR,ASYS,BSYS,RSYS,NSYS)
C------------------------------------------------------------------
C     Computes system matrices for run case IR.
C     Current forces and derivatives are assumed to be correct.
C------------------------------------------------------------------
      INCLUDE 'AVL.INC'
      REAL*8 ASYS(JEMAX,JEMAX),BSYS(JEMAX,NDMAX),RSYS(JEMAX)
C
C
      LOGICAL LTERR
C
      REAL RINER(3,3),
     &     MAMAT(3,3),
     &     MAINV(3,3),
     &     RIMAT(3,3),
     &     RIINV(3,3),
     &     P(3), P_U(3,NUMAX),
     &     H(3), H_U(3,NUMAX),
     &     WXP(3), WXP_U(3,NUMAX),
     &     WXH(3), WXH_U(3,NUMAX),
     &     MIF(3), MIF_U(3,NUMAX), MIF_D(3,NDMAX),
     &     RIM(3), RIM_U(3,NUMAX), RIM_D(3,NDMAX),
     &     PRF(3), PRF_U(3,NUMAX),
     &     PRM(3), PRM_U(3,NUMAX)
C
      REAL ANG(3), TT(3,3), TT_ANG(3,3,3), RT(3,3), RT_ANG(3,3,3)
C
      INTEGER ICRS(3), JCRS(3)
      DATA ICRS / 2, 3, 1 / , JCRS / 3, 1, 2 /
C
C
C
      GEE = PARVAL(IPGEE,IR)
      RHO = PARVAL(IPRHO,IR)
      VEE = PARVAL(IPVEE,IR)
      PHI = PARVAL(IPPHI,IR)
      THE = PARVAL(IPTHE,IR)
      PSI = PARVAL(IPPSI,IR)
      XCG = PARVAL(IPXCG,IR)
      YCG = PARVAL(IPYCG,IR)
      ZCG = PARVAL(IPZCG,IR)
      RMASS = PARVAL(IPMASS,IR)
      RINER(1,1) = PARVAL(IPIXX,IR)
      RINER(2,2) = PARVAL(IPIYY,IR)
      RINER(3,3) = PARVAL(IPIZZ,IR)
      RINER(1,2) = PARVAL(IPIXY,IR)
      RINER(2,3) = PARVAL(IPIYZ,IR)
      RINER(3,1) = PARVAL(IPIZX,IR)
      RINER(2,1) = PARVAL(IPIXY,IR)
      RINER(3,2) = PARVAL(IPIYZ,IR)
      RINER(1,3) = PARVAL(IPIZX,IR)
C
      DCL_U = PARVAL(IPCLU,IR)
      DCM_U = PARVAL(IPCMU,IR)
      DCL_A = PARVAL(IPCLA,IR)
      DCM_A = PARVAL(IPCMA,IR)
C
      SINA = SIN(PARVAL(IPALFA,IR))
      COSA = COS(PARVAL(IPALFA,IR))
C
      LTERR = .FALSE.
      IF(VEE .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Velocity.  Specify with run file or M menu'
       LTERR = .TRUE.
      ENDIF
      IF(RMASS .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Mass.  Specify with mass file or M menu'
       LTERR = .TRUE.
      ENDIF
      IF(RINER(1,1) .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Ixx.  Specify with mass file or M menu'
       LTERR = .TRUE.
      ENDIF
      IF(RINER(2,2) .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Iyy.  Specify with mass file or M menu'
       LTERR = .TRUE.
      ENDIF
      IF(RINER(3,3) .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Izz.  Specify with mass file or M menu'
       LTERR = .TRUE.
      ENDIF
C
      IF(LTERR) THEN
       WRITE(*,*)
       WRITE(*,*) 'Eigenmodes not computed for run case', IR
       RETURN
      ENDIF
C
      SREFD = SREF*UNITL**2
      BREFD = BREF*UNITL
      CREFD = CREF*UNITL
C
      XYZREF(1) = XCG
      XYZREF(2) = YCG
      XYZREF(3) = ZCG
C
      QS  = 0.5*RHO*VEE**2 * SREFD
      QSM = QS/RMASS
C
      ROT = VEE/UNITL
C
C---- set mass and inertia tensors (real + apparent)
      DO K = 1, 3
        MAMAT(K,1) = AMASS(K,1)*RHO
        MAMAT(K,2) = AMASS(K,2)*RHO
        MAMAT(K,3) = AMASS(K,3)*RHO
        MAMAT(K,K) = MAMAT(K,K) + RMASS
C
        RIMAT(K,1) = RINER(K,1) + AINER(K,1)*RHO
        RIMAT(K,2) = RINER(K,2) + AINER(K,2)*RHO
        RIMAT(K,3) = RINER(K,3) + AINER(K,3)*RHO
      ENDDO
C
C---- invert mass and inertia tensors
      CALL M3INV(MAMAT,MAINV)
      CALL M3INV(RIMAT,RIINV)
C
C                         -   = -                        -   = -
C---- set linear momentum P = m V  and angular momentum  H = I W, in AVL axes
      DO K = 1, 3
        P(K) = -(  MAMAT(K,1)*VINF(1)
     &           + MAMAT(K,2)*VINF(2)
     &           + MAMAT(K,3)*VINF(3) )*VEE
        P_U(K,1) = -MAMAT(K,1)*VEE
        P_U(K,2) = -MAMAT(K,2)*VEE
        P_U(K,3) = -MAMAT(K,3)*VEE
        P_U(K,4) = 0.
        P_U(K,5) = 0.
        P_U(K,6) = 0.
C
        H(K) = (  RIMAT(K,1)*WROT(1)
     &          + RIMAT(K,2)*WROT(2)
     &          + RIMAT(K,3)*WROT(3) )*ROT
        H_U(K,1) = 0.
        H_U(K,2) = 0.
        H_U(K,3) = 0.
        H_U(K,4) = RIMAT(K,1)*ROT
        H_U(K,5) = RIMAT(K,2)*ROT
        H_U(K,6) = RIMAT(K,3)*ROT
      ENDDO
C
C---- set linear and angular momentum rates  WXP = W x P,   WXH = W x H
      DO K = 1, 3
        I = ICRS(K)
        J = JCRS(K)
        WXP(K) = (WROT(I)*P(J) - WROT(J)*P(I))*ROT
        WXH(K) = (WROT(I)*H(J) - WROT(J)*H(I))*ROT
C
        WXP_U(K,1) = (WROT(I)*P_U(J,1) - WROT(J)*P_U(I,1))*ROT
        WXP_U(K,2) = (WROT(I)*P_U(J,2) - WROT(J)*P_U(I,2))*ROT
        WXP_U(K,3) = (WROT(I)*P_U(J,3) - WROT(J)*P_U(I,3))*ROT
        WXP_U(K,4) = 0.
        WXP_U(K,5) = 0.
        WXP_U(K,6) = 0.
        WXP_U(K,I+3) = WXP_U(K,I+3) + P(J)*ROT
        WXP_U(K,J+3) = WXP_U(K,J+3) - P(I)*ROT
C
        WXH_U(K,1) = 0.
        WXH_U(K,2) = 0.
        WXH_U(K,3) = 0.
        WXH_U(K,4) = (WROT(I)*H_U(J,4) - WROT(J)*H_U(I,4))*ROT
        WXH_U(K,5) = (WROT(I)*H_U(J,5) - WROT(J)*H_U(I,5))*ROT
        WXH_U(K,6) = (WROT(I)*H_U(J,6) - WROT(J)*H_U(I,6))*ROT
        WXH_U(K,I+3) = WXH_U(K,I+3) + H(J)*ROT
        WXH_U(K,J+3) = WXH_U(K,J+3) - H(I)*ROT
      ENDDO
C
C          =    -   =    -   =     - -    =     - -
C---- set  m^-1 F,  I^-1 M,  m^-1 (WxP),  I^-1 (WxH)
      DO K = 1, 3
        MIF(K) = MAINV(K,1)*CXTOT*QS
     &         + MAINV(K,2)*CYTOT*QS
     &         + MAINV(K,3)*CZTOT*QS
        RIM(K) = RIINV(K,1)*CRTOT*QS*BREFD
     &         + RIINV(K,2)*CMTOT*QS*CREFD
     &         + RIINV(K,3)*CNTOT*QS*BREFD
        PRF(K) = MAINV(K,1)*WXP(1)
     &         + MAINV(K,2)*WXP(2)
     &         + MAINV(K,3)*WXP(3)
        PRM(K) = RIINV(K,1)*WXH(1)
     &         + RIINV(K,2)*WXH(2)
     &         + RIINV(K,3)*WXH(3)
        DO IU = 1, 6
          MIF_U(K,IU) = 
     &           MAINV(K,1)*CXTOT_U(IU)*QS
     &         + MAINV(K,2)*CYTOT_U(IU)*QS
     &         + MAINV(K,3)*CZTOT_U(IU)*QS
          RIM_U(K,IU) = 
     &           RIINV(K,1)*CRTOT_U(IU)*QS*BREFD
     &         + RIINV(K,2)*CMTOT_U(IU)*QS*CREFD
     &         + RIINV(K,3)*CNTOT_U(IU)*QS*BREFD
          PRF_U(K,IU) =
     &           MAINV(K,1)*WXP_U(1,IU)
     &         + MAINV(K,2)*WXP_U(2,IU)
     &         + MAINV(K,3)*WXP_U(3,IU)
          PRM_U(K,IU) =
     &           RIINV(K,1)*WXH_U(1,IU)
     &         + RIINV(K,2)*WXH_U(2,IU)
     &         + RIINV(K,3)*WXH_U(3,IU)
        ENDDO

        DO N = 1, NCONTROL
          MIF_D(K,N) = 
     &           MAINV(K,1)*CXTOT_D(N)*QS
     &         + MAINV(K,2)*CYTOT_D(N)*QS
     &         + MAINV(K,3)*CZTOT_D(N)*QS
          RIM_D(K,N) = 
     &           RIINV(K,1)*CRTOT_D(N)*QS*BREFD
     &         + RIINV(K,2)*CMTOT_D(N)*QS*CREFD
     &         + RIINV(K,3)*CNTOT_D(N)*QS*BREFD
        ENDDO
C
C------ add additional derivatives, from viscous or Mach effects, or whatever
        IU = 1
        MIF_U(K,IU) = MIF_U(K,IU)  -  MAINV(K,3)*DCL_U*QS
        RIM_U(K,IU) = RIM_U(K,IU)  -  RIINV(K,2)*DCM_U*QS*CREFD
C
        IU = 3
        MIF_U(K,IU) = MIF_U(K,IU)  +  MAINV(K,3)*DCL_A*QS
        RIM_U(K,IU) = RIM_U(K,IU)  +  RIINV(K,2)*DCM_A*QS*CREFD
C
      ENDDO
C
      ANG(1) = PHI*DTR
      ANG(2) = THE*DTR
      ANG(3) = PSI*DTR
      CALL ROTENS3(ANG,TT,TT_ANG)
      CALL RATEKI3(ANG,RT,RT_ANG)
C
      NSYS = 12
      DO IEQ = 1, NSYS
        DO JE = 1, NSYS
          ASYS(IEQ,JE) = 0.
        ENDDO
        DO N = 1, NCONTROL
          BSYS(IEQ,N) = 0.
        ENDDO
      ENDDO
C
C---- x-acceleration
      IEQ = JEU
      K = 1
      RSYS(IEQ)     =   MIF(K)     - PRF(K)      - GEE*TT(3,K)
      ASYS(IEQ,JEU) = -(MIF_U(K,1) - PRF_U(K,1)) / VEE
      ASYS(IEQ,JEV) = -(MIF_U(K,2) - PRF_U(K,2)) / VEE
      ASYS(IEQ,JEW) = -(MIF_U(K,3) - PRF_U(K,3)) / VEE
      ASYS(IEQ,JEP) =  (MIF_U(K,4) - PRF_U(K,4)) / ROT
      ASYS(IEQ,JEQ) =  (MIF_U(K,5) - PRF_U(K,5)) / ROT
      ASYS(IEQ,JER) =  (MIF_U(K,6) - PRF_U(K,6)) / ROT
      ASYS(IEQ,JEPH)=                            - GEE*TT_ANG(3,K,1)
      ASYS(IEQ,JETH)=                            - GEE*TT_ANG(3,K,2)
      ASYS(IEQ,JEPS)=                            - GEE*TT_ANG(3,K,3)
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =   MIF_D(K,N)
      ENDDO

c      MIF_U(1,2)
c      write(*,*)
c      write(*,*) '* 1u', MIF_U(K,2), PRF_U(K,2)

C
C---- y-acceleration
      IEQ = JEV
      K = 2
      RSYS(IEQ)     =   MIF(K)     - PRF(K)      - GEE*TT(3,K)
      ASYS(IEQ,JEU) = -(MIF_U(K,1) - PRF_U(K,1)) / VEE
      ASYS(IEQ,JEV) = -(MIF_U(K,2) - PRF_U(K,2)) / VEE
      ASYS(IEQ,JEW) = -(MIF_U(K,3) - PRF_U(K,3)) / VEE
      ASYS(IEQ,JEP) =  (MIF_U(K,4) - PRF_U(K,4)) / ROT
      ASYS(IEQ,JEQ) =  (MIF_U(K,5) - PRF_U(K,5)) / ROT
      ASYS(IEQ,JER) =  (MIF_U(K,6) - PRF_U(K,6)) / ROT
      ASYS(IEQ,JEPH)=                            - GEE*TT_ANG(3,K,1)
      ASYS(IEQ,JETH)=                            - GEE*TT_ANG(3,K,2)
      ASYS(IEQ,JEPS)=                            - GEE*TT_ANG(3,K,3)
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =   MIF_D(K,N)
      ENDDO
C
C---- z-acceleration
      IEQ = JEW
      K = 3
      RSYS(IEQ)     =   MIF(K)     - PRF(K)      - GEE*TT(3,K)
      ASYS(IEQ,JEU) = -(MIF_U(K,1) - PRF_U(K,1)) / VEE
      ASYS(IEQ,JEV) = -(MIF_U(K,2) - PRF_U(K,2)) / VEE
      ASYS(IEQ,JEW) = -(MIF_U(K,3) - PRF_U(K,3)) / VEE
      ASYS(IEQ,JEP) =  (MIF_U(K,4) - PRF_U(K,4)) / ROT
      ASYS(IEQ,JEQ) =  (MIF_U(K,5) - PRF_U(K,5)) / ROT
      ASYS(IEQ,JER) =  (MIF_U(K,6) - PRF_U(K,6)) / ROT
      ASYS(IEQ,JEPH)=                            - GEE*TT_ANG(3,K,1)
      ASYS(IEQ,JETH)=                            - GEE*TT_ANG(3,K,2)
      ASYS(IEQ,JEPS)=                            - GEE*TT_ANG(3,K,3)
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =   MIF_D(K,N)
      ENDDO
C
C---- x-ang.accel.
      IEQ = JEP
      K = 1
      RSYS(IEQ)     =   RIM(K)     - PRM(K)
      ASYS(IEQ,JEU) = -(RIM_U(K,1) - PRM_U(K,1)) / VEE
      ASYS(IEQ,JEV) = -(RIM_U(K,2) - PRM_U(K,2)) / VEE
      ASYS(IEQ,JEW) = -(RIM_U(K,3) - PRM_U(K,3)) / VEE
      ASYS(IEQ,JEP) =  (RIM_U(K,4) - PRM_U(K,4)) / ROT
      ASYS(IEQ,JEQ) =  (RIM_U(K,5) - PRM_U(K,5)) / ROT
      ASYS(IEQ,JER) =  (RIM_U(K,6) - PRM_U(K,6)) / ROT
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =   RIM_D(K,N)
      ENDDO
C
C---- y-ang.accel.
      IEQ = JEQ
      K = 2
      RSYS(IEQ)     =   RIM(K)     - PRM(K)
      ASYS(IEQ,JEU) = -(RIM_U(K,1) - PRM_U(K,1)) / VEE
      ASYS(IEQ,JEV) = -(RIM_U(K,2) - PRM_U(K,2)) / VEE
      ASYS(IEQ,JEW) = -(RIM_U(K,3) - PRM_U(K,3)) / VEE
      ASYS(IEQ,JEP) =  (RIM_U(K,4) - PRM_U(K,4)) / ROT
      ASYS(IEQ,JEQ) =  (RIM_U(K,5) - PRM_U(K,5)) / ROT
      ASYS(IEQ,JER) =  (RIM_U(K,6) - PRM_U(K,6)) / ROT
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =   RIM_D(K,N)
      ENDDO
C
C---- z-ang.accel.
      IEQ = JER
      K = 3
      RSYS(IEQ)     =   RIM(K)     - PRM(K)
      ASYS(IEQ,JEU) = -(RIM_U(K,1) - PRM_U(K,1)) / VEE
      ASYS(IEQ,JEV) = -(RIM_U(K,2) - PRM_U(K,2)) / VEE
      ASYS(IEQ,JEW) = -(RIM_U(K,3) - PRM_U(K,3)) / VEE
      ASYS(IEQ,JEP) =  (RIM_U(K,4) - PRM_U(K,4)) / ROT
      ASYS(IEQ,JEQ) =  (RIM_U(K,5) - PRM_U(K,5)) / ROT
      ASYS(IEQ,JER) =  (RIM_U(K,6) - PRM_U(K,6)) / ROT
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =   RIM_D(K,N)
      ENDDO
C
C---- phi rate
      IEQ = JEPH
      K = 1
      RSYS(IEQ)     = ROT*(  RT(K,1)*WROT(1)
     &                     + RT(K,2)*WROT(2)
     &                     + RT(K,3)*WROT(3) )
      ASYS(IEQ,JEP) =        RT(K,1)
      ASYS(IEQ,JEQ) =        RT(K,2)
      ASYS(IEQ,JER) =        RT(K,3)
      ASYS(IEQ,JEPH)= ROT*(  RT_ANG(K,1,1)*WROT(1)
     &                     + RT_ANG(K,2,1)*WROT(2)
     &                     + RT_ANG(K,3,1)*WROT(3) )
      ASYS(IEQ,JETH)= ROT*(  RT_ANG(K,1,2)*WROT(1)
     &                     + RT_ANG(K,2,2)*WROT(2)
     &                     + RT_ANG(K,3,2)*WROT(3) )
      ASYS(IEQ,JEPS)= ROT*(  RT_ANG(K,1,3)*WROT(1)
     &                     + RT_ANG(K,2,3)*WROT(2)
     &                     + RT_ANG(K,3,3)*WROT(3) )
C
C---- theta rate
      IEQ = JETH
      K = 2
      RSYS(IEQ)     = ROT*(  RT(K,1)*WROT(1)
     &                     + RT(K,2)*WROT(2)
     &                     + RT(K,3)*WROT(3) )
      ASYS(IEQ,JEP) =        RT(K,1)
      ASYS(IEQ,JEQ) =        RT(K,2)
      ASYS(IEQ,JER) =        RT(K,3)
      ASYS(IEQ,JEPH)= ROT*(  RT_ANG(K,1,1)*WROT(1)
     &                     + RT_ANG(K,2,1)*WROT(2)
     &                     + RT_ANG(K,3,1)*WROT(3) )
      ASYS(IEQ,JETH)= ROT*(  RT_ANG(K,1,2)*WROT(1)
     &                     + RT_ANG(K,2,2)*WROT(2)
     &                     + RT_ANG(K,3,2)*WROT(3) )
      ASYS(IEQ,JEPS)= ROT*(  RT_ANG(K,1,3)*WROT(1)
     &                     + RT_ANG(K,2,3)*WROT(2)
     &                     + RT_ANG(K,3,3)*WROT(3) )
C
C---- psi rate
      IEQ = JEPS
      K = 3
      RSYS(IEQ)     = ROT*(  RT(K,1)*WROT(1)
     &                     + RT(K,2)*WROT(2)
     &                     + RT(K,3)*WROT(3) )
      ASYS(IEQ,JEP) =        RT(K,1)
      ASYS(IEQ,JEQ) =        RT(K,2)
      ASYS(IEQ,JER) =        RT(K,3)
      ASYS(IEQ,JEPH)= ROT*(  RT_ANG(K,1,1)*WROT(1)
     &                     + RT_ANG(K,2,1)*WROT(2)
     &                     + RT_ANG(K,3,1)*WROT(3) )
      ASYS(IEQ,JETH)= ROT*(  RT_ANG(K,1,2)*WROT(1)
     &                     + RT_ANG(K,2,2)*WROT(2)
     &                     + RT_ANG(K,3,2)*WROT(3) )
      ASYS(IEQ,JEPS)= ROT*(  RT_ANG(K,1,3)*WROT(1)
     &                     + RT_ANG(K,2,3)*WROT(2)
     &                     + RT_ANG(K,3,3)*WROT(3) )
C
C---- x-velocity
      IEQ = JEX
      K = 1
      RSYS(IEQ)     = -(  TT(K,1)*VINF(1)
     &                  + TT(K,2)*VINF(2)
     &                  + TT(K,3)*VINF(3) )*VEE
      ASYS(IEQ,JEU) =     TT(K,1)
      ASYS(IEQ,JEV) =     TT(K,2)
      ASYS(IEQ,JEW) =     TT(K,3)
      ASYS(IEQ,JEPH)= -(  TT_ANG(K,1,1)*VINF(1)
     &                  + TT_ANG(K,2,1)*VINF(2)
     &                  + TT_ANG(K,3,1)*VINF(3) )*VEE
      ASYS(IEQ,JETH)= -(  TT_ANG(K,1,2)*VINF(1)
     &                  + TT_ANG(K,2,2)*VINF(2)
     &                  + TT_ANG(K,3,2)*VINF(3) )*VEE
      ASYS(IEQ,JEPS)= -(  TT_ANG(K,1,3)*VINF(1)
     &                  + TT_ANG(K,2,3)*VINF(2)
     &                  + TT_ANG(K,3,3)*VINF(3) )*VEE
C
C---- y-velocity
      IEQ = JEY
      K = 2
      RSYS(IEQ)     = -(  TT(K,1)*VINF(1)
     &                  + TT(K,2)*VINF(2)
     &                  + TT(K,3)*VINF(3) )*VEE
      ASYS(IEQ,JEU) =     TT(K,1)
      ASYS(IEQ,JEV) =     TT(K,2)
      ASYS(IEQ,JEW) =     TT(K,3)
      ASYS(IEQ,JEPH)= -(  TT_ANG(K,1,1)*VINF(1)
     &                  + TT_ANG(K,2,1)*VINF(2)
     &                  + TT_ANG(K,3,1)*VINF(3) )*VEE
      ASYS(IEQ,JETH)= -(  TT_ANG(K,1,2)*VINF(1)
     &                  + TT_ANG(K,2,2)*VINF(2)
     &                  + TT_ANG(K,3,2)*VINF(3) )*VEE
      ASYS(IEQ,JEPS)= -(  TT_ANG(K,1,3)*VINF(1)
     &                  + TT_ANG(K,2,3)*VINF(2)
     &                  + TT_ANG(K,3,3)*VINF(3) )*VEE
C
C---- z-velocity
      IEQ = JEZ
      K = 3
      RSYS(IEQ)     = -(  TT(K,1)*VINF(1)
     &                  + TT(K,2)*VINF(2)
     &                  + TT(K,3)*VINF(3) )*VEE
      ASYS(IEQ,JEU) =     TT(K,1)
      ASYS(IEQ,JEV) =     TT(K,2)
      ASYS(IEQ,JEW) =     TT(K,3)
      ASYS(IEQ,JEPH)= -(  TT_ANG(K,1,1)*VINF(1)
     &                  + TT_ANG(K,2,1)*VINF(2)
     &                  + TT_ANG(K,3,1)*VINF(3) )*VEE
      ASYS(IEQ,JETH)= -(  TT_ANG(K,1,2)*VINF(1)
     &                  + TT_ANG(K,2,2)*VINF(2)
     &                  + TT_ANG(K,3,2)*VINF(3) )*VEE
      ASYS(IEQ,JEPS)= -(  TT_ANG(K,1,3)*VINF(1)
     &                  + TT_ANG(K,2,3)*VINF(2)
     &                  + TT_ANG(K,3,3)*VINF(3) )*VEE
C
c      write(*,*) 'H  ', H
c      write(*,*) 'WxH', WXH
c      write(*,*) 'I-1 M  ', RIM
c      write(*,*) 'I-1 WxH', PRM
C
c      write(*,*) nzmax, nsys
C
      RETURN
      END ! SYSMAT




      SUBROUTINE APPMAT(IR,ASYS,BSYS,RSYS,NSYS)
C------------------------------------------------------------------
C     Computes system matrices for run case IR,
C     using the approximate expression in Etkin.
C
C     Current forces and derivatives are assumed to be correct.
C------------------------------------------------------------------
      INCLUDE 'AVL.INC'
      REAL*8 ASYS(JEMAX,JEMAX),BSYS(JEMAX,NDMAX),RSYS(JEMAX)
C
      LOGICAL LTERR
C
      REAL RINER(3,3),
     &     MAMAT(3,3),
     &     MAINV(3,3),
     &     RIMAT(3,3),
     &     RIINV(3,3),
     &     P(3), P_U(3,NUMAX),
     &     H(3), H_U(3,NUMAX),
     &     WXP(3), WXP_U(3,NUMAX),
     &     WXH(3), WXH_U(3,NUMAX),
     &     MIF(3), MIF_U(3,NUMAX), MIF_D(3,NDMAX),
     &     RIM(3), RIM_U(3,NUMAX), RIM_D(3,NDMAX),
     &     PRF(3), PRF_U(3,NUMAX),
     &     PRM(3), PRM_U(3,NUMAX)
C
      REAL ANG(3), TT(3,3), TT_ANG(3,3,3), RT(3,3), RT_ANG(3,3,3)
C
      INTEGER ICRS(3), JCRS(3)
      DATA ICRS / 2, 3, 1 / , JCRS / 3, 1, 2 /
C
C
C
      GEE = PARVAL(IPGEE,IR)
      RHO = PARVAL(IPRHO,IR)
      VEE = PARVAL(IPVEE,IR)
      PHI = PARVAL(IPPHI,IR)
      THE = PARVAL(IPTHE,IR)
      PSI = PARVAL(IPPSI,IR)
      XCG = PARVAL(IPXCG,IR)
      YCG = PARVAL(IPYCG,IR)
      ZCG = PARVAL(IPZCG,IR)
      RMASS = PARVAL(IPMASS,IR)
      RINER(1,1) = PARVAL(IPIXX,IR)
      RINER(2,2) = PARVAL(IPIYY,IR)
      RINER(3,3) = PARVAL(IPIZZ,IR)
      RINER(1,2) = PARVAL(IPIXY,IR)
      RINER(2,3) = PARVAL(IPIYZ,IR)
      RINER(3,1) = PARVAL(IPIZX,IR)
      RINER(2,1) = PARVAL(IPIXY,IR)
      RINER(3,2) = PARVAL(IPIYZ,IR)
      RINER(1,3) = PARVAL(IPIZX,IR)
C
      DCL_U = PARVAL(IPCLU,IR)
      DCM_U = PARVAL(IPCMU,IR)
      DCL_A = PARVAL(IPCLA,IR)
      DCM_A = PARVAL(IPCMA,IR)
C
      LTERR = .FALSE.
      IF(VEE .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Velocity.  Specify with run file or M menu'
       LTERR = .TRUE.
      ENDIF
      IF(RMASS .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Mass.  Specify with mass file or M menu'
       LTERR = .TRUE.
      ENDIF
      IF(RINER(1,1) .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Ixx.  Specify with mass file or M menu'
       LTERR = .TRUE.
      ENDIF
      IF(RINER(2,2) .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Iyy.  Specify with mass file or M menu'
       LTERR = .TRUE.
      ENDIF
      IF(RINER(3,3) .LE. 0.0) THEN
       WRITE(*,*)
       WRITE(*,*) '** Zero Izz.  Specify with mass file or M menu'
       LTERR = .TRUE.
      ENDIF
C
      IF(LTERR) THEN
       WRITE(*,*)
       WRITE(*,*) 'Eigenmodes not computed for run case', IR
       RETURN
      ENDIF
C
      SREFD = SREF*UNITL**2
      BREFD = BREF*UNITL
      CREFD = CREF*UNITL
C
      XYZREF(1) = XCG
      XYZREF(2) = YCG
      XYZREF(3) = ZCG
C
      QS  = 0.5*RHO*VEE**2 * SREFD
      QSM = QS/RMASS
C
      QSC = QS*CREFD
      QSB = QS*BREFD
C
      RINXX = RINER(1,1)
      RINYY = RINER(2,2)
      RINZZ = RINER(3,3)
C
C
      ROT = VEE/UNITL
C
C
      ANG(1) = PHI*DTR
      ANG(2) = THE*DTR
      ANG(3) = PSI*DTR
      CALL ROTENS3(ANG,TT,TT_ANG)
      CALL RATEKI3(ANG,RT,RT_ANG)
C
      NSYS = 12
      DO IEQ = 1, NSYS
        DO JE = 1, NSYS
          ASYS(IEQ,JE) = 0.
        ENDDO
        DO N = 1, NCONTROL
          BSYS(IEQ,N) = 0.
        ENDDO
      ENDDO
C
C---- x-acceleration
      IEQ = JEU
      ASYS(IEQ,JEU) = -CXTOT_U(1)*QS /RMASS / VEE
      ASYS(IEQ,JEW) = -CXTOT_U(3)*QS /RMASS / VEE
      ASYS(IEQ,JEQ) =  CXTOT_U(5)*QS /RMASS / ROT  +  VINF(3)*VEE
      ASYS(IEQ,JETH)=  GEE
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =  CXTOT_D(N)*QS /RMASS
      ENDDO
C
C---- z-acceleration
      IEQ = JEW
      ASYS(IEQ,JEU) = -CZTOT_U(1)*QS /RMASS / VEE
      ASYS(IEQ,JEW) = -CZTOT_U(3)*QS /RMASS / VEE
      ASYS(IEQ,JEQ) =  CZTOT_U(5)*QS /RMASS / ROT  -  VINF(1)*VEE
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =  CZTOT_D(N)*QS /RMASS
      ENDDO
C
C---- y-ang.accel.
      IEQ = JEQ
      ASYS(IEQ,JEU) = -CMTOT_U(1)*QSC/RINYY / VEE
      ASYS(IEQ,JEW) = -CMTOT_U(3)*QSC/RINYY / VEE
      ASYS(IEQ,JEQ) =  CMTOT_U(5)*QSC/RINYY / ROT
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =  CMTOT_D(N)*QSC/RINYY
      ENDDO
C
C---- theta rate
      IEQ = JETH
      ASYS(IEQ,JEQ) =  1.0
C
C
C
C---- y-acceleration
      IEQ = JEV
      ASYS(IEQ,JEV) = -CYTOT_U(2)*QS /RMASS / VEE
      ASYS(IEQ,JEP) =  CYTOT_U(4)*QS /RMASS / ROT  -  VINF(3)*VEE
      ASYS(IEQ,JER) =  CYTOT_U(6)*QS /RMASS / ROT  +  VINF(1)*VEE
      ASYS(IEQ,JEPH)=  GEE
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =  CYTOT_D(N)*QS /RMASS
      ENDDO
C
C---- x-ang.accel.
      IEQ = JEP
      ASYS(IEQ,JEV) = -CRTOT_U(2)*QSB/RINXX / VEE
      ASYS(IEQ,JEP) =  CRTOT_U(4)*QSB/RINXX / ROT
      ASYS(IEQ,JER) =  CRTOT_U(6)*QSB/RINXX / ROT
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =  CRTOT_D(N)*QSB/RINXX
      ENDDO
C
C---- z-ang.accel.
      IEQ = JER
      ASYS(IEQ,JEV) = -CNTOT_U(2)*QSB/RINZZ / VEE
      ASYS(IEQ,JEP) =  CNTOT_U(4)*QSB/RINZZ / ROT
      ASYS(IEQ,JER) =  CNTOT_U(6)*QSB/RINZZ / ROT
      DO N = 1, NCONTROL
        BSYS(IEQ,N) =  CNTOT_D(N)*QSB/RINZZ
      ENDDO
C
C---- phi rate
      IEQ = JEPH
      ASYS(IEQ,JEP) =  -1.0



C---- psi rate
      IEQ = JEPS
      K = 3
      RSYS(IEQ)     = ROT*(  RT(K,1)*WROT(1)
     &                     + RT(K,2)*WROT(2)
     &                     + RT(K,3)*WROT(3) )
      ASYS(IEQ,JEP) =        RT(K,1)
      ASYS(IEQ,JEQ) =        RT(K,2)
      ASYS(IEQ,JER) =        RT(K,3)
      ASYS(IEQ,JEPH)= ROT*(  RT_ANG(K,1,1)*WROT(1)
     &                     + RT_ANG(K,2,1)*WROT(2)
     &                     + RT_ANG(K,3,1)*WROT(3) )
      ASYS(IEQ,JETH)= ROT*(  RT_ANG(K,1,2)*WROT(1)
     &                     + RT_ANG(K,2,2)*WROT(2)
     &                     + RT_ANG(K,3,2)*WROT(3) )
      ASYS(IEQ,JEPS)= ROT*(  RT_ANG(K,1,3)*WROT(1)
     &                     + RT_ANG(K,2,3)*WROT(2)
     &                     + RT_ANG(K,3,3)*WROT(3) )
C
C---- x-velocity
      IEQ = JEX
      K = 1
      RSYS(IEQ)     = -(  TT(K,1)*VINF(1)
     &                  + TT(K,2)*VINF(2)
     &                  + TT(K,3)*VINF(3) )*VEE
      ASYS(IEQ,JEU) =     TT(K,1)
      ASYS(IEQ,JEV) =     TT(K,2)
      ASYS(IEQ,JEW) =     TT(K,3)
      ASYS(IEQ,JEPH)= -(  TT_ANG(K,1,1)*VINF(1)
     &                  + TT_ANG(K,2,1)*VINF(2)
     &                  + TT_ANG(K,3,1)*VINF(3) )*VEE
      ASYS(IEQ,JETH)= -(  TT_ANG(K,1,2)*VINF(1)
     &                  + TT_ANG(K,2,2)*VINF(2)
     &                  + TT_ANG(K,3,2)*VINF(3) )*VEE
      ASYS(IEQ,JEPS)= -(  TT_ANG(K,1,3)*VINF(1)
     &                  + TT_ANG(K,2,3)*VINF(2)
     &                  + TT_ANG(K,3,3)*VINF(3) )*VEE
C
C---- y-velocity
      IEQ = JEY
      K = 2
      RSYS(IEQ)     = -(  TT(K,1)*VINF(1)
     &                  + TT(K,2)*VINF(2)
     &                  + TT(K,3)*VINF(3) )*VEE
      ASYS(IEQ,JEU) =     TT(K,1)
      ASYS(IEQ,JEV) =     TT(K,2)
      ASYS(IEQ,JEW) =     TT(K,3)
      ASYS(IEQ,JEPH)= -(  TT_ANG(K,1,1)*VINF(1)
     &                  + TT_ANG(K,2,1)*VINF(2)
     &                  + TT_ANG(K,3,1)*VINF(3) )*VEE
      ASYS(IEQ,JETH)= -(  TT_ANG(K,1,2)*VINF(1)
     &                  + TT_ANG(K,2,2)*VINF(2)
     &                  + TT_ANG(K,3,2)*VINF(3) )*VEE
      ASYS(IEQ,JEPS)= -(  TT_ANG(K,1,3)*VINF(1)
     &                  + TT_ANG(K,2,3)*VINF(2)
     &                  + TT_ANG(K,3,3)*VINF(3) )*VEE
C
C---- z-velocity
      IEQ = JEZ
      K = 3
      RSYS(IEQ)     = -(  TT(K,1)*VINF(1)
     &                  + TT(K,2)*VINF(2)
     &                  + TT(K,3)*VINF(3) )*VEE
      ASYS(IEQ,JEU) =     TT(K,1)
      ASYS(IEQ,JEV) =     TT(K,2)
      ASYS(IEQ,JEW) =     TT(K,3)
      ASYS(IEQ,JEPH)= -(  TT_ANG(K,1,1)*VINF(1)
     &                  + TT_ANG(K,2,1)*VINF(2)
     &                  + TT_ANG(K,3,1)*VINF(3) )*VEE
      ASYS(IEQ,JETH)= -(  TT_ANG(K,1,2)*VINF(1)
     &                  + TT_ANG(K,2,2)*VINF(2)
     &                  + TT_ANG(K,3,2)*VINF(3) )*VEE
      ASYS(IEQ,JEPS)= -(  TT_ANG(K,1,3)*VINF(1)
     &                  + TT_ANG(K,2,3)*VINF(2)
     &                  + TT_ANG(K,3,3)*VINF(3) )*VEE
C
      RETURN
      END ! APPMAT



      SUBROUTINE SYSSHO(LU,ASYS,BSYS,RSYS,NSYS)
C------------------------------------------------------------------
C     Prints out state-system matrices "A" and "B" 
C     In an organized manner.
C------------------------------------------------------------------
      INCLUDE 'AVL.INC'
      REAL*8 ASYS(JEMAX,JEMAX),BSYS(JEMAX,NDMAX),RSYS(JEMAX)
      REAL*8 USGN(JEMAX)
C
      DO I = 1, NSYS
        USGN(I) = 1.0
      ENDDO
      USGN(JEU) = -1.0
      USGN(JEW) = -1.0
      USGN(JEP) = -1.0
      USGN(JER) = -1.0
      USGN(JEX) = -1.0
      USGN(JEZ) = -1.0
C
      WRITE(LU,*)
      WRITE(LU,1100)
     &'     u         w         q        the   ',
     &'     v         p         r        phi   ',
     &'     x         y         z        psi   ',
     & (DNAME(N), N=1, NCONTROL)
C      1234567890123456789012345678901234567890
 1100 FORMAT(1X,A,A,A,1X,'|',2X,12A12)
C
      DO I = 1, NSYS
        WRITE(LU,1200) 
     &     (ASYS(I,J)*USGN(I)*USGN(J), J=1, NSYS),
     &     (BSYS(I,N)*USGN(I)        , N=1, NCONTROL)
c     &   ,   RSYS(I)*USGN(I)
 1200   FORMAT(1X,12F10.4,3X,12G12.4)
      ENDDO
C
      RETURN
      END ! SYSSHO


      SUBROUTINE EIGSOL(INFO,IR,ETOL,ASYS,NSYS)
C------------------------------------------------------------------
C     Computes eigenvalues and eigenvectors for run case IR.
C     Current forces and derivatives are assumed to be correct.
C------------------------------------------------------------------
      INCLUDE 'AVL.INC'
      REAL*8 ASYS(JEMAX,JEMAX)
C
      REAL*8 WR(JEMAX),WI(JEMAX),WVEC(JEMAX,JEMAX)
      REAL*8 WORK(JEMAX)
      INTEGER IWORK(JEMAX)
      LOGICAL LTERR
C
C---- call EISPACK's Real/General eigenvalue routine
C     ICALC = 0   ! get eigenvalues only
      ICALC = 1   ! get eigenvalues and eigenvectors
      CALL RG(JEMAX,NSYS,ASYS,WR,WI,ICALC,WVEC,IWORK,WORK,IERR)
C
C-------------------------------------------------------
C---- store goodies
C
      VEE = PARVAL(IPVEE,IR)
      BREFD = BREF*UNITL
      ETOLSQ = (ETOL*VEE/BREFD)**2
C
      KEIG = 0
C
      DO 100 J=1, NSYS
C------ don't store eigenvalue smaller than tolerance
        EMAGSQ = WR(J)**2 + WI(J)**2
        IF(EMAGSQ .LT. ETOLSQ) GO TO 100
C
        KEIG = KEIG + 1
        EVAL(KEIG,IR) = CMPLX( WR(J), WI(J) )
C
        IF    (WI(J) .EQ. 0.0) THEN
C------- real eigenvalue... just store real eigenvector
         DO I = 1, NSYS
           EVR = WVEC(I,J)
           EVI = 0.
           EVEC(I,KEIG,IR) = CMPLX( EVR , EVI )
         ENDDO
C
        ELSEIF(WI(J) .GT. 0.0) THEN
C------- positive imaginary part of eigenvalue... store complex eigenvector
         JP1 = MIN( J+1 , NSYS )
         DO I = 1, NSYS
           EVR = WVEC(I,J)
           EVI = WVEC(I,JP1)
           EVEC(I,KEIG,IR) = CMPLX( EVR , EVI )
         ENDDO
C
        ELSEIF(WI(J) .LT. 0.0) THEN
C------- negative imaginary part of eigenvalue... store complex eigenvector
         JM = MAX( J-1 , 1 )
         DO I = 1, NSYS
           EVR =  WVEC(I,JM)
           EVI = -WVEC(I,J)
           EVEC(I,KEIG,IR) = CMPLX( EVR , EVI )
         ENDDO
        ENDIF
 100  CONTINUE
C
      NEIGEN(IR) = KEIG
C
      RETURN
      END ! EIGSOL



      SUBROUTINE RUNLST(LU,IRE)
      INCLUDE 'AVL.INC'
      CHARACTER*1 RSYM
C
      WRITE(LU,1050)
 1050 FORMAT(1X,' ')
      WRITE(LU,1100) '  run  ',
     &    PARNAM(IPALFA),
     &    PARNAM(IPBETA), 
     &    PARNAM(IPCL  ), 
     &    PARNAM(IPCD0 ), 
     &    PARNAM(IPPHI ), 
     &    PARNAM(IPVEE ), 
     &    PARNAM(IPRHO ), 
     &    PARNAM(IPRAD ),
     &    PARNAM(IPFAC ),
     &    PARNAM(IPXCG ),
     &    PARNAM(IPZCG ),
     &    PARNAM(IPMASS),
     &    PARNAM(IPIXX ),
     &    PARNAM(IPIYY ),
     &    PARNAM(IPIZZ ) 
C
      WRITE(LU,1100) '       ',
     &    PARUNCH(IPALFA),
     &    PARUNCH(IPBETA), 
     &    PARUNCH(IPCL  ), 
     &    PARUNCH(IPCD0 ), 
     &    PARUNCH(IPPHI ), 
     &    PARUNCH(IPVEE ), 
     &    PARUNCH(IPRHO ), 
     &    PARUNCH(IPRAD ),
     &    PARUNCH(IPFAC ),
     &    PARUNCH(IPXCG ),
     &    PARUNCH(IPZCG ),
     &    PARUNCH(IPMASS),
     &    PARUNCH(IPIXX ),
     &    PARUNCH(IPIYY ),
     &    PARUNCH(IPIZZ ) 
C
 1100 FORMAT(1X,A, 20(1X,A9))
C
      DO IR = 1, NRUN
        IF(IRE.EQ.IR .OR. IRE.EQ.0) THEN
         RSYM = '>'
        ELSE
         RSYM = ' '
        ENDIF
        WRITE(LU,1300) RSYM, IR, 
     &    PARVAL(IPALFA,IR),
     &    PARVAL(IPBETA,IR), 
     &    PARVAL(IPCL  ,IR), 
     &    PARVAL(IPCD0 ,IR), 
     &    PARVAL(IPPHI ,IR), 
     &    PARVAL(IPVEE ,IR), 
     &    PARVAL(IPRHO ,IR), 
     &    PARVAL(IPRAD ,IR),
     &    PARVAL(IPFAC ,IR),
     &    PARVAL(IPXCG ,IR),
     &    PARVAL(IPZCG ,IR),
     &    PARVAL(IPMASS,IR),
     &    PARVAL(IPIXX ,IR),
     &    PARVAL(IPIYY ,IR),
     &    PARVAL(IPIZZ ,IR) 
 1300   FORMAT(1X,A, I3, 2X, 20G10.3)
      ENDDO
C
      RETURN
      END ! RUNLST



      SUBROUTINE PARMOD(IRE)
      INCLUDE 'AVL.INC'
C
      CHARACTER*2 CNUM
C
      CHARACTER*4 COM
      CHARACTER*80 CARG, PROMPT, RTNEW
      LOGICAL ERROR, REPKEY
C
      INTEGER IINP(10)
      REAL RINP(10)
C
      IF(IRE.EQ.0) THEN
       IR = 1
      ELSE
       IR = IRE
      ENDIF
C
C
 1000 FORMAT(A)
C
 2000 FORMAT(/'     Parameters of run case ',A,':  ', A)
 2005 FORMAT( '     ', A
     &       /'     =================================================')
 2105 FORMAT(6X, A, G10.4, 2X, A)
 2110 FORMAT(6X, A, A )
C
C--------------------------------------------------------------------------
C----- jump back here just for menu
 10    CONTINUE
       CALL CFRAC(IR,NRUN,PROMPT,NPR)
       WRITE(*,2000) PROMPT(1:NPR),RTITLE(IR)
C
       PHI   = PARVAL(IPPHI ,IR)
       THE   = PARVAL(IPTHE ,IR)
       MACH  = PARVAL(IPMACH,IR)
       VEE   = PARVAL(IPVEE ,IR)
       RHO   = PARVAL(IPRHO ,IR)
       GEE   = PARVAL(IPGEE ,IR)
       RMASS = PARVAL(IPMASS,IR)
       RIXX  = PARVAL(IPIXX ,IR)
       RIYY  = PARVAL(IPIYY ,IR)
       RIZZ  = PARVAL(IPIZZ ,IR)
       XCG   = PARVAL(IPXCG ,IR)
       YCG   = PARVAL(IPYCG ,IR)
       ZCG   = PARVAL(IPZCG ,IR)
       CD0   = PARVAL(IPCD0 ,IR)
       DCL_A = PARVAL(IPCLA ,IR)
       DCL_U = PARVAL(IPCLU ,IR)
       DCM_A = PARVAL(IPCMA ,IR)
       DCM_U = PARVAL(IPCMU ,IR)
C
       WRITE(*,2105) 'B  bank      = ', PHI  , 'deg'
       WRITE(*,2105) 'E  elevation = ', THE  , 'deg'
       WRITE(*,2105) 'MN Mach no.  = ', MACH , ' '
       WRITE(*,2105) 'V  velocity  = ', VEE  , UNCHV(1:NUV)
       WRITE(*,2105) 'D  air dens. = ', RHO  , UNCHD(1:NUD)
       WRITE(*,2105) 'G  grav.acc. = ', GEE  , UNCHA(1:NUA)
       WRITE(*,2105) 'M  mass      = ', RMASS, UNCHM(1:NUM)
       WRITE(*,2105) 'IX Ixx       = ', RIXX , UNCHI(1:NUI)
       WRITE(*,2105) 'IY Iyy       = ', RIYY , UNCHI(1:NUI)
       WRITE(*,2105) 'IZ Izz       = ', RIZZ , UNCHI(1:NUI)
       WRITE(*,2105) 'X  X_cg      = ', XCG  , 'Lunit'
       WRITE(*,2105) 'Y  Y_cg      = ', YCG  , 'Lunit'
       WRITE(*,2105) 'Z  Z_cg      = ', ZCG  , 'Lunit'
       WRITE(*,2105) 'CD CDo       = ', CD0  , ' '
       WRITE(*,2105) 'LA dCL_a     = ', DCL_A, ' '
       WRITE(*,2105) 'LU dCL_u     = ', DCL_U, ' '
       WRITE(*,2105) 'MA dCM_a     = ', DCM_A, ' '
       WRITE(*,2105) 'MU dCM_u     = ', DCM_U, ' '
C
       CALL ASKC('     Enter parameter, value  (or  # - + N )',COM,CARG)
C
       IF(COM.EQ.'    ') THEN
C------ just a Return entered... go back
        RETURN
       ENDIF
C
C------------------------------------------------------
C---- check for run case commands
      IF(COM.EQ.'+   ') THEN
C----- add new case after current one
C
       IF(NRUN.EQ.NRMAX) THEN
        WRITE(*,*)
        WRITE(*,*) '* Run case array limit NRMAX reached'
       ELSE
        NRUN = NRUN + 1
C
        DO JR = NRUN, IR+1, -1
          CALL RCOPY(JR,JR-1)
        ENDDO
        WRITE(*,*) 'Initializing new run case from current one'
C        
        IR = IR + 1
       ENDIF
C
       GO TO 10
C
      ELSEIF(COM.EQ.'-   ') THEN
C----- delete current case
C
       IF(NRUN.LE.1) THEN
        WRITE(*,*)
        WRITE(*,*) '* Cannot delete one remaining run case'
       ELSE
        DO JR = IR, NRUN-1
          CALL RCOPY(JR,JR+1)
        ENDDO
        NRUN  = NRUN - 1
        IRUN  = MAX( 1 , MIN( IRUN  , NRUN ) )
        IRUNE = MAX( 1 , MIN( IRUNE , NRUN ) )
       ENDIF
C
       GO TO 10
C
      ENDIF
C
C------------------------------------------------------
C---- see if command is an integer (new run case selection)
      NINP = 1
      CALL GETINT(COM,IINP,NINP,ERROR)
      IF(.NOT.ERROR .AND. NINP.GE.1 
     &  .AND. COM(1:1).NE.'T'
     &  .AND. COM(1:1).NE.'F' ) THEN
C----- command is an integer... new case index?
       IF(IINP(1).LT.1 .OR. IINP(1).GT.NRUN) THEN
        WRITE(*,*)
        WRITE(*,*) '* Selected new run case is not defined'
        GO TO 10
       ELSE
C------ valid new run case selected... go back to top of menu
        IR = IINP(1)
        GO TO 10
       ENDIF
      ENDIF
C
C
C------------------------------------------------------
C---- extract argument, if any
      NINP = 1
      CALL GETFLT(CARG,RINP,NINP,ERROR)
C
C
      IF    (COM(1:1) .EQ. COM(2:2)) THEN
       REPKEY = .TRUE.
       IR1 = 1
       IR2 = NRUN
       COM(2:2) = ' '
      ELSEIF(COM(1:2) .EQ. COM(3:4)) THEN
       REPKEY = .TRUE.
       IR1 = 1
       IR2 = NRUN
       COM(3:4) = '  '
      ELSE
       REPKEY = .FALSE.
       IR1 = IR
       IR2 = IR
      ENDIF
C
C==============================================================================
C---- now decode regular parameter value commands
C
C------------------------------------
      IF(COM(1:2) .EQ. 'B ') THEN
 11     CONTINUE
        IF(NINP.GE.1) THEN
         PHI = RINP(1)
        ELSE
         CALL ASKR('      Enter bank angle^',PHI)
        ENDIF
C
        IF(PHI.LE.-90.0.OR.PHI.GE.90.0) THEN
         WRITE(*,*) '    * Must have  -90 < bank < +90'
         NINP = 0
         GO TO 11
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPPHI,JR) = PHI
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'E ') THEN
 21     CONTINUE
        IF(NINP.GE.1) THEN
         THE = RINP(1)
        ELSE
         CALL ASKR('      Enter elevation angle^',THE)
        ENDIF
C
        IF(THE.LE.-90.0.OR.THE.GE.90.0) THEN
         WRITE(*,*) '    * Must have  -90 < elevation < +90'
         NINP = 0
         GO TO 21
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPTHE,JR) = THE
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'MN') THEN
 24     CONTINUE
        IF(NINP.GE.1) THEN
         MACH = RINP(1)
        ELSE
         CALL ASKR('      Enter Mach number^',MACH)
        ENDIF
C
        IF(MACH .LT. 0.0 .OR. MACH .GT. 0.999) THEN
         WRITE(*,*) '    * Must have 0 < Mach < 0.999'
         GO TO 24
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPMACH,JR) = MACH
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'V ') THEN
 31     CONTINUE
        IF(NINP.GE.1) THEN
         VEE = RINP(1)
        ELSE
         CALL ASKR('      Enter velocity^',VEE)
        ENDIF
C
        IF(VEE.LE.0.0) THEN
         WRITE(*,*) '    * Must have  V > 0'
         NINP = 0
         GO TO 31
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPVEE,JR) = VEE
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'M ') THEN
 41     CONTINUE
        IF(NINP.GE.1) THEN
         RMASS = RINP(1)
        ELSE
         CALL ASKR('      Enter mass^',RMASS)
        ENDIF
C
        IF(RMASS.LE.0.0) THEN
         WRITE(*,*) '    * Must have  m > 0'
         NINP = 0
         GO TO 41
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPMASS,JR) = RMASS
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'IX') THEN
 42     CONTINUE
        IF(NINP.GE.1) THEN
         RIXX = RINP(1)
        ELSE
         CALL ASKR('      Enter Ixx^',RIXX)
        ENDIF
C
        IF(RIXX.LE.0.0) THEN
         WRITE(*,*) '    * Must have  Ixx > 0'
         NINP = 0
         GO TO 42
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPIXX,JR) = RIXX
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'IY') THEN
 43     CONTINUE
        IF(NINP.GE.1) THEN
         RIYY = RINP(1)
        ELSE
         CALL ASKR('      Enter Iyy^',RIYY)
        ENDIF
C
        IF(RIYY.LE.0.0) THEN
         WRITE(*,*) '    * Must have  Iyy > 0'
         NINP = 0
         GO TO 43
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPIYY,JR) = RIYY
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'IZ') THEN
 44     CONTINUE
        IF(NINP.GE.1) THEN
         RIZZ = RINP(1)
        ELSE
         CALL ASKR('      Enter Izz^',RIZZ)
        ENDIF
C
        IF(RIZZ.LE.0.0) THEN
         WRITE(*,*) '    * Must have  Izz > 0'
         NINP = 0
         GO TO 44
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPIZZ,JR) = RIZZ
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'D ') THEN
 51     CONTINUE
        IF(NINP.GE.1) THEN
         RHO = RINP(1)
        ELSE
         CALL ASKR('      Enter air density^',RHO)
        ENDIF
C
        IF(RHO.LE.0.0) THEN
         WRITE(*,*) '    * Must have  rho > 0'
         NINP = 0
         GO TO 51
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPRHO,JR) = RHO
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'G ') THEN
 61     CONTINUE
        IF(NINP.GE.1) THEN
         GEE = RINP(1)
        ELSE
         CALL ASKR('      Enter gravity^',GEE)
        ENDIF
C
        IF(GEE.LE.0.0) THEN
         WRITE(*,*) '    * Must have  g > 0'
         NINP = 0
         GO TO 61
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPGEE,JR) = GEE
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'X ') THEN
        IF(NINP.GE.1) THEN
         XCG = RINP(1)
        ELSE
         CALL ASKR('      Enter X_cg location^',XCG)
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPXCG,JR) = XCG
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'Y ') THEN
        IF(NINP.GE.1) THEN
         YCG = RINP(1)
        ELSE
         CALL ASKR('      Enter Y_cg location^',YCG)
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPYCG,JR) = YCG
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'Z ') THEN
        IF(NINP.GE.1) THEN
         ZCG = RINP(1)
        ELSE
         CALL ASKR('      Enter Z_cg location^',ZCG)
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPZCG,JR) = ZCG
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'CD') THEN
        IF(NINP.GE.1) THEN
         CD0 = RINP(1)
        ELSE
         CALL ASKR('      Enter profile CDo^',CD0)
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPCD0,JR) = CD0
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'LA') THEN
        IF(NINP.GE.1) THEN
         DCL_A = RINP(1)
        ELSE
         CALL ASKR('      Enter added CL_a^',DCL_A)
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPCLA,JR) = DCL_A
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'LU') THEN
        IF(NINP.GE.1) THEN
         DCL_U = RINP(1)
        ELSE
         CALL ASKR('      Enter added CL_u^',DCL_U)
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPCLU,JR) = DCL_U
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'MA') THEN
        IF(NINP.GE.1) THEN
         DCM_A = RINP(1)
        ELSE
         CALL ASKR('      Enter added CM_a^',DCM_A)
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPCMA,JR) = DCM_A
        ENDDO
C
C-------------------------------------
      ELSEIF(COM(1:2) .EQ. 'MU') THEN
        IF(NINP.GE.1) THEN
         DCM_U = RINP(1)
        ELSE
         CALL ASKR('      Enter added CM_u^',DCM_U)
        ENDIF
C
        DO JR = IR1, IR2
          PARVAL(IPCMU,JR) = DCM_U
        ENDDO
C
C------------------------------------------------------
      ELSEIF(COM(1:1) .EQ. 'N') THEN
C------ change name of run case
        IF(CARG.NE.' ') THEN
         RTITLE(IR) = CARG
        ELSE
         WRITE(*,830) RTITLE(IR)
 830     FORMAT(/' Enter run case name:  ', A)
         READ(*,1000) RTNEW
         IF(RTNEW.NE.' ') RTITLE(IR) = RTNEW
        ENDIF
C
      ELSE
        WRITE(*,*) '     * Unrecognized parameter'
C
      ENDIF
C
      IF(REPKEY) WRITE(*,*) '      Value set for all run cases'
      GO TO 10
C
      END ! PARMOD

C***********************************************************************
C    Module:  aoper.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE OPER
C---------------------------------------
C     Main driver routine for AVL
C---------------------------------------
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      LOGICAL ERROR, LCERR, LCERRI, LWRIT, LMATCH
C
      CHARACTER*1 ANS
      CHARACTER*2 OPT
      CHARACTER*4 COMAND, ITEMC
      CHARACTER*256 FNOUT, FNDER, FNNEW, FNVB
      CHARACTER*80 LINE, COMARG, CRUN, PROMPT, RTNEW
      CHARACTER*50 SATYPE, ROTTYPE
C
      LOGICAL LOWRIT
C
      REAL    RINPUT(20), RINP(20)
      INTEGER IINPUT(20), IINP(20)
C
      IF(.NOT.LGEO) THEN
       WRITE(*,*)
       WRITE(*,*) '* Configuration not defined'
       RETURN
      ENDIF
C
C
      FNVB = ' '
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
      IF(LSA_RATES) THEN
        ROTTYPE = 'Rates,moments about Stability axes'
       ELSE
        ROTTYPE = 'Rates,moments about Body axes'
      ENDIF
C
 1000 FORMAT (A)
C
      LPLOT = .FALSE.
      LWRIT = .FALSE.
      LSOL  = .FALSE.
C
      FNOUT = ' '
C
C=================================================================
C---- start of user interaction loop
 800  CONTINUE
C
      LCERR = .FALSE.
C
C
      CALL CFRAC(IRUN,NRUN,CRUN,NPR)
C
      WRITE(*,1050) CRUN(1:NPR), RTITLE(IRUN)
      CALL CONLST(IRUN)
      WRITE(*,1052)
C
 1050 FORMAT(
     &  /' Operation of run case ',A,':  ', A
     &  /' ==========================================================')
C
 1052 FORMAT(
     &  /'  C1  set level or banked  horizontal flight constraints'
     &  /'  C2  set steady pitch rate (looping) flight constraints'
     &  /'  M odify parameters                                    '
     & //' "#" select  run case          L ist defined run cases   '
     &  /'  +  add new run case          S ave run cases to file   '
     &  /'  -  delete  run case          F etch run cases from file'
     &  /'  N ame current run case       W rite forces to file     '
     & //' eX ecute run case             I nitialize variables     '
     & //'  G eometry plot               T refftz Plane plot       '
     & //'  ST  stability derivatives    FT  total   forces        '
     &  /'  SB  body-axis derivatives    FN  surface forces        '
     &  /'  RE  reference quantities     FS  strip   forces        '
     &  /'  DE  design changes           FE  element forces        '
     &  /'  O ptions                     FB  body forces           '
     &  /'                               HM  hinge moments         '
     &  /'                               VM  strip shear,moment    ')
C 
C   A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
C   x x x x   x x   x     x x x x x   x x x   x x x x

 810  CONTINUE
      PROMPT = ' .OPER (case ' // CRUN(1:NPR) // ')^'
      CALL ASKC(PROMPT,COMAND,COMARG)
C
C------------------------------------------------------
      IF    (COMAND.EQ.'    ') THEN
       IF(LPLOT) CALL PLEND
       LPLOT = .FALSE.
       CALL CLRZOOM
       RETURN
C
      ELSEIF(COMAND.EQ.'?   ') THEN
       GO TO 800
C
      ENDIF
C
C------------------------------------------------------
C---- check for run case commands
      IF(COMAND.EQ.'+   ') THEN
C----- add new case after current one
C
       IF(NRUN.EQ.NRMAX) THEN
        WRITE(*,*)
        WRITE(*,*) '* Run case array limit NRMAX reached'
       ELSE
        NRUN = NRUN + 1
C
        DO JR = NRUN, IRUN+1, -1
          CALL RCOPY(JR,JR-1)
        ENDDO
        WRITE(*,*) 'Initializing new run case from current one'
C        
        IRUN = IRUN + 1
       ENDIF
C
       GO TO 800
C
      ELSEIF(COMAND.EQ.'-   ') THEN
C----- delete current case
C
       IF(NRUN.LE.1) THEN
        WRITE(*,*)
        WRITE(*,*) '* Cannot delete one remaining run case'
       ELSE
        DO JR = IRUN, NRUN-1
          CALL RCOPY(JR,JR+1)
        ENDDO
        NRUN  = NRUN - 1
        IRUN  = MAX( 1 , MIN( IRUN  , NRUN ) )
        IRUNE = MAX( 1 , MIN( IRUNE , NRUN ) )
       ENDIF
C
       GO TO 800
C
      ENDIF
C
C------------------------------------------------------
C---- first check if point index was input
      IF(INDEX('0123456789',COMAND(1:1)) .NE. 0) THEN
        READ(COMAND,*,ERR=8) IRUN
        IF(IRUN.LT.1 .OR. IRUN.GT.NRUN) THEN
         IRUN = MAX( 1 , MIN(NRUN,IRUN) )
         WRITE(*,*) '* Run case index was limited to available range'
        ENDIF
        GO TO 800
C
 8      WRITE(*,*) '* Invalid command: ', COMAND
        GO TO 800
      ENDIF
C
C------------------------------------------------------
C---- extract command line numeric arguments
      DO I=1, 20
        IINPUT(I) = 0
        RINPUT(I) = 0.0
      ENDDO
      NINPUT = 20
      CALL GETINT(COMARG,IINPUT,NINPUT,ERROR)
      NINPUT = 20
      CALL GETFLT(COMARG,RINPUT,NINPUT,ERROR)
C
 14   CONTINUE
C------------------------------------------------------
C---- check for parameter toggle/set command
      CALL CONSET(COMAND,COMARG,LMATCH,IRUN)
C
      IF(LMATCH) THEN
C----- match found... go back to OPER menu
       GO TO 800
      ENDIF
C
C------------------------------------------------------
C---- check for trim set command
      CALL TRMSET(COMAND,COMARG,LMATCH,IRUN)
C
      IF(LMATCH) THEN
C----- match found... go back to OPER menu
       GO TO 800
      ENDIF
C
C------------------------------------------------------
C---- pick up here to try decoding for remaining commands
C
      IF(COMAND .EQ. 'X   ') THEN
C------ execute calculation
        IF(LCERR) THEN
         WRITE(*,*) '** Flow solution is not possible.'
         WRITE(*,*) '** Cannot impose a constraint more than once.'
         GO TO 800
        ENDIF
C
        IRUN0 = IRUN
C
        XYZREF(1) = PARVAL(IPXCG,IRUN)
        XYZREF(2) = PARVAL(IPYCG,IRUN)
        XYZREF(3) = PARVAL(IPZCG,IRUN)
        CDREF     = PARVAL(IPCD0,IRUN)
C
        INFO = 1
        CALL EXEC(NITMAX,INFO,IRUN)
        IF(.NOT.LSOL) GO TO 810
C
        IF(LPTOT)   CALL OUTTOT(6)
        IF(LPSURF)  CALL OUTSURF(6)
        IF(LPSTRP)  CALL OUTSTRP(6)
        IF(LPELE)   CALL OUTELE(6)
        IF(LPHINGE) CALL OUTHINGE(6)
C
C------------------------------------------------------
      ELSEIF(COMAND .EQ. 'XX  ') THEN
C------ execute calculation for all run cases
        DO 24 IR = 1, NRUN
C-------- check for well-posedness
          LCERRI = .FALSE.
          DO IV = 1, NVTOT
            IC = ICON(IV,IR)
            DO JV = 1, NVTOT
              IF(IV.NE.JV .AND. ICON(IV,IR).EQ.ICON(JV,IR)) THEN
               LCERRI = .TRUE.
              ENDIF
            ENDDO
          ENDDO
          IF(LCERRI) THEN
           WRITE(*,*) '** Run case', IR,' ...'
           WRITE(*,*) '** Flow solution is not possible.'
           WRITE(*,*) '** Cannot impose a constraint more than once.'
           GO TO 24          
          ENDIF
C
          INFO = 1
          CALL EXEC(NITMAX,INFO,IR)
          IF(.NOT.LSOL) GO TO 24
C
          IF(LPTOT)  CALL OUTTOT(6)
          IF(LPSURF) CALL OUTSURF(6)
          IF(LPSTRP) CALL OUTSTRP(6)
          IF(LPELE)  CALL OUTELE(6)
          IF(LPHINGE) CALL OUTHINGE(6)
 24     CONTINUE
C
C------------------------------------------------------
      ELSEIF(COMAND .EQ. 'M   ') THEN
        CALL PARMOD(IRUN)
C
C------------------------------------------------------
      ELSEIF(COMAND .EQ. 'N   ') THEN
C------ change name of run case
        IF(COMARG.NE.' ') THEN
         RTITLE(IRUN) = COMARG
        ELSE
         WRITE(*,830) RTITLE(IRUN)
 830     FORMAT(/' Enter run case name:  ', A)
         READ(*,1000) RTNEW
         IF(RTNEW.NE.' ') RTITLE(IRUN) = RTNEW
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'DE  ') THEN
C------ design changes
        IF(NDESIGN.EQ.0) THEN
         WRITE(*,*) '* No design parameters are declared'
         GO TO 810
        ENDIF
C
 30     CONTINUE
        WRITE(*,1036)
        DO K = 1, NDESIGN
          WRITE(*,1037) K, GNAME(K), DELDES(K)
        ENDDO
 1036   FORMAT(/' ================================================'
     &         /' Current design parameter changes:' /
     &         /'    k   Parameter      change')
CCC              x1234xxx123456789012345612345678901234
 1037   FORMAT(1X, I4,3X, A, G14.5) 
C
        WRITE(*,*)
 35     WRITE(*,*) 'Enter  k, design changes (<return> if done) ...'
 37     READ (*,1000) LINE
        CALL STRIP(LINE,NLIN)
        IF(LINE(1:1).EQ.'?') GO TO 30
        IF(LINE(1:1).EQ.' ') GO TO 800
C
        NINP = 40
        CALL GETFLT(LINE,RINP,NINP,ERROR)
        IF(ERROR) THEN
         WRITE(*,*) '* Bad input'
         GO TO 35
        ENDIF
C
        DO I = 1, NINP, 2
          N = INT(RINP(I))
          IF(N.LT.1 .OR. N.GT.NDESIGN) THEN
           WRITE(*,*) 'Index k out of bounds. Input ignored.'
          ENDIF
          DELDES(N) = RINP(I+1)
          LSOL = .FALSE.
          GO TO 37
        ENDDO
        GO TO 30
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'I   ') THEN
C------ clear operating parameters
        ALFA = 0.
        BETA = 0.
        WROT(1) = 0.
        WROT(2) = 0.
        WROT(3) = 0.
C
        DO N = 1, NCONTROL
          DELCON(N) = 0.
        ENDDO
C
        DO N = 1, NDESIGN
          DELDES(N) = 0.
        ENDDO
C
        LSOL = .FALSE.
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'G   ') THEN
C------ plot geometry
        CALL PLOTVL(AZIMOB, ELEVOB, TILTOB, ROBINV)
        LPLOT = .TRUE.
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'T   ') THEN
C------ plot spanloadings in Trefftz plane
        CALL PLOTTP
        LPLOT = .TRUE.
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'FT  ') THEN
C------ print total forces
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL OUTTOT(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'FN  ') THEN
C------ print surface forces
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL OUTSURF(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'FS  ') THEN
C------ print strip forces
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL OUTSTRP(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'FE  ') THEN
C------ print vortex element forces
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL OUTELE(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'FB  ') THEN
C------ print body forces
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL OUTBODY(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'HM  ') THEN
C------ print hinge moments
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL OUTHINGE(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'VM  ') THEN
C------ calculate and print shear and bending on surfaces
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL OUTVM(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'CN  ') THEN
C------ print a spanloading file
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL OUTCNC(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'L   ') THEN
C------ list run cases
        LU = 6
        CALL RUNSAV(LU)
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'S   ') THEN
C------ save run case file
        CALL STRIP(FRNDEF,NFR)
        WRITE(*,2040) FRNDEF(1:NFR)
 2040   FORMAT(' Enter run case filename: ', A)
        READ (*,1000) FNNEW
C
        IF(FNNEW.NE.' ') FRNDEF = FNNEW
        OPEN(LURUN,FILE=FRNDEF,STATUS='OLD',ERR=42)
C
        IF(LOWRIT(FRNDEF)) THEN
         REWIND(LURUN)
         GO TO 45
        ELSE
         WRITE(*,*) 'Run cases not saved'
         GO TO 810
        ENDIF
C
 42     OPEN(LURUN,FILE=FRNDEF,STATUS='NEW')
C
 45     CALL RUNSAV(LURUN)
        CLOSE(LURUN)
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'F   ') THEN
C------ fetch run case file
        CALL STRIP(FRNDEF,NFR)
        WRITE(*,2050) FRNDEF(1:NFR)
 2050   FORMAT(' Enter run case filename: ', A)
        READ (*,1000) FNNEW
        IF(FNNEW.NE.' ') FRNDEF = FNNEW
C
        CALL RUNGET(LURUN,FRNDEF,ERROR)
        IF(ERROR) THEN
         GO TO 810
        ELSE
         WRITE(*,2055) (IR, RTITLE(IR), IR=1, NRUN)
 2055    FORMAT(' Run cases read in ...',
     &          100(/1X,I4,': ',A))
        ENDIF
C
        IRUN = MIN( IRUN, NRUN )
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'ST  ') THEN
C------ create stability derivatives
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL DERMATS(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'SM  ') THEN
C------ create stability derivatives
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL DERMATM(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'SB  ') THEN
C------ create stability derivatives
        IF(LSOL) THEN
         CALL GETFILE(LU,COMARG)
C
         IF(LU.LE.-1) THEN
          WRITE(*,*) '* Filename error *'
         ELSEIF(LU.EQ.0) THEN
          WRITE(*,*) '* Data not written'
         ELSE
          CALL DERMATB(LU)
          IF(LU.NE.5 .AND. LU.NE.6) CLOSE(LU)
         ENDIF
C
        ELSE
         WRITE(*,*) '* Execute flow calculation first!'
        ENDIF
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'W   ') THEN
C------ write force  data to a file
        CALL STRIP(FNOUT,NFN)
        WRITE(*,1080) FNOUT(1:NFN)
 1080   FORMAT('Enter forces output file: ', A)
        READ (*,1000) FNNEW
C
        IF(FNNEW.NE.' ') THEN
C-------- new filename was entered...
C-------- if previous file is open, close it
          IF(LWRIT) CLOSE(LUOUT)
          FNOUT = FNNEW
C-------- open new file and write header
          OPEN(LUOUT,FILE=FNOUT,STATUS='UNKNOWN')
          LWRIT = .TRUE.
C
        ELSE
C-------- just a <return> was entered...
          IF(.NOT.LWRIT) THEN
            WRITE(*,*) 'No action taken.'
            GO TO 800
          ENDIF
C
        ENDIF
C
        IF(LPTOT)   CALL OUTTOT(LUOUT)
        IF(LPSURF)  CALL OUTSURF(LUOUT)
        IF(LPSTRP)  CALL OUTSTRP(LUOUT)
        IF(LPELE)   CALL OUTELE(LUOUT)
ccc     IF(LPDERIV) CALL DERMAT(LUOUT)
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'RE  ') THEN
C------ Change reference data 
 89     WRITE(*,2090) SREF,CREF,BREF
 2090   FORMAT(/' ==========================='
     &         /'  S ref: ', G11.5,
     &         /'  C ref: ', G11.5,
     &         /'  B ref: ', G11.5 )
C
 90     CALL ASKC(' Select item,value^',ITEMC,COMARG)
 2100   FORMAT(' Enter new ',A,': ', $)
C
        IF(ITEMC.EQ.'    ') THEN
          GO TO 800
        ENDIF
C
        NINP = 1
        CALL GETFLT(COMARG,RINP,NINP,ERROR)
C
        IF    (INDEX('Ss',ITEMC(1:1)).NE.0) THEN
          IF(NINP.EQ.0) THEN
 91        WRITE(*,2100) 'reference area Sref'
           READ (*,*,ERR=91) SREF
          ELSE
           SREF = RINP(1)
          ENDIF
          LSOL = .FALSE.
C
        ELSEIF(INDEX('Cc',ITEMC(1:1)).NE.0) THEN
          IF(NINP.EQ.0) THEN
 92        WRITE(*,2100) 'reference chord Cref'
           READ (*,*,ERR=92) CREF
          ELSE
           CREF = RINP(1)
          ENDIF
          LSOL = .FALSE.
C
        ELSEIF(INDEX('Bb',ITEMC(1:1)).NE.0) THEN
          IF(NINP.EQ.0) THEN
 93        WRITE(*,2100) 'reference span Bref'
           READ (*,*,ERR=93) BREF
          ELSE
           BREF = RINP(1)
          ENDIF
          LSOL = .FALSE.
C
        ELSE
          WRITE(*,*) 'Item not recognized'
          GO TO 89
C
        ENDIF
        GO TO 89
C
C------------------------------------------------------
      ELSE IF(COMAND.EQ.'O   ') THEN
        CALL OPTGET


C------------------------------------------------------
      ELSE
        WRITE(*,*)
        WRITE(*,*) '* Option not recognized'
C
      ENDIF
      GO TO 800
C
      END ! OPER




      SUBROUTINE CONLST(IR)
      INCLUDE 'AVL.INC'
C
      CHARACTER*4 CHSS
C
      WRITE(*,1010)
C
      DO IV = 1, NVTOT
        IC = ICON(IV,IR)
        CHSS = '  '
        DO JV = 1, NVTOT
          IF(IV.NE.JV .AND. ICON(IV,IR).EQ.ICON(JV,IR)) THEN
           CHSS = '**'
          ENDIF
        ENDDO
        WRITE(*,1020) VARKEY(IV), CONNAM(IC), CONVAL(IC,IR), CHSS
      ENDDO
C
      WRITE(*,1030)
      RETURN
C      
 1010 FORMAT(
     &  /'  variable          constraint              '
     &  /'  ------------      ------------------------')
 10200 FORMAT(
     &   '  ',A,'  ->  ', A, '=', G12.4, 1X, A)
 1030 FORMAT(
     &   '  ------------      ------------------------')
      END ! CONLST



      SUBROUTINE CONSET(COMAND,COMARG,LMATCH,IR)
      INCLUDE 'AVL.INC'
      CHARACTER*(*) COMAND, COMARG
      LOGICAL LMATCH
C
      CHARACTER*80 PROMPT
      CHARACTER*4 ARROW
      REAL    RINP(20)
      INTEGER IINP(20)
      LOGICAL ERROR
C
C---- for control variable, first number in arg string should be part of command
      IF(COMAND(1:2) .EQ. 'D ') THEN
       COMAND(2:3) = COMARG(1:2)
       COMARG(1:2) = '  '
       CALL STRIP(COMARG,NARG)
      ENDIF
C
C---- length of non-blank part of command, if any
      KCLEN = INDEX(COMAND,' ') - 1
      IF(KCLEN.LE.0) KCLEN = LEN(COMAND)
C
C---- test command against variable keys, using only non-blank part of command
      DO IV = 1, NVTOT
        KVLEN = INDEX(VARKEY(IV),' ') - 1
        IF(KCLEN .EQ. KVLEN .AND.
     &     COMAND(1:KCLEN) .EQ. VARKEY(IV)(1:KVLEN)) GO TO 16
      ENDDO
C
C---- no variable key matched... go test for regular commands
      LMATCH = .FALSE.
      RETURN
C
C------------------------------------------------------
C---- found a variable-key match!
 16   CONTINUE
      LMATCH = .TRUE.
      CALL TOUPER(COMARG) 
C
C---- see if constraint was already specified as second command argument
      KCLEN = INDEX(COMARG,' ') - 1
      IF(KCLEN.LE.0) KCLEN = LEN(COMARG)
      KCLEN = MIN( KCLEN , LEN(CONKEY(1)) )
      DO IC = 1, NCTOT
        IF(COMARG(1:KCLEN) .EQ. CONKEY(IC)(1:KCLEN)) GO TO 18
      ENDDO
C
C---- constraint not given... get it from constraint-selection menu
      WRITE(*,1081)
      DO IC = 1, NCTOT
        IF(IC.EQ.ICON(IV,IR)) THEN
         ARROW = '->  '
        ELSE
         ARROW = '    '
        ENDIF
        WRITE(*,1082) ARROW, CONKEY(IC), CONNAM(IC), CONVAL(IC,IR)
      ENDDO
 1081 FORMAT(/'       constraint            value     '
     &       /'      - - - - - - - - - - - - - - - - -')
 1082 FORMAT( '   ', A, A, 2X, A, '=', G12.4)
C
      PROMPT= '      Select new  constraint,value  for '
     &        // VARNAM(IV) // '^'
      CALL ASKC(PROMPT,COMAND,COMARG)
      IF(COMAND.EQ.' ') RETURN
C
      IF(COMAND(1:2) .EQ. 'D ') THEN
       COMAND(2:3) = COMARG(1:2)
       COMARG(1:2) = '  '
       CALL STRIP(COMARG,NARG)
      ENDIF
C
C---- try to parse command again
      COMARG = COMAND(1:3) // ' ' // COMARG
      GO TO 16
C
C----------------------------------
C---- pick up here to set new constraint
 18   CONTINUE
C
C---- set new constraint index for selected variable IV
      ICON(IV,IR) = IC
C
C---- see if constraint value was already specified in command argument
      NINP = 1
      CALL GETFLT(COMARG(KCLEN+1:80),RINP,NINP,ERROR)
      IF(ERROR) NINP = 0
C
      IF(NINP.GE.1) THEN
C----- yep...  set constraint value to command argument
       CONVAL(IC,IR) = RINP(1)
      ELSE
C----- nope... get constraint value from user (current value is the default)
 19    WRITE(*,1090) CONNAM(IC), CONVAL(IC,IR)
 1090  FORMAT(/' Enter specified ', A,':', G12.4)
       CALL READR(1,CONVAL(IC,IR),ERROR)
       IF(ERROR) GO TO 19
      ENDIF
C
C---- go back to OPER menu
      RETURN
      END ! CONSET





      SUBROUTINE EXEC(NITER,INFO,IR)
C---------------------------------------------------
C     Solves for the flow condition specified by 
C     the global operating parameters:
C
C       CONVAL(ICALFA)     alpha (deg)
C       CONVAL(ICBETA)     beta  (deg)
C       CONVAL(ICROTX)     roll_rate * Bref / 2V
C       CONVAL(ICROTY)    pitch_rate * Cref / 2V
C       CONVAL(ICROTZ)      yaw_rate * Bref / 2V
C        .
C        .
C
C---------------------------------------------------
      INCLUDE 'AVL.INC'
      REAL VSYS(IVMAX,IVMAX), VRES(IVMAX), DDC(NDMAX), WORK(IVMAX)
      INTEGER IVSYS(IVMAX)
C
C---- convergence epsilon, max angle limit (radians)
      DATA EPS, DMAX / 0.00002, 1.0 /
C
      IF(LNASA_SA) THEN
C----- NASA Std. Stability axes, X fwd, Z down
       DIR = -1.0
      ELSE
C----- Geometric Stability axes, X aft, Z up
       DIR =  1.0
      ENDIF
C
      XYZREF(1) = PARVAL(IPXCG,IR)
      XYZREF(2) = PARVAL(IPYCG,IR)
      XYZREF(3) = PARVAL(IPZCG,IR)
C
      CDREF = PARVAL(IPCD0,IR)
C
      MACH = PARVAL(IPMACH,IR)
C
      IF(MACH.NE.AMACH) THEN
C----- new Mach number invalidates close to everything that's stored
       LAIC = .FALSE.
       LSRD = .FALSE.
       LSOL = .FALSE.
       LSEN = .FALSE.
      ENDIF
C
C---- set, factor AIC matrix and induced-velocity matrix (if they don't exist)
      CALL SETUP
C
      IF(NITER.GT.0) THEN
C----- might as well directly set operating variables if they are known
       IF(ICON(IVALFA,IR).EQ.ICALFA) ALFA    = CONVAL(ICALFA,IR)*DTR
       IF(ICON(IVBETA,IR).EQ.ICBETA) BETA    = CONVAL(ICBETA,IR)*DTR
       IF(ICON(IVROTX,IR).EQ.ICROTX) WROT(1) = CONVAL(ICROTX,IR)*2./BREF
       IF(ICON(IVROTY,IR).EQ.ICROTY) WROT(2) = CONVAL(ICROTY,IR)*2./CREF
       IF(ICON(IVROTZ,IR).EQ.ICROTZ) WROT(3) = CONVAL(ICROTZ,IR)*2./BREF
      ENDIF
C
C----- set GAM_U
ccc       WRITE(*,*) ' Solving for unit-freestream vortex circulations...'
      CALL GUCALC
C
C-------------------------------------------------------------
C---- calculate initial operating state
C
C---- set VINF() vector from initial ALFA,BETA
      CALL VINFAB
C
c      IF(NCONTROL.GT.0) THEN
cC----- set GAM_D
cccc       WRITE(*,*) ' Solving for vortex control-var sensitivities...'
c       CALL GDCALC(NCONTROL,LCONDEF,ENC_D,GAM_D)
c      ENDIF
C
c      IF(NDESIGN.GT.0) THEN
cC----- set GAM_G
cccc       WRITE(*,*) ' Solving for vortex  design-var sensitivities...'
c       CALL GDCALC(NDESIGN ,LDESDEF,ENC_G,GAM_G)
c      ENDIF
C
C---- sum AIC matrices to get GAM,SRC,DBL
      CALL GAMSUM
C
C---- sum AIC matrices to get WC,WV
      CALL VELSUM
C
C---- compute forces
      CALL AERO
C
C---- Newton loop for operating variables
      DO 190 ITER = 1, NITER
C
        IF(LSA_RATES) THEN
C-------- rates specified in NASA stability-axes, transform to body axes
          CA = COS(ALFA)
          SA = SIN(ALFA)
          CA_A = -SA
          SA_A =  CA
         ELSE
C-------- rates specified in body-axes, no transformation
          CA = 1.0
          SA = 0.0
          CA_A = 0.
          SA_A = 0.
        ENDIF
C
        DO K=1, IVMAX
          DO L=1, IVMAX
            VSYS(K,L) = 0.
          ENDDO
        ENDDO
C
C------ set up Newton system:  set constraints for all parameters
        DO 100 IV = 1, NVTOT
C
C-------- set index and value of constraint for this parameter
          IC = ICON(IV,IR)
C
C------------------------------------
          IF    (IC.EQ.ICALFA) THEN
           VRES(IV) = ALFA - CONVAL(IC,IR)*DTR
           VSYS(IV,IVALFA) = 1.0
C
C------------------------------------
          ELSEIF(IC.EQ.ICBETA) THEN
           VRES(IV) = BETA - CONVAL(IC,IR)*DTR
           VSYS(IV,IVBETA) = 1.0
C
C------------------------------------
          ELSEIF(IC.EQ.ICROTX) THEN
           VRES(IV) = (WROT(1)*CA + WROT(3)*SA)*DIR
     &              - CONVAL(IC,IR)*2.0/BREF
           VSYS(IV,IVROTX) = CA*DIR
           VSYS(IV,IVROTZ) = SA*DIR
           VSYS(IV,IVALFA) = (WROT(1)*CA_A + WROT(3)*SA_A)*DIR
C
C------------------------------------
          ELSEIF(IC.EQ.ICROTY) THEN
           VRES(IV) = WROT(2)
     &              - CONVAL(IC,IR)*2.0/CREF
           VSYS(IV,IVROTY) = 1.0
C
C------------------------------------
          ELSEIF(IC.EQ.ICROTZ) THEN
           VRES(IV) = (WROT(3)*CA - WROT(1)*SA)*DIR
     &              - CONVAL(IC,IR)*2.0/BREF
           VSYS(IV,IVROTX) = -SA*DIR
           VSYS(IV,IVROTZ) =  CA*DIR
           VSYS(IV,IVALFA) = (WROT(3)*CA_A - WROT(1)*SA_A)*DIR
C
C------------------------------------
          ELSEIF(IC.EQ.ICCL  ) THEN
           VRES(IV) = CLTOT - CONVAL(IC,IR)
           VSYS(IV,IVALFA) = CLTOT_U(1)*VINF_A(1)
     &                     + CLTOT_U(2)*VINF_A(2)
     &                     + CLTOT_U(3)*VINF_A(3) + CLTOT_A
           VSYS(IV,IVBETA) = CLTOT_U(1)*VINF_B(1)
     &                     + CLTOT_U(2)*VINF_B(2)
     &                     + CLTOT_U(3)*VINF_B(3)
           VSYS(IV,IVROTX) = CLTOT_U(4)
           VSYS(IV,IVROTY) = CLTOT_U(5)
           VSYS(IV,IVROTZ) = CLTOT_U(6)

C
           DO N = 1, NCONTROL
             NV = IVTOT + N
             VSYS(IV,NV) = CLTOT_D(N)
           ENDDO
C
C------------------------------------
          ELSEIF(IC.EQ.ICCY  ) THEN
           VRES(IV) = CYTOT - CONVAL(IC,IR)
           VSYS(IV,IVALFA) = CYTOT_U(1)*VINF_A(1)
     &                     + CYTOT_U(2)*VINF_A(2)
     &                     + CYTOT_U(3)*VINF_A(3)
           VSYS(IV,IVBETA) = CYTOT_U(1)*VINF_B(1)
     &                     + CYTOT_U(2)*VINF_B(2)
     &                     + CYTOT_U(3)*VINF_B(3)
           VSYS(IV,IVROTX) = CYTOT_U(4)
           VSYS(IV,IVROTY) = CYTOT_U(5)
           VSYS(IV,IVROTZ) = CYTOT_U(6)
C
           DO N = 1, NCONTROL
             NV = IVTOT + N
             VSYS(IV,NV) = CYTOT_D(N)
           ENDDO
C
C------------------------------------
          ELSEIF(IC.EQ.ICMOMX) THEN
           VRES(IV) = (CRTOT*CA + CNTOT*SA)*DIR - CONVAL(IC,IR)
           VSYS(IV,IVALFA) = ( CRTOT_U(1)*VINF_A(1)
     &                        +CRTOT_U(2)*VINF_A(2)
     &                        +CRTOT_U(3)*VINF_A(3))*CA*DIR
     &                     + ( CNTOT_U(1)*VINF_A(1)
     &                        +CNTOT_U(2)*VINF_A(2)
     &                        +CNTOT_U(3)*VINF_A(3))*SA*DIR
     &                     + (CRTOT*CA_A + CNTOT*SA_A)*DIR
           VSYS(IV,IVBETA) = ( CRTOT_U(1)*VINF_B(1)
     &                        +CRTOT_U(2)*VINF_B(2)
     &                        +CRTOT_U(3)*VINF_B(3))*CA*DIR
     &                     + ( CNTOT_U(1)*VINF_B(1)
     &                        +CNTOT_U(2)*VINF_B(2)
     &                        +CNTOT_U(3)*VINF_B(3))*SA*DIR
           VSYS(IV,IVROTX) = (CRTOT_U(4)*CA + CNTOT_U(4)*SA)*DIR
           VSYS(IV,IVROTY) = (CRTOT_U(5)*CA + CNTOT_U(5)*SA)*DIR
           VSYS(IV,IVROTZ) = (CRTOT_U(6)*CA + CNTOT_U(6)*SA)*DIR
C
           DO N = 1, NCONTROL
             NV = IVTOT + N
             VSYS(IV,NV) = (CRTOT_D(N)*CA + CNTOT_D(N)*SA)*DIR
           ENDDO
C
C------------------------------------
          ELSEIF(IC.EQ.ICMOMY) THEN
           VRES(IV) = CMTOT - CONVAL(IC,IR)
           VSYS(IV,IVALFA) = CMTOT_U(1)*VINF_A(1)
     &                     + CMTOT_U(2)*VINF_A(2)
     &                     + CMTOT_U(3)*VINF_A(3)
           VSYS(IV,IVBETA) = CMTOT_U(1)*VINF_B(1)
     &                     + CMTOT_U(2)*VINF_B(2)
     &                     + CMTOT_U(3)*VINF_B(3)
           VSYS(IV,IVROTX) = CMTOT_U(4)
           VSYS(IV,IVROTY) = CMTOT_U(5)
           VSYS(IV,IVROTZ) = CMTOT_U(6)
C
           DO N = 1, NCONTROL
             NV = IVTOT + N
             VSYS(IV,NV) = CMTOT_D(N)
           ENDDO
C
C------------------------------------
          ELSEIF(IC.EQ.ICMOMZ) THEN
           VRES(IV) = (CNTOT*CA - CRTOT*SA)*DIR - CONVAL(IC,IR)
           VSYS(IV,IVALFA) = ( CNTOT_U(1)*VINF_A(1)
     &                        +CNTOT_U(2)*VINF_A(2)
     &                        +CNTOT_U(3)*VINF_A(3))*CA*DIR
     &                     - ( CRTOT_U(1)*VINF_A(1)
     &                        +CRTOT_U(2)*VINF_A(2)
     &                        +CRTOT_U(3)*VINF_A(3))*SA*DIR
     &                     + (CNTOT*CA_A - CRTOT*SA_A)*DIR
           VSYS(IV,IVBETA) = ( CNTOT_U(1)*VINF_B(1)
     &                        +CNTOT_U(2)*VINF_B(2)
     &                        +CNTOT_U(3)*VINF_B(3))*CA*DIR
     &                     - ( CRTOT_U(1)*VINF_B(1)
     &                        +CRTOT_U(2)*VINF_B(2)
     &                        +CRTOT_U(3)*VINF_B(3))*SA*DIR
           VSYS(IV,IVROTX) = (CNTOT_U(4)*CA - CRTOT_U(4)*SA)*DIR
           VSYS(IV,IVROTY) = (CNTOT_U(5)*CA - CRTOT_U(5)*SA)*DIR
           VSYS(IV,IVROTZ) = (CNTOT_U(6)*CA - CRTOT_U(6)*SA)*DIR
C
           DO N = 1, NCONTROL
             NV = IVTOT + N
             VSYS(IV,NV) = (CNTOT_D(N)*CA - CRTOT_D(N)*SA)*DIR
           ENDDO
C
C------------------------------------
          ELSE
           DO N = 1, NCONTROL
             ICCON = ICTOT + N
             IVCON = IVTOT + N
             IF(IC.EQ.ICCON) THEN
              VRES(IV) = DELCON(N) - CONVAL(ICCON,IR)
              VSYS(IV,IVCON) = 1.0
              GO TO 100
             ENDIF
           ENDDO
C
           WRITE(*,*) '? Illegal constraint index: ', IC
          ENDIF
C
 100    CONTINUE
C

c        write(*,*)
c        do k = 1, nvtot
c          write(*,'(1x,40f9.4)') (vsys(k,l), l=1, nvtot), vres(k)
c        enddo
c        write(*,*)
C
C------ LU-factor,  and back-substitute RHS
        CALL LUDCMP(IVMAX,NVTOT,VSYS,IVSYS,WORK)
        CALL BAKSUB(IVMAX,NVTOT,VSYS,IVSYS,VRES)
C
C------ set Newton deltas
        DAL = -VRES(IVALFA)
        DBE = -VRES(IVBETA)
        DWX = -VRES(IVROTX)
        DWY = -VRES(IVROTY)
        DWZ = -VRES(IVROTZ)
        DO N = 1, NCONTROL
          IV = IVTOT + N
          DDC(N) = -VRES(IV)
        ENDDO
C
        IF(INFO .GE. 1) THEN
C------- display Newton deltas
         IF(ITER.EQ.1) THEN
          WRITE(*,*)
          WRITE(*,1902) 'iter',
     &            ' d(alpha)  ',
     &            ' d(beta)   ',
     &            ' d(pb/2V)  ',
     &            ' d(qc/2V)  ',
     &            ' d(rb/2V)  ',
     &            (DNAME(K), K=1, NCONTROL)
 1902     FORMAT(1X,A4,5A11,1X,30A11)
         ENDIF
         WRITE(*,1905) ITER, 
     &                 DAL/DTR, DBE/DTR, 
     &                 DWX*BREF/2.0, DWY*CREF/2.0, DWZ*BREF/2.0,
     &                 (DDC(K), K=1, NCONTROL)
 1905    FORMAT(1X,I3,40E11.3)
        ENDIF
C
C------ limits on angles and rates
        DMAXA = DMAX
        DMAXR = 5.0*DMAX/BREF
C
C------ if changes are too big, configuration is probably untrimmable
        IF(ABS(ALFA+DAL).GT.DMAXA) THEN
         WRITE(*,*) 'Cannot trim.  Alpha too large.  a =',(ALFA+DAL)/DTR
         RETURN
        ENDIF
C
        IF(ABS(BETA+DBE).GT.DMAXA) THEN
         WRITE(*,*) 'Cannot trim.  Beta too large.  b =',(BETA+DBE)/DTR
         RETURN
        ENDIF
C
        IF(ABS(WROT(1)+DWX).GT.DMAXR) THEN
         WRITE(*,*) 'Cannot trim.  Roll rate too large.  pb/2V =', 
     &               (WROT(1)+DWX)*BREF*0.5
         RETURN
        ENDIF
C
        IF(ABS(WROT(2)+DWY).GT.DMAXR) THEN
         WRITE(*,*) 'Cannot trim.  Pitch rate too large.  qc/2V =',
     &               (WROT(2)+DWY)*CREF*0.5
         RETURN
        ENDIF
C
        IF(ABS(WROT(3)+DWZ).GT.DMAXR) THEN
         WRITE(*,*) 'Cannot trim.  Yaw rate too large.  rb/2V =',
     &               (WROT(3)+DWZ)*BREF*0.5
         RETURN
        ENDIF
C
C------ update
        ALFA  = ALFA  + DAL
        BETA  = BETA  + DBE
        WROT(1) = WROT(1) + DWX
        WROT(2) = WROT(2) + DWY
        WROT(3) = WROT(3) + DWZ
        DO K = 1, NCONTROL
          DELCON(K) = DELCON(K) + DDC(K)
        ENDDO
C
C
C------ set VINF() vector from new ALFA,BETA
        CALL VINFAB
C
        IF(NCONTROL.GT.0) THEN
C------- set new GAM_D
         CALL GDCALC(NCONTROL,LCONDEF,ENC_D,GAM_D)
        ENDIF
C
        IF(NDESIGN.GT.0) THEN
C------- set new GAM_G
         CALL GDCALC(NDESIGN ,LDESDEF,ENC_G,GAM_G)
        ENDIF
C
C------ sum AIC matrices to get GAM,SRC,DBL
        CALL GAMSUM
C
C------ sum AIC matrices to get WC,WV
        CALL VELSUM
C
C------ compute forces
        CALL AERO
C
C
C------ convergence check
        DELMAX = MAX( ABS(DAL), 
     &                ABS(DBE),
     &                ABS(DWX*BREF/2.0),
     &                ABS(DWY*CREF/2.0),
     &                ABS(DWZ*BREF/2.0) )
        DO K = 1, NCONTROL
          DELMAX = MAX( DELMAX , ABS(DDC(K)) )
        ENDDO
C
        IF(DELMAX.LT.EPS) THEN
         LSOL = .TRUE.
C------- mark trim case as being converged
         ITRIM(IR) = IABS(ITRIM(IR))
         GO TO 191
        ENDIF
C
 190  CONTINUE
      IF(NITER.GT.0) THEN
       WRITE(*,*) 'Trim convergence failed'
       LSOL = .FALSE.
       RETURN
      ENDIF
C
 191  CONTINUE
      PARVAL(IPALFA,IR) = ALFA/DTR
      PARVAL(IPBETA,IR) = BETA/DTR
      PARVAL(IPROTX,IR) = WROT(1)*0.5*BREF
      PARVAL(IPROTY,IR) = WROT(2)*0.5*CREF
      PARVAL(IPROTZ,IR) = WROT(3)*0.5*BREF
      PARVAL(IPCL  ,IR) = CLTOT
C
      LSEN = .TRUE.
      RETURN
C
      END ! EXEC



      SUBROUTINE OPTGET
C-------------------------------------------------
C     Allows toggling and setting of various 
C     printing and plotting stuff.
C-------------------------------------------------
      INCLUDE 'AVL.INC'
      CHARACTER*4 ITEMC
      CHARACTER*80 COMARG
      CHARACTER*50 SATYPE, ROTTYPE
      LOGICAL ERROR
C
      REAL    RINPUT(20)
      INTEGER IINPUT(20)
      LOGICAL LINPUT(20)
C
 1000 FORMAT(A)
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
 100  CONTINUE
      IF(LSA_RATES) THEN
        ROTTYPE =
     &         'Rates,moments about Stability Axes, X along Vinf'
      ELSE
        ROTTYPE =
     &         'Rates,moments about Body Axes, X along geometric X axis'
      ENDIF
C  
      WRITE(*,1110) LPTOT,LPSURF,LPSTRP,LPELE,
     &              LPHINGE,LPDERIV,
     &              LTRFORCE,LVISC,LBFORCE,
     &                SATYPE,ROTTYPE,IZSYM,ZSYM,SAXFR,VRCORE
 1110   FORMAT(/'   ======================================'
     &         /'    P rint default output for...'
     &         /'        total     :  ',L2,
     &         /'        surfaces  :  ',L2,
     &         /'        strips    :  ',L2,
     &         /'        elements  :  ',L2,
     &        //'    H inge mom. output:  ',L2,
     &         /'    D erivative output:  ',L2,
     &        //'    T rail.leg forces:  ',L2,
     &         /'    V iscous forces  :  ',L2,
     &         /'    B ody forces     :  ',L2,
     &        //'    A xis orient. :  ', A, 
     &         /'    R ate,mom axes:  ', A,
     &         /'    Z  symmetry   :  ',I2,' @ Z =',F10.4
     &         /'    S pan axis x/c:  ',F10.4
     &         /'    C ore/ds ratio:  ',F10.4)
C
C
      CALL ASKC(' ..Select item to change^',ITEMC,COMARG)
C
C------------------------------------------------------
      IF    (ITEMC.EQ.'    ') THEN
        RETURN
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'A   ') THEN
        LNASA_SA = .NOT.LNASA_SA
        CALL GETSA(LNASA_SA,SATYPE,DIR)
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'R   ') THEN
        LSA_RATES = .NOT.LSA_RATES
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'V   ') THEN
        LVISC = .NOT.LVISC
        IF(LVISC) THEN
          WRITE(*,*) 'Forces will include profile drag'
         ELSE
          WRITE(*,*) 'Forces will not include profile drag'
        ENDIF
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'B   ') THEN
        LBFORCE = .NOT.LBFORCE
        IF(LBFORCE) THEN
          WRITE(*,*) 'Forces will include body forces'
         ELSE
          WRITE(*,*) 'Forces will not include body forces'
        ENDIF
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'T   ') THEN
        LTRFORCE = .NOT.LTRFORCE
        IF(LTRFORCE) THEN
          WRITE(*,*) 'Forces on trailing legs will be included'
         ELSE
          WRITE(*,*) 'Forces on trailing legs will not be included'
        ENDIF
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'P   ') THEN
 128   IF(COMARG(1:1).NE.' ') THEN
         NINP = 4
         CALL GETLGV(COMARG,LINPUT,NINP,ERROR)
         IF(ERROR) GO TO 130
C
         IF(NINP.GE.1) LPTOT   = LINPUT(1)
         IF(NINP.GE.2) LPSURF  = LINPUT(2)
         IF(NINP.GE.3) LPSTRP  = LINPUT(3)
         IF(NINP.GE.4) LPELE   = LINPUT(4)
C
         GO TO 100
        ENDIF
C
 130    WRITE(*,2100)
     &  'Enter print flags T/F (total,surf,strip,elem)'
 2100   FORMAT(1X,A,': ', $)
C
        READ(*,1000) COMARG
        IF(COMARG.EQ.' ') THEN
         GO TO 100
        ELSE
         GO TO 128
        ENDIF
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'H   ') THEN
        LPHINGE = .NOT.LPHINGE
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'D   ') THEN
        LPDERIV = .NOT.LPDERIV
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'Z   ') THEN
       WRITE(*,*) ' '
       WRITE(*,*) 'Currently:'
       IF(IZSYM.EQ.0) THEN
         WRITE (*,1015)
        ELSEIF(IZSYM.GT.0) THEN
         WRITE (*,1016) ZSYM
        ELSEIF(IZSYM.LT.0) THEN
         WRITE (*,1017) ZSYM
       ENDIF
       WRITE(*,*) 'Enter symmetry flag: -1 Free surface'
       WRITE(*,*) '                      0 no Z symmetry'
       WRITE(*,*) '                      1 Ground plane'
       ZSYMIN = 0.0
       READ(*,*,ERR=100) IZSYMIN
       IF(IZSYMIN.NE.0.0) THEN
         WRITE(*,2100) 'Enter Z for symmetry plane'
         READ(*,*,ERR=100) ZSYMIN
       ENDIF
       IZSYM = IZSYMIN
       ZSYM  = ZSYMIN
       LAIC = .FALSE.
       LSRD = .FALSE.
       LSOL = .FALSE.
       LVEL = .FALSE.
       LSEN = .FALSE.
C
 1015  FORMAT(' Z Symmetry: No symmetry assumed')
 1016  FORMAT(' Z Symmetry: Ground plane at Zsym =',F10.4)
 1017  FORMAT(' Z Symmetry: Free surface at Zsym =',F10.4)
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'S   ') THEN
        NINP = 1
        CALL GETFLT(COMARG,RINPUT,NINP,ERROR)
C
        IF(ERROR .OR. NINP.LE.0) THEN
         RINPUT(1) = SAXFR
         WRITE(*,1030) RINPUT(1)
 1030    FORMAT(/' Enter x/c location of spanwise ref. axis:', F10.4)
         CALL READR(1,RINPUT(1),ERROR)
         IF(ERROR) GO TO 100
        ENDIF
C
        SAXFR = MAX( 0.0 , MIN(1.0,RINPUT(1)) )
        CALL ENCALC
        CALL AERO
C
C---------------------------------
      ELSEIF(ITEMC.EQ.'C   ') THEN
        NINP = 1
        CALL GETFLT(COMARG,RINPUT,NINP,ERROR)
C
        IF(ERROR .OR. NINP.LE.0) THEN
         RINPUT(1) = VRCORE
         WRITE(*,1040) RINPUT(1)
 1040    FORMAT(/' Enter core/vortex-strip width:', F10.4)
         CALL READR(1,RINPUT,ERROR)
         IF(ERROR) GO TO 100
        ENDIF
C
        VRCORE = MAX( 0.0 , MIN(1.0,RINPUT(1)) )
        CALL ENCALC
        LAIC = .FALSE.
        LSRD = .FALSE.
        LSOL = .FALSE.
        LSEN = .FALSE.
C
C---------------------------------
      ELSE
        WRITE(*,*) 'Item not recognized'
        GO TO 100
      ENDIF
      GO TO 100
C
      END ! OPTGET



      SUBROUTINE CFRAC(IRUN,NRUN,CPR,NPR)
      CHARACTER*(*) CPR
C
      IZERO = ICHAR('0')
      ITEN = IRUN/10
      IONE = IRUN - 10*(IRUN/10)
      IF(ITEN.LE.0) THEN
       CPR = CHAR(IZERO+IONE) // '/'
      ELSE
       CPR = CHAR(IZERO+ITEN) // CHAR(IZERO+IONE) // '/'
      ENDIF
C
      NPR = INDEX(CPR,'/')
      ITEN = NRUN/10
      IONE = NRUN - 10*(NRUN/10)
      IF(ITEN.LE.0) THEN
       CPR = CPR(1:NPR)
     &    // CHAR(IZERO+IONE) // '^'
      ELSE
       CPR = CPR(1:NPR)
     &    // CHAR(IZERO+ITEN) // CHAR(IZERO+IONE) // '^'
      ENDIF
C
      NPR = INDEX(CPR,'^') - 1
C
      RETURN
      END ! CFRAC



      SUBROUTINE RCOPY(IRSET,IR)
      INCLUDE 'AVL.INC'
C
      DO IV = 1, NVTOT
        ICON(IV,IRSET) = ICON(IV,IR)
      ENDDO
      DO IC = 1, NCTOT
        CONVAL(IC,IRSET) = CONVAL(IC,IR)
      ENDDO
      DO IP = 1, NPTOT
        PARVAL(IP,IRSET) = PARVAL(IP,IR)
      ENDDO
C
      RTITLE(IRSET) = RTITLE(IR)
      ITRIM(IRSET) = ITRIM(IR)
      NEIGEN(IRSET) = NEIGEN(IR)
C
      DO KE = 1, JEMAX
        EVAL(KE,IRSET) = EVAL(KE,IR)
        DO JE = 1, JEMAX
          EVEC(KE,JE,IRSET) = EVEC(KE,JE,IR)
        ENDDO
      ENDDO
C
      RETURN
      END ! RCOPY





      SUBROUTINE GETFILE(LU,FNAME)
      CHARACTER(*) FNAME
C
      CHARACTER*1 ANS, DUMMY
C
 1000 FORMAT(A)
C
      IF(FNAME.EQ.' ') THEN
       CALL ASKS('Enter filename, or <return> for screen output^',FNAME)
      ENDIF
C
      IF(FNAME.EQ.' ') THEN
       LU = 6
       RETURN
C
      ELSE
       LU = 11
       OPEN(LU,FILE=FNAME,STATUS='OLD',FORM='FORMATTED',ERR=44)
       WRITE(*,*) 
       WRITE(*,*) 'File exists.  Append/Overwrite/Cancel  (A/O/C)?  C'
       READ(*,1000) ANS
       IF    (INDEX('Aa',ANS).NE.0) THEN
 40     CONTINUE
        READ(LU,1000,END=42) DUMMY
        GO TO 40
 42     CONTINUE
       ELSEIF(INDEX('Oo',ANS).NE.0) THEN
        REWIND(LU) 
       ELSE
        CLOSE(LU)
        LU = 0
       ENDIF
       RETURN
C
 44    OPEN(LU,FILE=FNAME,STATUS='UNKNOWN',FORM='FORMATTED',ERR=48)
       REWIND(LU)
       RETURN
C
 48    CONTINUE
       LU = -1
       RETURN
      ENDIF
      END ! GETFILE

      SUBROUTINE ARWSET(R,SN,SLEN,HLEN,RHEAD,NHEAD,RLINES,NLINES)
      REAL R(3), SN(3), RLINES(3,2,*)
C------------------------------------------------------------------------
C     Creates a 3D wireframe arrow with a conical arrowhead.
C     The last RLINES dimension must be at least 2*NHEAD+1
C
C     Input:
C        R(.)   location of arrow tail
C        SN(.)  unit vector along arrow
C        SLEN   length of arrowshaft 
C        HLEN   length of arrowhead  (total length is SLEN+HLEN)
C        RHEAD  arrowhead radius
C        NHEAD  number of "pie slices" forming conical arrowhead
C
C     Output:
C        RLINES(.1s)  first  point of line segment
C        RLINES(.2s)  second point of line segment
C        NLINES       number of line segments  ( = 2*NHEAD+1 )
C
C        The last segment (s=NLINES) is the arrowshaft
C------------------------------------------------------------------------
      REAL A(3), B(3)
      DATA PI / 3.1415926 /
C
      KMIN = 1
      IF(ABS(SN(2)) .LT. ABS(SN(KMIN))) KMIN = 2
      IF(ABS(SN(3)) .LT. ABS(SN(KMIN))) KMIN = 3
C
      B(1) = 0.
      B(2) = 0.
      B(3) = 0.
      B(KMIN) = 1.0
C
      CALL CROSS(B,SN,A)
      AMAG = SQRT(A(1)**2 + A(2)**2 + A(3)**2)
      IF(AMAG .GT. 0.0) THEN
       A(1) = RHEAD*A(1)/AMAG
       A(2) = RHEAD*A(2)/AMAG
       A(3) = RHEAD*A(3)/AMAG
      ENDIF
C
      CALL CROSS(A,SN,B)
C
C---- set arrowhead perimeter lin segments
      IL = 1
      RLINES(1,1,IL) = R(1) + A(1)
      RLINES(2,1,IL) = R(2) + A(2)
      RLINES(3,1,IL) = R(3) + A(3)
C
      NT = NHEAD
      DT = 2.0*PI / FLOAT(NT)
      DO IT = 1, NT-1
        T = DT * FLOAT(IT)
        COST = COS(T)
        SINT = SIN(T)
C
        IL = IT
        RLINES(1,2,IL) = R(1) + A(1)*COST + B(1)*SINT
        RLINES(2,2,IL) = R(2) + A(2)*COST + B(2)*SINT
        RLINES(3,2,IL) = R(3) + A(3)*COST + B(3)*SINT
C
        RLINES(1,1,IL+1) = RLINES(1,2,IL)
        RLINES(2,1,IL+1) = RLINES(2,2,IL)
        RLINES(3,1,IL+1) = RLINES(3,2,IL)
      ENDDO
C
      IL = NT
      RLINES(1,2,IL) = RLINES(1,1,1)
      RLINES(2,2,IL) = RLINES(2,1,1)
      RLINES(3,2,IL) = RLINES(3,1,1)
      NLINES = NT
C
C---- set arrowhead radial segments
      DO IT = 1, NT
        IL = NT + IT
C
C------ from point on perimeter ...
        RLINES(1,1,IL) = RLINES(1,1,IT)
        RLINES(2,1,IL) = RLINES(2,1,IT)
        RLINES(3,1,IL) = RLINES(3,1,IT)
C
C------  ... to arrowhead point
        RLINES(1,2,IL) = R(1) + SN(1)*HLEN
        RLINES(2,2,IL) = R(2) + SN(2)*HLEN
        RLINES(3,2,IL) = R(3) + SN(3)*HLEN
      ENDDO
C
      NLINES = 2*NT
C
C---------------------------------------------------
C---- add arrowshaft
C
C---- move entire arrowhead by shaft distance
      DO IL = 1, NLINES
        DO K = 1, 3
          RLINES(K,1,IL) = RLINES(K,1,IL) + SLEN*SN(K)
          RLINES(K,2,IL) = RLINES(K,2,IL) + SLEN*SN(K)
        ENDDO
      ENDDO
C
C---- add shaft segment
      NLINES = NLINES + 1
      IL = NLINES
C
      RLINES(1,1,IL) = R(1)
      RLINES(2,1,IL) = R(2)
      RLINES(3,1,IL) = R(3)
C
      RLINES(1,2,IL) = R(1) + SLEN*SN(1)
      RLINES(2,2,IL) = R(2) + SLEN*SN(2)
      RLINES(3,2,IL) = R(3) + SLEN*SN(3)
C
      RETURN
      END ! ARWSET



      SUBROUTINE ARWPLT(XO,YO,AFAC,RLINES,SN,RHEAD,NHEAD)
C---------------------------------------------------------
C     Plots the 3D arrow created by ARWSET, presumably
C     after it was projected into screen x,y coordinates.
C     The z coordinates are used here for hidden-line 
C     logic to give the arrow a "solid" appearance.
C---------------------------------------------------------
      REAL RLINES(3,2,*), SN(3)
C
      REAL DLHEAD(3)
C
C---- end of arrowshaft
      NL = 2*NHEAD + 1
      ZSHAFT = RLINES(3,2,NL)
C
C---- arrowshaft length
      SSHAFT = SQRT(  (RLINES(1,2,NL)-RLINES(1,1,NL))**2
     &              + (RLINES(2,2,NL)-RLINES(2,1,NL))**2
     &              + (RLINES(3,2,NL)-RLINES(3,1,NL))**2 )
C
C---- normalize direction vector just in case it was deformed by perspective
      SNSQ = SN(1)**2 + SN(2)**2 + SN(3)**2
      IF(SNSQ .GT. 0.0) THEN
       SNI = 1.0/SQRT(SNSQ)
      ELSE
       SNI = 1.0
      ENDIF
C
C---- plot arrowhead perimiter
      DO IH = 1, NHEAD
        IL = IH
C------ midpoint of perimter segment
        ZMID = (RLINES(3,2,IL) + RLINES(3,1,IL))*0.5
C
C------ plot segment only if arrow points down (z component into screen),
C        or arrowshaft end's z location is below segment's z midpoint
        IF(SN(3) .LT. 0.0 .OR. ZSHAFT .LT. ZMID) THEN
         X1 = XO + AFAC*RLINES(1,1,IL)
         Y1 = YO + AFAC*RLINES(2,1,IL)
         X2 = XO + AFAC*RLINES(1,2,IL)
         Y2 = YO + AFAC*RLINES(2,2,IL)
         CALL PLOT(X1,Y1,3)
         CALL PLOT(X2,Y2,2)
        ENDIF
      ENDDO
C
C---- plot arrowhead radial segments
      DO IH = 1, NHEAD
        IL = NHEAD + IH
C
C------ set unit vector along radial segment
        DLHEAD(1) = RLINES(1,2,IL) - RLINES(1,1,IL)
        DLHEAD(2) = RLINES(2,2,IL) - RLINES(2,1,IL)
        DLHEAD(3) = RLINES(3,2,IL) - RLINES(3,1,IL)
        SLHEAD = SQRT(DLHEAD(1)**2 + DLHEAD(2)**2 + DLHEAD(3)**2)
        IF(SLHEAD .GT. 0.0) THEN
         DLHEAD(1) = DLHEAD(1)/SLHEAD
         DLHEAD(2) = DLHEAD(2)/SLHEAD
         DLHEAD(3) = DLHEAD(3)/SLHEAD
        ENDIF
C
C------ plot segment only if it points more into screen than arrowshaft
        IF(DLHEAD(3) .LT. SN(3)*SNI) THEN
         X1 = XO + AFAC*RLINES(1,1,IL)
         Y1 = YO + AFAC*RLINES(2,1,IL)
         X2 = XO + AFAC*RLINES(1,2,IL)
         Y2 = YO + AFAC*RLINES(2,2,IL)
         CALL PLOT(X1,Y1,3)
         CALL PLOT(X2,Y2,2)
        ENDIF
      ENDDO
C
C---- don't bother plotting zero-length arrowshaft
      IF(SSHAFT .EQ. 0.0) RETURN
C
C---- find visible fraction of arrowshaft
      SN12 = SQRT(SN(1)**2 + SN(2)**2)
      IF(SN12 .EQ. 0.0) THEN
       TANT = 0.0
      ELSE
       TANT = SN(3) / SN12
      ENDIF
      SSEEN = MAX( SSHAFT - RHEAD*MAX( TANT , 0.0 ) , 0.0 )
C
      IF(SSEEN .EQ. 0.0) RETURN
C
C---- plot visible fraction of arrowshaft
      SFRAC = SSEEN/SSHAFT
C
      IL = NL
      X1 = XO + AFAC* RLINES(1,1,IL)
      Y1 = YO + AFAC* RLINES(2,1,IL)
      X2 = X1 + AFAC*(RLINES(1,2,IL)-RLINES(1,1,IL))*SFRAC
      Y2 = Y1 + AFAC*(RLINES(2,2,IL)-RLINES(2,1,IL))*SFRAC
      CALL PLOT(X1,Y1,3)
      CALL PLOT(X2,Y2,2)
C
      RETURN
      END ! ARWPLT

      SUBROUTINE SECONDS(TSEC)
      REAL*8 TSEC
C
      REAL*8 MICSEC
C
C---- get CPU time in microseconds
      CALL CLOCKX(MICSEC)
C
C---- return seconds
      TSEC = MICSEC/1.0D6
C
      RETURN
      END

      PROGRAM DTEST
C---------------------------------------------------------------------------
C     Checks stability derivatives by finite differencing.
C     Usage: 
C             % coef xxx yyy
C
C     where "xxx", "yyy" are AVL stability derivative output filenames.
C
C---------------------------------------------------------------------------
      IMPLICIT REAL(A-H,O-Z)

      CHARACTER*256 ARGP1, ARGP2
      CHARACTER*128 LINE
C
      PI = 4.0*ATAN(1.0)
C
C--------------------------------------
C
 1000 FORMAT(A)
C
C---- get Unix command arguments
      CALL GETARG(1,ARGP1)
      CALL GETARG(2,ARGP2)
C
C-----------------------------------------------------------------
      OPEN(1,FILE=ARGP1,STATUS='OLD')
      ILINE = 0
C
C==================================================================
C---- top of file-line reading loop
 10   CONTINUE
      READ(1,1000,END=11) LINE
      ILINE = ILINE + 1
      IF(INDEX('#!',LINE(1:1)).NE.0) GO TO 10
C
      CALL GETVAL(LINE,'Alpha =',ADEG)
      CALL GETVAL(LINE,'Beta  =',BDEG)
      a = ADEG*PI/180.0
      b = BDEG*PI/180.0
C
      CALL GETVAL(LINE,'p''b/2V =',p)
      CALL GETVAL(LINE,  'qc/2V =',q)
      CALL GETVAL(LINE,'r''b/2V =',r)

      CALL GETVAL(LINE,'Cl''tot =',Cr)
      CALL GETVAL(LINE,  'Cmtot =',Cm)
      CALL GETVAL(LINE,'Cn''tot =',Cn)

      CALL GETVAL(LINE,'CYtot =',CY)
      CALL GETVAL(LINE,'CLtot =',CL)
      CALL GETVAL(LINE,'CDtot =',CD)
      CALL GETVAL(LINE,'CDff  =',CDff)
      CALL GETVAL(LINE,'    e =', e)

      CALL GETVAL(LINE,'flap            =',d1)
      CALL GETVAL(LINE,'aileron         =',d2)
      CALL GETVAL(LINE,'elevator        =',d3)
      CALL GETVAL(LINE,'rudder          =',d4)

      CALL GETVAL(LINE,'CLa =',CLa)
      CALL GETVAL(LINE,'CYa =',CYa)
      CALL GETVAL(LINE,'Cla =',Cra)
      CALL GETVAL(LINE,'Cma =',Cma)
      CALL GETVAL(LINE,'Cna =',Cna)
                
      CALL GETVAL(LINE,'CLb =',CLb)
      CALL GETVAL(LINE,'CYb =',CYb)
      CALL GETVAL(LINE,'Clb =',Crb)
      CALL GETVAL(LINE,'Cmb =',Cmb)
      CALL GETVAL(LINE,'Cnb =',Cnb)
                
      CALL GETVAL(LINE,'CLp =',CLp)
      CALL GETVAL(LINE,'CYp =',CYp)
      CALL GETVAL(LINE,'Clp =',Crp)
      CALL GETVAL(LINE,'Cmp =',Cmp)
      CALL GETVAL(LINE,'Cnp =',Cnp)
                
      CALL GETVAL(LINE,'CLq =',CLq)
      CALL GETVAL(LINE,'CYq =',CYq)
      CALL GETVAL(LINE,'Clq =',Crq)
      CALL GETVAL(LINE,'Cmq =',Cmq)
      CALL GETVAL(LINE,'Cnq =',Cnq)
                
      CALL GETVAL(LINE,'CLr =',CLr)
      CALL GETVAL(LINE,'CYr =',CYr)
      CALL GETVAL(LINE,'Clr =',Crr)
      CALL GETVAL(LINE,'Cmr =',Cmr)
      CALL GETVAL(LINE,'Cnr =',Cnr)

      CALL GETVAL(LINE,'CLd1 =',CLd1)
      CALL GETVAL(LINE,'CYd1 =',CYd1)
      CALL GETVAL(LINE,'Cld1 =',Crd1)
      CALL GETVAL(LINE,'Cmd1 =',Cmd1)
      CALL GETVAL(LINE,'Cnd1 =',Cnd1)
      CALL GETVAL(LINE,'CDffd1 =',CDffd1)
      CALL GETVAL(LINE,'ed1 =',ed1)

      CALL GETVAL(LINE,'CLd2 =',CLd2)
      CALL GETVAL(LINE,'CYd2 =',CYd2)
      CALL GETVAL(LINE,'Cld2 =',Crd2)
      CALL GETVAL(LINE,'Cmd2 =',Cmd2)
      CALL GETVAL(LINE,'Cnd2 =',Cnd2)
      CALL GETVAL(LINE,'CDffd2 =',CDffd2)
      CALL GETVAL(LINE,'ed2 =',ed2)

      CALL GETVAL(LINE,'CLd3 =',CLd3)
      CALL GETVAL(LINE,'CYd3 =',CYd3)
      CALL GETVAL(LINE,'Cld3 =',Crd3)
      CALL GETVAL(LINE,'Cmd3 =',Cmd3)
      CALL GETVAL(LINE,'Cnd3 =',Cnd3)
      CALL GETVAL(LINE,'CDffd3 =',CDffd3)
      CALL GETVAL(LINE,'ed3 =',ed3)

      CALL GETVAL(LINE,'CLd4 =',CLd4)
      CALL GETVAL(LINE,'CYd4 =',CYd4)
      CALL GETVAL(LINE,'Cld4 =',Crd4)
      CALL GETVAL(LINE,'Cmd4 =',Cmd4)
      CALL GETVAL(LINE,'Cnd4 =',Cnd4)
      CALL GETVAL(LINE,'CDffd4 =',CDffd4)
      CALL GETVAL(LINE,'ed4 =',ed4)
      GO TO 10
C
C=============================================
C
 11   CONTINUE
      CLOSE(1)
C
C-----------------------------------------------------------------
      OPEN(2,FILE=ARGP2,STATUS='OLD')
      ILINE = 0
C
C==================================================================
C---- top of file-line reading loop
 20   CONTINUE
      READ(2,1000,END=21) LINE
      ILINE = ILINE + 1
      IF(INDEX('#!',LINE(1:1)).NE.0) GO TO 20
C
      CALL GETVAL(LINE,'Alpha =',ADEG)
      CALL GETVAL(LINE,'Beta  =',BDEG)
      a$ = ADEG*PI/180.0
      b$ = BDEG*PI/180.0
C
      CALL GETVAL(LINE,'p''b/2V =',p$)
      CALL GETVAL(LINE,  'qc/2V =',q$)
      CALL GETVAL(LINE,'r''b/2V =',r$)

      CALL GETVAL(LINE,'Cl''tot =',Cr$)
      CALL GETVAL(LINE,  'Cmtot =',Cm$)
      CALL GETVAL(LINE,'Cn''tot =',Cn$)

      CALL GETVAL(LINE,'CYtot =',CY$)
      CALL GETVAL(LINE,'CLtot =',CL$)
      CALL GETVAL(LINE,'CDtot =',CD$)
      CALL GETVAL(LINE,'CDff  =',CDff$)
      CALL GETVAL(LINE,'    e =', e$)

      CALL GETVAL(LINE,'flap            =',d1$)
      CALL GETVAL(LINE,'aileron         =',d2$)
      CALL GETVAL(LINE,'elevator        =',d3$)
      CALL GETVAL(LINE,'rudder          =',d4$)

      CALL GETVAL(LINE,'CLa =',CLa$)
      CALL GETVAL(LINE,'CYa =',CYa$)
      CALL GETVAL(LINE,'Cla =',Cra$)
      CALL GETVAL(LINE,'Cma =',Cma$)
      CALL GETVAL(LINE,'Cna =',Cna$)
                
      CALL GETVAL(LINE,'CLb =',CLb$)
      CALL GETVAL(LINE,'CYb =',CYb$)
      CALL GETVAL(LINE,'Clb =',Crb$)
      CALL GETVAL(LINE,'Cmb =',Cmb$)
      CALL GETVAL(LINE,'Cnb =',Cnb$)
                
      CALL GETVAL(LINE,'CLp =',CLp$)
      CALL GETVAL(LINE,'CYp =',CYp$)
      CALL GETVAL(LINE,'Clp =',Crp$)
      CALL GETVAL(LINE,'Cmp =',Cmp$)
      CALL GETVAL(LINE,'Cnp =',Cnp$)
                
      CALL GETVAL(LINE,'CLq =',CLq$)
      CALL GETVAL(LINE,'CYq =',CYq$)
      CALL GETVAL(LINE,'Clq =',Crq$)
      CALL GETVAL(LINE,'Cmq =',Cmq$)
      CALL GETVAL(LINE,'Cnq =',Cnq$)
                
      CALL GETVAL(LINE,'CLr =',CLr$)
      CALL GETVAL(LINE,'CYr =',CYr$)
      CALL GETVAL(LINE,'Clr =',Crr$)
      CALL GETVAL(LINE,'Cmr =',Cmr$)
      CALL GETVAL(LINE,'Cnr =',Cnr$)

      CALL GETVAL(LINE,'CLd1 =',CLd1$)
      CALL GETVAL(LINE,'CYd1 =',CYd1$)
      CALL GETVAL(LINE,'Cld1 =',Crd1$)
      CALL GETVAL(LINE,'Cmd1 =',Cmd1$)
      CALL GETVAL(LINE,'Cnd1 =',Cnd1$)
      CALL GETVAL(LINE,'CDffd1 =',CDffd1$)
      CALL GETVAL(LINE,'ed1 =',ed1$)

      CALL GETVAL(LINE,'CLd2 =',CLd2$)
      CALL GETVAL(LINE,'CYd2 =',CYd2$)
      CALL GETVAL(LINE,'Cld2 =',Crd2$)
      CALL GETVAL(LINE,'Cmd2 =',Cmd2$)
      CALL GETVAL(LINE,'Cnd2 =',Cnd2$)
      CALL GETVAL(LINE,'CDffd2 =',CDffd2$)
      CALL GETVAL(LINE,'ed2 =',ed2$)

      CALL GETVAL(LINE,'CLd3 =',CLd3$)
      CALL GETVAL(LINE,'CYd3 =',CYd3$)
      CALL GETVAL(LINE,'Cld3 =',Crd3$)
      CALL GETVAL(LINE,'Cmd3 =',Cmd3$)
      CALL GETVAL(LINE,'Cnd3 =',Cnd3$)
      CALL GETVAL(LINE,'CDffd3 =',CDffd3$)
      CALL GETVAL(LINE,'ed3 =',ed3$)

      CALL GETVAL(LINE,'CLd4 =',CLd4$)
      CALL GETVAL(LINE,'CYd4 =',CYd4$)
      CALL GETVAL(LINE,'Cld4 =',Crd4$)
      CALL GETVAL(LINE,'Cmd4 =',Cmd4$)
      CALL GETVAL(LINE,'Cnd4 =',Cnd4$)
      CALL GETVAL(LINE,'CDffd4 =',CDffd4$)
      CALL GETVAL(LINE,'ed4 =',ed4$)
      GO TO 20
C
C=============================================
C
 21   CONTINUE
      CLOSE(2)
C
      da = a$ - a
      db = b$ - b
      dp = p$ - p
      dq = q$ - q
      dr = r$ - r
      dd1 = d1$ - d1
      dd2 = d2$ - d2
      dd3 = d3$ - d3
      dd4 = d4$ - d4
c
      dCL = 0.
      dCY = 0.
      dCr = 0.
      dCm = 0.
      dCn = 0.
      dCDff = 0.
      de = 0.

      dCL = dCL + 0.5*(CLa$+CLa)*da
      dCY = dCY + 0.5*(CYa$+CYa)*da
      dCr = dCr + 0.5*(Cra$+Cra)*da
      dCm = dCm + 0.5*(Cma$+Cma)*da
      dCn = dCn + 0.5*(Cna$+Cna)*da
                
      dCL = dCL + 0.5*(CLb$+CLb)*db
      dCY = dCY + 0.5*(CYb$+CYb)*db
      dCr = dCr + 0.5*(Crb$+Crb)*db
      dCm = dCm + 0.5*(Cmb$+Cmb)*db
      dCn = dCn + 0.5*(Cnb$+Cnb)*db
                
      dCL = dCL + 0.5*(CLp$+CLp)*dp
      dCY = dCY + 0.5*(CYp$+CYp)*dp
      dCr = dCr + 0.5*(Crp$+Crp)*dp
      dCm = dCm + 0.5*(Cmp$+Cmp)*dp
      dCn = dCn + 0.5*(Cnp$+Cnp)*dp
                
      dCL = dCL + 0.5*(CLq$+CLq)*dq
      dCY = dCY + 0.5*(CYq$+CYq)*dq
      dCr = dCr + 0.5*(Crq$+Crq)*dq
      dCm = dCm + 0.5*(Cmq$+Cmq)*dq
      dCn = dCn + 0.5*(Cnq$+Cnq)*dq
                
      dCL = dCL + 0.5*(CLr$+CLr)*dr
      dCY = dCY + 0.5*(CYr$+CYr)*dr
      dCr = dCr + 0.5*(Crr$+Crr)*dr
      dCm = dCm + 0.5*(Cmr$+Cmr)*dr
      dCn = dCn + 0.5*(Cnr$+Cnr)*dr
                     
      dCL = dCL + 0.5*(CLd1$+CLd1)*dd1
      dCY = dCY + 0.5*(CYd1$+CYd1)*dd1
      dCr = dCr + 0.5*(Crd1$+Crd1)*dd1
      dCm = dCm + 0.5*(Cmd1$+Cmd1)*dd1
      dCn = dCn + 0.5*(Cnd1$+Cnd1)*dd1
                        
      dCL = dCL + 0.5*(CLd2$+CLd2)*dd2
      dCY = dCY + 0.5*(CYd2$+CYd2)*dd2
      dCr = dCr + 0.5*(Crd2$+Crd2)*dd2
      dCm = dCm + 0.5*(Cmd2$+Cmd2)*dd2
      dCn = dCn + 0.5*(Cnd2$+Cnd2)*dd2
                        
      dCL = dCL + 0.5*(CLd3$+CLd3)*dd3
      dCY = dCY + 0.5*(CYd3$+CYd3)*dd3
      dCr = dCr + 0.5*(Crd3$+Crd3)*dd3
      dCm = dCm + 0.5*(Cmd3$+Cmd3)*dd3
      dCn = dCn + 0.5*(Cnd3$+Cnd3)*dd3
                        
      dCL = dCL + 0.5*(CLd4$+CLd4)*dd4
      dCY = dCY + 0.5*(CYd4$+CYd4)*dd4
      dCr = dCr + 0.5*(Crd4$+Crd4)*dd4
      dCm = dCm + 0.5*(Cmd4$+Cmd4)*dd4
      dCn = dCn + 0.5*(Cnd4$+Cnd4)*dd4

      dCDff = dCDff + 0.5*(CDffd1$+CDffd1)*dd1
      dCDff = dCDff + 0.5*(CDffd2$+CDffd2)*dd2
      dCDff = dCDff + 0.5*(CDffd3$+CDffd3)*dd3
      dCDff = dCDff + 0.5*(CDffd4$+CDffd4)*dd4

      de = de + 0.5*(ed1$+ed1)*dd1
      de = de + 0.5*(ed2$+ed2)*dd2
      de = de + 0.5*(ed3$+ed3)*dd3
      de = de + 0.5*(ed4$+ed4)*dd4


      write(*,*)
      write(*,*) 'CL =', CL, CL$
      write(*,*) 'CY =', CY, CY$
      write(*,*) 'Cl =', Cr, Cr$
      write(*,*) 'Cm =', Cm, Cm$
      write(*,*) 'Cn =', Cn, Cn$

      write(*,*)
      write(*,*) 'da  = ',da
      write(*,*) 'db  = ',db 
      write(*,*) 'dp  = ',dp 
      write(*,*) 'dq  = ',dq 
      write(*,*) 'dr  = ',dr 
      write(*,*) 'dd1 = ',dd1
      write(*,*) 'dd2 = ',dd2
      write(*,*) 'dd3 = ',dd3
      write(*,*) 'dd4 = ',dd4
c

 2500 format(1x,5(4x,a,4x))
 2510 format(1x,5f12.8)

      write(*,*)
      write(*,2500) ' dCL', ' dCY'
      write(*,2510) dCL, dCY
      write(*,2510) CL$-CL, CY$-CY


      write(*,*)
      write(*,2500) ' dCl',' dCm ',' dCn'
      write(*,2510) dCr, dCm, dCn
      write(*,2510) Cr$-Cr, Cm$-Cm, Cn$-Cn


      write(*,*)
      write(*,2500) 'dCDf',' de '
      write(*,2510) dCDff, de
      write(*,2510) CDff$-CDff, e$-e

C
      STOP
      END



      SUBROUTINE GETVAL(LINE,LKEY,VAL)
      CHARACTER*(*) LINE, LKEY
C
      K = INDEX(LINE,LKEY)
C
      IF(K.GT.0) THEN
        LL = LEN(LINE)
C
        K1 = K + LEN(LKEY)
        K2 =     LEN(LINE)
        IF(K2.LT.K1) RETURN
C
        READ(LINE(K1:K2),*,ERR=10) VAL
      ENDIF
      RETURN
C
 10   WRITE(*,*) 'Read error:', LINE(K1:K2)
      RETURN
      END


      SUBROUTINE STRIP(STRING,NS)
      CHARACTER*(*) STRING
C-------------------------------------------
C     Strips leading blanks off string
C     and returns length of non-blank part.
C-------------------------------------------
      N = LEN(STRING)
C
C---- find last non-blank character
      DO 10 K2=N, 1, -1
        IF(STRING(K2:K2).NE.' ') GO TO 11
   10 CONTINUE
      K2 = 0
   11 CONTINUE
C
C---- find first non-blank character
      DO 20 K1=1, K2
        IF(STRING(K1:K1).NE.' ') GO TO 21
   20 CONTINUE
   21 CONTINUE
C
C---- number of non-blank characters
      NS = K2 - K1 + 1
      IF(NS.EQ.0) RETURN
C
C---- shift STRING so first character is non-blank
      STRING(1:NS) = STRING(K1:K2)
C
C---- pad tail of STRING with blanks
      DO 30 K=NS+1, N
        STRING(K:K) = ' '
   30 CONTINUE
C
      RETURN
      END

C***********************************************************************
C    Module:  aplottp.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE PLOTTP
C-------------------------------------------------
C     Plots circulation, CL, downwash versus y
C-------------------------------------------------
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      CHARACTER OPT*2, LINE*80, YAXTYPE*1, SATYPE*16
      REAL XTMP(2), YTMP(2)
      REAL SLE(NSMAX)
      LOGICAL LCOLHC
      CHARACTER*24 COL1, COL2, COL3, COL4
C
      REAL RINP(3)
      LOGICAL ERROR
C
      DATA  YAXTYPE / 'Y' /
C
      INCLUDE 'MASKS.INC'
C
C--- PLFAC is scale factor adjustment for this whole plot 
C--- WFAC  is scale factor for W axis (as fraction of C axis)
C--- VTITLEFRAC is fraction of vertical axis to use for big label block
      DATA PLFAC, WFAC, VTITLEFRAC / 0.85, 0.5, 0.15 /
C
      SMOD(SS) = SSF*(SS - SOFF)
C
      IF(.NOT.LSOL) THEN
        WRITE(*,*) '*** No flow solution...'
        RETURN
      ENDIF
C
C---- Initialize plot stuff
      SIZEOLD = SIZE
      CHOLD = CH
      SIZE  = 9.0
      CH    = 0.014

C---- line y-spacing factor
      YSP = 2.0
C
C--- define colors used for plot data
      COL1 = 'green'   ! cl c/Cref
      COL2 = 'blue'    ! alpha_i
      COL3 = 'red'     ! cl_perp
ccc   COL4 = 'yellow'  ! cl
      COL4 = 'orange'  ! cl
C
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
      CA = COS(ALFA)
      SA = SIN(ALFA)
      CRSAX = CRTOT*CA + CNTOT*SA
      CMSAX = CMTOT              
      CNSAX = CNTOT*CA - CRTOT*SA  
C
C---- Find the min/max of Y,CL,CNC,downwash
 50   YMIN =  RV1(2,1)
      YMAX =  RV1(2,1)
      ZMIN =  RV1(3,1)
      ZMAX =  RV1(3,1)
      FMIN =  CNC(1)
      FMAX =  CNC(1)
      CMIN = 0.0
      CMAX = 0.0
      WMAX = 0.0
      WMIN = 0.0
      DO I=1, NSTRIP
        IV = IJFRST(I)
        YMIN = MIN( YMIN, RV1(2,IV), RV2(2,IV), 0.0 )
        YMAX = MAX( YMAX, RV1(2,IV), RV2(2,IV), 0.0 )
        ZMIN = MIN( ZMIN, RV1(3,IV), RV2(3,IV), 0.0 )
        ZMAX = MAX( ZMAX, RV1(3,IV), RV2(3,IV), 0.0 )
        FMIN = MIN( FMIN, CNC(I), 0.0 )
        FMAX = MAX( FMAX, CNC(I), 0.0 )
C---- use either min-max or L8 norms for axis length determination
C     L8 prevents large local spikes from giving inappropriate axes
C--- L8 norm
        WMIN = WMIN + MIN( -DWWAKE(I)  , 0.0 ) ** 8
        WMAX = WMAX + MAX( -DWWAKE(I)  , 0.0 ) ** 8
C--- Regular min/max
        CMIN = MIN( CMIN, CLTSTRP(I)   , 0.0 )
        CMAX = MAX( CMAX, CLTSTRP(I)   , 0.0 )
c        WMIN = MIN( WMIN, -DWWAKE(I)  , 0.0 )
c        WMAX = MAX( WMAX, -DWWAKE(I)  , 0.0 )
      END DO
C
C--- Process L8 sums to norms
      IF(WMIN .NE. 0.0) WMIN = -(ABS(WMIN)/NSTRIP) ** 0.125
      IF(WMAX .NE. 0.0) WMAX =  (ABS(WMAX)/NSTRIP) ** 0.125
C
C---- normalized spanload CNC/Cref and CL will have the same axis, so...
      CMIN = MIN(FMIN/CREF,CMIN)
      CMAX = MAX(FMAX/CREF,CMAX)
C
      IF(CMAX-CMIN .LT. 1.0E-5) THEN
       CMIN = 0.0
       CMAX = 0.1
      ENDIF
C
      IF(WMAX-WMIN .LT. 1.0E-5) THEN
       WMIN = 0.0
       WMAX = 0.1
      ENDIF
C
C---- determine "nice" upper,lower bounds on y, z, CNC/Cref, CL, 
C-    and corresponding "nice" number of annotations
      CALL AXISADJ(YMIN,YMAX,YSPAN,DELY,NYANN)
      CALL AXISADJ(ZMIN,ZMAX,ZSPAN,DELZ,NZANN)
      CALL AXISADJ(WMIN,WMAX,WSPAN,DELW,NWANN)
      CALL AXISADJ(CMIN,CMAX,CSPAN,DELC,NCANN)
C
C---- Ratio of W and C scale factors
      WOC = WFAC*(CMAX-CMIN)/(WMAX-WMIN)
C
C
C---- Get down to the plot
C
 100  CONTINUE
      IF(YAXTYPE.EQ.'Y') THEN
        SMIN = YMIN
        SMAX = YMAX
        DELS  = DELY
        DO J = 1, NSTRIP
          SLE(J) = RLE(2,J)
        END DO
       ELSE
        SMIN = ZMIN
        SMAX = ZMAX
        DELS  = DELZ
        DO J = 1, NSTRIP
          SLE(J) = RLE(3,J)
        END DO
      ENDIF
C
 105  CONTINUE
      SSF  = 1.0 / (SMAX-SMIN)
      SOFF = SMIN
      IF(LDWASHPLT ) THEN
       CSF = PLOTAR / (MAX(CMAX,WOC*WMAX)-MIN(CMIN,WOC*WMIN))
C---- Modify CSF to allow portion of vertical space for a big label block
       CSF = (1.0 - VTITLEFRAC)*CSF
       WSF = WOC * CSF
      ELSE
       CSF = PLOTAR / (CMAX-CMIN)
C---- Modify CSF to allow portion of vertical space for a big label block
       CSF = (1.0 - VTITLEFRAC)*CSF
       WSF = 0.0
      ENDIF
C
      CALL PLTINI(IDEV)
C
      CALL NEWFACTOR(PLFAC*SIZE)
      CALL GETCOLOR(ICOL0)
C
C----Offset the X-axis, leaving room on left for labels
      FMIN = MIN(WSF*WMIN,CSF*CMIN)
      CALL PLOT(14.0*CH,6.0*CH-FMIN,-3)
C
C---Put up the Xaxis (suppressing the end annotations)
      CALL NEWPEN(3)
      XLAB = SMOD(SMAX - 1.5*DELS)
      IF(LDWASHPLT ) THEN
       IFLG = 3
      ELSE
       IFLG = 1
      ENDIF
      CALL XAXIS2(0.0,0.0,SSF*(SMAX-SMIN),SSF*DELS,
     &            SMIN,DELS,IFLG,0.9*CH,-2)
      CALL PLCHAR(XLAB-0.7*CH,-3.5*CH,1.2*CH,YAXTYPE,0.,1)
C
C--- cl_perp, cl, cl*c/Cref axis
      CALL NEWPEN(2)
      XLAB = SMOD(SMIN)
C
      IF(LCLPERPLT) THEN
       YLAB = CSF*(CMAX - 0.5*DELC)
       CALL NEWCOLORNAME(COL3)
       CALL PLCHAR(XLAB-6.5*CH,YLAB-0.5*CH,1.2*CH,'c'  ,0., 1)
       CALL PLMATH(XLAB-5.5*CH,YLAB-0.9*CH,0.8*CH, 'V' ,0., 1)
       CALL PLCHAR(XLAB-4.2*CH,YLAB-0.4*CH,0.7*CH,'T'  ,180.0, 1)
      ENDIF
C
      YLAB = CSF*(CMAX - 1.5*DELC)
      CALL NEWCOLORNAME(COL4)
      CALL PLCHAR(XLAB-6.5*CH,YLAB-0.5*CH,1.2*CH,'c'  ,0., 1)
      CALL PLMATH(XLAB-5.5*CH,YLAB-0.9*CH,0.8*CH, 'V' ,0., 1)
C
      YLAB = CSF*(CMAX - 2.5*DELC)
      CALL NEWCOLORNAME(COL1)
      CALL PLCHAR(XLAB-8.5*CH,YLAB-0.5*CH,1.2*CH,'c c/c',0.,5)
      CALL PLCHAR(999.,999.,0.65*CH,'ref',0.,3)
      CALL PLMATH(XLAB-7.5*CH,YLAB-0.9*CH,0.8*CH, 'V'    ,0.,1)
      CALL NEWCOLOR(ICOL0)
      CALL YAXIS(0.0,CSF*CMIN,CSF*(CMAX-CMIN),CSF*DELC,
     &           CMIN,DELC, 0.9*CH,-2)
C
C---Put up a reference grid on the Y/Z and cl_perp, cl, cl*c/Cref axes
      NY = IFIX(0.1 + (SMAX-SMIN)/DELS)
      NC = IFIX(0.1 + (CMAX-CMIN)/DELC)
      CALL PLGRID(0.0,CSF*CMIN,NY,SSF*DELS,NC,CSF*DELC,LMASK2)
C
C---Downwash axis
      IF(LDWASHPLT ) THEN
        CALL NEWPEN(3)
        CALL NEWCOLORNAME(COL2)
        XLAB = SMOD(SMAX)
        YLAB = WSF*(WMIN + 0.5*DELW)
        CALL PLMATH(XLAB+6.5*CH,YLAB-0.4*CH,1.2*CH,'a',0., 1)
        CALL PLCHAR(XLAB+7.6*CH,YLAB-0.8*CH,0.9*CH,'i',0., 1)
        CALL NEWPEN(4)
        CALL YAXIS(SMOD(SMAX),WSF*WMIN,WSF*(WMAX-WMIN),WSF*DELW,
     &             WMIN,DELW,-0.9*CH,-2)
      ENDIF
C
C---Plot the CL,CLC/Cref aand Downwash curves
      CALL NEWPEN(4)
      DO N = 1, NSURF
        J  = JFRST(N)
        JLABCLC = J + 0.33*NJ(N)
        JLABDW  = J + 0.50*NJ(N)
        JLABCL  = J + 0.66*NJ(N)
C
        CALL NEWCOLORNAME(COL4)
        CALL XYLINE(NJ(N),SLE(J),CLASTRP(J),SMIN,SSF,0.0,CSF,2)
        IF(LLABSURF) THEN
          XLAB = SMOD(SLE(JLABCL))         
          YLAB = CSF*CLASTRP(JLABCL)         
          CALL PLNUMB(XLAB+0.5*CH,YLAB+0.5*CH,0.8*CH,FLOAT(N),0.0,-1)
        ENDIF
C
        IF(LCLPERPLT) THEN
         CALL NEWCOLORNAME(COL3)
         CALL XYLINE(NJ(N),SLE(J),CLTSTRP(J),SMIN,SSF,0.0,CSF,3)
         IF(LLABSURF) THEN
           XLAB = SMOD(SLE(JLABCL))         
           YLAB = CSF*CLTSTRP(JLABCL)         
           CALL PLNUMB(XLAB+0.5*CH,YLAB+0.5*CH,0.8*CH,FLOAT(N),0.0,-1)
         ENDIF
        ENDIF
C
        CALL NEWCOLORNAME(COL1)
        CALL XYLINE(NJ(N),SLE(J),CNC(J),SMIN,SSF,0.0,CSF/CREF,1)
        IF(LLABSURF) THEN
          XLAB = SMOD(SLE(JLABCLC))         
          YLAB = CSF/CREF*CNC(JLABCLC)         
          CALL PLNUMB(XLAB+0.5*CH,YLAB+0.5*CH,0.8*CH,FLOAT(N),0.0,-1)
        ENDIF
C
        CALL NEWCOLORNAME(COL2)
        IF(LDWASHPLT ) THEN
          CALL XYLINE(NJ(N),SLE(J),DWWAKE(J),SMIN,SSF,0.0,-WSF,4)
          IF(LLABSURF) THEN
            XLAB = SMOD(SLE(JLABDW))         
            YLAB = -WSF*DWWAKE(JLABDW)         
            CALL PLNUMB(XLAB+0.5*CH,YLAB+0.5*CH,0.8*CH,FLOAT(N),0.0,-1)
          ENDIF
        ENDIF
      END DO
C
C---- Put up curve legends
      CALL NEWPEN(4)
C
      XTMP(1) = 0.75*SMAX 
      XTMP(2) = 0.85*SMAX
      YLAB = MAX(WSF*WMAX,CSF*CMAX) + 12.55*CH
C
      IF(LCLPERPLT) THEN
       CALL NEWCOLORNAME(COL3)
       YTMP(1) = YLAB/CSF
       YTMP(2) = YTMP(1)
       CALL XYLINE(2,XTMP,YTMP,SMIN,SSF,0.0,CSF,3)
       CALL PLCHAR(SMOD(XTMP(2))+1.5*CH,CSF*YTMP(2)-0.5*CH,
     &            1.2*CH,'c'  ,0., 1)
       CALL PLMATH(SMOD(XTMP(2))+2.5*CH,CSF*YTMP(2)-0.9*CH,
     &            0.8*CH, 'V' ,0., 1)
       CALL PLCHAR(SMOD(XTMP(2))+3.8*CH,CSF*YTMP(2)-0.4*CH,
     &            0.7*CH,'T'  ,180.0, 1)
      ENDIF
C
      CALL NEWCOLORNAME(COL4)
      YTMP(1) = YLAB/CSF - YSP*CH/CSF
      YTMP(2) = YTMP(1)
      CALL XYLINE(2,XTMP,YTMP,SMIN,SSF,0.0,CSF,2)
      CALL PLCHAR(SMOD(XTMP(2))+1.5*CH,CSF*YTMP(2)-0.5*CH,
     &            1.2*CH,'c'  ,0., 1)
      CALL PLMATH(SMOD(XTMP(2))+2.5*CH,CSF*YTMP(2)-0.9*CH,
     &            0.8*CH, 'V' ,0., 1)
C
      CALL NEWCOLORNAME(COL1)
      YTMP(1) = YLAB/CSF - 4.4*CH/CSF
      YTMP(2) = YTMP(1)
      CALL XYLINE(2,XTMP,YTMP,SMIN,SSF,0.0,CSF,1)
      CALL PLCHAR(SMOD(XTMP(2))+1.5*CH,CSF*YTMP(2)-0.5*CH,
     &            1.2*CH,'c c/c',0.,5)
      CALL PLCHAR(999.,999.,0.6*CH,'ref',0.,3)
      CALL PLMATH(SMOD(XTMP(2))+2.6*CH,CSF*YTMP(2)-0.9*CH,
     &            0.8*CH, 'V'    ,0.,1)
C
      YTMP(1) = YLAB/CSF - 6.6*CH/CSF
      YTMP(2) = YTMP(1)
      IF(LDWASHPLT) THEN
        CALL NEWCOLORNAME(COL2)
        CALL XYLINE(2,XTMP,YTMP,SMIN,SSF,0.0,CSF,4)
        CALL PLMATH(SMOD(XTMP(2))+1.5*CH,CSF*YTMP(2)-0.7*CH,
     &              1.2*CH,'a',0., 1)
        CALL PLCHAR(SMOD(XTMP(2))+2.6*CH,CSF*YTMP(2)-1.1*CH,
     &              0.9*CH,'i',0., 1)
      ENDIF
C
      CALL NEWPEN(2)
      CALL NEWCOLOR(ICOL0)
C
C
C---- Label Block with flow condition and forces located above plot
      XLAB2 = SMOD(SMAX) - 13.0*0.8*CH
      YLAB2 = CSF*CMAX + 0.9*CH
      CALL PLCHAR(XLAB2,YLAB2,0.8*CH,'Trefftz Plane',0.0,-1)
C
      XLAB2 = SMOD(SMAX) - 8.0*0.8*CH
      YLAB2 = CSF*CMAX + 2.5*CH
      CALL PLCHAR(XLAB2,YLAB2,0.8*CH,'AVL ',0.0,4)
      CALL PLNUMB(999.,999.,0.8*CH,VERSION,0.0,2)
C
c      XLAB = SMOD(SMIN) + 45.5*CH
c      YLAB = CSF*CMAX + 1.0*CH
c      CALL PLCHAR(XLAB,YLAB,0.8*CH,SATYPE,0.0,16)
C
C---- number of control-variable lines
ccc      NCONLIN = (NCONTROL+1)/2
      NCONLIN = MAX( NCONTROL-2 , 0 )
C
C---- Case title
      XLAB = SMOD(SMIN)
      YLAB = MAX(WSF*WMAX,CSF*CMAX) + 15.0*CH + YSP*CH*FLOAT(NCONLIN)
C
      CALL NEWPEN(3)
      CALL PLCHAR(XLAB,YLAB,1.2*CH,TITLE,0.0,LEN(TITLE))
      YLAB = YLAB - YSP*CH
      IF(INDEX(RTITLE(IRUN),'unnamed') .EQ. 0) THEN
       CALL PLCHAR(XLAB,YLAB,1.1*CH,RTITLE(IRUN),0.0,LEN(RTITLE(IRUN)))
      ENDIF
C
      CALL NEWPEN(2)
      XL1 = XLAB
      XL2 = XLAB + 13.5*CH
      XL3 = XLAB + 29.0*CH
      XL4 = XLAB + 43.5*CH
C
      YLAB = YLAB - 0.6*CH
      YLAB = YLAB - YSP*CH
C
C--- Flow condition and forces
      RX = WROT(1)*BREF/2.0
      RY = WROT(2)*CREF/2.0
      RZ = WROT(3)*BREF/2.0
C
      CALL PLMATH(XL1       ,YLAB,1.1*CH,'a'   ,0.0,1)
      CALL PLCHAR(XL1       ,YLAB,CH,'  = ',0.0,4)
      CALL PLNUMB(XL1+4.0*CH,YLAB,CH, ALFA/DTR,0.0,4)
C
      CALL PLCHAR(XL2       ,YLAB,CH,'pb/2V = ',0.0,8)
      CALL PLNUMB(XL2+8.0*CH,YLAB,CH, DIR*RX   ,0.0,4)
C
      CALL PLCHAR(XL3       ,YLAB,CH,'  CL = ',0.0,7)
      CALL PLNUMB(XL3+7.0*CH,YLAB,CH, CLTOT  ,0.0,4)
C
      CALL PLCHAR(XL4       ,YLAB,CH,'  Cl = ',0.0,7)
      CALL PLMATH(XL4       ,YLAB,CH,'    `'  ,0.0,5)
cc    CALL PLNUMB(XL4+7.0*CH,YLAB,CH, DIR*CRTOT ,0.0,4)
      CALL PLNUMB(XL4+7.0*CH,YLAB,CH, DIR*CRSAX ,0.0,4)
C
C
      YLAB = YLAB - YSP*CH
      CALL PLMATH(XL1        ,YLAB,1.1*CH,'b'   ,0.0,1)
      CALL PLCHAR(XL1        ,YLAB,CH,'  = ',0.0,4)
      CALL PLNUMB(XL1+4.0*CH,YLAB,CH, BETA/DTR,0.0,4)
C
      CALL PLCHAR(XL2       ,YLAB,CH,'qc/2V = ',0.0,8)
      CALL PLNUMB(XL2+8.0*CH,YLAB,CH, RY   ,0.0,4)
C
      CALL PLCHAR(XL3       ,YLAB,CH,'  CY = ',0.0,7)
      CALL PLNUMB(XL3+7.0*CH,YLAB,CH, CYTOT   ,0.0,4)
C
      CALL PLCHAR(XL4       ,YLAB,CH,'  Cm = ',0.0,7)
      CALL PLNUMB(XL4+7.0*CH,YLAB,CH, CMTOT   ,0.0,4)
C
C
      YLAB = YLAB - YSP*CH
      CALL PLCHAR(XL1       ,YLAB,CH,'M = ',0.0,4)
      CALL PLNUMB(XL1+4.0*CH,YLAB,CH,AMACH ,0.0,3)
C
      CALL PLCHAR(XL2       ,YLAB,CH,'rb/2V = ',0.0,8)
      CALL PLNUMB(XL2+8.0*CH,YLAB,CH, DIR*RZ  ,0.0,4)
C
      CALL PLCHAR(XL3       ,YLAB,CH,'  CD = ',0.0,7)
      CALL PLNUMB(XL3+7.0*CH,YLAB,CH, CDTOT   ,0.0,5)
C
      CALL PLCHAR(XL4       ,YLAB,CH,'  Cn = ',0.0,7)
      CALL PLMATH(XL4       ,YLAB,CH,'    `'  ,0.0,5)
cc    CALL PLNUMB(XL4+7.0*CH,YLAB,CH, DIR*CNTOT, 0.0,4)
      CALL PLNUMB(XL4+7.0*CH,YLAB,CH, DIR*CNSAX, 0.0,4)
C
C
      YLABI = YLAB
      YLABI = YLABI - YSP*CH
      CALL PLCHAR(XL3       ,YLABI,CH,'  CD = ',0.0,7)
      CALL PLCHAR(XL3+3.8*CH,YLABI-0.4*CH,
     &                         0.8*CH,'i'      ,0.0,1)
      CALL PLNUMB(XL3+7.0*CH,YLABI,CH, CDFF    ,0.0,5)
C
      CALL PLCHAR(XL4       ,YLABI,CH,'   e = ',0.0,7)
      CALL PLNUMB(XL4+7.0*CH,YLABI,CH, SPANEF  ,0.0,4)
C
      YLABI = YLABI - YSP*CH
      CALL PLCHAR(XL3       ,YLABI,CH,'  CD = ',0.0,7)
      CALL PLCHAR(XL3+3.8*CH,YLABI-0.4*CH,
     &                         0.8*CH,'p'      ,0.0,1)
      CALL PLNUMB(XL3+7.0*CH,YLABI,CH, CDVTOT  ,0.0,5)
C
      YLAB = YLAB - 0.3*CH

      NUMD = 0
      DO N = 1, NCONTROL
        CALL STRIP(DNAME(N),NUMDK)
        NUMD = MAX(NUMD,NUMDK)
      ENDDO
      DO N = 1, NCONTROL
        XLAB = XL1
        YLAB = YLAB - YSP*CH
        CALL PLCHAR(XLAB,YLAB,CH,DNAME(N) ,0.0,NUMD)
        CALL PLCHAR(999.,YLAB,CH,' = '    ,0.0,3)
        CALL PLNUMB(999.,YLAB,CH,DELCON(N),0.0,4)
      ENDDO
C
      CALL PLFLUSH
C
C*********************************************************
C
   15 LCOLHC = IDEVH.EQ.4
      WRITE(*,1010) LCLPERPLT, LDWASHPLT, LLABSURF, LCOLHC
   16 WRITE(*,1030)
C
 1010 FORMAT(/' ======================================================'
     &       /'   Y plot data vs Y'
     &       /'   Z plot data vs Z'
     &       /'   P erpendicular cl plot toggle (currently ',L2,')'
     &       /'   D ownwash angle   plot toggle (currently ',L2,')'
     &      //'   L imits for plot'
     &       /'   R eset plot limits'
     &      //'   N umber surfaces toggle (currently ',L2,')'
     &       /'   C olor hardcopy  toggle (currently ',L2,')'
     &       /'   A nnotate plot'
     &       /'   H ardcopy current plot'
     &      //'   ZM zoom'
     &       /'   U nzoom'
     &       /'   S ize change'/)
 1030 FORMAT( ' Trefftz plot command: ',$)
C
      READ(*,1000) OPT
      CALL TOUPER(OPT) 
 1000 FORMAT(A)
C
      IF(OPT.EQ.' ') THEN
        CALL CLRZOOM
        CALL PLEND
        SIZE = SIZEOLD
        CH = CHOLD
        WRITE(*,*) ' '
        RETURN
C
C---- Reset plot limits
      ELSEIF(OPT.EQ.'R') THEN
        GO TO 50
C
C---- Set plot limits
       ELSE IF(OPT.EQ.'L') THEN
        WRITE(*,*) 'Enter new plot limits (<return> for no change)'
        RINP(1) = SMIN
        RINP(2) = SMAX
        RINP(3) = DELS
        WRITE(*,32) SMIN,SMAX,DELS
 32     FORMAT('    xmin,xmax,xdel: ',3G12.6)
        CALL READR(3,RINP,ERROR)
        IF(ERROR) GO TO 15
        SMIN = RINP(1)
        SMAX = RINP(2)
        DELS = RINP(3)
C
        RINP(1) = CMIN
        RINP(2) = CMAX
        RINP(3) = DELC
        WRITE(*,34) CMIN,CMAX,DELC
 34     FORMAT('    ymin,ymax,ydel: ',3G12.6)
        CALL READR(3,RINP,ERROR)
        IF(ERROR) GO TO 15
        CMIN = RINP(1)
        CMAX = RINP(2)
        DELC = RINP(3)
        GO TO 105
C
C---- Use Y as abscissa for plot
      ELSEIF(OPT.EQ.'Y') THEN
        YAXTYPE = 'Y'
        GO TO 100
C
C---- Use Z as abscissa for plot
      ELSEIF(OPT.EQ.'Z') THEN
        YAXTYPE = 'Z'
        GO TO 100
C
C---- Zoom in on plot
      ELSEIF(OPT.EQ.'ZM') THEN
        CALL USETZOOM(.FALSE.,.TRUE.)
        CALL REPLOT(IDEV)
        GO TO 15
C
C---- Reset zoom on plot
      ELSEIF(OPT.EQ.'U') THEN
        CALL CLRZOOM
        CALL REPLOT(IDEV)
C
C---- Set plot size
      ELSEIF(OPT.EQ.'S') THEN
   10   WRITE(*,*)
        WRITE(*,*) 'Currently SIZE = ',SIZE*PLFAC
   12   WRITE(*,5050)
 5050   FORMAT(' Enter new value:  ',$)
        READ (*,*,ERR=12,END=15) SPLF
        PLFAC = SPLF/SIZE
        CALL CLRZOOM
        GO TO 100
C
C---- Number loadings by surface index
      ELSEIF(OPT.EQ.'N') THEN
        LLABSURF = .NOT.LLABSURF
        GO TO 100
C
C---- Annotate plot
      ELSEIF(OPT.EQ.'A') THEN
        WRITE(*,*)
        WRITE(*,*) '================================='
        CALL ANNOT(CH)
        GO TO 15
C
C---- Hardcopy color toggle
      ELSEIF(OPT.EQ.'C') THEN
        LCOLHC = .NOT. LCOLHC
        IF(LCOLHC) THEN
         IDEVH = 4
        ELSE
         IDEVH = 2
        ENDIF
        GO TO 15
C
C---- Hardcopy plot
      ELSEIF(OPT.EQ.'H') THEN
        CALL REPLOT(IDEVH)
C
C---- Toggle display of cl_perp on plot
      ELSEIF(OPT.EQ.'P') THEN
        LCLPERPLT = .NOT.LCLPERPLT
        CALL CLRZOOM
        GO TO 100
C
C---- Toggle display of downwash on plot
      ELSEIF(OPT.EQ.'D') THEN
        LDWASHPLT = .NOT.LDWASHPLT
        CALL CLRZOOM
        GO TO 100
C
      ENDIF
C
      GO TO 16
      END ! PLOTTP

      SUBROUTINE MOVIE(AZIM, ELEV, TILT, RINV, KEIG, IR)
C
C----Plotting module for AVL vortex lattice program
C
C    Plots geometry and loading results for vortex lattice
C     Geometry plots:
C       Surfaces     (straight tapered panels of chordwise strips of vortices)
C       Strips       (chordwise strips of vortices)
C       Vortex legs  (bound vortex legs)
C       Control pts  (vortex element control points)
C       Camber slope (camber of each strip - used for establishing BC's)
C       Hinge lines  (surface deflection axis and deflected surface outline)
C       Strip loading (chordwise plot of vortex loading on each strip)
C
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      LOGICAL LKEYS, LEVIEW, LCPAN
      LOGICAL ERROR
      LOGICAL LINITVIEW, LFIRST
      SAVE    LINITVIEW
      CHARACTER*4 OPT
      CHARACTER*1 CHKEY, ANS
C
      REAL ANGE(3), POSE(3)
      REAL ANG(3), POS(3), ANGP(3),DANG(3)
      REAL TT(3,3), TT_ANG(3,3,3),
     &     RT(3,3), RT_ANG(3,3,3)
C
      REAL EVR(JEMAX)
C
      REAL RINP(10)
C
C---- viewpoint changes (deg), zoom/unzoom, perspective scale factors
      DATA DAZIM, DELEV, ZUFAC, PRAT / 5.0 , 5.0 , 1.5 , 1.1 /
C
C---- phase step and scale factor step for interactive phase plots
      DATA DPHASE, SCALEF / 5.0 , 1.25 /
C
C
C---- Initialization for plot program variables
      IF(LPLTNEW .OR. (.NOT.LPLOT)) THEN 
        LPLTNEW = .FALSE.
        LINITVIEW = .FALSE.
      ENDIF
C
      LFIRST = .TRUE.
C
C---- default is camera pans with aircraft
      LCPAN = .TRUE.
C
C---- initial phase and eigenvector scale
      EPHASE = 0.
      EIGENF = 1.
C
C---- find geometry limits
      CALL GLIMS(GMIN,GMAX,.FALSE.)
C
C***************************************************
C---- Setup view transformation 
    4 CALL VIEWINIT(AZIM, ELEV, TILT, RINV)
      CALL VIEWPROJ(UNT,3,ORG)
C
C***************************************************
C
      SIGMA = REAL(EVAL(KEIG,IR))
      OMEGA = IMAG(EVAL(KEIG,IR))
      EVMAG = ABS( EVAL(KEIG,IR) )
C
      DAMP = -SIGMA / EVMAG
C
C---- set reasonable plot time interval, cycle it only once
      TPLOT = 1.0 / MAX( SLOMOF*ABS(SIGMA)/(2.0*PI) , 
     &                   SLOMOF*ABS(OMEGA)/(8.0*PI) ,
     &                   1.0/TMOVIE )
C
      write(*,*) 's', ABS(SIGMA)/(2.0*PI)
      write(*,*) 'w', ABS(OMEGA)/(8.0*PI)
      write(*,*) 'T', 1.0/TMOVIE
C
c 53     RINPUT(1) = TMOVIE
c        WRITE(*,1163) RINPUT(1), UNCHT(1:NUT)
c 1163   FORMAT(/' Enter play time of movie:', F10.3,' (',A,')')
c        CALL READR(1,RINPUT,ERROR)
c        IF(ERROR) GO TO 53
c        TMOVIE = RINPUT(1)

C-----------------------------------------------------------
C---- make sure we don't get trapped in very long movie
      REALT = TPLOT/SLOMOF
      IF(REALT .GT. 20.0) THEN
       WRITE(*,*) 'Movie will require real time =', REALT
       WRITE(*,*) 'Continue with new slo-mo factor?  Y'
       READ (*,1000) ANS
 1000  FORMAT(A)
       IF(INDEX('Nn',ANS).NE.0) RETURN
C
       WRITE(*,*) 'Enter slow-motion factor (bigger = faster):', SLOMOF
       CALL READR(1,SLOMOF,ERROR)
      ENDIF
C-----------------------------------------------------------
C



C***************************************************
C---- compute perturbed position at current phase angle
    6 CONTINUE
C
      VEE = PARVAL(IPVEE,IR)
      REFL = BREF*UNITL
      REFV = VEE
C
      EVMIN = (REFV/REFL) * 1.0E-5
C
      SIGMA = REAL(EVAL)
      OMEGA = IMAG(EVAL)
      EVMAG = SQRT(SIGMA**2 + OMEGA**2)
C
      CALL EVNORM(EVEC,ESF,REFL,REFV)
      EFAC = ESF*EIGENF
C


C---- set time using specified phase
      IF(EVMAG .LT. EVMIN) THEN
       TIMED = EPHASE*DTR / EVMIN
C
      ELSE
       TIMED = EPHASE*DTR / MAX( ABS(OMEGA) , ABS(SIGMA) )
C
      ENDIF
C


      CALL EVREAL(EVEC(1,KEIG,IR),EVAL(KEIG,IR), EFAC,TIMED, EVR)
C

C
C---- scale from standard (SI or English) to AVL units
      TIME = TIMED*VEE/UNITL
C
      EVR(JEX) = EVR(JEX)/UNITL
      EVR(JEY) = EVR(JEY)/UNITL
      EVR(JEZ) = EVR(JEZ)/UNITL
C
      EVR(JEU) = EVR(JEU)/VEE
      EVR(JEV) = EVR(JEV)/VEE
      EVR(JEW) = EVR(JEW)/VEE
C
      EVR(JEP) = EVR(JEP)*UNITL/VEE
      EVR(JEQ) = EVR(JEQ)*UNITL/VEE
      EVR(JER) = EVR(JER)*UNITL/VEE
C
CCC   EVR(JEPH) = EVR(JEPH)
CCC   EVR(JETH) = EVR(JETH)
CCC   EVR(JEPS) = EVR(JEPS)
C
C
C
c      write(*,*)
c      write(*,*) 'xyz', evr(jex),evr(jey),evr(jez)
c      write(*,*) 'uvw', evr(jeu),evr(jev),evr(jew)
c      write(*,*) 'pqr', evr(jep),evr(jeq),evr(jer)
c      write(*,*) 'reh', evr(jeph),evr(jeth),evr(jeps)

C
C---- set perturbed Earth-coordinate position
      IF(LCPAN) THEN
C----- camera panning... no baseline movement
       POS(1) = 0.
       POS(2) = 0.
       POS(3) = 0.
C
       ANG(1) = PARVAL(IPPHI,IR)*DTR
       ANG(2) = PARVAL(IPTHE,IR)*DTR
       ANG(3) = PARVAL(IPPSI,IR)*DTR
C
      ELSE
C----- camera is fixed... include aicraft motion, integrated up to present time
C
C----- sat baseline velocities and rotation rates
       ALFA = PARVAL(IPALFA,IR)*DTR
       BETA = PARVAL(IPBETA,IR)*DTR
       CALL VINFAB
       WROT(1) = PARVAL(IPROTX,IR)*2.0/BREF
       WROT(2) = PARVAL(IPROTY,IR)*2.0/CREF
       WROT(3) = PARVAL(IPROTZ,IR)*2.0/BREF
C
C----- set time step based on max Euler angle change
       RMAX = MAX( ABS(WROT(1)) , ABS(WROT(2)) , ABS(WROT(3)) )
       DAMAX = RMAX*ABS(TIME)
       NTIME = INT( DAMAX / 0.025 )
C
C----- set initial position,angles at t=0
       POS(1) = 0.
       POS(2) = 0.
       POS(3) = 0.
       ANG(1) = PARVAL(IPPHI,IR)*DTR
       ANG(2) = PARVAL(IPTHE,IR)*DTR
       ANG(3) = PARVAL(IPPSI,IR)*DTR
       CALL RATEKI3(ANG,RT,RT_ANG)
C
C----- integrate over time interval  t = 0..TIME
       DO ITIME = 1, NTIME
         DT = TIME/FLOAT(NTIME)
C
C------- predictor step, slopes evaluated at  t
         DO K = 1, 3
           DANG(K) = DT*( RT(K,1)*WROT(1)
     &                  + RT(K,2)*WROT(2)
     &                  + RT(K,3)*WROT(3) )
           ANGP(K) = ANG(K) + DANG(K)
         ENDDO
         CALL RATEKI3(ANGP,RT,RT_ANG)
C
C------- corrector step, slopes evaluated at  t + dt
         DO K = 1, 3
           DANGP = DT*( RT(K,1)*WROT(1)
     &                + RT(K,2)*WROT(2)
     &                + RT(K,3)*WROT(3) )
C--------- midpoint angles at  t + dt/2
           ANGP(K) = ANG(K) + 0.25*(DANG(K) + DANGP)
         ENDDO
C
C------- use midpoint-angle matrices
         CALL RATEKI3(ANGP,RT,RT_ANG)
         CALL ROTENS3(ANGP,TT,TT_ANG)
C
C------- final integration step, using midpoint slopes
         DO K = 1, 3
           POS(K) = POS(K) - DT*( TT(K,1)*VINF(1)
     &                          + TT(K,2)*VINF(2)
     &                          + TT(K,3)*VINF(3) )
           ANG(K) = ANG(K) + DT*( RT(K,1)*WROT(1)
     &                          + RT(K,2)*WROT(2)
     &                          + RT(K,3)*WROT(3) )
         ENDDO
       ENDDO
C
      ENDIF
C
C---- set final position, including eigenvector perturbation
      POSE(1) = POS(1) + EVR(JEX)
      POSE(2) = POS(2) + EVR(JEY)
      POSE(3) = POS(3) + EVR(JEZ)
C
C---- set final angles, including eigenvector perturbation
      ANGE(1) = ANG(1) + EVR(JEPH)
      ANGE(2) = ANG(2) + EVR(JETH)
      ANGE(3) = ANG(3) + EVR(JEPS)
C
C
c      CALL RATEKI3(ANG,RT,RT_ANG)
c      DO K = 1, 3
c        DANG(K) =    RT(K,1)*WROT(1)
c     &             + RT(K,2)*WROT(2)
c     &             + RT(K,3)*WROT(3)
c      ENDDO
c      write(1,1234) ( pos(k)/12.0, k=1, 3),
c     &              ( ang(k)/dtr , k=1, 3),
c     &              ( dang(k)*bref/dtr    , k=1, 3)
c      write(2,1234) (pose(k)/12.0, k=1, 3), (ange(k)/dtr, k=1, 3)
c 1234 format(1x,9f10.3)
C
C
C
      XYZREF(1) = PARVAL(IPXCG,IR)
      XYZREF(2) = PARVAL(IPYCG,IR)
      XYZREF(3) = PARVAL(IPZCG,IR)
C
C---- set limits for baseline position
      CALL ROTENS3(ANG,TT,TT_ANG)
      CALL GRLIMS(VMINP,VMAXP,.TRUE. ,TT ,XYZREF,POS )
      IF(LFIRST) THEN
C----- first frame... set plot limits directly
       XMIN = VMINP(1)
       YMIN = VMINP(2)
       XMAX = VMAXP(1)
       YMAX = VMAXP(2)
      ELSE
C----- clip to new limits
       XMIN = MIN(XMIN,VMINP(1))
       YMIN = MIN(YMIN,VMINP(2))
       XMAX = MAX(XMAX,VMAXP(1))
       YMAX = MAX(YMAX,VMAXP(2))
      ENDIF
      LFIRST = .FALSE.
C
C
C---- also enforce limits for perturbed position
      CALL ROTENS3(ANGE,TT,TT_ANG)
      CALL GRLIMS(VMINP,VMAXP,.TRUE. ,TT ,XYZREF,POSE)
      XMIN = MIN(XMIN,VMINP(1))
      YMIN = MIN(YMIN,VMINP(2))
      XMAX = MAX(XMAX,VMAXP(1))
      YMAX = MAX(YMAX,VMAXP(2))
C
      CALL OFFINI
C
C***************************************************
C---- plot the baseline and displaced geometry
    8 CONTINUE
      CALL PVLINI(TITLE,AZIM,ELEV,TILT,VERSION,LSVMOV)
C
      CALL GETWINSIZE(XWIND,YWIND)
C
      CCH = 0.8*CH
      XPLT = XABS2USR(PMARG)
      YPLT = YABS2USR(YWIND-PMARG) - 1.2*CCH
C
      CALL PLCHAR(XPLT,YPLT,CCH,'Run  ',0.0,5)
      CALL PLNUMB(999.,YPLT,CCH,FLOAT(IR),0.0,-1)
C
      YPLT = YPLT - 2.2*CCH
      CALL PLCHAR(XPLT,YPLT,CCH,'Mode ',0.0,5)
      CALL PLNUMB(999.,YPLT,CCH,FLOAT(KEIG),0.0,-1)
C
      YPLT = YPLT - 2.2*CCH
      FRQ = OMEGA / (2.0*PI)
      CALL PLCHAR(XPLT,YPLT,CCH,'f = ',0.0,4)
      CALL PLNUMB(999.,YPLT,CCH,FRQ,0.0,4)
      CALL PLCHAR(999.,YPLT,CCH,' cycles/' ,0.0,8)
      CALL PLCHAR(999.,YPLT,CCH,UNCHT(1:NUT),0.0,NUT)
C
      YPLT = YPLT - 2.2*CCH
      IF(SIGMA .EQ. 0.0) THEN
       DAMPR = 0.
      ELSE
       DAMPR = -SIGMA / SQRT(SIGMA**2 + OMEGA**2)
      ENDIF
      CALL PLMATH(XPLT,YPLT,CCH,'z = ',0.0,4)
      CALL PLNUMB(999.,YPLT,CCH,DAMPR,0.0,6)
C
      YPLT = YPLT - 2.2*CCH
      CALL PLMATH(XPLT,YPLT,CCH,'f = ',0.0, 4)
      CALL PLNUMB(999.,YPLT,CCH,EPHASE,0.0,-1)
      CALL PLMATH(999.,YPLT,CCH,   '"',0.0, 1)
C
C---- Setup hidden line data
      CALL HIDINITE(.TRUE., ANGE,POSE,XYZREF)
C
      CALL PLOTMODE(ANG ,POS ,XYZREF,0)
      CALL PLOTMODE(ANGE,POSE,XYZREF,1)
      CALL PLFLUSH
C
ccc      CALL DRAWTOSCREEN

C***********************************************************************
C    Module:  aero.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE AERO
      INCLUDE 'AVL.INC'
C
      CDTOT = 0.
      CLTOT = 0.
      CXTOT = 0.
      CYTOT = 0.
      CZTOT = 0.
      CRTOT = 0.
      CMTOT = 0.
      CNTOT = 0.
      CDVTOT = 0.
C
      CDTOT_A = 0.
      CLTOT_A = 0.
C
      DO L = 1, NCONTROL
        CHINGE(L) = 0.
      ENDDO
C
      DO N=1, NUMAX
        CDTOT_U(N) = 0.
        CLTOT_U(N) = 0.
        CXTOT_U(N) = 0.
        CYTOT_U(N) = 0.
        CZTOT_U(N) = 0.
        CRTOT_U(N) = 0.
        CMTOT_U(N) = 0.
        CNTOT_U(N) = 0.
        DO L = 1, NCONTROL
          CHINGE_U(L,N) = 0.
        ENDDO
      ENDDO
C
      DO N=1, NCONTROL
        CDTOT_D(N) = 0.
        CLTOT_D(N) = 0.
        CXTOT_D(N) = 0.
        CYTOT_D(N) = 0.
        CZTOT_D(N) = 0.
        CRTOT_D(N) = 0.
        CMTOT_D(N) = 0.
        CNTOT_D(N) = 0.
        DO L = 1, NCONTROL
          CHINGE_D(L,N) = 0.
        ENDDO
      ENDDO
C
      DO N=1, NDESIGN
        CDTOT_G(N) = 0.
        CLTOT_G(N) = 0.
        CXTOT_G(N) = 0.
        CYTOT_G(N) = 0.
        CZTOT_G(N) = 0.
        CRTOT_G(N) = 0.
        CMTOT_G(N) = 0.
        CNTOT_G(N) = 0.
        DO L = 1, NCONTROL
          CHINGE_G(L,N) = 0.
        ENDDO
      ENDDO

C
      CALL SFFORC
      CALL BDFORC
      CALL TPFORC
C
C---------------------------------------------------------
C---- add baseline reference CD
c      SINA = SIN(ALFA)
c      COSA = COS(ALFA)
C
      VSQ = VINF(1)**2 + VINF(2)**2 + VINF(3)**2
      VMAG = SQRT(VSQ)
C
      CDVTOT = CDVTOT + CDREF*VSQ
C
      CDTOT = CDTOT + CDREF*VSQ
      CXTOT = CXTOT + CDREF*VINF(1)*VMAG
      CYTOT = CYTOT + CDREF*VINF(2)*VMAG
      CZTOT = CZTOT + CDREF*VINF(3)*VMAG
C
      CXTOT_U(1) = CXTOT_U(1) + CDREF*VMAG
      CYTOT_U(2) = CYTOT_U(2) + CDREF*VMAG
      CZTOT_U(3) = CZTOT_U(3) + CDREF*VMAG
      DO IU = 1, 3
        CDTOT_U(IU) = CDTOT_U(IU) + CDREF*    2.0*VINF(IU)
        CXTOT_U(IU) = CXTOT_U(IU) + CDREF*VINF(1)*VINF(IU)/VMAG
        CYTOT_U(IU) = CYTOT_U(IU) + CDREF*VINF(2)*VINF(IU)/VMAG
        CZTOT_U(IU) = CZTOT_U(IU) + CDREF*VINF(3)*VINF(IU)/VMAG
      ENDDO
C
      RETURN
      END ! AERO



      SUBROUTINE SFFORC
C
C...PURPOSE  To calculate the forces on the configuration,
C            by vortex, strip and surface.
C
C...INPUT    Global Data in labelled commons, defining configuration
C            ALFA       Angle of attack (for stability-axis definition)
C            VINF()     Freestream velocity components
C            WROT()     Roll,Pitch,Yaw  rates
C            MACH       Mach number
C            NVOR       Number of vortices
C            R1         Coordinates of endpoint #1 of bound vortex
C            R2         Coordinates of endpoint #2 of bound vortex
C            ENV        Normal vector at bound vortex midpoint
C            DX         X-length of vortex lattice panel
C            NVSTRP     No. of vortices in strip
C          
C...OUTPUT   DCP                   Vortex element loadings
C            CXYZTOT                Total force,moment coefficients
C            CDFF                  Far-field drag (Trefftz plane)
C            CxxSURF               Surface force,moment coefficients
C            CxxSTRP               Strip force coefficients
C            CNC                   Span load for each strip
C
C...COMMENTS   
C
      INCLUDE 'AVL.INC'
C
      REAL RROT(3)
      REAL VEFF(3)    , VROT(3)  ,
     &     VEFF_U(3,6), VROT_U(3), WROT_U(3)
      REAL VPERP(3)
      REAL G(3), R(3), RH(3), MH(3)
      REAL F(3), F_U(3,6)
      REAL FGAM(3), FGAM_U(3,6), FGAM_D(3,NDMAX), FGAM_G(3,NGMAX)
      REAL ENAVE(3), SPN(3), UDRAG(3), ULIFT(3)
C
      REAL CFX_U(NUMAX), CFY_U(NUMAX), CFZ_U(NUMAX),
     &     CMX_U(NUMAX), CMY_U(NUMAX), CMZ_U(NUMAX), 
     &     CFX_D(NDMAX), CFY_D(NDMAX), CFZ_D(NDMAX),
     &     CMX_D(NDMAX), CMY_D(NDMAX), CMZ_D(NDMAX),
     &     CFX_G(NGMAX), CFY_G(NGMAX), CFZ_G(NGMAX),
     &     CMX_G(NGMAX), CMY_G(NGMAX), CMZ_G(NGMAX),
     &     CLV_U(NUMAX),
     &     CLV_D(NDMAX),
     &     CLV_G(NGMAX)
C
C
      SINA = SIN(ALFA)
      COSA = COS(ALFA)
C
C***********************************************************************
C...Integrate the forces strip-wise, surface-wise and total-wise
C***********************************************************************
C
C...Calculate strip forces...
C    normalized to strip reference quantities (strip area, chord)
      DO 100 J = 1, NSTRIP
C
        I1  = IJFRST(J)
        NVC = NVSTRP(J)
C
        CR = CHORD(J)
        SR = CHORD(J)*WSTRIP(J)
C
        XTE1 = RLE1(1,J) + CHORD1(J)
        XTE2 = RLE2(1,J) + CHORD2(J)
C
C--- Define local strip lift and drag directions
C--- The "spanwise" vector is cross product of strip normal with X chordline 
        SPN(1) =  0.0
        SPN(2) =  ENSZ(J)
        SPN(3) = -ENSY(J)
C--- Stability axes stream vector defines drag direction
        UDRAG(1) = COSA
        UDRAG(2) = 0.0
        UDRAG(3) = SINA
C--- Lift direction is vector product of "stream" and spanwise vector
        CALL CROSS(UDRAG,SPN,ULIFT)
        ULMAG = SQRT(DOT(ULIFT,ULIFT))
        IF(ULMAG.EQ.0.) THEN
          ULIFT(3) = 1.0
         ELSE
          ULIFT(1) = ULIFT(1)/ULMAG
          ULIFT(2) = ULIFT(2)/ULMAG
          ULIFT(3) = ULIFT(3)/ULMAG
        ENDIF
C
C...Use the strip 1/4 chord location for strip moments
        XR  = RLE(1,J) + 0.25*CR
        YR  = RLE(2,J)
        ZR  = RLE(3,J)
C
        CFX = 0.
        CFY = 0.
        CFZ = 0.
        CMX = 0.
        CMY = 0.
        CMZ = 0.
        CNC(J) = 0.
C
        DO N=1, NUMAX
          CFX_U(N) = 0.
          CFY_U(N) = 0.
          CFZ_U(N) = 0.
          CMX_U(N) = 0.
          CMY_U(N) = 0.
          CMZ_U(N) = 0.
          CNC_U(J,N) = 0.
        ENDDO
C
        DO N=1, NCONTROL
          CFX_D(N) = 0.
          CFY_D(N) = 0.
          CFZ_D(N) = 0.
          CMX_D(N) = 0.
          CMY_D(N) = 0.
          CMZ_D(N) = 0.
          CNC_D(J,N) = 0.
        ENDDO
C
        DO N=1, NDESIGN
          CFX_G(N) = 0.
          CFY_G(N) = 0.
          CFZ_G(N) = 0.
          CMX_G(N) = 0.
          CMY_G(N) = 0.
          CMZ_G(N) = 0.
          CNC_G(J,N) = 0.
        ENDDO
C
C...Sum the forces in the strip as generated by velocity
C    (freestream + rotation + induced) acting on bound vortex 
        DO 40 II = 1, NVC
          I = I1 + (II-1)
C
C------- local moment reference vector from vortex midpoint to strip c/4 pt.
c          R(1) = 0.5*(RV1(1,I) + RV2(1,I)) - XR
c          R(2) = 0.5*(RV1(2,I) + RV2(2,I)) - YR
c          R(3) = 0.5*(RV1(3,I) + RV2(3,I)) - ZR
          R(1) = RV(1,I) - XR
          R(2) = RV(2,I) - YR
          R(3) = RV(3,I) - ZR
C
C------- vector from rotation axes
c          RROT(1) = 0.5*(RV1(1,I) + RV2(1,I)) - XYZREF(1)
c          RROT(2) = 0.5*(RV1(2,I) + RV2(2,I)) - XYZREF(2)
c          RROT(3) = 0.5*(RV1(3,I) + RV2(3,I)) - XYZREF(3)
          RROT(1) = RV(1,I) - XYZREF(1)
          RROT(2) = RV(2,I) - XYZREF(2)
          RROT(3) = RV(3,I) - XYZREF(3)
C
C-------- set total effective velocity = freestream + rotation + induced
          CALL CROSS(RROT,WROT,VROT)
          VEFF(1) = VINF(1) + VROT(1) + WV(1,I)
          VEFF(2) = VINF(2) + VROT(2) + WV(2,I)
          VEFF(3) = VINF(3) + VROT(3) + WV(3,I)
C
C-------- set VEFF sensitivities to freestream,rotation components
          DO K = 1, 3
            VEFF_U(1,K) = WV_U(1,I,K)
            VEFF_U(2,K) = WV_U(2,I,K)
            VEFF_U(3,K) = WV_U(3,I,K)
            VEFF_U(K,K) = 1.0  +  VEFF_U(K,K)
          ENDDO
          DO K = 4, 6
            WROT_U(1) = 0.
            WROT_U(2) = 0.
            WROT_U(3) = 0.
            WROT_U(K-3) = 1.0
            CALL CROSS(RROT,WROT_U,VROT_U)
            VEFF_U(1,K) = VROT_U(1) + WV_U(1,I,K)
            VEFF_U(2,K) = VROT_U(2) + WV_U(2,I,K)
            VEFF_U(3,K) = VROT_U(3) + WV_U(3,I,K)
          ENDDO
C
C-------- Force coefficient on vortex segment is 2(Veff x Gamma)
          G(1) = RV2(1,I)-RV1(1,I)
          G(2) = RV2(2,I)-RV1(2,I)
          G(3) = RV2(3,I)-RV1(3,I)
          CALL CROSS(VEFF, G, F)
          DO N = 1, NUMAX
            CALL CROSS(VEFF_U(1,N), G, F_U(1,N))
          ENDDO
C
          FGAM(1) = 2.0*GAM(I)*F(1)
          FGAM(2) = 2.0*GAM(I)*F(2)
          FGAM(3) = 2.0*GAM(I)*F(3)
          DO N = 1, NUMAX
            FGAM_U(1,N) = 2.0*GAM_U(I,N)*F(1) + 2.0*GAM(I)*F_U(1,N)
            FGAM_U(2,N) = 2.0*GAM_U(I,N)*F(2) + 2.0*GAM(I)*F_U(2,N)
            FGAM_U(3,N) = 2.0*GAM_U(I,N)*F(3) + 2.0*GAM(I)*F_U(3,N)
          ENDDO
          DO N = 1, NCONTROL
            FGAM_D(1,N) = 2.0*GAM_D(I,N)*F(1)
            FGAM_D(2,N) = 2.0*GAM_D(I,N)*F(2)
            FGAM_D(3,N) = 2.0*GAM_D(I,N)*F(3)
          ENDDO
          DO N = 1, NDESIGN
            FGAM_G(1,N) = 2.0*GAM_G(I,N)*F(1)
            FGAM_G(2,N) = 2.0*GAM_G(I,N)*F(2)
            FGAM_G(3,N) = 2.0*GAM_G(I,N)*F(3)
          ENDDO
C
C
C-------- Delta Cp (loading across lifting surface) from vortex 
          FNV = DOT(ENV(1,I),FGAM)
          DCP(I) = FNV / (DXV(I)*WSTRIP(J))
C
          DO N = 1, NUMAX
            FNV_U = DOT(ENV(1,I),FGAM_U(1,N))
            DCP_U(I,N) = FNV_U / (DXV(I)*WSTRIP(J))
          ENDDO
C
          DO N = 1, NCONTROL
            FNV_D = DOT(ENV(1,I),FGAM_D(1,N)) + DOT(ENV_D(1,I,N),FGAM)
            DCP_D(I,N) = FNV_D / (DXV(I)*WSTRIP(J))
          ENDDO
C
          DO N = 1, NDESIGN
            FNV_G = DOT(ENV(1,I),FGAM_G(1,N)) + DOT(ENV_G(1,I,N),FGAM)
            DCP_G(I,N) = FNV_G / (DXV(I)*WSTRIP(J))
          ENDDO
C
C-------- vortex contribution to strip forces
          DCFX = FGAM(1) / SR
          DCFY = FGAM(2) / SR
          DCFZ = FGAM(3) / SR
C
C-------- forces normalized by strip area
          CFX = CFX +  DCFX
          CFY = CFY +  DCFY
          CFZ = CFZ +  DCFZ
C
C-------- moments referred to strip c/4 pt., normalized by strip chord and area
          CMX = CMX + (DCFZ*R(2) - DCFY*R(3))/CR
          CMY = CMY + (DCFX*R(3) - DCFZ*R(1))/CR
          CMZ = CMZ + (DCFY*R(1) - DCFX*R(2))/CR
C
C-------- accumulate strip spanloading = c*CN
          CNC(J) = CNC(J) + CR*(ENSY(J)*DCFY + ENSZ(J)*DCFZ)
C
C-------- freestream and rotation derivatives
          DO N=1, NUMAX
            DCFX_U = FGAM_U(1,N)/SR
            DCFY_U = FGAM_U(2,N)/SR
            DCFZ_U = FGAM_U(3,N)/SR
C
            CFX_U(N) = CFX_U(N) +  DCFX_U
            CFY_U(N) = CFY_U(N) +  DCFY_U
            CFZ_U(N) = CFZ_U(N) +  DCFZ_U
            CMX_U(N) = CMX_U(N) + (DCFZ_U*R(2) - DCFY_U*R(3))/CR
            CMY_U(N) = CMY_U(N) + (DCFX_U*R(3) - DCFZ_U*R(1))/CR
            CMZ_U(N) = CMZ_U(N) + (DCFY_U*R(1) - DCFX_U*R(2))/CR
C
            CNC_U(J,N) = CNC_U(J,N) 
     &                 + CR*(ENSY(J)*DCFY_U + ENSZ(J)*DCFZ_U)
          ENDDO
C
C-------- control derivatives
          DO N=1, NCONTROL
            DCFX_D = FGAM_D(1,N)/SR
            DCFY_D = FGAM_D(2,N)/SR
            DCFZ_D = FGAM_D(3,N)/SR
C
            CFX_D(N) = CFX_D(N) +  DCFX_D
            CFY_D(N) = CFY_D(N) +  DCFY_D
            CFZ_D(N) = CFZ_D(N) +  DCFZ_D
            CMX_D(N) = CMX_D(N) + (DCFZ_D*R(2) - DCFY_D*R(3))/CR
            CMY_D(N) = CMY_D(N) + (DCFX_D*R(3) - DCFZ_D*R(1))/CR
            CMZ_D(N) = CMZ_D(N) + (DCFY_D*R(1) - DCFX_D*R(2))/CR
C
            CNC_D(J,N) = CNC_D(J,N) 
     &                 + CR*(ENSY(J)*DCFY_D + ENSZ(J)*DCFZ_D)
          ENDDO
C
C-------- design derivatives
          DO N=1, NDESIGN
            DCFX_G = FGAM_G(1,N)/SR
            DCFY_G = FGAM_G(2,N)/SR
            DCFZ_G = FGAM_G(3,N)/SR
C
            CFX_G(N) = CFX_G(N) +  DCFX_G
            CFY_G(N) = CFY_G(N) +  DCFY_G
            CFZ_G(N) = CFZ_G(N) +  DCFZ_G
            CMX_G(N) = CMX_G(N) + (DCFZ_G*R(2) - DCFY_G*R(3))/CR
            CMY_G(N) = CMY_G(N) + (DCFX_G*R(3) - DCFZ_G*R(1))/CR
            CMZ_G(N) = CMZ_G(N) + (DCFY_G*R(1) - DCFX_G*R(2))/CR
C
            CNC_G(J,N) = CNC_G(J,N) 
     &                 + CR*(ENSY(J)*DCFY_G + ENSZ(J)*DCFZ_G)
          ENDDO
C
C-------- hinge moments
          DO L = 1, NCONTROL
            RH(1) = RV(1,I) - PHINGE(1,J,L)
            RH(2) = RV(2,I) - PHINGE(2,J,L)
            RH(3) = RV(3,I) - PHINGE(3,J,L)
C
            DFAC = DCONTROL(I,L) / (SREF*CREF)
C
            CALL CROSS(RH,FGAM,MH)
            CHINGE(L) = CHINGE(L) + DOT(MH,VHINGE(1,J,L))*DFAC
C
            DO N = 1, NUMAX
              CALL CROSS(RH,FGAM_U(1,N),MH)
              CHINGE_U(L,N) = CHINGE_U(L,N) + DOT(MH,VHINGE(1,J,L))*DFAC
            ENDDO
            DO N = 1, NCONTROL
              CALL CROSS(RH,FGAM_D(1,N),MH)
              CHINGE_D(L,N) = CHINGE_D(L,N) + DOT(MH,VHINGE(1,J,L))*DFAC
            ENDDO
            DO N = 1, NDESIGN
              CALL CROSS(RH,FGAM_G(1,N),MH)
              CHINGE_G(L,N) = CHINGE_G(L,N) + DOT(MH,VHINGE(1,J,L))*DFAC
            ENDDO
          ENDDO
C
   40   CONTINUE
C
C
        IF(.NOT.LTRFORCE) GO TO 80
C
C...Sum forces in the strip as generated by velocity (freestream + rotation)
C     the parts of trailing legs which lie on the surface
        DO 72 II = 1, NVC
          I = I1 + (II-1)
C
          DO 71 ILEG = 1, 2
            IF(ILEG.EQ.1) THEN
C----------- local moment reference vector from vortex midpoint to strip c/4 pt
             R(1) = 0.5*(RV1(1,I) + XTE1) - XR
             R(2) =      RV1(2,I)         - YR
             R(3) =      RV1(3,I)         - ZR
C 
C----------- vector from rotation axes
             RROT(1) = 0.5*(RV1(1,I) + XTE1) - XYZREF(1)
             RROT(2) =      RV1(2,I)         - XYZREF(2)
             RROT(3) =      RV1(3,I)         - XYZREF(3)
C
C----------- part of trailing leg lying on surface
             G(1) = RV1(1,I) - XTE1
             G(2) = 0.
             G(3) = 0.
C
            ELSE
C----------- local moment reference vector from vortex midpoint to strip c/4 pt
             R(1) = 0.5*(RV2(1,I) + XTE2) - XR
             R(2) =      RV2(2,I)         - YR
             R(3) =      RV2(3,I)         - ZR
C
C----------- vector from rotation axes
             RROT(1) = 0.5*(RV2(1,I) + XTE2) - XYZREF(1)
             RROT(2) =      RV2(2,I)         - XYZREF(2)
             RROT(3) =      RV2(3,I)         - XYZREF(3)
C
C----------- part of trailing leg lying on surface
             G(1) = XTE2 - RV2(1,I)
             G(2) = 0.
             G(3) = 0.
            ENDIF
C
C---------- set total effective velocity = freestream + rotation
            CALL CROSS(RROT,WROT,VROT)
            VEFF(1) = VINF(1) + VROT(1)
            VEFF(2) = VINF(2) + VROT(2)
            VEFF(3) = VINF(3) + VROT(3)
C
C---------- set VEFF sensitivities to freestream,rotation components
            DO K = 1, 3
              VEFF_U(1,K) = 0.
              VEFF_U(2,K) = 0.
              VEFF_U(3,K) = 0.
              VEFF_U(K,K) = 1.0
            ENDDO
            DO K = 4, 6
              WROT_U(1) = 0.
              WROT_U(2) = 0.
              WROT_U(3) = 0.
              WROT_U(K-3) = 1.0
              CALL CROSS(RROT,WROT_U,VROT_U)
              VEFF_U(1,K) = VROT_U(1)
              VEFF_U(2,K) = VROT_U(2)
              VEFF_U(3,K) = VROT_U(3)
            ENDDO
C
C---------- Force coefficient on vortex segment is 2(Veff x Gamma)
            CALL CROSS (VEFF, G, F)
C
            DO N = 1, NUMAX
              CALL CROSS(VEFF_U(1,N), G, F_U(1,N))
            ENDDO
C
            FGAM(1) = 2.0*GAM(I)*F(1)
            FGAM(2) = 2.0*GAM(I)*F(2)
            FGAM(3) = 2.0*GAM(I)*F(3)
            DO N = 1, NUMAX
              FGAM_U(1,N) = 2.0*GAM_U(I,N)*F(1) + 2.0*GAM(I)*F_U(1,N)
              FGAM_U(2,N) = 2.0*GAM_U(I,N)*F(2) + 2.0*GAM(I)*F_U(2,N)
              FGAM_U(3,N) = 2.0*GAM_U(I,N)*F(3) + 2.0*GAM(I)*F_U(3,N)
            ENDDO
            DO N = 1, NCONTROL
              FGAM_D(1,N) = 2.0*GAM_D(I,N)*F(1)
              FGAM_D(2,N) = 2.0*GAM_D(I,N)*F(2)
              FGAM_D(3,N) = 2.0*GAM_D(I,N)*F(3)
            ENDDO
            DO N = 1, NDESIGN
              FGAM_G(1,N) = 2.0*GAM_G(I,N)*F(1)
              FGAM_G(2,N) = 2.0*GAM_G(I,N)*F(2)
              FGAM_G(3,N) = 2.0*GAM_G(I,N)*F(3)
            ENDDO
C
cC---------- Delta Cp (loading across lifting surface) due to vortex 
c            FNV = DOT(ENV(1,I),FGAM)
c            DCP(I) = FNV / (DXV(I)*WSTRIP(J))
cC
c            DO N = 1, NUMAX
c              FNV_U = DOT(ENV(1,I),FGAM_U(1,N))
c              DCP_U(I,N) = FNV_U / (DXV(I)*WSTRIP(J))
c            ENDDO
cC
c            DO N = 1, NCONTROL
c              FNV_D = DOT(ENV(1,I),FGAM_D(1,N)) + DOT(ENV_D(1,I,N),FGAM)
c              DCP_D(I,N) = FNV_D / (DXV(I)*WSTRIP(J))
c            ENDDO
cC
c            DO N = 1, NDESIGN
c              FNV_G = DOT(ENV(1,I),FGAM_G(1,N)) + DOT(ENV_G(1,I,N),FGAM)
c              DCP_G(I,N) = FNV_G / (DXV(I)*WSTRIP(J))
c            ENDDO
C
C
C---------- vortex contribution to strip forces
            DCFX = FGAM(1) / SR
            DCFY = FGAM(2) / SR
            DCFZ = FGAM(3) / SR
C
C---------- forces normalized by strip area
            CFX = CFX +  DCFX
            CFY = CFY +  DCFY
            CFZ = CFZ +  DCFZ
C
C---------- moments referred to strip c/4 pt., normalized by strip chord and area
            CMX = CMX + (DCFZ*R(2) - DCFY*R(3))/CR
            CMY = CMY + (DCFX*R(3) - DCFZ*R(1))/CR
            CMZ = CMZ + (DCFY*R(1) - DCFX*R(2))/CR
C
C---------- accumulate strip spanloading = c*CN
            CNC(J) = CNC(J) + CR*(ENSY(J)*DCFY + ENSZ(J)*DCFZ)
C
C---------- freestream and rotation derivatives
            DO N=1, NUMAX
              DCFX_U = FGAM_U(1,N)/SR
              DCFY_U = FGAM_U(2,N)/SR
              DCFZ_U = FGAM_U(3,N)/SR
C
              CFX_U(N) = CFX_U(N) +  DCFX_U
              CFY_U(N) = CFY_U(N) +  DCFY_U
              CFZ_U(N) = CFZ_U(N) +  DCFZ_U
              CMX_U(N) = CMX_U(N) + (DCFZ_U*R(2) - DCFY_U*R(3))/CR
              CMY_U(N) = CMY_U(N) + (DCFX_U*R(3) - DCFZ_U*R(1))/CR
              CMZ_U(N) = CMZ_U(N) + (DCFY_U*R(1) - DCFX_U*R(2))/CR
C
              CNC_U(J,N) = CNC_U(J,N) 
     &                   + CR*(ENSY(J)*DCFY_U + ENSZ(J)*DCFZ_U)
            ENDDO
C
C---------- control derivatives
            DO N=1, NCONTROL
              DCFX_D = FGAM_D(1,N)/SR
              DCFY_D = FGAM_D(2,N)/SR
              DCFZ_D = FGAM_D(3,N)/SR
C  
              CFX_D(N) = CFX_D(N) +  DCFX_D
              CFY_D(N) = CFY_D(N) +  DCFY_D
              CFZ_D(N) = CFZ_D(N) +  DCFZ_D
              CMX_D(N) = CMX_D(N) + (DCFZ_D*R(2) - DCFY_D*R(3))/CR
              CMY_D(N) = CMY_D(N) + (DCFX_D*R(3) - DCFZ_D*R(1))/CR
              CMZ_D(N) = CMZ_D(N) + (DCFY_D*R(1) - DCFX_D*R(2))/CR
C  
              CNC_D(J,N) = CNC_D(J,N) 
     &                   + CR*(ENSY(J)*DCFY_D + ENSZ(J)*DCFZ_D)
            ENDDO
C
C---------- design derivatives
            DO N=1, NDESIGN
              DCFX_G = FGAM_G(1,N)/SR
              DCFY_G = FGAM_G(2,N)/SR
              DCFZ_G = FGAM_G(3,N)/SR
C
              CFX_G(N) = CFX_G(N) +  DCFX_G
              CFY_G(N) = CFY_G(N) +  DCFY_G
              CFZ_G(N) = CFZ_G(N) +  DCFZ_G
              CMX_G(N) = CMX_G(N) + (DCFZ_G*R(2) - DCFY_G*R(3))/CR
              CMY_G(N) = CMY_G(N) + (DCFX_G*R(3) - DCFZ_G*R(1))/CR
              CMZ_G(N) = CMZ_G(N) + (DCFY_G*R(1) - DCFX_G*R(2))/CR
C
              CNC_G(J,N) = CNC_G(J,N) 
     &                   + CR*(ENSY(J)*DCFY_G + ENSZ(J)*DCFZ_G)
            ENDDO
C
cC---------- hinge moments
c            DO L=1, NCONTROL
c              RH(1) = RV(1,I) - PHINGE(1,J,L)
c              RH(2) = RV(2,I) - PHINGE(2,J,L)
c              RH(3) = RV(3,I) - PHINGE(3,J,L)
cC
c              DFAC = DCONTROL(I,L) / (SREF * CREF)
cC
c              CALL CROSS(RH,FGAM,MH)
c              CHINGE(L) = CHINGE(L) + DOT(MH,VHINGE(1,J,L))*DFAC
cC
c              DO N = 1, NUMAX
c                CALL CROSS(RH,FGAM_U(1,N),MH)
c                CHINGE_U(L,N) = CHINGE_U(L,N) + DOT(MH,VHINGE(1,J,L))*DFAC
c              ENDDO
c              DO N = 1, NCONTROL
c                CALL CROSS(RH,FGAM_D(1,N),MH)
c                CHINGE_D(L,N) = CHINGE_D(L,N) + DOT(MH,VHINGE(1,J,L))*DFAC
c              ENDDO
c              DO N = 1, NDESIGN
c                CALL CROSS(RH,FGAM_G(1,N),MH)
c                CHINGE_G(L,N) = CHINGE_G(L,N) + DOT(MH,VHINGE(1,J,L))*DFAC
c              ENDDO
c            ENDDO
C
   71     CONTINUE
   72   CONTINUE
 80     CONTINUE
C
C
C*******************************************************************
C--- Drag terms due to viscous effects
C    Drag forces are assumed to be characterized by velocity at the c/4 
C    point and are assumed to act thru the same point. CD is defined by 
C    user-specified CD(CL) polar.  Drag comes from function lookup on 
C    section polar drag using local lift coefficient.  
C
        CDV_LSTRP(J) = 0.0
C
        IF(LVISC.AND.LVISCSTRP(J)) THEN
C--- local moment reference vector from ref point to c/4 point
c         R(1) = XR - XR
c         R(2) = YR - YR
c         R(3) = ZR - ZR
C--- Get rotational velocity at strip 1/4 chord reference point 
         RROT(1) = XR - XYZREF(1)
         RROT(2) = YR - XYZREF(2)
         RROT(3) = ZR - XYZREF(3)
C--- Onset velocity at strip c/4 = freestream + rotation
         CALL CROSS(RROT,WROT,VROT)
         VEFF(1) = VINF(1) + VROT(1)
         VEFF(2) = VINF(2) + VROT(2)
         VEFF(3) = VINF(3) + VROT(3)
         VEFFMAG = SQRT(VEFF(1)**2 +VEFF(2)**2 +VEFF(3)**2)
C
C------- set sensitivities to freestream,rotation components
         DO K = 1, 3
           VEFF_U(1,K) = 0.
           VEFF_U(2,K) = 0.
           VEFF_U(3,K) = 0.
         ENDDO
         VEFF_U(1,1) = 1.0
         VEFF_U(2,2) = 1.0
         VEFF_U(3,3) = 1.0
         DO K = 4, 6
           WROT_U(1) = 0.
           WROT_U(2) = 0.
           WROT_U(3) = 0.
           WROT_U(K-3) = 1.0
           CALL CROSS(RROT,WROT_U,VROT_U)
           VEFF_U(1,K) = VROT_U(1)
           VEFF_U(2,K) = VROT_U(2)
           VEFF_U(3,K) = VROT_U(3)
         ENDDO
C
C--- Generate CD from stored function using strip CL as parameter
         CLV = ULIFT(1)*CFX + ULIFT(2)*CFY + ULIFT(3)*CFZ
         DO N = 1, NUMAX
           CLV_U(N) = ENSY(J)* CFY_U(N)
     &              + ENSZ(J)*(CFZ_U(N)*COSA - CFX_U(N)*SINA)  
         END DO
C
         DO N = 1, NCONTROL
           CLV_D(N) = ENSY(J)* CFY_D(N)
     &              + ENSZ(J)*(CFZ_D(N)*COSA - CFX_D(N)*SINA)  
         END DO
C
         DO N = 1, NDESIGN
           CLV_G(N) = ENSY(J)* CFY_G(N)
     &              + ENSZ(J)*(CFZ_G(N)*COSA - CFX_G(N)*SINA)  
         END DO
C
         CALL CDCL(J,CLV,CDV,CDV_CLV)
C
C--- Strip viscous force contribution (per unit strip area)
         DCVFX = VEFF(1)*VEFFMAG * CDV
         DCVFY = VEFF(2)*VEFFMAG * CDV
         DCVFZ = VEFF(3)*VEFFMAG * CDV
C
C--- Add viscous terms to strip forces and moments
         CFX = CFX +  DCVFX
         CFY = CFY +  DCVFY
         CFZ = CFZ +  DCVFZ
C--- Viscous forces acting at c/4 have no effect on moments at c/4 pt.
c         CMX = CMX + (DCVFZ*R(2) - DCVFY*R(3))/CR
c         CMY = CMY + (DCVFX*R(3) - DCVFZ*R(1))/CR
c         CMZ = CMZ + (DCVFY*R(1) - DCVFX*R(2))/CR
C
         CDV_LSTRP(J) = UDRAG(1)*DCVFX + UDRAG(2)*DCVFY + UDRAG(3)*DCVFZ
C
C--- Add the sensitivity of viscous forces to the flow conditions
         DO N=1, NUMAX
           DCVFX_U = (VEFF_U(1,N)*(VEFFMAG + VEFF(1)**2/VEFFMAG))*CDV
     &             +  VEFF(1)    * VEFFMAG * CDV_CLV*CLV_U(N)
           DCVFY_U = (VEFF_U(2,N)*(VEFFMAG + VEFF(2)**2/VEFFMAG))*CDV
     &             +  VEFF(2)    * VEFFMAG * CDV_CLV*CLV_U(N)
           DCVFZ_U = (VEFF_U(3,N)*(VEFFMAG + VEFF(3)**2/VEFFMAG))*CDV
     &             +  VEFF(3)    * VEFFMAG * CDV_CLV*CLV_U(N)
C
           CFX_U(N) = CFX_U(N) +  DCVFX_U
           CFY_U(N) = CFY_U(N) +  DCVFY_U
           CFZ_U(N) = CFZ_U(N) +  DCVFZ_U
C--- Viscous forces acting at c/4 have no effect on moments at c/4 pt.
c           CMX_U(N) = CMX_U(N) + (DCVFZ_U*R(2) - DCVFY_U*R(3))/CR
c           CMY_U(N) = CMY_U(N) + (DCVFX_U*R(3) - DCVFZ_U*R(1))/CR
c           CMZ_U(N) = CMZ_U(N) + (DCVFY_U*R(1) - DCVFX_U*R(2))/CR
C
           CNC_U(J,N) = CNC_U(J,N) 
     &                + CR * (ENSY(J)*DCVFY_U + ENSZ(J)*DCVFZ_U)
         ENDDO
C
         DO N=1, NCONTROL
           DCVFX_D = VEFF(1)*VEFFMAG * CDV_CLV*CLV_D(N)
           DCVFY_D = VEFF(2)*VEFFMAG * CDV_CLV*CLV_D(N)
           DCVFZ_D = VEFF(3)*VEFFMAG * CDV_CLV*CLV_D(N)
C
           CFX_D(N) = CFX_D(N) +  DCVFX_D
           CFY_D(N) = CFY_D(N) +  DCVFY_D
           CFZ_D(N) = CFZ_D(N) +  DCVFZ_D
C--- Viscous forces acting at c/4 have no effect on moments at c/4 pt.
c           CMX_D(N) = CMX_D(N) + (DCVFZ_D*R(2) - DCVFY_D*R(3))/CR
c           CMY_D(N) = CMY_D(N) + (DCVFX_D*R(3) - DCVFZ_D*R(1))/CR
c           CMZ_D(N) = CMZ_D(N) + (DCVFY_D*R(1) - DCVFX_D*R(2))/CR
C
           CNC_D(J,N) = CNC_D(J,N) 
     &                + CR * (ENSY(J)*DCVFY_D + ENSZ(J)*DCVFZ_D)
         ENDDO
C
         DO N=1, NDESIGN
           DCVFX_G = VEFF(1)*VEFFMAG * CDV_CLV*CLV_G(N)
           DCVFY_G = VEFF(2)*VEFFMAG * CDV_CLV*CLV_G(N)
           DCVFZ_G = VEFF(3)*VEFFMAG * CDV_CLV*CLV_G(N)
C
           CFX_G(N) = CFX_G(N) +  DCVFX_G
           CFY_G(N) = CFY_G(N) +  DCVFY_G
           CFZ_G(N) = CFZ_G(N) +  DCVFZ_G
C--- Viscous forces acting at c/4 have no effect on moments at c/4 pt.
c           CMX_G(N) = CMX_G(N) + (DCVFZ_G*R(2) - DCVFY_G*R(3))/CR
c           CMY_G(N) = CMY_G(N) + (DCVFX_G*R(3) - DCVFZ_G*R(1))/CR
c           CMZ_G(N) = CMZ_G(N) + (DCVFY_G*R(1) - DCVFX_G*R(2))/CR
C
           CNC_G(J,N) = CNC_G(J,N) 
     &                + CR * (ENSY(J)*DCVFY_G + ENSZ(J)*DCVFZ_G)
         ENDDO
C
        ENDIF        
C
C*******************************************************************
C
C...Store strip X,Y,Z body axes forces 
C   (these are normalized by strip area and moments are referred to
C    c/4 point and are normalized by strip chord and area)
        CF_STRP(1,J) = CFX
        CF_STRP(2,J) = CFY
        CF_STRP(3,J) = CFZ
        CM_STRP(1,J) = CMX
        CM_STRP(2,J) = CMY
        CM_STRP(3,J) = CMZ
C
C...Transform strip body axes forces into stability axes
        CDSTRP(J) =  CFX*COSA + CFZ*SINA
        CLSTRP(J) = -CFX*SINA + CFZ*COSA 
        CXSTRP(J) =  CFX
        CYSTRP(J) =  CFY
        CZSTRP(J) =  CFZ
C
        CDST_A(J) = -CFX*SINA + CFZ*COSA
        CLST_A(J) = -CFX*COSA - CFZ*SINA 
C
        DO N=1, NUMAX
          CDST_U(J,N) =  CFX_U(N)*COSA + CFZ_U(N)*SINA
          CLST_U(J,N) = -CFX_U(N)*SINA + CFZ_U(N)*COSA 
          CXST_U(J,N) =  CFX_U(N)
          CYST_U(J,N) =  CFY_U(N)
          CZST_U(J,N) =  CFZ_U(N)
        END DO
C
        DO N=1, NCONTROL
          CDST_D(J,N) =  CFX_D(N)*COSA + CFZ_D(N)*SINA
          CLST_D(J,N) = -CFX_D(N)*SINA + CFZ_D(N)*COSA 
          CXST_D(J,N) =  CFX_D(N)
          CYST_D(J,N) =  CFY_D(N)
          CZST_D(J,N) =  CFZ_D(N)
        END DO
C
        DO N=1, NDESIGN
          CDST_G(J,N) =  CFX_G(N)*COSA + CFZ_G(N)*SINA
          CLST_G(J,N) = -CFX_G(N)*SINA + CFZ_G(N)*COSA 
          CXST_G(J,N) =  CFX_G(N)
          CYST_G(J,N) =  CFY_G(N)
          CZST_G(J,N) =  CFZ_G(N)
        END DO
C
C... Set strip moments about the overall moment reference point XYZREF 
C     (still normalized by strip area and chord)
        R(1) = XR - XYZREF(1)
        R(2) = YR - XYZREF(2)
        R(3) = ZR - XYZREF(3)
        CRSTRP(J) = CMX + (CFZ*R(2) - CFY*R(3))/CR
        CMSTRP(J) = CMY + (CFX*R(3) - CFZ*R(1))/CR
        CNSTRP(J) = CMZ + (CFY*R(1) - CFX*R(2))/CR
C
        DO N=1, NUMAX
          CRST_U(J,N) = CMX_U(N) + (CFZ_U(N)*R(2) - CFY_U(N)*R(3))/CR
          CMST_U(J,N) = CMY_U(N) + (CFX_U(N)*R(3) - CFZ_U(N)*R(1))/CR
          CNST_U(J,N) = CMZ_U(N) + (CFY_U(N)*R(1) - CFX_U(N)*R(2))/CR
        ENDDO
C
        DO N=1, NCONTROL
          CRST_D(J,N) = CMX_D(N) + (CFZ_D(N)*R(2) - CFY_D(N)*R(3))/CR
          CMST_D(J,N) = CMY_D(N) + (CFX_D(N)*R(3) - CFZ_D(N)*R(1))/CR
          CNST_D(J,N) = CMZ_D(N) + (CFY_D(N)*R(1) - CFX_D(N)*R(2))/CR
        ENDDO
C
        DO N=1, NDESIGN
          CRST_G(J,N) = CMX_G(N) + (CFZ_G(N)*R(2) - CFY_G(N)*R(3))/CR
          CMST_G(J,N) = CMY_G(N) + (CFX_G(N)*R(3) - CFZ_G(N)*R(1))/CR
          CNST_G(J,N) = CMZ_G(N) + (CFY_G(N)*R(1) - CFX_G(N)*R(2))/CR
        ENDDO
C
C...Take components of X,Y,Z forces in local strip axes 
C   (axial/normal and lift/drag)
C    in plane normal to (possibly dihedralled) strip
        CL_LSTRP(J) = ULIFT(1)*CFX + ULIFT(2)*CFY + ULIFT(3)*CFZ
        CD_LSTRP(J) = UDRAG(1)*CFX + UDRAG(2)*CFY + UDRAG(3)*CFZ
        CAXLSTRP(J) = CFX
        CNRMSTRP(J) = ENSY(J)*CFY + ENSZ(J)*CFZ
        CMC4(J)     = ENSZ(J)*CMY - ENSY(J)*CMZ
C
C------ vector at chord reference point from rotation axes
        RROT(1) = XSREF(J) - XYZREF(1)
        RROT(2) = YSREF(J) - XYZREF(2)
        RROT(3) = ZSREF(J) - XYZREF(3)
c        print *,"WROT ",WROT
C
C------ set total effective velocity = freestream + rotation
        CALL CROSS(RROT,WROT,VROT)
        VEFF(1) = VINF(1) + VROT(1)
        VEFF(2) = VINF(2) + VROT(2)
        VEFF(3) = VINF(3) + VROT(3)
C
        VSQ = VEFF(1)**2 + VEFF(2)**2 + VEFF(3)**2
        IF(VSQ .EQ. 0.0) THEN
         VSQI = 1.0
        ELSE
         VSQI = 1.0 / VSQ
        ENDIF
C
C------ spanwise and perpendicular velocity components
        VSPAN = VEFF(1)*ESS(1,J) + VEFF(2)*ESS(2,J) + VEFF(3)*ESS(3,J)
        VPERP(1) = VEFF(1) - ESS(1,J)*VSPAN
        VPERP(2) = VEFF(2) - ESS(2,J)*VSPAN
        VPERP(3) = VEFF(3) - ESS(3,J)*VSPAN
C
        VPSQ = VPERP(1)**2 + VPERP(2)**2 + VPERP(3)**2
        IF(VPSQ .EQ. 0.0) THEN
         VPSQI = 1.0
        ELSE
         VPSQI = 1.0 / VPSQ
        ENDIF
ccc     CLTSTRP(J) = CNRMSTRP(J) * VPSQI
        CLTSTRP(J) = CL_LSTRP(J) * VPSQI
        CLASTRP(J) = CL_LSTRP(J) * VSQI
C
C--- Moment about strip LE midpoint in direction of LE segment
        R(1) = XR - RLE(1,J)
        R(2) = YR - RLE(2,J)
        R(3) = ZR - RLE(3,J)
        DELX = RLE2(1,J) - RLE1(1,J)
        DELY = RLE2(2,J) - RLE1(2,J)
        DELZ = RLE2(3,J) - RLE1(3,J)
C
        IF(IMAGS(NSURFS(J)).LT.0) THEN 
         DELX = -DELX
         DELY = -DELY
         DELZ = -DELZ
        ENDIF
        DMAG = SQRT(DELX**2+DELY**2+DELZ**2)
        CMLE(J) = 0.0
        IF(DMAG.NE.0.0) THEN
         CMLE(J) = DELX/DMAG*(CMX + (CFZ*R(2) - CFY*R(3))/CR)
     &           + DELY/DMAG*(CMY + (CFX*R(3) - CFZ*R(1))/CR)
     &           + DELZ/DMAG*(CMZ + (CFY*R(1) - CFX*R(2))/CR)
        ENDIF
C
  100 CONTINUE
C
C
C
C...Surface forces and moments summed from strip forces...
C   XXSURF values normalized to configuration reference quantities
C   XX_SRF values normalized to each surface reference quantities
      DO 150 IS = 1, NSURF
        CDSURF(IS) = 0.
        CLSURF(IS) = 0.
        CXSURF(IS) = 0.
        CYSURF(IS) = 0.
        CZSURF(IS) = 0.
        CRSURF(IS) = 0.
        CMSURF(IS) = 0.
        CNSURF(IS) = 0.
        CDVSURF(IS) = 0.
C
        CDS_A(IS) = 0.
        CLS_A(IS) = 0.
        DO N=1, NUMAX
          CDS_U(IS,N) = 0.
          CLS_U(IS,N) = 0.
          CXS_U(IS,N) = 0.
          CYS_U(IS,N) = 0.
          CZS_U(IS,N) = 0.
          CRS_U(IS,N) = 0.
          CMS_U(IS,N) = 0.
          CNS_U(IS,N) = 0.
        ENDDO
        DO N=1, NCONTROL
          CDS_D(IS,N) = 0.
          CLS_D(IS,N) = 0.
          CXS_D(IS,N) = 0.
          CYS_D(IS,N) = 0.
          CZS_D(IS,N) = 0.
          CRS_D(IS,N) = 0.
          CMS_D(IS,N) = 0.
          CNS_D(IS,N) = 0.
        ENDDO
        DO N=1, NDESIGN
          CDS_G(IS,N) = 0.
          CLS_G(IS,N) = 0.
          CXS_G(IS,N) = 0.
          CYS_G(IS,N) = 0.
          CZS_G(IS,N) = 0.
          CRS_G(IS,N) = 0.
          CMS_G(IS,N) = 0.
          CNS_G(IS,N) = 0.
        ENDDO
C
C--- Surface body axes forces and moments
        DO L = 1, 3
          CF_SRF(L,IS) = 0.0
          CM_SRF(L,IS) = 0.0
          ENAVE(L)    = 0.0
        END DO
C
        NSTRPS = NJ(IS)
        DO 120 JJ = 1, NSTRPS
          J = JFRST(IS) + JJ-1
          SR = CHORD(J)*WSTRIP(J)
          CR = CHORD(J)
          XR = RLE(1,J) + 0.25*CHORD(J)
          YR = RLE(2,J)
          ZR = RLE(3,J)
C
          ENAVE(1) = 0.0
          ENAVE(2) = ENAVE(2) + SR*ENSY(J)
          ENAVE(3) = ENAVE(3) + SR*ENSZ(J)
C
          CDSURF(IS) = CDSURF(IS) + CDSTRP(J)*SR/SREF
          CLSURF(IS) = CLSURF(IS) + CLSTRP(J)*SR/SREF
C
          CXSURF(IS) = CXSURF(IS) + CXSTRP(J)*SR/SREF
          CYSURF(IS) = CYSURF(IS) + CYSTRP(J)*SR/SREF
          CZSURF(IS) = CZSURF(IS) + CZSTRP(J)*SR/SREF
C
          CRSURF(IS) = CRSURF(IS) + CRSTRP(J)*(SR/SREF)*(CR/BREF)
          CMSURF(IS) = CMSURF(IS) + CMSTRP(J)*(SR/SREF)*(CR/CREF)
          CNSURF(IS) = CNSURF(IS) + CNSTRP(J)*(SR/SREF)*(CR/BREF)
C
C--- Bug fix, HHY/S.Allmaras 
          CDVSURF(IS)  = CDVSURF(IS) + CDV_LSTRP(J)*(SR/SREF)
C
          CDS_A(IS) = CDS_A(IS) + CDST_A(J)*SR/SREF
          CLS_A(IS) = CLS_A(IS) + CLST_A(J)*SR/SREF
C
          DO N=1, NUMAX
            CDS_U(IS,N) = CDS_U(IS,N) + CDST_U(J,N)*SR/SREF
            CLS_U(IS,N) = CLS_U(IS,N) + CLST_U(J,N)*SR/SREF
C
            CXS_U(IS,N) = CXS_U(IS,N) + CXST_U(J,N)*SR/SREF
            CYS_U(IS,N) = CYS_U(IS,N) + CYST_U(J,N)*SR/SREF
            CZS_U(IS,N) = CZS_U(IS,N) + CZST_U(J,N)*SR/SREF
C
            CRS_U(IS,N) = CRS_U(IS,N) + CRST_U(J,N)*(SR/SREF)*(CR/BREF)
            CMS_U(IS,N) = CMS_U(IS,N) + CMST_U(J,N)*(SR/SREF)*(CR/CREF)
            CNS_U(IS,N) = CNS_U(IS,N) + CNST_U(J,N)*(SR/SREF)*(CR/BREF)
          ENDDO
C
          DO N=1, NCONTROL
            CDS_D(IS,N) = CDS_D(IS,N) + CDST_D(J,N)*SR/SREF
            CLS_D(IS,N) = CLS_D(IS,N) + CLST_D(J,N)*SR/SREF
C
            CXS_D(IS,N) = CXS_D(IS,N) + CXST_D(J,N)*SR/SREF
            CYS_D(IS,N) = CYS_D(IS,N) + CYST_D(J,N)*SR/SREF
            CZS_D(IS,N) = CZS_D(IS,N) + CZST_D(J,N)*SR/SREF
C
            CRS_D(IS,N) = CRS_D(IS,N) + CRST_D(J,N)*(SR/SREF)*(CR/BREF)
            CMS_D(IS,N) = CMS_D(IS,N) + CMST_D(J,N)*(SR/SREF)*(CR/CREF)
            CNS_D(IS,N) = CNS_D(IS,N) + CNST_D(J,N)*(SR/SREF)*(CR/BREF)
          ENDDO
C
          DO N=1, NDESIGN
            CDS_G(IS,N) = CDS_G(IS,N) + CDST_G(J,N)*SR/SREF
            CLS_G(IS,N) = CLS_G(IS,N) + CLST_G(J,N)*SR/SREF
C
            CXS_G(IS,N) = CXS_G(IS,N) + CXST_G(J,N)*SR/SREF
            CYS_G(IS,N) = CYS_G(IS,N) + CYST_G(J,N)*SR/SREF
            CZS_G(IS,N) = CZS_G(IS,N) + CZST_G(J,N)*SR/SREF
C
            CRS_G(IS,N) = CRS_G(IS,N) + CRST_G(J,N)*(SR/SREF)*(CR/BREF)
            CMS_G(IS,N) = CMS_G(IS,N) + CMST_G(J,N)*(SR/SREF)*(CR/CREF)
            CNS_G(IS,N) = CNS_G(IS,N) + CNST_G(J,N)*(SR/SREF)*(CR/BREF)
          ENDDO
C
C--- reference point for surface LE (hinge) moments
C    defined by surface hinge vector direction thru first strip LE point
          IF(IMAGS(IS).GE.0) THEN
            R(1) = XR - RLE1(1,JFRST(IS))
            R(2) = YR - RLE1(2,JFRST(IS))
            R(3) = ZR - RLE1(3,JFRST(IS))
           ELSE
            R(1) = XR - RLE2(1,JFRST(IS))
            R(2) = YR - RLE2(2,JFRST(IS))
            R(3) = ZR - RLE2(3,JFRST(IS))
          ENDIF
C--- Surface forces and moments (about LE ref point, normalized locally) 
          DO L = 1, 3
            L1 = MOD(L, 3) + 1
            L2 = MOD(L1,3) + 1
C
            CF_SRF(L,IS) = CF_SRF(L,IS) + CF_STRP(L,J)*SR/SSURF(IS)
C
            DCM = SR/SSURF(IS) * CR/CAVESURF(IS) *
     &          ( CM_STRP(L,J) 
     &          + CF_STRP(L2,J)*R(L1)/CR 
     &          - CF_STRP(L1,J)*R(L2)/CR )
C
            CM_SRF(L,IS) = CM_SRF(L,IS) + DCM 
          END DO
C
  120   CONTINUE
C
C--- To define surface CL and CD we need local lift and drag directions...
C--- Define drag and lift directions for surface using average strip normal
        ENAVE(1) = ENAVE(1)/SSURF(IS)
        ENAVE(2) = ENAVE(2)/SSURF(IS)
        ENAVE(3) = ENAVE(3)/SSURF(IS)
        ENMAG = SQRT(DOT(ENAVE,ENAVE))
        IF(ENMAG.EQ.0.) THEN
          ENAVE(3) = 1.0
         ELSE
          ENAVE(1) = ENAVE(1)/ENMAG 
          ENAVE(2) = ENAVE(2)/ENMAG 
          ENAVE(3) = ENAVE(3)/ENMAG 
        ENDIF
C--- Define a "spanwise" vector with cross product of average surface normal 
C    with chordline (x direction)
        SPN(1) =  0.0
        SPN(2) =  ENAVE(3)
        SPN(3) = -ENAVE(2)
C--- Stability axes stream vector defines drag direction
        UDRAG(1) = COSA
        UDRAG(2) = 0.0
        UDRAG(3) = SINA
C--- Lift direction is vector product of "stream" and spanwise vector
        CALL CROSS(UDRAG,SPN,ULIFT)
        ULMAG = SQRT(DOT(ULIFT,ULIFT))
        IF(ULMAG.EQ.0.) THEN
          ULIFT(3) = 1.0
         ELSE
          ULIFT(1) = ULIFT(1)/ULMAG
          ULIFT(2) = ULIFT(2)/ULMAG
          ULIFT(3) = ULIFT(3)/ULMAG
        ENDIF
        CL_SRF(IS) = DOT(ULIFT,CF_SRF(1,IS))
        CD_SRF(IS) = DOT(UDRAG,CF_SRF(1,IS))
C--- Surface hinge moments defined by surface LE moment about hinge vector 
ccc        CMLE_SRF(IS) = DOT(CM_SRF(1,IS),VHINGE(1,IS))
C
C
C-------------------------------------------------
        IF(LFLOAD(IS)) THEN
C------- Total forces summed from surface forces...
C-         normalized to configuration reference quantities
         CDTOT = CDTOT + CDSURF(IS)
         CLTOT = CLTOT + CLSURF(IS)
         CXTOT = CXTOT + CXSURF(IS)
         CYTOT = CYTOT + CYSURF(IS)
         CZTOT = CZTOT + CZSURF(IS)
         CRTOT = CRTOT + CRSURF(IS)
         CMTOT = CMTOT + CMSURF(IS)
         CNTOT = CNTOT + CNSURF(IS)
         CDVTOT = CDVTOT + CDVSURF(IS)
C
         CDTOT_A = CDTOT_A + CDS_A(IS)
         CLTOT_A = CLTOT_A + CLS_A(IS)
C
         DO N=1, NUMAX
           CDTOT_U(N) = CDTOT_U(N) + CDS_U(IS,N)
           CLTOT_U(N) = CLTOT_U(N) + CLS_U(IS,N)
           CXTOT_U(N) = CXTOT_U(N) + CXS_U(IS,N)
           CYTOT_U(N) = CYTOT_U(N) + CYS_U(IS,N)
           CZTOT_U(N) = CZTOT_U(N) + CZS_U(IS,N)
           CRTOT_U(N) = CRTOT_U(N) + CRS_U(IS,N)
           CMTOT_U(N) = CMTOT_U(N) + CMS_U(IS,N)
           CNTOT_U(N) = CNTOT_U(N) + CNS_U(IS,N)
         ENDDO
C
         DO N=1, NCONTROL
           CDTOT_D(N) = CDTOT_D(N) + CDS_D(IS,N)
           CLTOT_D(N) = CLTOT_D(N) + CLS_D(IS,N)
           CXTOT_D(N) = CXTOT_D(N) + CXS_D(IS,N)
           CYTOT_D(N) = CYTOT_D(N) + CYS_D(IS,N)
           CZTOT_D(N) = CZTOT_D(N) + CZS_D(IS,N)
           CRTOT_D(N) = CRTOT_D(N) + CRS_D(IS,N)
           CMTOT_D(N) = CMTOT_D(N) + CMS_D(IS,N)
           CNTOT_D(N) = CNTOT_D(N) + CNS_D(IS,N)
         ENDDO
C
         DO N=1, NDESIGN
           CDTOT_G(N) = CDTOT_G(N) + CDS_G(IS,N)
           CLTOT_G(N) = CLTOT_G(N) + CLS_G(IS,N)
           CXTOT_G(N) = CXTOT_G(N) + CXS_G(IS,N)
           CYTOT_G(N) = CYTOT_G(N) + CYS_G(IS,N)
           CZTOT_G(N) = CZTOT_G(N) + CZS_G(IS,N)
           CRTOT_G(N) = CRTOT_G(N) + CRS_G(IS,N)
           CMTOT_G(N) = CMTOT_G(N) + CMS_G(IS,N)
           CNTOT_G(N) = CNTOT_G(N) + CNS_G(IS,N)
         ENDDO
        ENDIF
C-------------------------------------------------
C
  150 CONTINUE
C
C--- If case is XZ symmetric (IYSYM=1), add contributions from images,
C    zero out the asymmetric forces and double the symmetric ones
      IF(IYSYM.EQ.1) THEN
        CDTOT   = 2.0 * CDTOT
        CLTOT   = 2.0 * CLTOT
        CXTOT   = 2.0 * CXTOT
        CYTOT   = 0.
        CZTOT   = 2.0 * CZTOT
        CRTOT   = 0.
        CMTOT   = 2.0 * CMTOT
        CNTOT   = 0.
        CDVTOT  = 2.0 * CDVTOT
C
        CDTOT_A = 2.0 * CDTOT_A
        CLTOT_A = 2.0 * CLTOT_A
C
        DO N=1, NUMAX
          CDTOT_U(N) = 2.0 * CDTOT_U(N)
          CLTOT_U(N) = 2.0 * CLTOT_U(N)
          CXTOT_U(N) = 2.0 * CXTOT_U(N)
          CYTOT_U(N) = 0.
          CZTOT_U(N) = 2.0 * CZTOT_U(N)
          CRTOT_U(N) = 0.
          CMTOT_U(N) = 2.0 * CMTOT_U(N)
          CNTOT_U(N) = 0.
        ENDDO
C
        DO N=1, NCONTROL
          CDTOT_D(N) = 2.0 * CDTOT_D(N)
          CLTOT_D(N) = 2.0 * CLTOT_D(N)
          CXTOT_D(N) = 2.0 * CXTOT_D(N)
          CYTOT_D(N) = 0.
          CZTOT_D(N) = 2.0 * CZTOT_D(N)
          CRTOT_D(N) = 0.
          CMTOT_D(N) = 2.0 * CMTOT_D(N)
          CNTOT_D(N) = 0.
        ENDDO
C
        DO N=1, NDESIGN
          CDTOT_G(N) = 2.0 * CDTOT_G(N)
          CLTOT_G(N) = 2.0 * CLTOT_G(N)
          CXTOT_G(N) = 2.0 * CXTOT_G(N)
          CYTOT_G(N) = 0.
          CZTOT_G(N) = 2.0 * CZTOT_G(N)
          CRTOT_G(N) = 0.
          CMTOT_G(N) = 2.0 * CMTOT_G(N)
          CNTOT_G(N) = 0.
        ENDDO
      ENDIF
C
      RETURN
      END ! SFFORC
C


      SUBROUTINE BDFORC
      INCLUDE 'AVL.INC'
C
      REAL RROT(3)
      REAL VEFF(3)    , VROT(3)  ,
     &     VEFF_U(3,6), VROT_U(3), WROT_U(3)
      REAL DRL(3), ESL(3), 
     &     FB(3), FB_U(3,NUMAX),
     &     MB(3), MB_U(3,NUMAX)
      REAL CDBDY_U(NUMAX), CLBDY_U(NUMAX), 
     &     CXBDY_U(NUMAX), CYBDY_U(NUMAX),  CZBDY_U(NUMAX), 
     &     CRBDY_U(NUMAX), CMBDY_U(NUMAX),  CNBDY_U(NUMAX)
C
C
      BETM = SQRT(1.0 - MACH**2)
C
      SINA = SIN(ALFA)
      COSA = COS(ALFA)
C
C
C---- add on body force contributions
      DO 200 IB = 1, NBODY
        CDBDY(IB) = 0.0
        CLBDY(IB) = 0.0
        CXBDY(IB) = 0.0
        CYBDY(IB) = 0.0
        CZBDY(IB) = 0.0
        CRBDY(IB) = 0.0
        CMBDY(IB) = 0.0
        CNBDY(IB) = 0.0
C
        DO IU = 1, 6
          CDBDY_U(IU) = 0.0
          CLBDY_U(IU) = 0.0
          CXBDY_U(IU) = 0.0
          CYBDY_U(IU) = 0.0
          CZBDY_U(IU) = 0.0
          CRBDY_U(IU) = 0.0
          CMBDY_U(IU) = 0.0
          CNBDY_U(IU) = 0.0
        ENDDO
C
        DO 205 ILSEG = 1, NL(IB)-1
          L1 = LFRST(IB) + ILSEG - 1
          L2 = LFRST(IB) + ILSEG
C
          L = L1
C
          DRL(1) = (RL(1,L2) - RL(1,L1))/BETM
          DRL(2) =  RL(2,L2) - RL(2,L1)
          DRL(3) =  RL(3,L2) - RL(3,L1)
          DRLMAG = SQRT(DRL(1)**2 + DRL(2)**2 + DRL(3)**2)
          IF(DRLMAG.EQ.0.0) THEN
           DRLMI = 0.0
          ELSE
           DRLMI = 1.0/DRLMAG
          ENDIF
C
          DIA = RADL(L1) + RADL(L2)
          IF(DIA.LE.0.0) THEN
           DINV = 0.0
          ELSE
           DINV = 1.0/DIA
          ENDIF
C
C-------- unit vector along line segment
          ESL(1) = DRL(1) * DRLMI
          ESL(2) = DRL(2) * DRLMI
          ESL(3) = DRL(3) * DRLMI
C
          RROT(1) = 0.5*(RL(1,L2)+RL(1,L1)) - XYZREF(1)
          RROT(2) = 0.5*(RL(2,L2)+RL(2,L1)) - XYZREF(2)
          RROT(3) = 0.5*(RL(3,L2)+RL(3,L1)) - XYZREF(3)
C
C-------- go over freestream velocity and rotation components
          CALL CROSS(RROT,WROT,VROT)
C
          VEFF(1) = (VINF(1) + VROT(1))/BETM
          VEFF(2) =  VINF(2) + VROT(2)
          VEFF(3) =  VINF(3) + VROT(3)
C
C-------- set VEFF sensitivities to freestream,rotation components
          DO K = 1, 3
            VEFF_U(1,K) = 0.
            VEFF_U(2,K) = 0.
            VEFF_U(3,K) = 0.
            VEFF_U(K,K) = 1.0
          ENDDO
C
          DO K = 4, 6
            WROT_U(1) = 0.
            WROT_U(2) = 0.
            WROT_U(3) = 0.
            WROT_U(K-3) = 1.0
            CALL CROSS(RROT,WROT_U,VROT_U)
C
            VEFF_U(1,K) = VROT_U(1)
            VEFF_U(2,K) = VROT_U(2)
            VEFF_U(3,K) = VROT_U(3)
          ENDDO
C
C-------- U.es
          US = VEFF(1)*ESL(1) + VEFF(2)*ESL(2) + VEFF(3)*ESL(3)
C
C
C-------- velocity projected on normal plane = U - (U.es) es
          DO K = 1, 3
            UN = VEFF(K) - US*ESL(K)
            FB(K) = UN*SRC(L)
C
            DO IU = 1, 6
              UN_U = VEFF_U(K,IU)
     &             - ( VEFF_U(1,IU)*ESL(1)
     &                +VEFF_U(2,IU)*ESL(2)
     &                +VEFF_U(3,IU)*ESL(3))*ESL(K)
              FB_U(K,IU) = UN *SRC_U(L,IU) + UN_U*SRC(L)
            ENDDO
C
            DCPB(K,L) = FB(K) * 2.0 * DINV*DRLMI
          ENDDO
C
          CALL CROSS(RROT,FB,MB)
          DO IU = 1, 6
            CALL CROSS(RROT,FB_U(1,IU),MB_U(1,IU)) 
          ENDDO
C
          CDBDY(IB) = CDBDY(IB) + ( FB(1)*COSA + FB(3)*SINA) * 2.0/SREF
          CLBDY(IB) = CLBDY(IB) + (-FB(1)*SINA + FB(3)*COSA) * 2.0/SREF

          CXBDY(IB) = CXBDY(IB) +   FB(1) * 2.0/SREF
          CYBDY(IB) = CYBDY(IB) +   FB(2) * 2.0/SREF
          CZBDY(IB) = CZBDY(IB) +   FB(3) * 2.0/SREF
C
          CRBDY(IB) = CRBDY(IB) +   MB(1) * 2.0/SREF / BREF
          CMBDY(IB) = CMBDY(IB) +   MB(2) * 2.0/SREF / CREF
          CNBDY(IB) = CNBDY(IB) +   MB(3) * 2.0/SREF / BREF
C
          DO IU = 1, 6
            CDBDY_U(IU) = CDBDY_U(IU) + ( FB_U(1,IU)*COSA
     &                                  + FB_U(3,IU)*SINA) * 2.0/SREF
            CLBDY_U(IU) = CLBDY_U(IU) + (-FB_U(1,IU)*SINA
     &                                  + FB_U(3,IU)*COSA) * 2.0/SREF
c
            CXBDY_U(IU) = CXBDY_U(IU) +   FB_U(1,IU) * 2.0/SREF
            CYBDY_U(IU) = CYBDY_U(IU) +   FB_U(2,IU) * 2.0/SREF
            CZBDY_U(IU) = CZBDY_U(IU) +   FB_U(3,IU) * 2.0/SREF
C
            CRBDY_U(IU) = CRBDY_U(IU) +   MB_U(1,IU) * 2.0/SREF / BREF
            CMBDY_U(IU) = CMBDY_U(IU) +   MB_U(2,IU) * 2.0/SREF / CREF
            CNBDY_U(IU) = CNBDY_U(IU) +   MB_U(3,IU) * 2.0/SREF / BREF
          ENDDO
 205    CONTINUE
C
C---- add body forces and sensitivities to totals
        CDTOT = CDTOT + CDBDY(IB)
        CLTOT = CLTOT + CLBDY(IB)
C
        CXTOT = CXTOT + CXBDY(IB)
        CYTOT = CYTOT + CYBDY(IB)
        CZTOT = CZTOT + CZBDY(IB)
C
        CRTOT = CRTOT + CRBDY(IB)
        CMTOT = CMTOT + CMBDY(IB)
        CNTOT = CNTOT + CNBDY(IB)
C
        DO IU = 1, 6
          CDTOT_U(IU) = CDTOT_U(IU) + CDBDY_U(IU)
          CLTOT_U(IU) = CLTOT_U(IU) + CLBDY_U(IU)
C
          CXTOT_U(IU) = CXTOT_U(IU) + CXBDY_U(IU)
cccc      CXTOT_U(IU) = CYTOT_U(IU) + CYBDY_U(IU)   <<< BUG  5 Dec 10  MD
          CYTOT_U(IU) = CYTOT_U(IU) + CYBDY_U(IU)
          CZTOT_U(IU) = CZTOT_U(IU) + CZBDY_U(IU)
C
          CRTOT_U(IU) = CRTOT_U(IU) + CRBDY_U(IU)
          CMTOT_U(IU) = CMTOT_U(IU) + CMBDY_U(IU)
          CNTOT_U(IU) = CNTOT_U(IU) + CNBDY_U(IU)
        ENDDO
 200  CONTINUE
C
      RETURN
      END ! BDFORC



      SUBROUTINE VINFAB
C
C...Purpose:  To calculate free stream vector components and sensitivities
C
C...Input:   ALFA       Angle of attack (for stability-axis definition)
C            BETA       Sideslip angle (positive wind on right cheek facing fwd)
C...Output:  VINF(3)    Velocity components of free stream
C            VINF_A(3)  dVINF()/dALFA
C            VINF_B(3)  dVINF()/dBETA
C
      INCLUDE 'AVL.INC'
C
      SINA = SIN(ALFA)
      COSA = COS(ALFA)
      SINB = SIN(BETA)
      COSB = COS(BETA)
C
      VINF(1) =  COSA*COSB
      VINF(2) =      -SINB
      VINF(3) =  SINA*COSB
C
      VINF_A(1) = -SINA*COSB
      VINF_A(2) =  0.
      VINF_A(3) =  COSA*COSB
C
      VINF_B(1) = -COSA*SINB
      VINF_B(2) =      -COSB
      VINF_B(3) = -SINA*SINB
C
      RETURN
      END ! VINFAB

C***********************************************************************
C    Module:  airutil.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE READBL(FNAME,IBX,NBX,XB,YB,IIB,NBL,
     &                  NAME,XINL,XOUT,YBOT,YTOP)
      CHARACTER*(*) FNAME
      DIMENSION XB(IBX,NBX) ,YB(IBX,NBX)
      DIMENSION IIB(NBX)
      CHARACTER*(*) NAME
C----------------------------------------------
C     Reads in blade.xxx dataset
C----------------------------------------------
C
      CHARACTER*80 LINE
      LOGICAL ERROR
C
      DIMENSION AINPUT(20)
C
      CHARACTER*19 NCHARS
      DATA NCHARS / '0123456789-+.,EDed ' /
C
C---- default top/bottom flow area ratio for "old" blade.xxx files
      DATA YRAT / 1.3 /
C
C---- first assume that there will be a read error
      NBL = 0
C
      NF = INDEX(FNAME,' ') + 1
C
      LU = 3
C
      OPEN(LU,FILE=FNAME,STATUS='OLD',ERR=98)
C
      READ(LU,1000) LINE
C
C---- if first line has any non-numeric character, go treat it as the name
      DO K=1, 80
        IF(INDEX(NCHARS,LINE(K:K)) .EQ. 0) GO TO 20
      ENDDO
C
C---- plain unlabeled file: rewind, and just read in X,Y coordinates
      NAME = ' '
      NINPUT = 0
C
      REWIND(LU)
cc      WRITE(*,*)
cc      WRITE(*,*) 'Reading plain coordinate file'
      GO TO 40
C
C---- first line interpreted as label string
   20 READ(LINE,1000) NAME
C
C---- read and decode second line --- grid domain limits will be set later
      READ(LU,1000) LINE
      NINPUT = 4
      CALL GETFLT(LINE,AINPUT,NINPUT,ERROR)
C
      IF(ERROR) GO TO 99
C
      IF(NINPUT.LT.4) THEN
C------ no domain parameters: re-read name string and then read X,Y coordinates
        REWIND(LU)
        READ(LU,1000) LINE
      ENDIF
C
cc      WRITE(*,1010) NAME
cc 1010 FORMAT(/1X,'Reading in coordinate file for: ',A/)
C
 40   CONTINUE
C
C---- read in airfoil coordinates
      DO 55 N=1, NBX+1
        IB = 1
 50     CONTINUE
          READ(LU,*,END=56,ERR=99) XBT, YBT
          IF(XBT.EQ.999.0) THEN
           IIB(N) = IB-1
           GO TO 55
          ENDIF
          IF(N.GT.NBX) THEN
           WRITE(*,*) '*** READBL: Too many elements. Increase NBX to',N
           STOP
          ENDIF
          IBLIM = MIN( IB , IBX )
          XB(IBLIM,N) = XBT
          YB(IBLIM,N) = YBT
C
          IB = IB + 1
          GO TO 50
   55 CONTINUE
      N = NBX
C
   56 CONTINUE
      IF(IB.EQ.1) THEN
C----- coordinate file has "999.0 999.0" at the end ...
       NBL = N-1
      ELSE
C----- coordinate file has no ending line (single element ISES file)
       NBL = N
       IIB(N) = IB-1
      ENDIF
C
      CLOSE(LU)
C
C
      DO 80 N = 1, NBL
        IF(IIB(N).GT.IBX) THEN
         WRITE(*,*)
     &    '*** READBL: Too many airfoil points. Increase IBX to', IIB(N)
         STOP
        ENDIF
C
C------ calculate airfoil element area
        AREA = 0.
        DO 802 IB=1, IIB(N)-1
          RX = XB(IB+1,N) + XB(IB,N)
          RY = YB(IB+1,N) + YB(IB,N)
          DX = XB(IB+1,N) - XB(IB,N)
          DY = YB(IB+1,N) - YB(IB,N)
          DA = 0.25*(RX*DY - RY*DX)
          AREA = AREA + DA
 802    CONTINUE
C
        IF(AREA.LT.0.0) THEN
C------- if area is negative (clockwise order), reverse coordinate order
         DO 804 IB=1, IIB(N)/2
           IBACK = IIB(N) - IB + 1
           XTMP = XB(IB,N)
           YTMP = YB(IB,N)
           XB(IB,N) = XB(IBACK,N)
           YB(IB,N) = YB(IBACK,N)
           XB(IBACK,N) = XTMP
           YB(IBACK,N) = YTMP
 804     CONTINUE
        ENDIF
C
 80   CONTINUE
C
      IF     (NINPUT.LT.4) THEN
C------ plain or labeled airfoil file -- no domain parameters specified
        XINL = 0.
        XOUT = 0.
        YBOT = 0.
        YTOP = 0.
      ELSEIF (NINPUT.EQ.4) THEN
C------ for "new" blade.xxx file, grid size is input directly
        XINL = AINPUT(1)
        XOUT = AINPUT(2)
        YBOT = AINPUT(3)
        YTOP = AINPUT(4)
      ELSE
C------ "old" blade.xxx file, grid size is implied from airfoil limits
        CHINL = AINPUT(3)
        CHOUT = AINPUT(4)
        CHWID = AINPUT(5)
C
        XMIN = XB(1,1) + 1.0
        XMAX = XB(1,1) - 1.0
        DO 84 N=1, NBL
          DO 842 IB=1, IIB(N)
            IF(XB(IB,N).LE.XMIN) THEN
             XMIN = XB(IB,N)
             YMIN = YB(IB,N)
            ENDIF
            IF(XB(IB,N).GE.XMAX) THEN
             XMAX = XB(IB,N)
             YMAX = YB(IB,N)
            ENDIF
 842      CONTINUE
 84     CONTINUE
C
        XINL = XMIN - CHINL
        XOUT = XMAX + CHOUT
        YBOT = YMIN - CHWID *  1.0/(1.0 + YRAT)
        YTOP = YMAX + CHWID * YRAT/(1.0 + YRAT)
      ENDIF
C
C
      RETURN
C
   98 CONTINUE
      WRITE(*,1050) FNAME(1:NF)
      NBL = 0
      RETURN
C
   99 CONTINUE
      WRITE(*,1100) FNAME(1:NF)
      RETURN
C...............................................................
 1000 FORMAT(A)
 1050 FORMAT(/' File OPEN error:  ', A)
 1100 FORMAT(/' File READ error:  ', A)
      END ! READBL



      SUBROUTINE GETCAM(X,Y,N,XC,YC,TC,NC,LNORM)
C
C---Takes airfoil X,Y surface points and returns the camber defined
C   in XC,YC at NC points
C
      REAL X(*), Y(*), XC(*), YC(*), TC(*)
      LOGICAL LNORM
C
      PARAMETER(NSIZ=500)
      REAL XP(NSIZ), YP(NSIZ), S(NSIZ)
C
      PI = 4.0*ATAN(1.0)
      IF(N.GT.NSIZ) THEN
       WRITE(*,*) '*** GETCAM: Array overflow. Increase NSIZ to', N
       STOP
      ENDIF
C
C---- spline coordinates
      CALL SCALC(X,Y,S,N)
      CALL SEGSPL(X,XP,S,N)
      CALL SEGSPL(Y,YP,S,N)
C
C---- find arc length position of leading edge
      CALL LEFIND(SLE,X,XP,Y,YP,S,N)
C
C---- normalize airfoil and its spline data to unit chord
      IF(LNORM) CALL NORMIT(SLE,X,XP,Y,YP,S,N)
C
      XLE = SEVAL(SLE,X,XP,S,N)
      YLE = SEVAL(SLE,Y,YP,S,N)
      XTE = 0.5*(X(1)+X(N))
      YTE = 0.5*(Y(1)+Y(N))
C
C---- Number of output points defaults to 30
      IF(NC.LE.0) NC = 30
C
      SU = SLE - 0.01
      SL = SLE + 0.01
      FNC1 = FLOAT(NC-1)
      XC(1) = XLE
      YC(1) = YLE
      TC(1) = 0.0
      DO I = 2, NC
        XOUT = XLE + (XTE-XLE)*0.5*(1.0 - COS(PI*FLOAT(I-1)/FNC1))
        CALL SINVRT(SU,XOUT,X,XP,S,N)
        YU = SEVAL(SU,Y,YP,S,N)
        CALL SINVRT(SL,XOUT,X,XP,S,N)
        YL = SEVAL(SL,Y,YP,S,N)
        XC(I) = XOUT
        YC(I) = 0.5*(YU+YL)
        TC(I) = YU-YL
      END DO
C
      RETURN
      END


      SUBROUTINE LEFIND(SLE,X,XP,Y,YP,S,N)
C     .......................................
C
C     Finds the spline parameter value SLE
C     at the leftmost point of the airfoil
C     (i.e. the leading edge)
C     .......................................
C
      REAL X(N),Y(N),XP(N),YP(N),S(N)
C
C---- initial guess for SLE = leftmost point
      DO I = 2, N
        IF(X(I).GT.X(I-1)) GO TO 6
      END DO
    6 SLE = S(I-1)
C
C---- Newton solution for the exact SLE value (at least to within machine zero)
      SREF = S(N) - S(1)
      DO ITER = 1, 20
        RES  = DEVAL(SLE,X,XP,S,N)
        RESP = D2VAL(SLE,X,XP,S,N)
        DSLE = -RES/RESP
        SLE = SLE + DSLE
        IF(ABS(DSLE)/SREF .LT. 1.0E-5) RETURN
      END DO
      WRITE(*,*) '** LEFIND: Leading edge not found.  Continuing...'
      SLE = S(I-1)
      RETURN
      END ! LEFIND
 
 

 
      SUBROUTINE NORMIT(SLE,X,XP,Y,YP,S,N)
C     .................................................
C
C     Normalizes airfoil coordinates and their spline
C     parameter to unit chord. The x coordinates are
C     also offset so that the leading edge is at x = 0.
C     .................................................
C
      REAL X(N),Y(N),XP(N),YP(N),S(N)
C
C---- leading edge and trailing edge x coordinates
      XLE = SEVAL(SLE,X,XP,S,N)
      XTE = 0.5*(X(1)+X(N))
C
C---- normalizing factor
      DNORM = 1.0/(XTE-XLE)
      DO I = 1, N
        X(I) = (X(I)-XLE)*DNORM
        Y(I) = Y(I)*DNORM
        S(I) = S(I)*DNORM
      END DO
      SLE = SLE*DNORM
C
      RETURN
      END ! NORMIT

C***********************************************************************
C    Module:  atpforc.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE TPFORC
C
C...PURPOSE  To calculate the far-field forces on the configuration using
C            a trefftz plane method.
C
C...INPUT    Geometry data from labelled commons
C            CNC     Strip span loading 
C
C...OUTPUT   CLFF    Total far-field lift
C            CYFF    Total far-field side force
C            CDFF    Total far-field drag
C            SPANEF  Span efficiency
C            DWWAKE  Far-field wake downwash at center of strip 
C
C...COMMENTS   The far-field drag is calculated using the Trefftz
C            plane (kinetic energy integral in the far wake).
C            The span-loading CNC is all that is required, plus
C            geometry data defining the wake position.
C            Since the wakes are just the horseshoe legs extending 
C            downstream from the bound legs, only the Y and Z 
C            coordinates are used. The normalwash in the cross-plane
C            is evaluated over the real and "image" sides.
C
      INCLUDE 'AVL.INC'
C
      REAL NY, NZ
      REAL VY_U(NUMAX), VZ_U(NUMAX), 
     &     VY_D(NDMAX), VZ_D(NDMAX), 
     &     VY_G(NGMAX), VZ_G(NGMAX)
      REAL P(3,3), P_M(3,3), P_A(3,3), P_B(3,3)
      REAL RT1(3,NSMAX),
     &     RT2(3,NSMAX),
     &     RTC(3,NSMAX)
      REAL GAMS(NSMAX), 
     &     GAMS_U(NSMAX,NUMAX),
     &     GAMS_D(NSMAX,NDMAX),
     &     GAMS_G(NSMAX,NGMAX)
C
      HPI = 1.0 / (2.0*PI)
C
C---- set Prandtl-Glauert transformation matrix
      ALFAT = 0.
      BETAT = 0.
      CALL PGMAT(AMACH,ALFAT,BETAT,P,P_M,P_A,P_B)
C
      YOFF = 2.0*YSYM
      ZOFF = 2.0*ZSYM
C
      CLFF = 0.
      CYFF = 0.
      CDFF = 0.
      DO N = 1, NUMAX
        CLFF_U(N) = 0.
        CYFF_U(N) = 0.
        CDFF_U(N) = 0.
      ENDDO
      DO N = 1, NCONTROL
        CLFF_D(N) = 0.
        CYFF_D(N) = 0.
        CDFF_D(N) = 0.
      ENDDO
      DO N = 1, NDESIGN
        CLFF_G(N) = 0.
        CYFF_G(N) = 0.
        CDFF_G(N) = 0.
      ENDDO
C
      DO JC = 1, NSTRIP
        GAMS(JC) = 0.
        DO N = 1, NUMAX
          GAMS_U(JC,N) = 0.
        ENDDO
        DO N = 1, NCONTROL
          GAMS_D(JC,N) = 0.
        ENDDO
        DO N = 1, NDESIGN
          GAMS_G(JC,N) = 0.
        ENDDO
C
ccc        ISURF = NSURFS(JC)
ccc        IF(LFLOAD(ISURF)) THEN   !Bug 6/13/14 HHY 
C------- add circulation of this strip only if it contributes to total load
         I1  = IJFRST(JC)
         NVC = NVSTRP(JC)
         DO I = I1, I1+NVC-1 
           GAMS(JC) = GAMS(JC) + GAM(I)
           DO N = 1, NUMAX
             GAMS_U(JC,N) = GAMS_U(JC,N) + GAM_U(I,N)
           ENDDO
           DO N = 1, NCONTROL
             GAMS_D(JC,N) = GAMS_D(JC,N) + GAM_D(I,N)
           ENDDO
           DO N = 1, NDESIGN
             GAMS_G(JC,N) = GAMS_G(JC,N) + GAM_G(I,N)
           ENDDO
         ENDDO
ccc        ENDIF
      ENDDO
C
C---- set x,y,z in wind axes (Y,Z are then in Trefftz plane)
      DO JC = 1, NSTRIP
        IC = IJFRST(JC) + NVSTRP(JC) - 1
        DO K = 1, 3
          RT1(K,JC) = P(K,1)*RV1(1,IC)+P(K,2)*RV1(2,IC)+P(K,3)*RV1(3,IC)
          RT2(K,JC) = P(K,1)*RV2(1,IC)+P(K,2)*RV2(2,IC)+P(K,3)*RV2(3,IC)
          RTC(K,JC) = P(K,1)*RC (1,IC)+P(K,2)*RC (2,IC)+P(K,3)*RC (3,IC)
        ENDDO
      ENDDO
C
C...Find the normal velocity across each strip at the projected control
C   point location
      DO 40 JC = 1, NSTRIP
        DXT = RT2(1,JC) - RT1(1,JC)
        DYT = RT2(2,JC) - RT1(2,JC)
        DZT = RT2(3,JC) - RT1(3,JC)
        DST = SQRT(DYT*DYT + DZT*DZT)
C
        NY = -DZT / DST
        NZ =  DYT / DST
        YCNTR = RTC(2,JC)
        ZCNTR = RTC(3,JC)
C
        VY = 0.
        VZ = 0.
        DO N = 1, NUMAX
          VY_U(N) = 0.
          VZ_U(N) = 0.
        ENDDO
        DO N = 1, NCONTROL
          VY_D(N) = 0.
          VZ_D(N) = 0.
        ENDDO
        DO N = 1, NDESIGN
          VY_G(N) = 0.
          VZ_G(N) = 0.
        ENDDO
C
C...Sum velocity contributions from wake vortices
        DO 30 JV = 1, NSTRIP
          DSYZ = SQRT(  (RT2(2,JV)-RT1(2,JV))**2
     &                + (RT2(3,JV)-RT1(3,JV))**2 )
          IF(LSCOMP(NSURFS(JC)) .EQ. LSCOMP(NSURFS(JV))) THEN
ccc        RCORE = 0.0001*DSYZ
           RCORE = 0.
          ELSE
           RCORE = MAX( VRCORE*CHORD(JV) , 2.0*VRCORE*DSYZ )
          ENDIF
C
          RCORE = 0.
C
          DY1 = YCNTR - RT1(2,JV)
          DY2 = YCNTR - RT2(2,JV)
          DZ1 = ZCNTR - RT1(3,JV)
          DZ2 = ZCNTR - RT2(3,JV)
          RSQ1 = DY1*DY1 + DZ1*DZ1 + RCORE**2
          RSQ2 = DY2*DY2 + DZ2*DZ2 + RCORE**2
          VY = VY + HPI*GAMS(JV)*( DZ1/RSQ1 - DZ2/RSQ2)
          VZ = VZ + HPI*GAMS(JV)*(-DY1/RSQ1 + DY2/RSQ2)
          DO N = 1, NUMAX
            VY_U(N) = VY_U(N) + HPI*GAMS_U(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)
            VZ_U(N) = VZ_U(N) + HPI*GAMS_U(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)
          ENDDO
          DO N = 1, NCONTROL
            VY_D(N) = VY_D(N) + HPI*GAMS_D(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)
            VZ_D(N) = VZ_D(N) + HPI*GAMS_D(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)
          ENDDO
          DO N = 1, NDESIGN
            VY_G(N) = VY_G(N) + HPI*GAMS_G(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)
            VZ_G(N) = VZ_G(N) + HPI*GAMS_G(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)
          ENDDO
C
          IF(IZSYM.NE.0) THEN
            DY1 = YCNTR -       RT1(2,JV)
            DY2 = YCNTR -       RT2(2,JV)
            DZ1 = ZCNTR - (ZOFF-RT1(3,JV))
            DZ2 = ZCNTR - (ZOFF-RT2(3,JV))
CCC         DZ1 = ZCNTR - (ZOFF-RT1(3,JV)+ALFA*RT1(1,JV))
CCC         DZ2 = ZCNTR - (ZOFF-RT2(3,JV)+ALFA*RT2(1,JV))
            RSQ1 = DY1*DY1 + DZ1*DZ1
            RSQ2 = DY2*DY2 + DZ2*DZ2
            VY = VY - HPI*GAMS(JV)*( DZ1/RSQ1 - DZ2/RSQ2)*IZSYM
            VZ = VZ - HPI*GAMS(JV)*(-DY1/RSQ1 + DY2/RSQ2)*IZSYM
            DO N = 1, NUMAX
              VY_U(N) = VY_U(N)
     &          - HPI*GAMS_U(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)*IZSYM
              VZ_U(N) = VZ_U(N)
     &          - HPI*GAMS_U(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)*IZSYM
            ENDDO
            DO N = 1, NCONTROL
              VY_D(N) = VY_D(N)
     &          - HPI*GAMS_D(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)*IZSYM
              VZ_D(N) = VZ_D(N)
     &          - HPI*GAMS_D(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)*IZSYM
            ENDDO
            DO N = 1, NDESIGN
              VY_G(N) = VY_G(N)
     &          - HPI*GAMS_G(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)*IZSYM
              VZ_G(N) = VZ_G(N)
     &          - HPI*GAMS_G(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)*IZSYM
            ENDDO
          ENDIF 
C
          IF(IYSYM.NE.0) THEN
            DY1 = YCNTR - (YOFF-RT1(2,JV))
            DY2 = YCNTR - (YOFF-RT2(2,JV))
            DZ1 = ZCNTR -       RT1(3,JV)
            DZ2 = ZCNTR -       RT2(3,JV)
            RSQ1 = DY1*DY1 + DZ1*DZ1
            RSQ2 = DY2*DY2 + DZ2*DZ2
            VY = VY - HPI*GAMS(JV)*( DZ1/RSQ1 - DZ2/RSQ2)*IYSYM
            VZ = VZ - HPI*GAMS(JV)*(-DY1/RSQ1 + DY2/RSQ2)*IYSYM
            DO N = 1, NUMAX
              VY_U(N) = VY_U(N)
     &          - HPI*GAMS_U(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)*IYSYM
              VZ_U(N) = VZ_U(N)
     &          - HPI*GAMS_U(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)*IYSYM
            ENDDO
            DO N = 1, NCONTROL
              VY_D(N) = VY_D(N)
     &          - HPI*GAMS_D(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)*IYSYM
              VZ_D(N) = VZ_D(N)
     &          - HPI*GAMS_D(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)*IYSYM
            ENDDO
            DO N = 1, NDESIGN
              VY_G(N) = VY_G(N)
     &          - HPI*GAMS_G(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)*IYSYM
              VZ_G(N) = VZ_G(N)
     &          - HPI*GAMS_G(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)*IYSYM
            ENDDO
C
            IF(IZSYM.NE.0) THEN
              DY1 = YCNTR - (YOFF-RT1(2,JV))
              DY2 = YCNTR - (YOFF-RT2(2,JV))
              DZ1 = ZCNTR - (ZOFF-RT1(3,JV))
              DZ2 = ZCNTR - (ZOFF-RT2(3,JV))
CCC           DZ1 = ZCNTR - (ZOFF-RT1(3,JV)+ALFA*RT1(1,JV))
CCC           DZ2 = ZCNTR - (ZOFF-RT2(3,JV)+ALFA*RT2(1,JV))
              RSQ1 = DY1*DY1 + DZ1*DZ1
              RSQ2 = DY2*DY2 + DZ2*DZ2
              VY = VY + HPI*GAMS(JV)*( DZ1/RSQ1 - DZ2/RSQ2)*IYSYM*IZSYM
              VZ = VZ + HPI*GAMS(JV)*(-DY1/RSQ1 + DY2/RSQ2)*IYSYM*IZSYM
              DO N = 1, NUMAX
                VY_U(N) = VY_U(N)
     &            - HPI*GAMS_U(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)*IYSYM*IZSYM
                VZ_U(N) = VZ_U(N)
     &            - HPI*GAMS_U(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)*IYSYM*IZSYM
              ENDDO
              DO N = 1, NCONTROL
                VY_D(N) = VY_D(N)
     &            - HPI*GAMS_D(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)*IYSYM*IZSYM
                VZ_D(N) = VZ_D(N)
     &            - HPI*GAMS_D(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)*IYSYM*IZSYM
              ENDDO
              DO N = 1, NDESIGN
                VY_G(N) = VY_G(N)
     &            - HPI*GAMS_G(JV,N)*( DZ1/RSQ1 - DZ2/RSQ2)*IYSYM*IZSYM
                VZ_G(N) = VZ_G(N)
     &            - HPI*GAMS_G(JV,N)*(-DY1/RSQ1 + DY2/RSQ2)*IYSYM*IZSYM
              ENDDO
            ENDIF
          ENDIF
C
   30   CONTINUE
C
        DWWAKE(JC) = -(NY*VY + NZ*VZ)
C
C...Trefftz-plane drag is kinetic energy in crossflow
C
        ISURF = NSURFS(JC)
        IF(LFLOAD(ISURF)) THEN   
C-------add load from this strip only if it contributes to total load
         CLFF = CLFF + 2.0*GAMS(JC)*          DYT    /SREF
         CYFF = CYFF - 2.0*GAMS(JC)* DZT             /SREF
         CDFF = CDFF +     GAMS(JC)*(DZT*VY - DYT*VZ)/SREF
         DO N = 1, NUMAX
           CLFF_U(N) = CLFF_U(N) + 2.0*GAMS_U(JC,N)*DYT/SREF
           CYFF_U(N) = CYFF_U(N) - 2.0*GAMS_U(JC,N)*DZT/SREF
           CDFF_U(N) = CDFF_U(N)
     &              + (  GAMS_U(JC,N)*(DZT*VY      - DYT*VZ     )
     &                 + GAMS(JC)    *(DZT*VY_U(N) - DYT*VZ_U(N)) )/SREF
         ENDDO
         DO N = 1, NCONTROL
           CLFF_D(N) = CLFF_D(N) + 2.0*GAMS_D(JC,N)*DYT/SREF
           CYFF_D(N) = CYFF_D(N) - 2.0*GAMS_D(JC,N)*DZT/SREF
           CDFF_D(N) = CDFF_D(N)
     &              + (  GAMS_D(JC,N)*(DZT*VY      - DYT*VZ     )
     &                 + GAMS(JC)    *(DZT*VY_D(N) - DYT*VZ_D(N)) )/SREF
         ENDDO
         DO N = 1, NDESIGN
           CLFF_G(N) = CLFF_G(N) + 2.0*GAMS_G(JC,N)*DYT/SREF
           CYFF_G(N) = CYFF_G(N) - 2.0*GAMS_G(JC,N)*DZT/SREF
           CDFF_G(N) = CDFF_G(N)
     &              + (  GAMS_G(JC,N)*(DZT*VY      - DYT*VZ     )
     &                 + GAMS(JC)    *(DZT*VY_G(N) - DYT*VZ_G(N)) )/SREF
         ENDDO
        ENDIF
   40 CONTINUE
C
C---- Double the X,Z forces, zero Y force for a Y symmetric case
      IF(IYSYM.EQ.1) THEN
       CLFF = 2.0 * CLFF
       CYFF = 0.0
       CDFF = 2.0 * CDFF
       DO N = 1, NUMAX
         CLFF_U(N) = 2.0 * CLFF_U(N)
         CYFF_U(N) = 0.0
         CDFF_U(N) = 2.0 * CDFF_U(N)
       ENDDO
       DO N = 1, NCONTROL
         CLFF_D(N) = 2.0 * CLFF_D(N)
         CYFF_D(N) = 0.0
         CDFF_D(N) = 2.0 * CDFF_D(N)
       ENDDO
       DO N = 1, NDESIGN
         CLFF_G(N) = 2.0 * CLFF_G(N)
         CYFF_G(N) = 0.0
         CDFF_G(N) = 2.0 * CDFF_G(N)
       ENDDO
      ENDIF
C
C---- aspect ratio
      AR = BREF**2 / SREF
C
C---- span efficiency
      IF(CDFF .EQ. 0.0) THEN
       SPANEF = 0.
       SPANEF_A = 0.
       DO N = 1, NUMAX
         SPANEF_U(N) = 0.
       ENDDO
       DO N = 1, NCONTROL
         SPANEF_D(N) = 0.
       ENDDO
       DO N = 1, NDESIGN
         SPANEF_G(N) = 0.
       ENDDO
C
      ELSE
       SPANEF = (CLFF**2 + CYFF**2)/ (PI * AR * CDFF)
       SPANEF_CL = 2.0*CLFF / (PI * AR * CDFF)
       SPANEF_CY = 2.0*CYFF / (PI * AR * CDFF)
       SPANEF_CD = -SPANEF/CDFF
C
       SPANEF_A = 0.
       DO N = 1, NUMAX
         SPANEF_U(N) = SPANEF_CL*CLFF_U(N)
     &               + SPANEF_CY*CYFF_U(N)
     &               + SPANEF_CD*CDFF_U(N)
       ENDDO
       DO N = 1, NCONTROL
         SPANEF_D(N) = SPANEF_CL*CLFF_D(N)
     &               + SPANEF_CY*CYFF_D(N)
     &               + SPANEF_CD*CDFF_D(N)
       ENDDO
       DO N = 1, NDESIGN
         SPANEF_G(N) = SPANEF_CL*CLFF_G(N)
     &               + SPANEF_CY*CYFF_G(N)
     &               + SPANEF_CD*CDFF_G(N)
       ENDDO
      ENDIF
C
      RETURN
      END ! TPFORC



      SUBROUTINE PGMAT(MACH,ALFA,BETA,P,P_M,P_A,P_B)
C-------------------------------------------------------
C     Calculates Prandtl-Glauert transformation matrix.
C      
C      xi      [       ] x
C              [       ]  
C      eta  =  [   P   ] y
C              [       ]
C      zeta    [       ] z
C
C-------------------------------------------------------
C
      REAL MACH, ALFA, BETA
      REAL P(3,3), P_M(3,3), P_A(3,3), P_B(3,3)
C
      BINV = 1.0 / SQRT(1.0 - MACH**2)
      BI_M = MACH * BINV**3
C
      SINA = SIN(ALFA)
      COSA = COS(ALFA)
C
      SINB = SIN(BETA)
      COSB = COS(BETA)
C
C
      P(1,1) =  COSA*COSB*BINV
      P(1,2) =      -SINB*BINV
      P(1,3) =  SINA*COSB*BINV
C
      P(2,1) =  COSA*SINB
      P(2,2) =       COSB
      P(2,3) =  SINA*SINB
C
      P(3,1) = -SINA
      P(3,2) = 0.
      P(3,3) =  COSA
C
C
      P_M(1,1) =  COSA*COSB*BI_M
      P_M(1,2) =      -SINB*BI_M
      P_M(1,3) =  SINA*COSB*BI_M
C
      P_M(2,1) = 0.
      P_M(2,2) = 0.
      P_M(2,3) = 0.
C
      P_M(3,1) = 0.
      P_M(3,2) = 0.
      P_M(3,3) = 0.
C
C
      P_A(1,1) = -SINA*COSB*BINV
      P_A(1,2) = 0.
      P_A(1,3) =  COSA*COSB*BINV
C
      P_A(2,1) = -SINA*SINB
      P_A(2,2) = 0.
      P_A(2,3) =  COSA*SINB
C
      P_A(3,1) = -COSA
      P_A(3,2) = 0.
      P_A(3,3) = -SINA
C
C
      P_B(1,1) = -COSA*SINB*BINV
      P_B(1,2) =      -COSB*BINV
      P_B(1,3) = -SINA*SINB*BINV
C
      P_B(2,1) =  COSA*COSB
      P_B(2,2) =      -SINB
      P_B(2,3) =  SINA*COSB
C
      P_B(3,1) = 0.
      P_B(3,2) = 0.
      P_B(3,3) = 0.
C
      RETURN
      END ! PGMAT

C***********************************************************************
C    Module:  hidden.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE TRIINIT(ID,NROWS,NCOLS,PTS, NTRI,TRI)
C...PURPOSE:  Set up triangle data for hidden line routine from quadrilateral
C             input polygons.
C
C          This routine takes a grid of quadrilaterals and defines
C          two triangles per quad and puts them into the triangle 
C          arrays.  The input grid of quads is in the form of NROWSxNCOLS
C          of quads, defined by NROWS+1 x NCOLS+1 points in the PTS array. 
C          The ID index corresponds to the first quad in the lattice and 
C          is incremented as TRIINIT steps through the quad array to define
C          triangles.  Thus the output value of ID is ID + NROWSxNCOLS - 1.
C          This allows the user to use the ID option in the hidden line 
C          routines to avoid visibility tests for input features that  
C          lie on triangles with the same ID index.
C
      REAL PTS(3,*)
      REAL XYZLIM(3,2), TRI(16,*)
C
      IT = NTRI
      IDX = ID - 1
C
C--- For a rectangular grid of quadrilaterals defined by NROWS, NCOLS
C    polygons, find the vertices of each quadrilateral and divide it into
C    two triangles.
C
      DO 110 J = 1, NCOLS
        DO 1110 K = 1, NROWS
C          
C--- Increment ID# to get ID for next element
          IDX  = IDX + 1
C
          IP1 = (NROWS+1)*(J-1) + K
          IP2 = IP1 + 1
          IP3 = IP1 + NROWS+1
          IP4 = IP3 + 1
C
C          1  = x1
C          2  = y1
C          3  = z1
C          4  = x2
C          5  = y2
C          6  = z2
C          7  = x3
C          8  = y3
C          9  = z3
C         10  = min(x)
C         11  = min(y)
C         12  = min(z)
C         13  = max(x)
C         14  = max(y)
C         15  = max(z)
C         16  = ID reference number
C
C--- First triangle
          IT = IT+1
C 
          TRI(1,IT) = PTS(1,IP1)
          TRI(2,IT) = PTS(2,IP1)
          TRI(3,IT) = PTS(3,IP1)
C         
          TRI(4,IT) = PTS(1,IP2)
          TRI(5,IT) = PTS(2,IP2)
          TRI(6,IT) = PTS(3,IP2)
C         
          TRI(7,IT) = PTS(1,IP3)
          TRI(8,IT) = PTS(2,IP3)
          TRI(9,IT) = PTS(3,IP3)
C         
          TRI(10,IT) = MIN( TRI(1,IT) , TRI(4,IT) , TRI(7,IT) )
          TRI(11,IT) = MIN( TRI(2,IT) , TRI(5,IT) , TRI(8,IT) )
          TRI(12,IT) = MIN( TRI(3,IT) , TRI(6,IT) , TRI(9,IT) )
          TRI(13,IT) = MAX( TRI(1,IT) , TRI(4,IT) , TRI(7,IT) )
          TRI(14,IT) = MAX( TRI(2,IT) , TRI(5,IT) , TRI(8,IT) )
          TRI(15,IT) = MAX( TRI(3,IT) , TRI(6,IT) , TRI(9,IT) )
C
          TRI(16,IT) = FLOAT(IDX)
C
C--- Second triangle          
          IT = IT+1
C         
          TRI(1,IT) = PTS(1,IP3)
          TRI(2,IT) = PTS(2,IP3)
          TRI(3,IT) = PTS(3,IP3)
C         
          TRI(4,IT) = PTS(1,IP2)
          TRI(5,IT) = PTS(2,IP2)
          TRI(6,IT) = PTS(3,IP2)
C         
          TRI(7,IT) = PTS(1,IP4)
          TRI(8,IT) = PTS(2,IP4)
          TRI(9,IT) = PTS(3,IP4)
C         
          TRI(10,IT) = MIN( TRI(1,IT) , TRI(4,IT) , TRI(7,IT) )
          TRI(11,IT) = MIN( TRI(2,IT) , TRI(5,IT) , TRI(8,IT) )
          TRI(12,IT) = MIN( TRI(3,IT) , TRI(6,IT) , TRI(9,IT) )
          TRI(13,IT) = MAX( TRI(1,IT) , TRI(4,IT) , TRI(7,IT) )
          TRI(14,IT) = MAX( TRI(2,IT) , TRI(5,IT) , TRI(8,IT) )
          TRI(15,IT) = MAX( TRI(3,IT) , TRI(6,IT) , TRI(9,IT) )
C
          TRI(16,IT) = FLOAT(IDX)
C         
 1110   CONTINUE
  110 CONTINUE
C
      NTRI = IT
      ID = IDX 
C
      RETURN
      END ! TRIINIT



      SUBROUTINE HIDLIN(XYZLIN,ID,NGRP,ILSTGRP,XYZGRP,
     &                   NTRI,XYZTRI,NSEG,ALFSEG)
C
C      This is a hidden line routine.  Given a set of triangles, and a
C      single line as input, it computes the line segments (if any)
C      which are visible.
C
C      XYZLIN = array of data about input line (unchanged by routine)
C          1,1  = x1
C          2,1  = y1
C          3,1  = z1
C          1,2  = x2
C          2,2  = y2
C          3,2  = z2
C      ID = ID index for input line 
C           May be used to designate triangle or collection of triangles 
C           that contain this line and should be skipped for visibility 
C           tests.  If ID=0 no triangles will be skipped.
C
C      NGRP = number of triangle groups 
C             (if NGRP<=0 no group minmax tests will be done)
C      ILSTGRP(n) = index of last triangle in group n
C      XYZGRP(.n) = x,y group limits
C             1   = min(x)
C             2   = min(y)
C             3   = min(z)
C             4   = max(x)
C             5   = max(y)
C             6   = max(z)
C
C      NTRI = number of triangles (used if NGRP=0)
C      XYZTRI = array of triangle data
C          1  = x1
C          2  = y1
C          3  = z1
C          4  = x2
C          5  = y2
C          6  = z2
C          7  = x3
C          8  = y3
C          9  = z3
C         10  = min(x)
C         11  = min(y)
C         12  = min(z)
C         13  = max(x)
C         14  = max(y)
C         15  = max(z)
C         16  = ID field, ID associated with this triangle 
C
C      NSEG   = (input)  dimension of ALFSEG = max. no. of segments
C               (output) number of visible line segments
C      ALFSEG = output values describing the visible line segments as
C               fractions of the original line
C          1  = beginning of segment
C          2  =       end of segment
C
       REAL XYZLIN(3,2), XYZTRI(16,*), ALFSEG(2,NSEG)
       REAL XYZGRP(6,NGRP)
       INTEGER ILSTGRP(NGRP)
C
       DATA EPS/1.0E-7/
C
       NMXSEG = NSEG
       NSEG = 0
C
C----- Initialize a few things
       X1 = XYZLIN(1,1)
       Y1 = XYZLIN(2,1)
       Z1 = XYZLIN(3,1)
       X2 = XYZLIN(1,2)
       Y2 = XYZLIN(2,2)
       Z2 = XYZLIN(3,2)
C
       XMIN = MIN(X1,X2)
       YMIN = MIN(Y1,Y2)
       ZMIN = MIN(Z1,Z2)
       XMAX = MAX(X1,X2)
       YMAX = MAX(Y1,Y2)
       ZMAX = MAX(Z1,Z2)
C---Check for degenerate line
       IF(XMAX.EQ.XMIN .AND. YMAX.EQ.YMIN .AND. ZMAX.EQ.ZMIN) RETURN
C
       NSEG = 1
       ALFSEG(1,1) = 0.0
       ALFSEG(2,1) = 1.0
C
C----- Main processing loop
       KLAST = 0
       NNGRP = MAX(1,NGRP)
C
       DO 100 IGRP=1, NNGRP
C
       KT1 = KLAST + 1
       KLAST = NTRI
C
       IF(NGRP.GE.1) THEN   
C--- Check for group with no triangles (last index <= 0)
       IF(ILSTGRP(IGRP).LE.0) GO TO 100
        KLAST = ILSTGRP(IGRP)       
C..... preliminary purge of whole group
        IF( (XYZGRP(1,IGRP).GE.XMAX .OR. 
     &       XYZGRP(4,IGRP).LE.XMIN) .OR.
     &      (XYZGRP(2,IGRP).GE.YMAX .OR. 
     &       XYZGRP(5,IGRP).LE.YMIN) ) GO TO 100
C     &      (XYZGRP(6,IGRP).LE.ZMIN) ) GO TO 100
       ENDIF
C
       DO 1 KT=KT1, KLAST
C
C....... second purge of most cells
         IF( (XYZTRI(10,KT).GE.XMAX .OR. 
     &        XYZTRI(13,KT).LE.XMIN)   .OR.
     &       (XYZTRI(11,KT).GE.YMAX .OR. 
     &        XYZTRI(14,KT).LE.YMIN)   .OR.
     &       (XYZTRI(15,KT).LE.ZMIN) ) GO TO 1
C
C....... if ID of this line matches a triangle ID skip visibility tests
         IF(ID.NE.0) THEN
          IDTRI = IFIX(XYZTRI(16,KT))
          IF(ID.EQ.IDTRI) GO TO 1
         ENDIF
C
C---Check for line as a side of masking triangle
         NSAME=0
         DO IS=1,2
           DO L=1, 3
             IF( ABS(XYZLIN(1,IS)-XYZTRI(1+3*(L-1),KT)).LT.EPS .AND.
     &           ABS(XYZLIN(2,IS)-XYZTRI(2+3*(L-1),KT)).LT.EPS .AND.
     &           ABS(XYZLIN(3,IS)-XYZTRI(3+3*(L-1),KT)).LT.EPS ) THEN
               NSAME=NSAME+1
             ENDIF
           END DO
         END DO
         IF(NSAME.GE.2) THEN
          GO TO 1
         ENDIF
C
C--- Find where cell nodes are relative to line
         N1 = 0
           IF( (XYZTRI(1,KT)-X1)*(Y2-Y1) .GT. 
     &         (XYZTRI(2,KT)-Y1)*(X2-X1) )    N1 = N1+1
           IF( (XYZTRI(4,KT)-X1)*(Y2-Y1) .GT. 
     &         (XYZTRI(5,KT)-Y1)*(X2-X1) )    N1 = N1+2
           IF( (XYZTRI(7,KT)-X1)*(Y2-Y1) .GT. 
     &         (XYZTRI(8,KT)-Y1)*(X2-X1) )    N1 = 3-N1
C
C--- Skip tests if triangle points all on one side of line
         IF(N1.EQ.0) GO TO 1
C
C--- Set up temporary variables in canonical orientation where the line
C    passes through sides 1-2 and 1-3 of triangle (point 1 is common point)
         N2 = MOD(N1,3) + 1           
         N3 = MOD(N2,3) + 1           
C
         XT1 = XYZTRI(3*N1-2,KT)
         YT1 = XYZTRI(3*N1-1,KT)
         ZT1 = XYZTRI(3*N1  ,KT)
         XT2 = XYZTRI(3*N2-2,KT)
         YT2 = XYZTRI(3*N2-1,KT)
         ZT2 = XYZTRI(3*N2  ,KT)
         XT3 = XYZTRI(3*N3-2,KT)
         YT3 = XYZTRI(3*N3-1,KT)
         ZT3 = XYZTRI(3*N3  ,KT)
C
C--- Compute xi, eta, zeta values for line endpoints in triangle coords
         DET = ( (XT2-XT1)*(YT3-YT1) - (XT3-XT1)*(YT2-YT1) )
         IF(DET.EQ.0.0) GO TO 1
C
         DETINV = 1.0 / DET
         XI1 = DETINV * ( (X1 -XT1)*(YT3-YT1) - (XT3-XT1)*(Y1 -YT1) )
         ET1 = DETINV * ( (XT2-XT1)*(Y1 -YT1) - (X1 -XT1)*(YT2-YT1) )
         XI2 = DETINV * ( (X2 -XT1)*(YT3-YT1) - (XT3-XT1)*(Y2 -YT1) )
         ET2 = DETINV * ( (XT2-XT1)*(Y2 -YT1) - (X2 -XT1)*(YT2-YT1) )
C
C--- Check for line parallel to triangle sides (skip hide tests)
         IF( (ABS(XI1).LT.EPS .AND. ABS(XI2).LT.EPS) .OR.
     &       (ABS(ET1).LT.EPS .AND. ABS(ET2).LT.EPS) ) GO TO 1
C
C--- Get Z coordinates relative to triangle plane
         IF(ABS(XI1-1.0).LT.EPS) XI1 = 1.0
         IF(ABS(ET1-1.0).LT.EPS) ET1 = 1.0
         ZE1 = (Z1-ZT1) - XI1*(ZT2-ZT1) - ET1*(ZT3-ZT1)
C
         IF(ABS(XI2-1.0).LT.EPS) XI2 = 1.0
         IF(ABS(ET2-1.0).LT.EPS) ET2 = 1.0
         ZE2 = (Z2-ZT1) - XI2*(ZT2-ZT1) - ET2*(ZT3-ZT1)
C
C--- Skip this triangle test if line is outside XI=0,ETA=0 or XI+ETA-1 edges
         IF(MAX(XI1,XI2).LE.0.0 .OR.
     &      MAX(ET1,ET2).LE.0.0 .OR.
     &      MIN(XI1+ET1,XI2+ET2) .GT. 1.0) GO TO 1
C
C--- Check for line completely above triangle plane
         IF(MIN(ZE1,ZE2).GE.0.) GO TO 1
C
         ALF1 = 0.0
         ALF2 = 1.0
C
C--- Intersect the line with sides 1-2 and 1-3 
C    This defines the ALF (relative coordinate on line 0->1)
         DENBET = (X2-X1)*(YT2-YT1) - (Y2-Y1)*(XT2-XT1)
         DENGAM = (X2-X1)*(YT3-YT1) - (Y2-Y1)*(XT3-XT1)
         IF( ABS(DENBET).LT.EPS .OR.
     &       ABS(DENGAM).LT.EPS ) GO TO 1

         BET = ( (0.5*(XT1+XT2)-X1)*(YT2-YT1) -
     &           (0.5*(YT1+YT2)-Y1)*(XT2-XT1) ) / DENBET
C
         GAM = ( (0.5*(XT1+XT3)-X1)*(YT3-YT1) -
     &           (0.5*(YT1+YT3)-Y1)*(XT3-XT1) ) / DENGAM
C
         ALF1 = MAX(ALF1,MIN(BET,GAM))
         ALF2 = MIN(ALF2,MAX(BET,GAM))
C
C--- If line endpoint Z values straddle the triangle plane, also 
C    check the line-plane intersection point
         IF(ZE1.GT.0.0 .AND. ZE2.LT.0.0) THEN
           ALF1 = MAX(ALF1, ZE1/(ZE1-ZE2))
          ELSEIF(ZE1.LT.0.0 .AND. ZE2.GT.0.0) THEN
           ALF2 = MIN(ALF2, ZE1/(ZE1-ZE2))
         ENDIF
C
C
C--- Skip to next triangle if no part is hidden
         IF(ALF1.GE.ALF2) GO TO 1
         IF(ALF1 .LT.     EPS) ALF1 = 0.0
         IF(ALF2 .GT. 1.0-EPS) ALF2 = 1.0
C
C....... combine new hidden part with previous visible bits
         NSEG2 = NSEG
C
         DO NS = NSEG2, 1, -1
           IF(ALF1.GE.ALFSEG(2,NS) .OR. ALF2.LE.ALFSEG(1,NS)) THEN
           ELSE IF(ALF1.GT.ALFSEG(1,NS) .AND. ALF2.LT.ALFSEG(2,NS)) THEN
            IF(NSEG.EQ.NMXSEG) THEN
             WRITE(*,*) '** HIDLIN: too many segments'
             GO TO 100
            ENDIF
            NSEG = NSEG+1
            ALFSEG(1,NSEG) = ALF2
            ALFSEG(2,NSEG) = ALFSEG(2,NS)
            ALFSEG(2,NS) = ALF1
           ELSE IF(ALF1.LE.ALFSEG(1,NS) .AND. ALF2.GE.ALFSEG(2,NS)) THEN
            ALFSEG(1,NS) = ALFSEG(1,NSEG)
            ALFSEG(2,NS) = ALFSEG(2,NSEG)
            NSEG = NSEG-1
           ELSE IF(ALF1.LE.ALFSEG(1,NS) .AND. ALF2.LT.ALFSEG(2,NS)) THEN
            ALFSEG(1,NS) = ALF2
           ELSE IF(ALF1.GT.ALFSEG(1,NS) .AND. ALF2.GE.ALFSEG(2,NS)) THEN
            ALFSEG(2,NS) = ALF1
           ENDIF
         END DO
C
         IF(NSEG.EQ.0) RETURN
 1     CONTINUE
C
 100   CONTINUE
       RETURN
       END ! HIDLIN


       SUBROUTINE HIDPNT(XYZPT,ID,NGRP,ILSTGRP,XYZGRP,NTRI,XYZTRI,LVIS)
C
C      This routine determines the visibility of a single point.
C      Given a set of triangles it computes visibility of an input point
C
C      XYZPT = test point coordinate array (X,Y,Z)
C      ID = ID index for input point 
C           May be used to designate triangle or collection of triangles 
C           that contain this point and should be skipped for visibility 
C           tests.  If ID=0 no triangles will be skipped.
C
C      NGRP = number of triangle groups 
C             (if NGRP<=0 no group minmax tests will be done)
C      ILSTGRP(n) = index of last triangle in group n
C      XYZGRP(.n) = x,y group limits
C             1   = min(x)
C             2   = min(y)
C             3   = min(z)
C             4   = max(x)
C             5   = max(y)
C             6   = max(z)
C
C      NTRI = number of triangles (used if NGRP=0)
C      XYZTRI = array of triangle data
C          1  = x1
C          2  = y1
C          3  = z1
C          4  = x2
C          5  = y2
C          6  = z2
C          7  = x3
C          8  = y3
C          9  = z3
C         10  = min(x)
C         11  = min(y)
C         12  = min(z)
C         13  = max(x)
C         14  = max(y)
C         15  = max(z)
C         16  = ID field, ID associated with this triangle 
C
C      LVIS = logical flag  LVIS=.true.  if the point is visible
C
       REAL XYZPT(3), XYZTRI(16,*), XYZGRP(6,NGRP)
       INTEGER ILSTGRP(NGRP)
       LOGICAL LVIS
C
       DATA EPS/1.0E-7/
C
C----- Initialize a few things
       X1 = XYZPT(1)
       Y1 = XYZPT(2)
       Z1 = XYZPT(3)
       LVIS=.TRUE.
C
C----- Main processing loop
       KLAST = 0
       NNGRP = MAX(1,NGRP)
C
       DO 100 IGRP=1, NNGRP
C
       KT1 = KLAST + 1
       KLAST = NTRI
C
       IF(NGRP.GE.1) THEN
C--- Check for group with no triangles (last index <= 0)
        IF(ILSTGRP(IGRP).LE.0) GO TO 100
        KLAST = ILSTGRP(IGRP)       
C--- Preliminary purge of whole group
        IF( (XYZGRP(1,IGRP).GE.X1 .OR. 
     &       XYZGRP(4,IGRP).LE.X1) .OR.
     &      (XYZGRP(2,IGRP).GE.Y1 .OR. 
     &       XYZGRP(5,IGRP).LE.Y1) ) GO TO 100
C     &      (XYZGRP(6,IGRP).LE.Z1) ) GO TO 100
       ENDIF
C
       DO 1 KT=KT1, KLAST
C
C--- Second purge of most cells
         IF( (XYZTRI(10,KT).GE.X1 .OR. 
     &        XYZTRI(13,KT).LE.X1)   .OR.
     &       (XYZTRI(11,KT).GE.Y1 .OR. 
     &        XYZTRI(14,KT).LE.Y1)   .OR.
     &       (XYZTRI(15,KT).LE.Z1) ) GO TO 1
C
C--- If ID of this point matches a triangle ID skip visibility tests
         IF(ID.NE.0) THEN
          IDTRI = IFIX(XYZTRI(16,KT))
          IF(ID.EQ.IDTRI) GO TO 1
         ENDIF
C
         NSAME=0
         DO L=1, 3
           IF( ABS(X1-XYZTRI(1+3*(L-1),KT)).LT.EPS .AND.
     &         ABS(Y1-XYZTRI(2+3*(L-1),KT)).LT.EPS .AND.
     &         ABS(Z1-XYZTRI(3+3*(L-1),KT)).LT.EPS )  NSAME=NSAME+1
         END DO
         IF(NSAME.GE.1) GO TO 1
C
         N1 = 1
C--- Set up temporary variables in canonical orientation where the line
C    passes through sides 1-2 and 1-3 of triangle (point 1 is common point)
         N2 = MOD(N1,3) + 1           
         N3 = MOD(N2,3) + 1           
C
         XT1 = XYZTRI(3*N1-2,KT)
         YT1 = XYZTRI(3*N1-1,KT)
         ZT1 = XYZTRI(3*N1  ,KT)
         XT2 = XYZTRI(3*N2-2,KT)
         YT2 = XYZTRI(3*N2-1,KT)
         ZT2 = XYZTRI(3*N2  ,KT)
         XT3 = XYZTRI(3*N3-2,KT)
         YT3 = XYZTRI(3*N3-1,KT)
         ZT3 = XYZTRI(3*N3  ,KT)
C
C--- Compute xi, eta, zeta values for point in triangle coords
         DET = ( (XT2-XT1)*(YT3-YT1) - (XT3-XT1)*(YT2-YT1) )
         IF(DET.EQ.0.0) GO TO 1
C
         DETINV = 1.0 / DET
         XI1 = DETINV * ( (X1 -XT1)*(YT3-YT1) - (XT3-XT1)*(Y1 -YT1) )
         ET1 = DETINV * ( (XT2-XT1)*(Y1 -YT1) - (X1 -XT1)*(YT2-YT1) )
C
         IF(ABS(XI1-1.0).LT.EPS) XI1 = 1.0
         IF(ABS(ET1-1.0).LT.EPS) ET1 = 1.0
         ZE1 = (Z1-ZT1) - XI1*(ZT2-ZT1) - ET1*(ZT3-ZT1)
C
C---point is visible if it is outside triangle
         IF(XI1.LE.0. .OR. ET1.LE.0. .OR. (XI1+ET1).GT.1.0) GO TO 1
C---Or above it...
         IF(ZE1.GT.0.) GO TO 1
C
         LVIS=.FALSE.
         RETURN
 1     CONTINUE
C
 100   CONTINUE
       RETURN
       END ! HIDPNT

C***********************************************************************
C    Module:  matrix.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE LUDCMP(NSIZ,N,A,INDX,WORK)
C     *******************************************************
C     *   Factors a full NxN matrix into an LU form.        *
C     *   Subr. BAKSUB can back-substitute it with some RHS.*
C     *   Assumes matrix is non-singular...                 *
C     *    ...if it isn't, a divide by zero will result.    *
C     *                                                     *
C     *   A is the matrix...                                *
C     *     ...replaced with its LU factors.                *
C     *                                                     *
C     *   Stolen from Numerical Recipes.                    *
C     *******************************************************
C
      REAL A(NSIZ,NSIZ), WORK(NSIZ)
      INTEGER INDX(NSIZ)
C
      DO 12 I=1, N
        AAMAX = 0.
        DO 11 J=1, N
          AAMAX = MAX( ABS(A(I,J)) , AAMAX )
   11   CONTINUE
        WORK(I) = 1.0/AAMAX
   12 CONTINUE
C
      DO 19 J=1, N
        DO 14 I=1, J-1
          SUM = A(I,J)
          DO 13 K=1, I-1
            SUM = SUM - A(I,K)*A(K,J)
   13     CONTINUE
          A(I,J) = SUM
   14   CONTINUE
C
        AAMAX = 0.
        DO 16 I=J, N
          SUM = A(I,J)
          DO 15 K=1, J-1
            SUM = SUM - A(I,K)*A(K,J)
   15     CONTINUE
          A(I,J) = SUM
C
          DUM = WORK(I)*ABS(SUM)
          IF(DUM.GE.AAMAX) THEN
           IMAX = I
           AAMAX = DUM
          ENDIF
   16   CONTINUE
C
        IF(J.NE.IMAX) THEN
         DO 17 K=1, N
           DUM = A(IMAX,K)
           A(IMAX,K) = A(J,K)
           A(J,K) = DUM
   17    CONTINUE
         WORK(IMAX) = WORK(J)
        ENDIF
C
        INDX(J) = IMAX
        IF(J.NE.N) THEN
         DUM = 1.0/A(J,J)
         DO 18 I=J+1, N
           A(I,J) = A(I,J)*DUM
   18    CONTINUE
        ENDIF
C
   19 CONTINUE
C
      RETURN
      END ! LUDCMP


      SUBROUTINE BAKSUB(NSIZ,N,A,INDX,B)
      REAL A(NSIZ,NSIZ), B(NSIZ)
      INTEGER INDX(NSIZ)
C
      II = 0
      DO 12 I=1, N
        LL = INDX(I)
        SUM = B(LL)
        B(LL) = B(I)
        IF(II.NE.0) THEN
         DO 11 J=II, I-1
           SUM = SUM - A(I,J)*B(J)
   11    CONTINUE
        ELSE IF(SUM.NE.0.0) THEN
         II = I
        ENDIF
        B(I) = SUM
   12 CONTINUE
C
      DO 14 I=N, 1, -1
        SUM = B(I)
        IF(I.LT.N) THEN
         DO 13 J=I+1, N
           SUM = SUM - A(I,J)*B(J)
   13    CONTINUE
        ENDIF
        B(I) = SUM/A(I,I)
   14 CONTINUE
C
      RETURN
      END ! BAKSUB

C***********************************************************************
C    Module:  getvm.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE OUTVM(LU)
C...PURPOSE  Print STRIP SHEAR and BENDING QUANTITIES, ie. V, BM
C            Integrates spanload to get shear and bending moment
C     NOTE:  only works for single surface at at time (ie. V,BM on each panel)
C
      INCLUDE 'AVL.INC'
      REAL V(NSMAX), BM(NSMAX), YSTRP(NSMAX)
      CHARACTER*256 FNAMVB
C
    1 FORMAT(A)
    2 FORMAT(A,I3,A)
C
      WRITE(LU,10) TITLE(1:60),AMACH,ALFA/DTR,CLTOT,BETA/DTR,SREF,BREF
 10   FORMAT(/' Shear/q and Bending Moment/q vs Y'
     &       /'  Configuration: ',A
     &       /'  Mach  = ',F8.3,
     &       /'  alpha = ',F8.3,'    CLtot = ',F8.3,
     &       /'  beta  = ',F8.3,
     &      //'  Sref  = ',F11.5
     &       /'  Bref  = ',F11.5)
C
C---- Process the surfaces one by one, calculating shear and bending on each, 
C      with moments refered to Y=0 (centerline)
C
      DO N = 1, NSURF
        J1 = JFRST(N)
        JN = J1 + NJ(N) - 1 
C
        YMIN =  1.0E10
        YMAX = -1.0E10
        DO J = J1, JN
          IV = IJFRST(J)
          YMIN = MIN(YMIN,RV1(2,IV),RV2(2,IV))
          YMAX = MAX(YMAX,RV1(2,IV),RV2(2,IV))
        ENDDO
C
C------ Integrate spanload from first strip to last strip defined for 
C        this surface to get shear and bending moment
        CNCLST = 0.0
        BMLST  = 0.0
        WLST   = 0.0
        VLST   = 0.0
C
        JF = J1
        JL = JN
        JINC = 1
C
C------ Integrate from first to last strip in surface
        DO J = JL, JF, -JINC
          JJ = JINC*(J - JF + JINC)
C
          DY = 0.5*(WSTRIP(J)+WLST)
          YSTRP(JJ) = RLE(2,J)
          V(JJ)     = VLST  + 0.5*(CNC(J)+CNCLST) * DY 
          BM(JJ)    = BMLST + 0.5*(V(JJ)+VLST)    * DY
C
          VLST   = V(JJ) 
          BMLST  = BM(JJ)
          CNCLST = CNC(J)
          WLST   = WSTRIP(J)
        ENDDO
C
C------ Inboard edge Y,Vz,Mx
        VROOT  = VLST  +      CNCLST      * 0.5*DY 
        BMROOT = BMLST + 0.5*(VROOT+VLST) * 0.5*DY
        VTIP   = 0.0
        BMTIP  = 0.0
        IF(IMAGS(N).GE.0) THEN
         YROOT = RLE1(2,J1)
         YTIP  = RLE2(2,JN)
        ELSE
         YROOT = RLE2(2,J1)
         YTIP  = RLE1(2,JN)
        ENDIF
C
        DIR = 1.0
        IF(YMIN+YMAX.LT.0.0) DIR = -1.0
C
        WRITE(LU,*) '  '
        WRITE(LU,2) ' Surface: ',N,'  ',STITLE(N)
        WRITE(LU,*) '    2Ymin/Bref = ',2.0*YMIN/BREF
        WRITE(LU,*) '    2Ymax/Bref = ',2.0*YMAX/BREF
        WRITE(LU,*) '  2Y/Bref      Vz/(q*Sref)      Mx/(q*Bref*Sref)'
C
        WRITE(LU,4)   2.*YROOT/BREF,VROOT/SREF,DIR*BMROOT/SREF/BREF
        DO J = 1, NJ(N)
          WRITE(LU,4) 2.*YSTRP(J)/BREF,V(J)/SREF,DIR*BM(J)/SREF/BREF
        ENDDO
        WRITE(LU,4)   2.*YTIP/BREF,VTIP/SREF,DIR*BMTIP/SREF/BREF
   4    FORMAT(F10.4,G14.6,3X,G14.6)
C
C       N = 0
C       CALL GRPHIN(N,YSTRP,V)
C       CALL GRPHIN(NJ(N),YSTRP,V)
C       CALL GRPHIN(NJ(N),YSTRP,BM)
C       CALL GRPHPL
      ENDDO
C
      RETURN
      END ! OUTVM

C***********************************************************************
C    Module:  aoutput.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE OUTTOT(LUN)
C
C...PURPOSE  To print out results of the vortex lattice calculation
C            for the input configuration.  
C
C...INPUT    Configuration data for case in labeled commons
C          
C...OUTPUT   Printed output on logical unit LUN
C
      INCLUDE 'AVL.INC'
      CHARACTER*50 SATYPE
C
 1000 FORMAT (A)
C
      IF (LUN.EQ.0) RETURN
C
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
      CA = COS(ALFA)
      SA = SIN(ALFA)
C
C---- set normalized rates in Stability or Body axes
      RX_S = (WROT(1)*CA + WROT(3)*SA) * BREF/2.0
      RY_S =  WROT(2)                  * CREF/2.0
      RZ_S = (WROT(3)*CA - WROT(1)*SA) * BREF/2.0
      RX_B =  WROT(1) * BREF/2.0
      RY_B =  WROT(2) * CREF/2.0
      RZ_B =  WROT(3) * BREF/2.0
C
C---- set body forces in Geometric axes
      CXTOT = CDTOT*CA - CLTOT*SA
      CZTOT = CDTOT*SA + CLTOT*CA
C
C---- set moments in stability axes
      CRSAX = CRTOT*CA + CNTOT*SA
      CMSAX = CMTOT              
      CNSAX = CNTOT*CA - CRTOT*SA  
CCC   CNSAX = CNTOT*CA - CRTOT*CA        !!! Bug   MD  02 Apr 04
C
C---- dump it
      WRITE(LUN,200)
      WRITE(LUN,201) 
      WRITE(LUN,202) TITLE(1:60),NSURF,NSTRIP,NVOR
      IF(IYSYM.GT.0) WRITE (*,2034) YSYM
      IF(IYSYM.LT.0) WRITE (*,2035) YSYM
      IF(IZSYM.GT.0) WRITE (*,2036) ZSYM
      IF(IZSYM.LT.0) WRITE (*,2037) ZSYM

      WRITE(LUN,204) SREF,CREF,BREF, 
     &               XYZREF(1), XYZREF(2), XYZREF(3)
C
      WRITE(LUN,205) SATYPE

      WRITE(LUN,218) RTITLE(IRUN)
      WRITE(LUN,220) ALFA/DTR, DIR*RX_B, DIR*RX_S, 
     &               BETA/DTR,     RY_B,
     &               AMACH   , DIR*RZ_B, DIR*RZ_S
C
      CDITOT = CDTOT - CDVTOT
      WRITE (LUN,221) DIR*CXTOT ,  DIR*CRTOT,  DIR*CRSAX,
     &                    CYTOT ,      CMTOT,
     &                DIR*CZTOT ,  DIR*CNTOT,  DIR*CNSAX,
     &                CLTOT ,
     &                CDTOT ,
     &                CDVTOT,  CDITOT,
     &                CLFF  ,  CDFF  ,
     &                CYFF  ,  SPANEF
C
      WRITE(LUN,*)
      DO K = 1, NCONTROL
        WRITE(LUN,231) DNAME(K), DELCON(K)
      ENDDO

      WRITE(LUN,*)
      DO K = 1, NDESIGN
        WRITE(LUN,231) GNAME(K), DELDES(K)
      ENDDO
C
      WRITE(LUN,200)
 200  FORMAT(1X,
     &'---------------------------------------------------------------')
 201  FORMAT(' Vortex Lattice Output -- Total Forces')
 202  FORMAT(/' Configuration: ',A
     &       /5X,'# Surfaces =',I4
     &       /5X,'# Strips   =',I4
     &       /5X,'# Vortices =',I4)
C
 2034 FORMAT(' Y Symmetry: Wall plane   at Ysym =',F10.4)
 2035 FORMAT(' Y Symmetry: Free surface at Ysym =',F10.4)
 2036 FORMAT(' Z Symmetry: Ground plane at Zsym =',F10.4)
 2037 FORMAT(' Z Symmetry: Free surface at Zsym =',F10.4)
C
 204  FORMAT(/2X, 'Sref =',G12.5,3X,'Cref =',G12.5,3X,'Bref =',G12.5
     &       /2X, 'Xref =',G12.5,3X,'Yref =',G12.5,3X,'Zref =',G12.5 )

 205  FORMAT(/1X, A)
 218  FORMAT(/' Run case: ', A)
 220  FORMAT(
     & /2X,'Alpha =',F10.5,5X,'pb/2V =',F10.5,5X,'p''b/2V =',F10.5
     & /2X,'Beta  =',F10.5,5X,'qc/2V =',F10.5
     & /2X,'Mach  =',F10.3,5X,'rb/2V =',F10.5,5X,'r''b/2V =',F10.5)
C
 221  FORMAT (
     & /2X,'CXtot =',F10.5,5X,'Cltot =',F10.5,5X,'Cl''tot =',F10.5
     & /2X,'CYtot =',F10.5,5X,'Cmtot =',F10.5 
     & /2X,'CZtot =',F10.5,5X,'Cntot =',F10.5,5X,'Cn''tot =',F10.5
     &//2X,'CLtot =',F10.5
     & /2X,'CDtot =',F10.5
     & /2X,'CDvis =',F10.5,5X,'CDind =',F10.7
     & /2X,'CLff  =',F10.5,5X,'CDff  =',F10.7,4X,'| Trefftz'
     & /2X,'CYff  =',F10.5,5X,'    e =',F10.4,4X,'| Plane  ' )
C
 231  FORMAT(3X,A,'=',F10.5)
C
 240  FORMAT (/)
C
      RETURN
      END ! OUTTOT


      SUBROUTINE OUTSURF(LUN)
C
C...PURPOSE  To print out surface forces from the vortex lattice calculation
C
C...INPUT    Configuration data for case in labeled commons
C          
C...OUTPUT   Printed output for each surface on logical unit LUN
C
      INCLUDE 'AVL.INC'
      CHARACTER*50 SATYPE
C
 1000 FORMAT (A)
C
      IF (LUN.EQ.0) RETURN
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
C...Print out the results
C
C...Force components from each surface
      WRITE(LUN,200)
 200  FORMAT(1X,
     &'---------------------------------------------------------------')
      WRITE (LUN,210) SATYPE,
     &                SREF,CREF,BREF, 
     &                XYZREF(1), XYZREF(2), XYZREF(3)
      DO N = 1, NSURF
        CALL STRIP(STITLE(N),NT)
        WRITE (LUN,211) N,SSURF(N),CLSURF(N),CDSURF(N),CMSURF(N),
     &                  CYSURF(N),DIR*CNSURF(N),DIR*CRSURF(N),
     &                  CDSURF(N)-CDVSURF(N),CDVSURF(N),
     &                  STITLE(N)(1:NT)
      END DO
cc      WRITE(LUN,212)
C
C--- Surface forces normalized by local reference quantities
      WRITE (LUN,220) 
      DO N = 1, NSURF
        CALL STRIP(STITLE(N),NT)
        WRITE (LUN,221) N,SSURF(N),CAVESURF(N),
     &                  CL_SRF(N),CD_SRF(N),
     &                  CDVSURF(N)*SREF/SSURF(N),CMLE_SRF(N),
     &                  STITLE(N)(1:NT)
      END DO
      WRITE(LUN,200)
C
  210 FORMAT ( ' Surface Forces (referred to Sref,Cref,Bref',
     &                                   ' about Xref,Yref,Zref)',
     &        /' ',A //
     &      5X,'Sref =',G12.4,   3X,'Cref =',F10.4,3X,'Bref =',F10.4/
     &      5X,'Xref =',2X,F10.4,3X,'Yref =',F10.4,3X,'Zref =',F10.4//
     &     ' n',6X,'Area',6X,'CL',6X,'CD',6X,'Cm',
     &                    6X,'CY',6X,'Cn',6X,'Cl',5X,'CDi',5X,'CDv')
  211 FORMAT (I2,1X,F9.3,8F8.4,3X,A)
  212 FORMAT (/)
C
  220 FORMAT (/' Surface Forces (referred to Ssurf, Cave ',
     &         'about root LE on hinge axis)'//
     &        2X,' n',5X,'Ssurf',6X,'Cave',
     &        7X,'cl',7X,'cd',6X,'cdv',4x,'cm_LE')
  221 FORMAT (2X,I2,F10.3,F10.3,4(1X,F8.4),2X,A)
C
      RETURN
      END ! OUTSURF


      SUBROUTINE OUTBODY(LUN)
C
C...PURPOSE  To print out body forces from source/doublet calculation
C
C...INPUT    Configuration data for case in labeled commons
C          
C...OUTPUT   Printed output for each body on logical unit LUN
C
      INCLUDE 'AVL.INC'
      CHARACTER*50 SATYPE
C
 1000 FORMAT (A)
C
      IF (LUN.EQ.0) RETURN
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
C...Print out the results
C
C...Force components from each body 
      WRITE(LUN,200)
 200  FORMAT(1X,
     &'---------------------------------------------------------------')
      WRITE (LUN,210) SATYPE,
     &                SREF,CREF,BREF, 
     &                XYZREF(1), XYZREF(2), XYZREF(3)
      DO IB = 1, NBODY
        CALL STRIP(BTITLE(IB),NT)
        ELBD = ELBDY(IB)
        SBDY = SRFBDY(IB)
        VBDY = VOLBDY(IB)
        WRITE (LUN,211) IB,ELBD,SBDY,VBDY,
     &                  CLBDY(IB),CDBDY(IB),CMBDY(IB),
     &                  CYBDY(IB),DIR*CNBDY(IB),DIR*CRBDY(IB),  
     &                  BTITLE(IB)(1:NT)
      END DO
cc      WRITE(LUN,212)
      WRITE(LUN,200)
C
  210 FORMAT ( ' Body Forces (referred to Sref,Cref,Bref',
     &                            ' about Xref,Yref,Zref)',
     &        /' ',A //
     &      5X,'Sref =',G12.4,   3X,'Cref =',F10.4,3X,'Bref =',F10.4/
     &      5X,'Xref =',2X,F10.4,3X,'Yref =',F10.4,3X,'Zref =',F10.4//
     &     'Ibdy',4X,'Length',5X,'Asurf',7X,'Vol',
     &      6X,'CL',6X,'CD',6X,'Cm',
     &      6X,'CY',6X,'Cn',6X,'Cl')
  211 FORMAT (I4,3(1X,F9.3),6F8.4,3X,A)
  212 FORMAT (/)
C
      RETURN
      END ! OUTBODY



      SUBROUTINE OUTSTRP(LUN)
C
C...PURPOSE  To print out results of the vortex lattice calculation
C            for the input configuration strip and surface forces.  
C
C...INPUT    Configuration data for case in labeled commons
C          
C...OUTPUT   Printed output on logical unit LUN
C
      INCLUDE 'AVL.INC'
      CHARACTER*50 SATYPE
C
 1000 FORMAT (A)
C
      IF (LUN.EQ.0) RETURN
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
C...Print out the results -> Forces by surface and strip
      WRITE(LUN,200)
      WRITE(LUN,210) 
      WRITE(LUN,212) SATYPE
      DO N = 1, NSURF
        NS = NJ(N)
        NV = NK(N)
        J1 = JFRST(N)
C
        WRITE (LUN,211) N,STITLE(N),NV,NS,J1,SSURF(N),CAVESURF(N)
        CDISURF = CDSURF(N)-CDVSURF(N)
        WRITE (LUN,213) CLSURF(N),DIR*CRSURF(N),
     &                  CYSURF(N),    CMSURF(N),
     &                  CDSURF(N),DIR*CNSURF(N),
     &                  CDISURF,CDVSURF(N)
        WRITE (LUN,214) CL_SRF(N),CD_SRF(N)
        WRITE (LUN,216) 
        DO JJ = 1, NS
          J = J1 + JJ-1
          ASTRP = WSTRIP(J)*CHORD(J)
          XCP = 999.
cc        IF(CLSTRP(J).NE.0.)  XCP = 0.25 - CMC4(J)/CLSTRP(J)       !!! BUG  13 Jan 12   MD
          IF(CL_LSTRP(J).NE.0.)  XCP = 0.25 - CMC4(J)/CL_LSTRP(J)
          IF(XCP.LT.2.0 .AND. XCP.GT.-1.0) THEN
            WRITE (LUN,217)
     &            J,RLE(2,J),CHORD(J),ASTRP,CNC(J),DWWAKE(J),
     &            CLTSTRP(J), CL_LSTRP(J),CD_LSTRP(J),CDV_LSTRP(J),
     &            CMC4(J),CMLE(J),XCP
           ELSE
            WRITE (LUN,217)
     &            J,RLE(2,J),CHORD(J),ASTRP,CNC(J),DWWAKE(J),
     &            CLTSTRP(J),CL_LSTRP(J),CD_LSTRP(J),CDV_LSTRP(J),
     &            CMC4(J),CMLE(J)
          ENDIF
        END DO
      END DO
      WRITE(LUN,200)
C
  200 FORMAT(1X,
     &'---------------------------------------------------------------')
  210 FORMAT (' Surface and Strip Forces by surface')
  211 FORMAT (/2X,'Surface #',I2,5X,A/
     &        5X,'# Chordwise =',I3,3X,'# Spanwise =',I3,
     &        5X,'First strip =',I3/
     &        5X,'Surface area =',F12.6,5X,'  Ave. chord =',F12.6)
  212 FORMAT (/'  Forces referred to Sref, Cref, Bref ',
     &        'about Xref, Yref, Zref'/
     &         ' ',A)
  213 FORMAT ( 5X,'CLsurf  =',F10.5,5X,'Clsurf  =',F10.5,
     &        /5X,'CYsurf  =',F10.5,5X,'Cmsurf  =',F10.5,
     &        /5X,'CDsurf  =',F10.5,5X,'Cnsurf  =',F10.5, 
     &        /5X,'CDisurf =',F10.5,5x,'CDvsurf =',F10.5)
  214 FORMAT (/'  Forces referred to Ssurf, Cave ',
     &         'about hinge axis thru LE'/
     &         5X,'CLsurf  =',F10.5,5X,'CDsurf  =',F10.5/
     &         5X,'Deflect =',F10.5,5X,'CmLEsurf=',F10.5)
  216 FORMAT (/' Strip Forces referred to Strip Area, Chord'/
     &        2X,'  j ',5X,'Yle',4X,'Chord',5X,'Area',
     &        5X,'c cl',6X,'ai',6X,'cl_norm',2X,'cl',7X,'cd',7X,
     &        'cdv',4x,'cm_c/4',4x,'cm_LE',2x,'C.P.x/c')
  217 FORMAT (2X,I4,11(1X,F8.4),1X,F8.3)
C
      RETURN
      END ! OUTSTRP


      SUBROUTINE OUTELE(LUN)
      INCLUDE 'AVL.INC'
      CHARACTER*50 SATYPE
C
 1000 FORMAT (A)
C
      IF (LUN.EQ.0) RETURN
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
C...Forces on each strip and element (long output, and slow to printout)
      WRITE(LUN,200)
      WRITE(LUN,230)
      WRITE(LUN,212) SATYPE
      DO N = 1, NSURF
        NS = NJ(N)
        NV = NK(N)
        J1 = JFRST(N)
C
        WRITE (LUN,231) N,STITLE(N),NV,NS,J1,
     &                  SSURF(N),CAVESURF(N)
C
        CDISURF = CDSURF(N)-CDVSURF(N)
        WRITE (LUN,213) CLSURF(N),DIR*CRSURF(N),
     &                  CYSURF(N),    CMSURF(N),
     &                  CDSURF(N),DIR*CNSURF(N),
     &                  CDISURF,CDVSURF(N)
        WRITE (LUN,214) CL_SRF(N),CD_SRF(N)
C
        DO JJ = 1, NS
          J = J1 + JJ-1
          I1 = IJFRST(J)
          ASTRP = WSTRIP(J)*CHORD(J)
          DIHED = -ATAN2(ENSY(J),ENSZ(J))/DTR
          WRITE (LUN,232) J,NV,I1,
     &                    RLE(1,J),CHORD(J),AINC(J)/DTR,
     &                    RLE(2,J),WSTRIP(J),ASTRP,
     &                    RLE(3,J),DIHED
          WRITE (LUN,233) CL_LSTRP(J), CD_LSTRP(J), CDV_LSTRP(J),
     &                    CNRMSTRP(J), CAXLSTRP(J), 
     &                    CNC(J),    DWWAKE(J),
     &                    CMLE(J),   CMC4(J)
          DO II = 1, NV
            I = I1 + (II-1)
            XM = 0.5*(RV1(1,I)+RV2(1,I))
            YM = 0.5*(RV1(2,I)+RV2(2,I))
            ZM = 0.5*(RV1(3,I)+RV2(3,I))
            WRITE (LUN,234) I,XM,YM,ZM,DXV(I),SLOPEC(I),DCP(I)
          END DO
        END DO
      END DO
      WRITE(LUN,200)
C
      RETURN
C
  200 FORMAT(1X,
     &'---------------------------------------------------------------')
  230 FORMAT (' Vortex Strengths (by surface, by strip)')
  231 FORMAT (/1X,78('*')/2X,'Surface #',I2,5X,A/
     &        5X,'# Chordwise  =',I3,3X,'# Spanwise =',I3,
     &        3X,'First strip  =',I3/
     &        5X,'Surface area =',F12.6,5X,'  Ave. chord =',F12.6)
C
  212 FORMAT (/'  Forces referred to Sref, Cref, Bref ',
     &        'about Xref, Yref, Zref'/
     &         '  ',A)
  213 FORMAT ( 5X,'CLsurf  =',F10.5,5X,'Clsurf  =',F10.5,
     &        /5X,'CYsurf  =',F10.5,5X,'Cmsurf  =',F10.5,
     &        /5X,'CDsurf  =',F10.5,5X,'Cnsurf  =',F10.5, 
     &        /5X,'CDisurf =',F10.5,5x,'CDvsurf =',F10.5)
  214 FORMAT (/'  Forces referred to Ssurf, Cave ',
     &         'about hinge axis thru LE'/
     &         5X,'CLsurf  =',F10.5,5X,'CDsurf  =',F10.5/
     &         1X,78('*'))
C
  232 FORMAT (/1X,'Strip #',I3,5X,'# Chordwise =',I3,
     &         3X,'First Vortex =',I4/
     &         4X,'Xle =',F10.5,4X,'Ave. Chord   =',F10.4,
     &         3X,'Incidence  =',F10.4,' deg'/
     &         4X,'Yle =',F10.5,4X,'Strip Width  =',F10.5,
     &         3X,'Strip Area =',F12.6/
     &         4X,'Zle =',F10.5,4X,'Strip Dihed. =',F10.4)
  233 FORMAT (/4X,'cl  =',F10.5,4X,'   cd  =',F10.5,4X,'  cdv =',F10.5,
     &        /4X,'cn  =',F10.5,4X,'   ca  =',F10.5,
     &         4X,'  cnc =',F10.5,4X,'wake dnwsh =',F10.5,
     &        /4X,'cmLE=',F10.5,4X,'cm c/4 =',F10.5,
     &       //4X,'I',8X,'X   ',8X,'Y   ',8X,'Z   ',8X,'DX  ',
     &         6X,'Slope',8X,'dCp')
  234 FORMAT (2X,I3,6(2X,F10.5))
C
      END ! OUTELE



      SUBROUTINE OUTHINGE(LUN)
C
C...PURPOSE  To print out results of the vortex lattice calculation
C            for the input configuration.  
C
C...INPUT    Configuration data for case in labeled commons
C          
C...OUTPUT   Printed output on logical unit LUN
C
      INCLUDE 'AVL.INC'
C
 1000 FORMAT (A)
C
      IF (LUN.EQ.0) RETURN
C
C...Print out the results
C
C...Hinge moments for each CONTROL
      WRITE(LUN,200)
 200  FORMAT(1X,
     &'---------------------------------------------------------------')
C
      WRITE (LUN,210) SREF,CREF
  210 FORMAT (
     & ' Control Hinge Moments' /
     & ' (referred to    Sref =',G12.4,   3X,'Cref =',F10.4,')' )
C
      WRITE (LUN,212) 
 212  FORMAT(/' Control          Chinge'
     &       /' ---------------- -----------')
C
      DO N = 1, NCONTROL
        WRITE (LUN,220) DNAME(N),CHINGE(N)
  220   FORMAT (1X,A16,G12.4)
      END DO
C
      WRITE(LUN,200)
C
      RETURN
      END ! OUTHINGE



      SUBROUTINE OUTCNC(LUN)
C
C...PURPOSE  To write out a CNC loading file
C            for the input configuration strips
C
C...INPUT    Configuration data for case in labeled commons
C          
C...OUTPUT   Printed output on logical unit LUN
C
      INCLUDE 'AVL.INC'
      CHARACTER*1 ANS
      CHARACTER*256 FNAM
      SAVE FNAM
      DATA FNAM /' '/
C
 1000 FORMAT (A)
C
      IF (LUN.EQ.0) RETURN
C
c      WRITE(*,2090) 
c 2090 FORMAT('Output file Simple(y,cnc,cl) or Full(x,y,z,cnc,cl,c)? ',$)
c      READ (*,1000) ANS
c      CALL TOUPER(ANS)
      ANS = 'F'
C
C...Print out the results -> strip loadings
c     WRITE (LUN,210) 
      DO J=1, NSTRIP
        I = IJFRST(J)
        XM = 0.5*(RV1(1,I)+RV2(1,I))
        YM = 0.5*(RV1(2,I)+RV2(2,I))
        ZM = 0.5*(RV1(3,I)+RV2(3,I))
        CNCM = CNC(J)
        CLM  = CL_LSTRP(J)
        CHM  = CHORD(J)
        DYM  = WSTRIP(J)
        ASM  = DYM*CHM
        IF(ANS.EQ.'S') THEN
          WRITE (LUN,213) YM,CNCM,CLM,CHM
         ELSE
          WRITE (LUN,212) XM,YM,ZM,CNCM,CLM,CHM,DYM,ASM
        ENDIF
      END DO
C
  210 FORMAT (//' *** Strip Loadings')
  212 FORMAT (3(F8.3,1X),2(F10.4,1X),2(F8.4,1X),F9.4)
  213 FORMAT (F8.3,1X,3(F10.4,1X))
C
      RETURN
      END ! OUTCNC



      SUBROUTINE DERMATM(LU)
C---------------------------------------------------------
C     Calculates and outputs stability derivative matrix
C     for current ALFA, BETA.
C---------------------------------------------------------
      INCLUDE 'AVL.INC'
      CHARACTER*50 SATYPE
      REAL WROT_RX(3), WROT_RZ(3), WROT_A(3)
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
C---- set freestream velocity components from alpha, beta
      CALL VINFAB
C
C---- calculate forces and sensitivities
      CALL AERO
C
C---- set stability-axes rates (RX,RY,RZ) in terms of body-axes rates
      CA = COS(ALFA)
      SA = SIN(ALFA)
      RX = (WROT(1)*CA + WROT(3)*SA) * DIR
      RY =  WROT(2)
      RZ = (WROT(3)*CA - WROT(1)*SA) * DIR
C
C---- now vice-versa, and set sensitivities (which is what's really needed)
cc    WROT(1)    =  RX*CA - RZ*SA
cc    WROT(2)    =  RY
cc    WROT(3)    =  RZ*CA + RX*SA
C
      WROT_RX(1) = CA     * DIR
      WROT_RX(2) = 0.
      WROT_RX(3) =     SA * DIR
C
      WROT_RZ(1) =    -SA * DIR
      WROT_RZ(2) = 0.
      WROT_RZ(3) = CA     * DIR
C
      WROT_A(1)  = -RX*SA - RZ*CA   !!! = -WROT(3)
      WROT_A(2)  =  0.
      WROT_A(3)  = -RZ*SA + RX*CA   !!! =  WROT(1)
C
C
C---- set force derivatives in stability axes
      CL_AL = CLTOT_U(1)*VINF_A(1) + CLTOT_U(4)*WROT_A(1)
     &      + CLTOT_U(2)*VINF_A(2) + CLTOT_U(5)*WROT_A(2)
     &      + CLTOT_U(3)*VINF_A(3) + CLTOT_U(6)*WROT_A(3) + CLTOT_A
      CL_BE = CLTOT_U(1)*VINF_B(1)
     &      + CLTOT_U(2)*VINF_B(2)
     &      + CLTOT_U(3)*VINF_B(3)
      CL_RX = CLTOT_U(4)*WROT_RX(1) + CLTOT_U(6)*WROT_RX(3)
      CL_RY = CLTOT_U(5)
      CL_RZ = CLTOT_U(6)*WROT_RZ(3) + CLTOT_U(4)*WROT_RZ(1)
C
      CY_AL = CYTOT_U(1)*VINF_A(1) + CYTOT_U(4)*WROT_A(1)
     &      + CYTOT_U(2)*VINF_A(2) + CYTOT_U(5)*WROT_A(2)
     &      + CYTOT_U(3)*VINF_A(3) + CYTOT_U(6)*WROT_A(3)
      CY_BE = CYTOT_U(1)*VINF_B(1)
     &      + CYTOT_U(2)*VINF_B(2)
     &      + CYTOT_U(3)*VINF_B(3)
      CY_RX = CYTOT_U(4)*WROT_RX(1) + CYTOT_U(6)*WROT_RX(3)
      CY_RY = CYTOT_U(5)
      CY_RZ = CYTOT_U(6)*WROT_RZ(3) + CYTOT_U(4)*WROT_RZ(1)
C
      CR_AL = CRTOT_U(1)*VINF_A(1) + CRTOT_U(4)*WROT_A(1)
     &      + CRTOT_U(2)*VINF_A(2) + CRTOT_U(5)*WROT_A(2)
     &      + CRTOT_U(3)*VINF_A(3) + CRTOT_U(6)*WROT_A(3)
      CR_BE = CRTOT_U(1)*VINF_B(1)
     &      + CRTOT_U(2)*VINF_B(2)
     &      + CRTOT_U(3)*VINF_B(3)
      CR_RX = CRTOT_U(4)*WROT_RX(1) + CRTOT_U(6)*WROT_RX(3)
      CR_RY = CRTOT_U(5)
      CR_RZ = CRTOT_U(6)*WROT_RZ(3) + CRTOT_U(4)*WROT_RZ(1)
C
      CM_AL = CMTOT_U(1)*VINF_A(1) + CMTOT_U(4)*WROT_A(1)
     &      + CMTOT_U(2)*VINF_A(2) + CMTOT_U(5)*WROT_A(2)
     &      + CMTOT_U(3)*VINF_A(3) + CMTOT_U(6)*WROT_A(3)
      CM_BE = CMTOT_U(1)*VINF_B(1)
     &      + CMTOT_U(2)*VINF_B(2)
     &      + CMTOT_U(3)*VINF_B(3)
      CM_RX = CMTOT_U(4)*WROT_RX(1) + CMTOT_U(6)*WROT_RX(3)
      CM_RY = CMTOT_U(5)
      CM_RZ = CMTOT_U(6)*WROT_RZ(3) + CMTOT_U(4)*WROT_RZ(1)
C
      CN_AL = CNTOT_U(1)*VINF_A(1) + CNTOT_U(4)*WROT_A(1)
     &      + CNTOT_U(2)*VINF_A(2) + CNTOT_U(5)*WROT_A(2)
     &      + CNTOT_U(3)*VINF_A(3) + CNTOT_U(6)*WROT_A(3)
      CN_BE = CNTOT_U(1)*VINF_B(1)
     &      + CNTOT_U(2)*VINF_B(2)
     &      + CNTOT_U(3)*VINF_B(3)
      CN_RX = CNTOT_U(4)*WROT_RX(1) + CNTOT_U(6)*WROT_RX(3)
      CN_RY = CNTOT_U(5)
      CN_RZ = CNTOT_U(6)*WROT_RZ(3) + CNTOT_U(4)*WROT_RZ(1)
C
C
      CALL OUTTOT(LU)
C
      WRITE(LU,7004)
 7004 FORMAT(/' Derivatives...')
C
      WRITE(LU,7006)
 7006 FORMAT(14X, 4X,'           alpha',
     &            4X,'            beta'
     &      /14X, 4X,'----------------',
     &            4X,'----------------')
C
      WRITE(LU,7010) CL_AL, CL_BE
 7010 FORMAT(' z force     |','    CLa =',F11.6,'    CLb =',F11.6)
C
      WRITE(LU,7020) CY_AL, CY_BE
 7020 FORMAT(' y force     |','    CYa =',F11.6,'    CYb =',F11.6)
C
      WRITE(LU,7040) DIR*CR_AL, DIR*CR_BE
 7040 FORMAT(' roll  x mom.|','    Cla =',F11.6,'    Clb =',F11.6)
C
      WRITE(LU,7050) CM_AL, CM_BE
 7050 FORMAT(' pitch y mom.|','    Cma =',F11.6,'    Cmb =',F11.6)
C
      WRITE(LU,7060) DIR*CN_AL, DIR*CN_BE
 7060 FORMAT(' yaw   z mom.|','    Cna =',F11.6,'    Cnb =',F11.6)
C
C
      WRITE(LU,7106)
 7106 FORMAT(/14X, 4X,'    roll rate  p',
     &             4X,'   pitch rate  q',
     &             4X,'     yaw rate  r'
     &       /14X, 4X,'----------------',
     &             4X,'----------------',
     &             4X,'----------------' )
C
      WRITE(LU,7110) CL_RX*2.0/BREF, 
     &               CL_RY*2.0/CREF, 
     &               CL_RZ*2.0/BREF
 7110 FORMAT(' z force     |','    CLp =',F11.6,
     &                        '    CLq =',F11.6,
     &                        '    CLr =',F11.6 )
C
      WRITE(LU,7120) CY_RX*2.0/BREF,
     &               CY_RY*2.0/CREF,
     &               CY_RZ*2.0/BREF
 7120 FORMAT(' y force     |','    CYp =',F11.6,
     &                        '    CYq =',F11.6,
     &                        '    CYr =',F11.6 )
C
      WRITE(LU,7140) DIR*CR_RX*2.0/BREF, 
     &               DIR*CR_RY*2.0/CREF,
     &               DIR*CR_RZ*2.0/BREF
 7140 FORMAT(' roll  x mom.|','    Clp =',F11.6,
     &                        '    Clq =',F11.6,
     &                        '    Clr =',F11.6 )
C
      WRITE(LU,7150) CM_RX*2.0/BREF,
     &               CM_RY*2.0/CREF,
     &               CM_RZ*2.0/BREF
 7150 FORMAT(' pitch y mom.|','    Cmp =',F11.6,
     &                        '    Cmq =',F11.6,
     &                        '    Cmr =',F11.6 )
C
      WRITE(LU,7160) DIR*CN_RX*2.0/BREF,
     &               DIR*CN_RY*2.0/CREF,
     &               DIR*CN_RZ*2.0/BREF
 7160 FORMAT(' yaw   z mom.|','    Cnp =',F11.6,
     &                        '    Cnq =',F11.6,
     &                        '    Cnr =',F11.6 )
C
      IF(NCONTROL.GT.0) THEN
C
      WRITE(LU,8106) (DNAME(K), K, K=1, NCONTROL)
 8106 FORMAT(/14X,20(4X,A12, ' d',I1,' '))
      WRITE(LU,8107) (' ',K=1, NCONTROL)
 8107 FORMAT( 14X,20(3X,A,'----------------'))
C
      WRITE(LU,8110) (' ',K,CLTOT_D(K), K=1, NCONTROL)
 8110 FORMAT(' z force     |',20(A,'  CLd',I1,' =',F11.6))
C
      WRITE(LU,8120) (' ',K,CYTOT_D(K), K=1, NCONTROL)
 8120 FORMAT(' y force     |',20(A,'  CYd',I1,' =',F11.6))
C
      WRITE(LU,8140) (' ',K,DIR*CRTOT_D(K), K=1, NCONTROL)
 8140 FORMAT(' roll  x mom.|',20(A,'  Cld',I1,' =',F11.6))
C
      WRITE(LU,8150) (' ',K,    CMTOT_D(K), K=1, NCONTROL)
 8150 FORMAT(' pitch y mom.|',20(A,'  Cmd',I1,' =',F11.6))
C
      WRITE(LU,8160) (' ',K,DIR*CNTOT_D(K), K=1, NCONTROL)
 8160 FORMAT(' yaw   z mom.|',20(A,'  Cnd',I1,' =',F11.6))
C
      WRITE(LU,8170) (' ',K,    CDFF_D(K), K=1, NCONTROL)
 8170 FORMAT(' Trefftz drag|',20(A,'CDffd',I1,' =',F11.6))
C
      WRITE(LU,8180) (' ',K,  SPANEF_D(K), K=1, NCONTROL)
 8180 FORMAT(' span eff.   |',20(A,'   ed',I1,' =',F11.6))
C
      WRITE(LU,*)
      WRITE(LU,*)
C
      ENDIF
C
      IF(NDESIGN.GT.0) THEN
C
      WRITE(LU,8206) (GNAME(K), K, K=1, NDESIGN)
 8206 FORMAT(/14X,20(4X,A12, ' g',I1,' '))
      WRITE(LU,8207) (' ',K=1, NDESIGN)
 8207 FORMAT( 14X,20(3X,A,'----------------'))
C
      WRITE(LU,8210) (' ',K,CLTOT_G(K), K=1, NDESIGN)
 8210 FORMAT(' z force     |',20(A,'  CLg',I1,' =',F11.6))
C
      WRITE(LU,8220) (' ',K,CYTOT_G(K), K=1, NDESIGN)
 8220 FORMAT(' y force     |',20(A,'  CYg',I1,' =',F11.6))
C
      WRITE(LU,8230) (' ',K,DIR*CRTOT_G(K), K=1, NDESIGN)
 8230 FORMAT(' roll  x mom.|',20(A,'  Clg',I1,' =',F11.6))
C
      WRITE(LU,8240) (' ',K,    CMTOT_G(K), K=1, NDESIGN)
 8240 FORMAT(' pitch y mom.|',20(A,'  Cmg',I1,' =',F11.6))
C
      WRITE(LU,8250) (' ',K,DIR*CNTOT_G(K), K=1, NDESIGN)
 8250 FORMAT(' yaw   z mom.|',20(A,'  Cng',I1,' =',F11.6))
C
      WRITE(LU,8260) (' ',K,    CDFF_G(K), K=1, NDESIGN)
 8260 FORMAT(' Trefftz drag|',20(A,'CDffg',I1,' =',F11.6))
C
      WRITE(LU,8270) (' ',K,  SPANEF_G(K), K=1, NDESIGN)
 8270 FORMAT(' span eff.   |',20(A,'   eg',I1,' =',F11.6))
C
      WRITE(LU,*)
      WRITE(LU,*)
C
      ENDIF
C
      IF(CL_AL .NE. 0.0) THEN
       XNP = XYZREF(1) - CREF*CM_AL/CL_AL
       WRITE(LU,8401) XNP
 8401  FORMAT(/' Neutral point  Xnp =', F11.6)
      ENDIF
C
      IF(ABS(CR_RZ*CN_BE) .GT. 0.0001) THEN
       BB = CR_BE*CN_RZ / (CR_RZ*CN_BE)
       WRITE(LU,8402) BB 
 8402  FORMAT(/' Clb Cnr / Clr Cnb  =', F11.6,
     &    '    (  > 1 if spirally stable )')
      ENDIF

C
      RETURN
      END ! DERMATM



      SUBROUTINE DERMATS(LU)
C---------------------------------------------------------
C     Calculates and outputs stability derivative matrix
C     for current ALFA, BETA.
C---------------------------------------------------------
      INCLUDE 'AVL.INC'
      CHARACTER*50 SATYPE
      REAL WROT_RX(3), WROT_RZ(3), WROT_A(3)
      REAL
     & CRSAX_U(NUMAX),CMSAX_U(NUMAX),CNSAX_U(NUMAX),
     & CRSAX_D(NDMAX),CMSAX_D(NDMAX),CNSAX_D(NDMAX),
     & CRSAX_G(NGMAX),CMSAX_G(NGMAX),CNSAX_G(NGMAX)
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
C---- set freestream velocity components from alpha, beta
      CALL VINFAB
C
C---- calculate forces and sensitivities
      CALL AERO
C
C---- set stability-axes rates (RX,RY,RZ) in terms of body-axes rates
      CA = COS(ALFA)
      SA = SIN(ALFA)
C
      RX = (WROT(1)*CA + WROT(3)*SA) * DIR
      RY =  WROT(2)
      RZ = (WROT(3)*CA - WROT(1)*SA) * DIR
C
C---- now vice-versa, and set sensitivities (which is what's really needed)
cc    WROT(1)    =  RX*CA - RZ*SA
cc    WROT(2)    =  RY
cc    WROT(3)    =  RZ*CA + RX*SA
C
      WROT_RX(1) = CA     * DIR
      WROT_RX(2) = 0.
      WROT_RX(3) =     SA * DIR
C
      WROT_RZ(1) =    -SA * DIR
      WROT_RZ(2) = 0.
      WROT_RZ(3) = CA     * DIR
C
      WROT_A(1)  = -RX*SA - RZ*CA   !!! = -WROT(3)
      WROT_A(2)  =  0.
      WROT_A(3)  = -RZ*SA + RX*CA   !!! =  WROT(1)
C
C
      CRSAX = CRTOT*CA + CNTOT*SA
      CMSAX = CMTOT              
      CNSAX = CNTOT*CA - CRTOT*SA  
      CRSAX_A = -CRTOT*SA + CNTOT*CA
      CNSAX_A = -CNTOT*SA - CRTOT*CA
C
      DO K = 1, 6
        CRSAX_U(K) = CRTOT_U(K)*CA + CNTOT_U(K)*SA
        CMSAX_U(K) = CMTOT_U(K)              
        CNSAX_U(K) = CNTOT_U(K)*CA - CRTOT_U(K)*SA  
      ENDDO
      DO K = 1, NCONTROL
        CRSAX_D(K) = CRTOT_D(K)*CA + CNTOT_D(K)*SA
        CMSAX_D(K) = CMTOT_D(K)              
        CNSAX_D(K) = CNTOT_D(K)*CA - CRTOT_D(K)*SA  
      ENDDO
      DO K = 1, NDESIGN
        CRSAX_G(K) = CRTOT_G(K)*CA + CNTOT_G(K)*SA
        CMSAX_G(K) = CMTOT_G(K)              
        CNSAX_G(K) = CNTOT_G(K)*CA - CRTOT_G(K)*SA  
      ENDDO

C
C---- set force derivatives in stability axes
      CL_AL = CLTOT_U(1)*VINF_A(1) + CLTOT_U(4)*WROT_A(1)
     &      + CLTOT_U(2)*VINF_A(2) + CLTOT_U(5)*WROT_A(2)
     &      + CLTOT_U(3)*VINF_A(3) + CLTOT_U(6)*WROT_A(3) + CLTOT_A
      CL_BE = CLTOT_U(1)*VINF_B(1)
     &      + CLTOT_U(2)*VINF_B(2)
     &      + CLTOT_U(3)*VINF_B(3)
      CL_RX = CLTOT_U(4)*WROT_RX(1) + CLTOT_U(6)*WROT_RX(3)
      CL_RY = CLTOT_U(5)
      CL_RZ = CLTOT_U(6)*WROT_RZ(3) + CLTOT_U(4)*WROT_RZ(1)
C
      CY_AL = CYTOT_U(1)*VINF_A(1) + CYTOT_U(4)*WROT_A(1)
     &      + CYTOT_U(2)*VINF_A(2) + CYTOT_U(5)*WROT_A(2)
     &      + CYTOT_U(3)*VINF_A(3) + CYTOT_U(6)*WROT_A(3)
      CY_BE = CYTOT_U(1)*VINF_B(1)
     &      + CYTOT_U(2)*VINF_B(2)
     &      + CYTOT_U(3)*VINF_B(3)
      CY_RX = CYTOT_U(4)*WROT_RX(1) + CYTOT_U(6)*WROT_RX(3)
      CY_RY = CYTOT_U(5)
      CY_RZ = CYTOT_U(6)*WROT_RZ(3) + CYTOT_U(4)*WROT_RZ(1)
C
      CR_AL = CRSAX_U(1)*VINF_A(1) + CRSAX_U(4)*WROT_A(1)
     &      + CRSAX_U(2)*VINF_A(2) + CRSAX_U(5)*WROT_A(2)
     &      + CRSAX_U(3)*VINF_A(3) + CRSAX_U(6)*WROT_A(3) + CRSAX_A
      CR_BE = CRSAX_U(1)*VINF_B(1)
     &      + CRSAX_U(2)*VINF_B(2)
     &      + CRSAX_U(3)*VINF_B(3)
      CR_RX = CRSAX_U(4)*WROT_RX(1) + CRSAX_U(6)*WROT_RX(3)
      CR_RY = CRSAX_U(5)
      CR_RZ = CRSAX_U(6)*WROT_RZ(3) + CRSAX_U(4)*WROT_RZ(1)
C
      CM_AL = CMSAX_U(1)*VINF_A(1) + CMSAX_U(4)*WROT_A(1)
     &      + CMSAX_U(2)*VINF_A(2) + CMSAX_U(5)*WROT_A(2)
     &      + CMSAX_U(3)*VINF_A(3) + CMSAX_U(6)*WROT_A(3)
      CM_BE = CMSAX_U(1)*VINF_B(1)
     &      + CMSAX_U(2)*VINF_B(2)
     &      + CMSAX_U(3)*VINF_B(3)
      CM_RX = CMSAX_U(4)*WROT_RX(1) + CMSAX_U(6)*WROT_RX(3)
      CM_RY = CMSAX_U(5)
      CM_RZ = CMSAX_U(6)*WROT_RZ(3) + CMSAX_U(4)*WROT_RZ(1)
C
      CN_AL = CNSAX_U(1)*VINF_A(1) + CNSAX_U(4)*WROT_A(1)
     &      + CNSAX_U(2)*VINF_A(2) + CNSAX_U(5)*WROT_A(2)
     &      + CNSAX_U(3)*VINF_A(3) + CNSAX_U(6)*WROT_A(3) + CNSAX_A
      CN_BE = CNSAX_U(1)*VINF_B(1)
     &      + CNSAX_U(2)*VINF_B(2)
     &      + CNSAX_U(3)*VINF_B(3)
      CN_RX = CNSAX_U(4)*WROT_RX(1) + CNSAX_U(6)*WROT_RX(3)
      CN_RY = CNSAX_U(5)
      CN_RZ = CNSAX_U(6)*WROT_RZ(3) + CNSAX_U(4)*WROT_RZ(1)
C
C
      CALL OUTTOT(LU)
C
      WRITE(LU,7004)
 7004 FORMAT(/' Stability-axis derivatives...')
C
      WRITE(LU,7006)
 7006 FORMAT(/14X, 4X,'           alpha',
     &             4X,'            beta'
     &       /14X, 4X,'----------------',
     &             4X,'----------------')
C
      WRITE(LU,7010) CL_AL, CL_BE
 7010 FORMAT(' z'' force CL |' ,'    CLa =',F11.6,'    CLb =',F11.6)
C
      WRITE(LU,7020) CY_AL, CY_BE
 7020 FORMAT(' y  force CY |'  ,'    CYa =',F11.6,'    CYb =',F11.6)
C
      WRITE(LU,7040) DIR*CR_AL, DIR*CR_BE
 7040 FORMAT(' x'' mom.  Cl''|','    Cla =',F11.6,'    Clb =',F11.6)
C
      WRITE(LU,7050) CM_AL, CM_BE
 7050 FORMAT(' y  mom.  Cm |'  ,'    Cma =',F11.6,'    Cmb =',F11.6)
C
      WRITE(LU,7060) DIR*CN_AL, DIR*CN_BE
 7060 FORMAT(' z'' mom.  Cn''|','    Cna =',F11.6,'    Cnb =',F11.6)
C
C
      WRITE(LU,7106)
 7106 FORMAT(/14X, 4X,'   roll rate  p''',
     &             4X,'  pitch rate  q''',
     &             4X,'    yaw rate  r'''
     &       /14X, 4X,'----------------',
     &             4X,'----------------',
     &             4X,'----------------' )
C
      WRITE(LU,7110) CL_RX*2.0/BREF, 
     &               CL_RY*2.0/CREF, 
     &               CL_RZ*2.0/BREF
 7110 FORMAT(' z'' force CL |','    CLp =',F11.6,
     &                         '    CLq =',F11.6,
     &                         '    CLr =',F11.6 )
C
      WRITE(LU,7120) CY_RX*2.0/BREF,
     &               CY_RY*2.0/CREF,
     &               CY_RZ*2.0/BREF
 7120 FORMAT(' y  force CY |','    CYp =',F11.6,
     &                        '    CYq =',F11.6,
     &                        '    CYr =',F11.6 )
C
      WRITE(LU,7140) DIR*CR_RX*2.0/BREF, 
     &               DIR*CR_RY*2.0/CREF,
     &               DIR*CR_RZ*2.0/BREF
 7140 FORMAT(' x'' mom.  Cl''|','    Clp =',F11.6,
     &                        '    Clq =',F11.6,
     &                        '    Clr =',F11.6 )
C
      WRITE(LU,7150) CM_RX*2.0/BREF,
     &               CM_RY*2.0/CREF,
     &               CM_RZ*2.0/BREF
 7150 FORMAT(' y  mom.  Cm |','    Cmp =',F11.6,
     &                        '    Cmq =',F11.6,
     &                        '    Cmr =',F11.6 )
C
      WRITE(LU,7160) DIR*CN_RX*2.0/BREF,
     &               DIR*CN_RY*2.0/CREF,
     &               DIR*CN_RZ*2.0/BREF
 7160 FORMAT(' z'' mom.  Cn''|','    Cnp =',F11.6,
     &                        '    Cnq =',F11.6,
     &                        '    Cnr =',F11.6 )
C
      IF(NCONTROL.GT.0) THEN
C
      WRITE(LU,8106) (DNAME(K), K, K=1, NCONTROL)
 8106 FORMAT(/14X,20(4X,A12, ' d',I1,' '))
      WRITE(LU,8107) (' ',K=1, NCONTROL)
 8107 FORMAT( 14X,20(3X,A,'----------------'))
C
      WRITE(LU,8110) (' ',K,CLTOT_D(K), K=1, NCONTROL)
 8110 FORMAT(' z'' force CL |' ,20(A,'  CLd',I1,' =',F11.6))
C
      WRITE(LU,8120) (' ',K,CYTOT_D(K), K=1, NCONTROL)
 8120 FORMAT(' y  force CY |'  ,20(A,'  CYd',I1,' =',F11.6))
C
      WRITE(LU,8140) (' ',K,DIR*CRTOT_D(K), K=1, NCONTROL)
 8140 FORMAT(' x'' mom.  Cl''|',20(A,'  Cld',I1,' =',F11.6))
C
      WRITE(LU,8150) (' ',K,    CMTOT_D(K), K=1, NCONTROL)
 8150 FORMAT(' y  mom.  Cm |'  ,20(A,'  Cmd',I1,' =',F11.6))
C
      WRITE(LU,8160) (' ',K,DIR*CNTOT_D(K), K=1, NCONTROL)
 8160 FORMAT(' z'' mom.  Cn''|',20(A,'  Cnd',I1,' =',F11.6))
C
      WRITE(LU,8170) (' ',K,    CDFF_D(K), K=1, NCONTROL)
 8170 FORMAT(' Trefftz drag|'  ,20(A,'CDffd',I1,' =',F11.6))
C
      WRITE(LU,8180) (' ',K,  SPANEF_D(K), K=1, NCONTROL)
 8180 FORMAT(' span eff.   |'  ,20(A,'   ed',I1,' =',F11.6))
C
      WRITE(LU,*)
      WRITE(LU,*)
C
      ENDIF
C
      IF(NDESIGN.GT.0) THEN
C
      WRITE(LU,8206) (GNAME(K), K, K=1, NDESIGN)
 8206 FORMAT(/14X,20(4X,A12, ' g',I1,' '))
      WRITE(LU,8207) (' ',K=1, NDESIGN)
 8207 FORMAT( 14X,20(3X,A,'----------------'))
C
      WRITE(LU,8210) (' ',K,CLTOT_G(K), K=1, NDESIGN)
 8210 FORMAT(' z'' force CL |'  ,20(A,'  CLg',I1,' =',F11.6))
C
      WRITE(LU,8220) (' ',K,CYTOT_G(K), K=1, NDESIGN)
 8220 FORMAT(' y  force CY |'   ,20(A,'  CYg',I1,' =',F11.6))
C
      WRITE(LU,8230) (' ',K,DIR*CRTOT_G(K), K=1, NDESIGN)
 8230 FORMAT(' x'' mom.  Cl''|' ,20(A,'  Clg',I1,' =',F11.6))
C
      WRITE(LU,8240) (' ',K,    CMTOT_G(K), K=1, NDESIGN)
 8240 FORMAT(' y  mom.  Cm |'    ,20(A,'  Cmg',I1,' =',F11.6))
C
      WRITE(LU,8250) (' ',K,DIR*CNTOT_G(K), K=1, NDESIGN)
 8250 FORMAT(' z'' mom.  Cn''|',20(A,'  Cng',I1,' =',F11.6))
C
      WRITE(LU,8260) (' ',K,    CDFF_G(K), K=1, NDESIGN)
 8260 FORMAT(' Trefftz drag|',20(A,'CDffg',I1,' =',F11.6))
C
      WRITE(LU,8270) (' ',K,  SPANEF_G(K), K=1, NDESIGN)
 8270 FORMAT(' span eff.   |',20(A,'   eg',I1,' =',F11.6))
C
      WRITE(LU,*)
      WRITE(LU,*)
C
      ENDIF
C
      IF(CL_AL .NE. 0.0) THEN
       XNP = XYZREF(1) - CREF*CM_AL/CL_AL
       WRITE(LU,8401) XNP
 8401  FORMAT(/' Neutral point  Xnp =', F11.6)
      ENDIF
C
      IF(ABS(CR_RZ*CN_BE) .GT. 0.0001) THEN
       BB = CR_BE*CN_RZ / (CR_RZ*CN_BE)
       WRITE(LU,8402) BB 
 8402  FORMAT(/' Clb Cnr / Clr Cnb  =', F11.6,
     &    '    (  > 1 if spirally stable )')
      ENDIF

C
      RETURN
      END ! DERMATS



      SUBROUTINE DERMATB(LU)
C---------------------------------------------------------
C     Calculates and outputs stability derivative matrix
C     in body axes
C---------------------------------------------------------
      INCLUDE 'AVL.INC'
      CHARACTER*50 SATYPE
      REAL WROT_RX(3), WROT_RZ(3), WROT_A(3)
C
      CALL GETSA(LNASA_SA,SATYPE,DIR)
C
C---- set freestream velocity components from alpha, beta
      CALL VINFAB
C
C---- calculate forces and sensitivities
      CALL AERO
C
      CALL OUTTOT(LU)
C
      WRITE(LU,7004)
 7004 FORMAT(/' Geometry-axis derivatives...')
C
C
      WRITE(LU,7006)
 7006 FORMAT(/14X, 4X,'  axial   vel. u',
     &             4X,' sideslip vel. v',
     &             4X,'  normal  vel. w'
     &       /14X, 4X,'----------------',
     &             4X,'----------------',
     &             4X,'----------------' )
C
      WRITE(LU,7010) -    CXTOT_U(1),
     &               -DIR*CXTOT_U(2),
     &               -    CXTOT_U(3)
 7010 FORMAT(' x force CX  |','    CXu =',F11.6,
     &                        '    CXv =',F11.6,
     &                        '    CXw =',F11.6 )
C
      WRITE(LU,7020) -DIR*CYTOT_U(1),
     &               -    CYTOT_U(2),
     &               -DIR*CYTOT_U(3)
 7020 FORMAT(' y force CY  |','    CYu =',F11.6,
     &                        '    CYv =',F11.6,
     &                        '    CYw =',F11.6 )
C
      WRITE(LU,7030) -    CZTOT_U(1),
     &               -DIR*CZTOT_U(2),
     &               -    CZTOT_U(3)
 7030 FORMAT(' z force CZ  |','    CZu =',F11.6,
     &                        '    CZv =',F11.6,
     &                        '    CZw =',F11.6 )
C
      WRITE(LU,7040) -    CRTOT_U(1),
     &               -DIR*CRTOT_U(2),
     &               -    CRTOT_U(3)
 7040 FORMAT(' x mom.  Cl  |','    Clu =',F11.6,
     &                        '    Clv =',F11.6,
     &                        '    Clw =',F11.6 )
C
      WRITE(LU,7050) -DIR*CMTOT_U(1),
     &               -    CMTOT_U(2),
     &               -DIR*CMTOT_U(3)
 7050 FORMAT(' y mom.  Cm  |','    Cmu =',F11.6,
     &                        '    Cmv =',F11.6,
     &                        '    Cmw =',F11.6 )
C
      WRITE(LU,7060) -    CNTOT_U(1),
     &               -DIR*CNTOT_U(2),
     &               -    CNTOT_U(3)
 7060 FORMAT(' z mom.  Cn  |','    Cnu =',F11.6,
     &                        '    Cnv =',F11.6,
     &                        '    Cnw =',F11.6 )
C
C
      WRITE(LU,7106)
 7106 FORMAT(/14X, 4X,'    roll rate  p',
     &             4X,'   pitch rate  q',
     &             4X,'     yaw rate  r'
     &       /14X, 4X,'----------------',
     &             4X,'----------------',
     &             4X,'----------------' )
C
      WRITE(LU,7110)     CXTOT_U(4)*2.0/BREF, 
     &               DIR*CXTOT_U(5)*2.0/CREF, 
     &                   CXTOT_U(6)*2.0/BREF
 7110 FORMAT(' x force CX  |','    CXp =',F11.6,
     &                        '    CXq =',F11.6,
     &                        '    CXr =',F11.6 )
C
      WRITE(LU,7120) DIR*CYTOT_U(4)*2.0/BREF,
     &                   CYTOT_U(5)*2.0/CREF,
     &               DIR*CYTOT_U(6)*2.0/BREF
 7120 FORMAT(' y force CY  |','    CYp =',F11.6,
     &                        '    CYq =',F11.6,
     &                        '    CYr =',F11.6 )
C
      WRITE(LU,7130)     CZTOT_U(4)*2.0/BREF,
     &               DIR*CZTOT_U(5)*2.0/CREF,
     &                   CZTOT_U(6)*2.0/BREF
 7130 FORMAT(' z force CZ  |','    CZp =',F11.6,
     &                        '    CZq =',F11.6,
     &                        '    CZr =',F11.6 )
C
      WRITE(LU,7140)     CRTOT_U(4)*2.0/BREF, 
     &               DIR*CRTOT_U(5)*2.0/CREF,
     &                   CRTOT_U(6)*2.0/BREF
 7140 FORMAT(' x mom.  Cl  |','    Clp =',F11.6,
     &                        '    Clq =',F11.6,
     &                        '    Clr =',F11.6 )
C
      WRITE(LU,7150) DIR*CMTOT_U(4)*2.0/BREF,
     &                   CMTOT_U(5)*2.0/CREF,
     &               DIR*CMTOT_U(6)*2.0/BREF
 7150 FORMAT(' y mom.  Cm  |','    Cmp =',F11.6,
     &                        '    Cmq =',F11.6,
     &                        '    Cmr =',F11.6 )
C
      WRITE(LU,7160)     CNTOT_U(4)*2.0/BREF,
     &               DIR*CNTOT_U(5)*2.0/CREF,
     &                   CNTOT_U(6)*2.0/BREF
 7160 FORMAT(' z mom.  Cn  |','    Cnp =',F11.6,
     &                        '    Cnq =',F11.6,
     &                        '    Cnr =',F11.6 )
C
      IF(NCONTROL.GT.0) THEN
C
      WRITE(LU,8106) (DNAME(K), K, K=1, NCONTROL)
 8106 FORMAT(/14X,20(4X,A12, ' d',I1,' '))
      WRITE(LU,8107) (' ',K=1, NCONTROL)
 8107 FORMAT( 14X,20(3X,A,'----------------'))
C
      WRITE(LU,8110) (' ',K,DIR*CXTOT_D(K), K=1, NCONTROL)
 8110 FORMAT(' x force CX  |',20(A,'  CXd',I1,' =',F11.6))
C
      WRITE(LU,8120) (' ',K,    CYTOT_D(K), K=1, NCONTROL)
 8120 FORMAT(' y force CY  |',20(A,'  CYd',I1,' =',F11.6))
C
      WRITE(LU,8130) (' ',K,DIR*CZTOT_D(K), K=1, NCONTROL)
 8130 FORMAT(' z force CZ  |',20(A,'  CZd',I1,' =',F11.6))
C
      WRITE(LU,8140) (' ',K,DIR*CRTOT_D(K), K=1, NCONTROL)
 8140 FORMAT(' x mom.  Cl  |',20(A,'  Cld',I1,' =',F11.6))
C
      WRITE(LU,8150) (' ',K,    CMTOT_D(K), K=1, NCONTROL)
 8150 FORMAT(' y mom.  Cm  |',20(A,'  Cmd',I1,' =',F11.6))
C
      WRITE(LU,8160) (' ',K,DIR*CNTOT_D(K), K=1, NCONTROL)
 8160 FORMAT(' z mom.  Cn  |',20(A,'  Cnd',I1,' =',F11.6))
C
      WRITE(LU,*)
      WRITE(LU,*)
C
      ENDIF
C
      IF(NDESIGN.GT.0) THEN
C
      WRITE(LU,8206) (GNAME(K), K, K=1, NDESIGN)
 8206 FORMAT(/14X,20(4X,A12, ' g',I1,' '))
      WRITE(LU,8207) (' ',K=1, NDESIGN)
 8207 FORMAT( 14X,20(3X,A,'----------------'))
C
      WRITE(LU,8210) (' ',K,DIR*CXTOT_G(K), K=1, NDESIGN)
 8210 FORMAT(' x force CX  |',20(A,'  CXg',I1,' =',F11.6))
C
      WRITE(LU,8220) (' ',K,    CYTOT_G(K), K=1, NDESIGN)
 8220 FORMAT(' y force CY  |',20(A,'  CYg',I1,' =',F11.6))
C
      WRITE(LU,8230) (' ',K,DIR*CZTOT_G(K), K=1, NDESIGN)
 8230 FORMAT(' z force CZ  |',20(A,'  CZg',I1,' =',F11.6))
C
      WRITE(LU,8240) (' ',K,DIR*CRTOT_G(K), K=1, NDESIGN)
 8240 FORMAT(' x mom.  Cl  |',20(A,'  Clg',I1,' =',F11.6))
C
      WRITE(LU,8250) (' ',K,    CMTOT_G(K), K=1, NDESIGN)
 8250 FORMAT(' y mom.  Cm  |',20(A,'  Cmg',I1,' =',F11.6))
C
      WRITE(LU,8260) (' ',K,DIR*CNTOT_G(K), K=1, NDESIGN)
 8260 FORMAT(' z mom.  Cn  |',20(A,'  Cng',I1,' =',F11.6))
C
      WRITE(LU,*)
      WRITE(LU,*)
C
      ENDIF
C
      RETURN
      END ! DERMATB



      SUBROUTINE DUMPIT(LU,NF,VINF,ALPHA, BETA,
     &                  OMEGAX, OMEGAY, OMEGAZ,
     &                  CFX, CFY, CFZ, CMX, CMY, CMZ)
C
C--- Writes flow condition header to logical unit
C
       REAL VINF(NF),ALPHA(NF), BETA(NF),
     &     OMEGAX(NF), OMEGAY(NF), OMEGAZ(NF),
     &     CFX(NF), CFY(NF), CFZ(NF), CMX(NF), CMY(NF), CMZ(NF)
C
      DO IF=1, NF
        WRITE(LU,2050) IF, VINF(IF)
        WRITE(LU,2060) ALPHA(IF), BETA(IF),
     &                 OMEGAX(IF), OMEGAY(IF), OMEGAZ(IF)
        WRITE(LU,2070) CFX(IF), CFY(IF), CFZ(IF),
     &                 CMX(IF), CMY(IF), CMZ(IF)
      END DO
C
 2050 FORMAT(/1X,'Flow condition', I3, '    Vinf =', F8.3)
 2060 FORMAT(/1X,6X,'Alpha' ,7X,'Beta',
     &           5X,'Omegax',5X,'Omegay',5X,'Omegaz' /1X,5F11.6)
 2070 FORMAT(/1X,8X,'CFx',8X,'CFy',8X,'CFz',
     &           8X,'CMx',8X,'CMy',8X,'CMz' /1X,6F11.6 / )
C
      RETURN
      END


      SUBROUTINE GETSA(LSA,SATYPE,DIR)
      LOGICAL LSA
      CHARACTER*(*) SATYPE
C
      IF(LSA) THEN
       SATYPE = 'Standard axis orientation,  X fwd, Z down'
       DIR = -1.0
      ELSE
       SATYPE = 'Geometric axis orientation,  X aft, Z up  '
       DIR =  1.0
      ENDIF
C
      RETURN
      END ! GETSA

      SUBROUTINE LUDCMP(NSIZ,N,A,INDX,WORK)
C     *******************************************************
C     *   Factors a full NxN matrix into an LU form.        *
C     *   Uses LINPACK routines for linear algebra          *
C     *******************************************************
C
      REAL A(NSIZ,NSIZ), WORK(NSIZ)
      INTEGER INDX(NSIZ)
C
      INFO = 0
      CALL SGEFA(A,NSIZ,N,INDX,INFO)
C
      RETURN
      END ! LUDCMP


      SUBROUTINE BAKSUB(NSIZ,N,A,INDX,B)
      REAL A(NSIZ,NSIZ), B(NSIZ)
      INTEGER INDX(NSIZ)
C     *******************************************************
C     *   BAKSUB does back-substitution with RHS using      *
C     *   stored LU decomposition.                          *
C     *   Uses LINPACK routines for linear algebra          *
C     *******************************************************
C
      INFO = 0
      CALL SGESL(A,NSIZ,N,INDX,B,INFO)
C
      RETURN
      END ! BAKSUB

      SUBROUTINE SGEFA(A,LDA,N,IPVT,INFO)
      INTEGER LDA,N,IPVT(1),INFO
      REAL A(LDA,1)
C
C     SGEFA FACTORS A REAL MATRIX BY GAUSSIAN ELIMINATION.
C
C     SGEFA IS USUALLY CALLED BY SGECO, BUT IT CAN BE CALLED
C     DIRECTLY WITH A SAVING IN TIME IF  RCOND  IS NOT NEEDED.
C     (TIME FOR SGECO) = (1 + 9/N)*(TIME FOR SGEFA) .
C
C     ON ENTRY
C
C        A       REAL(LDA, N)
C                THE MATRIX TO BE FACTORED.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C     ON RETURN
C
C        A       AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS
C                WHICH WERE USED TO OBTAIN IT.
C                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE
C                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER
C                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.
C
C        IPVT    INTEGER(N)
C                AN INTEGER VECTOR OF PIVOT INDICES.
C
C        INFO    INTEGER
C                = 0  NORMAL VALUE.
C                = K  IF  U(K,K) .EQ. 0.0 .  THIS IS NOT AN ERROR
C                     CONDITION FOR THIS SUBROUTINE, BUT IT DOES
C                     INDICATE THAT SGESL OR SGEDI WILL DIVIDE BY ZERO
C                     IF CALLED.  USE  RCOND  IN SGECO FOR A RELIABLE
C                     INDICATION OF SINGULARITY.
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS SAXPY,SSCAL,ISAMAX
C
C     INTERNAL VARIABLES
C
      REAL T
      INTEGER ISAMAX,J,K,KP1,L,NM1
C
C
C     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
C
      INFO = 0
      NM1 = N - 1
      IF (NM1 .LT. 1) GO TO 70
      DO 60 K = 1, NM1
         KP1 = K + 1
C
C        FIND L = PIVOT INDEX
C
         L = ISAMAX(N-K+1,A(K,K),1) + K - 1
         IPVT(K) = L
C
C        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
C
         IF (A(L,K) .EQ. 0.0E0) GO TO 40
C
C           INTERCHANGE IF NECESSARY
C
            IF (L .EQ. K) GO TO 10
               T = A(L,K)
               A(L,K) = A(K,K)
               A(K,K) = T
   10       CONTINUE
C
C           COMPUTE MULTIPLIERS
C
            T = -1.0E0/A(K,K)
            CALL SSCAL(N-K,T,A(K+1,K),1)
C
C           ROW ELIMINATION WITH COLUMN INDEXING
C
            DO 30 J = KP1, N
               T = A(L,J)
               IF (L .EQ. K) GO TO 20
                  A(L,J) = A(K,J)
                  A(K,J) = T
   20          CONTINUE
               CALL SAXPY(N-K,T,A(K+1,K),1,A(K+1,J),1)
   30       CONTINUE
         GO TO 50
   40    CONTINUE
            INFO = K
   50    CONTINUE
   60 CONTINUE
   70 CONTINUE
      IPVT(N) = N
      IF (A(N,N) .EQ. 0.0E0) INFO = N
      RETURN
      END


      SUBROUTINE SGESL(A,LDA,N,IPVT,B,JOB)
      INTEGER LDA,N,IPVT(1),JOB
      REAL A(LDA,1),B(1)
C
C     SGESL SOLVES THE REAL SYSTEM
C     A * X = B  OR  TRANS(A) * X = B
C     USING THE FACTORS COMPUTED BY SGECO OR SGEFA.
C
C     ON ENTRY
C
C        A       REAL(LDA, N)
C                THE OUTPUT FROM SGECO OR SGEFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        IPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM SGECO OR SGEFA.
C
C        B       REAL(N)
C                THE RIGHT HAND SIDE VECTOR.
C
C        JOB     INTEGER
C                = 0         TO SOLVE  A*X = B ,
C                = NONZERO   TO SOLVE  TRANS(A)*X = B  WHERE
C                            TRANS(A)  IS THE TRANSPOSE.
C
C     ON RETURN
C
C        B       THE SOLUTION VECTOR  X .
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS A
C        ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES SINGULARITY
C        BUT IT IS OFTEN CAUSED BY IMPROPER ARGUMENTS OR IMPROPER
C        SETTING OF LDA .  IT WILL NOT OCCUR IF THE SUBROUTINES ARE
C        CALLED CORRECTLY AND IF SGECO HAS SET RCOND .GT. 0.0
C        OR SGEFA HAS SET INFO .EQ. 0 .
C
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX
C     WITH  P  COLUMNS
C           CALL SGECO(A,LDA,N,IPVT,RCOND,Z)
C           IF (RCOND IS TOO SMALL) GO TO ...
C           DO 10 J = 1, P
C              CALL SGESL(A,LDA,N,IPVT,C(1,J),0)
C        10 CONTINUE
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS SAXPY,SDOT
C
C     INTERNAL VARIABLES
C
      REAL SDOT,T
      INTEGER K,KB,L,NM1
C
      NM1 = N - 1
      IF (JOB .NE. 0) GO TO 50
C
C        JOB = 0 , SOLVE  A * X = B
C        FIRST SOLVE  L*Y = B
C
         IF (NM1 .LT. 1) GO TO 30
         DO 20 K = 1, NM1
            L = IPVT(K)
            T = B(L)
            IF (L .EQ. K) GO TO 10
               B(L) = B(K)
               B(K) = T
   10       CONTINUE
            CALL SAXPY(N-K,T,A(K+1,K),1,B(K+1),1)
   20    CONTINUE
   30    CONTINUE
C
C        NOW SOLVE  U*X = Y
C
         DO 40 KB = 1, N
            K = N + 1 - KB
            B(K) = B(K)/A(K,K)
            T = -B(K)
            CALL SAXPY(K-1,T,A(1,K),1,B(1),1)
   40    CONTINUE
      GO TO 100
   50 CONTINUE
C
C        JOB = NONZERO, SOLVE  TRANS(A) * X = B
C        FIRST SOLVE  TRANS(U)*Y = B
C
         DO 60 K = 1, N
            T = SDOT(K-1,A(1,K),1,B(1),1)
            B(K) = (B(K) - T)/A(K,K)
   60    CONTINUE
C
C        NOW SOLVE TRANS(L)*X = Y
C
         IF (NM1 .LT. 1) GO TO 90
         DO 80 KB = 1, NM1
            K = N - KB
            B(K) = B(K) + SDOT(N-K,A(K+1,K),1,B(K+1),1)
            L = IPVT(K)
            IF (L .EQ. K) GO TO 70
               T = B(L)
               B(L) = B(K)
               B(K) = T
   70       CONTINUE
   80    CONTINUE
   90    CONTINUE
  100 CONTINUE
      RETURN
      END


      subroutine saxpy(n,sa,sx,incx,sy,incy)
c
c     constant times a vector plus a vector.
c     uses unrolled loop for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      real sx(1),sy(1),sa
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if (sa .eq. 0.0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        sy(iy) = sy(iy) + sa*sx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,4)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        sy(i) = sy(i) + sa*sx(i)
   30 continue
      if( n .lt. 4 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,4
        sy(i) = sy(i) + sa*sx(i)
        sy(i + 1) = sy(i + 1) + sa*sx(i + 1)
        sy(i + 2) = sy(i + 2) + sa*sx(i + 2)
        sy(i + 3) = sy(i + 3) + sa*sx(i + 3)
   50 continue
      return
      end
      real function sdot(n,sx,incx,sy,incy)
c
c     forms the dot product of two vectors.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      real sx(1),sy(1),stemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      stemp = 0.0e0
      sdot = 0.0e0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        stemp = stemp + sx(ix)*sy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      sdot = stemp
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        stemp = stemp + sx(i)*sy(i)
   30 continue
      if( n .lt. 5 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        stemp = stemp + sx(i)*sy(i) + sx(i + 1)*sy(i + 1) +
     *   sx(i + 2)*sy(i + 2) + sx(i + 3)*sy(i + 3) + sx(i + 4)*sy(i + 4)
   50 continue
   60 sdot = stemp
      return
      end


      subroutine sscal(n,sa,sx,incx)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to 1.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c
      real sa,sx(1)
      integer i,incx,m,mp1,n,nincx
c
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        sx(i) = sa*sx(i)
   10 continue
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        sx(i) = sa*sx(i)
   30 continue
      if( n .lt. 5 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        sx(i) = sa*sx(i)
        sx(i + 1) = sa*sx(i + 1)
        sx(i + 2) = sa*sx(i + 2)
        sx(i + 3) = sa*sx(i + 3)
        sx(i + 4) = sa*sx(i + 4)
   50 continue
      return
      end


      integer function isamax(n,sx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c
      real sx(1),smax
      integer i,incx,ix,n
c
      isamax = 0
      if( n.lt.1 .or. incx.le.0 ) return
      isamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = abs(sx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(abs(sx(ix)).le.smax) go to 5
         isamax = i
         smax = abs(sx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = abs(sx(1))
      do 30 i = 2,n
         if(abs(sx(i)).le.smax) go to 30
         isamax = i
         smax = abs(sx(i))
   30 continue
      return
      end

C***********************************************************************
C    Module:  aplotvl.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE PLOTVL(AZIM, ELEV, TILT, RINV)
C
C----Plotting module for AVL vortex lattice program
C
C    Plots geometry and loading results for vortex lattice
C     Geometry plots:
C       Surfaces     (straight tapered panels of chordwise strips of vortices)
C       Strips       (chordwise strips of vortices)
C       Vortex legs  (bound vortex legs)
C       Control pts  (vortex element control points)
C       Camber slope (camber of each strip - used for establishing BC's)
C       Hinge lines  (surface deflection axis and deflected surface outline)
C       Strip loading (chordwise plot of vortex loading on each strip)
C
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      LOGICAL LKEYS, LCOLHC, ERROR
      LOGICAL LINITVIEW, LDEBUG
      SAVE    LINITVIEW, LDEBUG
      CHARACTER*80 LINE
      CHARACTER*4 OPT
      CHARACTER*1 CKEY
C
      REAL RINP(10), ARG(5)
C
C---- viewpoint changes (deg), zoom/unzoom, perspective scale factors
      DATA DAZIM, DELEV, ZUFAC, DPAN , PRAT 
     &     / 5.0 , 5.0 , 1.25 , 0.075, 1.1 /
C
    1 FORMAT(A)
C
C***************************************************
C---- Initialization for plot program variables
      IF(LPLTNEW .OR. (.NOT.LPLOT)) THEN 
        LPLTNEW = .FALSE.
        LINITVIEW = .FALSE.
        LDEBUG = .FALSE.
      ENDIF
C
      LKEYS = .FALSE.
C
C---- find geometry and axis limits
      CALL GLIMS(GMIN,GMAX,.FALSE.)
      CALL AXLIMS
C
C***************************************************
C---- Setup view transformation 
 4    CONTINUE
      CALL VIEWINIT(AZIM, ELEV, TILT, RINV)
C
C---- scale and project x,y,z orientation arrows UAXARW(....)
C-    also project x,y,z unit vectors UAXDIR(..)
      ARWLEN = 0.2*BREF
C
      RHEADP = RHEAD*ARWLEN
      DO IXYZ = 1, 3
        DO K = 1, 3
          DO IL = 1, NLINAX
            UAXARWP(K,1,IL,IXYZ) = UAXARW(K,1,IL,IXYZ)*ARWLEN
            UAXARWP(K,2,IL,IXYZ) = UAXARW(K,2,IL,IXYZ)*ARWLEN
          ENDDO
        ENDDO
      ENDDO
      NLIN = 3 * 2*NLINAX
      NAXD = 3   
      CALL VIEWPROJ(UAXARWP,NLIN,UAXARWP)
      CALL VIEWPROJ(UAXDIR ,NAXD,UAXDIRP)
C
      DO IAXD = 1, NAXD
        DIRMAG = SQRT( UAXDIRP(1,IAXD)**2
     &               + UAXDIRP(2,IAXD)**2
     &               + UAXDIRP(3,IAXD)**2 )
        IF(DIRMAG .GT. 0.0) THEN
         UAXDIRP(1,IAXD) = UAXDIRP(1,IAXD)/DIRMAG
         UAXDIRP(2,IAXD) = UAXDIRP(2,IAXD)/DIRMAG
         UAXDIRP(3,IAXD) = UAXDIRP(3,IAXD)/DIRMAG
        ENDIF
      ENDDO
C
C---- Setup hidden line data
      CALL HIDINIT(.TRUE.)
C
C---- find plot limits
      CALL GLIMS(GMINP,GMAXP,.TRUE.)
      XMIN = GMINP(1)
      YMIN = GMINP(2)
      XMAX = GMAXP(1)
      YMAX = GMAXP(2)
C
C---- set plot offsets and scale
      CALL OFFINI
C
      LINITVIEW = .FALSE.
C
C
C***************************************************
C---- start geometry plot
 6    CONTINUE
      CALL PVLINI(TITLE,AZIM,ELEV,TILT,VERSION,.FALSE.)

C---- DEBUG: Check the triangle array
      IF(LDEBUG) THEN
       CALL GETCOLOR(ICOL0)
       CALL NEWCOLORNAME('RED')
       DO I = 1, NTRI
        CALL PLTPOLY(TRI(1,I),3)
       END DO
       CALL NEWCOLOR(ICOL0)
       CALL PLFLUSH
cc      PAUSE
      ENDIF
C
C---- plot the selected geometry items
      CALL PLOTGEOM


      CALL PLFLUSH
C
 7    CONTINUE
C
      IF(LKEYS) THEN
C------ process keystroke-mode commands, skipping normal menu loop farther below
        CKEY = ' '
        CALL GETCURSORXY(XX,YY,CKEY)
C
        IF(CKEY.EQ.' ') THEN
C------- exit to normal menu loop
         LKEYS = .FALSE.
C
        ELSEIF(INDEX('Ll',CKEY).NE.0) THEN
         AZIM = AZIM + DAZIM
         IF(AZIM .GT.  180.01) AZIM = AZIM - 360.0
         GO TO 4
C
        ELSEIF(INDEX('Rr',CKEY).NE.0) THEN
         AZIM = AZIM - DAZIM
         IF(AZIM .LT. -180.01) AZIM = AZIM + 360.0
         GO TO 4
C
        ELSEIF(INDEX('Uu',CKEY).NE.0) THEN
         ELEV = ELEV + DELEV
         IF(ELEV .GT.  90.01) THEN
          ELEV = 90.0
          WRITE(*,*) 'Elevation angle is limited to +/- 90 deg'
         ENDIF
         GO TO 4
C
        ELSEIF(INDEX('Dd',CKEY).NE.0) THEN
         ELEV = ELEV - DELEV
         IF(ELEV .LT. -90.01) THEN
          ELEV = -90.0
          WRITE(*,*) 'Elevation angle is limited to +/- 90 deg'
         ENDIF
         GO TO 4
C
c        ELSEIF(INDEX('Tt',CKEY).NE.0) THEN
c         TILT = TILT + 5.0
c         IF(TILT .GT.  180.01) TILT = TILT - 360.0
c         GO TO 4
cC
c        ELSEIF(INDEX('Ss',CKEY).NE.0) THEN
c         TILT = TILT - 5.0
c         IF(TILT .LT. -180.01) TILT = TILT + 360.0
c         GO TO 4
C
        ELSEIF(INDEX('Cc',CKEY).NE.0) THEN
         AZIM = 0.
         ELEV = 0.
         TILT = 0.
         GO TO 4
C
        ELSEIF(INDEX('Zz',CKEY).NE.0) THEN
         XOFF = XX/SF + XOFF
         YOFF = YY/SF + YOFF
         SF = SF*ZUFAC
         XDIF =    1.0/SF
         YDIF = PLOTAR/SF
         XOFF = XOFF - 0.5*XDIF
         YOFF = YOFF - 0.5*YDIF
         GO TO 6
C
        ELSEIF(INDEX('Ee',CKEY).NE.0) THEN
         XOFF = XX/SF + XOFF
         YOFF = YY/SF + YOFF
         SF = SF/ZUFAC
         XDIF =    1.0/SF
         YDIF = PLOTAR/SF
         XOFF = XOFF - 0.5*XDIF
         YOFF = YOFF - 0.5*YDIF
         GO TO 6
C
        ELSEIF(INDEX('Pp',CKEY).NE.0) THEN
         DX = XX - 0.5
         DY = YY - 0.5*PLOTAR
C
         XOFF = XOFF + DPAN*DX/SF
         YOFF = YOFF + DPAN*DY/SF
         GO TO 6
C
        ELSEIF(INDEX('Nn',CKEY).NE.0) THEN
         GO TO 4
C
        ELSEIF(INDEX('Ii',CKEY).NE.0) THEN
         IF(RINV.EQ.0.0) THEN
          RINV = 0.02/BREF
         ELSE
          RINV = RINV*PRAT
         ENDIF
         WRITE(*,8010) UNITL/RINV, UNCHL(1:NUL)
         GO TO 4
C
        ELSEIF(INDEX('Oo',CKEY).NE.0) THEN
         IF(RINV .LT. 0.02/BREF) THEN
          RINV = 0.0
          WRITE(*,*) '  Observer distance = infinity  (no perspective)'
         ELSE
          RINV = RINV/PRAT
          WRITE(*,8010) UNITL/RINV, UNCHL(1:NUL)
         ENDIF
         GO TO 4
C
        ELSEIF(INDEX('Aa',CKEY).NE.0) THEN
C------- Annotate
         CALL ANNOT(CH)
         WRITE(*,2040)
         GO TO 7
C
        ELSEIF(INDEX('Hh',CKEY).NE.0) THEN
C------- Make hardcopy
         IF(LPLOT) CALL PLEND
         LPLOT = .FALSE.
         CALL REPLOT(IDEVH)
         GO TO 6
C
        ELSE
         WRITE(*,*)
         WRITE(*,*) '*** "', CKEY,'"  key not recognized'
         WRITE(*,2040)
C
        ENDIF
C
        GO TO 4
      ENDIF
C
C
C***************************************************
C---- top of normal user interaction loop
C
 8    CONTINUE
      WRITE(*,2010)
      WRITE(*,2020) LCHORDLINE,LCAMBER,LCNTLPTS,LWAKEPLT,
     &              LBOUNDLEG,LNRMLPLT,LLOADPLT,LAXESPLT
      WRITE(*,2030) 
      READ(*,1) OPT 
C
 2010 FORMAT(
     &  /' ========================================='
     &  /'  K eystroke mode       V iewpoint        '
     &  /'  A nnotate plot        O ptions          '
     &  /'  H ardcopy plot        S elect surfaces  '
     &  /'  Z oom                 U nzoom           ')
 2020 FORMAT(
     &  /'  CH ordline   ',L2,7X,'CA amber       ',L2,
     &  /'  CN tlpoint   ',L2,7X,'TR ailing legs ',L2,
     &  /'  BO ound leg  ',L2,7X,'NO rmal vector ',L2,
     &  /'  LO ading     ',L2,7X,'AX es, xyz ref.',L2 )
 2030 FORMAT(/' Geometry plot command: ', $)
C
      CALL TOUPER(OPT) 
      IF(OPT.EQ.'  ' .OR. OPT.EQ.'Q ') THEN
       CALL PLEND
       RETURN
      ENDIF
C
      IF(OPT.EQ.'K ') THEN
C----- enter keystroke mode
       LKEYS = .TRUE.
       WRITE(*,2040)
 2040  FORMAT(
     &   /'  ------------------------------------------------'
     &   /'  Type keys in graphics window...'
     &  //'    L eft               R ight        (Azimuth  ) '
     &   /'    U p                 D own         (Elevation) '
     &   /'    C lear'
     &  //'    P an from cursor    Z oom on cursor           '
     &   /'    I ngress            E xpand on cursor         '
     &   /'    O utgress           N ormal size              '
     &  //'    H ardcopy           A nnotate plot            '
     &  //'  ...<space> to exit  '
     &   /'  ------------------------------------------------')
       GO TO 6
      ENDIF
C
C===================================================
      IF(OPT.EQ.'V ') THEN
 20     WRITE(*,2050) AZIM, ELEV
 2050   FORMAT(
     &   /'  Enter viewpoint azimuth,elevation angles:',2F7.0)
        RINP(1) = AZIM
        RINP(2) = ELEV
        NINP = 2
        CALL READR(NINP,RINP,ERROR)
        IF(ERROR) GO TO 20
C
        AZIM = RINP(1)
        ELEV = RINP(2)
        IF(AZIM .GT.  180.01) AZIM = AZIM - 360.0
        IF(AZIM .LT. -180.01) AZIM = AZIM + 360.0
        IF(ELEV .GT.   90.01) ELEV =  90.0
        IF(ELEV .LT.  -90.01) ELEV = -90.0
        GO TO 4
C===================================================
      ELSE IF(OPT.EQ.'CH') THEN
C------ Toggle chordline plotting
        LCHORDLINE = .NOT.LCHORDLINE
C
C===================================================
      ELSE IF(OPT.EQ.'CA') THEN
C------ Toggle camber
        LCAMBER = .NOT.LCAMBER
C
C===================================================
      ELSE IF(OPT.EQ.'BO') THEN
C------ Toggle plotting of bound legs
        LBOUNDLEG = .NOT.LBOUNDLEG
C
C===================================================
      ELSE IF(OPT.EQ.'CN') THEN
C------ Toggle control point plotting
        LCNTLPTS = .NOT.LCNTLPTS
C
C===================================================
      ELSE IF(OPT.EQ.'TR') THEN
C------ Toggle wake plotting
        LWAKEPLT = .NOT.LWAKEPLT
C
C===================================================
      ELSE IF(OPT.EQ.'LO') THEN
C------ Toggle plotting of surface loading
        LLOADPLT = .NOT.LLOADPLT
C
C===================================================
      ELSE IF(OPT.EQ.'NO') THEN
C------ Toggle plotting of surface normals
        LNRMLPLT = .NOT.LNRMLPLT
C
C===================================================
      ELSE IF(OPT.EQ.'AX') THEN
C------ Toggle plotting of x,y,z axes
        LAXESPLT = .NOT.LAXESPLT
C
C===================================================
      ELSE IF(OPT.EQ.'RE') THEN
C------ Toggle plotting of x,y,z reference location
        LRREFPLT = .NOT.LRREFPLT
C
C===================================================
cc    ELSE IF(OPT.EQ.'HI') THEN
ccC---- Toggle plotting of hinge axes 
cc      LHINGEPLT = .NOT.LHINGEPLT
C
C===================================================
      ELSE IF(OPT.EQ.'DE') THEN
C------ Toggle DEBUG
        LDEBUG = .NOT.LDEBUG
C
C===================================================
      ELSEIF(OPT.EQ.'A ') THEN
C----- Annotate
       IF(LPLOT) THEN
        CALL ANNOT(CH)
       ELSE
        WRITE(*,*) 'No active plot'
       ENDIF
C
C===================================================
      ELSEIF(OPT.EQ.'H ') THEN
C----- Make hardcopy
       IF(LPLOT) CALL PLEND
       LPLOT = .FALSE.
       CALL REPLOT(IDEVH)
       GO TO 8
C
C===================================================
      ELSEIF(OPT.EQ.'Z ') THEN
C----- Zoom in on the plot
       IF (LPLOT) THEN
        CALL OFFGET   
       ELSE
        WRITE(*,*) 'No active plot'
       ENDIF
C
C===================================================
      ELSEIF(OPT.EQ.'U ') THEN
C----- Reset to default offset and scaling factors
       CALL OFFINI   
C
C===================================================
      ELSEIF(OPT.EQ.'S ') THEN
C----- Set surfaces to plot
       CALL SELSURF(AZIM, ELEV, TILT, RINV)
       GO TO 4
C
C===================================================
      ELSEIF(OPT.EQ.'O ') THEN
C----- Display options 
 50    CONTINUE
       WRITE(*,*) ' '
       ROB = 999999.
       IF(RINV.NE.0.) ROB = 1.0/RINV
       LCOLHC = IDEVH.EQ.4
       WRITE(*,5500) LHID, ROB, SIZE, CPFAC, ENFAC, LCOLHC,
     &              LABEL_SURF, LABEL_STRP, LABEL_VRTX, LABEL_BODY
 5500  FORMAT(/' ================================================'
     &        /'   H iddenLine            currently ',L2
     &        /'   D ist. to observer     currently ',F12.2
     &        /'   S ize of plot          currently ',F10.2
     &        /'   L oading scale factor  currently ',F10.4
     &        /'   N ormal  scale factor  currently ',F10.4
     &        /'   C olor hardcopy        currently ',L2
     &        /'   LN label surfaces      currently ',L2
     &        /'   LS label strips        currently ',L2
     &        /'   LV label vortices      currently ',L2
     &        /'   LB label bodies        currently ',L2
     &       //' Select item to change (or <return>):  ', $)
       READ(*,1,ERR=50) LINE
       CALL STRIP(LINE,NLIN)
       OPT = LINE(1:2)
       CALL TOUPER(OPT)
C
       LINE(1:2) = '  '
       CALL STRIP(LINE,NLIN)
       NARG = 1
       CALL GETFLT(LINE,ARG,NARG,ERROR)
C
C----------------------------------------------------
       IF(OPT.EQ.'  ') THEN
         IF(LINITVIEW) THEN
           GO TO 4
          ELSE
           GO TO 6
         ENDIF
C
C----------------------------------------------------
       ELSE IF (OPT.EQ.'S ') THEN 
C------ Change size
        IF(NARG.GT.0) THEN
         SIZE = MAX( ARG(1) , 0.0 )
        ELSE
   52    WRITE(*,1052)
 1052    FORMAT(' Enter new plot size:  ',$)
         READ(*,*,ERR=52,END=50) SIZE
        ENDIF
C
C----------------------------------------------------
       ELSE IF(OPT.EQ.'D ') THEN
C------ Set distance to observer (controls perspective)
        IF(NARG.GT.0) THEN
         ROB = MAX( ARG(1) , 0.0 )
        ELSE
   53    WRITE(*,1053)
 1053    FORMAT(' Enter new distance to observer (0 for infinity):  ',$)
         READ (*,*,ERR=53,END=50) ROB
        ENDIF
C
        IF(ROB.EQ.0.0) THEN
         RINV = 0.
        ELSE
         RINV = 1.0/ROB
        ENDIF
        LINITVIEW = .TRUE.
C
C----------------------------------------------------
       ELSE IF(OPT.EQ.'L ') THEN
C------ Loading scale factor for DCP values (as fraction of CREF)
        IF(NARG.GT.0) THEN
         CPFAC = ARG(1)
        ELSE
   54    WRITE(*,1054)
 1054    FORMAT(' Enter new loading scale factor:  ',$)
         READ (*,*,ERR=54,END=50) CPFAC
        ENDIF
C
C----------------------------------------------------
       ELSE IF(OPT.EQ.'N ') THEN
C------ Normal vector scale factor (as fraction of CREF)
        IF(NARG.GT.0) THEN
         ENFAC = ARG(1)
        ELSE
 55      WRITE(*,1055)
 1055    FORMAT(' Enter new normal scale factor:  ',$)
         READ (*,*,ERR=55,END=50) ENFAC
        ENDIF
C
C----------------------------------------------------
       ELSE IF(OPT.EQ.'H ') THEN
C------ Toggle hidden line
        LHID = .NOT.LHID
C
C----------------------------------------------------
       ELSE IF(OPT.EQ.'C ') THEN
C------ Toggle Color hardcopy
        LCOLHC = .NOT.LCOLHC
        IF(LCOLHC) THEN
         IDEVH = 4
        ELSE
         IDEVH = 2
        ENDIF
C
C----------------------------------------------------
       ELSE IF(OPT.EQ.'LN') THEN
C------ Labeling for surfaces
        LABEL_SURF = .NOT.LABEL_SURF
C----------------------------------------------------
       ELSE IF(OPT.EQ.'LS') THEN
C------ Labeling for strips
        LABEL_STRP = .NOT.LABEL_STRP
C----------------------------------------------------
       ELSE IF(OPT.EQ.'LV') THEN
C------ Labeling for vortex elements
        LABEL_VRTX = .NOT.LABEL_VRTX
C----------------------------------------------------
       ELSE IF(OPT.EQ.'LB') THEN
C------ Labeling for bodies
        LABEL_BODY = .NOT.LABEL_BODY
       ENDIF
       GO TO 50
C
      ELSE
       WRITE(*,*) ' * Unrecognized command'
C
      ENDIF
C
      GO TO 6
C
 8010 FORMAT('   Observer distance =', G11.3,1X,A)
C
      END ! PLOTVL


      SUBROUTINE SELSURF(AZIM, ELEV, TILT, RINV)
C--- Selects surfaces for plotting
C
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      CHARACTER*40 OPT, OPT2
      CHARACTER*1 CKEY
      LOGICAL ERROR
C
    1 FORMAT(A)
C
C---- Select surfaces to plot
   60 CONTINUE
      CALL VIEWINIT(AZIM, ELEV, TILT, RINV)
      CALL HIDINIT(.TRUE.)
      CALL GLIMS(GMIN,GMAX,.FALSE.)
      CALL AXLIMS
cc    CALL OFFINI
      CALL PVLINI(TITLE,AZIM,ELEV,TILT,VERSION,.FALSE.)
      CALL PLOTGEOM
      CALL PLFLUSH
C
      WRITE(*,*) ' '
      WRITE(*,*) '==================================================='
      WRITE(*,*) '#surf component Nchord Nspan   plot?   Surface name'
      DO N = 1, NSURF
        WRITE(*,61) N, LSCOMP(N), NK(N), NJ(N), LPLTSURF(N), STITLE(N)
      END DO
   61 FORMAT(1X,I3,4X,I3, 4X,I3,4X,I3,4X,L3,6X,A)
C

 62   WRITE(*,*) '---------------------------------------------------'
      WRITE(*,1062) IMARKSURF
 1062 FORMAT(/'   #    Select surface #  or  #:#   selects range',
     &       /'  -#  DeSelect surface #  or -#:# deselects range,'
     &       /'   A    Select all surfaces',
     &       /'   N  DeSelect all surfaces',
     &       /'   M    Mark surface, currently', I3 )
C
 65   WRITE(*,1065)
 1065 FORMAT(/' Enter selection: (P prints surface list):  ',$)
C
      READ(*,1,ERR=65) OPT
cc      CALL LC2UC(OPT)
      KC = INDEX(OPT,':')
      KM = INDEX(OPT,',')
C
      CKEY = OPT(1:1)
C
      IF(CKEY.EQ.' ') THEN
        GO TO 100
C
C--- Read colon-separated number specs - i.e. 1:3 or -5:8
       ELSEIF(KC.GT.1) THEN
        READ(OPT(1:KC-1),*,ERR=62) N1
        READ(OPT(KC+1:LEN(OPT)),*,ERR=62) N2
        L1 = ABS(N1)
        L2 = ABS(N2)
        L1 = MIN(L1,NSURF)
        L2 = MIN(L2,NSURF)
        IF(L1.GT.0 .AND. L2.GE.L1) THEN
          DO N = L1, L2
            LPLTSURF(N) = (N1.GT.0)
          END DO
        ENDIF
C
C--- Read comma-separated number string - i.e. 1,2,3,-5,-8
       ELSEIF(KM.GT.1) THEN
        OPT2 = OPT
 67     READ(OPT2(1:KM-1),*,ERR=62) N
        NABS = ABS(N)
        IF(NABS.LE.0 .OR. NABS.GT.NSURF) GO TO 65
        LPLTSURF(NABS) = (N.GT.0) 
        OPT2 = OPT2(KM+1:LEN(OPT2))
        KM = INDEX(OPT2,',')
        IF(KM.GT.1) GO TO 67
C
        READ(OPT2,*,ERR=62) N
        NABS = ABS(N)
        IF(NABS.LE.0 .OR. NABS.GT.NSURF) GO TO 65
        LPLTSURF(NABS) = (N.GT.0) 
C
      ELSEIF(INDEX('Pp',CKEY).NE.0) THEN
        GO TO 60

      ELSEIF(INDEX('Aa',CKEY).NE.0) THEN
        DO N=1,NSURF
          LPLTSURF(N) = .TRUE.
        END DO
C
      ELSEIF(INDEX('Nn',CKEY).NE.0) THEN
        DO N=1,NSURF
          LPLTSURF(N) = .FALSE.
        END DO
C
      ELSEIF(INDEX('Mm',CKEY).NE.0) THEN
        NINP = 1
        CALL GETINT(OPT(2:40),IMARKSURF,NINP,ERROR)
C
        IF(NINP.EQ.0 .OR. ERROR) THEN
         WRITE(*,1068)
 1068    FORMAT(/' Enter surface # to mark:  ', $)
         READ (*,*,ERR=65,END=65) IMARKSURF
        ENDIF
C
        IF(IMARKSURF.LT.0)     IMARKSURF = 0
        IF(IMARKSURF.GT.NSURF) IMARKSURF = 0
C
      ELSE
        READ(OPT,*,ERR=65) N
        NABS = ABS(N)
        IF(NABS.LE.0 .OR. NABS.GT.NSURF) GO TO 65
        LPLTSURF(NABS) = (N.GT.0) 
      ENDIF
      GO TO 60
CC
 100  RETURN
      END ! SELSURF




      SUBROUTINE PVLINI(TITLE,AZIM,ELEV,TILT,VERSION,LDEVM)
C...PURPOSE:    Initializes plot frame for plotting and 
C               puts up axis orientation and labels
C
      INCLUDE 'AVLPLT.INC'
C
      CHARACTER*80 TITLE
      LOGICAL LDEVM

      CHARACTER*1 CHXYZ(3)
      DATA CHXYZ / 'x', 'y', 'z' /
C
      IF (LPLOT) CALL PLEND
C
      SCH = 0.7*SIZE*CH
      DLEN = 0.045*SIZE
C
      IF(LDEVM) THEN
       CALL PLTINI(IDEVM)
      ELSE
       CALL PLTINI(IDEV)
      ENDIF

C
C      IF(.NOT.LPLOT) CALL COLORMAP(NCOLORS)
      LPLOT = .TRUE. 
      XPLT = PMARG
      YPLT = PMARG
      CALL PLCHAR(XPLT,YPLT,0.6*SCH,'AVL ',0.0,4)
      CALL PLNUMB(999.,999.,0.6*SCH,VERSION,0.0,2)
C
      CALL GETCOLOR(ICOL0)
C
C---- small axis arrows
      CALL NEWPEN(2)
      CALL NEWCOLORNAME('GREEN')
      XO = PMARG + DLEN + 1.5*SCH
      YO = PMARG + DLEN + 8.5*SCH
C
      AFAC = DLEN/ARWLEN
      DO IXYZ = 1, 3
        CALL ARWPLT(XO,YO,AFAC,
     &              UAXARWP(1,1,1,IXYZ),
     &              UAXDIRP(1,IXYZ),RHEADP,NHEAD)
      ENDDO
C
C---- xyz labels
      LTIP = NHEAD+1
      DO IXYZ = 1, 3
        XPLT = XO + UAXARWP(1,2,LTIP,IXYZ)*AFAC
     &            + UAXDIRP(1       ,IXYZ)*1.3*SCH - 0.5*SCH
        YPLT = YO + UAXARWP(2,2,LTIP,IXYZ)*AFAC
     &            + UAXDIRP(2       ,IXYZ)*1.3*SCH - 0.5*SCH
        CALL PLCHAR(XPLT,YPLT,0.9*SCH,CHXYZ(IXYZ),0.0,1)
      ENDDO
      CALL NEWCOLOR(ICOL0)
C
C---- azimuth and elevation angles
      CALL NEWPEN(2)
      XPLT = PMARG
      YPLT = PMARG + 3.0*SCH
C
      CALL PLCHAR(XPLT             ,YPLT,0.75*SCH,'Elev',0.0, 4)
      CALL PLCHAR(XPLT+4.5*0.75*SCH,YPLT,0.75*SCH,'='   ,0.0, 1)
      CALL PLNUMB(XPLT+6.0*0.75*SCH,YPLT,0.75*SCH,ELEV  ,0.0,-1)
      CALL PLMATH(999.             ,999.,0.75*SCH,'"'   ,0.0, 1)
C
      YPLT = YPLT + 1.8*SCH
      CALL PLCHAR(XPLT             ,YPLT,0.75*SCH,'Azim',0.0, 4)
      CALL PLCHAR(XPLT+4.5*0.75*SCH,YPLT,0.75*SCH,'='   ,0.0, 1)
      CALL PLNUMB(XPLT+6.0*0.75*SCH,YPLT,0.75*SCH,AZIM  ,0.0,-1)
      CALL PLMATH(999.             ,999.,0.75*SCH,'"'   ,0.0, 1)
C
C---- Configuration title
      CALL NEWPEN(3)
      XPLT = PMARG + 10.0*SCH
      YPLT = PMARG
      CALL PLCHAR(XPLT,YPLT,1.1*SCH,TITLE,0.0,80)
C
C---- Move plot origin to miss axis block
      CALL PLOT(PMARG+2.0*DLEN+2.0*SCH,PMARG+5.0*SCH,-3)   
      CALL NEWFACTOR(SIZE)
      CALL NEWPEN(1)
C
C      CALL PLOT(0.,0.,3)   
C      CALL PLOT(1.,0.,2)   
C      CALL PLOT(1.,AR,2)   
C      CALL PLOT(0.,AR,2)   
C      CALL PLOT(0.,0.,2)   
C
      RETURN        
      END ! PVLINI  



      SUBROUTINE PLOTGEOM
C...PURPOSE:    Plotting routine to plot selected geometry data
C
C     Plots:
C       Surfaces     (straight tapered panels of chordwise strips of vortices)
C       Strips       (chordwise strips of vortices)
C       Vortex legs  (bound vortex legs)
C       Control pts  (vortex element control points)
C       Normal vector (normal vector at control points)
C       Camber slope (camber of each strip - used for establishing BC's)
C       Hinge lines  (surface deflection axis and deflected surface outline)
C       Strip loading (chordwise plot of vortex loading on each strip)
C
C     User can optionally display an identifying index for each item 
C      (surface, strip, element)
C
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      LOGICAL LVIS
C
      REAL ENTOT(3)
      REAL PLAB(3), PLAB2(3), SVEC1(3), SVEC2(3)
      REAL PTSORG(3)
      REAL PTS_LINES(3,2,NVMAX), ID_LINES(NVMAX),
     &     PTS_LPROJ(3,2,NVMAX)
      REAL PTS_POINT(3,NLMAX),
     &     PTS_PPROJ(3,NLMAX),
     &     RNUM_POINT(NLMAX)
      LOGICAL LOFF(NLMAX)
      INTEGER IDUM(1)
      REAL DUM(1,1)

      DATA ID_LINES / NVMAX * 0.0 /
C
      INCLUDE 'MASKS.INC'
C
      EPS    = 1.0E-5
      CHSIZE = 0.01
C
C---- number of line segments for drawing a body section "hoop"
      KK = 18
C
      IF(LAXESPLT) THEN
C----- plot x,y,z axes
       DTICK = 0.08 * MIN( AXDEL(1), AXDEL(2), AXDEL(3) )
       CHN = 1.0*DTICK*SF
C
       IP = 0
       IN = 0
C
C----- go over x,y,z axes
       DO 50 IAX = 1, 3
C------- go over axis tick marks
         DO IANN = 1, NAXANN(IAX)
C--------- previous and current tick mark location (x, y, or z value)
           XYZM = AXMIN(IAX) + AXDEL(IAX)*FLOAT(IANN-2)
           XYZO = AXMIN(IAX) + AXDEL(IAX)*FLOAT(IANN-1)
C
C--------- go over x,y,z directions
           DO 505 IDIR = 1, 3
             IF(IANN.EQ.1 .AND. IDIR.EQ.IAX) GO TO 505
C
             IF(IDIR.EQ.IAX) THEN
C------------ axis segment, along IAX direction
              IP = IP+1
              DO K = 1, 3
                PTS_LINES(K,1,IP) = 0.
                PTS_LINES(K,2,IP) = 0.
              ENDDO
              PTS_LINES(IAX,1,IP) = XYZM
              PTS_LINES(IAX,2,IP) = XYZO
C
             ELSE
C------------ tick marks, along the other two directions
              IP = IP+1
              DO K = 1, 3
                PTS_LINES(K,1,IP) = 0.
                PTS_LINES(K,2,IP) = 0.
              ENDDO
              PTS_LINES(IAX ,1,IP) = XYZO
              PTS_LINES(IAX ,2,IP) = XYZO
              PTS_LINES(IDIR,1,IP) = -0.5*DTICK
              PTS_LINES(IDIR,2,IP) =  0.5*DTICK
             ENDIF
 505       CONTINUE
C
C--------- save point on axis for annotation number placement
           IF(XYZO .NE. 0.0) THEN
            IN = IN+1
            RNUM_POINT(IN) = XYZO
            IF    (IAX.EQ.1) THEN
             PTS_POINT(1,IN) = XYZO
             PTS_POINT(2,IN) = 0.
             PTS_POINT(3,IN) = -0.5*DTICK - 1.3*CHN/SF
             LOFF(IN) = .FALSE.
            ELSEIF(IAX.EQ.2) THEN
             PTS_POINT(1,IN) = 0.
             PTS_POINT(2,IN) = XYZO
             PTS_POINT(3,IN) = -0.5*DTICK - 1.3*CHN/SF
             LOFF(IN) = .FALSE.
            ELSE
             PTS_POINT(1,IN) = 0.
             PTS_POINT(2,IN) = 0.
             PTS_POINT(3,IN) = XYZO
             LOFF(IN) = .TRUE.
            ENDIF
ccc            ID_LINES(IN) = IAX
            ID_LINES(IN) = 0
           ENDIF
C
         ENDDO
 50    CONTINUE
C
C-----------------------------------
C----- plot axes
       CALL NEWPEN(1)
       CALL GETCOLOR(ICOL0)
       CALL NEWCOLORRGB(0,128,0)
C
       NLINES = IP
       NPROJ = 2*NLINES
       CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
       CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
C

       NPOINT = IN
       CALL VIEWPROJ(PTS_POINT,NPOINT,PTS_PPROJ)
C
       DO IN = 1, NPOINT
         LVIS = .TRUE.
         IF(LHID) THEN
          ID = 0
          NGRP = 0
          IDUM(1) = 0
          DUM(1,1) = 0.
          CALL HIDPNT(PTS_PPROJ(1,IN),ID,NGRP,IDUM,DUM,NTRI,TRI,LVIS)
         ENDIF
C
         RNUM = RNUM_POINT(IN)
         IF(LVIS) CALL PLTFLT(PTS_PPROJ(1,IN),RNUM,CHN,LOFF(IN),-2)
       ENDDO
C
C
C----- plot moment-reference point
       CALL NEWPEN(2)
       CALL NEWCOLORNAME('RED')
       IP = 0
       DO IDIR = 1, 3
         IP = IP+1
         PTS_LINES(1,1,IP) = XYZREF(1)
         PTS_LINES(2,1,IP) = XYZREF(2)
         PTS_LINES(3,1,IP) = XYZREF(3)
         PTS_LINES(IDIR,1,IP) = PTS_LINES(IDIR,1,IP) - 0.7*DTICK
         ID_LINES(IP) = 0
C
         PTS_LINES(1,2,IP) = XYZREF(1)
         PTS_LINES(2,2,IP) = XYZREF(2)
         PTS_LINES(3,2,IP) = XYZREF(3)
         PTS_LINES(IDIR,2,IP) = PTS_LINES(IDIR,2,IP) + 0.7*DTICK
         ID_LINES(IP) = 0
       ENDDO
C
       NLINES = IP
       NPROJ = 2*NLINES
       CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
       CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
C
C
       CALL NEWCOLOR(ICOL0)
      ENDIF
C
C
C---- go over surfaces
      DO 100 N = 1, NSURF
C
C------ do only surfaces which are to be plotted
        IF(.NOT.LPLTSURF(N)) GO TO 100
C
C------ Emphasize panel 'IMARKSURF' with color
        IF(IMARKSURF.EQ.N) THEN
          CALL NEWCOLORNAME('RED')
         ELSE
          CALL NEWCOLOR(ICOL0)
        ENDIF
C
        J1 = JFRST(N)
        JN = JFRST(N) + NJ(N)-1
        JINC = 1
        IF(IMAGS(N).LT.0) THEN
         J1 = JFRST(N) + NJ(N)-1
         JN = JFRST(N)
         JINC = -1
        ENDIF
C
C
C--- Bound vortex legs plotted
        IF(LBOUNDLEG) THEN
         IP = 0
         DO J = J1, JN, JINC
           I1 = IJFRST(J)
           NV = NVSTRP(J)
           DO II = 1, NV
             IV = I1 + II-1
             IP = IP+1
             XAVE = 0.5*(RV1(1,IV) + RV2(1,IV))
             YAVE = 0.5*(RV1(2,IV) + RV2(2,IV))
             ZAVE = 0.5*(RV1(3,IV) + RV2(3,IV))
C
C--- Optionally regress vortex edges slightly for visibility
             REGR = 0.0
             PTS_LINES(1,1,IP) = (1.0-REGR)*(RV1(1,IV) + REGR*XAVE)
             PTS_LINES(2,1,IP) = (1.0-REGR)*(RV1(2,IV) + REGR*YAVE)
             PTS_LINES(3,1,IP) = (1.0-REGR)*(RV1(3,IV) + REGR*ZAVE)
             PTS_LINES(1,2,IP) = (1.0-REGR)*(RV2(1,IV) + REGR*XAVE)
             PTS_LINES(2,2,IP) = (1.0-REGR)*(RV2(2,IV) + REGR*YAVE)
             PTS_LINES(3,2,IP) = (1.0-REGR)*(RV2(3,IV) + REGR*ZAVE)
             ID_LINES(IP) = J
           END DO
         END DO
C
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C 
         CALL GETCOLOR(ICOL)
         CALL NEWCOLORNAME('MAGENTA')
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
         CALL NEWCOLOR(ICOL)
        ENDIF
C
C--- Control points plotted
        IF(LCNTLPTS) THEN
         SCL = 0.01*MIN(CREF,0.5*BREF)
C
         IP = 0
         DO J = J1, JN, JINC
           I1 = IJFRST(J)
           NV = NVSTRP(J)
C--- Define vector on strip plane for control point "x" mark
           SVEC1(1) =  1.0    *SCL
           SVEC1(2) = -ENSZ(J)*SCL
           SVEC1(3) =  ENSY(J)*SCL
           SVEC2(1) = -SVEC1(1)
           SVEC2(2) =  SVEC1(2)
           SVEC2(3) =  SVEC1(3)
           DO II = 1, NV
             IV = I1 + II-1
             IP = IP+1
             PTS_LINES(1,1,IP) = RC(1,IV) - SVEC1(1)  
             PTS_LINES(2,1,IP) = RC(2,IV) - SVEC1(2)  
             PTS_LINES(3,1,IP) = RC(3,IV) - SVEC1(3)  
             PTS_LINES(1,2,IP) = RC(1,IV) + SVEC1(1)  
             PTS_LINES(2,2,IP) = RC(2,IV) + SVEC1(2)  
             PTS_LINES(3,2,IP) = RC(3,IV) + SVEC1(3)  
             ID_LINES(IP) = J
             IP = IP+1
             PTS_LINES(1,1,IP) = RC(1,IV) - SVEC2(1)  
             PTS_LINES(2,1,IP) = RC(2,IV) - SVEC2(2)  
             PTS_LINES(3,1,IP) = RC(3,IV) - SVEC2(3)  
             PTS_LINES(1,2,IP) = RC(1,IV) + SVEC2(1)  
             PTS_LINES(2,2,IP) = RC(2,IV) + SVEC2(2)  
             PTS_LINES(3,2,IP) = RC(3,IV) + SVEC2(3)  
             ID_LINES(IP) = J
           END DO
         END DO
C
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C 
         CALL GETCOLOR(ICOL)
         CALL NEWCOLORNAME('YELLOW')
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
         CALL NEWCOLOR(ICOL)
C
C
         IP = 0
         DO J = J1, JN, JINC
           I1 = IJFRST(J)
           NV = NVSTRP(J)
C--- Define vector on strip plane for control point "x" mark
           SVEC1(1) =  1.0    *SCL
           SVEC1(2) = -ENSZ(J)*SCL
           SVEC1(3) =  ENSY(J)*SCL
           SVEC2(1) = -SVEC1(1)
           SVEC2(2) =  SVEC1(2)
           SVEC2(3) =  SVEC1(3)
           DO II = 1, NV
             IV = I1 + II-1
cc             IF(LVNC(IV)) THEN
              IP = IP+1
              PTS_LINES(1,1,IP) = RV(1,IV) - SVEC1(1)  
              PTS_LINES(2,1,IP) = RV(2,IV) - SVEC1(2)  
              PTS_LINES(3,1,IP) = RV(3,IV) - SVEC1(3)  
              PTS_LINES(1,2,IP) = RV(1,IV) + SVEC1(1)  
              PTS_LINES(2,2,IP) = RV(2,IV) + SVEC1(2)  
              PTS_LINES(3,2,IP) = RV(3,IV) + SVEC1(3)  
              ID_LINES(IP) = J
              IP = IP+1
              PTS_LINES(1,1,IP) = RV(1,IV) - SVEC2(1)  
              PTS_LINES(2,1,IP) = RV(2,IV) - SVEC2(2)  
              PTS_LINES(3,1,IP) = RV(3,IV) - SVEC2(3)  
              PTS_LINES(1,2,IP) = RV(1,IV) + SVEC2(1)  
              PTS_LINES(2,2,IP) = RV(2,IV) + SVEC2(2)  
              PTS_LINES(3,2,IP) = RV(3,IV) + SVEC2(3)  
              ID_LINES(IP) = J
cc             ENDIF
           END DO
         END DO
C
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C 
         CALL GETCOLOR(ICOL)
         CALL NEWCOLORNAME('ORANGE')
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
         CALL NEWCOLOR(ICOL)

        ENDIF
C
C
C--- Chordlines plotted
        IF(LCHORDLINE) THEN
         IP = 0
         DO J = J1, JN, JINC
           IP = IP+1
           PTS_LINES(1,1,IP) = RLE1(1,J)
           PTS_LINES(2,1,IP) = RLE1(2,J)
           PTS_LINES(3,1,IP) = RLE1(3,J)
           PTS_LINES(1,2,IP) = RLE1(1,J) + CHORD1(J)
           PTS_LINES(2,2,IP) = RLE1(2,J)
           PTS_LINES(3,2,IP) = RLE1(3,J)
           ID_LINES(IP) = J
C--- Plot trailing legs back 2.0*BREF if enabled
           IF(LWAKEPLT .AND. LFWAKE(N)) THEN
             IP = IP+1
             PTS_LINES(1,1,IP) = PTS_LINES(1,2,IP-1)
             PTS_LINES(2,1,IP) = PTS_LINES(2,2,IP-1)
             PTS_LINES(3,1,IP) = PTS_LINES(3,2,IP-1)
             PTS_LINES(1,2,IP) = PTS_LINES(1,1,IP) + 2.0*BREF
             PTS_LINES(2,2,IP) = PTS_LINES(2,1,IP)
             PTS_LINES(3,2,IP) = PTS_LINES(3,1,IP)
             ID_LINES(IP) = 0
           ENDIF
         END DO
         IP = IP+1
         PTS_LINES(1,1,IP) = RLE2(1,JN)
         PTS_LINES(2,1,IP) = RLE2(2,JN)
         PTS_LINES(3,1,IP) = RLE2(3,JN)
         PTS_LINES(1,2,IP) = RLE2(1,JN) + CHORD2(JN)
         PTS_LINES(2,2,IP) = RLE2(2,JN)
         PTS_LINES(3,2,IP) = RLE2(3,JN)
         ID_LINES(IP) = JN
C--- Plot trailing legs back 2.0*BREF if enabled
         IF(LWAKEPLT .AND. LFWAKE(N)) THEN
           IP = IP+1
           PTS_LINES(1,1,IP) = PTS_LINES(1,2,IP-1)
           PTS_LINES(2,1,IP) = PTS_LINES(2,2,IP-1)
           PTS_LINES(3,1,IP) = PTS_LINES(3,2,IP-1)
           PTS_LINES(1,2,IP) = PTS_LINES(1,1,IP) + 2.0*BREF
           PTS_LINES(2,2,IP) = PTS_LINES(2,1,IP)
           PTS_LINES(3,2,IP) = PTS_LINES(3,1,IP)
           ID_LINES(IP) = 0
         ENDIF
C
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C--- plot chordlines dashed 
         CALL NEWPAT(lmask2)
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
         CALL NEWPAT(lmask0)
        ENDIF
C
C--- Strip camberline plotted (approx., integrated from camber slopes)
        IF(LCAMBER) THEN
         CALL GETCOLOR(ICOL)
         DO IPASS = 1, 2
           IP = 0
           DO J = J1, JN, JINC
             I1 = IJFRST(J)
             NV = NVSTRP(J)
             XX0 = RLE(1,J)
             YY0 = RLE(2,J)
             ZZ0 = RLE(3,J) + EPS
             DO II = 1, NV
               IV = I1 + II-1
C
               DENT = 0.
               IF(IPASS.EQ.1) THEN
                DO K = 1, NCONTROL
                  DENT = DENT
     &               + 0.5*(ENC_D(1,IV,K) + ENV_D(1,IV,K))*DELCON(K)
                ENDDO
               ENDIF
               ENTOT(1) = 0.5*(ENC(1,IV) + ENV(1,IV)) + DENT
C
               TC = -DXV(IV)*ENTOT(1)
               XX1 = XX0 + DXV(IV)
               YY1 = YY0 + TC*ENSY(J)
               ZZ1 = ZZ0 + TC*ENSZ(J)
C
               IP = IP+1
               PTS_LINES(1,1,IP) = XX0
               PTS_LINES(2,1,IP) = YY0
               PTS_LINES(3,1,IP) = ZZ0
               PTS_LINES(1,2,IP) = XX1
               PTS_LINES(2,2,IP) = YY1
               PTS_LINES(3,2,IP) = ZZ1
               ID_LINES(IP) = 0
C
               XX0 = XX1
               YY0 = YY1
               ZZ0 = ZZ1
             ENDDO
           ENDDO
C
           NLINES = IP
           NPROJ = 2*NLINES
           CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C 
           IF(IPASS.EQ.1) THEN
            CALL NEWCOLORNAME('ORANGE')
           ELSE
            CALL NEWCOLORNAME('CYAN')
           ENDIF
           CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
         ENDDO
         CALL NEWCOLOR(ICOL)
        ENDIF
C
C--- Strip loading plotted
        IF(LLOADPLT) THEN
C 
         CALL GETPEN(IPN)
         CALL GETCOLOR(ICOL)
C
         CALL NEWCOLORNAME('GREEN')
C
C--- Plot the load vectors (up from surface)
         CALL NEWPEN(5)
         IP = 0
         CPSCL = CPFAC*CREF
         DO J = J1, JN, JINC
           I1 = IJFRST(J)
           NV = NVSTRP(J)
           DO II = 1, NV
             IV = I1 + II-1
             IP = IP+1
             XAVE = RV(1,IV)
             YAVE = RV(2,IV)
             ZAVE = RV(3,IV)
             DELYZ = DCP(IV) * CPSCL
             XLOAD = XAVE
             YLOAD = YAVE + DELYZ*ENSY(J) 
             ZLOAD = ZAVE + DELYZ*ENSZ(J)

c             XLOAD = XAVE + DELYZ*ENC(1,IV)
c             YLOAD = YAVE + DELYZ*ENC(2,IV)
c             ZLOAD = ZAVE + DELYZ*ENC(3,IV)
C
             PTS_LINES(1,1,IP) = XAVE
             PTS_LINES(2,1,IP) = YAVE
             PTS_LINES(3,1,IP) = ZAVE
             PTS_LINES(1,2,IP) = XLOAD
             PTS_LINES(2,2,IP) = YLOAD
             PTS_LINES(3,2,IP) = ZLOAD
             ID_LINES(IP) = 0
           END DO
         END DO
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
C
C--- Plot the loading lines 
         CALL NEWPEN(2)
         CALL NEWCOLORNAME('RED')
         IP = 0
         DO J = J1, JN, JINC
           I1 = IJFRST(J)
           NV = NVSTRP(J)
           DO II = 1, NV
             IV = I1 + II-1
             XAVE = RV(1,IV)
             YAVE = RV(2,IV)
             ZAVE = RV(3,IV)
             DELYZ = DCP(IV) * CPSCL
             XLOAD = XAVE
             YLOAD = YAVE + DELYZ*ENSY(J) 
             ZLOAD = ZAVE + DELYZ*ENSZ(J)

c             XLOAD = XAVE + DELYZ*ENC(1,IV) 
c             YLOAD = YAVE + DELYZ*ENC(2,IV) 
c             ZLOAD = ZAVE + DELYZ*ENC(3,IV)

             IF(II.GT.1) THEN
               IP = IP+1
               PTS_LINES(1,1,IP) = XLOADOLD
               PTS_LINES(2,1,IP) = YLOADOLD
               PTS_LINES(3,1,IP) = ZLOADOLD
               PTS_LINES(1,2,IP) = XLOAD
               PTS_LINES(2,2,IP) = YLOAD
               PTS_LINES(3,2,IP) = ZLOAD
               ID_LINES(IP) = 0
             ENDIF             
             XLOADOLD = XLOAD
             YLOADOLD = YLOAD
             ZLOADOLD = ZLOAD
           END DO
         END DO
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
         CALL NEWCOLOR(ICOL)
         CALL NEWPEN(IPN)
        ENDIF
C
C
C--- Surface boundary lines plotted
        IP = 0
        IP = IP+1
        PTS_LINES(1,1,IP) = RLE1(1,J1)
        PTS_LINES(2,1,IP) = RLE1(2,J1)
        PTS_LINES(3,1,IP) = RLE1(3,J1)
        PTS_LINES(1,2,IP) = RLE1(1,J1) + CHORD1(J1)
        PTS_LINES(2,2,IP) = RLE1(2,J1)
        PTS_LINES(3,2,IP) = RLE1(3,J1)
        ID_LINES(IP) = J1
C--- Plot trailing legs back 2.0*BREF if enabled and exist
        IF(LWAKEPLT .AND. LFWAKE(N)) THEN
          IP = IP+1
          PTS_LINES(1,1,IP) = PTS_LINES(1,2,IP-1)
          PTS_LINES(2,1,IP) = PTS_LINES(2,2,IP-1)
          PTS_LINES(3,1,IP) = PTS_LINES(3,2,IP-1)
          PTS_LINES(1,2,IP) = PTS_LINES(1,1,IP) + 2.0*BREF
          PTS_LINES(2,2,IP) = PTS_LINES(2,1,IP)
          PTS_LINES(3,2,IP) = PTS_LINES(3,1,IP)
          ID_LINES(IP) = 0
        ENDIF
C
        IP = IP+1
        PTS_LINES(1,1,IP) = RLE2(1,JN)
        PTS_LINES(2,1,IP) = RLE2(2,JN)
        PTS_LINES(3,1,IP) = RLE2(3,JN)
        PTS_LINES(1,2,IP) = RLE2(1,JN) + CHORD2(JN)
        PTS_LINES(2,2,IP) = RLE2(2,JN)
        PTS_LINES(3,2,IP) = RLE2(3,JN)
        ID_LINES(IP) = JN
C--- Plot trailing legs back 2.0*BREF if enabled and exist
        IF(LWAKEPLT .AND. LFWAKE(N)) THEN
          IP = IP+1
          PTS_LINES(1,1,IP) = PTS_LINES(1,2,IP-1)
          PTS_LINES(2,1,IP) = PTS_LINES(2,2,IP-1)
          PTS_LINES(3,1,IP) = PTS_LINES(3,2,IP-1)
          PTS_LINES(1,2,IP) = PTS_LINES(1,1,IP) + 2.0*BREF
          PTS_LINES(2,2,IP) = PTS_LINES(2,1,IP)
          PTS_LINES(3,2,IP) = PTS_LINES(3,1,IP)
          ID_LINES(IP) = 0
        ENDIF
C
        DO J = J1, JN, JINC
          IP = IP+1
          PTS_LINES(1,1,IP) = RLE1(1,J)
          PTS_LINES(2,1,IP) = RLE1(2,J)
          PTS_LINES(3,1,IP) = RLE1(3,J)
          PTS_LINES(1,2,IP) = RLE2(1,J)
          PTS_LINES(2,2,IP) = RLE2(2,J)
          PTS_LINES(3,2,IP) = RLE2(3,J)
          ID_LINES(IP) = J
          IP = IP+1
          PTS_LINES(1,1,IP) = RLE1(1,J) + CHORD1(J)
          PTS_LINES(2,1,IP) = RLE1(2,J)
          PTS_LINES(3,1,IP) = RLE1(3,J)
          PTS_LINES(1,2,IP) = RLE2(1,J) + CHORD2(J)
          PTS_LINES(2,2,IP) = RLE2(2,J)
          PTS_LINES(3,2,IP) = RLE2(3,J)
          ID_LINES(IP) = J
        END DO
C
        NLINES = IP
        NPROJ = 2*NLINES
        CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
        CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
C
C
C*************************************************************************
C---Now do any labels (integer indices for surfaces,strips or vortices)
C
C---Surface labels
        IF(LABEL_SURF) THEN
          JMID = JFRST(N) + IFIX(0.5*FLOAT(NJ(N))) - 1
          PLAB(1) = RLE(1,JMID) + 0.6*CHORD(JMID)
          PLAB(2) = RLE(2,JMID)
          PLAB(3) = RLE(3,JMID)
          CALL VIEWPROJ(PLAB,1,PTS_LPROJ)
          ID = JMID
          LVIS=.TRUE.
          IF(LHID) THEN
            NGRP = 0
            IDUM(1) = 0
            DUM(1,1) = 0.
            CALL HIDPNT(PTS_LPROJ,ID,NGRP,IDUM,DUM,NTRI,TRI,LVIS)
          ENDIF
          ILAB = N
          IF (LVIS) CALL PLTINT(PTS_LPROJ,ILAB,1.5*CHSIZE,.FALSE.)
        ENDIF
C
C---Strip labels
        IF(LABEL_STRP) THEN
          NGRP = 0
          IDUM(1) = 0
          DUM(1,1) = 0.
          CALL GETPEN(IPN)
          CALL NEWPEN(1)
          CALL GETCOLOR(ICOL)
          CALL NEWCOLORNAME('CYAN')
          DO J = J1, JN, JINC
            PLAB(1) = RLE(1,J) + 0.4*CHORD(J)
            PLAB(2) = RLE(2,J)
            PLAB(3) = RLE(3,J)
            CALL VIEWPROJ(PLAB,1,PTS_LPROJ)
            ID = J
            LVIS=.TRUE.
            IF(LHID) THEN
              CALL HIDPNT(PTS_LPROJ,ID,NGRP,IDUM,DUM,NTRI,TRI,LVIS)
            ENDIF
            ILAB = J
            IF(LVIS) CALL PLTINT(PTS_LPROJ,ILAB,1.2*CHSIZE,.FALSE.)
          END DO
          CALL NEWPEN(IPN)
          CALL NEWCOLOR(ICOL)
        ENDIF
C
C---Vortex labels
        IF(LABEL_VRTX) THEN
          NGRP = 0
          IDUM(1) = 0
          DUM(1,1) = 0.
          CALL GETPEN(IPN)
          CALL NEWPEN(1)
          CALL GETCOLOR(ICOL)
          CALL NEWCOLORNAME('RED')
          DO J = J1, JN, JINC
            I1 = IJFRST(J)
            NV = NVSTRP(J)
            DO II = 1, NV
              IV = I1 + II-1
              IP = IP+1
              XAVE = RV(1,IV)
              YAVE = RV(2,IV)
              ZAVE = RV(3,IV)
              PLAB(1) = 0.5*(XAVE+RC(1,IV))
              PLAB(2) = 0.5*(YAVE+RC(2,IV))
              PLAB(3) = 0.5*(ZAVE+RC(3,IV))
              CALL VIEWPROJ(PLAB,1,PTS_LPROJ)
              ID = J
              LVIS=.TRUE.
              IF(LHID) THEN
                CALL HIDPNT(PTS_LPROJ,ID,NGRP,IDUM,DUM,NTRI,TRI,LVIS)
              ENDIF
              ILAB = IV
              IF(LVIS) CALL PLTINT(PTS_LPROJ,ILAB,CHSIZE,.FALSE.)
            END DO
          END DO
          CALL NEWPEN(IPN)
          CALL NEWCOLOR(ICOL)
        ENDIF
C
 100  CONTINUE
C

      IF(LNRMLPLT) THEN
      DO IPASS = 1, 2
C
      CALL GETCOLOR(ICOL)
      IF(IPASS.EQ.1) THEN
C----- with control deflections
       CALL NEWCOLORNAME('ORANGE')
      ELSE
C----- without control deflections
       CALL NEWCOLORNAME('BLUE')
      ENDIF
C
C---- go over surfaces again
      DO 200 N = 1, NSURF
C
C------ do only surfaces which are to be plotted
        IF(.NOT.LPLTSURF(N)) GO TO 200
C
        J1 = JFRST(N)
        JN = JFRST(N) + NJ(N)-1
        JINC = 1
        IF(IMAGS(N).LT.0) THEN
         J1 = JFRST(N) + NJ(N)-1
         JN = JFRST(N)
         JINC = -1
        ENDIF
C
C----- Normal vectors plotted
        SCL = ENFAC*CREF
C
        IP = 0
        DO J = J1, JN, JINC
          I1 = IJFRST(J)
          NV = NVSTRP(J)
          DO II = 1, NV
            IV = I1 + II-1
C
            ENTOT(1) = ENC(1,IV)
            ENTOT(2) = ENC(2,IV)
            ENTOT(3) = ENC(3,IV)
            IF(IPASS.EQ.1) THEN
             DO K = 1, NCONTROL
               ENTOT(1) = ENTOT(1) + ENC_D(1,IV,K)*DELCON(K)
               ENTOT(2) = ENTOT(2) + ENC_D(2,IV,K)*DELCON(K)
               ENTOT(3) = ENTOT(3) + ENC_D(3,IV,K)*DELCON(K)
             ENDDO
            ENDIF
C
C-- Define vector from control point in direction of normal vector 
            SVEC1(1) = ENTOT(1) * SCL
            SVEC1(2) = ENTOT(2) * SCL
            SVEC1(3) = ENTOT(3) * SCL
            SVEC2(1) = 0.02*SCL
            SVEC2(2) = 0.0
            SVEC2(3) = 0.0
C-- Vector out from control point
            IP = IP+1
            PTS_LINES(1,1,IP) = RC(1,IV)
            PTS_LINES(2,1,IP) = RC(2,IV)
            PTS_LINES(3,1,IP) = RC(3,IV)
            PTS_LINES(1,2,IP) = RC(1,IV) + SVEC1(1)  
            PTS_LINES(2,2,IP) = RC(2,IV) + SVEC1(2)  
            PTS_LINES(3,2,IP) = RC(3,IV) + SVEC1(3)  
            ID_LINES(IP) = 0
C-- Arrow head for normal vector
            IP = IP+1
            PTS_LINES(1,1,IP) = RC(1,IV) + SVEC1(1)  
            PTS_LINES(2,1,IP) = RC(2,IV) + SVEC1(2)  
            PTS_LINES(3,1,IP) = RC(3,IV) + SVEC1(3)  
            PTS_LINES(1,2,IP) = RC(1,IV) + 0.8*SVEC1(1) + SVEC2(1) 
            PTS_LINES(2,2,IP) = RC(2,IV) + 0.8*SVEC1(2) + SVEC2(2) 
            PTS_LINES(3,2,IP) = RC(3,IV) + 0.8*SVEC1(3) + SVEC2(3)  
            ID_LINES(IP) = 0
            IP = IP+1
            PTS_LINES(1,1,IP) = RC(1,IV) + SVEC1(1)  
            PTS_LINES(2,1,IP) = RC(2,IV) + SVEC1(2)  
            PTS_LINES(3,1,IP) = RC(3,IV) + SVEC1(3)  
            PTS_LINES(1,2,IP) = RC(1,IV) + 0.8*SVEC1(1) - SVEC2(1) 
            PTS_LINES(2,2,IP) = RC(2,IV) + 0.8*SVEC1(2) - SVEC2(2) 
            PTS_LINES(3,2,IP) = RC(3,IV) + 0.8*SVEC1(3) - SVEC2(3)  
            ID_LINES(IP) = 0
          END DO
        END DO
        NLINES = IP
        NPROJ = 2*NLINES
        CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C
        CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
 200  CONTINUE
C
      CALL NEWCOLOR(ICOL)
      ENDDO
      ENDIF
C
C
C---- go over bodies
      DO 300 N = 1, NBODY
C
C------ do only bodies which are to be plotted
        IF(.NOT.LPLTBODY(N)) GO TO 300
C
        L1 = LFRST(N)
        LN = LFRST(N) + NL(N)-1
        LINC = 1
C
C------ source lines plotted
        IP = 0
        DO L = L1, LN-LINC, LINC
          IP = IP+1
          PTS_LINES(1,1,IP) = RL(1,L)
          PTS_LINES(2,1,IP) = RL(2,L)
          PTS_LINES(3,1,IP) = RL(3,L)
          PTS_LINES(1,2,IP) = RL(1,L+LINC)
          PTS_LINES(2,2,IP) = RL(2,L+LINC)
          PTS_LINES(3,2,IP) = RL(3,L+LINC)
          ID_LINES(IP) = 0
        END DO
C
        NLINES = IP
        NPROJ = 2*NLINES
        CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
C
        CALL GETCOLOR(ICOL)
        CALL NEWCOLORNAME('MAGENTA')
        CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
        CALL NEWCOLOR(ICOL)
C
C
C------ Chordlines plotted
ccc        IF(LCHORDLINE) THEN
         IP = 0
         DO L = L1, LN, LINC
C--------- set "horizontal" and "vertical" body section unit vectors
           IF(LINC.GT.0) THEN
            LM = MAX(L-1,L1)
            LP = MIN(L+1,LN)
           ELSE
            LM = MAX(L-1,LN)
            LP = MIN(L+1,L1)
           ENDIF
           DXL = RL(1,LP) - RL(1,LM)
           DYL = RL(2,LP) - RL(2,LM)
           DZL = RL(3,LP) - RL(3,LM)
           DSL = SQRT(DXL**2 + DYL**2 + DZL**2)
           IF(DSL.NE.0.0) THEN
            DXL = DXL/DSL
            DYL = DYL/DSL
            DZL = DZL/DSL
           ENDIF
C     
           UHX = -DYL
           UHY =  DXL
           UHZ = 0.
C
           UVX = DYL*UHZ - DZL*UHY
           UVY = DZL*UHX - DXL*UHZ
           UVZ = DXL*UHY - DYL*UHX
C
           DO K = 1, KK
             THK1 = 2.0*PI*FLOAT(K-1)/FLOAT(KK)
             THK2 = 2.0*PI*FLOAT(K  )/FLOAT(KK)
C
             HX1 = UHX*COS(THK1)
             HY1 = UHY*COS(THK1)
             HZ1 = UHZ*COS(THK1)
C
             VX1 = UVX*SIN(THK1)
             VY1 = UVY*SIN(THK1)
             VZ1 = UVZ*SIN(THK1)
C
             HX2 = UHX*COS(THK2)
             HY2 = UHY*COS(THK2)
             HZ2 = UHZ*COS(THK2)
C
             VX2 = UVX*SIN(THK2)
             VY2 = UVY*SIN(THK2)
             VZ2 = UVZ*SIN(THK2)
C
             IP = IP+1
             PTS_LINES(1,1,IP) = RL(1,L) + HX1*RADL(L) + VX1*RADL(L)
             PTS_LINES(2,1,IP) = RL(2,L) + HY1*RADL(L) + VY1*RADL(L)
             PTS_LINES(3,1,IP) = RL(3,L) + HZ1*RADL(L) + VZ1*RADL(L)
             PTS_LINES(1,2,IP) = RL(1,L) + HX2*RADL(L) + VX2*RADL(L)
             PTS_LINES(2,2,IP) = RL(2,L) + HY2*RADL(L) + VY2*RADL(L)
             PTS_LINES(3,2,IP) = RL(3,L) + HZ2*RADL(L) + VZ2*RADL(L)
             ID_LINES(IP) = 0
           ENDDO
         END DO
C
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
ccc        ENDIF
C
C------ source line loading plotted
        IF(LLOADPLT) THEN
C 
         CALL GETPEN(IPN)
         CALL GETCOLOR(ICOL)
C
         CALL NEWCOLORNAME('GREEN')
C
C--- Plot the load vectors (up from surface)
         CALL NEWPEN(5)
         IP = 0
         CPSCL = CPFAC*CREF
         DO L = L1, LN
           IP = IP+1
           XAVE = 0.5*(RL(1,L) + RL(1,L+1))
           YAVE = 0.5*(RL(2,L) + RL(2,L+1))
           ZAVE = 0.5*(RL(3,L) + RL(3,L+1))
           XLOAD = XAVE + DCPB(1,L) * CPSCL
           YLOAD = YAVE + DCPB(2,L) * CPSCL
           ZLOAD = ZAVE + DCPB(3,L) * CPSCL
C
           PTS_LINES(1,1,IP) = XAVE
           PTS_LINES(2,1,IP) = YAVE
           PTS_LINES(3,1,IP) = ZAVE
           PTS_LINES(1,2,IP) = XLOAD
           PTS_LINES(2,2,IP) = YLOAD
           PTS_LINES(3,2,IP) = ZLOAD
           ID_LINES(IP) = 0
         END DO
         NLINES = IP
         NPROJ = 2*NLINES
         CALL VIEWPROJ(PTS_LINES,NPROJ,PTS_LPROJ)
         CALL PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
C---Bugfix 8/8/08 HHY
         CALL NEWPEN(IPN)
         CALL NEWCOLOR(ICOL)
C
        ENDIF
C
C
C*************************************************************************
C---Now do any labels (integer indices for surfaces,strips or vortices)
C
C--- Body labels
        IF(LABEL_BODY) THEN
          JMID = JFRST(N) + IFIX(0.5*FLOAT(NJ(N))) - 1
          PLAB(1) = RLE(1,JMID) + 0.6*CHORD(JMID)
          PLAB(2) = RLE(2,JMID)
          PLAB(3) = RLE(3,JMID)
          CALL VIEWPROJ(PLAB,1,PTS_LPROJ)
          ID = JMID
          LVIS=.TRUE.
          IF(LHID) THEN
            NGRP = 0
            IDUM(1) = 0
            DUM(1,1) = 0.
            CALL HIDPNT(PTS_LPROJ,ID,NGRP,IDUM,DUM,NTRI,TRI,LVIS)
          ENDIF
          ILAB = N
          IF (LVIS) CALL PLTINT(PTS_LPROJ,ILAB,1.5*CHSIZE,.FALSE.)
        ENDIF
C
 300  CONTINUE
C
      RETURN
      END ! PLOTGEOM


      SUBROUTINE PLOTLINES(NLINES,PTS_LPROJ,ID_LINES)
C...PURPOSE:    Plot line segments with hidden line 
C               routine.
C
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      REAL PTS_LPROJ(3,2,*), ID_LINES(*)
C
      PARAMETER (NVX=32)
      REAL ALF(2,NVX)
C
      INTEGER IDUM(1)
      REAL DUM(1,1)
C
      ALF(1,1) = 0.0
      ALF(2,1) = 1.0
      NALF = 1
C
      DO L=1, NLINES
C-----  Check for hidden line treatment
        IF(LHID) THEN
          NALF = NVX
          NGRP = 0
          ID = ID_LINES(L)
          IDUM(1) = 0
          DUM(1,1) = 0.0
          CALL HIDLIN(PTS_LPROJ(1,1,L),ID,NGRP,IDUM,DUM,
     &                NTRI,TRI,NALF,ALF)
        ENDIF

C-----  If any of the line segment is visible, plot the visible pieces
        IF(NALF.GT.0) CALL PLTSEG(PTS_LPROJ(1,1,L),ALF,NALF)
      END DO
C
      RETURN
      END ! PLOTLINES

C***********************************************************************
C    Module:  ainput.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE INPUT(LUN,FNAME,FERR)
C---------------------------------------------------------
C     Reads an processes an AVL configuration input file
C---------------------------------------------------------
      INCLUDE 'AVL.INC'
C
      CHARACTER*(*) FNAME
      LOGICAL FERR
C
      CHARACTER*4  KEYWD
      CHARACTER*80 CNAME, ANAME
      CHARACTER*128 LINE
      LOGICAL LDUPL, LHINGE
C
      REAL CLX(3), CDX(3)
      REAL XYZSCAL(3), XYZTRAN(3)
C
      PARAMETER (NWRK=NSMAX, IBX=300)
      REAL XYZLES(3,NWRK),CHORDS(NWRK),AINCS(NWRK),SSPACES(NWRK),
     &     BRADY(NWRK), BRADZ(NWRK), CLAF(NWRK)
      INTEGER NSPANS(NWRK), NASEC(NWRK)
      REAL XASEC(IBX,NWRK), SASEC(IBX,NWRK), TASEC(IBX,NWRK)
      REAL CLCDSRF(6)
      REAL CLCDSEC(6,NWRK)
C
      REAL XB(IBX), YB(IBX)
      REAL XIN(IBX), YIN(IBX), TIN(IBX)
      REAL XBOD(IBX), YBOD(IBX), TBOD(IBX)
C
C---- max number of control or design variable declaration lines per section
      PARAMETER (ICONX = 20)
C
      INTEGER ICONTD(ICONX,NWRK),
     &        NSCON(NWRK),
     &        IDESTD(ICONX,NWRK),
     &        NSDES(NWRK)
C
      REAL XHINGED(ICONX,NWRK), 
     &     VHINGED(3,ICONX,NWRK), 
     &     GAIND(ICONX,NWRK),
     &     REFLD(ICONX,NWRK),
     &     GAING(ICONX,NWRK)
C
C
      REAL    RINPUT(10)
      INTEGER IINPUT(10)
      LOGICAL ERROR
C
C----------------------------------------------------
      FERR = .FALSE.
C
      OPEN(UNIT=LUN,FILE=FNAME,STATUS='OLD',ERR=3)
      GO TO 6
C
 3    CONTINUE
      CALL STRIP(FNAME,NFN)
      WRITE(*,*) 
      WRITE(*,*) '** Open error on file: ', FNAME(1:NFN)
      FNAME = FNAME(1:NFN) // '.avl'
      WRITE(*,*) '   Trying alternative: ', FNAME(1:NFN+4)
      OPEN(UNIT=LUN,FILE=FNAME,STATUS='OLD',ERR=4)
      GO TO 6
C
 4    CONTINUE
      CALL STRIP(FNAME,NFN)
      WRITE(*,*) 
      WRITE(*,*) '** Open error on file: ', FNAME(1:NFN)
      FERR = .TRUE.
      RETURN
C
C----------------------------------------------------
 6    CONTINUE
      CALL STRIP(FNAME,NFN)
      WRITE(*,*) 
      WRITE(*,*) 'Reading file: ', FNAME(1:NFN), '  ...'
C
      DCL_A0 = 0.
      DCM_A0 = 0.
      DCL_U0 = 0.
      DCM_U0 = 0.
C
C---- initialize all entity counters
      NSEC = 0
C
      NSURF = 0
      NVOR = 0
      NSTRIP = 0
C
      NBODY = 0
      NLNODE = 0
C
      NCONTROL = 0
      NDESIGN = 0
C---- clear surface polar data
      DO L=1, 6
        CLCDSRF(L) = 0.0
      END DO
C
      LVISC  = .FALSE.
C
C---- initialize counters and active-entity indicators
      ISURF = 0
      IBODY = 0
C
C---- initialize input-file line counter
      ILINE = 0
C
C------------------------------------------------------------------------------
C---- start reading file
C
C---------------------------------------------------
      CALL RDLINE(LUN,LINE,NLINE,ILINE)
      TITLE = LINE(1:NLINE)
C
      WRITE(*,1001) TITLE(1:60)
 1001 FORMAT(/' Configuration: ', A)
C
C
C---------------------------------------------------
      CALL RDLINE(LUN,LINE,NLINE,ILINE)
      READ (LINE,*,ERR=990) MACH0
C
C---------------------------------------------------
      CALL RDLINE(LUN,LINE,NLINE,ILINE)
      READ (LINE,*,ERR=990) IYSYM, IZSYM, ZSYM
C
C---- y-symmetry plane hard-wired at y=0
      YSYM = 0.
C
      IF(IYSYM.GT.0) IYSYM =  1
      IF(IYSYM.LT.0) IYSYM = -1
      IF(IZSYM.GT.0) IZSYM =  1
      IF(IZSYM.LT.0) IZSYM = -1
C
C---------------------------------------------------
      CALL RDLINE(LUN,LINE,NLINE,ILINE)
      READ (LINE,*,ERR=990) SREF,CREF,BREF
C
      IF(SREF .LE. 0.) SREF = 1.
      IF(CREF .LE. 0.) CREF = 1.
      IF(BREF .LE. 0.) BREF = 1.
C
C---------------------------------------------------
      CALL RDLINE(LUN,LINE,NLINE,ILINE)
      READ (LINE,*,ERR=990) XYZREF0(1), XYZREF0(2), XYZREF0(3)
C
C---------------------------------------------------
C---- try to read CD data which may or may not be present
      CALL RDLINE(LUN,LINE,NLINE,ILINE)
      READ (LINE,*,ERR=8) CDREF0
C
C---- drag data was read OK... just keep going
      GO TO 10
C
 8    CONTINUE
C---- read error occurred (drag data wasn't present)...
C      ... interpret the line as keyword
      CDREF0 = 0.
      GO TO 11
C
C==============================================================================
C---- start of keyword-interpretation loop
 10   CONTINUE
      CALL RDLINE(LUN,LINE,NLINE,ILINE)
C
 11   CONTINUE
      KEYWD = LINE(1:4)
      CALL TOUPER(KEYWD)
C
C===========================================================================
      IF    (KEYWD.EQ.'EOF ') THEN
C------ end of file... clean up loose ends
C
        IF(ISURF.NE.0) THEN
C------- "old" surface is still active, so build it before finishing
         CALL MAKESURF(ISURF, IBX,NSEC, 
     &       NVC, CSPACE, NVS, SSPACE,
     &       XYZSCAL,XYZTRAN,ADDINC,
     &       XYZLES,CHORDS,AINCS,SSPACES,NSPANS,
     &       XASEC,SASEC,TASEC,NASEC,
     &       CLCDSEC,CLAF,
     &       ICONX, 
     &       ICONTD,NSCON,GAIND,XHINGED,VHINGED,REFLD,
     &       IDESTD,NSDES,GAING )
C
         IF(LDUPL) THEN
          CALL SDUPL(ISURF,YDUPL,'YDUP')
         ENDIF
C
         ISURF = 0
        ENDIF
C
        IF(IBODY.NE.0) THEN
C------- "old" body is still active, so build it before finishing
         CALL MAKEBODY(IBODY, IBX,
     &       NVB, BSPACE,
     &       XYZSCAL,XYZTRAN,
     &       XBOD,YBOD,TBOD,NBOD)
C
         IF(LDUPL) THEN
          CALL BDUPL(IBODY,YDUPL,'YDUP')
         ENDIF
C
         IBODY = 0
        ENDIF
C
C------ go finish up
        GO TO 900
C
C===========================================================================
      ELSEIF(KEYWD.EQ.'SURF') THEN
C------ new surface is about to start
C
        IF(ISURF.NE.0) THEN
C------- "old" surface is still active, so build it before starting new one
         CALL MAKESURF(ISURF, IBX,NSEC, 
     &       NVC, CSPACE, NVS, SSPACE,
     &       XYZSCAL,XYZTRAN,ADDINC,
     &       XYZLES,CHORDS,AINCS,SSPACES,NSPANS,
     &       XASEC,SASEC,TASEC,NASEC,
     &       CLCDSEC,CLAF,
     &       ICONX, 
     &       ICONTD,NSCON,GAIND,XHINGED,VHINGED,REFLD,
     &       IDESTD,NSDES,GAING )
C
         IF(LDUPL) THEN
          CALL SDUPL(ISURF,YDUPL,'YDUP')
         ENDIF
C
         ISURF = 0
        ENDIF
C
        IF(IBODY.NE.0) THEN
C------- "old" body is still active, so build it before finishing
         CALL MAKEBODY(IBODY, IBX,
     &       NVB, BSPACE,
     &       XYZSCAL,XYZTRAN,
     &       XBOD,YBOD,TBOD,NBOD)
C
         IF(LDUPL) THEN
          CALL BDUPL(IBODY,YDUPL,'YDUP')
         ENDIF
C
         IBODY = 0
        ENDIF
C
C------ new surface  (ISURF.ne.0 denotes surface accumulation is active)
        NSURF = NSURF + 1
        ISURF = MIN( NSURF , NSMAX )
C
C------ default surface component index is just the surface number
        LSCOMP(ISURF) = ISURF
C
C------ clear indices for accumulation
        NSEC = 0
        ISEC = 0
C
C------ set surface defaults
        LDUPL  = .FALSE.   
        LHINGE = .FALSE.

C------ assume this will be a conventional loaded surface
        LFWAKE(ISURF) = .TRUE.
        LFALBE(ISURF) = .TRUE.
        LFLOAD(ISURF) = .TRUE.

        XYZSCAL(1) = 1.0
        XYZSCAL(2) = 1.0
        XYZSCAL(3) = 1.0
        XYZTRAN(1) = 0.
        XYZTRAN(2) = 0.
        XYZTRAN(3) = 0.
        ADDINC = 0.
C---- clear surface polar data before starting new surface
        DO L=1, 6
          CLCDSRF(L) = 0.0
        END DO
C
        NCVAR = 0
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        STITLE(ISURF) = LINE(1:NLINE)
        WRITE(*,*)
        WRITE(*,*) '  Building surface: ', STITLE(ISURF)
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        NINPUT = 4
        CALL GETFLT(LINE,RINPUT,NINPUT,ERROR)
        IF(ERROR .OR. NINPUT.LT.2) GO TO 990
C
        NVC = INT( RINPUT(1) + 0.001 )
        CSPACE = RINPUT(2)
C
        IF(NINPUT.GE.4) THEN
         NVS = INT( RINPUT(3) + 0.001 )
         SSPACE = RINPUT(4)
        ELSE
         NVS = 0
         SSPACE = 0.0
        ENDIF
C
C===========================================================================
      ELSEIF(KEYWD.EQ.'BODY') THEN
C------ new body is about to start
C
        IF(ISURF.NE.0) THEN
C------- "old" surface is still active, so build it before starting new one
         CALL MAKESURF(ISURF, IBX,NSEC, 
     &       NVC, CSPACE, NVS, SSPACE,
     &       XYZSCAL,XYZTRAN,ADDINC,
     &       XYZLES,CHORDS,AINCS,SSPACES,NSPANS,
     &       XASEC,SASEC,TASEC,NASEC,
     &       CLCDSEC,CLAF,
     &       ICONX, 
     &       ICONTD,NSCON,GAIND,XHINGED,VHINGED,REFLD,
     &       IDESTD,NSDES,GAING )
C
         IF(LDUPL) THEN
          CALL SDUPL(ISURF,YDUPL,'YDUP')
         ENDIF
C
         ISURF = 0
        ENDIF
C
        IF(IBODY.NE.0) THEN
C------- "old" body is still active, so build it before finishing
         CALL MAKEBODY(IBODY, IBX,
     &       NVB, BSPACE,
     &       XYZSCAL,XYZTRAN,
     &       XBOD,YBOD,TBOD,NBOD)
C
         IF(LDUPL) THEN
          CALL BDUPL(IBODY,YDUPL,'YDUP')
         ENDIF
C
         IBODY = 0
        ENDIF
C
C------ new body  (IBODY.ne.0 denotes body accumulation is active)
        NBODY = NBODY + 1
        IBODY = MIN( NBODY , NBMAX )
C
        NSEC = 0
        ISEC = 0
        NBOD = 0
C
        NIN = 0
C
        LDUPL  = .FALSE.
C
        XYZSCAL(1) = 1.0
        XYZSCAL(2) = 1.0
        XYZSCAL(3) = 1.0
        XYZTRAN(1) = 0.
        XYZTRAN(2) = 0.
        XYZTRAN(3) = 0.
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        BTITLE(IBODY) = LINE(1:NLINE)
        WRITE(*,*)
        WRITE(*,*) '  Building body: ', BTITLE(IBODY)
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        READ(LINE,*,ERR=990) NVB, BSPACE
C
C===========================================================================
      ELSEIF(KEYWD.EQ.'YDUP') THEN
C------ this surface is to be duplicated with an image surface
        IF    (ISURF.NE.0) THEN
CC         WRITE(*,*) '  + duplicate surface ',STITLE(ISURF)
        ELSEIF(IBODY.NE.0) THEN
CC         WRITE(*,*) '  + duplicate body ',BTITLE(IBODY)
        ELSE
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active surface or body to duplicate'
         GO TO 10
        ENDIF
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        READ (LINE,*,ERR=990) YDUPL
C
        LDUPL = .TRUE.
C
        IF(IYSYM.NE.0 .AND. YDUPL.EQ.0.0) THEN
         WRITE(*,*) 'ERROR: Redundant y-symmetry specifications...'
         WRITE(*,*) '       IYSYM /= 0'
         WRITE(*,*) '       YDUPLICATE  0.0'
         WRITE(*,*) 'Can use one or the other, but not both.'
         STOP
        ENDIF
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'INDE' .OR. KEYWD.EQ.'COMP') THEN
C------ set component index for surface (may be lumped together)
        IF(ISURF.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active surface for component index'
         GO TO 10
        ENDIF
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        READ (LINE,*,ERR=990) LSCOMP(ISURF)
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'SCAL') THEN
C------ read scaling factors
        IF(ISURF.EQ.0 .AND. IBODY.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active surface or body for scaling'
         GO TO 10
        ENDIF
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        READ (LINE,*,ERR=990) XYZSCAL(1), XYZSCAL(2), XYZSCAL(3)
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'TRAN') THEN
C------ read translation vector
        IF(ISURF.EQ.0 .AND. IBODY.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active surface or body for translation'
         GO TO 10
        ENDIF
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        READ (LINE,*,ERR=990) XYZTRAN(1), XYZTRAN(2), XYZTRAN(3)
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'ANGL' .OR. KEYWD.EQ.'AINC') THEN
C------ read surface incidence angle change
        IF(ISURF.EQ.0 .AND. IBODY.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active surface or body for added incid.'
         GO TO 10
        ENDIF
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        READ (LINE,*,ERR=990) ADDINC
        ADDINC = ADDINC*DTR
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'NOWA') THEN
C------ disable wake shedding for this surface
        IF(ISURF.EQ.0) THEN
         WRITE(*,9000)'** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)   '** No active surface for wake-shedding flag'
         GO TO 10
        ENDIF
C
        LFWAKE(ISURF) = .FALSE.

C===========================================================================
      ELSEIF (KEYWD.EQ.'NOAL') THEN
C------ disable freestream angles for this surface
        IF(ISURF.EQ.0) THEN
         WRITE(*,9000)'** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)   '** No active surface for freestream-angles flag'
         GO TO 10
        ENDIF
C
        LFALBE(ISURF) = .FALSE.

C===========================================================================
      ELSEIF (KEYWD.EQ.'NOLO') THEN
C------ disable total-load contributions for this surface
        IF(ISURF.EQ.0) THEN
         WRITE(*,9000)'** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)   '** No active surface for load-disable flag'
         GO TO 10
        ENDIF
C
        LFLOAD(ISURF) = .FALSE.

C===========================================================================
      ELSEIF (KEYWD.EQ.'BSEC') THEN
C------ read body section
C
        IF(IBODY.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active body for this section'
         GO TO 10
        ENDIF
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
C
C------ store section data for current body
        NSEC = NSEC + 1
        ISEC = MIN( NSEC , NWRK )
C
        NINPUT = 5
        CALL GETFLT(LINE,RINPUT,NINPUT,ERROR)
        IF(ERROR .OR. NINPUT.LT.4) GO TO 990
C
        XYZLES(1,ISEC) = RINPUT(1)
        XYZLES(2,ISEC) = RINPUT(2)
        XYZLES(3,ISEC) = RINPUT(3)
        BRADY(ISEC) = RINPUT(4)
C
        IF(NINPUT.GE.5) THEN
         BRADZ(ISEC) = RINPUT(5)
        ELSE
         BRADZ(ISEC) = BRADY(ISEC)
        ENDIF
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'SECT') THEN
C------ read surface section
C
        IF(ISURF.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active surface for this section'
         GO TO 10
        ENDIF
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
C
C------ store section data for current surface
        NSEC = NSEC + 1
        ISEC = MIN( NSEC , NWRK )
C
        NINPUT = 7
        CALL GETFLT(LINE,RINPUT,NINPUT,ERROR)
        IF(ERROR .OR. NINPUT.LT.5) GO TO 990
C
        XYZLES(1,ISEC) = RINPUT(1)
        XYZLES(2,ISEC) = RINPUT(2)
        XYZLES(3,ISEC) = RINPUT(3)
        CHORDS(ISEC) = RINPUT(4)
        AINCS(ISEC)  = RINPUT(5)*DTR
C
        IF(NINPUT.GE.7) THEN
         NSPANS(ISEC) = INT( RINPUT(6) + 0.001 )
         SSPACES(ISEC) = RINPUT(7)
        ELSE
         NSPANS(ISEC) = 0
         SSPACES(ISEC) = 0.
        ENDIF
C
C------ default section...
C    ...flat camberline
        NASEC(ISEC)   = 2
        XASEC(1,ISEC) = 0.0
        XASEC(2,ISEC) = 1.0
        SASEC(1,ISEC)  = 0.0
        SASEC(2,ISEC)  = 0.0
        TASEC(1,ISEC)  = 0.0
        TASEC(2,ISEC)  = 0.0
C    ...copy polar data from surface polar (if specified)
        DO L=1, 6
          CLCDSEC(L,ISEC) = CLCDSRF(L)
        END DO
C    ...no control
        NSCON(ISEC) = 0
C    ...no design
        NSDES(ISEC) = 0
C
C    ...unity dCL/da factor
        CLAF(ISEC) = 1.0
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'NACA') THEN 
C------ input NACA camberline
C
        IF(ISURF.EQ.0 .OR. ISEC.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active section for this airfoil'
         GO TO 10
        ENDIF
C
C------ find blank (if any) after keyword
        IB = INDEX(LINE(1:NLINE),' ')

        IF(IB.EQ.0 .OR. IB.GE.NLINE-2) THEN
C------- default airfoil x/c limits are the whole airfoil
         XFMIN = 0.
         XFMAX = 1.
        ELSE
C------- read optional airfoil x/c limits
         NINPUT = 2
         CALL GETFLT(LINE(IB:NLINE),RINPUT,NINPUT,ERROR)
         IF(ERROR .OR. NINPUT.LT.2) THEN
          XFMIN = 0.
          XFMAX = 1.
         ELSE
          XFMIN = MAX( 0.0 , RINPUT(1) )
          XFMAX = MIN( 1.0 , RINPUT(2) )
         ENDIF
        ENDIF
C
C------ read NACA 4-digit designator
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        READ(LINE,*,ERR=990) IDES

C------ parse designator and set camber coordinates
        ICAM = IDES/1000
        IPOS = (IDES-1000*ICAM)/100
        ITHK =  IDES-1000*ICAM-100*IPOS
        C = FLOAT(ICAM) / 100.0
        P = FLOAT(IPOS) / 10.0
        T = FLOAT(ITHK) / 100.0
C
        NASEC(ISEC) = MIN( 50 , IBX )
        DO I = 1, NASEC(ISEC)
          XF = XFMIN + (XFMAX-XFMIN)*FLOAT(I-1)/FLOAT(NASEC(ISEC)-1)

          XASEC(I,ISEC) = XF
          TASEC(I,ISEC) = 
     &        (   0.29690*SQRT(XF)
     &          - 0.12600*XF
     &          - 0.35160*XF**2
     &          + 0.28430*XF**3
     &          - 0.10150*XF**4  ) * T * 10.0
          IF    (XF .LT. P) THEN
           SASEC(I,ISEC) = C * 2.0*(P - XF) / P**2
          ELSEIF(XF .GE. P) THEN
           SASEC(I,ISEC) = C * 2.0*(P - XF) / (1.0-P)**2
          ELSE
           SASEC(I,ISEC) = 0.
          ENDIF
        ENDDO

        CALL NRMLIZ(NASEC(ISEC),XASEC(1,ISEC))
C
C===========================================================================
      ELSE IF (KEYWD.EQ.'AIRF') THEN 
C------ input y(x) for an airfoil, get camber then slopes via spline
C
        IF(ISURF.EQ.0 .OR. ISEC.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active section for this airfoil'
         GO TO 10
        ENDIF

C------ find blank (if any) after keyword
        IB = INDEX(LINE(1:NLINE),' ')

        IF(IB.EQ.0 .OR. IB.GE.NLINE-2) THEN
C------- default airfoil x/c limits are the whole airfoil
         XFMIN = 0.
         XFMAX = 1.
        ELSE
C------- read optional airfoil x/c limits
         NINPUT = 2
         CALL GETFLT(LINE(IB:NLINE),RINPUT,NINPUT,ERROR)
         IF(ERROR .OR. NINPUT.LT.2) THEN
          XFMIN = 0.
          XFMAX = 1.
         ELSE
          XFMIN = MAX( 0.0 , RINPUT(1) )
          XFMAX = MIN( 1.0 , RINPUT(2) )
         ENDIF
        ENDIF

C------ read airfoil coordinates
        DO I = 1, 123456
          IB = MIN(I,IBX)
C
          CALL RDLINE(LUN,LINE,NLINE,ILINE)
          NINPUT = 2
          CALL GETFLT(LINE,RINPUT,NINPUT,ERROR)
          IF(ERROR .OR. NINPUT.LT.2) THEN
           NB = IB-1
           GO TO 40
          ELSE
           XB(IB) = RINPUT(1)
           YB(IB) = RINPUT(2)
          ENDIF
        ENDDO
C
 40     CONTINUE
        IF(I.GT.IBX) THEN
         WRITE(*,*) 
     &    '*** AINPUT: Airfoil array overflow.  Increase IBX to', I
         STOP
        ENDIF
C
C------ set camber and thickness, normalized to unit chord
        NIN = MIN( 50 , IBX )
        CALL GETCAM(XB,YB,NB,XIN,YIN,TIN,NIN,.TRUE.)
C
C------ store airfoil only if surface and section are active
        NASEC(ISEC) = NIN
        DO I = 1, NIN
          XF = XFMIN + (XFMAX-XFMIN)*FLOAT(I-1)/FLOAT(NASEC(ISEC)-1)
          XASEC(I,ISEC) = XIN(1) + XF*(XIN(NIN)-XIN(1))
          CALL AKIMA(XIN,YIN,NIN,XASEC(I,ISEC),DUMMY,SASEC(I,ISEC))
          CALL AKIMA(XIN,TIN,NIN,XASEC(I,ISEC),TASEC(I,ISEC),DUMMY)
        END DO
        CALL NRMLIZ(NASEC(ISEC),XASEC(1,ISEC))
C
C------ go to top of keyword-reading loop, with last-read line
        GO TO 11
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'AFIL') THEN 
C------ input y(x) from an airfoil coordinate file
C
        IF(ISURF.EQ.0 .OR. ISEC.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active section for this airfoil'
         GO TO 10
        ENDIF

C------ find blank (if any) after keyword
        IB = INDEX(LINE(1:NLINE),' ')

        IF(IB.EQ.0 .OR. IB.GE.NLINE-2) THEN
C------- default airfoil x/c limits are the whole airfoil
         XFMIN = 0.
         XFMAX = 1.
        ELSE
C------- read optional airfoil x/c limits
         NINPUT = 2
         CALL GETFLT(LINE(IB:NLINE),RINPUT,NINPUT,ERROR)
         IF(ERROR .OR. NINPUT.LT.2) THEN
          XFMIN = 0.
          XFMAX = 1.
         ELSE
          XFMIN = MAX( 0.0 , RINPUT(1) )
          XFMAX = MIN( 1.0 , RINPUT(2) )
         ENDIF
        ENDIF

C------ read filename
        CALL RDLINE(LUN,LINE,NLINE,ILINE)

C------ parse file name
C       double quotes checked to delimit file name to allow blanks in name 
        IDQ1 = INDEX(LINE,'"')
        IF(IDQ1.NE.0) THEN
         IDQ2 = INDEX(LINE(IDQ1+1:),'"')
         IF(IDQ2.GT.1) THEN 
          CNAME = LINE(IDQ1+1:IDQ2+IDQ1-1)
         ELSE
          WRITE(*,9000) '** Bad quotes in file name ',ILINE,
     &                  LINE(1:NLINE)
          GO TO 10
         ENDIF

        ELSE
         CNAME = LINE

        ENDIF
C
        CALL STRIP(CNAME,NCN)
        WRITE(*,*) '    Reading airfoil from file: ',CNAME(1:NCN)
        NBLDS = 1
        CALL READBL(CNAME,IBX,NBLDS,XB,YB,NB,NBL,
     &               ANAME,XINL,XOUT,YBOT,YTOP)
C
        IF(NBL.EQ.0) THEN
         WRITE(*,*) '**   Airfoil file not found  : ',CNAME(1:NCN)
         WRITE(*,*) '**   Using default zero-camber airfoil'
C
         NASEC(ISEC) = MIN( 50 , IBX )
         DO I = 1, NASEC(ISEC)
          XASEC(I,ISEC) = FLOAT(I-1)/FLOAT(NASEC(ISEC)-1)
          SASEC(I,ISEC) = 0.0
          TASEC(I,ISEC) = 0.0
         ENDDO
C
        ELSE
C------- camber and thickness
         NIN = MIN( 50 , IBX )
         CALL GETCAM(XB,YB,NB,XIN,YIN,TIN,NIN,.TRUE.)
C
C------- camberline slopes at specified locations from spline
         NASEC(ISEC) = NIN
         DO I = 1, NIN
           XF = XFMIN + (XFMAX-XFMIN)*FLOAT(I-1)/FLOAT(NASEC(ISEC)-1)
           XASEC(I,ISEC) = XIN(1) + XF*(XIN(NIN)-XIN(1))
           CALL AKIMA(XIN,YIN,NIN,XASEC(I,ISEC),DUMMY,SASEC(I,ISEC))
           CALL AKIMA(XIN,TIN,NIN,XASEC(I,ISEC),TASEC(I,ISEC),DUMMY)
         END DO
         CALL NRMLIZ (NASEC(ISEC),XASEC(1,ISEC))
        ENDIF
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'BFIL') THEN 
C------ input r(x) from an airfoil coordinate file
C
        IF(IBODY.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active body for this shape'
         GO TO 10
        ENDIF
C
C------ find blank (if any) after keyword
        IB = INDEX(LINE(1:NLINE),' ')

        IF(IB.EQ.0 .OR. IB.GE.NLINE-2) THEN
C------- default x/c limits are the whole airfoil
         XFMIN = 0.
         XFMAX = 1.
        ELSE
C------- read optional x/c limits
         NINPUT = 2
         CALL GETFLT(LINE(IB:NLINE),RINPUT,NINPUT,ERROR)
         IF(ERROR .OR. NINPUT.LT.2) THEN
          XFMIN = 0.
          XFMAX = 1.
         ELSE
          XFMIN = MAX( 0.0 , RINPUT(1) )
          XFMAX = MIN( 1.0 , RINPUT(2) )
         ENDIF
        ENDIF

        CALL RDLINE(LUN,LINE,NLINE,ILINE)

C---- parse file name and optional parameters
C     double quotes checked to delimit file name to allow blanks in name 
        IDQ1 = INDEX(LINE,'"')
        IF(IDQ1.NE.0) THEN
         IDQ2 = INDEX(LINE(IDQ1+1:),'"')
         IF(IDQ2.GT.1) THEN 
           CNAME = LINE(IDQ1+1:IDQ2+IDQ1-1)
           IB = IDQ2 + IDQ1 + 1
         ELSE
           WRITE(*,9000) '** Bad quotes in file name ',ILINE,
     &                   LINE(1:NLINE)
           GO TO 10
         ENDIF
        ELSE
         CNAME = LINE

        ENDIF


        CALL STRIP(CNAME,NCN)
        WRITE(*,*) '    Reading body shape from file: ',CNAME(1:NCN)
        NBLDS = 1
        CALL READBL(CNAME,IBX,NBLDS,XB,YB,NB,NBL,
     &               ANAME,XINL,XOUT,YBOT,YTOP)
C
C------ set thread line y, and thickness t ( = 2r)
        NBOD = MIN( 50 , IBX )
        CALL GETCAM(XB,YB,NB,XBOD,YBOD,TBOD,NBOD,.FALSE.)
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'CDCL') THEN 
C------ input approximate CD(CL) polar defining data
C
        IF(ISURF.EQ.0 .AND. ISEC.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active surface or section for this polar'
         GO TO 10
        ENDIF
C
C------ if defining surface before sections store polar for surface
        IF(ISURF.NE.0 .AND. ISEC.EQ.0) THEN
         WRITE(*,*)    '** Polar data for surface (all sections)'

        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        READ(LINE,*,ERR=990) CLX(1),CDX(1),CLX(2),CDX(2),CLX(3),CDX(3)
C
        LMAX = 1
        LMIN = 1
        DO L = 2, 3 
          IF(CLX(L).GT.CLX(LMAX)) LMAX = L
          IF(CLX(L).LT.CLX(LMIN)) LMIN = L
        END DO
C
C------ Trick: sum must be 6 so we can get the "other" index
         LMID = 6 - (LMIN+LMAX)
         CLCDSRF(1) = CLX(LMIN)
         CLCDSRF(2) = CDX(LMIN)
         CLCDSRF(3) = CLX(LMID)
         CLCDSRF(4) = CDX(LMID)
         CLCDSRF(5) = CLX(LMAX)
         CLCDSRF(6) = CDX(LMAX)
         WRITE(*,1700) CLX(LMIN),CDX(LMIN),
     &                 CLX(LMID),CDX(LMID),
     &                 CLX(LMAX),CDX(LMAX)
 1700    FORMAT('    Reading CD(CL) data for surface',
     &         /'     CLneg    = ',F8.3,'  CD@CLneg = ',F10.5,
     &         /'     CL@CDmin = ',F8.3,'  CDmin    = ',F10.5,
     &         /'     CLpos    = ',F8.3,'  CD@CLpos = ',F10.5)
         LVISC = .TRUE.
C
C------ define polar for the current active section
        ELSEIF(ISURF.NE.0 .AND. ISEC.NE.0) THEN
C
         CALL RDLINE(LUN,LINE,NLINE,ILINE)
         READ(LINE,*,ERR=990) CLX(1),CDX(1),CLX(2),CDX(2),CLX(3),CDX(3)
C
         LMAX = 1
         LMIN = 1
         DO L = 2, 3 
           IF(CLX(L).GT.CLX(LMAX)) LMAX = L
           IF(CLX(L).LT.CLX(LMIN)) LMIN = L
         END DO
C
         IF(ISEC.GT.1) THEN
          IF(CLCDSEC(4,ISEC-1).LE.0.0) THEN
           WRITE(*,*) '* AINPUT: previous section defined with no polar' 
          ENDIF
         ENDIF
C
C------ Trick: sum must be 6 so we can get the "other" index
         LMID = 6 - (LMIN+LMAX)
         CLCDSEC(1,ISEC) = CLX(LMIN)
         CLCDSEC(2,ISEC) = CDX(LMIN)
         CLCDSEC(3,ISEC) = CLX(LMID)
         CLCDSEC(4,ISEC) = CDX(LMID)
         CLCDSEC(5,ISEC) = CLX(LMAX)
         CLCDSEC(6,ISEC) = CDX(LMAX)
         WRITE(*,1701) CLX(LMIN),CDX(LMIN),
     &                CLX(LMID),CDX(LMID),
     &                CLX(LMAX),CDX(LMAX)
 1701    FORMAT('    Reading CD(CL) data for section',
     &         /'     CLneg    = ',F8.3,'  CD@CLneg = ',F10.5,
     &         /'     CL@CDmin = ',F8.3,'  CDmin    = ',F10.5,
     &         /'     CLpos    = ',F8.3,'  CD@CLpos = ',F10.5)
         LVISC = .TRUE.
C
        ENDIF
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'CLAF') THEN 
C------ input dCL/da scaling factor
C
        IF(ISURF.EQ.0 .OR. ISEC.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active section for dCL/da factor'
         GO TO 10
        ENDIF

        CALL RDLINE(LUN,LINE,NLINE,ILINE)
        READ(LINE,*,ERR=990) CLAF(ISEC)
C
        IF(CLAF(ISEC) .LE. 0.0 .OR. 
     &     CLAF(ISEC) .GE. 2.0      ) THEN
         WRITE(*,*) '** dCL/da factor must be in the range 0..2 --',
     &              ' Setting factor to 1.0'
         CLAF(ISEC) = 1.0
        ENDIF
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'CONT') THEN
C------ link section to control variables
C
        IF(ISURF.EQ.0 .OR. ISEC.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active section for this control'
         GO TO 10
        ENDIF
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
C
C
C------ increment control-declaration counter for this section
        NSCON(ISEC) = NSCON(ISEC) + 1
        ISCON = MIN( NSCON(ISEC) , ICONX )
C
C------ extract control name
        NNAME = INDEX(LINE,' ') - 1
        IF(NNAME.LE.0) THEN
         WRITE(*,*) '** Bad control declaration line:  ', LINE
         STOP
        ENDIF
C
C------ see if this control variable has already been declared
        DO N = 1, NCONTROL
          IF(LINE(1:NNAME) .EQ. DNAME(N)(1:NNAME)) THEN
           ICONTROL = N
           GO TO 62
          ENDIF
        ENDDO
C
C------ new control variable... assign slot for it
        NCONTROL = NCONTROL + 1
        ICONTROL = MIN( NCONTROL , NDMAX )
        DNAME(ICONTROL) = LINE(1:NNAME)
C
 62     CONTINUE
        ICONTD(ISCON,ISEC) = ICONTROL
C
C------ read numbers after control variable name
        NINPUT = 6
        CALL GETFLT(LINE(NNAME+1:120),RINPUT,NINPUT,ERROR)
        IF(ERROR) THEN
         WRITE(*,*) '*** Bad control data line:  ', LINE
         STOP
        ENDIF
C
        IF(NINPUT.LT.1) THEN
         GAIND(ISCON,ISEC) = 1.0
        ELSE
         GAIND(ISCON,ISEC) = RINPUT(1)
        ENDIF
C
        IF(NINPUT.LT.2) THEN
         XHINGED(ISCON,ISEC) = 0.0
        ELSE
         XHINGED(ISCON,ISEC) = RINPUT(2)
        ENDIF
C
        IF(NINPUT.LT.5) THEN
         VHINGED(1,ISCON,ISEC) = 0.0
         VHINGED(2,ISCON,ISEC) = 0.0
         VHINGED(3,ISCON,ISEC) = 0.0
        ELSE
         VHINGED(1,ISCON,ISEC) = RINPUT(3)
         VHINGED(2,ISCON,ISEC) = RINPUT(4)
         VHINGED(3,ISCON,ISEC) = RINPUT(5)
        ENDIF
C
        IF(NINPUT.LT.6) THEN
         REFLD(ISCON,ISEC) = 1.0
        ELSE
         REFLD(ISCON,ISEC) = RINPUT(6)
        ENDIF
C
C===========================================================================
      ELSEIF (KEYWD.EQ.'DESI') THEN 
C------ link section to design variable and weight
C
        IF(ISURF.EQ.0 .OR. ISEC.EQ.0) THEN
         WRITE(*,9000) '** Misplaced line', ILINE, LINE(1:NLINE)
         WRITE(*,*)    '** No active section for this design var.'
         GO TO 10
        ENDIF
C
        CALL RDLINE(LUN,LINE,NLINE,ILINE)
C
C------ increment design-declaration counter for this section
        NSDES(ISEC) = NSDES(ISEC) + 1
        ISDES = MIN( NSDES(ISEC) , ICONX )
C
C------ extract design name
        NNAME = INDEX(LINE,' ') - 1
        IF(NNAME.LE.0) THEN
         WRITE(*,9000) '   *** Bad design declaration line', 
     &                  ILINE, LINE(1:NLINE)
         STOP
        ENDIF
C
C------ see if this control variable has already been declared
        DO K = 1, NDESIGN
          IF(LINE(1:NNAME) .EQ. GNAME(K)(1:NNAME)) THEN
           IDESIGN = K
           GO TO 72
          ENDIF
        ENDDO
C
        NDESIGN = NDESIGN + 1
        IDESIGN = MIN( NDESIGN , NGMAX )
        GNAME(IDESIGN) = LINE(1:NNAME)
C
 72     CONTINUE
        IDESTD(ISDES,ISEC) = IDESIGN
C
C------ read numbers after control variable name
        NINPUT = 1
        CALL GETFLT(LINE(NNAME+1:120),RINPUT,NINPUT,ERROR)
        IF(ERROR) GO TO 990
C
        IF(NINPUT.LT.1) THEN
         GAING(ISDES,ISEC) = 1.0
        ELSE
         GAING(ISDES,ISEC) = RINPUT(1)
        ENDIF
C
C===========================================================================
      ELSE
C------ line not recognized or unassignable ... keep reading file
        WRITE(*,8000) ILINE, LINE(1:NLINE)
 8000   FORMAT('  * Line',I5,' ignored: ', A)
C
      ENDIF
      GO TO 10
C
C===========================================================================
C---- normal end-of-file exit point
 900  CONTINUE
      CLOSE(UNIT=LUN)
C
C*********************************************************************
C
      WRITE (*,2018) MACH0,NBODY,NSURF,NSTRIP,NVOR
      WRITE (*,2019) NCONTROL,NDESIGN
C
      IF(IYSYM.GT.0) WRITE (*,2024) YSYM
      IF(IYSYM.LT.0) WRITE (*,2025) YSYM
      IF(IZSYM.GT.0) WRITE (*,2026) ZSYM
      IF(IZSYM.LT.0) WRITE (*,2027) ZSYM
C
 2018 FORMAT (/' Mach =',F10.4,'  (default)'
     &       //1X,I4,' Bodies'
     &        /1X,I4,' Solid surfaces'
     &        /1X,I4,' Strips'
     &        /1X,I4,' Vortices')
 2019 FORMAT (/1X,I4,' Control variables'
     &        /1X,I4,' Design parameters')

 2024 FORMAT (/' Y Symmetry: Wall plane   at Ysym =',F10.4)
 2025 FORMAT (/' Y Symmetry: Free surface at Ysym =',F10.4)
 2026 FORMAT (/' Z Symmetry: Ground plane at Zsym =',F10.4)
 2027 FORMAT (/' Z Symmetry: Free surface at Zsym =',F10.4)
C
      LGEO = .TRUE.
      RETURN
C
C*********************************************************************
 990  CONTINUE
      WRITE(*,9000) '** Read error on line', ILINE, LINE(1:NLINE)
      FERR = .TRUE.
      RETURN
C
 9000 FORMAT(/ 1X,A,I5,' ...' / 1X,A)
      END ! INPUT





      SUBROUTINE RDLINE(LUN,LINE,NLINE,ILINE)
C-----------------------------------------------------------------------
C     Reads next non-comment line from logical unit LU
C     Strips off leading blanks
C     Ignores everything after and including "!"
C
C     LINE returns the line
C     NLINE returns the number of characters in non-blank portion
C
C     If e.o.f. is reached, LINE returns 'EOF'
C     If read error occurs, LINE returns 'ERR'
C-----------------------------------------------------------------------
      CHARACTER*(*) LINE
C
 1000 FORMAT(A)
   20 READ (LUN,1000,END=80,ERR=90) LINE
      ILINE = ILINE + 1
C
C---- skip comment line
      IF(INDEX('!#',LINE(1:1)) .NE. 0) GO TO 20
C
C---- skip blank line
      IF(LINE.EQ.' ') GO TO 20
C
C---- strip off leading blanks and do normal return after significant line
      CALL STRIP(LINE,NLINE)
      KEXL = INDEX(LINE(1:NLINE),'!')
      IF(KEXL.GT.1) NLINE = KEXL-1
      RETURN
C
   80 LINE = 'EOF '
      RETURN
C
   90 LINE = 'ERR '
      RETURN
      END


      SUBROUTINE TOUPER(INPUT)
      CHARACTER*(*) INPUT
C
      CHARACTER*26 LCASE, UCASE
      DATA LCASE / 'abcdefghijklmnopqrstuvwxyz' /
      DATA UCASE / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
C
      N = LEN(INPUT)
C
      DO 10 I=1, N
        K = INDEX( LCASE , INPUT(I:I) )
        IF(K.GT.0) INPUT(I:I) = UCASE(K:K)
 10   CONTINUE
C
      RETURN
      END 

C***********************************************************************
C    Module:  aic.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************


      SUBROUTINE VVOR(BETM,IYSYM,YSYM,IZSYM,ZSYM,VRCORE,
     &     NV,RV1,RV2,NSURFV,CHORDV,
     &     NC,RC ,    NSURFC,LVTEST,
     &     WC_GAM,NCDIM)
C--------------------------------------------------------------------
C     Calculates the velocity influence matrix for a collection 
C     of horseshoe vortices and control points
C     
C Input
C -----
C     BETM      SQRT(1-MACH*MACH)
C     IYSYM     Plane of symmetry XZ 
C                = 0 no symmetry
C                = 1 regular symmetry
C                =-1 free-surface symmetry
C     YSYM      Y coordinate of symmetry plane
C     IZSYM     Second plane of symmetry XY 
C                = 0 no second plane
C                = 1 regular symmetry
C                =-1 free-surface symmetry
C     ZSYM      Z coordinate of symmetry plane
C
C     VRCORE    vortex-line core radius / max(semichord,vortex width)
C
C     NV        number of vortices
C     RV1(3,v)  coordinates of endpoint #1 of the vortices
C     RV2(3,v)  coordinates of endpoint #2 of the vortices
C     NSURFV(v) index of surface containing h.v.
C     CHORDV(v) chord of strip containing h.v.
C
C     NC        number of control points
C     RC(3,c)   coordinates of the control points
C     NSURFC(c) index of surface containing c.p.
C     LVTEST    T if core-radius test is to be applied
C
C     NCDIM     declared size of WC_GAM matrix
C     
C Output
C ------
C     WC_GAM(3..)   Induced-velocity/gamma influence matrix
C     
C--------------------------------------------------------------------
      REAL RV1(3,NV),
     &     RV2(3,NV),
     &     CHORDV(NV)
      REAL RC(3,NC),
     &     WC_GAM(3,NCDIM,*)
      INTEGER NSURFV(NV), NSURFC(NC)
      LOGICAL LVTEST
C     
      LOGICAL LBOUND
C     
C     
      FYSYM = FLOAT(IYSYM)
      FZSYM = FLOAT(IZSYM)
C     
C...  Nested pair of loops to calculate the normalwash influence matrix
C     the outer loop runs over all the control points
C     the inner loop runs over all the vortex elements 
C     
      DO 200 I = 1, NC
C...  Control point location
         X = RC(1,I)
         Y = RC(2,I)
         Z = RC(3,I)
C     
         U = 0.
         V = 0.
         W = 0.
C     
         DO 100 J = 1, NV
C--------- set vortex core
            DSYZ = SQRT(  (RV2(2,J)-RV1(2,J))**2
     &                  + (RV2(3,J)-RV1(3,J))**2 )
            IF(NSURFC(I) .EQ. NSURFV(J)) THEN
             RCORE = 0.0001*DSYZ
            ELSE
             RCORE = MAX( VRCORE*CHORDV(J) , 2.0*VRCORE*DSYZ )
cc             RCORE = VRCORE*DSYZ
            ENDIF
C     
            UI = 0.0
            VI = 0.0
            WI = 0.0
C     
            YOFF = 2.0* YSYM
            ZOFF = 2.0* ZSYM
CCC   ZOFF = 2.0*(ZSYM + ALFA*0.5*(RV1(1,J)+RV2(1,J)) )
C     
C...  Calculate the influence of the REAL vortex

            LBOUND = .NOT.(LVTEST .AND. I.EQ.J)
            CALL VORVELC(X,Y,Z,LBOUND,
     &           RV1(1,J),RV1(2,J),RV1(3,J),
     &           RV2(1,J),RV2(2,J),RV2(3,J),
     &           BETM,U,V,W,RCORE)
C     
            IF(IYSYM.NE.0) THEN
C...  Calculate the influence of the y-IMAGE vortex
               LBOUND = .TRUE.
C...  For sym/asym matrices check for vortex midpoints of image vortices
               IF(IYSYM.EQ.1) THEN
                  XAVE =        0.5*(RV1(1,J)+RV2(1,J))
                  YAVE = YOFF - 0.5*(RV1(2,J)+RV2(2,J))
                  ZAVE =        0.5*(RV1(3,J)+RV2(3,J))
                  IF(X.EQ.XAVE .AND. 
     &               Y.EQ.YAVE .AND.
     &               Z.EQ.ZAVE       ) LBOUND = .FALSE.
ccc   IF(.NOT.LBOUND) write(*,*) 'POS self vortex i,j ',i,j
               ENDIF

               CALL VORVELC(X,Y,Z,LBOUND,
     &              RV2(1,J),YOFF-RV2(2,J),RV2(3,J),
     &              RV1(1,J),YOFF-RV1(2,J),RV1(3,J),
     &              BETM,UI,VI,WI,RCORE)

c               CALL VORVEL(X,Y,Z,LBOUND,
c     &              RV2(1,J),YOFF-RV2(2,J),RV2(3,J),
c     &              RV1(1,J),YOFF-RV1(2,J),RV1(3,J),
c     &              BETM,UI,VI,WI)

               UI = UI*FYSYM
               VI = VI*FYSYM
               WI = WI*FYSYM 
            ENDIF
C     
            IF(IZSYM.NE.0) THEN
C...  Calculate the influence of the z-IMAGE vortex
               LBOUND = .TRUE.
               CALL VORVELC(X,Y,Z,LBOUND,
     &              RV2(1,J),RV2(2,J),ZOFF-RV2(3,J),
     &              RV1(1,J),RV1(2,J),ZOFF-RV1(3,J),
     &              BETM,UII,VII,WII,RCORE)
               U = U + UII*FZSYM
               V = V + VII*FZSYM
               W = W + WII*FZSYM
C     
C...  Calculate the influence of the y,z-IMAGE vortex
               IF(IYSYM.NE.0) THEN
                  LBOUND = .TRUE.
                  CALL VORVELC(X,Y,Z,LBOUND,
     &                 RV1(1,J),YOFF-RV1(2,J),ZOFF-RV1(3,J),
     &                 RV2(1,J),YOFF-RV2(2,J),ZOFF-RV2(3,J),
     &                 BETM,UII,VII,WII,RCORE)
C     
                  UI = UI + UII*FYSYM*FZSYM
                  VI = VI + VII*FYSYM*FZSYM
                  WI = WI + WII*FYSYM*FZSYM
               ENDIF
            ENDIF
C     
            US = U + UI
            VS = V + VI
            WS = W + WI
C     
            WC_GAM(1,I,J) = US
            WC_GAM(2,I,J) = VS
            WC_GAM(3,I,J) = WS
C     
 100     CONTINUE

 200  CONTINUE
C     
      RETURN
      END



      SUBROUTINE VSRD(BETM,IYSYM,YSYM,IZSYM,ZSYM,SRCORE,
     &                NBODY,LFRST,NLDIM,
     &                NL,RL,RADL,
     &                NU,SRC_U,DBL_U,
     &                NC,RC,
     &                WC_U,NCDIM)
C--------------------------------------------------------------------
C     Calculates the velocity influence matrix for a collection 
C     of source+doublet lines
C     
C Input
C -----
C       BETM     SQRT(1-MACH*MACH)
C       IYSYM    Plane of symmetry XZ 
C                 = 0 no symmetry
C                 = 1 regular symmetry
C                 =-1 free-surface symmetry
C       YSYM     Y coordinate of symmetry plane
C       IZSYM    Second plane of symmetry XY 
C                 = 0 no second plane
C                 = 1 regular symmetry
C                 =-1 free-surface symmetry
C       ZSYM     Z coordinate of symmetry plane
C
C       SRCORE   source-line core radius / body radius
C
C       NBODY      number of bodies
C       LFRST(b)   index of first node in body b
C       NLDIM      size of SRC_U, DBL_U matrices
C       NL(b)      number of source-line nodes in each body
C       RL(3,b)    source-line node
C       RADL(b)    body radius at node
C
C       NU         number of apparent-freestream components
C       SRC_U(u)   source  strength per unit freestream component
C       DBL_U(3,u) doublet strength per unit freestream component
C
C       NC        number of control points
C       RC(3,c)   control point node where velocity is evaluated
C
C       NCDIM      size of WC matrix
C          
C Output
C ------
C       WC_U(3,c,u)  velocity per unit freestream
C
C--------------------------------------------------------------------
      INTEGER LFRST(*),NL(*)
      REAL RL(3,*), RADL(*)
      REAL SRC_U(NLDIM,*), DBL_U(3,NLDIM,*),
     &     RC(3,NCDIM),
     &     WC_U(3,NCDIM,*)
C
C
      REAL VSRC(3), VDBL(3,3)
      DATA PI / 3.14159265 /
C
      FYSYM = FLOAT(IYSYM)
      FZSYM = FLOAT(IZSYM)
C
      YOFF = 2.0* YSYM
      ZOFF = 2.0* ZSYM
CCC   ZOFF = 2.0*(ZSYM + ALFA*0.5*(RV1(1,J)+RV2(1,J)) )
C
      DO I = 1, NC
        DO IU = 1, NU
          WC_U(1,I,IU) = 0.
          WC_U(2,I,IU) = 0.
          WC_U(3,I,IU) = 0.
        ENDDO
      ENDDO
C
C
      DO 10 IBODY = 1, NBODY
        DO 105 ILSEG = 1, NL(IBODY)-1
          L1 = LFRST(IBODY) + ILSEG - 1
          L2 = LFRST(IBODY) + ILSEG
C
          L = L1
C
          RAVG = SQRT(0.5*(RADL(L2)**2 + RADL(L1)**2))
          RCORE = SRCORE*RAVG
C
          DO I = 1, NC
C------------------------------------------------------------
C---------- influence of real segment
            CALL SRDVELC(RC(1,I) ,RC(2,I) ,RC(3,I) ,
     &                   RL(1,L1),RL(2,L1),RL(3,L1),
     &                   RL(1,L2),RL(2,L2),RL(3,L2),
     &                   BETM,RCORE,
     &                   VSRC,VDBL  )
            DO IU = 1, NU
              DO K = 1, 3
                WC_U(K,I,IU) = WC_U(K,I,IU)
     &               + VSRC(K)*SRC_U(L,IU)
     &               + VDBL(K,1)*DBL_U(1,L,IU)
     &               + VDBL(K,2)*DBL_U(2,L,IU)
     &               + VDBL(K,3)*DBL_U(3,L,IU)
              ENDDO
            ENDDO
C
C------------------------------------------------------------
            IF (IYSYM.NE.0) THEN
C----------- influence of y-image
             CALL SRDVELC(RC(1,I) ,     RC(2,I) ,RC(3,I) ,
     &                    RL(1,L1),YOFF-RL(2,L1),RL(3,L1),
     &                    RL(1,L2),YOFF-RL(2,L2),RL(3,L2),
     &                    BETM,RCORE,
     &                    VSRC,VDBL  )
             DO IU = 1, NU
               DO K = 1, 3
                 WC_U(K,I,IU) = WC_U(K,I,IU)
     &                + VSRC(K)*SRC_U(L,IU)
     &                + VDBL(K,1)*DBL_U(1,L,IU)
     &                - VDBL(K,2)*DBL_U(2,L,IU)
     &                + VDBL(K,3)*DBL_U(3,L,IU)
               ENDDO
             ENDDO
            ENDIF
C
C------------------------------------------------------------
            IF (IZSYM.NE.0) THEN
C----------- influence of z-image
             CALL SRDVELC(RC(1,I) ,RC(2,I) ,     RC(3,I) ,
     &                    RL(1,L1),RL(2,L1),ZOFF-RL(3,L1),
     &                    RL(1,L2),RL(2,L2),ZOFF-RL(3,L2),
     &                    BETM,RCORE,
     &                    VSRC,VDBL  )
             DO IU = 1, NU
               DO K = 1, 3
                 WC_U(K,I,IU) = WC_U(K,I,IU)
     &                + VSRC(K)*SRC_U(L,IU)
     &                + VDBL(K,1)*DBL_U(1,L,IU)
     &                + VDBL(K,2)*DBL_U(2,L,IU)
     &                - VDBL(K,3)*DBL_U(3,L,IU)
               ENDDO
             ENDDO

C------------------------------------------------------------
             IF (IYSYM.NE.0) THEN
C------------ influence of z-image
              CALL SRDVELC(RC(1,I) ,     RC(2,I) ,     RC(3,I) ,
     &                     RL(1,L1),YOFF-RL(2,L1),ZOFF-RL(3,L1),
     &                     RL(1,L2),YOFF-RL(2,L2),ZOFF-RL(3,L2),
     &                     BETM,RCORE,
     &                     VSRC,VDBL  )
              DO IU = 1, NU
                DO K = 1, 3
                  WC_U(K,I,IU) = WC_U(K,I,IU)
     &                 + VSRC(K)*SRC_U(L,IU)
     &                 + VDBL(K,1)*DBL_U(1,L,IU)
     &                 - VDBL(K,2)*DBL_U(2,L,IU)
     &                 - VDBL(K,3)*DBL_U(3,L,IU)
                ENDDO
              ENDDO
             ENDIF
            ENDIF
C
          ENDDO
C
 105    CONTINUE
 10   CONTINUE
C
      RETURN
      END ! VSRD



      SUBROUTINE SRDSET(BETM,XYZREF,
     &                  NBODY,LFRST,NLDIM,
     &                  NL,RL,RADL,
     &                  SRC_U,DBL_U )
C----------------------------------------------------------
C     Sets strengths of source+doublet line segments
C     for each unit freestream and rotation component
C
C Input
C -----
C       BETM     SQRT(1-MACH*MACH)
C
C       NBODY      number of bodies
C       LFRST(b)   index of first node in body b
C       NLDIM      size of SRC_U, DBL_U matrices
C       NL(b)      number of source-line nodes in each body
C       RL(3,b)    source-line node
C       RADL(b)    body radius at node
C
C Output
C ------
C       SRC_U(u)   source  strength per unit freestream component
C       DBL_U(3,u) doublet strength per unit freestream component
C
C----------------------------------------------------------
      REAL XYZREF(3)
      REAL RL(3,*), RADL(*)
      INTEGER LFRST(*),NL(*)
      REAL SRC_U(NLDIM,*), DBL_U(3,NLDIM,*)
C
C
      REAL DRL(3), VSRC(3), VDBL(3,3)
      REAL ESL(3), UN(3)
      REAL WROT(3), UREL(3), RLREF(3)
C
      DATA PI / 3.14159265 /
C
      DO 10 IBODY = 1, NBODY
        DO 105 ILSEG = 1, NL(IBODY)-1
          L1 = LFRST(IBODY) + ILSEG - 1
          L2 = LFRST(IBODY) + ILSEG
C
          L = L1
C
          DRL(1) = (RL(1,L2) - RL(1,L1))/BETM
          DRL(2) =  RL(2,L2) - RL(2,L1)
          DRL(3) =  RL(3,L2) - RL(3,L1)
          DRLMAG = SQRT(DRL(1)**2 + DRL(2)**2 + DRL(3)**2)
          IF(DRLMAG.EQ.0.0) THEN
           DRLMI = 0.0
          ELSE
           DRLMI = 1.0/DRLMAG
          ENDIF
C
C-------- unit vector along line segment
          ESL(1) = DRL(1) * DRLMI
          ESL(2) = DRL(2) * DRLMI
          ESL(3) = DRL(3) * DRLMI
C
          ADEL = PI *     (RADL(L2)**2 - RADL(L1)**2)
          AAVG = PI * 0.5*(RADL(L2)**2 + RADL(L1)**2)
C
          RLREF(1) = 0.5*(RL(1,L2)+RL(1,L1)) - XYZREF(1)
          RLREF(2) = 0.5*(RL(2,L2)+RL(2,L1)) - XYZREF(2)
          RLREF(3) = 0.5*(RL(3,L2)+RL(3,L1)) - XYZREF(3)
C
C-------- go over freestream velocity and rotation components
          DO IU = 1, 6
            UREL(1) = 0.
            UREL(2) = 0.
            UREL(3) = 0.
            WROT(1) = 0.
            WROT(2) = 0.
            WROT(3) = 0.
C
            IF  (IU.LE.3) THEN
             UREL(IU) = 1.0
            ELSE
             WROT(IU-3) = 1.0
             CALL CROSS(RLREF,WROT,UREL)
            ENDIF
            UREL(1) = UREL(1)/BETM
C
C---------- U.es
            US = UREL(1)*ESL(1) + UREL(2)*ESL(2) + UREL(3)*ESL(3)
C
C---------- velocity projected on normal plane = U - (U.es) es
            UN(1) = UREL(1) - US*ESL(1)
            UN(2) = UREL(2) - US*ESL(2)
            UN(3) = UREL(3) - US*ESL(3)
C
C---------- total source and doublet strength of segment
            SRC_U(L,IU)   = ADEL*US
            DBL_U(1,L,IU) = AAVG*UN(1)*DRLMAG*2.0
            DBL_U(2,L,IU) = AAVG*UN(2)*DRLMAG*2.0
            DBL_U(3,L,IU) = AAVG*UN(3)*DRLMAG*2.0
          ENDDO
 105    CONTINUE
 10   CONTINUE
C
      RETURN
      END ! SRDSET



 
      SUBROUTINE CROSS (U,V,W)
      REAL U(3), V(3), W(3)
      W(1) = U(2)*V(3) - U(3)*V(2)
      W(2) = U(3)*V(1) - U(1)*V(3)
      W(3) = U(1)*V(2) - U(2)*V(1)
      RETURN
      END      


      FUNCTION DOT (U,V)
      REAL U(3),V(3)
      DOT = U(1)*V(1) + U(2)*V(2) + U(3)*V(3)
      RETURN
      END





      SUBROUTINE VORVEL(X,Y,Z,LBOUND,X1,Y1,Z1,X2,Y2,Z2,BETA,
     &                   U,V,W )
C----------------------------------------------------------
C     Same as VORVEL1, with somewhat different formulation
C----------------------------------------------------------
      LOGICAL LBOUND
C
      REAL A(3), B(3), AXB(3)
C
      DATA PI4INV  / 0.079577472 /
C
      A(1) = (X1 - X)/BETA
      A(2) =  Y1 - Y
      A(3) =  Z1 - Z
C
      B(1) = (X2 - X)/BETA
      B(2) =  Y2 - Y
      B(3) =  Z2 - Z
C
      ASQ = A(1)**2 + A(2)**2 + A(3)**2
      BSQ = B(1)**2 + B(2)**2 + B(3)**2
C
      AMAG = SQRT(ASQ)
      BMAG = SQRT(BSQ)
C
      U = 0.
      V = 0.
      W = 0.
C
C---- contribution from the transverse bound leg
      IF (LBOUND .AND.  AMAG*BMAG .NE. 0.0) THEN
        AXB(1) = A(2)*B(3) - A(3)*B(2)
        AXB(2) = A(3)*B(1) - A(1)*B(3)
        AXB(3) = A(1)*B(2) - A(2)*B(1)
C
        ADB = A(1)*B(1) + A(2)*B(2) + A(3)*B(3)
C
        DEN = AMAG*BMAG + ADB
C
        T = (1.0/AMAG + 1.0/BMAG) / DEN
C
        U = AXB(1)*T
        V = AXB(2)*T
        W = AXB(3)*T
      ENDIF
C
C---- trailing leg attached to A
      IF (AMAG .NE. 0.0) THEN
        AXISQ = A(3)**2 + A(2)**2
C
        ADI = A(1)
        RSQ = AXISQ
C
        T = - (1.0 - ADI/AMAG) / RSQ
C
        V = V + A(3)*T
        W = W - A(2)*T
      ENDIF
C
C---- trailing leg attached to B
      IF (BMAG .NE. 0.0) THEN
        BXISQ = B(3)**2 + B(2)**2
C
        BDI = B(1)
        RSQ = BXISQ
C
        T =   (1.0 - BDI/BMAG) / RSQ
C
        V = V + B(3)*T
        W = W - B(2)*T
      ENDIF
C
      U = U*PI4INV / BETA
      V = V*PI4INV 
      W = W*PI4INV 
C
      RETURN
      END ! VORVEL




      SUBROUTINE VORVELC(X,Y,Z,LBOUND,X1,Y1,Z1,X2,Y2,Z2,BETA,
     &                   U,V,W, RCORE)
C----------------------------------------------------------
C     Same as VORVEL, with finite core radius
C----------------------------------------------------------
      LOGICAL LBOUND
C
C
      REAL A(3), B(3), AXB(3)
C
      DATA PI4INV  / 0.079577472 /
C
      A(1) = (X1 - X)/BETA
      A(2) =  Y1 - Y
      A(3) =  Z1 - Z
C
      B(1) = (X2 - X)/BETA
      B(2) =  Y2 - Y
      B(3) =  Z2 - Z
C
      ASQ = A(1)**2 + A(2)**2 + A(3)**2
      BSQ = B(1)**2 + B(2)**2 + B(3)**2
C
      AMAG = SQRT(ASQ)
      BMAG = SQRT(BSQ)
C
      U = 0.
      V = 0.
      W = 0.
C
C---- contribution from the transverse bound leg
      IF (LBOUND  .AND.  AMAG*BMAG .NE. 0.0) THEN
        AXB(1) = A(2)*B(3) - A(3)*B(2)
        AXB(2) = A(3)*B(1) - A(1)*B(3)
        AXB(3) = A(1)*B(2) - A(2)*B(1)
        AXBSQ = AXB(1)**2 + AXB(2)**2 + AXB(3)**2
C
        ADB = A(1)*B(1) + A(2)*B(2) + A(3)*B(3)
        ALSQ = ASQ + BSQ - 2.0*ADB
C
ccc     RSQ = AXBSQ / ALSQ
C
        AB = AMAG*BMAG
c        T = (AMAG+BMAG)*(1.0 - ADB/AB) / (AXBSQ + ALSQ*RCORE**2)
        T = (  (BSQ-ADB)/SQRT(BSQ+RCORE**2)
     &       + (ASQ-ADB)/SQRT(ASQ+RCORE**2) ) / (AXBSQ + ALSQ*RCORE**2)
C
        U = AXB(1)*T
        V = AXB(2)*T
        W = AXB(3)*T
      ENDIF
C
C---- trailing leg attached to A
      IF (AMAG .NE. 0.0) THEN
        AXISQ = A(3)**2 + A(2)**2
C
        ADI = A(1)
        RSQ = AXISQ
C
        T = - (1.0 - ADI/AMAG) / (RSQ + RCORE**2)
C
        V = V + A(3)*T
        W = W - A(2)*T
      ENDIF
C
C---- trailing leg attached to B
      IF (BMAG .NE. 0.0) THEN
        BXISQ = B(3)**2 + B(2)**2
C
        BDI = B(1)
        RSQ = BXISQ
C
        T =   (1.0 - BDI/BMAG) / (RSQ + RCORE**2)
C
        V = V + B(3)*T
        W = W - B(2)*T
      ENDIF
C
      U = U*PI4INV / BETA
      V = V*PI4INV 
      W = W*PI4INV 
C
      RETURN
      END ! VORVELC




      SUBROUTINE SRDVELC(X,Y,Z, X1,Y1,Z1, X2,Y2,Z2,
     &                   BETA,RCORE,
     &                   UVWS,UVWD  )
C-------------------------------------------------------------------
C     Same as SRDVEL, but with finite core radius
C-------------------------------------------------------------------
      REAL UVWS(3), UVWD(3,3)
C
      REAL R1(3), R2(3)
      REAL RXR(3)
C
      DATA PI4INV  / 0.079577472 /
C
      R1(1) = (X1-X)/BETA
      R1(2) =  Y1-Y
      R1(3) =  Z1-Z
C
      R2(1) = (X2-X)/BETA
      R2(2) =  Y2-Y
      R2(3) =  Z2-Z
C
      RCSQ = RCORE**2
C
      R1SQ = R1(1)**2 + R1(2)**2 + R1(3)**2
      R2SQ = R2(1)**2 + R2(2)**2 + R2(3)**2
C
      R1SQEPS = R1SQ + RCSQ
      R2SQEPS = R2SQ + RCSQ
C
      R1EPS = SQRT(R1SQEPS)
      R2EPS = SQRT(R2SQEPS)
C
      RDR = R1(1)*R2(1) + R1(2)*R2(2) + R1(3)*R2(3)
      RXR(1) = R1(2)*R2(3) - R1(3)*R2(2)
      RXR(2) = R1(3)*R2(1) - R1(1)*R2(3)
      RXR(3) = R1(1)*R2(2) - R1(2)*R2(1)
C
      XDX = RXR(1)**2 + RXR(2)**2 + RXR(3)**2
C
      ALL = R1SQ + R2SQ - 2.0*RDR
C
      DEN = RCSQ*ALL + XDX
C
      AI1 = ((RDR+RCSQ)/R1EPS - R2EPS)/DEN
      AI2 = ((RDR+RCSQ)/R2EPS - R1EPS)/DEN
C
C---- set velocity components for unit source and doublet
      DO K = 1, 3
        UVWS(K) = R1(K)*AI1 + R2(K)*AI2
C
        RR1 =  (R1(K)+R2(K))    /R1EPS 
     &        - R1(K)*(RDR+RCSQ)/R1EPS**3
     &        - R2(K)           /R2EPS
C
        RR2 =  (R1(K)+R2(K))    /R2EPS 
     &        - R2(K)*(RDR+RCSQ)/R2EPS**3
     &        - R1(K)           /R1EPS
C
        RRT = 2.0*R1(K)*(R2SQ  - RDR)
     &      + 2.0*R2(K)*(R1SQ  - RDR)
C
        AJ1 = (RR1 - AI1*RRT)/DEN
C
        AJ2 = (RR2 - AI2*RRT)/DEN
C
        DO J = 1, 3
          UVWD(K,J) = - AJ1*R1(J)
     &                - AJ2*R2(J)
        ENDDO
C
        UVWD(K,K) = UVWD(K,K) - AI1 - AI2
      ENDDO
C
      UVWS(1) = UVWS(1)*PI4INV/BETA
      UVWS(2) = UVWS(2)*PI4INV
      UVWS(3) = UVWS(3)*PI4INV
      DO L = 1, 3
        UVWD(1,L) = UVWD(1,L)*PI4INV/BETA
        UVWD(2,L) = UVWD(2,L)*PI4INV
        UVWD(3,L) = UVWD(3,L)*PI4INV
      ENDDO
C
      RETURN
      END ! SRDVELC

C***********************************************************************
C    Module:  pltops.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE PLTINI(IDEV1)
      INCLUDE 'AVLPLT.INC'

C---- terminate old plot if any
      IF(LPLOT) CALL PLEND
C
C---- initialize new plot
      CALL PLOPEN(SCRNFRAC,IPSLU,IDEV1)
      LPLOT = .TRUE.

      CALL DRAWTOBUFFER

C---- set X-window size in inches (might have been resized by user)
      CALL GETWINSIZE(XWIND,YWIND)
C
      IF(LCREV) THEN
       CALL BGFILL
      ENDIF
C
C---- draw plot page outline offset by margins
      CALL NEWPEN(5)
      IF(XMARG .GT. 0.0) THEN
        CALL PLOTABS(      XMARG,      YMARG,3)
        CALL PLOTABS(      XMARG,YPAGE-YMARG,2)
        CALL PLOTABS(XPAGE-XMARG,      YMARG,3)
        CALL PLOTABS(XPAGE-XMARG,YPAGE-YMARG,2)
      ENDIF
      IF(YMARG .GT. 0.0) THEN
        CALL PLOTABS(      XMARG,      YMARG,3)
        CALL PLOTABS(XPAGE-XMARG,      YMARG,2)
        CALL PLOTABS(      XMARG,YPAGE-YMARG,3)
        CALL PLOTABS(XPAGE-XMARG,YPAGE-YMARG,2)
      ENDIF
      CALL NEWPEN(1)
C
      CALL PLOTABS(XMARG,YMARG,-3)
      CALL NEWCLIPABS( XMARG, XPAGE-XMARG, YMARG, YPAGE-YMARG )

      RETURN
      END ! PLTINI



      SUBROUTINE PLTSEG(VEC,ALF,N)
C...PURPOSE:    Plot portions of vectors in VEC given by normalized
C               segment start and end points in ALF
C
      INCLUDE 'AVLPLT.INC'
      REAL VEC(3,2),ALF(2,N)
C
      XMOD(XTMP) = SF * (XTMP - XOFF)
      YMOD(YTMP) = SF * (YTMP - YOFF)
C
      X1 = VEC(1,1)
      Y1 = VEC(2,1)
C
      DX = VEC(1,2) - VEC(1,1)
      DY = VEC(2,2) - VEC(2,1)
C
      I = 1
      XA = X1 + ALF(1,I)*DX
      YA = Y1 + ALF(1,I)*DY
      CALL PLOT(XMOD(XA),YMOD(YA),3)
C
      XA = X1 + ALF(2,I)*DX
      YA = Y1 + ALF(2,I)*DY
      CALL PLOT(XMOD(XA),YMOD(YA),2)
C
      DO 10 I=2, N
C
        IF(ABS(ALF(1,I)-ALF(2,I-1)) .GT. 1.0E-3) THEN
         XA = X1 + ALF(1,I)*DX
         YA = Y1 + ALF(1,I)*DY
         CALL PLOT(XMOD(XA),YMOD(YA),3)
        ENDIF
C
        XA = X1 + ALF(2,I)*DX
        YA = Y1 + ALF(2,I)*DY
        CALL PLOT(XMOD(XA),YMOD(YA),2)
C
   10 CONTINUE
C
      RETURN
      END ! PLTSEG



      SUBROUTINE PLTPOLY(PTS,NPTS)
C...PURPOSE:   Plot polygon given by NPTS vertices in PTS array of XYZ points
C
      INCLUDE 'AVLPLT.INC'
      REAL PTS(3,*)
C
      XMOD(XTMP) = SF * (XTMP - XOFF)
      YMOD(YTMP) = SF * (YTMP - YOFF)
C
      CALL PLOT(XMOD(PTS(1,1)),YMOD(PTS(2,1)),3)
      DO K=2, NPTS
        CALL PLOT(XMOD(PTS(1,K)),YMOD(PTS(2,K)),2)
      END DO
      CALL PLOT(XMOD(PTS(1,1)),YMOD(PTS(2,1)),2)
      RETURN
      END ! PLTPOLY


      SUBROUTINE PLTINT(PT,N,CHSIZE,LOFFSET)
C...Purpose:   Plot integer N at location PT 
C              with character size CHSIZE
C
      INCLUDE 'AVLPLT.INC'
      REAL PT(3)
      LOGICAL LOFFSET
C
      XMOD(XTMP) = SF * (XTMP - XOFF)
      YMOD(YTMP) = SF * (YTMP - YOFF)
C
      FLTN = FLOAT(N)
      X = XMOD(PT(1))
      Y = YMOD(PT(2))
      IF(LOFFSET) THEN
       X = X + 0.80*CHSIZE
       Y = Y - 0.50*CHSIZE
      ELSE
       NCHAR = 1 + INT(LOG10(ABS(FLTN))+0.01)
       X = X - 0.5*CHSIZE*FLOAT(NCHAR)
       Y = Y - 0.5*CHSIZE
       IF(FLTN.LT.0.0) X = X - CHSIZE
      ENDIF
      CALL PLNUMB(X,Y,CHSIZE,FLTN,0.,-1)
C
      RETURN
      END ! PLTINT


      SUBROUTINE PLTFLT(PT,R,CHSIZE,LOFFSET,NDIG)
C...Purpose:   Plot float R at location PT 
C              with character size CHSIZE
C
      INCLUDE 'AVLPLT.INC'
      REAL PT(3)
      LOGICAL LOFFSET
C
      XMOD(XTMP) = SF * (XTMP - XOFF)
      YMOD(YTMP) = SF * (YTMP - YOFF)
C
      ABSR = ABS(R)
C
C---- determine # of digits to use for diplay
      IF(NDIG.LE.-2) THEN
       ND = 1 - MAX( 0 , INT(LOG10(ABSR)) )
       IF(ABSR*10**ND - AINT(ABSR*10**ND+0.01) .GT. 0.01) ND = ND + 1
       IF(ABSR*10**ND - AINT(ABSR*10**ND+0.01) .GT. 0.01) ND = ND + 1
      ELSE
       ND = NDIG
      ENDIF
C
      X = XMOD(PT(1))
      Y = YMOD(PT(2))
      IF(LOFFSET) THEN
       X = X + 0.85*CHSIZE
       Y = Y - 0.50*CHSIZE
      ELSE
       NCHAR = 1 + INT(LOG10(ABSR)) + 1 + ND
       X = X - 0.5*CHSIZE*FLOAT(NCHAR)
       Y = Y - 0.5*CHSIZE
       IF(R.LT.0.0) X = X - CHSIZE
      ENDIF
      CALL PLNUMB(X,Y,CHSIZE,R,0.0,ND)
C
      RETURN
      END ! PLTFLT


      SUBROUTINE PLTARROW(PT1,PT2)
C...PURPOSE:   Plot an arrow vector from PT1 to PT2
C
      INCLUDE 'AVLPLT.INC'
      REAL PT1(3), PT2(3)
C
      XMOD(XTMP) = SF * (XTMP - XOFF)
      YMOD(YTMP) = SF * (YTMP - YOFF)
C
      XAVE = PT1(1)
      YAVE = PT1(2)
      XHED = PT2(1)
      YHED = PT2(2)
C
      DX = XHED - XAVE
      DY = YHED - YAVE
C
      CALL PLOT(XMOD(XAVE),YMOD(YAVE),3)
      CALL PLOT(XMOD(XHED),YMOD(YHED),2)
C
      X1 = XAVE + 0.8*DX + 0.02*DY
      Y1 = YAVE + 0.8*DY - 0.02*DX
      X2 = XAVE + 0.8*DX - 0.02*DY
      Y2 = YAVE + 0.8*DY + 0.02*DX
      CALL PLOT(XMOD(X1  ),YMOD(Y1  ),2)
      CALL PLOT(XMOD(X2  ),YMOD(Y2  ),2)
      CALL PLOT(XMOD(XHED),YMOD(YHED),2)
C
      RETURN
      END ! PLTARROW




      SUBROUTINE ROTATEPT(PT0,PT1,DIR,COSR,SINR)
C...PURPOSE:  Rotate point PT1 about vector in direction DIR through
C             point PT0 by angle with cosine COSR and sine SINR.
C             Rotated point is returned in PT1.
C
C
      REAL PT0(3), PT1(3), DIR(3), DPT(3), EP(3), EQ(3)
C
      DO L = 1, 3
        DPT(L) = PT1(L) - PT0(L)
      END DO
C-----EP = normal-vector component perpendicular to hinge line
      ENDOT = DOT(DPT,DIR)
      EP(1) = DPT(1) - ENDOT*DIR(1)
      EP(2) = DPT(2) - ENDOT*DIR(2)
      EP(3) = DPT(3) - ENDOT*DIR(3)
C-----EQ = unit vector perpendicular to both EP and DIR
      CALL CROSS(DIR,EP,EQ)
C-----rotated vector consists of sin,cos parts from EP and EQ,
C-    with hinge-parallel component ENDOT restored
      DO L = 1, 3
        DPT(L) = EP(L)*COSR + EQ(L)*SINR + ENDOT*DIR(L)
        PT1(L) = PT0(L) + DPT(L)
      END DO
C
      RETURN
      END ! ROTATEPT


      SUBROUTINE OFFINI       
C---- set initial scaling and offset parameters   
C
      INCLUDE 'AVLPLT.INC'
C
      XRANGE = XMAX-XMIN
      YRANGE = YMAX-YMIN
      IF(XRANGE.EQ.0.) XRANGE = 1.0
      IF(YRANGE.EQ.0.) YRANGE = 1.0
      SF = 0.95*MIN( 1.0/XRANGE , PLOTAR/YRANGE )
      XOFF = XMIN - 0.5*(1.0    - SF*XRANGE)/SF
      YOFF = YMIN - 0.5*(PLOTAR - SF*YRANGE)/SF
C
      RETURN        
      END ! OFFINI  


      SUBROUTINE OFFGET       
C---- Get offsets for zoom from user interaction (mouse)
C
      INCLUDE 'AVLPLT.INC'
      CHARACTER*1 CKEY
C
      SH = 2.0
C
      WRITE(*,*)
      WRITE(*,*) 'Mark off corners of blowup area'
      WRITE(*,*) '(2 spaces default to current area)'       
      CALL GETCURSORXY(XX1,YY1,CKEY)
      CALL PLSYMB(XX1,YY1,SH,3,0.0,0)
      CALL GETCURSORXY(XX2,YY2,CKEY)
      CALL PLSYMB(XX2,YY2,SH,3,0.0,0)
      IF(ABS(XX1-XX2).LT.0.01 .AND. ABS(YY1-YY2).LT.0.01) RETURN      
C
      XOFF = MIN(XX1,XX2)/SF + XOFF
      YOFF = MIN(YY1,YY2)/SF + YOFF
      XDIF = ABS(XX2 - XX1)/SF
      YDIF = ABS(YY2 - YY1)/SF   
      IF(XDIF.EQ.0.0) XDIF = 1.0E-5
      IF(YDIF.EQ.0.0) YDIF = 1.0E-5
      SF = MIN( 1.0/XDIF , PLOTAR/YDIF )     
C
C
C---- Re-center the blowup
C      XDIF = MAX(XDIF,YDIF/0.75)
      YDIF = MAX(0.75*XDIF,YDIF)
      XOFF = XOFF - 0.5*(1.0    - SF*XDIF)/SF
      YOFF = YOFF - 0.5*(PLOTAR - SF*YDIF)/SF
C
      RETURN        
      END ! OFFGET  


      SUBROUTINE BGFILL
      INCLUDE 'AVLPLT.INC'
      REAL XBOX(5), YBOX(5)
C
      XBOX(1) = 0.0
      XBOX(2) = XWIND
      XBOX(3) = XWIND
      XBOX(4) = 0.0
      XBOX(5) = XBOX(1)

      YBOX(1) = 0.0
      YBOX(2) = 0.0
      YBOX(3) = YWIND
      YBOX(4) = YWIND
      YBOX(5) = XBOX(1)

      CALL NEWCOLORNAME('BLACK')
      IF(SCRNFRAC .GT. 0.0) THEN
       CALL POLYLINE(XBOX,YBOX,5,1)
      ELSE
       CALL POLYLINE(YBOX,XBOX,5,1)
      ENDIF
      CALL NEWCOLORNAME('WHITE')
C
      RETURN
      END ! BGFILL

C***********************************************************************
C    Module:  amass.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************
 
      SUBROUTINE MASINI
      INCLUDE 'AVL.INC'
C---------------------------------------------------
C     Initializes default mass, inertia tensor
C---------------------------------------------------
      RMASS0 = 1.0
C
      DO K = 1, 3
        RINER0(K,1) = 0.
        RINER0(K,2) = 0.
        RINER0(K,3) = 0.
        RINER0(K,K) = 1.0
C
        AMASS(K,1) = 0.
        AMASS(K,2) = 0.
        AMASS(K,3) = 0.
C
        AINER(K,1) = 0.
        AINER(K,2) = 0.
        AINER(K,3) = 0.
      ENDDO
C
      XYZMASS0(1) = 0.
      XYZMASS0(2) = 0.
      XYZMASS0(3) = 0.
C
      LMASS = .FALSE.
C
      RETURN
      END ! MASINI



      SUBROUTINE MASGET(LU,FNAME,ERROR)
C--------------------------------------------------
C     Reads mass distributions file,
C     computes default mass, inertia tensor
C--------------------------------------------------
      INCLUDE 'AVL.INC'
      CHARACTER*(*) FNAME
C
      REAL mass, mi
      REAL Ixx , Iyy , Izz , Ixy , Ixz , Iyz
      REAL Ixxi, Iyyi, Izzi, Ixyi, Ixzi, Iyzi
C
      CHARACTER*80 CASE
      CHARACTER*256 LINE, LINEU
C
      CHARACTER*32 UNCHGEE, UNCHRHO, UNCH
C
      LOGICAL ERROR
      REAL RINP(10), FAC(10), ADD(10)
C
 1000 FORMAT(A)
C
      OPEN(LU,FILE=FNAME,STATUS='OLD',ERR=90)
C
      sum_m   = 0.
      sum_mx  = 0.
      sum_my  = 0.
      sum_mz  = 0.
      sum_mxx = 0.
      sum_myy = 0.
      sum_mzz = 0.
      sum_mxy = 0.
      sum_mxz = 0.
      sum_myz = 0.
      sum_mzz = 0.
      sum_ixx = 0.
      sum_iyy = 0.
      sum_izz = 0.
      sum_ixy = 0.
      sum_iyz = 0.
      sum_ixz = 0.
C
      xcg = 0.
      ycg = 0.
      zcg = 0.
C
C---- default multipliers and adders
      DO K = 1, 10
        FAC(K) = 1.0
        ADD(K) = 0.0
      ENDDO
C
      UNITL = 1.
      UNITM = 1.
      UNITT = 1.
      UNCHL = 'Lunit'
      UNCHM = 'Munit'
      UNCHT = 'Tunit'
      NUL = 5
      NUM = 5
      NUT = 5
C
      GEE0 = 1.
      RHO0 = 1.
      UNCHGEE = 'Lunit/Tunit^2'
      UNCHRHO = 'Munit/Lunit^3'
      NUGEE = 13
      NURHO = 13
C
      ILINE = 0

C---- search all lines of file for data values
C=============================================
 10   CONTINUE
        READ(LU,1000,END=50) LINE
        ILINE = ILINE + 1
C
        IF(INDEX('#!',LINE(1:1)).NE.0) GO TO 10
C
        IF(INDEX('*',LINE(1:1)).NE.0) THEN
C------- read multiplier line
         KINP = 10
         CALL GETFLT(LINE(2:80),RINP,KINP,ERROR)
         IF(ERROR) GO TO 40
C
         DO K = 1, KINP
           FAC(K) = RINP(K)
         ENDDO
         GO TO 10
        ENDIF
C
        IF(INDEX('+',LINE(1:1)).NE.0) THEN
C------- read adder line
         KINP = 10
         CALL GETFLT(LINE(2:80),RINP,KINP,ERROR)
         IF(ERROR) GO TO 40
C
         DO K = 1, KINP
           ADD(K) = RINP(K)
         ENDDO
         GO TO 10
        ENDIF
C
C
C------ don't look for special parameters if there's no "=" character
        KEQ = INDEX(LINE,'=')
        IF(KEQ.LE.1) GO TO 20
C
C------------------------------------------
C------ look for parameter keywords in front of "=" character
C
        K = INDEX(LINE(1:KEQ-1),'Lunit')
        IF(K .NE. 0) THEN
         LINEU = LINE(KEQ+1:256)
         CALL STRIP(LINEU,NLN)
         KB = INDEX(LINEU,' ')
         READ(LINEU(1:KB),*,ERR=40) UNITL
         UNCHL = LINEU(KB+1:256)
         CALL STRIP(UNCHL,NUL)
         NUL = MAX(NUL,1)
         GO TO 10
        ENDIF
C
        K = INDEX(LINE(1:KEQ-1),'Munit')
        IF(K .NE. 0) THEN
         LINEU = LINE(KEQ+1:256)
         CALL STRIP(LINEU,NLN)
         KB = INDEX(LINEU,' ')
         READ(LINEU(1:KB),*,ERR=40) UNITM
         UNCHM = LINEU(KB+1:256)
         CALL STRIP(UNCHM,NUM)
         NUM = MAX(NUM,1)
         GO TO 10
        ENDIF
C
        K = INDEX(LINE(1:KEQ-1),'Tunit')
        IF(K .NE. 0) THEN
         LINEU = LINE(KEQ+1:256)
         CALL STRIP(LINEU,NLN)
         KB = INDEX(LINEU,' ')
         READ(LINEU(1:KB),*,ERR=40) UNITT
         UNCHT = LINEU(KB+1:256)
         CALL STRIP(UNCHT,NUT)
         NUT = MAX(NUT,1)
         GO TO 10
        ENDIF
C
C
        K = INDEX(LINE(1:KEQ-1),'g')
        IF(K .NE. 0) THEN
         LINEU = LINE(KEQ+1:256)
         CALL STRIP(LINEU,NLN)
         KB = INDEX(LINEU,' ')
         READ(LINEU(1:KB),*,ERR=40) GEE0
         UNCHGEE = LINEU(KB+1:256)
         CALL STRIP(UNCHGEE,NUGEE)
         NUGEE = MAX(NUGEE,1)
         GO TO 10
        ENDIF
C
        K = INDEX(LINE(1:KEQ-1),'rho')
        IF(K .NE. 0) THEN
         LINEU = LINE(KEQ+1:256)
         CALL STRIP(LINEU,NLN)
         KB = INDEX(LINEU,' ')
         READ(LINEU(1:KB),*,ERR=40) RHO0
         UNCHRHO = LINEU(KB+1:256)
         CALL STRIP(UNCHRHO,NURHO)
         NURHO = MAX(NURHO,1)
         GO TO 10
        ENDIF
C
C------------------------------
 20     CONTINUE
C
        DO I=1, 10
          RINP(I) = 0.
        ENDDO
C
        KINP = 10
        CALL GETFLT(LINE,RINP,KINP,ERROR)
        IF(ERROR) GO TO 40
C
        mi = FAC(1)*RINP(1) + ADD(1)
        xi = FAC(2)*RINP(2) + ADD(2)
        yi = FAC(3)*RINP(3) + ADD(3)
        zi = FAC(4)*RINP(4) + ADD(4)
        Ixxi = FAC(5)*RINP(5) + ADD(5)
        Iyyi = FAC(6)*RINP(6) + ADD(6)
        Izzi = FAC(7)*RINP(7) + ADD(7)
        Ixyi = FAC(8)*RINP(8) + ADD(8)
        Ixzi = FAC(9)*RINP(9) + ADD(9)
        Iyzi = FAC(10)*RINP(10) + ADD(10)
C
        sum_m   = sum_m   + mi
        sum_mx  = sum_mx  + mi*xi
        sum_my  = sum_my  + mi*yi
        sum_mz  = sum_mz  + mi*zi
        sum_mxx = sum_mxx + mi*xi*xi
        sum_myy = sum_myy + mi*yi*yi
        sum_mzz = sum_mzz + mi*zi*zi
        sum_mxy = sum_mxy + mi*xi*yi
        sum_mxz = sum_mxz + mi*xi*zi
        sum_myz = sum_myz + mi*yi*zi
c
        sum_ixx = sum_ixx + Ixxi
        sum_iyy = sum_iyy + Iyyi
        sum_izz = sum_izz + Izzi
        sum_ixy = sum_ixy + Ixyi
        sum_ixz = sum_ixz + Ixzi
        sum_iyz = sum_iyz + Iyzi
C
      GO TO 10
C
C-----------------------------------
 40   WRITE(*,1500) ILINE, LINE(1:80)
 1500 FORMAT(' * Bad data line',I5,'  ignored:  ',A)
      GO TO 10
C
C=============================================
C
 50   CONTINUE
      CLOSE(LU)
C
      mass = sum_m
C
      xcg = sum_mx/sum_m
      ycg = sum_my/sum_m
      zcg = sum_mz/sum_m
C
      Ixx = sum_ixx + (sum_myy + sum_mzz) - sum_m*(ycg**2 + zcg**2)
      Iyy = sum_iyy + (sum_mzz + sum_mxx) - sum_m*(zcg**2 + xcg**2)
      Izz = sum_izz + (sum_mxx + sum_myy) - sum_m*(xcg**2 + ycg**2)
      Ixy = sum_ixy +  sum_mxy            - sum_m* xcg*ycg
      Ixz = sum_ixz +  sum_mxz            - sum_m* xcg*zcg
      Iyz = sum_iyz +  sum_myz            - sum_m* ycg*zcg
C
      RMASS0 = mass * UNITM
C
      RINER0(1,1) =  Ixx * UNITM*UNITL**2
      RINER0(1,2) = -Ixy * UNITM*UNITL**2
      RINER0(1,3) = -Ixz * UNITM*UNITL**2
C
      RINER0(2,1) = -Ixy * UNITM*UNITL**2
      RINER0(2,2) =  Iyy * UNITM*UNITL**2
      RINER0(2,3) = -Iyz * UNITM*UNITL**2
C
      RINER0(3,1) = -Ixz * UNITM*UNITL**2
      RINER0(3,2) = -Iyz * UNITM*UNITL**2
      RINER0(3,3) =  Izz * UNITM*UNITL**2
C
      XYZMASS0(1) = xcg * UNITL
      XYZMASS0(2) = ycg * UNITL
      XYZMASS0(3) = zcg * UNITL
C
C----------------------------------------
C---- set derived unit values and names
      CALL UNITSET
C
C---- set parameter unit names
      CALL PARNSET
C
      ERROR = .FALSE.
      LMASS = .TRUE.
      RETURN
C
 90   CONTINUE
      CALL STRIP(FNAME,NFN)
      WRITE(*,9000) FNAME(1:NFN)
 9000 FORMAT(/' Mass file  ',A,'  open error')
      ERROR = .TRUE.
      LMASS = .FALSE.
      RETURN
      END ! MASGET



      SUBROUTINE MASPUT(IR1,IR2)
      INCLUDE 'AVL.INC'
C-------------------------------------------
C     Stores default mass, inertias 
C     in run case parameter array
C-------------------------------------------
C
      DO IR = IR1, IR2
        PARVAL(IPMASS,IR) = RMASS0
        PARVAL(IPIXX,IR) = RINER0(1,1)
        PARVAL(IPIYY,IR) = RINER0(2,2)
        PARVAL(IPIZZ,IR) = RINER0(3,3)
        PARVAL(IPIXY,IR) = RINER0(1,2)
        PARVAL(IPIYZ,IR) = RINER0(2,3)
        PARVAL(IPIZX,IR) = RINER0(3,1)

        PARVAL(IPGEE,IR) = GEE0
        PARVAL(IPRHO,IR) = RHO0
C
        PARVAL(IPXCG,IR) = XYZMASS0(1)/UNITL
        PARVAL(IPYCG,IR) = XYZMASS0(2)/UNITL
        PARVAL(IPZCG,IR) = XYZMASS0(3)/UNITL
      ENDDO
C
      RETURN
      END ! MASPUT



      SUBROUTINE MASSHO(LU)
      INCLUDE 'AVL.INC'
C
      WRITE(LU,*)
      IF(UNCHM(1:NUM).NE.'Munit')
     &WRITE(LU,1250) 'Mass        = ', RMASS0/UNITM, 'Munit'
      WRITE(LU,1250) 'Mass        = ', RMASS0, UNCHM(1:NUM)
C
      WRITE(LU,*)
      WRITE(LU,1260) 'Ref. x,y,z  = ',(XYZREF0(K)       , K=1,3),'Lunit'
      IF(UNCHL(1:NUL).NE.'Lunit')
     &WRITE(LU,1260) 'C.G. x,y,z  = ',(XYZMASS0(K)/UNITL, K=1,3),'Lunit'
      WRITE(LU,1260) 'C.G. x,y,z  = ',(XYZMASS0(K), K=1,3), UNCHL(1:NUL)
C
      WRITE(LU,*)
      WRITE(LU,1271) 'Ixx -Ixy -Ixz   | ',
     &            RINER0(1,1),RINER0(1,2),RINER0(1,3),'|'
      WRITE(LU,1272) '     Iyy -Iyz = | ',
     &                        RINER0(2,2),RINER0(2,3),'|', UNCHI(1:NUI)
      WRITE(LU,1273) '          Izz   | ',
     &                                    RINER0(3,3),'|'
C
 1250 FORMAT(1X, A,  G12.4,2X,A)
 1260 FORMAT(1X, A, 3G12.4,2X,A)
 1271 FORMAT(1X, A,      3G12.4, 2X, A, 2X, A)
 1272 FORMAT(1X, A, 12X, 2G12.4, 2X, A, 2X, A)
 1273 FORMAT(1X, A, 24X,  G12.4, 2X, A, 2X, A)
C
      RETURN
      END ! MASSHO


      SUBROUTINE APPSHO(LU,RHO)
      INCLUDE 'AVL.INC'
C
      WRITE(LU,*) 'Apparent mass, inertia'
      WRITE(LU,*)
      WRITE(LU,1271) 'mxx  mxy  mxz   | ',
     &  AMASS(1,1)*RHO,AMASS(1,2)*RHO,AMASS(1,3)*RHO,'|'
      WRITE(LU,1272) '     myy  myz = | ',
     &                 AMASS(2,2)*RHO,AMASS(2,3)*RHO,'|', UNCHM(1:NUM)
      WRITE(LU,1273) '          mzz   | ',
     &                                AMASS(3,3)*RHO,'|'
      WRITE(LU,*)
      WRITE(LU,1271) 'Ixx -Ixy -Ixz   | ',
     &  AINER(1,1)*RHO,AINER(1,2)*RHO,AINER(1,3)*RHO,'|'
      WRITE(LU,1272) '     Iyy -Iyz = | ',
     &                 AINER(2,2)*RHO,AINER(2,3)*RHO,'|', UNCHI(1:NUI)
      WRITE(LU,1273) '          Izz   | ',
     &                                AINER(3,3)*RHO,'|'
C
 1271 FORMAT(1X, A,      3G12.4, 2X, A, 2X, A)
 1272 FORMAT(1X, A, 12X, 2G12.4, 2X, A, 2X, A)
 1273 FORMAT(1X, A, 24X,  G12.4, 2X, A, 2X, A)
C
      RETURN
      END ! APPSHO



      SUBROUTINE APPGET
C----------------------------------------------------------------
C     Calculates apparent mass and inertia for unit air density
C----------------------------------------------------------------
      INCLUDE 'AVL.INC'
      REAL UC(3), US(3), UN(3), RM(3), RXUN(3)
C
      DO K = 1, 3
        DO L = 1, 3
          AMASS(K,L) = 0.
          AINER(K,L) = 0.
        ENDDO
      ENDDO
C
      DO 100 J = 1, NSTRIP
        CR = CHORD(J)
        SR = CHORD(J)*WSTRIP(J)
C
C------ strip normal unit vector UN
        UN(1) = 0.0
        UN(2) = ENSY(J)
        UN(3) = ENSZ(J)
C
C------ spanwise unit vector US (along midchord)
        US(1) = RLE2(1,J) - RLE1(1,J) + 0.5*(CHORD2(J) - CHORD1(J))
        US(2) = RLE2(2,J) - RLE1(2,J)
        US(3) = RLE2(3,J) - RLE1(3,J)
        UMAG = SQRT(US(1)*US(1) + US(2)*US(2) + US(3)*US(3))
        IF(UMAG.GT.0.0) THEN
         US(1) = US(1)/UMAG
         US(2) = US(2)/UMAG
         US(3) = US(3)/UMAG
        ENDIF
C
C------ perpendicular-chord unit vector UC
        CALL CROSS(US,UN,UC)
C
C------ use the strip 1/2 chord location for moment arm
        RM(1) = RLE(1,J) + 0.5*CR
        RM(2) = RLE(2,J)
        RM(3) = RLE(3,J)
C
        CALL CROSS(RM,UN,RXUN)
C
C------ perpendicular chord
        CPERP = CR * (US(2)*UN(3) - US(3)*UN(2))
C
C------ apparent mass and spanwise-axis apparent inertia of strip
        APPM = SR * 0.25*PI*CPERP          
        APPI = SR * 0.25*PI*CPERP**3 / 64.0
C
C------ add apparent mass contribution
        DO K = 1, 3
          DO L = 1, 3
            AMASS(K,L) = AMASS(K,L) + APPM*  UN(K)*  UN(L) * UNITL**3
            AINER(K,L) = AINER(K,L) + APPM*RXUN(K)*RXUN(L) * UNITL**5
     &                              + APPI*  US(K)*  US(L) * UNITL**5
          ENDDO
        ENDDO
C
  100 CONTINUE
C
      RETURN
      END ! APPGET



      SUBROUTINE UNITSET
      INCLUDE 'AVL.INC'

C----------------------------------------
C---- set force unit
      UNITF = UNITM*UNITL/UNITT**2
      IF(UNCHM(1:1).NE.' ' .AND.
     &   UNCHL(1:1).NE.' ' .AND.
     &   UNCHT(1:1).NE.' '      ) THEN
       UNCHF = UNCHM(1:NUM)//'-'//UNCHL(1:NUL)//'/'//UNCHT(1:NUT)//'^2'
       CALL STRIP(UNCHF,NUF)
       IF(UNCHF(1:NUF).EQ.'slug-ft/s^2') UNCHF = 'lb'
       IF(UNCHF(1:NUF).EQ.'kg-m/s^2'   ) UNCHF = 'N'
       IF(UNCHF(1:NUF).EQ.'g-cm/s^2'   ) UNCHF = 'dyn'
       CALL STRIP(UNCHF,NUF)
      ENDIF
C
C---- set area unit
      UNITS = UNITL**2
      IF(UNCHL(1:1).NE.' ') THEN
       UNCHS = UNCHL(1:NUL)//'^2'
       CALL STRIP(UNCHS,NUS)
      ENDIF
C 
C---- set velocity unit
      UNITV = UNITL/UNITT
      IF(UNCHL(1:1).NE.' ' .AND.
     &   UNCHT(1:1).NE.' '      ) THEN
       UNCHV = UNCHL(1:NUL)//'/'//UNCHT(1:NUT)
       CALL STRIP(UNCHV,NUV)
      ENDIF
C 
C---- set acceleration unit name
      UNITA = UNITL/UNITT**2
      IF(UNCHL(1:1).NE.' ' .AND.
     &   UNCHT(1:1).NE.' '      ) THEN
       UNCHA = UNCHL(1:NUL)//'/'//UNCHT(1:NUT)//'^2'
       CALL STRIP(UNCHA,NUA)
      ENDIF
C 
C---- set inertia unit name
      UNITI = UNITM*UNITL**2
      IF(UNCHM(1:1).NE.' ' .AND.
     &   UNCHL(1:1).NE.' '      ) THEN
       UNCHI = UNCHM(1:NUM)//'-'//UNCHL(1:NUL)//'^2'
       CALL STRIP(UNCHI,NUI)
      ENDIF
C
C---- set density unit name
      UNITD = UNITM/UNITL**3
      IF(UNCHM(1:1).NE.' ' .AND.
     &   UNCHL(1:1).NE.' '      ) THEN
       UNCHD = UNCHM(1:NUM)//'/'//UNCHL(1:NUL)//'^3'
       CALL STRIP(UNCHD,NUD)
      ENDIF
C
      RETURN
      END ! UNITSET

      SUBROUTINE SECONDS(TSEC)
      REAL*8 TSEC
C
C...SECNDS is a real*4 function that returns seconds.
C   The value is modified by subtracting the supplied argument.
C   It acts as in the VMS FORTRAN Manual.
C
      REAL*4 SECNDS, TIME
      TIME = 0.0
      TSEC = SECNDS(TIME)
      END

C***********************************************************************
C    Module:  cdcl.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE CDCL(J,CL,CD,CD_CL)
C
C--- Routine for CD as a function of CL, as defined by 6 parameters
C    defining the polar, input by the user and stored for each strip J.
C
C    The CD-CL polar is based on a simple interpolation scheme using
C    four CL regions:
C     1) negative stall region
C     2) parabolic CD(CL) region between negative stall and the drag minimum
C     2) parabolic CD(CL) region between the drag minimum and positive stall
C     4) positive stall region
C
C             CLpos,CDpos       <-  Region 4 (quadratic above CLpos)
C    CL |     X--------      
C       |    /                     
C       |   |                   <-  Region 3 (quadratic above CLcdmin)
C       |   X CLcdmin,CDmin  
C       |   |                
C       |    \                  <-  Region 2 (quadratic below CLcdmin)
C       |     X_________      
C       |     CLneg,CDneg       <-  Region 1 (quadratic below CLneg)
C       |                             
C       -------------------------
C                       CD
C
C    The parameters that control the section "polar" are:
C      CLCDSEC(1)  the CL (CLneg) at point before the negative stall drag rise
C      CLCDSEC(2)  the CD (CDneg) at CLneg
C      CLCDSEC(3)  the CL (CLcdmin) at minimum drag (middle of polar)
C      CLCDSEC(4)  the CD (CDmin) at CLcdmin
C      CLCDSEC(5)  the CL (CLpos) at point before the positive stall drag rise
C      CLCDSEC(6)  the CD (CDpos) at CLpos
C
      INCLUDE 'AVL.INC'
C
C--- CLINC and CDINC control the rate of increase of drag in the stall regions
C    CLINC=0.2 forces drag to increase by CDINC over deltaCL=0.2 after stall
C    The CDINC term is the CD increment added by deltaCL=CLINC after stall
C
      DATA  CLINC, CDINC / 0.2, 0.0500 /
C
      CD    = 0.0
      CD_CL = 0.0
      IF(J.LT.1 .OR. J.GT.NSTRIP) THEN
        WRITE(*,*) 'Error in CDCL - strip index out of bounds'
        RETURN
      ENDIF
C
C--- Unpack the CD,CL parameters for this strip
      CLMIN = CLCD(1,J)
      CDMIN = CLCD(2,J)
      CL0   = CLCD(3,J)
      CD0   = CLCD(4,J)
      CLMAX = CLCD(5,J)
      CDMAX = CLCD(6,J)
      IF(CLMAX.LE.CL0 .OR. CL0.LE.CLMIN) THEN
        WRITE(*,*) '*** CDCL input CL data out of order'
        RETURN
      ENDIF
C
C--- Some matching parameters that make the slopes smooth at the stall joins
      CDX1 = 2.0*(CDMIN-CD0)*(CLMIN-CL0)/(CLMIN-CL0)**2 
      CDX2 = 2.0*(CDMAX-CD0)*(CLMAX-CL0)/(CLMAX-CL0)**2 
      CLFAC = 1.0 / CLINC
C
C--- Four formulas are used for CD, depending on the CL  
C
      IF(CL.LT.CLMIN) THEN
C--- Negative stall drag model (slope matches lower side, quadratic drag rise)
        CD = CDMIN + CDINC*(CLFAC*(CL-CLMIN))**2
     &      + CDX1*(1.0 - (CL-CL0)/(CLMIN-CL0))
        CD_CL = CDINC*CLFAC*2.0*(CL-CLMIN)
C
C--- Quadratic matching negative stall and minimum drag point with zero slope
       ELSEIF(CL.LT.CL0) THEN
        CD = CD0 + (CDMIN-CD0)*(CL-CL0)**2/(CLMIN-CL0)**2  
        CD_CL = (CDMIN-CD0)*2.0*(CL-CL0)/(CLMIN-CL0)**2  
C
C--- Quadratic matching positive stall and minimum drag point with zero slope
       ELSEIF(CL.LT.CLMAX) THEN
        CD = CD0 + (CDMAX-CD0)*(CL-CL0)**2/(CLMAX-CL0)**2  
        CD_CL = (CDMAX-CD0)*2.0*(CL-CL0)/(CLMAX-CL0)**2  
C
       ELSE
C--- Positive stall drag model (slope matches upper side, quadratic drag rise)
        CD = CDMAX + CDINC*(CLFAC*(CL-CLMAX))**2  
     &      - CDX2*(1.0 - (CL-CL0)/(CLMAX-CL0))
        CD_CL = CDINC*CLFAC*2.0*(CL-CLMAX)
      ENDIF
C
      RETURN
      END

C***********************************************************************
C    Module:  limits.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE GLIMS(XYZMIN,XYZMAX, LPROJ)
C--------------------------------------------------------------
C     Finds geometry limits
C     If LPROJ=T, does projection before finding limits
C--------------------------------------------------------------
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      REAL XYZMIN(3), XYZMAX(3)
      LOGICAL LPROJ
C
      REAL PTS(3,2)
C
      XYZMIN(1) =  1.0E20
      XYZMIN(2) =  1.0E20
      XYZMIN(3) =  1.0E20
      XYZMAX(1) = -1.0E20
      XYZMAX(2) = -1.0E20
      XYZMAX(3) = -1.0E20
C
      DO N = 1, NSURF
       IF(LPLTSURF(N)) THEN
C
        J1 = JFRST(N)
        JN = JFRST(N) + NJ(N)-1
        JDEL = 1  !  MAX( (JN-J1)/5 , 1)
C
        DO J = J1, JN, JDEL
          PTS(1,1) = RLE1(1,J)
          PTS(2,1) = RLE1(2,J)
          PTS(3,1) = RLE1(3,J)
          PTS(1,2) = RLE1(1,J) + CHORD1(J)
          PTS(2,2) = RLE1(2,J)
          PTS(3,2) = RLE1(3,J)
          IF(LPROJ) CALL VIEWPROJ(PTS,2,PTS)
C
          DO K = 1, 3
            XYZMIN(K) = MIN( XYZMIN(K), PTS(K,1), PTS(K,2) )
            XYZMAX(K) = MAX( XYZMAX(K), PTS(K,1), PTS(K,2) )
          ENDDO
        ENDDO
       ENDIF
      END DO
C
C
      DO N = 1, NBODY
       IF(LPLTBODY(N)) THEN
C
        L1 = LFRST(N)
        LN = LFRST(N) + NL(N)-1
C
        PTS(1,1) = RL(1,L1)
        PTS(2,1) = RL(2,L1)
        PTS(3,1) = RL(3,L1)
        PTS(1,2) = RL(1,LN)
        PTS(2,2) = RL(2,LN)
        PTS(3,2) = RL(3,LN)
        IF(LPROJ) CALL VIEWPROJ(PTS,2,PTS)
C
        DO K = 1, 3
          XYZMIN(K) = MIN( XYZMIN(K), PTS(K,1), PTS(K,2) )
          XYZMAX(K) = MAX( XYZMAX(K), PTS(K,1), PTS(K,2) )
        ENDDO
C
       ENDIF
      END DO
C
      RETURN
      END ! GLIMS



      SUBROUTINE GRLIMS(XYZMIN,XYZMAX, LPROJ, TT,XYZR,DXYZ)
C--------------------------------------------------------------
C     Finds rotated,translated geometry limits
C     If LPROJ=T, does plot projection before finding limits
C--------------------------------------------------------------
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      REAL XYZMIN(3), XYZMAX(3)
      LOGICAL LPROJ
      REAL TT(3,3), XYZR(3), DXYZ(3)
C
C
      REAL PTS(3,2)
C
      XYZMIN(1) =  1.0E20
      XYZMIN(2) =  1.0E20
      XYZMIN(3) =  1.0E20
      XYZMAX(1) = -1.0E20
      XYZMAX(2) = -1.0E20
      XYZMAX(3) = -1.0E20
C
      DO N = 1, NSURF
       IF(LPLTSURF(N)) THEN
C
        J1 = JFRST(N)
        JN = JFRST(N) + NJ(N)-1
C
        PTS(1,1) = RLE1(1,J1)
        PTS(2,1) = RLE1(2,J1)
        PTS(3,1) = RLE1(3,J1)
        PTS(1,2) = RLE1(1,J1) + CHORD1(J1)
        PTS(2,2) = RLE1(2,J1)
        PTS(3,2) = RLE1(3,J1)
        CALL TETRAN(PTS(1,1),TT,XYZR,DXYZ)
        CALL TETRAN(PTS(1,2),TT,XYZR,DXYZ)
        IF(LPROJ) CALL VIEWPROJ(PTS,2,PTS)
C
        DO K = 1, 3
          XYZMIN(K) = MIN( XYZMIN(K), PTS(K,1), PTS(K,2) )
          XYZMAX(K) = MAX( XYZMAX(K), PTS(K,1), PTS(K,2) )
        ENDDO
C
        PTS(1,1) = RLE2(1,JN)
        PTS(2,1) = RLE2(2,JN)
        PTS(3,1) = RLE2(3,JN)
        PTS(1,2) = RLE2(1,JN) + CHORD2(JN)
        PTS(2,2) = RLE2(2,JN)
        PTS(3,2) = RLE2(3,JN)
        CALL TETRAN(PTS(1,1),TT,XYZR,DXYZ)
        CALL TETRAN(PTS(1,2),TT,XYZR,DXYZ)
        IF(LPROJ) CALL VIEWPROJ(PTS,2,PTS)
C
        DO K = 1, 3
          XYZMIN(K) = MIN( XYZMIN(K), PTS(K,1), PTS(K,2) )
          XYZMAX(K) = MAX( XYZMAX(K), PTS(K,1), PTS(K,2) )
        ENDDO
C
       ENDIF
      END DO
C
C
      DO N = 1, NBODY
       IF(LPLTBODY(N)) THEN
C
        L1 = LFRST(N)
        LN = LFRST(N) + NL(N)-1
C
        PTS(1,1) = RL(1,L1)
        PTS(2,1) = RL(2,L1)
        PTS(3,1) = RL(3,L1)
        PTS(1,2) = RL(1,LN)
        PTS(2,2) = RL(2,LN)
        PTS(3,2) = RL(3,LN)
        CALL TETRAN(PTS(1,1),TT,XYZR,DXYZ)
        CALL TETRAN(PTS(1,2),TT,XYZR,DXYZ)
        IF(LPROJ) CALL VIEWPROJ(PTS,2,PTS)
C
        DO K = 1, 3
          XYZMIN(K) = MIN( XYZMIN(K), PTS(K,1), PTS(K,2) )
          XYZMAX(K) = MAX( XYZMAX(K), PTS(K,1), PTS(K,2) )
        ENDDO
C
       ENDIF
      END DO
C
      RETURN
      END ! GRLIMS



      SUBROUTINE AXLIMS
C---------------------------------------------------------
C     Sets min,max,delta annotations for geometry axes
C---------------------------------------------------------
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
C
      DO K = 1, 3
        AXMIN(K) = MIN( GMIN(K) , 0.0 )
        AXMAX(K) = MAX( GMAX(K) , 0.0 )
      ENDDO
C
      AXDMAX = MAX( AXMAX(1)-AXMIN(1),
     &              AXMAX(2)-AXMIN(2),
     &              AXMAX(3)-AXMIN(3) )
      DO K = 1, 3
        IF(AXMAX(K)-AXMIN(K) .LT. 0.25*AXDMAX) THEN
         AXMIN(K) = MIN( AXMIN(K) , -0.125*AXDMAX )
         AXMAX(K) = MAX( AXMAX(K) ,  0.125*AXDMAX )
        ENDIF
        CALL AXISADJ(AXMIN(K),AXMAX(K),AXSPAN(K),AXDEL(K),NAXANN(K))
      ENDDO
C
      RETURN
      END ! AXLIMS



      SUBROUTINE HIDINIT(LRESET)
C-------------------------------------------------------------
C     Sets up surface triangle data for hidden line routine
C
C     If LRESET=T resets NTRI=0 to start accumulating 
C     a new set of triangles
C-------------------------------------------------------------
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      LOGICAL LRESET
C
C
      REAL PTS(3,4)
C
      IF(LRESET) NTRI = 0
C
      DO N = 1, NSURF
       IF(LPLTSURF(N)) THEN
C
        J1 = JFRST(N)
        JN = JFRST(N) + NJ(N)-1
        JINC = 1
C
        DO J = J1, JN, JINC
          ID = J
          PTS(1,1) = RLE1(1,J)
          PTS(2,1) = RLE1(2,J)
          PTS(3,1) = RLE1(3,J)
          PTS(1,2) = RLE1(1,J) + CHORD1(J)
          PTS(2,2) = RLE1(2,J)
          PTS(3,2) = RLE1(3,J)
C
          PTS(1,3) = RLE2(1,J)
          PTS(2,3) = RLE2(2,J)
          PTS(3,3) = RLE2(3,J)
          PTS(1,4) = RLE2(1,J) + CHORD2(J)
          PTS(2,4) = RLE2(2,J)
          PTS(3,4) = RLE2(3,J)
C
          CALL VIEWPROJ(PTS,4,PTS)
          CALL TRIINIT(ID,1,1,PTS, NTRI,TRI)
C
        END DO
C
       ENDIF
      END DO
C
C
c      DO N = 1, NBODY
c       IF(LPLTBODY(N)) THEN
cC
c        L1 = LFRST(N)
c        LN = LFRST(N) + NL(N)-1
cC
c        PTS(1,1) = RL(1,L1)
c        PTS(2,1) = RL(2,L1)
c        PTS(3,1) = RL(3,L1)
c        PTS(1,2) = RL(1,LN)
c        PTS(2,2) = RL(2,LN)
c        PTS(3,2) = RL(3,LN)
cC
c        CALL VIEWPROJ(PTS,2,PROJPTS)
cC
c       ENDIF
c      END DO
C
      RETURN
      END ! HIDINIT



      SUBROUTINE HIDINITE(LRESET, ANG,POS,XYZR)
C-------------------------------------------------------------
C     Sets up surface triangle data for hidden line routine
C
C     If LRESET=T resets NTRI=0 to start accumulating 
C     a new set of triangles
C-------------------------------------------------------------
      INCLUDE 'AVL.INC'
      INCLUDE 'AVLPLT.INC'
      LOGICAL LRESET
      REAL ANG(3), POS(3), XYZR(3)
C
      REAL PTS(3,4)
      REAL TT(3,3), TT_ANG(3,3,3)
C
      IF(LRESET) NTRI = 0
C
      CALL ROTENS3(ANG,TT,TT_ANG)
C
      DO N = 1, NSURF
       IF(LPLTSURF(N)) THEN
C
        J1 = JFRST(N)
        JN = JFRST(N) + NJ(N)-1
        JINC = 1
C
        DO J = J1, JN, JINC
          ID = J
          PTS(1,1) = RLE1(1,J)
          PTS(2,1) = RLE1(2,J)
          PTS(3,1) = RLE1(3,J)
          PTS(1,2) = RLE1(1,J) + CHORD1(J)
          PTS(2,2) = RLE1(2,J)
          PTS(3,2) = RLE1(3,J)
C
          PTS(1,3) = RLE2(1,J)
          PTS(2,3) = RLE2(2,J)
          PTS(3,3) = RLE2(3,J)
          PTS(1,4) = RLE2(1,J) + CHORD2(J)
          PTS(2,4) = RLE2(2,J)
          PTS(3,4) = RLE2(3,J)
C
          CALL TETRAN(PTS(1,1),TT,XYZR,POS)
          CALL TETRAN(PTS(1,2),TT,XYZR,POS)
          CALL TETRAN(PTS(1,3),TT,XYZR,POS)
          CALL TETRAN(PTS(1,4),TT,XYZR,POS)
C
          CALL VIEWPROJ(PTS,4,PTS)
          CALL TRIINIT(ID,1,1,PTS, NTRI,TRI)
C
        END DO
C
       ENDIF
      END DO
C
C
c      DO N = 1, NBODY
c       IF(LPLTBODY(N)) THEN
cC
c        L1 = LFRST(N)
c        LN = LFRST(N) + NL(N)-1
cC
c        PTS(1,1) = RL(1,L1)
c        PTS(2,1) = RL(2,L1)
c        PTS(3,1) = RL(3,L1)
c        PTS(1,2) = RL(1,LN)
c        PTS(2,2) = RL(2,LN)
c        PTS(3,2) = RL(3,LN)
cC
c        CALL VIEWPROJ(PTS,2,PROJPTS)
cC
c       ENDIF
c      END DO
C
      RETURN
      END ! HIDINIT
